/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/errors","fs","vs/base/common/buffer","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/common/process","vs/platform/extensions/common/extensions","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/request/common/request","vs/platform/product/common/product","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","util","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","path","vs/platform/environment/node/argvHelper","vs/base/common/performance","vs/base/common/iterator","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Z=function($){for(var t=[],m=0,C=$.length;m<C;m++)t[m]=Q[$[m]];return t};define(Q[56],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function m(C,b){if(!C)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=m}),define(Q[57],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0;function m(d){return(f,O,h)=>{let E=null,P=null;if(typeof h.value=="function"?(E="value",P=h.value):typeof h.get=="function"&&(E="get",P=h.get),!P)throw new Error("not supported");h[E]=d(P,O)}}t.createDecorator=m;let C=0;function b(){const d=`$memoize${C++}`;let f;const O=function(E,P,l){let v=null,p=null;if(typeof l.value=="function"?(v="value",p=l.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(v="get",p=l.get),!p)throw new Error("not supported");const y=`${d}:${P}`;l[v]=function(...I){return f=this,this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!0,enumerable:!1,writable:!0,value:p.apply(this,I)}),this[y]}};return O.clear=()=>{typeof f!="undefined"&&Object.getOwnPropertyNames(f).forEach(h=>{h.indexOf(d)===0&&delete f[h]})},O}t.createMemoizer=b;function w(d,f,O){return b()(d,f,O)}t.memoize=w;function T(d,f,O){return m((h,E)=>{const P=`$debounce$${E}`,l=`$debounce$result$${E}`;return function(...v){this[l]||(this[l]=O?O():void 0),clearTimeout(this[P]),f&&(this[l]=f(this[l],...v),v=[this[l]]),this[P]=setTimeout(()=>{h.apply(this,v),this[l]=O?O():void 0},d)}})}t.debounce=T;function R(d,f,O){return m((h,E)=>{const P=`$throttle$timer$${E}`,l=`$throttle$result$${E}`,v=`$throttle$lastRun$${E}`,p=`$throttle$pending$${E}`;return function(...y){if(this[l]||(this[l]=O?O():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),f&&(this[l]=f(this[l],...y)),!this[p]){const I=this[v]+d;I<=Date.now()?(this[v]=Date.now(),h.apply(this,[this[l]]),this[l]=O?O():void 0):(this[p]=!0,this[P]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),h.apply(this,[this[l]]),this[l]=O?O():void 0},I-Date.now()))}}})}t.throttle=R}),define(Q[23],Z([0,1,15]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function C(W,G=0){return W[W.length-(1+G)]}t.tail=C;function b(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}t.tail2=b;function w(W,G,_=(c,u)=>c===u){if(W===G)return!0;if(!W||!G||W.length!==G.length)return!1;for(let c=0,u=W.length;c<u;c++)if(!_(W[c],G[c]))return!1;return!0}t.equals=w;function T(W,G,_){let c=0,u=W.length-1;for(;c<=u;){const D=(c+u)/2|0,L=_(W[D],G);if(L<0)c=D+1;else if(L>0)u=D-1;else return D}return-(c+1)}t.binarySearch=T;function R(W,G){let _=0,c=W.length;if(c===0)return 0;for(;_<c;){const u=Math.floor((_+c)/2);G(W[u])?c=u:_=u+1}return _}t.findFirstInSorted=R;function d(W,G,_){if(W=W|0,W>=G.length)throw new TypeError("invalid index");let c=G[Math.floor(G.length*Math.random())],u=[],D=[],L=[];for(let k of G){const M=_(k,c);M<0?u.push(k):M>0?D.push(k):L.push(k)}return W<u.length?d(W,u,_):W<u.length+L.length?L[0]:d(W-(u.length+L.length),D,_)}t.quickSelect=d;function f(W,G){const _=[];let c;for(const u of W.slice(0).sort(G))!c||G(c[0],u)!==0?(c=[u],_.push(c)):c.push(u);return _}t.groupBy=f;function O(W,G,_){const c=[];function u(k,M,z){if(!(M===0&&z.length===0)){const B=c[c.length-1];B&&B.start+B.deleteCount===k?(B.deleteCount+=M,B.toInsert.push(...z)):c.push({start:k,deleteCount:M,toInsert:z})}}let D=0,L=0;for(;;){if(D===W.length){u(D,0,G.slice(L));break}if(L===G.length){u(D,W.length-D,[]);break}const k=W[D],M=G[L],z=_(k,M);z===0?(D+=1,L+=1):z<0?(u(D,1,[]),D+=1):z>0&&(u(D,0,[M]),L+=1)}return c}t.sortedDiff=O;function h(W,G,_){const c=O(W,G,_),u=[],D=[];for(const L of c)u.push(...W.slice(L.start,L.start+L.deleteCount)),D.push(...L.toInsert);return{removed:u,added:D}}t.delta=h;function E(W,G,_){if(_===0)return[];const c=W.slice(0,_).sort(G);return l(W,G,c,_,W.length),c}t.top=E;function P(W,G,_,c,u){return _===0?Promise.resolve([]):new Promise((D,L)=>{(async()=>{const k=W.length,M=W.slice(0,_).sort(G);for(let z=_,B=Math.min(_+c,k);z<k;z=B,B=Math.min(B+c,k)){if(z>_&&await new Promise(q=>setTimeout(q)),u&&u.isCancellationRequested)throw(0,m.canceled)();l(W,G,M,z,B)}return M})().then(D,L)})}t.topAsync=P;function l(W,G,_,c,u){for(const D=_.length;c<u;c++){const L=W[c];if(G(L,_[D-1])<0){_.pop();const k=R(_,M=>G(L,M)<0);_.splice(k,0,L)}}}function v(W){return W.filter(G=>!!G)}t.coalesce=v;function p(W){let G=0;for(let _=0;_<W.length;_++)W[_]&&(W[G]=W[_],G+=1);W.length=G}t.coalesceInPlace=p;function y(W,G,_){W.splice(_,0,W.splice(G,1)[0])}t.move=y;function I(W){return!Array.isArray(W)||W.length===0}t.isFalsyOrEmpty=I;function S(W){return Array.isArray(W)&&W.length>0}t.isNonEmptyArray=S;function o(W,G){if(!G)return W.filter((c,u)=>W.indexOf(c)===u);const _=Object.create(null);return W.filter(c=>{const u=G(c);return _[u]?!1:(_[u]=!0,!0)})}t.distinct=o;function i(W){const G=new Set;return W.filter(_=>G.has(_)?!1:(G.add(_),!0))}t.distinctES6=i;function e(W){const G=Object.create(null);return _=>{const c=W(_);return G[c]?!1:(G[c]=!0,!0)}}t.uniqueFilter=e;function n(W,G){for(let _=W.length-1;_>=0;_--){const c=W[_];if(G(c))return _}return-1}t.lastIndex=n;function r(W,G){return W.length>0?W[0]:G}t.firstOrDefault=r;function a(W,G,_=(c,u)=>c===u){let c=0;for(let u=0,D=Math.min(W.length,G.length);u<D&&_(W[u],G[u]);u++)c++;return c}t.commonPrefixLength=a;function s(W){return[].concat(...W)}t.flatten=s;function g(W,G){let _=typeof G=="number"?W:0;typeof G=="number"?_=W:(_=0,G=W);const c=[];if(_<=G)for(let u=_;u<G;u++)c.push(u);else for(let u=_;u>G;u--)c.push(u);return c}t.range=g;function F(W,G,_){return W.reduce((c,u)=>(c[G(u)]=_?_(u):u,c),Object.create(null))}t.index=F;function U(W,G){return W.push(G),()=>N(W,G)}t.insert=U;function N(W,G){const _=W.indexOf(G);if(_>-1)return W.splice(_,1),G}t.remove=N;function A(W,G,_){const c=W.slice(0,G),u=W.slice(G);return c.concat(_,u)}t.arrayInsert=A;function j(W,G){let _;if(typeof G=="number"){let c=G;_=()=>{const u=Math.sin(c++)*179426549;return u-Math.floor(u)}}else _=Math.random;for(let c=W.length-1;c>0;c-=1){const u=Math.floor(_()*(c+1)),D=W[c];W[c]=W[u],W[u]=D}}t.shuffle=j;function x(W,G){const _=W.indexOf(G);_>-1&&(W.splice(_,1),W.unshift(G))}t.pushToStart=x;function X(W,G){const _=W.indexOf(G);_>-1&&(W.splice(_,1),W.push(G))}t.pushToEnd=X;function ne(W,G){return Array.isArray(W)?W.map(G):G(W)}t.mapArrayOrNot=ne;function ee(W){return Array.isArray(W)?W:[W]}t.asArray=ee;function te(W){return W[Math.floor(Math.random()*W.length)]}t.getRandomElement=te;function ae(W,G){for(const _ of W){const c=G(_);if(c!==void 0)return c}}t.mapFind=ae}),define(Q[58],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var m;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(m=t.ScanError||(t.ScanError={}));var C;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(C=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var w;(function(e){e.DEFAULT={allowTrailingComma:!0}})(w=t.ParseOptions||(t.ParseOptions={}));function T(e,n=!1){let r=0,a=e.length,s="",g=0,F=16,U=0;function N(te){let ae=0,W=0;for(;ae<te;){const G=e.charCodeAt(r);if(G>=48&&G<=57)W=W*16+G-48;else if(G>=65&&G<=70)W=W*16+G-65+10;else if(G>=97&&G<=102)W=W*16+G-97+10;else break;r++,ae++}return ae<te&&(W=-1),W}function A(te){r=te,s="",g=0,F=16,U=0}function j(){const te=r;if(e.charCodeAt(r)===48)r++;else for(r++;r<e.length&&f(e.charCodeAt(r));)r++;if(r<e.length&&e.charCodeAt(r)===46)if(r++,r<e.length&&f(e.charCodeAt(r)))for(r++;r<e.length&&f(e.charCodeAt(r));)r++;else return U=3,e.substring(te,r);let ae=r;if(r<e.length&&(e.charCodeAt(r)===69||e.charCodeAt(r)===101))if(r++,(r<e.length&&e.charCodeAt(r)===43||e.charCodeAt(r)===45)&&r++,r<e.length&&f(e.charCodeAt(r))){for(r++;r<e.length&&f(e.charCodeAt(r));)r++;ae=r}else U=3;return e.substring(te,ae)}function x(){let te="",ae=r;for(;;){if(r>=a){te+=e.substring(ae,r),U=2;break}const W=e.charCodeAt(r);if(W===34){te+=e.substring(ae,r),r++;break}if(W===92){if(te+=e.substring(ae,r),r++,r>=a){U=2;break}switch(e.charCodeAt(r++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const _=N(4);_>=0?te+=String.fromCharCode(_):U=4;break;default:U=5}ae=r;continue}if(W>=0&&W<=31)if(d(W)){te+=e.substring(ae,r),U=2;break}else U=6;r++}return te}function X(){if(s="",U=0,g=r,r>=a)return g=a,F=17;let te=e.charCodeAt(r);if(R(te)){do r++,s+=String.fromCharCode(te),te=e.charCodeAt(r);while(R(te));return F=15}if(d(te))return r++,s+=String.fromCharCode(te),te===13&&e.charCodeAt(r)===10&&(r++,s+=`
`),F=14;switch(te){case 123:return r++,F=1;case 125:return r++,F=2;case 91:return r++,F=3;case 93:return r++,F=4;case 58:return r++,F=6;case 44:return r++,F=5;case 34:return r++,s=x(),F=10;case 47:const ae=r-1;if(e.charCodeAt(r+1)===47){for(r+=2;r<a&&!d(e.charCodeAt(r));)r++;return s=e.substring(ae,r),F=12}if(e.charCodeAt(r+1)===42){r+=2;const W=a-1;let G=!1;for(;r<W;){if(e.charCodeAt(r)===42&&e.charCodeAt(r+1)===47){r+=2,G=!0;break}r++}return G||(r++,U=1),s=e.substring(ae,r),F=13}return s+=String.fromCharCode(te),r++,F=16;case 45:if(s+=String.fromCharCode(te),r++,r===a||!f(e.charCodeAt(r)))return F=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),F=11;default:for(;r<a&&ne(te);)r++,te=e.charCodeAt(r);if(g!==r){switch(s=e.substring(g,r),s){case"true":return F=8;case"false":return F=9;case"null":return F=7}return F=16}return s+=String.fromCharCode(te),r++,F=16}}function ne(te){if(R(te)||d(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let te;do te=X();while(te>=12&&te<=15);return te}return{setPosition:A,getPosition:()=>r,scan:n?ee:X,getToken:()=>F,getTokenValue:()=>s,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>U}}t.createScanner=T;function R(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function d(e){return e===10||e===13||e===8232||e===8233}function f(e){return e>=48&&e<=57}var O;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(O||(O={}));function h(e,n){const r=[],a=new Object;let s;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let F=!1;function U(N,A,j,x){g.value=N,g.offset=A,g.length=j,g.type=x,g.colonOffset=void 0,s=g}try{S(e,{onObjectBegin:(N,A)=>{if(n<=N)throw a;s=void 0,F=n>N,r.push("")},onObjectProperty:(N,A,j)=>{if(n<A||(U(N,A,j,"property"),r[r.length-1]=N,n<=A+j))throw a},onObjectEnd:(N,A)=>{if(n<=N)throw a;s=void 0,r.pop()},onArrayBegin:(N,A)=>{if(n<=N)throw a;s=void 0,r.push(0)},onArrayEnd:(N,A)=>{if(n<=N)throw a;s=void 0,r.pop()},onLiteralValue:(N,A,j)=>{if(n<A||(U(N,A,j,i(N)),n<=A+j))throw a},onSeparator:(N,A,j)=>{if(n<=A)throw a;if(N===":"&&s&&s.type==="property")s.colonOffset=A,F=!1,s=void 0;else if(N===","){const x=r[r.length-1];typeof x=="number"?r[r.length-1]=x+1:(F=!0,r[r.length-1]=""),s=void 0}}})}catch(N){if(N!==a)throw N}return{path:r,previousNode:s,isAtPropertyKey:F,matches:N=>{let A=0;for(let j=0;A<N.length&&j<r.length;j++)if(N[A]===r[j]||N[A]==="*")A++;else if(N[A]!=="**")return!1;return A===N.length}}}t.getLocation=h;function E(e,n=[],r=w.DEFAULT){let a=null,s=[];const g=[];function F(N){Array.isArray(s)?s.push(N):a!==null&&(s[a]=N)}return S(e,{onObjectBegin:()=>{const N={};F(N),g.push(s),s=N,a=null},onObjectProperty:N=>{a=N},onObjectEnd:()=>{s=g.pop()},onArrayBegin:()=>{const N=[];F(N),g.push(s),s=N,a=null},onArrayEnd:()=>{s=g.pop()},onLiteralValue:F,onError:(N,A,j)=>{n.push({error:N,offset:A,length:j})}},r),s[0]}t.parse=E;function P(e,n=[],r=w.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(N){a.type==="property"&&(a.length=N-a.offset,a=a.parent)}function g(N){return a.children.push(N),N}S(e,{onObjectBegin:N=>{a=g({type:"object",offset:N,length:-1,parent:a,children:[]})},onObjectProperty:(N,A,j)=>{a=g({type:"property",offset:A,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:N,offset:A,length:j,parent:a})},onObjectEnd:(N,A)=>{a.length=N+A-a.offset,a=a.parent,s(N+A)},onArrayBegin:(N,A)=>{a=g({type:"array",offset:N,length:-1,parent:a,children:[]})},onArrayEnd:(N,A)=>{a.length=N+A-a.offset,a=a.parent,s(N+A)},onLiteralValue:(N,A,j)=>{g({type:i(N),offset:A,length:j,parent:a,value:N}),s(A+j)},onSeparator:(N,A,j)=>{a.type==="property"&&(N===":"?a.colonOffset=A:N===","&&s(A))},onError:(N,A,j)=>{n.push({error:N,offset:A,length:j})}},r);const U=a.children[0];return U&&delete U.parent,U}t.parseTree=P;function l(e,n){if(!!e){let r=e;for(let a of n)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===a){r=g.children[1],s=!0;break}if(!s)return}else{const s=a;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}}t.findNodeAtLocation=l;function v(e){if(!e.parent||!e.parent.children)return[];const n=v(e.parent);if(e.parent.type==="property"){const r=e.parent.children[0].value;n.push(r)}else if(e.parent.type==="array"){const r=e.parent.children.indexOf(e);r!==-1&&n.push(r)}return n}t.getNodePath=v;function p(e){switch(e.type){case"array":return e.children.map(p);case"object":const n=Object.create(null);for(let r of e.children){const a=r.children[1];a&&(n[r.children[0].value]=p(a))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=p;function y(e,n,r=!1){return n>=e.offset&&n<e.offset+e.length||r&&n===e.offset+e.length}t.contains=y;function I(e,n,r=!1){if(y(e,n,r)){const a=e.children;if(Array.isArray(a))for(let s=0;s<a.length&&a[s].offset<=n;s++){const g=I(a[s],n,r);if(g)return g}return e}}t.findNodeAtOffset=I;function S(e,n,r=w.DEFAULT){const a=T(e,!1);function s(M){return M?()=>M(a.getTokenOffset(),a.getTokenLength()):()=>!0}function g(M){return M?z=>M(z,a.getTokenOffset(),a.getTokenLength()):()=>!0}const F=s(n.onObjectBegin),U=g(n.onObjectProperty),N=s(n.onObjectEnd),A=s(n.onArrayBegin),j=s(n.onArrayEnd),x=g(n.onLiteralValue),X=g(n.onSeparator),ne=s(n.onComment),ee=g(n.onError),te=r&&r.disallowComments,ae=r&&r.allowTrailingComma;function W(){for(;;){const M=a.scan();switch(a.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:te||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(M){case 12:case 13:te?G(10):ne();break;case 16:G(1);break;case 15:case 14:break;default:return M}}}function G(M,z=[],B=[]){if(ee(M),z.length+B.length>0){let q=a.getToken();for(;q!==17;){if(z.indexOf(q)!==-1){W();break}else if(B.indexOf(q)!==-1)break;q=W()}}}function _(M){const z=a.getTokenValue();return M?x(z):U(z),W(),!0}function c(){switch(a.getToken()){case 11:let M=0;try{M=JSON.parse(a.getTokenValue()),typeof M!="number"&&(G(2),M=0)}catch(z){G(2)}x(M);break;case 7:x(null);break;case 8:x(!0);break;case 9:x(!1);break;default:return!1}return W(),!0}function u(){return a.getToken()!==10?(G(3,[],[2,5]),!1):(_(!1),a.getToken()===6?(X(":"),W(),k()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function D(){F(),W();let M=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(M||G(4,[],[]),X(","),W(),a.getToken()===2&&ae)break}else M&&G(6,[],[]);u()||G(4,[],[2,5]),M=!0}return N(),a.getToken()!==2?G(7,[2],[]):W(),!0}function L(){A(),W();let M=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(M||G(4,[],[]),X(","),W(),a.getToken()===4&&ae)break}else M&&G(6,[],[]);k()||G(4,[],[4,5]),M=!0}return j(),a.getToken()!==4?G(8,[4],[]):W(),!0}function k(){switch(a.getToken()){case 3:return L();case 1:return D();case 10:return _(!0);default:return c()}}return W(),a.getToken()===17?r.allowEmptyContent?!0:(G(4,[],[]),!1):k()?(a.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}t.visit=S;function o(e,n){let r=T(e),a=[],s,g=0,F;do switch(F=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:g!==F&&a.push(e.substring(g,F)),n!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,n)),g=r.getPosition();break}while(s!==17);return a.join("")}t.stripComments=o;function i(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=i});"use strict";(function(){function $(b){const w=[];typeof b=="number"&&w.push("code/timeOrigin",b);function T(d){w.push(d,Date.now())}function R(){const d=[];for(let f=0;f<w.length;f+=2)d.push({name:w[f],startTime:w[f+1]});return d}return{mark:T,getMarks:R}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const w=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const T of performance.getEntriesByType("mark"))w.push({name:T.name,startTime:Math.round(b+T.startTime)});return w}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function m(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=m(C))})(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var m=t();for(var C in m)(typeof exports=="object"?exports:$)[C]=m[C]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function m(C){if(t[C])return t[C].exports;var b=t[C]={i:C,l:!1,exports:{}};return $[C].call(b.exports,b,b.exports,m),b.l=!0,b.exports}return m.m=$,m.c=t,m.d=function(C,b,w){m.o(C,b)||Object.defineProperty(C,b,{enumerable:!0,get:w})},m.r=function(C){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},m.t=function(C,b){if(1&b&&(C=m(C)),8&b||4&b&&typeof C=="object"&&C&&C.__esModule)return C;var w=Object.create(null);if(m.r(w),Object.defineProperty(w,"default",{enumerable:!0,value:C}),2&b&&typeof C!="string")for(var T in C)m.d(w,T,function(R){return C[R]}.bind(null,T));return w},m.n=function(C){var b=C&&C.__esModule?function(){return C.default}:function(){return C};return m.d(b,"a",b),b},m.o=function(C,b){return Object.prototype.hasOwnProperty.call(C,b)},m.p="",m(m.s=0)}([function($,t,m){(function(C){var b;t=$.exports=B,b=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var w=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=t.re=[],d=t.src=[],f=0,O=f++;d[O]="0|[1-9]\\d*";var h=f++;d[h]="[0-9]+";var E=f++;d[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var P=f++;d[P]="("+d[O]+")\\.("+d[O]+")\\.("+d[O]+")";var l=f++;d[l]="("+d[h]+")\\.("+d[h]+")\\.("+d[h]+")";var v=f++;d[v]="(?:"+d[O]+"|"+d[E]+")";var p=f++;d[p]="(?:"+d[h]+"|"+d[E]+")";var y=f++;d[y]="(?:-("+d[v]+"(?:\\."+d[v]+")*))";var I=f++;d[I]="(?:-?("+d[p]+"(?:\\."+d[p]+")*))";var S=f++;d[S]="[0-9A-Za-z-]+";var o=f++;d[o]="(?:\\+("+d[S]+"(?:\\."+d[S]+")*))";var i=f++,e="v?"+d[P]+d[y]+"?"+d[o]+"?";d[i]="^"+e+"$";var n="[v=\\s]*"+d[l]+d[I]+"?"+d[o]+"?",r=f++;d[r]="^"+n+"$";var a=f++;d[a]="((?:<|>)?=?)";var s=f++;d[s]=d[h]+"|x|X|\\*";var g=f++;d[g]=d[O]+"|x|X|\\*";var F=f++;d[F]="[v=\\s]*("+d[g]+")(?:\\.("+d[g]+")(?:\\.("+d[g]+")(?:"+d[y]+")?"+d[o]+"?)?)?";var U=f++;d[U]="[v=\\s]*("+d[s]+")(?:\\.("+d[s]+")(?:\\.("+d[s]+")(?:"+d[I]+")?"+d[o]+"?)?)?";var N=f++;d[N]="^"+d[a]+"\\s*"+d[F]+"$";var A=f++;d[A]="^"+d[a]+"\\s*"+d[U]+"$";var j=f++;d[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var x=f++;d[x]="(?:~>?)";var X=f++;d[X]="(\\s*)"+d[x]+"\\s+",R[X]=new RegExp(d[X],"g");var ne=f++;d[ne]="^"+d[x]+d[F]+"$";var ee=f++;d[ee]="^"+d[x]+d[U]+"$";var te=f++;d[te]="(?:\\^)";var ae=f++;d[ae]="(\\s*)"+d[te]+"\\s+",R[ae]=new RegExp(d[ae],"g");var W=f++;d[W]="^"+d[te]+d[F]+"$";var G=f++;d[G]="^"+d[te]+d[U]+"$";var _=f++;d[_]="^"+d[a]+"\\s*("+n+")$|^$";var c=f++;d[c]="^"+d[a]+"\\s*("+e+")$|^$";var u=f++;d[u]="(\\s*)"+d[a]+"\\s*("+n+"|"+d[F]+")",R[u]=new RegExp(d[u],"g");var D=f++;d[D]="^\\s*("+d[F]+")\\s+-\\s+("+d[F]+")\\s*$";var L=f++;d[L]="^\\s*("+d[U]+")\\s+-\\s+("+d[U]+")\\s*$";var k=f++;d[k]="(<|>)?=?\\s*\\*";for(var M=0;M<35;M++)b(M,d[M]),R[M]||(R[M]=new RegExp(d[M]));function z(V,H){if(V instanceof B)return V;if(typeof V!="string"||V.length>w||!(H?R[r]:R[i]).test(V))return null;try{return new B(V,H)}catch(K){return null}}function B(V,H){if(V instanceof B){if(V.loose===H)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>w)throw new TypeError("version is longer than "+w+" characters");if(!(this instanceof B))return new B(V,H);b("SemVer",V,H),this.loose=H;var K=V.trim().match(H?R[r]:R[i]);if(!K)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var oe=+se;if(oe>=0&&oe<T)return oe}return se}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=z,t.valid=function(V,H){var K=z(V,H);return K?K.version:null},t.clean=function(V,H){var K=z(V.trim().replace(/^[=v]+/,""),H);return K?K.version:null},t.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(V){return b("SemVer.compare",this.version,this.loose,V),V instanceof B||(V=new B(V,this.loose)),this.compareMain(V)||this.comparePre(V)},B.prototype.compareMain=function(V){return V instanceof B||(V=new B(V,this.loose)),J(this.major,V.major)||J(this.minor,V.minor)||J(this.patch,V.patch)},B.prototype.comparePre=function(V){if(V instanceof B||(V=new B(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],se=V.prerelease[H];if(b("prerelease compare",H,K,se),K===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(K===void 0)return-1;if(K!==se)return J(K,se)}while(++H)},B.prototype.inc=function(V,H){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,H,K,se){typeof K=="string"&&(se=K,K=void 0);try{return new B(V,K).inc(H,se).version}catch(oe){return null}},t.diff=function(V,H){if(he(V,H))return null;var K=z(V),se=z(H);if(K.prerelease.length||se.prerelease.length){for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return"pre"+oe;return"prerelease"}for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return oe},t.compareIdentifiers=J;var q=/^[0-9]+$/;function J(V,H){var K=q.test(V),se=q.test(H);return K&&se&&(V=+V,H=+H),K&&!se?-1:se&&!K?1:V<H?-1:V>H?1:0}function Y(V,H,K){return new B(V,K).compare(new B(H,K))}function ie(V,H,K){return Y(V,H,K)>0}function re(V,H,K){return Y(V,H,K)<0}function he(V,H,K){return Y(V,H,K)===0}function ge(V,H,K){return Y(V,H,K)!==0}function De(V,H,K){return Y(V,H,K)>=0}function Oe(V,H,K){return Y(V,H,K)<=0}function Fe(V,H,K,se){var oe;switch(H){case"===":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),oe=V===K;break;case"!==":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),oe=V!==K;break;case"":case"=":case"==":oe=he(V,K,se);break;case"!=":oe=ge(V,K,se);break;case">":oe=ie(V,K,se);break;case">=":oe=De(V,K,se);break;case"<":oe=re(V,K,se);break;case"<=":oe=Oe(V,K,se);break;default:throw new TypeError("Invalid operator: "+H)}return oe}function Re(V,H){if(V instanceof Re){if(V.loose===H)return V;V=V.value}if(!(this instanceof Re))return new Re(V,H);b("comparator",V,H),this.loose=H,this.parse(V),this.semver===Me?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(V,H){return J(H,V)},t.major=function(V,H){return new B(V,H).major},t.minor=function(V,H){return new B(V,H).minor},t.patch=function(V,H){return new B(V,H).patch},t.compare=Y,t.compareLoose=function(V,H){return Y(V,H,!0)},t.rcompare=function(V,H,K){return Y(H,V,K)},t.sort=function(V,H){return V.sort(function(K,se){return t.compare(K,se,H)})},t.rsort=function(V,H){return V.sort(function(K,se){return t.rcompare(K,se,H)})},t.gt=ie,t.lt=re,t.eq=he,t.neq=ge,t.gte=De,t.lte=Oe,t.cmp=Fe,t.Comparator=Re;var Me={};function ve(V,H){if(V instanceof ve)return V.loose===H?V:new ve(V.raw,H);if(V instanceof Re)return new ve(V.value,H);if(!(this instanceof ve))return new ve(V,H);if(this.loose=H,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Se(V){return!V||V.toLowerCase()==="x"||V==="*"}function xe(V,H,K,se,oe,be,de,Ce,Ee,Le,ke,we,Ie){return((H=Se(K)?"":Se(se)?">="+K+".0.0":Se(oe)?">="+K+"."+se+".0":">="+H)+" "+(Ce=Se(Ee)?"":Se(Le)?"<"+(+Ee+1)+".0.0":Se(ke)?"<"+Ee+"."+(+Le+1)+".0":we?"<="+Ee+"."+Le+"."+ke+"-"+we:"<="+Ce)).trim()}function $e(V,H){for(var K=0;K<V.length;K++)if(!V[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<V.length;K++)if(b(V[K].semver),V[K].semver!==Me&&V[K].semver.prerelease.length>0){var se=V[K].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function Ue(V,H,K){try{H=new ve(H,K)}catch(se){return!1}return H.test(V)}function ze(V,H,K,se){var oe,be,de,Ce,Ee;switch(V=new B(V,se),H=new ve(H,se),K){case">":oe=ie,be=Oe,de=re,Ce=">",Ee=">=";break;case"<":oe=re,be=De,de=ie,Ce="<",Ee="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(V,H,se))return!1;for(var Le=0;Le<H.set.length;++Le){var ke=H.set[Le],we=null,Ie=null;if(ke.forEach(function(Te){Te.semver===Me&&(Te=new Re(">=0.0.0")),we=we||Te,Ie=Ie||Te,oe(Te.semver,we.semver,se)?we=Te:de(Te.semver,Ie.semver,se)&&(Ie=Te)}),we.operator===Ce||we.operator===Ee||(!Ie.operator||Ie.operator===Ce)&&be(V,Ie.semver)||Ie.operator===Ee&&de(V,Ie.semver))return!1}return!0}Re.prototype.parse=function(V){var H=this.loose?R[_]:R[c],K=V.match(H);if(!K)throw new TypeError("Invalid comparator: "+V);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new B(K[2],this.loose):this.semver=Me},Re.prototype.toString=function(){return this.value},Re.prototype.test=function(V){return b("Comparator.test",V,this.loose),this.semver===Me||(typeof V=="string"&&(V=new B(V,this.loose)),Fe(V,this.operator,this.semver,this.loose))},Re.prototype.intersects=function(V,H){if(!(V instanceof Re))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ve(V.value,H),Ue(this.value,K,H);if(V.operator==="")return K=new ve(this.value,H),Ue(V.semver,K,H);var se=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),be=this.semver.version===V.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ce=Fe(this.semver,"<",V.semver,H)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ee=Fe(this.semver,">",V.semver,H)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return se||oe||be&&de||Ce||Ee},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(V){var H=this.loose;V=V.trim(),b("range",V,H);var K=H?R[L]:R[D];V=V.replace(K,xe),b("hyphen replace",V),V=V.replace(R[u],"$1$2$3"),b("comparator trim",V,R[u]),V=(V=(V=V.replace(R[X],"$1~")).replace(R[ae],"$1^")).split(/\s+/).join(" ");var se=H?R[_]:R[c],oe=V.split(" ").map(function(be){return function(de,Ce){return b("comp",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Ie){b("caret",we,Ie);var Te=Ie?R[G]:R[W];return we.replace(Te,function(Ae,le,fe,me,pe){var Pe;return b("caret",we,Ae,le,fe,me,pe),Se(le)?Pe="":Se(fe)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Se(me)?Pe=le==="0"?">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+".0 <"+(+le+1)+".0.0":pe?(b("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=le==="0"?fe==="0"?">="+le+"."+fe+"."+me+pe+" <"+le+"."+fe+"."+(+me+1):">="+le+"."+fe+"."+me+pe+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+me+pe+" <"+(+le+1)+".0.0"):(b("no pr"),Pe=le==="0"?fe==="0"?">="+le+"."+fe+"."+me+" <"+le+"."+fe+"."+(+me+1):">="+le+"."+fe+"."+me+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+me+" <"+(+le+1)+".0.0"),b("caret return",Pe),Pe})}(ke,Le)}).join(" ")}(de,Ce),b("caret",de),de=function(Ee,Le){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Ie){var Te=Ie?R[ee]:R[ne];return we.replace(Te,function(Ae,le,fe,me,pe){var Pe;return b("tilde",we,Ae,le,fe,me,pe),Se(le)?Pe="":Se(fe)?Pe=">="+le+".0.0 <"+(+le+1)+".0.0":Se(me)?Pe=">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":pe?(b("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Pe=">="+le+"."+fe+"."+me+pe+" <"+le+"."+(+fe+1)+".0"):Pe=">="+le+"."+fe+"."+me+" <"+le+"."+(+fe+1)+".0",b("tilde return",Pe),Pe})}(ke,Le)}).join(" ")}(de,Ce),b("tildes",de),de=function(Ee,Le){return b("replaceXRanges",Ee,Le),Ee.split(/\s+/).map(function(ke){return function(we,Ie){we=we.trim();var Te=Ie?R[A]:R[N];return we.replace(Te,function(Ae,le,fe,me,pe,Pe){b("xRange",we,Ae,le,fe,me,pe,Pe);var Be=Se(fe),Ne=Be||Se(me),je=Ne||Se(pe);return le==="="&&je&&(le=""),Be?Ae=le===">"||le==="<"?"<0.0.0":"*":le&&je?(Ne&&(me=0),je&&(pe=0),le===">"?(le=">=",Ne?(fe=+fe+1,me=0,pe=0):je&&(me=+me+1,pe=0)):le==="<="&&(le="<",Ne?fe=+fe+1:me=+me+1),Ae=le+fe+"."+me+"."+pe):Ne?Ae=">="+fe+".0.0 <"+(+fe+1)+".0.0":je&&(Ae=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0"),b("xRange return",Ae),Ae})}(ke,Le)}).join(" ")}(de,Ce),b("xrange",de),de=function(Ee,Le){return b("replaceStars",Ee,Le),Ee.trim().replace(R[k],"")}(de,Ce),b("stars",de),de}(be,H)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(be){return!!be.match(se)})),oe=oe.map(function(be){return new Re(be,H)})},ve.prototype.intersects=function(V,H){if(!(V instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(se){return V.set.some(function(oe){return oe.every(function(be){return se.intersects(be,H)})})})})},t.toComparators=function(V,H){return new ve(V,H).set.map(function(K){return K.map(function(se){return se.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new B(V,this.loose));for(var H=0;H<this.set.length;H++)if($e(this.set[H],V))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(V,H,K){var se=null,oe=null;try{var be=new ve(H,K)}catch(de){return null}return V.forEach(function(de){be.test(de)&&(se&&oe.compare(de)!==-1||(oe=new B(se=de,K)))}),se},t.minSatisfying=function(V,H,K){var se=null,oe=null;try{var be=new ve(H,K)}catch(de){return null}return V.forEach(function(de){be.test(de)&&(se&&oe.compare(de)!==1||(oe=new B(se=de,K)))}),se},t.validRange=function(V,H){try{return new ve(V,H).range||"*"}catch(K){return null}},t.ltr=function(V,H,K){return ze(V,H,"<",K)},t.gtr=function(V,H,K){return ze(V,H,">",K)},t.outside=ze,t.prerelease=function(V,H){var K=z(V,H);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(V,H,K){return V=new ve(V,K),H=new ve(H,K),V.intersects(H)},t.coerce=function(V){if(V instanceof B)return V;if(typeof V!="string")return null;var H=V.match(R[j]);return H==null?null:z((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,m(1))},function($,t){var m,C,b=$.exports={};function w(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(p){if(m===setTimeout)return setTimeout(p,0);if((m===w||!m)&&setTimeout)return m=setTimeout,setTimeout(p,0);try{return m(p,0)}catch(y){try{return m.call(null,p,0)}catch(I){return m.call(this,p,0)}}}(function(){try{m=typeof setTimeout=="function"?setTimeout:w}catch(p){m=w}try{C=typeof clearTimeout=="function"?clearTimeout:T}catch(p){C=T}})();var d,f=[],O=!1,h=-1;function E(){O&&d&&(O=!1,d.length?f=d.concat(f):h=-1,f.length&&P())}function P(){if(!O){var p=R(E);O=!0;for(var y=f.length;y;){for(d=f,f=[];++h<y;)d&&d[h].run();h=-1,y=f.length}d=null,O=!1,function(I){if(C===clearTimeout)return clearTimeout(I);if((C===T||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(I);try{C(I)}catch(S){try{return C.call(null,I)}catch(o){return C.call(this,I)}}}(p)}}function l(p,y){this.fun=p,this.array=y}function v(){}b.nextTick=function(p){var y=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)y[I-1]=arguments[I];f.push(new l(p,y)),f.length!==1||O||R(P)},l.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=v,b.addListener=v,b.once=v,b.off=v,b.removeListener=v,b.removeAllListeners=v,b.emit=v,b.prependListener=v,b.prependOnceListener=v,b.listeners=function(p){return[]},b.binding=function(p){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(p){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Q[34],Z([0,1,15,2]),function($,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.transform=t.toReadable=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function b(p){const y=p;return y&&[y.on,y.pause,y.resume,y.destroy].every(I=>typeof I=="function")}t.isReadableStream=b;function w(p){const y=p;return y&&b(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean"}t.isReadableBufferedStream=w;function T(p,y){return new R(p,y)}t.newWriteableStream=T;class R{constructor(y,I){this.reducer=y,this.options=I,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(y){var I;if(!this.state.destroyed){if(this.state.flowing)this.emitData(y);else if(this.buffer.data.push(y),typeof((I=this.options)===null||I===void 0?void 0:I.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(y){this.state.destroyed||(this.state.flowing?this.emitError(y):this.buffer.error.push(y))}end(y){this.state.destroyed||(typeof y!="undefined"&&this.write(y),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(y){this.listeners.data.slice(0).forEach(I=>I(y))}emitError(y){this.listeners.error.length===0?(0,m.onUnexpectedError)(y):this.listeners.error.slice(0).forEach(I=>I(y))}emitEnd(){this.listeners.end.slice(0).forEach(y=>y())}on(y,I){if(!this.state.destroyed)switch(y){case"data":this.listeners.data.push(I),this.resume();break;case"end":this.listeners.end.push(I),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(I),this.state.flowing&&this.flowErrors();break}}removeListener(y,I){if(!this.state.destroyed){let S;switch(y){case"data":S=this.listeners.data;break;case"end":S=this.listeners.end;break;case"error":S=this.listeners.error;break}if(S){const o=S.indexOf(I);o>=0&&S.splice(o,1)}}}flowData(){if(this.buffer.data.length>0){const y=this.reducer(this.buffer.data);this.emitData(y),this.buffer.data.length=0;const I=[...this.pendingWritePromises];this.pendingWritePromises.length=0,I.forEach(S=>S())}}flowErrors(){if(this.listeners.error.length>0){for(const y of this.buffer.error)this.emitError(y);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(p,y){const I=[];let S;for(;(S=p.read())!==null;)I.push(S);return y(I)}t.consumeReadable=d;function f(p,y,I){const S=[];let o;for(;(o=p.read())!==null&&S.length<I;)S.push(o);return o===null&&S.length>0?y(S):{read:()=>{if(S.length>0)return S.shift();if(typeof o!="undefined"){const i=o;return o=void 0,i}return p.read()}}}t.peekReadable=f;function O(p,y){return new Promise((I,S)=>{const o=[];h(p,{onData:i=>{y&&o.push(i)},onError:i=>{y?S(i):I(void 0)},onEnd:()=>{I(y?y(o):void 0)}})})}t.consumeStream=O;function h(p,y){p.on("error",I=>y.onError(I)),p.on("end",()=>y.onEnd()),p.on("data",I=>y.onData(I))}t.listenStream=h;function E(p,y){return new Promise((I,S)=>{const o=new C.DisposableStore,i=[],e=a=>{if(i.push(a),i.length>y)return o.dispose(),p.pause(),I({stream:p,buffer:i,ended:!1})},n=a=>S(a),r=()=>I({stream:p,buffer:i,ended:!0});o.add((0,C.toDisposable)(()=>p.removeListener("error",n))),p.on("error",n),o.add((0,C.toDisposable)(()=>p.removeListener("end",r))),p.on("end",r),o.add((0,C.toDisposable)(()=>p.removeListener("data",e))),p.on("data",e)})}t.peekStream=E;function P(p,y){const I=T(y);return I.end(p),I}t.toStream=P;function l(p){let y=!1;return{read:()=>y?null:(y=!0,p)}}t.toReadable=l;function v(p,y,I){const S=T(I);return h(p,{onData:o=>S.write(y.data(o)),onError:o=>S.error(y.error?y.error(o):o),onEnd:()=>S.end()}),S}t.transform=v}),define(Q[17],Z([0,1,21,34]),function($,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const b=typeof Buffer!="undefined",w=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let R,d;class f{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return b?new f(Buffer.allocUnsafe(s)):new f(new Uint8Array(s))}static wrap(s){return b&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new f(s)}static fromString(s,g){return!((g==null?void 0:g.dontUseNodeBuffer)||!1)&&b?new f(Buffer.from(s)):w?(R||(R=new TextEncoder),new f(R.encode(s))):new f(m.encodeUTF8(s))}static concat(s,g){if(typeof g=="undefined"){g=0;for(let N=0,A=s.length;N<A;N++)g+=s[N].byteLength}const F=f.alloc(g);let U=0;for(let N=0,A=s.length;N<A;N++){const j=s[N];F.set(j,U),U+=j.byteLength}return F}toString(){return b?this.buffer.toString():T?(d||(d=new TextDecoder),d.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(s,g){return new f(this.buffer.subarray(s,g))}set(s,g){s instanceof f?this.buffer.set(s.buffer,g):this.buffer.set(s,g)}readUInt32BE(s){return E(this.buffer,s)}writeUInt32BE(s,g){P(this.buffer,s,g)}readUInt32LE(s){return l(this.buffer,s)}writeUInt32LE(s,g){v(this.buffer,s,g)}readUInt8(s){return p(this.buffer,s)}writeUInt8(s,g){y(this.buffer,s,g)}}t.VSBuffer=f;function O(a,s){return a[s+0]<<0>>>0|a[s+1]<<8>>>0}t.readUInt16LE=O;function h(a,s,g){a[g+0]=s&255,s=s>>>8,a[g+1]=s&255}t.writeUInt16LE=h;function E(a,s){return a[s]*2**24+a[s+1]*2**16+a[s+2]*2**8+a[s+3]}t.readUInt32BE=E;function P(a,s,g){a[g+3]=s,s=s>>>8,a[g+2]=s,s=s>>>8,a[g+1]=s,s=s>>>8,a[g]=s}t.writeUInt32BE=P;function l(a,s){return a[s+0]<<0>>>0|a[s+1]<<8>>>0|a[s+2]<<16>>>0|a[s+3]<<24>>>0}t.readUInt32LE=l;function v(a,s,g){a[g+0]=s&255,s=s>>>8,a[g+1]=s&255,s=s>>>8,a[g+2]=s&255,s=s>>>8,a[g+3]=s&255}t.writeUInt32LE=v;function p(a,s){return a[s]}t.readUInt8=p;function y(a,s,g){a[g]=s}t.writeUInt8=y;function I(a){return C.consumeReadable(a,s=>f.concat(s))}t.readableToBuffer=I;function S(a){return C.toReadable(a)}t.bufferToReadable=S;function o(a){return C.consumeStream(a,s=>f.concat(s))}t.streamToBuffer=o;async function i(a){return a.ended?f.concat(a.buffer):f.concat([...a.buffer,await o(a.stream)])}t.bufferedStreamToBuffer=i;function e(a){return C.toStream(a,s=>f.concat(s))}t.bufferToStream=e;function n(a){return C.transform(a,{data:s=>typeof s=="string"?f.fromString(s):f.wrap(s)},s=>f.concat(s))}t.streamToBufferReadableStream=n;function r(a){return C.newWriteableStream(s=>f.concat(s),a)}t.newWriteableBufferStream=r}),define(Q[22],Z([0,1,8]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function C(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const v=Array.isArray(l)?[]:{};return Object.keys(l).forEach(p=>{l[p]&&typeof l[p]=="object"?v[p]=C(l[p]):v[p]=l[p]}),v}t.deepClone=C;function b(l){if(!l||typeof l!="object")return l;const v=[l];for(;v.length>0;){const p=v.shift();Object.freeze(p);for(const y in p)if(w.call(p,y)){const I=p[y];typeof I=="object"&&!Object.isFrozen(I)&&v.push(I)}}return l}t.deepFreeze=b;const w=Object.prototype.hasOwnProperty;function T(l,v){return R(l,v,new Set)}t.cloneAndChange=T;function R(l,v,p){if((0,m.isUndefinedOrNull)(l))return l;const y=v(l);if(typeof y!="undefined")return y;if((0,m.isArray)(l)){const I=[];for(const S of l)I.push(R(S,v,p));return I}if((0,m.isObject)(l)){if(p.has(l))throw new Error("Cannot clone recursive data-structure");p.add(l);const I={};for(let S in l)w.call(l,S)&&(I[S]=R(l[S],v,p));return p.delete(l),I}return l}function d(l,v,p=!0){return(0,m.isObject)(l)?((0,m.isObject)(v)&&Object.keys(v).forEach(y=>{y in l?p&&((0,m.isObject)(l[y])&&(0,m.isObject)(v[y])?d(l[y],v[y],p):l[y]=v[y]):l[y]=v[y]}),l):v}t.mixin=d;function f(l,v){if(l===v)return!0;if(l==null||v===null||v===void 0||typeof l!=typeof v||typeof l!="object"||Array.isArray(l)!==Array.isArray(v))return!1;let p,y;if(Array.isArray(l)){if(l.length!==v.length)return!1;for(p=0;p<l.length;p++)if(!f(l[p],v[p]))return!1}else{const I=[];for(y in l)I.push(y);I.sort();const S=[];for(y in v)S.push(y);if(S.sort(),!f(I,S))return!1;for(p=0;p<I.length;p++)if(!f(l[I[p]],v[I[p]]))return!1}return!0}t.equals=f;function O(l){const v=new Set;return JSON.stringify(l,(p,y)=>{if((0,m.isObject)(y)||Array.isArray(y)){if(v.has(y))return"[Circular]";v.add(y)}return y})}t.safeStringify=O;function h(l,v,p){const y=v(l);return typeof y=="undefined"?p:y}t.getOrDefault=h;function E(l,v){const p=Object.create(null);return!l||!v||Object.keys(v).forEach(I=>{const S=l[I],o=v[I];f(S,o)||(p[I]=o)}),p}t.distinct=E;function P(l,v){const p=v.toLowerCase(),y=Object.keys(l).find(I=>I.toLowerCase()===p);return y?l[y]:l[v]}t.getCaseInsensitive=P}),define(Q[59],Z([0,1,9]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function C(f){const O=f;return O&&typeof O.type=="string"&&typeof O.severity=="string"}t.isRemoteConsoleLog=C;function b(f){const O=[];let h;try{const E=JSON.parse(f.arguments),P=E[E.length-1];P&&P.__$stack&&(E.pop(),h=P.__$stack),O.push(...E)}catch(E){O.push("Unable to log remote console arguments",f.arguments)}return{args:O,stack:h}}t.parse=b;function w(f){if(typeof f!="string")return w(b(f).stack);const O=f;if(O){const h=T(O),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(h||"");if(E&&E.length===4)return{uri:m.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}t.getFirstFrame=w;function T(f){if(!f)return f;const O=f.indexOf(`
`);return O===-1?f:f.substring(0,O)}function R(f,O){const{args:h,stack:E}=b(f),P=typeof h[0]=="string"&&h.length===1;let l=T(E);l&&(l=`(${l.trim()})`);let v=[];if(typeof h[0]=="string"?l&&P?v=[`%c[${O}] %c${h[0]} %c${l}`,d("blue"),d(""),d("grey")]:v=[`%c[${O}] %c${h[0]}`,d("blue"),d(""),...h.slice(1)]:v=[`%c[${O}]%`,d("blue"),...h],l&&!P&&v.push(l),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,v)}t.log=R;function d(f){return`color: ${f}`}}),define(Q[60],Z([0,1,17,21,9]),function($,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function w(f){return JSON.stringify(f,R)}t.stringify=w;function T(f){let O=JSON.parse(f);return O=d(O),O}t.parse=T;function R(f,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,C.regExpFlags)(O)}:O}function d(f,O=0){if(!f||O>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return b.URI.revive(f);case 2:return new RegExp(f.source,f.flags)}if(f instanceof m.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let h=0;h<f.length;++h)f[h]=d(f[h],O+1);else for(const h in f)Object.hasOwnProperty.call(f,h)&&(f[h]=d(f[h],O+1))}return f}t.revive=d}),define(Q[61],Z([0,1,21,35,3,44,4]),function($,t,m,C,b,w,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function R(){return Object.create(null)}t.getEmptyExpression=R;const d="**",f="/",O="[/\\\\]",h="[^/\\\\]",E=/\//g;function P(u){switch(u){case 0:return"";case 1:return`${h}*?`;default:return`(?:${O}|${h}+${O}|${O}${h}+)*?`}}function l(u,D){if(!u)return[];const L=[];let k=!1,M=!1,z="";for(const B of u){switch(B){case D:if(!k&&!M){L.push(z),z="";continue}break;case"{":k=!0;break;case"}":k=!1;break;case"[":M=!0;break;case"]":M=!1;break}z+=B}return z&&L.push(z),L}t.splitGlobAware=l;function v(u){if(!u)return"";let D="";const L=l(u,f);if(L.every(k=>k===d))D=".*";else{let k=!1;L.forEach((M,z)=>{if(M===d){k||(D+=P(2),k=!0);return}let B=!1,q="",J=!1,Y="";for(const ie of M){if(ie!=="}"&&B){q+=ie;continue}if(J&&(ie!=="]"||!Y)){let re;ie==="-"?re=ie:(ie==="^"||ie==="!")&&!Y?re="^":ie===f?re="":re=m.escapeRegExpCharacters(ie),Y+=re;continue}switch(ie){case"{":B=!0;continue;case"[":J=!0;continue;case"}":D+=`(?:${l(q,",").map(ge=>v(ge)).join("|")})`,B=!1,q="";break;case"]":D+="["+Y+"]",J=!1,Y="";break;case"?":D+=h;continue;case"*":D+=P(1);continue;default:D+=m.escapeRegExpCharacters(ie)}}z<L.length-1&&(L[z+1]!==d||z+2<L.length)&&(D+=O),k=!1})}return D}const p=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,S=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new w.LRUCache(1e4),n=function(){return!1},r=function(){return null};function a(u,D){if(!u)return r;let L;typeof u!="string"?L=u.pattern:L=u,L=L.trim();const k=`${L}_${!!D.trimForExclusions}`;let M=e.get(k);if(M)return s(M,u);let z;if(p.test(L)){const B=L.substr(4);M=function(q,J){return typeof q=="string"&&q.endsWith(B)?L:null}}else(z=y.exec(g(L,D)))?M=F(z[1],L):(D.trimForExclusions?S:I).test(L)?M=U(L,D):(z=o.exec(g(L,D)))?M=N(z[1].substr(1),L,!0):(z=i.exec(g(L,D)))?M=N(z[1],L,!1):M=A(L);return e.set(k,M),s(M,u)}function s(u,D){return typeof D=="string"?u:function(L,k){return C.isEqualOrParent(L,D.base)?u(b.relative(D.base,L),k):null}}function g(u,D){return D.trimForExclusions&&u.endsWith("/**")?u.substr(0,u.length-2):u}function F(u,D){const L=`/${u}`,k=`\\${u}`,M=function(B,q){return typeof B!="string"?null:q?q===u?D:null:B===u||B.endsWith(L)||B.endsWith(k)?D:null},z=[u];return M.basenames=z,M.patterns=[D],M.allBasenames=z,M}function U(u,D){const L=c(u.slice(1,-1).split(",").map(q=>a(q,D)).filter(q=>q!==r),u),k=L.length;if(!k)return r;if(k===1)return L[0];const M=function(q,J){for(let Y=0,ie=L.length;Y<ie;Y++)if(L[Y](q,J))return u;return null},z=L.find(q=>!!q.allBasenames);z&&(M.allBasenames=z.allBasenames);const B=L.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return B.length&&(M.allPaths=B),M}function N(u,D,L){const k=b.sep===b.posix.sep,M=k?u:u.replace(E,b.sep),z=b.sep+M,B=b.posix.sep+u,q=L?function(J,Y){return typeof J=="string"&&(J===M||J.endsWith(z)||!k&&(J===u||J.endsWith(B)))?D:null}:function(J,Y){return typeof J=="string"&&(J===M||!k&&J===u)?D:null};return q.allPaths=[(L?"*/":"./")+u],q}function A(u){try{const D=new RegExp(`^${v(u)}$`);return function(L){return D.lastIndex=0,typeof L=="string"&&D.test(L)?u:null}}catch(D){return r}}function j(u,D,L){return!u||typeof D!="string"?!1:x(u)(D,void 0,L)}t.match=j;function x(u,D={}){if(!u)return n;if(typeof u=="string"||te(u)){const L=a(u,D);if(L===r)return n;const k=function(M,z){return!!L(M,z)};return L.allBasenames&&(k.allBasenames=L.allBasenames),L.allPaths&&(k.allPaths=L.allPaths),k}return G(u,D)}t.parse=x;function X(u){if(!!u){let D;return L=>(D||(D=(u()||Promise.resolve([])).then(k=>k?ee(k):{})),D.then(k=>!!k[L]))}}t.hasSiblingPromiseFn=X;function ne(u){if(!!u){let D;return L=>{if(!D){const k=u();D=k?ee(k):{}}return!!D[L]}}}t.hasSiblingFn=ne;function ee(u){const D={};for(const L of u)D[L]=!0;return D}function te(u){const D=u;return D&&typeof D.base=="string"&&typeof D.pattern=="string"}t.isRelativePattern=te;function ae(u){return u.allBasenames||[]}t.getBasenameTerms=ae;function W(u){return u.allPaths||[]}t.getPathTerms=W;function G(u,D){const L=c(Object.getOwnPropertyNames(u).map(q=>_(q,u[q],D)).filter(q=>q!==r)),k=L.length;if(!k)return r;if(!L.some(q=>!!q.requiresSiblings)){if(k===1)return L[0];const q=function(ie,re){for(let he=0,ge=L.length;he<ge;he++){const De=L[he](ie,re);if(De)return De}return null},J=L.find(ie=>!!ie.allBasenames);J&&(q.allBasenames=J.allBasenames);const Y=L.reduce((ie,re)=>re.allPaths?ie.concat(re.allPaths):ie,[]);return Y.length&&(q.allPaths=Y),q}const M=function(q,J,Y){let ie;for(let re=0,he=L.length;re<he;re++){const ge=L[re];ge.requiresSiblings&&Y&&(J||(J=b.basename(q)),ie||(ie=J.substr(0,J.length-b.extname(q).length)));const De=ge(q,J,ie,Y);if(De)return De}return null},z=L.find(q=>!!q.allBasenames);z&&(M.allBasenames=z.allBasenames);const B=L.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return B.length&&(M.allPaths=B),M}function _(u,D,L){if(D===!1)return r;const k=a(u,L);if(k===r)return r;if(typeof D=="boolean")return k;if(D){const M=D.when;if(typeof M=="string"){const z=(B,q,J,Y)=>{if(!Y||!k(B,q))return null;const ie=M.replace("$(basename)",J),re=Y(ie);return(0,T.isThenable)(re)?re.then(he=>he?u:null):re?u:null};return z.requiresSiblings=!0,z}}return k}function c(u,D){const L=u.filter(q=>!!q.basenames);if(L.length<2)return u;const k=L.reduce((q,J)=>{const Y=J.basenames;return Y?q.concat(Y):q},[]);let M;if(D){M=[];for(let q=0,J=k.length;q<J;q++)M.push(D)}else M=L.reduce((q,J)=>{const Y=J.patterns;return Y?q.concat(Y):q},[]);const z=function(q,J){if(typeof q!="string")return null;if(!J){let ie;for(ie=q.length;ie>0;ie--){const re=q.charCodeAt(ie-1);if(re===47||re===92)break}J=q.substr(ie)}const Y=k.indexOf(J);return Y!==-1?M[Y]:null};z.basenames=k,z.patterns=M,z.allBasenames=k;const B=u.filter(q=>!q.basenames);return B.push(z),B}}),define(Q[62],Z([0,1,9,3,21,10,14,18,35]),function($,t,m,C,b,w,T,R,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function f(a,s,g){if(typeof a=="string"&&(a=m.URI.file(a)),g){const U=g.getWorkspaceFolder(a);if(U){const N=g.getWorkspace().folders.length>1;let A;if((0,R.isEqual)(U.uri,a)?A="":A=(0,R.relativePath)(U.uri,a),N){const j=U.name?U.name:(0,R.basename)(U.uri);A=A?j+" \u2022 "+A:j}return A}}if(a.scheme!==w.Schemas.file&&a.scheme!==w.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(a.fsPath))return(0,C.normalize)(h(a.fsPath));let F=(0,C.normalize)(a.fsPath);return!T.isWindows&&(s==null?void 0:s.userHome)&&(F=P(F,s.userHome.fsPath)),F}t.getPathLabel=f;function O(a){if(!!a){typeof a=="string"&&(a=m.URI.file(a));const s=(0,R.basename)(a)||(a.scheme===w.Schemas.file?a.fsPath:a.path);return T.isWindows&&(0,d.isRootOrDriveLetter)(s)?h(s):s}}t.getBaseLabel=O;function h(a){return(0,d.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}t.normalizeDriveLetter=h;let E=Object.create(null);function P(a,s){if(T.isWindows||!a||!s)return a;let g=E.original===s?E.normalized:void 0;return g||(g=`${(0,b.rtrim)(s,C.posix.sep)}${C.posix.sep}`,E={original:s,normalized:g}),(T.isLinux?a.startsWith(g):(0,b.startsWithIgnoreCase)(a,g))&&(a=`~/${a.substr(g.length)}`),a}t.tildify=P;function l(a,s){return a.replace(/^~($|\/|\\)/,`${s}$1`)}t.untildify=l;const v="\u2026",p="\\\\",y="~";function I(a,s=C.sep){const g=new Array(a.length);let F=!1;for(let U=0;U<a.length;U++){let N=a[U];if(N===""){g[U]=`.${s}`;continue}if(!N){g[U]=N;continue}F=!0;let A="";N.indexOf(p)===0?(A=N.substr(0,N.indexOf(p)+p.length),N=N.substr(N.indexOf(p)+p.length)):N.indexOf(s)===0?(A=N.substr(0,N.indexOf(s)+s.length),N=N.substr(N.indexOf(s)+s.length)):N.indexOf(y)===0&&(A=N.substr(0,N.indexOf(y)+y.length),N=N.substr(N.indexOf(y)+y.length));const j=N.split(s);for(let x=1;F&&x<=j.length;x++)for(let X=j.length-x;F&&X>=0;X--){F=!1;let ne=j.slice(X,X+x).join(s);for(let ee=0;!F&&ee<a.length;ee++)if(ee!==U&&a[ee]&&a[ee].indexOf(ne)>-1){const te=X+x===j.length,ae=X>0&&a[ee].indexOf(s)>-1?s+ne:ne,W=a[ee].endsWith(ae);F=!te||W}if(!F){let ee="";(j[0].endsWith(":")||A!=="")&&(X===1&&(X=0,x++,ne=j[0]+s+ne),X>0&&(ee=j[0]+s),ee=A+ee),X>0&&(ee=ee+v+s),ee=ee+ne,X+x<j.length&&(ee=ee+s+v),g[U]=ee}}F&&(g[U]=N)}return g}t.shorten=I;var S;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(S||(S={}));function o(a,s=Object.create(null)){const g=[];let F=!1,U="";for(const N of a)if(N==="$"||F&&N==="{")U&&g.push({value:U,type:S.TEXT}),U="",F=!0;else if(N==="}"&&F){const A=s[U];if(typeof A=="string")A.length&&g.push({value:A,type:S.VARIABLE});else if(A){const j=g[g.length-1];(!j||j.type!==S.SEPARATOR)&&g.push({value:A.label,type:S.SEPARATOR})}U="",F=!1}else U+=N;return U&&!F&&g.push({value:U,type:S.TEXT}),g.filter((N,A)=>{if(N.type===S.SEPARATOR){const j=g[A-1],x=g[A+1];return[j,x].every(X=>X&&(X.type===S.VARIABLE||X.type===S.TEXT)&&X.value.length>0)}return!0}).map(N=>N.value).join("")}t.template=o;function i(a,s){return T.isMacintosh||s?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):a.replace(/&&|&/g,g=>g==="&"?"&&":"&")}t.mnemonicMenuLabel=i;function e(a,s){return T.isMacintosh||s?a.replace(/\(&&\w\)|&&/g,""):T.isWindows?a.replace(/&&|&/g,g=>g==="&"?"&&":"&"):a.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function n(a){return a.replace(/&/g,"&&")}t.unmnemonicLabel=n;function r(a){const s=a.indexOf("/")!==-1?C.posix:C.win32,g=s.basename(a),F=s.dirname(a);return g.length?{name:g,parentPath:F}:{name:F,parentPath:""}}t.splitName=r}),define(Q[45],Z([0,1,126]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class C{constructor(w="utf8"){this.stringDecoder=new m.StringDecoder(w),this.remaining=null}write(w){const T=[],R=this.remaining?this.remaining+this.stringDecoder.write(w):this.stringDecoder.write(w);if(R.length<1)return T;let d=0,f,O=d;for(;O<R.length;)if(f=R.charCodeAt(O),f===13||f===10){if(T.push(R.substring(d,O)),O++,O<R.length){const h=f;f=R.charCodeAt(O),(h===13&&f===10||h===10&&f===13)&&O++}d=O}else O++;return this.remaining=d<R.length?R.substr(d):null,T}end(){return this.remaining}}t.LineDecoder=C}),define(Q[63],Z([0,1,16,64,21,3,12]),function($,t,m,C,b,w,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function R(h){const E=(0,w.dirname)(h);if(h===E)return h;const P=((0,w.basename)(h)||h).toLowerCase();try{const v=(0,T.readdirSync)(E).filter(p=>p.toLowerCase()===P);if(v.length===1){const p=R(E);if(p)return(0,w.join)(p,v[0])}else if(v.length>1){const p=v.indexOf(P);if(p>=0){const y=R(E);if(y)return(0,w.join)(y,v[p])}}}catch(l){}return null}t.realcaseSync=R;async function d(h){try{return await(0,C.promisify)(m.realpath)(h)}catch(E){const P=O(h);return await m.promises.access(P,m.constants.R_OK),P}}t.realpath=d;function f(h){try{return m.realpathSync(h)}catch(E){const P=O(h);return m.accessSync(P,m.constants.R_OK),P}}t.realpathSync=f;function O(h){return(0,b.rtrim)((0,w.normalize)(h),w.sep)}});var ye=this&&this.__await||function($){return this instanceof ye?(this.v=$,this):new ye($)},Ve=this&&this.__asyncGenerator||function($,t,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var C=m.apply($,t||[]),b,w=[];return b={},T("next"),T("throw"),T("return"),b[Symbol.asyncIterator]=function(){return this},b;function T(E){C[E]&&(b[E]=function(P){return new Promise(function(l,v){w.push([E,P,l,v])>1||R(E,P)})})}function R(E,P){try{d(C[E](P))}catch(l){h(w[0][3],l)}}function d(E){E.value instanceof ye?Promise.resolve(E.value.v).then(f,O):h(w[0][2],E)}function f(E){R("next",E)}function O(E){R("throw",E)}function h(E,P){E(P),w.shift(),w.length&&R(w[0][0],w[0][1])}},_e=this&&this.__asyncValues||function($){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t=$[Symbol.asyncIterator],m;return t?t.call($):($=typeof __values=="function"?__values($):$[Symbol.iterator](),m={},C("next"),C("throw"),C("return"),m[Symbol.asyncIterator]=function(){return this},m);function C(w){m[w]=$[w]&&function(T){return new Promise(function(R,d){T=$[w](T),b(R,d,T.done,T.value)})}}function b(w,T,R,d){Promise.resolve(d).then(function(f){w({value:f,done:R})},T)}};define(Q[65],Z([0,1,12,32,3]),function($,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const w=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var d;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(d||(d={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let O;process.env.PROCESSOR_ARCHITEW6432?O=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?O=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?O=1:O=0;class h{constructor(i,e,n){this.exePath=i,this.displayName=e,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:o=!1}={}){return o?f===0?process.env["ProgramFiles(x86)"]||null:O===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function P({useAlternateBitness:o=!1,findPreview:i=!1}={}){const e=E({useAlternateBitness:o});if(!e)return null;const n=b.join(e,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(n))return null;let r=-1,a=null;for(const F of await m.readdir(n)){let U=-1;if(i){const A=F.indexOf("-");if(A<0)continue;const j=F.substring(0,A);if(!w.test(j)||F.substring(A+1)!=="preview")continue;U=parseInt(j,10)}else{if(!w.test(F))continue;U=parseInt(F,10)}if(!(U<=r)){const N=b.join(n,F,"pwsh.exe");!await m.SymlinkSupport.existsFile(N)||(a=N,r=U)}}if(!a)return null;const s=e.includes("x86")?" (x86)":"",g=i?" Preview":"";return new h(a,`PowerShell${g}${s}`,!0)}async function l({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const i=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:e,pwshMsixName:n}=o?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const r of await m.readdir(i))if(e.test(r)){const a=b.join(i,r,"pwsh.exe");return new h(a,n)}return null}function v(){const o=b.join(C.homedir(),".dotnet","tools","pwsh.exe");return new h(o,".NET Core PowerShell Global Tool")}function p(){const o=b.join(process.env.windir,f===1&&O!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new h(o,"Windows PowerShell",!0)}function y(){return Ve(this,arguments,function*(){let i=yield ye(P());i&&(yield yield ye(i)),i=yield ye(P({useAlternateBitness:!0})),i&&(yield yield ye(i)),i=yield ye(l()),i&&(yield yield ye(i)),i=v(),i&&(yield yield ye(i)),i=yield ye(P({findPreview:!0})),i&&(yield yield ye(i)),i=yield ye(l({findPreview:!0})),i&&(yield yield ye(i)),i=yield ye(P({useAlternateBitness:!0,findPreview:!0})),i&&(yield yield ye(i)),i=p(),i&&(yield yield ye(i))})}function I(){return Ve(this,arguments,function*(){var i,e;try{for(var n=_e(y()),r;r=yield ye(n.next()),!r.done;){const a=r.value;(yield ye(a.exists()))&&(yield yield ye(a))}}catch(a){i={error:a}}finally{try{r&&!r.done&&(e=n.return)&&(yield ye(e.call(n)))}finally{if(i)throw i.error}}})}t.enumeratePowerShellInstallations=I;async function S(){var o,i;try{for(var e=_e(I()),n;n=await e.next(),!n.done;)return n.value}catch(r){o={error:r}}finally{try{n&&!n.done&&(i=e.return)&&await i.call(e)}finally{if(o)throw o.error}}return null}t.getFirstAvailablePowerShellInstallation=S}),define(Q[66],Z([0,1,3,16,14,127,2,12]),function($,t,m,C,b,w,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function d(h,E,P){return O({path:h,isDirectory:!1},E,P)}t.watchFile=d;function f(h,E,P){return O({path:h,isDirectory:!0},E,P)}t.watchFolder=f,t.CHANGE_BUFFER_DELAY=100;function O(h,E,P){const l=(0,m.basename)(h.path),v=new Map;let p=!1,y=[(0,T.toDisposable)(()=>{v.forEach(I=>(0,T.dispose)(I)),v.clear()})];try{const I=(0,C.watch)(h.path);y.push((0,T.toDisposable)(()=>{I.removeAllListeners(),I.close()}));const S=new Set;h.isDirectory&&(0,R.readdir)(h.path).then(o=>o.forEach(i=>S.add(i))),I.on("error",(o,i)=>{p||P(`Failed to watch ${h.path} for changes using fs.watch() (${o}, ${i})`)}),I.on("change",(o,i)=>{if(!p){let e="";if(i&&(e=i.toString(),b.isMacintosh&&(e=(0,w.normalizeNFC)(e))),!(!e||o!=="change"&&o!=="rename")){const n=h.isDirectory?(0,m.join)(h.path,e):h.path;if(h.isDirectory)if(o==="rename"){const r=v.get(n);r&&(0,T.dispose)(r);const a=setTimeout(async()=>{v.delete(n);const s=await(0,R.exists)(n);if(!p){let g;s?S.has(e)?g="changed":(g="added",S.add(e)):(S.delete(e),g="deleted"),E(g,n)}},t.CHANGE_BUFFER_DELAY);v.set(n,(0,T.toDisposable)(()=>clearTimeout(a)))}else{let r;S.has(e)?r="changed":(r="added",S.add(e)),E(r,n)}else if(o==="rename"||e!==l){const r=setTimeout(async()=>{const a=await(0,R.exists)(n);p||(a?(E("changed",n),y=[O(h,E,P)]):E("deleted",n))},t.CHANGE_BUFFER_DELAY);(0,T.dispose)(y),y=[(0,T.toDisposable)(()=>clearTimeout(r))]}else E("changed",n)}}})}catch(I){(0,R.exists)(h.path).then(S=>{S&&!p&&P(`Failed to watch ${h.path} for changes using fs.watch() (${I.toString()})`)})}return(0,T.toDisposable)(()=>{p=!0,y=(0,T.dispose)(y)})}}),define(Q[36],Z([0,1,11,2,4,28,15,17,23,8,60,21]),function($,t,m,C,b,w,T,R,d,f,O,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var E;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(E=t.RequestType||(t.RequestType={}));function P(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(l=t.ResponseType||(t.ResponseType={}));function v(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(p||(p={}));class y{constructor(c){this.buffer=c,this.pos=0}read(c){const u=this.buffer.slice(this.pos,this.pos+c);return this.pos+=u.byteLength,u}}class I{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(c){this.buffers.push(c)}}var S;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(S||(S={}));function o(_){const c=R.VSBuffer.alloc(4);return c.writeUInt32BE(_,0),c}function i(_){return _.read(4).readUInt32BE(0)}function e(_){const c=R.VSBuffer.alloc(1);return c.writeUInt8(_,0),c}const n={Undefined:e(S.Undefined),String:e(S.String),Buffer:e(S.Buffer),VSBuffer:e(S.VSBuffer),Array:e(S.Array),Object:e(S.Object)},r=typeof Buffer!="undefined";function a(_,c){if(typeof c=="undefined")_.write(n.Undefined);else if(typeof c=="string"){const u=R.VSBuffer.fromString(c);_.write(n.String),_.write(o(u.byteLength)),_.write(u)}else if(r&&Buffer.isBuffer(c)){const u=R.VSBuffer.wrap(c);_.write(n.Buffer),_.write(o(u.byteLength)),_.write(u)}else if(c instanceof R.VSBuffer)_.write(n.VSBuffer),_.write(o(c.byteLength)),_.write(c);else if(Array.isArray(c)){_.write(n.Array),_.write(o(c.length));for(const u of c)a(_,u)}else{const u=R.VSBuffer.fromString(JSON.stringify(c));_.write(n.Object),_.write(o(u.byteLength)),_.write(u)}}function s(_){switch(_.read(1).readUInt8(0)){case S.Undefined:return;case S.String:return _.read(i(_)).toString();case S.Buffer:return _.read(i(_)).buffer;case S.VSBuffer:return _.read(i(_));case S.Array:{const u=i(_),D=[];for(let L=0;L<u;L++)D.push(s(_));return D}case S.Object:return JSON.parse(_.read(i(_)).toString())}}class g{constructor(c,u,D=null,L=1e3){this.protocol=c,this.ctx=u,this.logger=D,this.timeoutDelay=L,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(k=>this.onRawMessage(k)),this.sendResponse({type:200})}registerChannel(c,u){this.channels.set(c,u),setTimeout(()=>this.flushPendingRequests(c),0)}sendResponse(c){switch(c.type){case 200:{const u=this.send([c.type]);this.logger&&this.logger.logOutgoing(u,0,1,v(c.type));return}case 201:case 202:case 204:case 203:{const u=this.send([c.type,c.id],c.data);this.logger&&this.logger.logOutgoing(u,c.id,1,v(c.type),c.data);return}}}send(c,u=void 0){const D=new I;return a(D,c),a(D,u),this.sendBuffer(D.buffer)}sendBuffer(c){try{return this.protocol.send(c),c.byteLength}catch(u){return 0}}onRawMessage(c){const u=new y(c),D=s(u),L=s(u),k=D[0];switch(k){case 100:return this.logger&&this.logger.logIncoming(c.byteLength,D[1],1,`${P(k)}: ${D[2]}.${D[3]}`,L),this.onPromise({type:k,id:D[1],channelName:D[2],name:D[3],arg:L});case 102:return this.logger&&this.logger.logIncoming(c.byteLength,D[1],1,`${P(k)}: ${D[2]}.${D[3]}`,L),this.onEventListen({type:k,id:D[1],channelName:D[2],name:D[3],arg:L});case 101:return this.logger&&this.logger.logIncoming(c.byteLength,D[1],1,`${P(k)}`),this.disposeActiveRequest({type:k,id:D[1]});case 103:return this.logger&&this.logger.logIncoming(c.byteLength,D[1],1,`${P(k)}`),this.disposeActiveRequest({type:k,id:D[1]})}}onPromise(c){const u=this.channels.get(c.channelName);if(!u){this.collectPendingRequest(c);return}const D=new w.CancellationTokenSource;let L;try{L=u.call(this.ctx,c.name,c.arg,D.token)}catch(z){L=Promise.reject(z)}const k=c.id;L.then(z=>{this.sendResponse({id:k,data:z,type:201}),this.activeRequests.delete(c.id)},z=>{z instanceof Error?this.sendResponse({id:k,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.sendResponse({id:k,data:z,type:203}),this.activeRequests.delete(c.id)});const M=(0,C.toDisposable)(()=>D.cancel());this.activeRequests.set(c.id,M)}onEventListen(c){const u=this.channels.get(c.channelName);if(!u){this.collectPendingRequest(c);return}const D=c.id,k=u.listen(this.ctx,c.name,c.arg)(M=>this.sendResponse({id:D,data:M,type:204}));this.activeRequests.set(c.id,k)}disposeActiveRequest(c){const u=this.activeRequests.get(c.id);u&&(u.dispose(),this.activeRequests.delete(c.id))}collectPendingRequest(c){let u=this.pendingRequests.get(c.channelName);u||(u=[],this.pendingRequests.set(c.channelName,u));const D=setTimeout(()=>{console.error(`Unknown channel: ${c.channelName}`),c.type===100&&this.sendResponse({id:c.id,data:{name:"Unknown channel",message:`Channel name '${c.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);u.push({request:c,timeoutTimer:D})}flushPendingRequests(c){const u=this.pendingRequests.get(c);if(u){for(const D of u)switch(clearTimeout(D.timeoutTimer),D.request.type){case 100:this.onPromise(D.request);break;case 102:this.onEventListen(D.request);break}this.pendingRequests.delete(c)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(c=>c.dispose()),this.activeRequests.clear()}}t.ChannelServer=g;var F;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(F=t.RequestInitiator||(t.RequestInitiator={}));class U{constructor(c,u=null){this.protocol=c,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(D=>this.onBuffer(D)),this.logger=u}getChannel(c){const u=this;return{call(D,L,k){return u.isDisposed?Promise.reject(T.canceled()):u.requestPromise(c,D,L,k)},listen(D,L){return u.isDisposed?Promise.reject(T.canceled()):u.requestEvent(c,D,L)}}}requestPromise(c,u,D,L=w.CancellationToken.None){const k=this.lastRequestId++,z={id:k,type:100,channelName:c,name:u,arg:D};if(L.isCancellationRequested)return Promise.reject(T.canceled());let B;return new Promise((J,Y)=>{if(L.isCancellationRequested)return Y(T.canceled());const ie=()=>{const De=Oe=>{switch(Oe.type){case 201:this.handlers.delete(k),J(Oe.data);break;case 202:this.handlers.delete(k);const Fe=new Error(Oe.data.message);Fe.stack=Oe.data.stack,Fe.name=Oe.data.name,Y(Fe);break;case 203:this.handlers.delete(k),Y(Oe.data);break}};this.handlers.set(k,De),this.sendRequest(z)};let re=null;this.state===p.Idle?ie():(re=(0,b.createCancelablePromise)(De=>this.whenInitialized()),re.then(()=>{re=null,ie()}));const he=()=>{re?(re.cancel(),re=null):this.sendRequest({id:k,type:101}),Y(T.canceled())},ge=L.onCancellationRequested(he);B=(0,C.combinedDisposable)((0,C.toDisposable)(he),ge),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(c,u,D){const L=this.lastRequestId++,M={id:L,type:102,channelName:c,name:u,arg:D};let z=null;const B=new m.Emitter({onFirstListenerAdd:()=>{z=(0,b.createCancelablePromise)(J=>this.whenInitialized()),z.then(()=>{z=null,this.activeRequests.add(B),this.sendRequest(M)})},onLastListenerRemove:()=>{z?(z.cancel(),z=null):(this.activeRequests.delete(B),this.sendRequest({id:L,type:103}))}}),q=J=>B.fire(J.data);return this.handlers.set(L,q),B.event}sendRequest(c){switch(c.type){case 100:case 102:{const u=this.send([c.type,c.id,c.channelName,c.name],c.arg);this.logger&&this.logger.logOutgoing(u,c.id,0,`${P(c.type)}: ${c.channelName}.${c.name}`,c.arg);return}case 101:case 103:{const u=this.send([c.type,c.id]);this.logger&&this.logger.logOutgoing(u,c.id,0,P(c.type));return}}}send(c,u=void 0){const D=new I;return a(D,c),a(D,u),this.sendBuffer(D.buffer)}sendBuffer(c){try{return this.protocol.send(c),c.byteLength}catch(u){return 0}}onBuffer(c){const u=new y(c),D=s(u),L=s(u),k=D[0];switch(k){case 200:return this.logger&&this.logger.logIncoming(c.byteLength,0,0,v(k)),this.onResponse({type:D[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(c.byteLength,D[1],0,v(k),L),this.onResponse({type:D[0],id:D[1],data:L})}}onResponse(c){if(c.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const u=this.handlers.get(c.id);u&&u(c)}whenInitialized(){return this.state===p.Idle?Promise.resolve():m.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(c=>c.dispose()),this.activeRequests.clear()}}t.ChannelClient=U;class N{constructor(c){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,c(({protocol:u,onDidClientDisconnect:D})=>{m.Event.once(u.onMessage)(k=>{const M=new y(k),z=s(M),B=new g(u,z),q=new U(u);this.channels.forEach((Y,ie)=>B.registerChannel(ie,Y));const J={channelServer:B,channelClient:q,ctx:z};this._connections.add(J),this._onDidAddConnection.fire(J),D(()=>{B.dispose(),q.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const c=[];return this._connections.forEach(u=>c.push(u)),c}getChannel(c,u){const D=this;return{call(L,k,M){let z;if((0,f.isFunction)(u)){let q=(0,d.getRandomElement)(D.connections.filter(u));z=q?Promise.resolve(q):m.Event.toPromise(m.Event.filter(D.onDidAddConnection,u))}else z=u.routeCall(D,L,k);const B=z.then(q=>q.channelClient.getChannel(c));return j(B).call(L,k,M)},listen(L,k){if((0,f.isFunction)(u))return D.getMulticastEvent(c,u,L,k);const M=u.routeEvent(D,L,k).then(z=>z.channelClient.getChannel(c));return j(M).listen(L,k)}}}getMulticastEvent(c,u,D,L){const k=this;let M=new C.DisposableStore;const z=new m.Emitter({onFirstListenerAdd:()=>{M=new C.DisposableStore;const B=new m.EventMultiplexer,q=new Map,J=ie=>{const he=ie.channelClient.getChannel(c).listen(D,L),ge=B.add(he);q.set(ie,ge)},Y=ie=>{const re=q.get(ie);!re||(re.dispose(),q.delete(ie))};k.connections.filter(u).forEach(J),m.Event.filter(k.onDidAddConnection,u)(J,void 0,M),k.onDidRemoveConnection(Y,void 0,M),B.event(z.fire,z,M),M.add(B)},onLastListenerRemove:()=>{M.dispose()}});return z.event}registerChannel(c,u){this.channels.set(c,u),this._connections.forEach(D=>{D.channelServer.registerChannel(c,u)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=N;class A{constructor(c,u,D=null){const L=new I;a(L,u),c.send(L.buffer),this.channelClient=new U(c,D),this.channelServer=new g(c,u,D)}getChannel(c){return this.channelClient.getChannel(c)}registerChannel(c,u){this.channelServer.registerChannel(c,u)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=A;function j(_){return{call(c,u,D){return _.then(L=>L.call(c,u,D))},listen(c,u){const D=new m.Relay;return _.then(L=>D.input=L.listen(c,u)),D.event}}}t.getDelayedChannel=j;function x(_){let c=!1;return{call(u,D,L){return c?_.call(u,D,L):(0,b.timeout)(0).then(()=>c=!0).then(()=>_.call(u,D,L))},listen(u,D){if(c)return _.listen(u,D);const L=new m.Relay;return(0,b.timeout)(0).then(()=>c=!0).then(()=>L.input=_.listen(u,D)),L.event}}}t.getNextTickChannel=x;class X{constructor(c){this.fn=c}routeCall(c){return this.route(c)}routeEvent(c){return this.route(c)}async route(c){for(const u of c.connections)if(await Promise.resolve(this.fn(u.ctx)))return Promise.resolve(u);return await m.Event.toPromise(c.onDidAddConnection),await this.route(c)}}t.StaticRouter=X;var ne;(function(_){function c(L,k){const M=L,z=k&&k.disableMarshalling,B=new Map;for(const q in M)D(q)&&B.set(q,m.Event.buffer(M[q],!0));return new class{listen(q,J){const Y=B.get(J);if(Y)return Y;throw new Error(`Event not found: ${J}`)}call(q,J,Y){const ie=M[J];if(typeof ie=="function"){if(!z&&Array.isArray(Y))for(let re=0;re<Y.length;re++)Y[re]=(0,O.revive)(Y[re]);return ie.apply(M,Y)}throw new Error(`Method not found: ${J}`)}}}_.fromService=c;function u(L,k){const M=k&&k.disableMarshalling;return new Proxy({},{get(z,B){var q;if(typeof B=="string")return((q=k==null?void 0:k.properties)===null||q===void 0?void 0:q.has(B))?k.properties.get(B):D(B)?L.listen(B):async function(...J){let Y;k&&!(0,f.isUndefinedOrNull)(k.context)?Y=[k.context,...J]:Y=J;const ie=await L.call(B,Y);return M?ie:(0,O.revive)(ie)};throw new Error(`Property not found: ${String(B)}`)}})}_.toService=u;function D(L){return L[0]==="o"&&L[1]==="n"&&h.isUpperAsciiLetter(L.charCodeAt(2))}})(ne=t.ProxyChannel||(t.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){let c=_.toString();if(c!=="[object Object]")return c}return _}function ae(_){return Array.isArray(_)?_.map(te):te(_)}function W(_,c,u,D,L,k,M){M=ae(M);const z=ee[L],B=z[D%z.length];let q=[`%c[${_}]%c[${String(c).padStart(7," ")}]%c[len: ${String(u).padStart(5," ")}]%c${String(D).padStart(5," ")} - ${k}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(k)?(q=q.concat(M),q.push(")")):q.push(M),console.log.apply(console,q)}t.logWithColors=W;class G{constructor(c,u){this._outgoingPrefix=c,this._incomingPrefix=u,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(c,u,D,L,k){this._totalOutgoing+=c,W(this._outgoingPrefix,this._totalOutgoing,c,u,D,L,k)}logIncoming(c,u,D,L,k){this._totalIncoming+=c,W(this._incomingPrefix,this._totalIncoming,c,u,D,L,k)}}t.IPCLogger=G}),define(Q[67],Z([0,1,2,11,4,8]),function($,t,m,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var T;(function(O){O[O.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));var R;(function(O){O[O.None=0]="None",O[O.Initialized=1]="Initialized",O[O.Closed=2]="Closed"})(R||(R={}));class d extends m.Disposable{constructor(h,E=Object.create(null)){super();this.database=h,this.options=E,this._onDidChangeStorage=this._register(new C.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new b.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){var E,P;(E=h.changed)===null||E===void 0||E.forEach((l,v)=>this.accept(v,l)),(P=h.deleted)===null||P===void 0||P.forEach(l=>this.accept(l,void 0))}accept(h,E){if(this.state!==R.Closed){let P=!1;(0,w.isUndefinedOrNull)(E)?P=this.cache.delete(h):this.cache.get(h)!==E&&(this.cache.set(h,E),P=!0),P&&this._onDidChangeStorage.fire(h)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,E){const P=this.cache.get(h);return(0,w.isUndefinedOrNull)(P)?E:P}getBoolean(h,E){const P=this.get(h);return(0,w.isUndefinedOrNull)(P)?E:P==="true"}getNumber(h,E){const P=this.get(h);return(0,w.isUndefinedOrNull)(P)?E:parseInt(P,10)}async set(h,E){if(this.state!==R.Closed){if((0,w.isUndefinedOrNull)(E))return this.delete(h);const P=String(E);if(this.cache.get(h)!==P)return this.cache.set(h,P),this.pendingInserts.set(h,P),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(h){if(this.state!==R.Closed&&!!this.cache.delete(h))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(h){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{var E;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(E=this.whenFlushedCallbacks.pop())===null||E===void 0||E()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class f{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((E,P)=>this.items.set(P,E)),h.delete&&h.delete.forEach(E=>this.items.delete(E))}async close(){}}t.InMemoryStorageDatabase=f}),define(Q[68],Z([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(Q[69],Z([0,1,68]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const C=60,b=C*60,w=b*24,T=w*7,R=w*30,d=w*365;function f(h,E){typeof h!="number"&&(h=h.getTime());const P=Math.round((new Date().getTime()-h)/1e3);if(P<-30)return(0,m.localize)(0,null,f(new Date().getTime()+P*1e3,!1));if(P<30)return(0,m.localize)(1,null);let l;return P<C?(l=P,E?l===1?(0,m.localize)(2,null,l):(0,m.localize)(3,null,l):l===1?(0,m.localize)(4,null,l):(0,m.localize)(5,null,l)):P<b?(l=Math.floor(P/C),E?l===1?(0,m.localize)(6,null,l):(0,m.localize)(7,null,l):l===1?(0,m.localize)(8,null,l):(0,m.localize)(9,null,l)):P<w?(l=Math.floor(P/b),E?l===1?(0,m.localize)(10,null,l):(0,m.localize)(11,null,l):l===1?(0,m.localize)(12,null,l):(0,m.localize)(13,null,l)):P<T?(l=Math.floor(P/w),E?l===1?(0,m.localize)(14,null,l):(0,m.localize)(15,null,l):l===1?(0,m.localize)(16,null,l):(0,m.localize)(17,null,l)):P<R?(l=Math.floor(P/T),E?l===1?(0,m.localize)(18,null,l):(0,m.localize)(19,null,l):l===1?(0,m.localize)(20,null,l):(0,m.localize)(21,null,l)):P<d?(l=Math.floor(P/R),E?l===1?(0,m.localize)(22,null,l):(0,m.localize)(23,null,l):l===1?(0,m.localize)(24,null,l):(0,m.localize)(25,null,l)):(l=Math.floor(P/d),E?l===1?(0,m.localize)(26,null,l):(0,m.localize)(27,null,l):l===1?(0,m.localize)(28,null,l):(0,m.localize)(29,null,l))}t.fromNow=f;function O(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=O}),define(Q[70],Z([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Q[29],Z([0,1,70,8,23]),function($,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function w(f,O){return O&&(f.stack||f.stacktrace)?m.localize(0,null,R(f),T(f.stack)||T(f.stacktrace)):R(f)}function T(f){return Array.isArray(f)?f.join(`
`):f}function R(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?m.localize(1,null,f.message):f.message||m.localize(2,null)}function d(f=null,O=!1){if(!f)return m.localize(3,null);if(Array.isArray(f)){const h=b.coalesce(f),E=d(h[0],O);return h.length>1?m.localize(4,null,E,h.length):E}if(C.isString(f))return f;if(f.detail){const h=f.detail;if(h.error)return w(h.error,O);if(h.exception)return w(h.exception,O)}return f.stack?w(f,O):f.message?f.message:m.localize(5,null)}t.toErrorMessage=d}),define(Q[71],Z([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(Q[46],Z([0,1,3,16,12,33,71,37,8,22,35,14,45,10]),function($,t,m,C,b,w,T,R,d,f,O,h,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function l(i){switch(i){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(i,e){if(h.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};e&&(n.cwd=e);const r=w.execFile("taskkill",["/T","/F","/PID",i.pid.toString()],n);return new Promise(a=>{r.once("error",s=>{a({success:!1,error:s})}),r.once("exit",(s,g)=>{a(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?l(n.status):1})}else if(h.isLinux||h.isMacintosh)try{const n=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(r=>{w.execFile(n,[i.pid.toString()],{encoding:"utf8",shell:!0},(a,s,g)=>{r(a?{success:!1,error:a}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else i.kill("SIGKILL");return Promise.resolve({success:!0})}function p(i=R.env){return i.comspec||"cmd.exe"}t.getWindowsShell=p;class y{constructor(e,n,r,a){if(n!==void 0&&r!==void 0&&a!==void 0)this.cmd=e,this.args=n,this.shell=r,this.options=a;else{const s=e;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(R.env).forEach(g=>{s[g]=R.env[g]}),Object.keys(this.options.env).forEach(g=>{s[g]=this.options.env[g]}),this.options.env=s}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const n=e.lastIndexOf(m.sep);return n!==-1&&(e=e.substring(n+1)),y.WellKnowCommands[e]?e:"other"}start(e){return h.isWindows&&(this.options&&this.options.cwd&&O.isUNC(this.options.cwd)||!this.options&&O.isUNC(R.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(n=>{let r,a;const s=new Promise((g,F)=>{r=g,a=F});if(n){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=w.exec(g,this.options,(F,U,N)=>{this.childProcess=null;const A=F;A&&A.killed?a({killed:this.terminateRequested,stdout:U.toString(),stderr:N.toString()}):this.handleExec(r,e,F,U,N)})}else{let g=null;const F=U=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(U,r,e,a);const N={terminated:this.terminateRequested};d.isNumber(U)&&(N.cmdCode=U),r(N)};if(this.shell&&h.isWindows){const U=f.deepClone(this.options);U.windowsVerbatimArguments=!0,U.detached=!1;let N=!1,A=!1;const j=[];let x=this.ensureQuotes(this.cmd);j.push(x.value),N=x.quoted,this.args&&this.args.forEach(ne=>{x=this.ensureQuotes(ne),j.push(x.value),A=A&&x.quoted});const X=["/s","/c"];N?A?X.push('"'+j.join(" ")+'"'):j.length>1?X.push('"'+j[0]+'" '+j.slice(1).join(" ")):X.push('"'+j[0]+'"'):X.push(j.join(" ")),g=w.spawn(p(),X,U)}else this.cmd&&(g=w.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(d.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",U=>{this.childProcess=null,a({terminated:this.terminateRequested,error:U})}),g.pid&&(this.childProcess.on("close",F),this.handleSpawn(g,r,e,a,!0)))}return s})}handleClose(e,n,r,a){}ensureQuotes(e){return y.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,v(e,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!h.isWindows)return e(!1);const n=w.spawn(p(),["/s","/c"]);n.on("error",r=>e(!0)),n.on("exit",r=>e(!1))})}}t.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class I extends y{constructor(e,n,r,a){super(e,n,r,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,n,r,a,s){[a,s].forEach((g,F)=>{const U=new E.LineDecoder;U.write(g).forEach(j=>{n({line:j,source:F===0?0:1})});const A=U.end();A&&n({line:A,source:F===0?0:1})}),e({terminated:this.terminateRequested,error:r})}handleSpawn(e,n,r,a,s){const g=new E.LineDecoder,F=new E.LineDecoder;e.stdout.on("data",U=>{g.write(U).forEach(A=>r({line:A,source:0}))}),e.stderr.on("data",U=>{F.write(U).forEach(A=>r({line:A,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=F}handleClose(e,n,r,a){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&r({line:g,source:1})}}t.LineProcess=I;function S(i){let e=[],n=!1;const r=function(a){if(n){e.push(a);return}(!i.send(a,g=>{if(g&&console.error(g),n=!1,e.length>0){const F=e.slice(0);e=[],F.forEach(U=>r(U))}})||h.isWindows)&&(n=!0)};return{send:r}}t.createQueuedSender=S;var o;(function(i){async function e(n,r,a){if(m.isAbsolute(n))return n;if(r===void 0&&(r=R.cwd()),m.dirname(n)!=="."||(a===void 0&&d.isString(R.env.PATH)&&(a=R.env.PATH.split(m.delimiter)),a===void 0||a.length===0))return m.join(r,n);async function g(F){return await b.exists(F)?!(await C.promises.stat(F)).isDirectory():!1}for(let F of a){let U;if(m.isAbsolute(F)?U=m.join(F,n):U=m.join(r,F,n),await g(U))return U;let N=U+".com";if(await g(N)||(N=U+".exe",await g(N)))return N}return m.join(r,n)}i.findExecutable=e})(o=t.win32||(t.win32={}))}),define(Q[72],Z([0,1,32,14,65,46]),function($,t,m,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(P,l){return P===3?C.isWindows?h():w.getWindowsShell(l):f(P,l)}t.getSystemShell=T;function R(P,l){return P===3?C.isWindows?E(l):w.getWindowsShell(l):f(P,l)}t.getSystemShellSync=R;let d=null;function f(P,l){if(C.isLinux&&P===1||C.isMacintosh&&P===2)return"/bin/bash";if(!d){let v;if(C.isWindows)v="/bin/bash";else{if(v=l.SHELL,!v)try{v=m.userInfo().shell}catch(p){}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}d=v}return d}let O=null;async function h(){return O||(O=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),O}function E(P){if(O)return O;const l=C.isWindows&&parseFloat(m.release())>=10,v=P.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${P.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?p:w.getWindowsShell(P)}}),define(Q[47],Z([0,1,33,2,4,22,11,46,36,59,28,15,17,14]),function($,t,m,C,b,w,T,R,d,f,O,h,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class l extends d.ChannelServer{constructor(y){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(S){}},onMessage:T.Event.fromNodeEventEmitter(process,"message",I=>E.VSBuffer.wrap(Buffer.from(I,"base64")))},y);process.once("disconnect",()=>this.dispose())}}t.Server=l;class v{constructor(y,I){this.modulePath=y,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new b.Delayer(S),this.child=null,this._client=null}getChannel(y){const I=this;return{call(S,o,i){return I.requestPromise(y,S,o,i)},listen(S,o){return I.requestEvent(y,S,o)}}}requestPromise(y,I,S,o=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(h.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(y),e=(0,b.createCancelablePromise)(a=>i.call(I,S,a)),n=o.onCancellationRequested(()=>e.cancel()),r=(0,C.toDisposable)(()=>e.cancel());return this.activeRequests.add(r),e.finally(()=>{n.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(y,I,S){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let o;const i=new T.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(y).listen(I,S)(i.fire,i),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env=Object.assign(Object.assign({},(0,w.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(I.env=Object.assign(Object.assign({},I.env),this.options.env)),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),P.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,y,I);const S=new T.Emitter;T.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,f.isRemoteConsoleLog)(s)){(0,f.log)(s,`IPC Library: ${this.options.serverName}`);return}S.fire(E.VSBuffer.wrap(Buffer.from(s,"base64")))});const i=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,e=s=>this.child&&this.child.connected&&i.send(s.buffer.toString("base64")),n=S.event,r={send:e,onMessage:n};this._client=new d.ChannelClient(r);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,g)=>{process.removeListener("exit",a),this.activeRequests.forEach(F=>(0,C.dispose)(F)),this.activeRequests.clear(),s!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:g})})}return this._client}getCachedChannel(y){let I=this.channels.get(y);return I||(I=this.client.getChannel(y),this.channels.set(y,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=v}),define(Q[73],Z([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(Q[74],Z([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[75],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[76],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[77],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[78],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[79],Z([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[80],Z([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[81],Z([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Q[82],Z([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Q[83],Z([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[84],Z([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Q[85],Z([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)});var ue=this&&this.__decorate||function($,t,m,C){var b=arguments.length,w=b<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,m):C,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate($,t,m,C);else for(var R=$.length-1;R>=0;R--)(T=$[R])&&(w=(b<3?T(w):b>3?T(t,m,w):T(t,m))||w);return b>3&&w&&Object.defineProperty(t,m,w),w};define(Q[86],Z([0,1,3,18,57,69,10,9,37]),function($,t,m,C,b,w,T,R,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class f{constructor(l,v,p){this._args=l,this.paths=v,this.productService=p}get appRoot(){return(0,m.dirname)(T.FileAccess.asFileUri("",$).fsPath)}get userHome(){return R.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return R.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return R.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(R.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=d.env.VSCODE_PORTABLE;return l?R.URI.file((0,m.join)(l,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,m.resolve)(l):(0,m.normalize)((0,m.join)(T.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=this.args["extensions-download-dir"];return l?(0,m.resolve)(l):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,m.resolve)(l);const v=d.env.VSCODE_EXTENSIONS;if(v)return v;const p=d.env.VSCODE_PORTABLE;return p?(0,m.join)(p,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(v=>/^[^:/?#]+?:\/\//.test(v)?R.URI.parse(v):R.URI.file((0,m.normalize)(v)))}get extensionDevelopmentKind(){var l;return(l=this.args.extensionDevelopmentKind)===null||l===void 0?void 0:l.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?R.URI.parse(l):R.URI.file((0,m.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return O(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!d.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return R.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ue([b.memoize],f.prototype,"appRoot",null),ue([b.memoize],f.prototype,"userHome",null),ue([b.memoize],f.prototype,"userDataPath",null),ue([b.memoize],f.prototype,"appSettingsHome",null),ue([b.memoize],f.prototype,"tmpDir",null),ue([b.memoize],f.prototype,"userRoamingDataHome",null),ue([b.memoize],f.prototype,"settingsResource",null),ue([b.memoize],f.prototype,"userDataSyncHome",null),ue([b.memoize],f.prototype,"userDataSyncLogResource",null),ue([b.memoize],f.prototype,"sync",null),ue([b.memoize],f.prototype,"machineSettingsResource",null),ue([b.memoize],f.prototype,"globalStorageHome",null),ue([b.memoize],f.prototype,"workspaceStorageHome",null),ue([b.memoize],f.prototype,"keybindingsResource",null),ue([b.memoize],f.prototype,"keyboardLayoutResource",null),ue([b.memoize],f.prototype,"argvResource",null),ue([b.memoize],f.prototype,"snippetsHome",null),ue([b.memoize],f.prototype,"isExtensionDevelopment",null),ue([b.memoize],f.prototype,"untitledWorkspacesHome",null),ue([b.memoize],f.prototype,"installSourcePath",null),ue([b.memoize],f.prototype,"builtinExtensionsPath",null),ue([b.memoize],f.prototype,"extensionsPath",null),ue([b.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ue([b.memoize],f.prototype,"extensionDevelopmentKind",null),ue([b.memoize],f.prototype,"extensionTestsLocationURI",null),ue([b.memoize],f.prototype,"debugExtensionHost",null),ue([b.memoize],f.prototype,"serviceMachineIdResource",null),ue([b.memoize],f.prototype,"telemetryLogResource",null),t.AbstractNativeEnvironmentService=f;function O(P,l){return E(P["inspect-extensions"],P["inspect-brk-extensions"],5870,l,P.debugId)}t.parseExtensionHostPort=O;function h(P,l){return E(P["inspect-search"],P["inspect-brk-search"],5876,l)}t.parseSearchPort=h;function E(P,l,v,p,y){const S=Number(l||P)||(p?null:v),o=S?Boolean(!!l):!1;return{port:S,break:o,debugId:y}}}),function(){"use strict";function $(t,m,C){function b(T){return t.resolve(w(T))}function w(T){const R=process.env.VSCODE_PORTABLE;if(R)return t.join(R,"user-data");const d=T["user-data-dir"];if(d)return d;let f=process.env.VSCODE_APPDATA;if(!f)switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=t.join(O,"AppData","Roaming")}break;case"darwin":f=t.join(m.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||t.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(f,C)}return{getUserDataPath:b}}if(typeof define=="function")define(Q[87],Z([0,128,32,10,18]),function(t,m,C,b,w){const T=w.dirname(b.FileAccess.asFileUri("",t)),R=t.__$__nodeRequire(w.joinPath(T,"package.json").fsPath);return $(m,C,R.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),m=require("path"),C=require("os");module.exports=$(m,C,t.name)}else throw new Error("Unknown context")}(),define(Q[88],Z([0,1,32,87,86]),function($,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class w extends b.AbstractNativeEnvironmentService{constructor(R,d){super(R,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,C.getUserDataPath)(R)},d)}}t.NativeEnvironmentService=w}),define(Q[89],Z([0,1,22]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const C=/^%([\w\d.-]+)%$/i;function b(w,T){const R=d=>{if(typeof d=="string"){const f=C.exec(d);if(!!f)return T[f[1]]||d}};return(0,m.cloneAndChange)(w,R)}t.localizeManifest=b}),define(Q[48],Z([0,1,80]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function b(h){return h=h.trim(),h==="*"||C.test(h)}t.isValidVersionStr=b;function w(h){if(!b(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=h.match(C);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}t.parseVersion=w;function T(h){if(!h)return null;let E=h.majorBase,P=h.majorMustEqual,l=h.minorBase,v=h.minorMustEqual,p=h.patchBase,y=h.patchMustEqual;return h.hasCaret&&(E===0||(v=!1),y=!1),{majorBase:E,majorMustEqual:P,minorBase:l,minorMustEqual:v,patchBase:p,patchMustEqual:y,isMinimum:h.hasGreaterEquals}}t.normalizeVersion=T;function R(h,E){let P;typeof h=="string"?P=T(w(h)):P=h;let l;if(typeof E=="string"?l=T(w(E)):l=E,!P||!l)return!1;let v=P.majorBase,p=P.minorBase,y=P.patchBase,I=l.majorBase,S=l.minorBase,o=l.patchBase,i=l.majorMustEqual,e=l.minorMustEqual,n=l.patchMustEqual;return l.isMinimum?v>I?!0:v<I?!1:p>S?!0:p<S?!1:y>=o:(v===1&&I===0&&(!i||!e||!n)&&(I=1,S=0,o=0,i=!0,e=!1,n=!1),v<I?!1:v>I?!i:p<S?!1:p>S?!e:y<o?!1:y>o?!n:!0)}t.isValidVersion=R;function d(h,E,P){return E.isBuiltin||typeof E.main=="undefined"?!0:O(h,E.engines.vscode,P)}t.isValidExtensionVersion=d;function f(h,E){return h==="*"||O(E,h)}t.isEngineValid=f;function O(h,E,P=[]){let l=T(w(E));if(!l)return P.push(m.localize(0,null,E)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return P.push(m.localize(1,null,E)),!1}else if(!l.majorMustEqual)return P.push(m.localize(2,null,E)),!1;return R(h,l)?!0:(P.push(m.localize(3,null,h,E)),!1)}t.isVersionValid=O}),define(Q[90],Z([0,1,36,47,2,10]),function($,t,m,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends b.Disposable{constructor(d,f,O,h){super();this.folders=d,this.onDidFilesChange=f,this.onLogMessage=O,this.verboseLogging=h,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new C.Client(w.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(d.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.setFolders(this.folders)}setVerboseLogging(d){this.verboseLogging=d,!this.isDisposed&&this.service&&this.service.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${d}`})}setFolders(d){this.folders=d,this.service&&this.service.setRoots(d)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Q[91],Z([0,1,36,47,2,10]),function($,t,m,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends b.Disposable{constructor(d,f,O,h,E={}){super();this.folders=d,this.onDidFilesChange=f,this.onLogMessage=O,this.verboseLogging=h,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new C.Client(w.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(d.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.service.setRoots(this.folders)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${d}`})}setVerboseLogging(d){this.verboseLogging=d,this.service&&this.service.setVerboseLogging(d)}setFolders(d){this.folders=d,this.service&&this.service.setRoots(d)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Q[92],Z([0,1,33,45,61,10]),function($,t,m,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class T{constructor(d,f,O,h,E){this.watchedFolder=d,this.eventCallback=O,this.logCallback=h,this.verboseLogging=E,this.restartCounter=0,Array.isArray(f)?this.ignored=f.map(P=>b.parse(P)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${d}`),this.startWatcher()}startWatcher(){const d=[this.watchedFolder];this.verboseLogging&&d.push("-verbose"),this.handle=m.spawn(w.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,d);const f=new C.LineDecoder;this.handle.stdout.on("data",O=>{const h=[];f.write(O).forEach(E=>{const P=E.split("|");if(P.length===2){const l=Number(P[0]),v=P[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(p=>p(v))){this.verboseLogging&&this.log(v);return}h.push({type:T.changeTypeMap[l],path:v})}else this.log(P[1])}}),h.length>0&&this.eventCallback(h)}),this.handle.on("error",O=>this.onError(O)),this.handle.stderr.on("data",O=>this.onError(O)),this.handle.on("exit",(O,h)=>this.onExit(O,h))}onError(d){this.error("process error: "+d.toString())}onExit(d,f){this.handle&&(this.error(`terminated unexpectedly (code: ${d}, signal: ${f})`),this.restartCounter<=T.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(d){this.logCallback({type:"error",message:`[File Watcher (C#)] ${d}`})}log(d){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${d}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=T,T.MAX_RESTARTS=5,T.changeTypeMap=[0,1,2]}),define(Q[93],Z([0,1,92,3,21]),function($,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class w{constructor(R,d,f,O){this.onDidFilesChange=d,this.onLogMessage=f,this.verboseLogging=O,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(C.posix.sep)&&(this.folder.path=(0,b.rtrim)(this.folder.path,C.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=w}),define(Q[49],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class m{constructor(w,T=[],R=!1){this.ctor=w,this.staticArguments=T,this.supportsDelayedInstantiation=R}}t.SyncDescriptor=m;const C=(b,...w)=>new m(b,w);t.createSyncDescriptor=C}),define(Q[94],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class m{constructor(w){this.incoming=new Map,this.outgoing=new Map,this.data=w}}t.Node=m;class C{constructor(w){this._hashFn=w,this._nodes=new Map}roots(){const w=[];for(let T of this._nodes.values())T.outgoing.size===0&&w.push(T);return w}insertEdge(w,T){const R=this.lookupOrInsertNode(w),d=this.lookupOrInsertNode(T);R.outgoing.set(this._hashFn(T),d),d.incoming.set(this._hashFn(w),R)}removeNode(w){const T=this._hashFn(w);this._nodes.delete(T);for(let R of this._nodes.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(w){const T=this._hashFn(w);let R=this._nodes.get(T);return R||(R=new m(w),this._nodes.set(T,R)),R}lookup(w){return this._nodes.get(this._hashFn(w))}isEmpty(){return this._nodes.size===0}toString(){let w=[];for(let[T,R]of this._nodes)w.push(`${T}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return w.join(`
`)}}t.Graph=C}),define(Q[95],Z([0,1,7]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,m.createDecorator)("downloadService")}),define(Q[19],Z([0,1,7]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,m.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,m.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[24],Z([0,1,75,7,10]),function($,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function w(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}t.isIExtensionIdentifier=w;var T;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=5]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(T=t.SortBy||(t.SortBy={}));var R;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(R=t.SortOrder||(t.SortOrder={}));var d;(function(h){h.Uninstall="uninstall"})(d=t.StatisticType||(t.StatisticType={}));var f;(function(h){h[h.None=0]="None",h[h.Install=1]="Install",h[h.Update=2]="Update"})(f=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class O extends Error{constructor(E,P){super(E);this.code=P}}t.ExtensionManagementError=O,t.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=b.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,m.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,m.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(Q[38],Z([0,1,21,7]),function($,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=b,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(w=t.ExtensionType||(t.ExtensionType={}));class T{constructor(O){this.value=O,this._lower=O.toLowerCase()}static equals(O,h){if(typeof O=="undefined"||O===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof O=="string"||typeof h=="string"){let E=typeof O=="string"?O:O.value,P=typeof h=="string"?h:h.value;return m.equalsIgnoreCase(E,P)}return O._lower===h._lower}static toKey(O){return typeof O=="string"?O.toLowerCase():O._lower}}t.ExtensionIdentifier=T;function R(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}t.isLanguagePackExtension=R;function d(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=d,t.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[25],Z([0,1,21,38]),function($,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function b(P,l){return P.uuid&&l.uuid?P.uuid===l.uuid:P.id===l.id?!0:(0,m.compareIgnoreCase)(P.id,l.id)===0}t.areSameExtensions=b;class w{constructor(l,v){this.version=v,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof w?b(this,l)&&this.version===l.version:!1}}t.ExtensionIdentifierWithVersion=w;function T(P,l){return`${P}.${l}`}t.getExtensionId=T;function R(P){return P.toLocaleLowerCase()}t.adoptToGalleryExtensionId=R;function d(P,l){return R(T(P,l))}t.getGalleryExtensionId=d;function f(P,l){const v=[],p=y=>{for(const I of v)if(I.some(S=>b(l(S),l(y))))return I;return null};for(const y of P){const I=p(y);I?I.push(y):v.push([y])}return v}t.groupByExtension=f;function O(P){return{id:P.identifier.id,name:P.manifest.name,galleryId:null,publisherId:P.publisherId,publisherName:P.manifest.publisher,publisherDisplayName:P.publisherDisplayName,dependencies:P.manifest.extensionDependencies&&P.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=O;function h(P){return Object.assign({id:P.identifier.id,name:P.name,galleryId:P.identifier.uuid,publisherId:P.publisherId,publisherName:P.publisher,publisherDisplayName:P.publisherDisplayName,dependencies:!!(P.properties.dependencies&&P.properties.dependencies.length>0)},P.telemetryData)}t.getGalleryExtensionTelemetryData=h,t.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function E(P){const l=new Set;for(const v of P)v.malicious&&l.add(v.id.id);return l}t.getMaliciousExtensionsSet=E}),define(Q[96],Z([0,1,2,3,38,12]),function($,t,m,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends m.Disposable{constructor(d,f){super();this.environmentService=d,this.extensionsManifestCache=(0,C.join)(this.environmentService.userDataPath,b.MANIFEST_CACHE_FOLDER,b.USER_MANIFEST_CACHE_FILE),this._register(f.onDidInstallExtension(O=>this.onDidInstallExtension(O))),this._register(f.onDidUninstallExtension(O=>this.onDidUnInstallExtension(O)))}onDidInstallExtension(d){d.error||this.invalidate()}onDidUnInstallExtension(d){d.error||this.invalidate()}invalidate(){w.rimraf(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(Q[97],Z([0,1,33,30,14,129,29,72]),function($,t,m,C,b,w,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function d(h,E,P){return E["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(P)&&!E["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(P)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=O(h)),f)}t.resolveShellEnv=d;let f;async function O(h){const E=new Promise(async(P,l)=>{const v=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",v);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const y=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),I=new RegExp(y+"(.*)"+y),S=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"}),o=`'${process.execPath}' -p '"${y}" + JSON.stringify(process.env) + "${y}"'`;h.trace("getUnixShellEnvironment#env",S),h.trace("getUnixShellEnvironment#spawn",o);const i=await(0,R.getSystemShell)(b.platform,S);h.trace("getUnixShellEnvironment#shell",i);const e=(0,m.spawn)(i,["-ilc",o],{detached:!0,stdio:["ignore","pipe",process.stderr],env:S}),n=[];e.on("error",()=>P({})),e.stdout.on("data",r=>n.push(r)),e.on("close",r=>{if(r!==0)return l(new Error("Failed to get environment"));const a=Buffer.concat(n).toString("utf8");h.trace("getUnixShellEnvironment#raw",a);const s=I.exec(a),g=s?s[1]:"{}";try{const F=JSON.parse(g);v?F.ELECTRON_RUN_AS_NODE=v:delete F.ELECTRON_RUN_AS_NODE,p?F.ELECTRON_NO_ATTACH_CONSOLE=p:delete F.ELECTRON_NO_ATTACH_CONSOLE,delete F.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",F),P(F)}catch(F){h.error("getUnixShellEnvironment#error",F),l(F)}})});try{return await E}catch(P){return h.error("getUnixShellEnvironment#error",(0,T.toErrorMessage)(P)),{}}}}),define(Q[50],Z([0,1,82,17,20,15]),function($,t,m,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(O,h,E,P,l,v){let p;try{await R(O,h,E,P,l,v)}catch(y){p=y}finally{p&&l.errorTransformer&&(p=l.errorTransformer(p)),typeof p!="undefined"&&E.error(p),E.end()}}t.readFileIntoStream=T;async function R(O,h,E,P,l,v){d(v);const p=await O.open(h,{create:!1});try{d(v);let y=0,I=0,S=l&&typeof l.length=="number"?l.length:void 0,o=C.VSBuffer.alloc(Math.min(l.bufferSize,typeof S=="number"?S:l.bufferSize)),i=l&&typeof l.position=="number"?l.position:0,e=0;do I=await O.read(p,i,o.buffer,e,o.byteLength-e),i+=I,e+=I,y+=I,typeof S=="number"&&(S-=I),e===o.byteLength&&(await E.write(P(o)),o=C.VSBuffer.alloc(Math.min(l.bufferSize,typeof S=="number"?S:l.bufferSize)),e=0);while(I>0&&(typeof S!="number"||S>0)&&d(v)&&f(y,l));if(e>0){let n=e;typeof S=="number"&&(n=Math.min(e,S)),E.write(P(o.slice(0,n)))}}catch(y){throw(0,b.ensureFileSystemProviderError)(y)}finally{await O.close(p)}}function d(O){if(O.isCancellationRequested)throw(0,w.canceled)();return!0}function f(O,h){if(h==null?void 0:h.limits){if(typeof h.limits.memory=="number"&&O>h.limits.memory)throw(0,b.createFileSystemProviderError)((0,m.localize)(0,null),b.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof h.limits.size=="number"&&O>h.limits.size)throw(0,b.createFileSystemProviderError)((0,m.localize)(1,null),b.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[51],Z([0,1,9,20,14]),function($,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function w(d){return d.map(f=>({type:f.type,resource:m.URI.file(f.path)}))}t.toFileChanges=w;function T(d){const f=new R;for(const O of d)f.processEvent(O);return f.normalize()}t.normalizeFileChanges=T;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(f){const O=this.mapPathToChange.get(f.path);if(O){const h=O.type,E=f.type;h===1&&E===2?(this.mapPathToChange.delete(f.path),this.normalized.splice(this.normalized.indexOf(O),1)):h===2&&E===1?O.type=0:h===1&&E===0||(O.type=E)}else this.normalized.push(f),this.mapPathToChange.set(f.path,f)}normalize(){const f=[],O=[];return this.normalized.filter(h=>h.type!==2?(f.push(h),!1):!0).sort((h,E)=>h.path.length-E.path.length).filter(h=>O.some(E=>(0,C.isParent)(h.path,E,!b.isLinux))?!1:(O.push(h.path),!0)).concat(f)}}}),define(Q[98],Z([0,1,51,2,12,63,66,4,3]),function($,t,m,C,b,w,T,R,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class f extends C.Disposable{constructor(h,E,P,l){super();this.path=h,this.onDidFilesChange=E,this.onLogMessage=P,this.verboseLogging=l,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(h){this.verboseLogging=h}async startWatching(){try{const{stat:h,symbolicLink:E}=await b.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let P=this.path;if(E)try{P=await(0,w.realpath)(P)}catch(l){if(this.onError(l),E.dangling)return}h.isDirectory()?this._register((0,T.watchFolder)(P,(l,v)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,d.join)(this.path,(0,d.basename)(v))})},l=>this.onError(l))):this._register((0,T.watchFile)(P,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(h){h.code!=="ENOENT"&&this.onError(h)}}onFileChange(h){this.fileChangesBuffer.push(h),this.verboseLogging&&this.onVerbose(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const P=(0,m.normalizeFileChanges)(E);this.verboseLogging&&P.forEach(l=>{this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`)}),P.length>0&&this.onDidFilesChange(P)})}onError(h){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${h}`})}onVerbose(h){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=f}),define(Q[52],Z([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class m{constructor(...b){this._entries=new Map;for(let[w,T]of b)this.set(w,T)}set(b,w){const T=this._entries.get(b);return this._entries.set(b,w),T}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=m}),define(Q[99],Z([0,1,15,94,49,7,52,4]),function($,t,m,C,b,w,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const d=!1;class f extends Error{constructor(l){super("cyclic dependency between services");this.message=l.toString()}}class O{constructor(l=new T.ServiceCollection,v=!1,p){this._activeInstantiations=new Set,this._services=l,this._strict=v,this._parent=p,this._services.set(w.IInstantiationService,this)}createChild(l){return new O(l,this._strict,this)}invokeFunction(l,...v){let p=E.traceInvocation(l),y=!1;try{return l({get:(S,o)=>{if(y)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(S,p);if(!i&&o!==w.optional)throw new Error(`[invokeFunction] unknown service '${S}'`);return i}},...v)}finally{y=!0,p.stop()}}createInstance(l,...v){let p,y;return l instanceof b.SyncDescriptor?(p=E.traceCreation(l.ctor),y=this._createInstance(l.ctor,l.staticArguments.concat(v),p)):(p=E.traceCreation(l),y=this._createInstance(l,v,p)),p.stop(),y}_createInstance(l,v=[],p){let y=w._util.getServiceDependencies(l).sort((o,i)=>o.index-i.index),I=[];for(const o of y){let i=this._getOrCreateServiceInstance(o.id,p);if(!i&&this._strict&&!o.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${o.id}.`);I.push(i)}let S=y.length>0?y[0].index:v.length;if(v.length!==S){console.warn(`[createInstance] First service dependency of ${l.name} at position ${S+1} conflicts with ${v.length} static arguments`);let o=S-v.length;o>0?v=v.concat(new Array(o)):v=v.slice(0,S)}return new l(...[...v,...I])}_setServiceInstance(l,v){if(this._services.get(l)instanceof b.SyncDescriptor)this._services.set(l,v);else if(this._parent)this._parent._setServiceInstance(l,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let v=this._services.get(l);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):v}_getOrCreateServiceInstance(l,v){let p=this._getServiceInstanceOrDescriptor(l);return p instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,p,v.branch(l,!0)):(v.branch(l,!1),p)}_safeCreateAndCacheServiceInstance(l,v,p){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,v,p)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,v,p){const y=new C.Graph(o=>o.id.toString());let I=0;const S=[{id:l,desc:v,_trace:p}];for(;S.length;){const o=S.pop();if(y.lookupOrInsertNode(o),I++>1e3)throw new f(y);for(let i of w._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(i.id);if(!e&&!i.optional&&console.warn(`[createInstance] ${l} depends on ${i.id} which is NOT registered.`),e instanceof b.SyncDescriptor){const n={id:i.id,desc:e,_trace:o._trace.branch(i.id,!0)};y.insertEdge(o,n),S.push(n)}}}for(;;){const o=y.roots();if(o.length===0){if(!y.isEmpty())throw new f(y);break}for(const{data:i}of o){if(this._getServiceInstanceOrDescriptor(i.id)instanceof b.SyncDescriptor){const n=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setServiceInstance(i.id,n)}y.removeNode(i)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,v,p=[],y,I){if(this._services.get(l)instanceof b.SyncDescriptor)return this._createServiceInstance(v,p,y,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,v,p,y,I);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(l,v=[],p,y){if(p){const I=new R.IdleValue(()=>this._createInstance(l,v,y));return new Proxy(Object.create(null),{get(S,o){if(o in S)return S[o];let i=I.value,e=i[o];return typeof e!="function"||(e=e.bind(i),S[o]=e),e},set(S,o,i){return I.value[o]=i,!0}})}else return this._createInstance(l,v,y)}}t.InstantiationService=O;var h;(function(P){P[P.Creation=0]="Creation",P[P.Invocation=1]="Invocation",P[P.Branch=2]="Branch"})(h||(h={}));class E{constructor(l,v){this.type=l,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return d?new E(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(l){return d?new E(0,l.name):E._None}branch(l,v){let p=new E(2,l.toString());return this._dep.push([l,v,p]),p}stop(){let l=Date.now()-this._start;E._totals+=l;let v=!1;function p(I,S){let o=[],i=new Array(I+1).join("	");for(const[e,n,r]of S._dep)if(n&&r){v=!0,o.push(`${i}CREATES -> ${e}`);let a=p(I+1,r);a&&o.push(a)}else o.push(`${i}uses -> ${e}`);return o.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(l>2||v)&&console.log(y.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(Q[39],Z([0,1,7]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,m.createDecorator)("localizationsService");function C(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const w of b.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}t.isValidLocalization=C});var ce=this&&this.__param||function($,t){return function(m,C){t(m,C,$)}};define(Q[100],Z([0,1,76,15,9,40,24,25,38,62,28,10,39]),function($,t,m,C,b,w,T,R,d,f,O,h,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const P=S=>(0,m.localize)(0,null,S),l=(0,m.localize)(1,null,"ms-dotnettools.csharp");function v(S,o){return o?`${S.publisher}.${S.name}@${S.version}`:`${S.publisher}.${S.name}`}const p=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function y(S){const o=p.exec(S);return o&&o[1]?[(0,R.adoptToGalleryExtensionId)(o[1]),o[2]]:[(0,R.adoptToGalleryExtensionId)(S),void 0]}t.getIdAndVersion=y;let I=class{constructor(o,i,e){this.extensionManagementService=o,this.extensionGalleryService=i,this.localizationsService=e}get location(){}async listExtensions(o,i,e=console){let n=await this.extensionManagementService.getInstalled(1);const r=d.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(i&&i!==""){if(r.indexOf(i.toLowerCase())<0){e.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}n=n.filter(s=>s.manifest.categories?s.manifest.categories.map(F=>F.toLowerCase()).indexOf(i.toLowerCase())>-1:!1)}else if(i===""){e.log("Possible Categories: "),r.forEach(s=>{e.log(s)});return}this.location&&e.log((0,m.localize)(2,null,this.location)),n=n.sort((s,g)=>s.identifier.id.localeCompare(g.identifier.id));let a;for(let s of n)a!==s.identifier.id&&(a=s.identifier.id,e.log(v(s.manifest,o)))}async installExtensions(o,i,e,n,r=console){const a=[],s=[];o.length&&r.log(this.location?(0,m.localize)(3,null,this.location):(0,m.localize)(4,null));const g=await this.extensionManagementService.getInstalled(1),F=(A,j)=>{const x=g.find(X=>(0,R.areSameExtensions)(X.identifier,{id:A}));if(x){if(!j&&!n)return r.log((0,m.localize)(5,null,A,x.manifest.version,A)),!1;if(j&&x.manifest.version===j)return r.log((0,m.localize)(6,null,`${A}@${j}`)),!1}return!0},U=[],N=[];for(const A of o)if(A instanceof b.URI)U.push(A);else{const[j,x]=y(A);F(j,x)&&N.push({id:j,version:x,installOptions:{isBuiltin:!1,isMachineScoped:e}})}for(const A of i){const[j,x]=y(A);F(j,x)&&N.push({id:j,version:x,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(U.length&&await Promise.all(U.map(async A=>{try{const j=await this.installVSIX(A,n,r);j&&s.push(j)}catch(j){r.error(j.message||j.stack||j),a.push(A.toString())}})),N.length){const A=await this.getGalleryExtensions(N);await Promise.all(N.map(async j=>{const x=A.get(j.id.toLowerCase());if(x)try{const X=await this.installFromGallery(j,x,g,n,r);X&&s.push(X)}catch(X){r.error(X.message||X.stack||X),a.push(j.id)}else r.error(`${P(j.version?`${j.id}@${j.version}`:j.id)}
${l}`),a.push(j.id)}))}if(s.some(A=>(0,d.isLanguagePackExtension)(A))&&await this.updateLocalizationsCache(),a.length)throw new Error((0,m.localize)(7,null,a.join(", ")))}async installVSIX(o,i,e){const n=await this.extensionManagementService.getManifest(o);if(!n)throw new Error("Invalid vsix");if(await this.validateVSIX(n,i,e))try{return await this.extensionManagementService.install(o),e.log((0,m.localize)(8,null,(0,f.getBaseLabel)(o))),n}catch(a){if((0,C.isPromiseCanceledError)(a))return e.log((0,m.localize)(9,null,(0,f.getBaseLabel)(o))),null;throw a}return null}async getGalleryExtensions(o){const i=o.filter(({version:r})=>r===void 0).map(({id:r})=>r),e=o.filter(({version:r})=>r!==void 0),n=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(i,O.CancellationToken.None)).forEach(a=>n.set(a.identifier.id.toLowerCase(),a))})(),Promise.all(e.map(async({id:r,version:a})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:r},a);s&&n.set(s.identifier.id.toLowerCase(),s)}))]),n}async installFromGallery({id:o,version:i,installOptions:e},n,r,a,s){const g=await this.extensionGalleryService.getManifest(n,O.CancellationToken.None);if(g&&!this.validateExtensionKind(g,s))return null;const F=r.find(U=>(0,R.areSameExtensions)(U.identifier,n.identifier));if(F){if(n.version===F.manifest.version)return s.log((0,m.localize)(10,null,i?`${o}@${i}`:o)),null;s.log((0,m.localize)(11,null,o,n.version))}try{return e.isBuiltin?s.log((0,m.localize)(12,null,o,n.version)):s.log((0,m.localize)(13,null,o,n.version)),await this.extensionManagementService.installFromGallery(n,e),s.log((0,m.localize)(14,null,o,n.version)),g}catch(U){if((0,C.isPromiseCanceledError)(U))return s.log((0,m.localize)(15,null,o)),null;throw U}}validateExtensionKind(o,i){return!0}async validateVSIX(o,i,e){const n={id:(0,R.getGalleryExtensionId)(o.publisher,o.name)},a=(await this.extensionManagementService.getInstalled(1)).find(s=>(0,R.areSameExtensions)(n,s.identifier)&&(0,w.gt)(s.manifest.version,o.version));return a&&!i?(e.log((0,m.localize)(16,null,a.identifier.id,a.manifest.version,o.version)),!1):this.validateExtensionKind(o,e)}async uninstallExtensions(o,i,e=console){const n=async a=>{if(a instanceof b.URI){const s=await this.extensionManagementService.getManifest(a);return v(s)}return a},r=[];for(const a of o){const s=await n(a),F=(await this.extensionManagementService.getInstalled()).filter(U=>(0,R.areSameExtensions)(U.identifier,{id:s}));if(!F.length)throw new Error(`${this.notInstalled(s)}
${l}`);if(F.some(U=>U.type===0)){e.log((0,m.localize)(17,null,s));return}if(!i&&F.some(U=>U.isBuiltin)){e.log((0,m.localize)(18,null,s));return}e.log((0,m.localize)(19,null,s));for(const U of F)await this.extensionManagementService.uninstall(U),r.push(U);this.location?e.log((0,m.localize)(20,null,s,this.location)):e.log((0,m.localize)(21,null,s))}r.some(a=>(0,d.isLanguagePackExtension)(a.manifest))&&await this.updateLocalizationsCache()}async locateExtension(o,i=console){const e=await this.extensionManagementService.getInstalled();o.forEach(n=>{e.forEach(r=>{if(r.identifier.id===n&&r.location.scheme===h.Schemas.file){i.log(r.location.fsPath);return}})})}updateLocalizationsCache(){return this.localizationsService.update()}notInstalled(o){return this.location?(0,m.localize)(22,null,o,this.location):(0,m.localize)(23,null,o)}};I=ue([ce(0,T.IExtensionManagementService),ce(1,T.IExtensionGalleryService),ce(2,E.ILocalizationsService)],I),t.ExtensionManagementCLIService=I}),define(Q[13],Z([0,1,7,2,14,11,29]),function($,t,m,C,b,w,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,m.createDecorator)("logService"),t.ILoggerService=(0,m.createDecorator)("loggerService");function R(){return new Date().toISOString()}var d;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(d=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=d.Info;class f extends C.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new w.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=f;class O extends f{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...e){this.checkLogLevel(d.Trace)&&this.log(d.Trace,this.format([i,...e]))}debug(i,...e){this.checkLogLevel(d.Debug)&&this.log(d.Debug,this.format([i,...e]))}info(i,...e){this.checkLogLevel(d.Info)&&this.log(d.Info,this.format([i,...e]))}warn(i,...e){this.checkLogLevel(d.Warning)&&this.log(d.Warning,this.format([i,...e]))}error(i,...e){if(this.checkLogLevel(d.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(d.Error,this.format(n))}else this.log(d.Error,this.format([i,...e]))}critical(i,...e){this.checkLogLevel(d.Critical)&&this.log(d.Critical,this.format([i,...e]))}flush(){}format(i){let e="";for(let n=0;n<i.length;n++){let r=i[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}e+=(n>0?" ":"")+r}return e}}t.AbstractMessageLogger=O;class h extends f{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!b.isWindows}trace(i,...e){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...e):console.log(`[main ${R()}]`,i,...e))}debug(i,...e){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...e):console.log(`[main ${R()}]`,i,...e))}info(i,...e){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...e):console.log(`[main ${R()}]`,i,...e))}warn(i,...e){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...e):console.warn(`[main ${R()}]`,i,...e))}error(i,...e){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...e):console.error(`[main ${R()}]`,i,...e))}critical(i,...e){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...e):console.error(`[main ${R()}]`,i,...e))}dispose(){}flush(){}}t.ConsoleMainLogger=h;class E extends f{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...e){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",i,...e)}debug(i,...e){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...e)}info(i,...e){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",i,...e)}warn(i,...e){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",i,...e)}error(i,...e){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",i,...e)}critical(i,...e){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...e)}dispose(){}flush(){}}t.ConsoleLogger=E;class P extends f{constructor(i,e=t.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(e)}trace(i,...e){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(i),...e])}debug(i,...e){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(i),...e])}info(i,...e){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(i),...e])}warn(i,...e){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(i),...e])}error(i,...e){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(i),...e])}critical(i,...e){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(i),...e])}extractMessage(i){return typeof i=="string"?i:(0,T.toErrorMessage)(i,this.getLevel()<=d.Trace)}dispose(){}flush(){}}t.AdapterLogger=P;class l extends f{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const e of this.logServices)e.setLevel(i);super.setLevel(i)}trace(i,...e){for(const n of this.logServices)n.trace(i,...e)}debug(i,...e){for(const n of this.logServices)n.debug(i,...e)}info(i,...e){for(const n of this.logServices)n.info(i,...e)}warn(i,...e){for(const n of this.logServices)n.warn(i,...e)}error(i,...e){for(const n of this.logServices)n.error(i,...e)}critical(i,...e){for(const n of this.logServices)n.critical(i,...e)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}t.MultiplexLogService=l;class v extends C.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...e){this.logger.trace(i,...e)}debug(i,...e){this.logger.debug(i,...e)}info(i,...e){this.logger.info(i,...e)}warn(i,...e){this.logger.warn(i,...e)}error(i,...e){this.logger.error(i,...e)}critical(i,...e){this.logger.critical(i,...e)}flush(){this.logger.flush()}}t.LogService=v;class p{constructor(){this.onDidChangeLogLevel=new w.Emitter().event}setLevel(i){}getLevel(){return d.Info}trace(i,...e){}debug(i,...e){}info(i,...e){}warn(i,...e){}error(i,...e){}critical(i,...e){}dispose(){}flush(){}}t.NullLogService=p;function y(o){if(o.verbose)return d.Trace;if(typeof o.logLevel=="string"){const i=I(o.logLevel.toLowerCase());if(i!==void 0)return i}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=y;function I(o){switch(o){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}t.parseLogLevel=I;function S(o){switch(o){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}t.LogLevelToString=S}),define(Q[101],Z([0,1,16,2,20,24,19,9,18,25,13,30,40,14,4]),function($,t,m,C,b,w,T,R,d,f,O,h,E,P,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends C.Disposable{constructor(I,S,o,i){super();this.fileService=S,this.extensionGalleryService=o,this.logService=i,this.extensionsDownloadDir=R.URI.file(I.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(I,S){await this.cleanUpPromise;const o=this.getName(I),i=(0,d.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(i)){const e=(0,d.joinPath)(this.extensionsDownloadDir,`.${o}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(I,e,S),await this.rename(e,i,Date.now()+2*60*1e3)}return i}async delete(I){}async rename(I,S,o){try{await m.promises.rename(I.fsPath,S.fsPath)}catch(i){if(P.isWindows&&i&&i.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${I} to ${S} with 'EPERM' error. Trying again...`),this.rename(I,S,o);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const I=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(I.children){const S=[],o=[];for(const n of I.children){const r=this.parse(n.name);r&&o.push([r,n])}const i=(0,f.groupByExtension)(o,([n])=>n),e=[];for(const n of i)n.sort((r,a)=>E.rcompare(r[0].version,a[0].version)),S.push(...n.slice(1).map(r=>r[1].resource)),e.push(n[0][1]);e.sort((n,r)=>n.mtime-r.mtime),S.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(n=>n.resource)),await l.Promises.settled(S.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(I){this.logService.error(I)}}getName(I){return this.cache?new f.ExtensionIdentifierWithVersion(I.identifier,I.version).key().toLowerCase():(0,h.generateUuid)()}parse(I){const S=v.exec(I);return S&&S[1]&&S[2]?new f.ExtensionIdentifierWithVersion({id:S[1]},S[2]):null}};p=ue([ce(0,T.INativeEnvironmentService),ce(1,b.IFileService),ce(2,w.IExtensionGalleryService),ce(3,O.ILogService)],p),t.ExtensionsDownloader=p}),define(Q[102],Z([0,1,2,13,33,29,3,4,11,10,12,19]),function($,t,m,C,b,w,T,R,d,f,O,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let E=class extends m.Disposable{constructor(l,v){super();this.environmentService=l,this.logService=v,this.processesLimiter=new R.Limiter(5)}async postUninstall(l){const v=this.parseScript(l,"uninstall");return v&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(v.script,"uninstall",v.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),p=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${p}`)))),(0,O.rimraf)(this.getExtensionStoragePath(l)).then(void 0,p=>this.logService.error("Error while removing extension storage path",p))}parseScript(l,v){const p=`vscode:${v}`;if(l.location.scheme===f.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[p]=="string"){const y=l.manifest.scripts[p].split(" ");return y.length<2||y[0]!=="node"||!y[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${p} should be a node script`),null):{script:(0,T.join)(l.location.fsPath,y[1]),args:y.slice(2)||[]}}return null}runLifecycleHook(l,v,p,y,I){return new Promise((S,o)=>{const i=this.start(l,v,p,I);let e;const n=r=>{e&&(clearTimeout(e),e=null),r?o(r):S(void 0)};i.on("error",r=>{n((0,w.toErrorMessage)(r)||"Unknown")}),i.on("exit",(r,a)=>{n(r?`post-${v} process exited with code ${r}`:void 0)}),y&&(e=setTimeout(()=>{e=null,i.kill(),o("timed out")},5e3))})}start(l,v,p,y){const I={silent:!0,execArgv:void 0},S=(0,b.fork)(l,[`--type=extension-post-${v}`,...p],I);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const o=d.Event.fromNodeEventEmitter(S.stdout,"data"),i=d.Event.fromNodeEventEmitter(S.stderr,"data");o(r=>this.logService.info(y.identifier.id,y.manifest.version,`post-${v}`,r)),i(r=>this.logService.error(y.identifier.id,y.manifest.version,`post-${v}`,r));const e=d.Event.any(d.Event.map(o,r=>({data:`%c${r}`,format:[""]})),d.Event.map(i,r=>({data:`%c${r}`,format:["color: red"]})));return d.Event.debounce(e,(r,a)=>r?{data:r.data+a.data,format:[...r.format,...a.format]}:{data:a.data,format:a.format},100)(r=>{console.group(y.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),S}getExtensionStoragePath(l){return(0,T.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};E=ue([ce(0,h.IEnvironmentService),ce(1,C.ILogService)],E),t.ExtensionsLifecycle=E}),define(Q[103],Z([0,1,2,19,11,20,9,25,18,13]),function($,t,m,C,b,w,T,R,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let O=class extends m.Disposable{constructor(E,P,l,v){super();this.extensionsManagementService=E,this.logService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new b.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(S=>S.identifier),this.startTimestamp=Date.now()}),this._register(E.onInstallExtension(I=>this.onInstallExtension(I))),this._register(E.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(E.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const p=T.URI.file(l.extensionsPath),y=new d.ExtUri(I=>!P.hasCapability(I,1024));this._register(P.watch(p)),this._register(b.Event.filter(P.onDidFilesChange,I=>I.changes.some(S=>this.doesChangeAffects(S,p,y)))(()=>this.onDidChange()))}doesChangeAffects(E,P,l){return l.isEqual(l.dirname(E.resource),P)?l.isEqual(E.resource,l.joinPath(P,".obsolete"))?!0:!(E.type!==1&&E.type!==2||l.basename(E.resource).startsWith(".")):!1}onInstallExtension(E){this.addInstallingExtension(E.identifier)}onDidInstallExtension(E){this.removeInstallingExtension(E.identifier),E.error||this.addInstalledExtension(E.identifier)}onDidUninstallExtension(E){E.error||this.removeInstalledExtension(E.identifier)}addInstallingExtension(E){this.removeInstallingExtension(E),this.installingExtensions.push(E)}removeInstallingExtension(E){this.installingExtensions=this.installingExtensions.filter(P=>!(0,R.areSameExtensions)(P,E))}addInstalledExtension(E){this.installedExtensions&&(this.removeInstalledExtension(E),this.installedExtensions.push(E))}removeInstalledExtension(E){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(P=>!(0,R.areSameExtensions)(P,E)))}async onDidChange(){if(this.installedExtensions){const E=await this.extensionsManagementService.getInstalled(1),P=E.filter(v=>[...this.installingExtensions,...this.installedExtensions].some(p=>(0,R.areSameExtensions)(p,v.identifier))?!1:v.installedTimestamp&&v.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",v.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",v.identifier.id),!1)),l=this.installedExtensions.filter(v=>E.every(p=>!(0,R.areSameExtensions)(p.identifier,v))?(this.logService.info("Detected extension removed from another source",v.id),!0):!1);this.installedExtensions=E.map(v=>v.identifier),(P.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:P,removed:l})}}};O=ue([ce(1,w.IFileService),ce(2,C.INativeEnvironmentService),ce(3,f.ILogService)],O),t.ExtensionsWatcher=O}),define(Q[104],Z([0,1,81,130,2,20,11,18,44,23,13,17,34,4,28,10,50,131]),function($,t,m,C,b,w,T,R,d,f,O,h,E,P,l,v,p,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let I=class extends b.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(o,i){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:i});const e=new b.DisposableStore;return e.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new w.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),e.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:o}))),typeof i.onDidErrorOccur=="function"&&e.add(i.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:i}),this.provider.delete(o),(0,b.dispose)(e)})}async activateProvider(o){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){i.push(e)}}),!this.provider.has(o)&&await P.Promises.settled(i)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,i){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&i)}listCapabilities(){return y.Iterable.map(this.provider,([o,i])=>({scheme:o,capabilities:i.capabilities}))}async withProvider(o){if(!(0,R.isAbsolutePath)(o))throw new w.FileOperationError((0,m.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const i=this.provider.get(o.scheme);if(!i){const e=new Error;throw e.name="ENOPRO",e.message=(0,m.localize)(1,null,o.toString()),e}return i}async withReadProvider(o){const i=await this.withProvider(o);if((0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)||(0,w.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const i=await this.withProvider(o);if((0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,i){try{return await this.doResolveFile(o,i)}catch(e){throw(0,w.toFileSystemProviderErrorCode)(e)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,m.localize)(2,null,this.resourceForError(o)),1):(0,w.ensureFileSystemProviderError)(e)}}async doResolveFile(o,i){const e=await this.withProvider(o),n=this.isPathCaseSensitive(e),r=i==null?void 0:i.resolveTo,a=i==null?void 0:i.resolveSingleChildDescendants,s=i==null?void 0:i.resolveMetadata,g=await e.stat(o);let F;return this.toFileStat(e,o,g,void 0,!!s,(U,N)=>(F||(F=d.TernarySearchTree.forUris(()=>!n),F.set(o,!0),(0,f.isNonEmptyArray)(r)&&r.forEach(A=>F.set(A,!0))),Boolean(F.findSuperstr(U.resource)||F.get(U.resource))?!0:U.isDirectory&&a?N===1:!1))}async toFileStat(o,i,e,n,r,a){const{providerExtUri:s}=this.getExtUri(o),g={resource:i,name:s.basename(i),isFile:(e.type&w.FileType.File)!=0,isDirectory:(e.type&w.FileType.Directory)!=0,isSymbolicLink:(e.type&w.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,etag:(0,w.etag)({mtime:e.mtime,size:e.size})};if(g.isDirectory&&a(g,n)){try{const F=await o.readdir(i),U=await P.Promises.settled(F.map(async([N,A])=>{try{const j=s.joinPath(i,N),x=r?await o.stat(j):{type:A};return await this.toFileStat(o,j,x,F.length,r,a)}catch(j){return this.logService.trace(j),null}}));g.children=(0,f.coalesce)(U)}catch(F){this.logService.trace(F),g.children=[]}return g}return g}async resolveAll(o){return P.Promises.settled(o.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const i=await this.withProvider(o);try{return!!await i.stat(o)}catch(e){return!1}}async canCreateFile(o,i){try{await this.doValidateCreateFile(o,i)}catch(e){return e}return!0}async doValidateCreateFile(o,i){if(!(i==null?void 0:i.overwrite)&&await this.exists(o))throw new w.FileOperationError((0,m.localize)(3,null,this.resourceForError(o)),3,i)}async createFile(o,i=h.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const n=await this.writeFile(o,i);return this._onDidRunOperation.fire(new w.FileOperationEvent(o,0,n)),n}async writeFile(o,i,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(n);try{await this.validateWriteFile(n,o,e)||await this.mkdirp(n,r.dirname(o));let s;if((0,w.hasReadWriteCapability)(n)&&!(i instanceof h.VSBuffer))if((0,E.isReadableStream)(i)){const g=await(0,E.peekStream)(i,3);g.ended?s=h.VSBuffer.concat(g.buffer):s=g}else s=(0,E.peekReadable)(i,g=>h.VSBuffer.concat(g),3);else s=i;!(0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)&&s instanceof h.VSBuffer?await this.doWriteUnbuffered(n,o,e,s):await this.doWriteBuffered(n,o,e,s instanceof h.VSBuffer?(0,h.bufferToReadable)(s):s)}catch(a){throw new w.FileOperationError((0,m.localize)(4,null,this.resourceForError(o),(0,w.ensureFileSystemProviderError)(a).toString()),(0,w.toFileOperationResult)(a),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,i,e){if(!!(e==null?void 0:e.unlock)&&!(o.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(i)));let r;try{r=await o.stat(i)}catch(a){return}if((r.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,m.localize)(6,null,this.resourceForError(i)),0,e);if(e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==w.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&e.mtime<r.mtime&&e.etag!==(0,w.etag)({mtime:e.mtime,size:r.size}))throw new w.FileOperationError((0,m.localize)(7,null),3,e);return r}async readFile(o,i){const e=await this.withReadProvider(o);return(i==null?void 0:i.atomic)?this.doReadFileAtomic(e,o,i):this.doReadFile(e,o,i)}async doReadFileAtomic(o,i,e){return new Promise((n,r)=>{this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,i,e);n(a)}catch(a){r(a)}})})}async doReadFile(o,i,e){const n=await this.doReadFileStream(o,i,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},n),{value:await(0,h.streamToBuffer)(n.value)})}async readFileStream(o,i){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,i)}async doReadFileStream(o,i,e){const n=new l.CancellationTokenSource,r=this.validateReadFile(i,e).then(s=>s,s=>{throw n.cancel(),s});let a;try{e&&typeof e.etag=="string"&&e.etag!==w.ETAG_DISABLED&&await r,!((0,w.hasOpenReadWriteCloseCapability)(o)||(0,w.hasFileReadStreamCapability)(o))||(0,w.hasReadWriteCapability)(o)&&(e==null?void 0:e.preferUnbuffered)?a=this.readFileUnbuffered(o,i,e):(0,w.hasFileReadStreamCapability)(o)?a=this.readFileStreamed(o,i,n.token,e):a=this.readFileBuffered(o,i,n.token,e);const s=await r;return Object.assign(Object.assign({},s),{value:a})}catch(s){throw a&&await(0,E.consumeStream)(a),new w.FileOperationError((0,m.localize)(8,null,this.resourceForError(i),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),e)}}readFileStreamed(o,i,e,n=Object.create(null)){const r=o.readFileStream(i,n,e);return(0,E.transform)(r,{data:a=>a instanceof h.VSBuffer?a:h.VSBuffer.wrap(a),error:a=>new w.FileOperationError((0,m.localize)(9,null,this.resourceForError(i),(0,w.ensureFileSystemProviderError)(a).toString()),(0,w.toFileOperationResult)(a),n)},a=>h.VSBuffer.concat(a))}readFileBuffered(o,i,e,n=Object.create(null)){const r=(0,h.newWriteableBufferStream)();return(0,p.readFileIntoStream)(o,i,r,a=>a,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new w.FileOperationError((0,m.localize)(10,null,this.resourceForError(i),(0,w.ensureFileSystemProviderError)(a).toString()),(0,w.toFileOperationResult)(a),n)}),e),r}readFileUnbuffered(o,i,e){const n=(0,E.newWriteableStream)(r=>h.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(i);e&&typeof e.position=="number"&&(r=r.slice(e.position)),e&&typeof e.length=="number"&&(r=r.slice(0,e.length)),this.validateReadFileLimits(i,r.byteLength,e),n.end(h.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async validateReadFile(o,i){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new w.FileOperationError((0,m.localize)(11,null,this.resourceForError(o)),0,i);if(i&&typeof i.etag=="string"&&i.etag!==w.ETAG_DISABLED&&i.etag===e.etag)throw new w.FileOperationError((0,m.localize)(12,null),2,i);return this.validateReadFileLimits(o,e.size,i),e}validateReadFileLimits(o,i,e){if(e==null?void 0:e.limits){let n;if(typeof e.limits.memory=="number"&&i>e.limits.memory&&(n=9),typeof e.limits.size=="number"&&i>e.limits.size&&(n=7),typeof n=="number")throw new w.FileOperationError((0,m.localize)(13,null,this.resourceForError(o)),n)}}async canMove(o,i,e){return this.doCanMoveCopy(o,i,"move",e)}async canCopy(o,i,e){return this.doCanMoveCopy(o,i,"copy",e)}async doCanMoveCopy(o,i,e,n){if(o.toString()!==i.toString())try{const r=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,o,a,i,e,n)}catch(r){return r}return!0}async move(o,i,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(n,o,r,i,"move",!!e),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(o,a==="move"?2:3,s)),s}async copy(o,i,e){const n=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(n,o,r,i,"copy",!!e),s=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(o,a==="copy"?3:2,s)),s}async doMoveCopy(o,i,e,n,r,a){if(i.toString()===n.toString())return r;const{exists:s,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(o,i,e,n,r,a);if(s&&!g&&a&&await this.del(n,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(n)),r==="copy"){if(o===e&&(0,w.hasFileFolderCopyCapability)(o))await o.copy(i,n,{overwrite:a});else{const F=await this.resolve(i);F.isDirectory?await this.doCopyFolder(o,F,e,n):await this.doCopyFile(o,i,e,n)}return r}else return o===e?(await o.rename(i,n,{overwrite:a}),r):(await this.doMoveCopy(o,i,e,n,"copy",a),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(o,i,e,n){if((0,w.hasOpenReadWriteCloseCapability)(o)&&(0,w.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,i,e,n);if((0,w.hasOpenReadWriteCloseCapability)(o)&&(0,w.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,i,e,n);if((0,w.hasReadWriteCapability)(o)&&(0,w.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,i,e,n);if((0,w.hasReadWriteCapability)(o)&&(0,w.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,i,e,n)}async doCopyFolder(o,i,e,n){await e.mkdir(n),Array.isArray(i.children)&&await P.Promises.settled(i.children.map(async r=>{const a=this.getExtUri(e).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),e,a):this.doCopyFile(o,r.resource,e,a)}))}async doValidateMoveCopy(o,i,e,n,r,a){let s=!1;if(o===e){const{providerExtUri:F,isPathCaseSensitive:U}=this.getExtUri(o);if(U||(s=F.isEqual(i,n)),s&&r==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!s&&F.isEqualOrParent(n,i))throw new Error((0,m.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const g=await this.exists(n);if(g&&!s){if(!a)throw new w.FileOperationError((0,m.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(o===e){const{providerExtUri:F}=this.getExtUri(o);if(F.isEqualOrParent(i,n))throw new Error((0,m.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:g,isSameResourceWithDifferentPathCase:s}}getExtUri(o){const i=this.isPathCaseSensitive(o);return{providerExtUri:i?R.extUri:R.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(i,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(o,0,e)),e}async mkdirp(o,i){const e=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(i,n.dirname(i));)try{if(((await o.stat(i)).type&w.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,w.toFileSystemProviderErrorCode)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;e.push(n.basename(i)),i=n.dirname(i)}for(let r=e.length-1;r>=0;r--){i=n.joinPath(i,e[r]);try{await o.mkdir(i)}catch(a){if((0,w.toFileSystemProviderErrorCode)(a)!==w.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,i){try{await this.doValidateDelete(o,i)}catch(e){return e}return!0}async doValidateDelete(o,i){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(i==null?void 0:i.useTrash)&&!(e.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(o)));const r=await this.exists(o);if(!r)throw new w.FileOperationError((0,m.localize)(20,null,this.resourceForError(o)),1);if(!!!(i==null?void 0:i.recursive)&&r){const s=await this.resolve(o);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(o)))}return e}async del(o,i){const e=await this.doValidateDelete(o,i),n=!!(i==null?void 0:i.useTrash),r=!!(i==null?void 0:i.recursive);await e.delete(o,{recursive:r,useTrash:n}),this._onDidRunOperation.fire(new w.FileOperationEvent(o,1))}watch(o,i={recursive:!1,excludes:[]}){let e=!1,n=()=>{e=!0};return this.doWatch(o,i).then(r=>{e?(0,b.dispose)(r):n=()=>(0,b.dispose)(r)},r=>this.logService.error(r)),(0,b.toDisposable)(()=>n())}async doWatch(o,i){const e=await this.withProvider(o),n=this.toWatchKey(e,o,i),r=this.activeWatchers.get(n)||{count:0,disposable:e.watch(o,i)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,r),r.count+=1,(0,b.toDisposable)(()=>{r.count--,r.count===0&&((0,b.dispose)(r.disposable),this.activeWatchers.delete(n))})}toWatchKey(o,i,e){const{providerExtUri:n}=this.getExtUri(o);return[n.getComparisonKey(i),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,b.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,i,e,n){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{var r;const a=await o.open(i,{create:!0,unlock:(r=e==null?void 0:e.unlock)!==null&&r!==void 0?r:!1});try{(0,E.isReadableStream)(n)||(0,E.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,a,n):await this.doWriteReadableBufferedQueued(o,a,n)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await o.close(a)}})}async doWriteStreamBufferedQueued(o,i,e){let n=0,r;if((0,E.isReadableBufferedStream)(e)){if(e.buffer.length>0){const a=h.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,i,a,a.byteLength,n,0),n+=a.byteLength}if(e.ended)return;r=e.stream}else r=e;return new Promise(async(a,s)=>{(0,E.listenStream)(r,{onData:async g=>{r.pause();try{await this.doWriteBuffer(o,i,g,g.byteLength,n,0)}catch(F){return s(F)}n+=g.byteLength,setTimeout(()=>r.resume())},onError:g=>s(g),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,i,e){let n=0,r;for(;(r=e.read())!==null;)await this.doWriteBuffer(o,i,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(o,i,e,n,r,a){let s=0;for(;s<n;)s+=await o.write(i,r+s,e.buffer,a+s,n-s)}async doWriteUnbuffered(o,i,e,n){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,i,e,n))}async doWriteUnbufferedQueued(o,i,e,n){var r;let a;n instanceof h.VSBuffer?a=n:(0,E.isReadableStream)(n)?a=await(0,h.streamToBuffer)(n):(0,E.isReadableBufferedStream)(n)?a=await(0,h.bufferedStreamToBuffer)(n):a=(0,h.readableToBuffer)(n),await o.writeFile(i,a.buffer,{create:!0,overwrite:!0,unlock:(r=e==null?void 0:e.unlock)!==null&&r!==void 0?r:!1})}async doPipeBuffered(o,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,i,e,n))}async doPipeBufferedQueued(o,i,e,n){let r,a;try{r=await o.open(i,{create:!1}),a=await e.open(n,{create:!0,unlock:!1});const s=h.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,F=0,U=0;do U=await o.read(r,g,s.buffer,F,s.byteLength-F),await this.doWriteBuffer(e,a,s,U,g,F),g+=U,F+=U,F===s.byteLength&&(F=0);while(U>0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await P.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?e.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,i,e,n))}async doPipeUnbufferedQueued(o,i,e,n){return e.writeFile(n,await o.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,i,e,n))}async doPipeUnbufferedToBufferedQueued(o,i,e,n){const r=await e.open(n,{create:!0,unlock:!1});try{const a=await o.readFile(i);await this.doWriteBuffer(e,r,h.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,w.ensureFileSystemProviderError)(a)}finally{await e.close(r)}}async doPipeBufferedToUnbuffered(o,i,e,n){const r=await(0,h.streamToBuffer)(this.readFileBuffered(o,i,l.CancellationToken.None));await this.doWriteUnbuffered(e,n,void 0,r)}throwIfFileSystemIsReadonly(o,i){if(o.capabilities&2048)throw new w.FileOperationError((0,m.localize)(22,null,this.resourceForError(i)),6);return o}resourceForError(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};I=ue([ce(0,O.ILogService)],I),t.FileService=I}),define(Q[105],Z([0,1,16,64,2,20,11,14,12,3,18,35,4,13,83,51,91,93,90,98,34,50,23,17]),function($,t,m,C,b,w,T,R,d,f,O,h,E,P,l,v,p,y,I,S,o,i,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class r extends b.Disposable{constructor(s,g){var F;super();this.logService=s,this.options=g,this.BUFFER_SIZE=((F=this.options)===null||F===void 0?void 0:F.bufferSize)||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new E.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:g,symbolicLink:F}=await d.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(g,F),ctime:g.birthtime.getTime(),mtime:g.mtime.getTime(),size:g.size}}catch(g){throw this.toFileSystemProviderError(g)}}async readdir(s){try{const g=await(0,d.readdir)(this.toFilePath(s),{withFileTypes:!0}),F=[];return await Promise.all(g.map(async U=>{try{let N;U.isSymbolicLink()?N=(await this.stat((0,O.joinPath)(s,U.name))).type:N=this.toType(U),F.push([U.name,N])}catch(N){this.logService.trace(N)}})),F}catch(g){throw this.toFileSystemProviderError(g)}}toType(s,g){let F;return(g==null?void 0:g.dangling)?F=w.FileType.Unknown:s.isFile()?F=w.FileType.File:s.isDirectory()?F=w.FileType.Directory:F=w.FileType.Unknown,g&&(F|=w.FileType.SymbolicLink),F}async readFile(s){try{const g=this.toFilePath(s);return await m.promises.readFile(g)}catch(g){throw this.toFileSystemProviderError(g)}}readFileStream(s,g,F){const U=(0,o.newWriteableStream)(N=>n.VSBuffer.concat(N.map(A=>n.VSBuffer.wrap(A))).buffer);return(0,i.readFileIntoStream)(this,s,U,N=>N.buffer,Object.assign(Object.assign({},g),{bufferSize:this.BUFFER_SIZE}),F),U}async writeFile(s,g,F){let U;try{const N=this.toFilePath(s);if(!F.create||!F.overwrite){if(await(0,d.exists)(N)){if(!F.overwrite)throw(0,w.createFileSystemProviderError)((0,l.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!F.create)throw(0,w.createFileSystemProviderError)((0,l.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}U=await this.open(s,{create:!0,unlock:F.unlock}),await this.write(U,0,g,0,g.byteLength)}catch(N){throw await this.toFileSystemProviderWriteError(s,N)}finally{typeof U=="number"&&await this.close(U)}}async open(s,g){try{const F=this.toFilePath(s);if((0,w.isFileOpenForWriteOptions)(g)&&g.unlock)try{const{stat:A}=await d.SymlinkSupport.stat(F);A.mode&128||await m.promises.chmod(F,A.mode|128)}catch(A){this.logService.trace(A)}let U;if((0,w.isFileOpenForWriteOptions)(g)){if(R.isWindows)try{await m.promises.truncate(F,0),U="r+"}catch(A){A.code!=="ENOENT"&&this.logService.trace(A)}U||(U="w")}else U="r";const N=await(0,C.promisify)(m.open)(F,U);return this.mapHandleToPos.set(N,0),(0,w.isFileOpenForWriteOptions)(g)&&this.writeHandles.set(N,s),N}catch(F){throw(0,w.isFileOpenForWriteOptions)(g)?await this.toFileSystemProviderWriteError(s,F):this.toFileSystemProviderError(F)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await(0,C.promisify)(m.fdatasync)(s)}catch(g){this.canFlush=!1,this.logService.error(g)}return await(0,C.promisify)(m.close)(s)}catch(g){throw this.toFileSystemProviderError(g)}}async read(s,g,F,U,N){const A=this.normalizePos(s,g);let j=null;try{const x=await(0,C.promisify)(m.read)(s,F,U,N,A);return typeof x=="number"?j=x:j=x.bytesRead,j}catch(x){throw this.toFileSystemProviderError(x)}finally{this.updatePos(s,A,j)}}normalizePos(s,g){return g===this.mapHandleToPos.get(s)?null:g}updatePos(s,g,F){const U=this.mapHandleToPos.get(s);typeof U=="number"&&(typeof g=="number"||(typeof F=="number"?this.mapHandleToPos.set(s,U+F):this.mapHandleToPos.delete(s)))}async write(s,g,F,U,N){return(0,E.retry)(()=>this.doWrite(s,g,F,U,N),100,3)}async doWrite(s,g,F,U,N){const A=this.normalizePos(s,g);let j=null;try{const x=await(0,C.promisify)(m.write)(s,F,U,N,A);return typeof x=="number"?j=x:j=x.bytesWritten,j}catch(x){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),x)}finally{this.updatePos(s,A,j)}}async mkdir(s){try{await m.promises.mkdir(this.toFilePath(s))}catch(g){throw this.toFileSystemProviderError(g)}}async delete(s,g){try{const F=this.toFilePath(s);await this.doDelete(F,g)}catch(F){throw this.toFileSystemProviderError(F)}}async doDelete(s,g){g.recursive?await(0,d.rimraf)(s,d.RimRafMode.MOVE):await m.promises.unlink(s)}async rename(s,g,F){const U=this.toFilePath(s),N=this.toFilePath(g);if(U!==N)try{await this.validateTargetDeleted(s,g,"move",F.overwrite),await(0,d.move)(U,N)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,l.localize)(2,null,(0,f.basename)(U),(0,f.basename)((0,f.dirname)(N)),A.toString()))),this.toFileSystemProviderError(A)}}async copy(s,g,F){const U=this.toFilePath(s),N=this.toFilePath(g);if(U!==N)try{await this.validateTargetDeleted(s,g,"copy",F.overwrite),await(0,d.copy)(U,N,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,l.localize)(3,null,(0,f.basename)(U),(0,f.basename)((0,f.dirname)(N)),A.toString()))),this.toFileSystemProviderError(A)}}async validateTargetDeleted(s,g,F,U){const N=this.toFilePath(s),A=this.toFilePath(g);let j=!1;if(!!(this.capabilities&1024)||(j=(0,h.isEqual)(N,A,!0)),j&&F==="copy")throw(0,w.createFileSystemProviderError)((0,l.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!j&&await(0,d.exists)(A)){if(!U)throw(0,w.createFileSystemProviderError)((0,l.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(g,{recursive:!0,useTrash:!1})}}watch(s,g){return g.recursive?this.watchRecursive(s,g.excludes):this.watchNonRecursive(s)}watchRecursive(s,g){const F={path:this.toFilePath(s),excludes:g},U=(0,e.insert)(this.recursiveFoldersToWatch,F);return this.refreshRecursiveWatchers(),(0,b.toDisposable)(()=>{U(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,g,F;if(this.recursiveWatcher instanceof I.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,b.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let U,N;((g=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||g===void 0?void 0:g.usePolling)?(U=p.FileWatcher,N=(F=this.options)===null||F===void 0?void 0:F.watcher):this.recursiveFoldersToWatch.length===1?R.isWindows?U=y.FileWatcher:U=p.FileWatcher:U=I.FileWatcher,this.recursiveWatcher=new U(this.recursiveFoldersToWatch,A=>this._onDidChangeFile.fire((0,v.toFileChanges)(A)),A=>{A.type==="error"&&this._onDidWatchErrorOccur.fire(A.message),this.logService[A.type](A.message)},this.logService.getLevel()===P.LogLevel.Trace,N),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)}))}}watchNonRecursive(s){const g=new S.FileWatcher(this.toFilePath(s),U=>this._onDidChangeFile.fire((0,v.toFileChanges)(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===P.LogLevel.Trace),F=this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===P.LogLevel.Trace)});return(0,b.combinedDisposable)(g,F)}toFilePath(s){return(0,f.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof w.FileSystemProviderError)return s;let g;switch(s.code){case"ENOENT":g=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":g=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":g=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":g=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":g=w.FileSystemProviderErrorCode.NoPermissions;break;default:g=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(s,g)}async toFileSystemProviderWriteError(s,g){let F=this.toFileSystemProviderError(g);if(s&&F.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:U}=await d.SymlinkSupport.stat(this.toFilePath(s));U.mode&128||(F=(0,w.createFileSystemProviderError)(g,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(U){this.logService.trace(U)}return F}dispose(){super.dispose(),(0,b.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,b.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=r}),define(Q[106],Z([0,1,12,16,132,24,2,19,4,25,13,39,23,11,10,3]),function($,t,m,C,b,w,T,R,d,f,O,h,E,P,l,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let p=class extends T.Disposable{constructor(S,o,i){super();this.extensionManagementService=S,this.logService=i,this._onDidLanguagesChange=this._register(new P.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new y(o,i)),this._register(S.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(S.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(S=>{const o=["en",...Object.keys(S)];return(0,E.distinct)(o)})}onDidInstallExtension(S){S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",S.identifier.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(S){this.cache.getLanguagePacks().then(o=>{Object.keys(o).some(i=>o[i]&&o[i].extensions.some(e=>(0,f.areSameExtensions)(e.extensionIdentifier,S)))&&(this.logService.debug("Removing language packs from the extension",S.id),this.update().then(i=>{i&&this._onDidLanguagesChange.fire()}))})}async update(){const[S,o]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(o);return!(0,E.equals)(Object.keys(S),Object.keys(i))}};p=ue([ce(0,w.IExtensionManagementService),ce(1,R.INativeEnvironmentService),ce(2,O.ILogService)],p),t.LocalizationsService=p;let y=class extends T.Disposable{constructor(S,o){super();this.logService=o,this.languagePacks={},this.languagePacksFilePath=(0,v.join)(S.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new d.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(S){return this.withLanguagePacks(o=>{Object.keys(o).forEach(i=>delete o[i]),this.createLanguagePacksFromExtensions(o,...S)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(S,...o){for(const i of o)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(S,i);Object.keys(S).forEach(i=>this.updateHash(S[i]))}createLanguagePacksFromExtension(S,o){const i=o.identifier,e=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const n of e)if(o.location.scheme===l.Schemas.file&&(0,h.isValidLocalization)(n)){let r=S[n.languageId];r||(r={hash:"",extensions:[],translations:{}},S[n.languageId]=r);let a=r.extensions.filter(s=>(0,f.areSameExtensions)(s.extensionIdentifier,i))[0];a?a.version=o.manifest.version:r.extensions.push({extensionIdentifier:i,version:o.manifest.version});for(const s of n.translations)r.translations[s.id]=(0,v.join)(o.location.fsPath,s.path)}}updateHash(S){if(S){const o=(0,b.createHash)("md5");for(const i of S.extensions)o.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);S.hash=o.digest("hex")}}withLanguagePacks(S=()=>null){return this.languagePacksFileLimiter.queue(()=>{let o=null;return C.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch(e){return{}}}).then(i=>(o=S(i),i)).then(i=>{for(const n of Object.keys(i))i[n]||delete i[n];this.languagePacks=i,this.initializedCache=!0;const e=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",e),(0,m.writeFile)(this.languagePacksFilePath,e)}).then(()=>o,i=>this.logService.error(i))})}};y=ue([ce(0,R.INativeEnvironmentService),ce(1,O.ILogService)],y)}),define(Q[107],Z([0,1,13,20]),function($,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function b(d,f,O,h){try{const E=await new Promise((P,l)=>{$(["spdlog"],P,l)});return E.setAsyncMode(8192,500),E.createRotatingLoggerAsync(d,f,O,h)}catch(E){console.error(E)}return null}function w(d,f,O,h){return $.__$__nodeRequire("spdlog").createRotatingLogger(d,f,O,h)}t.createRotatingLogger=w;function T(d,f,O){switch(f){case m.LogLevel.Trace:d.trace(O);break;case m.LogLevel.Debug:d.debug(O);break;case m.LogLevel.Info:d.info(O);break;case m.LogLevel.Warning:d.warn(O);break;case m.LogLevel.Error:d.error(O);break;case m.LogLevel.Critical:d.critical(O);break;default:throw new Error("Invalid log level")}}class R extends m.AbstractMessageLogger{constructor(f,O,h,E){super();this.name=f,this.filepath=O,this.rotating=h,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(P=>{this._logger&&this._logger.setLevel(P)}))}_createSpdLogLogger(){const f=this.rotating?6:1,O=30/f*C.ByteSize.MB;return b(this.name,this.filepath,O,f).then(h=>{if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:E,message:P}of this.buffer)T(this._logger,E,P);this.buffer=[]}})}log(f,O){this._logger?T(this._logger,f,O):this.getLevel()<=f&&this.buffer.push({level:f,message:O})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=R}),define(Q[41],Z([0,1,7]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,m.createDecorator)("productService")}),define(Q[26],Z([0,1,8,56]),function($,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(T,R){C.ok(m.isString(T)),C.ok(m.isObject(R)),C.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,R)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new b}),define(Q[108],Z([0,1,26,11]),function($,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class w{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,f){this.schemasById[b(d)]=f,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new w;m.Registry.add(t.Extensions.JSONContribution,T)}),define(Q[31],Z([0,1,74,11,26,8,108]),function($,t,m,C,b,w,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var R;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const d=b.Registry.as(T.Extensions.JSONContribution);class f{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(y,I=!0){this.registerConfigurations([y],I)}registerConfigurations(y,I=!0){const S=[];y.forEach(o=>{S.push(...this.validateAndRegisterProperties(o,I)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterConfigurations(y){const I=[],S=o=>{if(o.properties)for(const i in o.properties)I.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i]);o.allOf&&o.allOf.forEach(i=>S(i))};for(const o of y){S(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}d.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}registerDefaultConfigurations(y){const I=[],S=[];for(const o of y)for(const i in o)if(I.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]=Object.assign(Object.assign({},this.defaultValues[i]||{}),o[i]);const e={type:"object",default:this.defaultValues[i],description:m.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};S.push(h(i)),this.configurationProperties[i]=e,this.defaultLanguageConfigurationOverridesNode.properties[i]=e}else{this.defaultValues[i]=o[i];const e=this.configurationProperties[i];e&&(this.updatePropertyDefaultValue(i,e),this.updateSchema(i,e))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}deregisterDefaultConfigurations(y){const I=[];for(const S of y)for(const o in S)if(I.push(o),delete this.defaultValues[o],t.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const i=this.configurationProperties[o];i&&(this.updatePropertyDefaultValue(o,i),this.updateSchema(o,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}notifyConfigurationSchemaUpdated(...y){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(y){for(const I of y)this.overrideIdentifiers.add(I);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(y,I=!0,S=3){S=w.isUndefinedOrNull(y.scope)?S:y.scope;let o=[],i=y.properties;if(i)for(let n in i){if(I&&l(n)){delete i[n];continue}const r=i[n];if(this.updatePropertyDefaultValue(n,r),t.OVERRIDE_PROPERTY_PATTERN.test(n)?r.scope=void 0:r.scope=w.isUndefinedOrNull(r.scope)?S:r.scope,i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),o.push(n)}let e=y.allOf;if(e)for(let n of e)o.push(...this.validateAndRegisterProperties(n,I,S));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(y){const I=S=>{let o=S.properties;if(o)for(const e in o)this.updateSchema(e,o[e]);let i=S.allOf;i&&i.forEach(I)};I(y)}updateSchema(y,I){switch(t.allSettings.properties[y]=I,I.scope){case 1:t.applicationSettings.properties[y]=I;break;case 2:t.machineSettings.properties[y]=I;break;case 6:t.machineOverridableSettings.properties[y]=I;break;case 3:t.windowSettings.properties[y]=I;break;case 4:t.resourceSettings.properties[y]=I;break;case 5:t.resourceSettings.properties[y]=I,this.resourceLanguageSettingsSchema.properties[y]=I;break}}removeFromSchema(y,I){switch(delete t.allSettings.properties[y],I.scope){case 1:delete t.applicationSettings.properties[y];break;case 2:delete t.machineSettings.properties[y];break;case 6:delete t.machineOverridableSettings.properties[y];break;case 3:delete t.windowSettings.properties[y];break;case 4:case 5:delete t.resourceSettings.properties[y];break}}updateOverridePropertyPatternKey(){for(const y of this.overrideIdentifiers.values()){const I=`[${y}]`,S={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(I,S),t.allSettings.properties[I]=S,t.applicationSettings.properties[I]=S,t.machineSettings.properties[I]=S,t.machineOverridableSettings.properties[I]=S,t.windowSettings.properties[I]=S,t.resourceSettings.properties[I]=S}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(y,I){let S=this.defaultValues[y];w.isUndefined(S)&&(S=I.default),w.isUndefined(S)&&(S=E(I.type)),I.default=S}}const O="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(O);function h(p){return p.substring(1,p.length-1)}t.overrideIdentifierFromKey=h;function E(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=E;const P=new f;b.Registry.add(t.Extensions.Configuration,P);function l(p){return p.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(p)?m.localize(5,null,p):P.getConfigurationProperties()[p]!==void 0?m.localize(6,null,p):null:m.localize(4,null)}t.validateProperty=l;function v(){const p=[],y=P.getConfigurationProperties();for(const I of Object.keys(y))p.push([I,y[I].scope]);return p.push(["launch",4]),p.push(["task",4]),p}t.getScopes=v}),define(Q[27],Z([0,1,22,8,9,26,7,31]),function($,t,m,C,b,w,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,T.createDecorator)("configurationService");function d(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof b.URI)}t.isConfigurationOverrides=d;var f;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(f=t.ConfigurationTarget||(t.ConfigurationTarget={}));function O(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=O;function h(n,r){const a=r?n?r.keys.filter(j=>n.keys.indexOf(j)===-1):[...r.keys]:[],s=n?r?n.keys.filter(j=>r.keys.indexOf(j)===-1):[...n.keys]:[],g=[];if(r&&n){for(const j of n.keys)if(r.keys.indexOf(j)!==-1){const x=y(n.contents,j),X=y(r.contents,j);m.equals(x,X)||g.push(j)}}const F=[],U=j=>{const x={};for(const X of j)for(const ne of X.identifiers)x[i(ne)]=X;return x},N=r?U(r.overrides):{},A=n?U(n.overrides):{};if(Object.keys(N).length)for(const j of a){const x=N[j];x&&F.push([(0,R.overrideIdentifierFromKey)(j),x.keys])}if(Object.keys(A).length)for(const j of s){const x=A[j];x&&F.push([(0,R.overrideIdentifierFromKey)(j),x.keys])}if(Object.keys(N).length&&Object.keys(A).length)for(const j of g){const x=A[j],X=N[j];if(x&&X){const ne=h({contents:x.contents,keys:x.keys,overrides:[]},{contents:X.contents,keys:X.keys,overrides:[]});F.push([(0,R.overrideIdentifierFromKey)(j),[...ne.added,...ne.removed,...ne.updated]])}}return{added:a,removed:s,updated:g,overrides:F}}t.compare=h;function E(n,r){const a=[];for(const s of Object.keys(n))if(R.OVERRIDE_PROPERTY_PATTERN.test(s)){const g={};for(const F in n[s])g[F]=n[s][F];a.push({identifiers:[(0,R.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(g),contents:P(g,r)})}return a}t.toOverrides=E;function P(n,r){const a=Object.create(null);for(let s in n)l(a,s,n[s],r);return a}t.toValuesTree=P;function l(n,r,a,s){const g=r.split("."),F=g.pop();let U=n;for(let N=0;N<g.length;N++){let A=g[N],j=U[A];switch(typeof j){case"undefined":j=U[A]=Object.create(null);break;case"object":break;default:s(`Ignoring ${r} as ${g.slice(0,N+1).join(".")} is ${JSON.stringify(j)}`);return}U=j}if(typeof U=="object"&&U!==null)try{U[F]=a}catch(N){s(`Ignoring ${r} as ${g.join(".")} is ${JSON.stringify(U)}`)}else s(`Ignoring ${r} as ${g.join(".")} is ${JSON.stringify(U)}`)}t.addToValueTree=l;function v(n,r){const a=r.split(".");p(n,a)}t.removeFromValueTree=v;function p(n,r){const a=r.shift();if(r.length===0){delete n[a];return}if(Object.keys(n).indexOf(a)!==-1){const s=n[a];typeof s=="object"&&!Array.isArray(s)&&(p(s,r),Object.keys(s).length===0&&delete n[a])}}function y(n,r,a){function s(U,N){let A=U;for(const j of N){if(typeof A!="object"||A===null)return;A=A[j]}return A}const g=r.split("."),F=s(n,g);return typeof F=="undefined"?a:F}t.getConfigurationValue=y;function I(n,r,a){Object.keys(r).forEach(s=>{s!=="__proto__"&&(s in n?C.isObject(n[s])&&C.isObject(r[s])?I(n[s],r[s],a):a&&(n[s]=r[s]):n[s]=r[s])})}t.merge=I;function S(){const n=w.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}t.getConfigurationKeys=S;function o(){const n=Object.create(null),r=w.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let a in r){let s=r[a].default;l(n,a,s,g=>console.error(`Conflict in default settings: ${g}`))}return n}t.getDefaultValues=o;function i(n){return`[${n}]`}t.keyFromOverrideIdentifier=i;function e(n,r,a){const s=n.inspect(r),g=n.inspect(a);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:s.defaultValue}t.getMigratedSettingValue=e}),define(Q[109],Z([0,1,58,44,23,8,22,9,31,27,26,2,11]),function($,t,m,C,b,w,T,R,d,f,O,h,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class P{constructor(e={},n=[],r=[]){this._contents=e,this._keys=n,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,f.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const r=this.getContentsForOverrideIdentifer(n);return r?e?(0,f.getConfigurationValue)(r,e):r:void 0}getKeysForOverrideIdentifier(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.keys;return[]}override(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const a of b.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[a],g=n[a];g&&(typeof s=="object"&&typeof g=="object"?(s=T.deepClone(s),this.mergeContents(s,g)):s=g),r[a]=s}return new P(r,this.keys,this.overrides)}merge(...e){const n=T.deepClone(this.contents),r=T.deepClone(this.overrides),a=[...this.keys];for(const s of e){this.mergeContents(n,s.contents);for(const g of s.overrides){const[F]=r.filter(U=>b.equals(U.identifiers,g.identifiers));F?this.mergeContents(F.contents,g.contents):r.push(T.deepClone(g))}for(const g of s.keys)a.indexOf(g)===-1&&a.push(g)}return new P(n,a,r)}freeze(){return this.isFrozen=!0,this}mergeContents(e,n){for(const r of Object.keys(n)){if(r in e&&w.isObject(e[r])&&w.isObject(n[r])){this.mergeContents(e[r],n[r]);continue}e[r]=T.deepClone(n[r])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,f.addToValueTree)(this.contents,e,n,r=>{throw new Error(r)})}removeValue(e){this.removeKey(e)&&(0,f.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let r=0;r<n;r++)e.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=P;class l extends P{constructor(){const e=(0,f.getDefaultValues)(),n=(0,f.getConfigurationKeys)(),r=[];for(const a of Object.keys(e))d.OVERRIDE_PROPERTY_PATTERN.test(a)&&r.push({identifiers:[(0,d.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(e[a]),contents:(0,f.toValuesTree)(e[a],s=>console.error(`Conflict in default settings file: ${s}`))});super(e,n,r)}}t.DefaultConfigurationModel=l;class v{constructor(e,n){this._name=e,this._scopes=n,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new P}get errors(){return this._parseErrors}parseContent(e){if(!w.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n)}}parseRaw(e){this._raw=e;const n=this.doParseRaw(e);this._configurationModel=new P(n.contents,n.keys,n.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(e){let n={},r=null,a=[],s=[],g=[];function F(N){Array.isArray(a)?a.push(N):r&&(a[r]=N)}let U={onObjectBegin:()=>{let N={};F(N),s.push(a),a=N,r=null},onObjectProperty:N=>{r=N},onObjectEnd:()=>{a=s.pop()},onArrayBegin:()=>{let N=[];F(N),s.push(a),a=N,r=null},onArrayEnd:()=>{a=s.pop()},onLiteralValue:F,onError:(N,A,j)=>{g.push({error:N,offset:A,length:j})}};if(e)try{m.visit(e,U),n=a[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(e){if(this._scopes){const s=O.Registry.as(d.Extensions.Configuration).getConfigurationProperties();e=this.filterByScope(e,s,!0,this._scopes)}const n=(0,f.toValuesTree)(e,s=>console.error(`Conflict in settings file ${this._name}: ${s}`)),r=Object.keys(e),a=(0,f.toOverrides)(e,s=>console.error(`Conflict in settings file ${this._name}: ${s}`));return{contents:n,keys:r,overrides:a}}filterByScope(e,n,r,a){const s={};for(let g in e)if(d.OVERRIDE_PROPERTY_PATTERN.test(g)&&r)s[g]=this.filterByScope(e[g],n,!1,a);else{const F=this.getScope(g,n);(F===void 0||a.indexOf(F)!==-1)&&(s[g]=e[g])}return s}getScope(e,n){const r=n[e];return r?typeof r.scope!="undefined"?r.scope:3:void 0}}t.ConfigurationModelParser=v;class p extends h.Disposable{constructor(e,n,r,a){super();this.userSettingsResource=e,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(E.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(e.value.toString()||"{}"),this.parser.configurationModel}catch(e){return new P}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}t.UserSettings=p;class y{constructor(e,n,r=new P,a=new P,s=new C.ResourceMap,g=new P,F=new C.ResourceMap,U=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=s,this._memoryConfiguration=g,this._memoryConfigurationByResource=F,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(e,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(e)}updateValue(e,n,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new P,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(e):a.setValue(e,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,r){const a=this.getConsolidateConfigurationModel(n,r),s=this.getFolderConfigurationModelForResource(n.resource,r),g=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,F=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),U=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),A=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),j=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,x=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(e):s.freeze().getValue(e):void 0,X=n.overrideIdentifier?g.override(n.overrideIdentifier).getValue(e):g.getValue(e),ne=a.getValue(e),ee=b.distinct(b.flatten(a.overrides.map(te=>te.identifiers))).filter(te=>a.getOverrideValue(e,te)!==void 0);return{defaultValue:F,userValue:U,userLocalValue:N,userRemoteValue:A,workspaceValue:j,workspaceFolderValue:x,memoryValue:X,value:ne,default:F!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:U!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:j!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:x!==void 0?{value:s==null?void 0:s.freeze().getValue(e),override:n.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:X!==void 0?{value:g.getValue(e),override:n.overrideIdentifier?g.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const r=n.filter(a=>d.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const s=(0,d.overrideIdentifierFromKey)(a),g=this._defaultConfiguration.getKeysForOverrideIdentifier(s),F=e.getKeysForOverrideIdentifier(s),U=[...F.filter(N=>g.indexOf(N)===-1),...g.filter(N=>F.indexOf(N)===-1),...g.filter(N=>!T.equals(this._defaultConfiguration.override(s).getValue(N),e.override(s).getValue(N)))];return[s,U]});return this.updateDefaultConfiguration(e),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:r,removed:a,overrides:s}=(0,f.compare)(this.localUserConfiguration,e),g=[...n,...r,...a];return g.length&&this.updateLocalUserConfiguration(e),{keys:g,overrides:s}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:r,removed:a,overrides:s}=(0,f.compare)(this.remoteUserConfiguration,e);let g=[...n,...r,...a];return g.length&&this.updateRemoteUserConfiguration(e),{keys:g,overrides:s}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:r,removed:a,overrides:s}=(0,f.compare)(this.workspaceConfiguration,e);let g=[...n,...r,...a];return g.length&&this.updateWorkspaceConfiguration(e),{keys:g,overrides:s}}compareAndUpdateFolderConfiguration(e,n){const r=this.folderConfigurations.get(e),{added:a,updated:s,removed:g,overrides:F}=(0,f.compare)(r,n);let U=[...a,...s,...g];return(U.length||!r)&&this.updateFolderConfiguration(e,n),{keys:U,overrides:F}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:r,updated:a,removed:s,overrides:g}=(0,f.compare)(n,void 0);return{keys:[...r,...a,...s],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let r=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?r.override(e.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:e},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const a=n.getFolder(e);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const s=this._memoryConfigurationByResource.get(e);s&&(r=r.merge(s))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(e);a?(n=r.merge(a),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=r}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const r=n.getFolder(e);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:r,overrides:a,keys:s}=this._folderConfigurations.get(n);return e.push([n,{contents:r,overrides:a,keys:s}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>e.add(r))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(e).forEach(a=>n.add(a))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),r=this.parseConfigurationModel(e.user),a=this.parseConfigurationModel(e.workspace),s=e.folders.reduce((g,F)=>(g.set(R.URI.revive(F[0]),this.parseConfigurationModel(F[1])),g),new C.ResourceMap);return new y(n,r,new P,a,s,new P,new C.ResourceMap,!1)}static parseConfigurationModel(e){return new P(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=y;function I(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const e=new Set,n=new Map;for(const a of i)a.keys.forEach(s=>e.add(s)),a.overrides.forEach(([s,g])=>{const F=(0,C.getOrSet)(n,s,new Set);g.forEach(U=>F.add(U))});const r=[];return n.forEach((a,s)=>r.push([s,[...a.values()]])),{keys:[...e.values()],overrides:r}}t.mergeChanges=I;class S{constructor(e,n,r,a){this.change=e,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=a,this._previousConfiguration=void 0;const s=new Set;e.keys.forEach(F=>s.add(F)),e.overrides.forEach(([,F])=>F.forEach(U=>s.add(U))),this.affectedKeys=[...s.values()];const g=new P;this.affectedKeys.forEach(F=>g.setValue(F,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const a=this.previousConfiguration?this.previousConfiguration.getValue(e,n,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,s=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!T.equals(a,s)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let r=(0,f.toValuesTree)({[n]:!0},()=>{}),a;for(;typeof r=="object"&&(a=Object.keys(r)[0]);){if(e=e[a],!e)return!1;r=r[a]}return!0}}t.ConfigurationChangeEvent=S;class o extends S{constructor(e,n,r,a){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=r,this.sourceConfig=a}}t.AllKeysConfigurationChangeEvent=o}),define(Q[110],Z([0,1,26,31,2,27,109,11,4,18]),function($,t,m,C,b,w,T,R,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class O extends b.Disposable{constructor(E,P){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,f.extUriBiasedIgnorePathCase,P)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new d.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,P){const l=typeof E=="string"?E:void 0,v=(0,w.isConfigurationOverrides)(E)?E:(0,w.isConfigurationOverrides)(P)?P:{};return this.configuration.getValue(l,v,void 0)}updateValue(E,P,l,v){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const P=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(l,P,1)}onDidDefaultConfigurationChange(E){const P=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,E);this.trigger(l,P,6)}trigger(E,P,l){const v=new T.ConfigurationChangeEvent(E,{data:P},this.configuration);v.source=l,v.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=O}),define(Q[53],Z([0,1,84,7,31,26,17]),function($,t,m,C,b,w,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,C.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}t.isSuccess=R;function d(h){return h.res.statusCode===204}async function f(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return d(h)?null:(await(0,T.streamToBuffer)(h.stream)).toString()}t.asText=f;async function O(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(d(h))return null;const P=(await(0,T.streamToBuffer)(h.stream)).toString();try{return JSON.parse(P)}catch(l){throw l.message+=`:
`+P,l}}t.asJson=O,w.Registry.as(b.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,m.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null)],default:"override",description:(0,m.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(8,null)}}})}),define(Q[111],Z([0,1,112,8]),function($,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(T,R){return T.protocol==="http:"?R.HTTP_PROXY||R.http_proxy||null:T.protocol==="https:"&&(R.HTTPS_PROXY||R.https_proxy||R.HTTP_PROXY||R.http_proxy)||null}async function w(T,R,d={}){const f=(0,m.parse)(T),O=d.proxyUrl||b(f,R);if(!O)return null;const h=(0,m.parse)(O);if(!/^https?:$/.test(h.protocol||""))return null;const E={host:h.hostname||"",port:h.port||(h.protocol==="https"?"443":"80"),auth:h.auth,rejectUnauthorized:(0,C.isBoolean)(d.strictSSL)?d.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((P,l)=>{$(["http-proxy-agent"],P,l)}))(E):new(await new Promise((P,l)=>{$(["https-proxy-agent"],P,l)}))(E)}t.getProxyAgent=w}),define(Q[113],Z([0,1,30,17]),function($,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(w,T,R){let d=R&&R.get("storage.serviceMachineId",0)||null;if(d)return d;try{const O=(await T.readFile(w.serviceMachineIdResource)).value.toString();d=(0,m.isUUID)(O)?O:null}catch(f){d=null}if(!d){d=(0,m.generateUuid)();try{await T.writeFile(w.serviceMachineIdResource,C.VSBuffer.fromString(d))}catch(f){}}return R&&R.store("storage.serviceMachineId",d,0,1),d}t.getServiceMachineId=b}),define(Q[114],Z([0,1,7]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=(0,m.createDecorator)("stateService")}),define(Q[115],Z([0,1,3,16,19,12,8,13]),function($,t,m,C,b,w,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class d{constructor(h,E){this.dbPath=h,this.onError=E,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const h=await this.loadAsync();this._database||(this._database=h)}}loadSync(){try{return this.lastFlushedSerializedDatabase=C.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(h){return h.code!=="ENOENT"&&this.onError(h),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await C.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(h){return h.code!=="ENOENT"&&this.onError(h),{}}}getItem(h,E){const P=this.database[h];return(0,T.isUndefinedOrNull)(P)?E:P}setItem(h,E){if((0,T.isUndefinedOrNull)(E))return this.removeItem(h);(typeof E=="string"||typeof E=="number"||typeof E=="boolean")&&this.database[h]===E||(this.database[h]=E,this.saveSync())}removeItem(h){(0,T.isUndefined)(this.database[h])||(this.database[h]=void 0,this.saveSync())}saveSync(){const h=JSON.stringify(this.database,null,4);if(h!==this.lastFlushedSerializedDatabase)try{(0,w.writeFileSync)(this.dbPath,h),this.lastFlushedSerializedDatabase=h}catch(E){this.onError(E)}}}t.FileStorage=d;let f=class We{constructor(h,E){this.fileStorage=new d(m.join(h.userDataPath,We.STATE_FILE),P=>E.error(P))}init(){return this.fileStorage.init()}getItem(h,E){return this.fileStorage.getItem(h,E)}setItem(h,E){this.fileStorage.setItem(h,E)}removeItem(h){this.fileStorage.removeItem(h)}};f.STATE_FILE="storage.json",f=ue([ce(0,b.INativeEnvironmentService),ce(1,R.ILogService)],f),t.StateService=f}),define(Q[116],Z([0,1,7,11,2,8,67,4]),function($,t,m,C,b,w,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";t.IStorageService=(0,m.createDecorator)("storageService");var f;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(f=t.WillSaveStateReason||(t.WillSaveStateReason={}));var O;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(O=t.StorageScope||(t.StorageScope={}));var h;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(h=t.StorageTarget||(t.StorageTarget={}));class E extends b.Disposable{constructor(p={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=p,this._onDidChangeValue=this._register(new C.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new C.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new C.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,y){y===d?(p===0?this._globalKeyTargets=void 0:p===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:p})):this._onDidChangeValue.fire({scope:p,key:y,target:this.getKeyTargets(p)[y]})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,y,I){var S;return(S=this.getStorage(y))===null||S===void 0?void 0:S.get(p,I)}getBoolean(p,y,I){var S;return(S=this.getStorage(y))===null||S===void 0?void 0:S.getBoolean(p,I)}getNumber(p,y,I){var S;return(S=this.getStorage(y))===null||S===void 0?void 0:S.getNumber(p,I)}store(p,y,I,S){if((0,w.isUndefinedOrNull)(y)){this.remove(p,I);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(p,I,S),(o=this.getStorage(I))===null||o===void 0||o.set(p,y)})}remove(p,y){this.withPausedEmitters(()=>{var I;this.updateKeyTarget(p,y,void 0),(I=this.getStorage(y))===null||I===void 0||I.delete(p)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,y){const I=[],S=this.getKeyTargets(p);for(const o of Object.keys(S))S[o]===y&&I.push(o);return I}updateKeyTarget(p,y,I){var S,o;const i=this.getKeyTargets(y);typeof I=="number"?i[p]!==I&&(i[p]=I,(S=this.getStorage(y))===null||S===void 0||S.set(d,JSON.stringify(i))):typeof i[p]=="number"&&(delete i[p],(o=this.getStorage(y))===null||o===void 0||o.set(d,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(p){return p===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(p){const y=this.get(d,p);if(y)try{return JSON.parse(y)}catch(I){}return Object.create(null)}isNew(p){return this.getBoolean(t.IS_NEW_KEY,p)===!0}async flush(){var p,y,I,S;this._onWillSaveState.fire({reason:f.NONE}),await R.Promises.settled([(y=(p=this.getStorage(0))===null||p===void 0?void 0:p.whenFlushed())!==null&&y!==void 0?y:Promise.resolve(),(S=(I=this.getStorage(1))===null||I===void 0?void 0:I.whenFlushed())!==null&&S!==void 0?S:Promise.resolve()])}async logStorage(){var p,y,I,S,o,i;const e=(y=(p=this.getStorage(0))===null||p===void 0?void 0:p.items)!==null&&y!==void 0?y:new Map,n=(S=(I=this.getStorage(1))===null||I===void 0?void 0:I.items)!==null&&S!==void 0?S:new Map;return l(e,n,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(i=this.getLogDetails(1))!==null&&i!==void 0?i:"")}}t.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class P extends E{constructor(){super();this.globalStorage=new T.Storage(new T.InMemoryStorageDatabase),this.workspaceStorage=new T.Storage(new T.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.globalStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p)))}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(p){}}t.InMemoryStorageService=P;async function l(v,p,y,I){const S=s=>{try{return JSON.parse(s)}catch(g){return s}},o=new Map,i=new Map;v.forEach((s,g)=>{o.set(g,s),i.set(g,S(s))});const e=new Map,n=new Map;p.forEach((s,g)=>{e.set(g,s),n.set(g,S(s))}),console.group(`Storage: Global (path: ${y})`);let r=[];o.forEach((s,g)=>{r.push({key:g,value:s})}),console.table(r),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${I})`);let a=[];e.forEach((s,g)=>{a.push({key:g,value:s})}),console.table(a),console.groupEnd(),console.log(n)}t.logStorage=l}),define(Q[117],Z([0,1,14,37,30,9]),function($,t,m,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0;async function T(d,f,O,h,E,P,l,v,p){const y=Object.create(null);y["common.machineId"]=P,y.sessionID=(0,b.generateUuid)()+Date.now(),y.commitHash=h,y.version=E,y["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,m.PlatformToString)(m.platform),y["common.nodePlatform"]=C.platform,y["common.nodeArch"]=O,y["common.product"]=p||"desktop";const I=R(l||[]);I&&(y["common.msftInternal"]=I);let S=0;const o=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),m.isLinuxSnap&&(y["common.snap"]="true");try{const i=await d.readFile(w.URI.file(v));y["common.source"]=i.value.toString().slice(0,30)}catch(i){}return y}t.resolveCommonProperties=T;function R(d){const f=C.env.USERDNSDOMAIN;if(!f)return!1;const O=f.toLowerCase();return d.some(h=>O===h)}}),define(Q[42],Z([0,1,7]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,m.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Q[118],Z([0,1,15,24,25,22,42,53,48,19,28,13,20,9,41,116,113,7,18]),function($,t,m,C,b,w,T,R,d,f,O,h,E,P,l,v,p,y,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var S;(function(c){c[c.None=0]="None",c[c.IncludeVersions=1]="IncludeVersions",c[c.IncludeFiles=2]="IncludeFiles",c[c.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",c[c.IncludeSharedAccounts=8]="IncludeSharedAccounts",c[c.IncludeVersionProperties=16]="IncludeVersionProperties",c[c.ExcludeNonValidated=32]="ExcludeNonValidated",c[c.IncludeInstallationTargets=64]="IncludeInstallationTargets",c[c.IncludeAssetUri=128]="IncludeAssetUri",c[c.IncludeStatistics=256]="IncludeStatistics",c[c.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",c[c.Unpublished=4096]="Unpublished"})(S||(S={}));function o(...c){return String(c.reduce((u,D)=>u|D,0))}var i;(function(c){c[c.Tag=1]="Tag",c[c.ExtensionId=4]="ExtensionId",c[c.Category=5]="Category",c[c.ExtensionName=7]="ExtensionName",c[c.Target=8]="Target",c[c.Featured=9]="Featured",c[c.SearchText=10]="SearchText",c[c.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:S.None,criteria:[],assetTypes:[]};class s{constructor(u=a){this.state=u}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(u,D=this.state.pageSize){return new s(Object.assign(Object.assign({},this.state),{pageNumber:u,pageSize:D}))}withFilter(u,...D){const L=[...this.state.criteria,...D.length?D.map(k=>({filterType:u,value:k})):[{filterType:u}]];return new s(Object.assign(Object.assign({},this.state),{criteria:L}))}withSortBy(u){return new s(Object.assign(Object.assign({},this.state),{sortBy:u}))}withSortOrder(u){return new s(Object.assign(Object.assign({},this.state),{sortOrder:u}))}withFlags(...u){return new s(Object.assign(Object.assign({},this.state),{flags:u.reduce((D,L)=>D|L,0)}))}withAssetTypes(...u){return new s(Object.assign(Object.assign({},this.state),{assetTypes:u}))}get raw(){const{criteria:u,pageNumber:D,pageSize:L,sortBy:k,sortOrder:M,flags:z,assetTypes:B}=this.state;return{filters:[{criteria:u,pageNumber:D,pageSize:L,sortBy:k,sortOrder:M}],assetTypes:B,flags:z}}get searchText(){const u=this.state.criteria.filter(D=>D.filterType===i.SearchText)[0];return u&&u.value?u.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(u=>String(u.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function g(c,u){const D=(c||[]).filter(L=>L.statisticName===u)[0];return D?D.value:0}function F(c){const u="Microsoft.VisualStudio.Code.Translation.";return c.files.filter(L=>L.assetType.indexOf(u)===0).reduce((L,k)=>{const M=j(c,k.assetType);return M&&L.push([k.assetType.substring(u.length),M]),L},[])}function U(c){if(c.properties){const u=c.properties.filter(k=>k.key===e.Repository),D=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),L=u.filter(k=>D.test(k.value))[0];return L?{uri:L.value,fallbackUri:L.value}:null}return j(c,e.Repository)}function N(c){return{uri:`${c.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${c.fallbackAssetUri}/${e.VSIX}`}}function A(c){const u=j(c,e.Icon);if(u)return u;const D=C.DefaultIconPath;return{uri:D,fallbackUri:D}}function j(c,u){return c.files.filter(L=>L.assetType===u)[0]?{uri:`${c.assetUri}/${u}`,fallbackUri:`${c.fallbackAssetUri}/${u}`}:null}function x(c,u){const D=c.properties?c.properties.filter(k=>k.key===u):[],L=D.length>0&&D[0].value;return L?L.split(",").map(k=>(0,b.adoptToGalleryExtensionId)(k)):[]}function X(c){const u=c.properties?c.properties.filter(D=>D.key===n.Engine):[];return u.length>0&&u[0].value||""}function ne(c){const u=c.properties?c.properties.filter(L=>L.key===n.LocalizedLanguages):[],D=u.length>0&&u[0].value||"";return D?D.split(","):[]}function ee(c){return c.indexOf("preview")!==-1}function te(c){const u=c.properties?c.properties.find(D=>D.key===n.WebExtension):void 0;return!!u&&u.value==="true"}function ae(c){return c.files.some(u=>u.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,I.joinPath)(P.URI.parse(c.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function W(c,u,D,L,k){const M={manifest:j(u,e.Manifest),readme:j(u,e.Details),changelog:j(u,e.Changelog),license:j(u,e.License),repository:U(u),download:N(u),icon:A(u),coreTranslations:F(u)};return{identifier:{id:(0,b.getGalleryExtensionId)(c.publisher.publisherName,c.extensionName),uuid:c.extensionId},name:c.extensionName,version:u.version,date:u.lastUpdated,displayName:c.displayName,publisherId:c.publisher.publisherId,publisher:c.publisher.publisherName,publisherDisplayName:c.publisher.displayName,description:c.shortDescription||"",installCount:g(c.statistics,"install"),rating:g(c.statistics,"averagerating"),ratingCount:g(c.statistics,"ratingcount"),assetUri:P.URI.parse(u.assetUri),webResource:ae(u),assetTypes:u.files.map(({assetType:z})=>z),assets:M,properties:{dependencies:x(u,n.Dependency),extensionPack:x(u,n.ExtensionPack),engine:X(u),localizedLanguages:ne(u),webExtension:te(u)},telemetryData:{index:(L.pageNumber-1)*L.pageSize+D,searchText:L.searchText,querySource:k},preview:ee(c.flags)}}let G=class{constructor(u,D,L,k,M,z,B){this.requestService=u,this.logService=D,this.environmentService=L,this.telemetryService=k,this.fileService=M,this.productService=z;const q=z.extensionsGallery;this.extensionsGalleryUrl=q&&q.serviceUrl,this.extensionsControlUrl=q&&q.controlUrl,this.commonHeadersPromise=_(z.version,this.environmentService,this.fileService,B)}api(u=""){return`${this.extensionsGalleryUrl}${u}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(u,D){const L=[];let{total:k,firstPage:M,getPage:z}=await this.query({names:u,pageSize:u.length},D);L.push(...M);for(let B=1;L.length<k&&(M=await z(B,D),M.length);B++)L.push(...M);return L}async getCompatibleExtension(u,D){const L=await this.getCompatibleExtensionByEngine(u,D);return(L==null?void 0:L.properties.webExtension)?L.webResource?L:null:L}async getCompatibleExtensionByEngine(u,D){const L=(0,C.isIExtensionIdentifier)(u)?null:u;if(L&&L.properties.engine&&(0,d.isEngineValid)(L.properties.engine,this.productService.version))return L;const{id:k,uuid:M}=L?L.identifier:u;let z=new s().withFlags(S.IncludeAssetUri,S.IncludeStatistics,S.IncludeFiles,S.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");M?z=z.withFilter(i.ExtensionId,M):z=z.withFilter(i.ExtensionName,k);const{galleryExtensions:B}=await this.queryGallery(z,O.CancellationToken.None),[q]=B;if(!q||!q.versions.length)return null;if(D){const Y=q.versions.filter(ie=>ie.version===D)[0];if(Y){const ie=W(q,Y,0,z);if(ie.properties.engine&&(0,d.isEngineValid)(ie.properties.engine,this.productService.version))return ie}return null}const J=await this.getLastValidExtensionVersion(q,q.versions);return J?W(q,J,0,z):null}async query(u,D){const L=O.CancellationToken.isCancellationToken(u)?{}:u,k=O.CancellationToken.isCancellationToken(u)?u:D;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=L.text||"";const z=(0,w.getOrDefault)(L,re=>re.pageSize,50);let B=new s().withFlags(S.IncludeLatestVersionOnly,S.IncludeAssetUri,S.IncludeStatistics,S.IncludeFiles,S.IncludeVersionProperties).withPage(1,z).withFilter(i.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,ge)=>(B=B.withFilter(i.Category,ge||he),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,ge)=>(B=B.withFilter(i.Tag,ge||he),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(i.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),B=B.withFilter(i.SearchText,M)),B=B.withSortBy(0)):L.ids?B=B.withFilter(i.ExtensionId,...L.ids):L.names?B=B.withFilter(i.ExtensionName,...L.names):B=B.withSortBy(4),typeof L.sortBy=="number"&&(B=B.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(B=B.withSortOrder(L.sortOrder));const{galleryExtensions:q,total:J}=await this.queryGallery(B,k),Y=q.map((re,he)=>W(re,re.versions[0],he,B,L.source)),ie=async(re,he)=>{if(he.isCancellationRequested)throw(0,m.canceled)();const ge=B.withPage(re+1),{galleryExtensions:De}=await this.queryGallery(ge,he);return De.map((Oe,Fe)=>W(Oe,Oe.versions[0],Fe,ge,L.source))};return{firstPage:Y,total:J,pageSize:B.pageSize,getPage:ie}}async queryGallery(u,D){if(!this.isEnabled())throw new Error("No extension gallery service configured.");u=u.withFlags(u.flags,S.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,o(S.Unpublished));const L=await this.commonHeadersPromise,k=JSON.stringify(u.raw),M=Object.assign(Object.assign({},L),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(k.length)}),z=new Date().getTime();let B,q,J=0;try{if(B=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:k,headers:M},D),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:J};const Y=await(0,R.asJson)(B);if(Y){const ie=Y.results[0],re=ie.extensions,he=ie.resultMetadata&&ie.resultMetadata.filter(ge=>ge.metadataType==="ResultCount")[0];return J=he&&he.metadataItems.filter(ge=>ge.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:J}}return{galleryExtensions:[],total:J}}catch(Y){throw q=Y,Y}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},u.telemetryData),{requestBodySize:String(k.length),duration:new Date().getTime()-z,success:!!B&&(0,R.isSuccess)(B),responseBodySize:B==null?void 0:B.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:q?(0,m.isPromiseCanceledError)(q)?"canceled":(0,m.getErrorMessage)(q).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(J)}))}}async reportStatistic(u,D,L,k){if(!!this.isEnabled()){const M=await this.commonHeadersPromise,z=Object.assign(Object.assign({},M),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${u}/extensions/${D}/${L}/stats?statType=${k}`),headers:z},O.CancellationToken.None)}catch(B){}}}async download(u,D,L){this.logService.trace("ExtensionGalleryService#download",u.identifier.id);const k=(0,b.getGalleryExtensionTelemetryData)(u),M=new Date().getTime(),z=Y=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},k),{duration:Y})),B=L===1?"install":L===2?"update":"",q=B?{uri:`${u.assets.download.uri}&${B}=true`,fallbackUri:`${u.assets.download.fallbackUri}?${B}=true`}:u.assets.download,J=await this.getAsset(q);await this.fileService.writeFile(D,J.stream),z(new Date().getTime()-M)}async getReadme(u,D){if(u.assets.readme){const L=await this.getAsset(u.assets.readme,{},D);return await(0,R.asText)(L)||""}return""}async getManifest(u,D){if(u.assets.manifest){const L=await this.getAsset(u.assets.manifest,{},D),k=await(0,R.asText)(L);return k?JSON.parse(k):null}return null}async getCoreTranslation(u,D){const L=u.assets.coreTranslations.filter(k=>k[0]===D.toUpperCase())[0];if(L){const k=await this.getAsset(L[1]),M=await(0,R.asText)(k);return M?JSON.parse(M):null}return null}async getChangelog(u,D){if(u.assets.changelog){const L=await this.getAsset(u.assets.changelog,{},D);return await(0,R.asText)(L)||""}return""}async getAllVersions(u,D){let L=new s().withFlags(S.IncludeVersions,S.IncludeFiles,S.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");u.identifier.uuid?L=L.withFilter(i.ExtensionId,u.identifier.uuid):L=L.withFilter(i.ExtensionName,u.identifier.id);const k=[],{galleryExtensions:M}=await this.queryGallery(L,O.CancellationToken.None);return M.length&&(D?await Promise.all(M[0].versions.map(async z=>{let B;try{B=await this.getEngine(z)}catch(q){}B&&(0,d.isEngineValid)(B,this.productService.version)&&k.push({version:z.version,date:z.lastUpdated})})):k.push(...M[0].versions.map(z=>({version:z.version,date:z.lastUpdated})))),k}async getAsset(u,D={},L=O.CancellationToken.None){const k=await this.commonHeadersPromise,M={type:"GET"},z=Object.assign(Object.assign({},k),D.headers||{});D=Object.assign(Object.assign(Object.assign({},D),M),{headers:z});const B=u.uri,q=u.fallbackUri,J=Object.assign(Object.assign({},D),{url:B});try{const Y=await this.requestService.request(J,L);if(Y.res.statusCode===200)return Y;const ie=await(0,R.asText)(Y);throw new Error(`Expected 200, got back ${Y.res.statusCode} instead.

${ie}`)}catch(Y){if((0,m.isPromiseCanceledError)(Y))throw Y;const ie=(0,m.getErrorMessage)(Y);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:B,message:ie});const re=Object.assign(Object.assign({},D),{url:q});return this.requestService.request(re,L)}}async getLastValidExtensionVersion(u,D){const L=this.getLastValidExtensionVersionFromProperties(u,D);return L||this.getLastValidExtensionVersionRecursively(u,D)}getLastValidExtensionVersionFromProperties(u,D){for(const L of D){const k=X(L);if(!k)return null;if((0,d.isEngineValid)(k,this.productService.version))return L}return null}async getEngine(u){const D=X(u);if(D)return D;const L=j(u,e.Manifest);if(!L)throw new Error("Manifest was not found");const k={"Accept-Encoding":"gzip"},M=await this.getAsset(L,{headers:k}),z=await(0,R.asJson)(M);if(z)return z.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(u,D){if(!D.length)return null;const L=D[0],k=await this.getEngine(L);return(0,d.isEngineValid)(k,this.productService.version)?(L.properties=L.properties||[],L.properties.push({key:n.Engine,value:k}),L):this.getLastValidExtensionVersionRecursively(u,D.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const u=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(u.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,R.asJson)(u),L=new Map;if(D)for(const k of D.malicious){const M=L.get(k)||{id:{id:k},malicious:!0,slow:!1};M.malicious=!0,L.set(k,M)}return[...L.values()]}};G=ue([ce(0,R.IRequestService),ce(1,h.ILogService),ce(2,f.IEnvironmentService),ce(3,T.ITelemetryService),ce(4,E.IFileService),ce(5,l.IProductService),ce(6,(0,y.optional)(v.IStorageService))],G),t.ExtensionGalleryService=G;async function _(c,u,D,L){const k={"X-Market-Client-Id":`VSCode ${c}`,"User-Agent":`VSCode ${c}`},M=await(0,p.getServiceMachineId)(u,D,L);return k["X-Market-User-Id"]=M,k}t.resolveMarketplaceHeaders=_}),define(Q[119],Z([0,1,54,85,21,7,27,31,2,22,26]),function($,t,m,C,b,w,T,R,d,f,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let h=class{constructor(l,v){this._configurationService=v,this._experimentProperties={},this._disposables=new d.DisposableStore,this._cleanupPatterns=[],this._appender=l.appender,this._commonProperties=l.commonProperties||Promise.resolve({}),this._piiPaths=l.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,b.escapeRegExpCharacters)(p),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(p=>{const y=/^[a-f0-9]+$/i.test(p["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!y})}))}setExperimentProperty(l,v){this._experimentProperties[l]=v}setEnabled(l){this._enabled=l}_updateUserOptIn(){var l;const v=(l=this._configurationService)===null||l===void 0?void 0:l.getValue(E);this._userOptIn=v?v.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const l=await this._commonProperties;let v=l.sessionID,p=l["common.instanceId"],y=l["common.machineId"],I=l["common.firstSessionDate"],S=l["common.msftInternal"];return{sessionId:v,instanceId:p,machineId:y,firstSessionDate:I,msftInternal:S}}dispose(){this._disposables.dispose()}publicLog(l,v,p){return this.isOptedIn?this._commonProperties.then(y=>{v=(0,f.mixin)(v,y),v=(0,f.mixin)(v,this._experimentProperties),v=(0,f.cloneAndChange)(v,I=>{if(typeof I=="string")return this._cleanupInfo(I,p)}),this._appender.log(l,v)},y=>{console.error(y)}):Promise.resolve(void 0)}publicLog2(l,v,p){return this.publicLog(l,v,p)}publicLogError(l,v){return this.sendErrorTelemetry?this.publicLog(l,v,!0):Promise.resolve(void 0)}publicLogError2(l,v){return this.publicLogError(l,v)}_cleanupInfo(l,v){let p=l;if(v){const y=[];for(let i of this._cleanupPatterns)for(;;){const e=i.exec(l);if(!e)break;y.push([e.index,i.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(p="";;){const i=S.exec(l);if(!i)break;!I.test(i[0])&&y.every(([e,n])=>i.index<e||i.index>=n)&&(p+=l.substring(o,i.index)+"<REDACTED: user-file-path>",o=S.lastIndex)}o<l.length&&(p+=l.substr(o))}for(let y of this._cleanupPatterns)p=p.replace(y,"");return p}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=ue([ce(1,(0,w.optional)(T.IConfigurationService))],h),t.TelemetryService=h;const E="telemetry";O.Registry.as(R.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,C.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,C.localize)(2,null,m.default.privacyStatementUrl):(0,C.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Q[55],Z([0,1,27,22,8,4]),function($,t,m,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(l,v){return Promise.resolve(void 0)}publicLog2(l,v){return this.publicLog(l,v)}publicLogError(l,v){return Promise.resolve(void 0)}publicLogError2(l,v){return this.publicLogError(l,v)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(v,p,y){}async publicLogError(v,p,y){}}t.NullEndpointTelemetryService=T;function R(...l){return{log:(v,p)=>l.forEach(y=>y.log(v,p)),flush:()=>w.Promises.settled(l.map(v=>v.flush()))}}t.combinedAppender=R,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(l,v){return v.onDidChangeConfiguration(p=>{p.source!==6&&l.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(p.source),configurationKeys:E(p.sourceConfig)})})}t.configurationTelemetry=d;function f(l){const v=Object.create(null),p=Object.create(null),y=Object.create(null);h(l,y);for(let I in y){I=I.length>150?I.substr(I.length-149):I;const S=y[I];typeof S=="number"?p[I]=S:typeof S=="boolean"?p[I]=S?1:0:typeof S=="string"?v[I]=S.substring(0,1023):typeof S!="undefined"&&S!==null&&(v[I]=S)}return{properties:v,measurements:p}}t.validateTelemetryData=f;function O(l){if(!l)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(y=>{l.indexOf(`${y}+`)===0&&(v=y)}),v}t.cleanRemoteAuthority=O;function h(l,v,p=0,y){if(!!l)for(let I of Object.getOwnPropertyNames(l)){const S=l[I],o=y?y+I:I;Array.isArray(S)?v[o]=(0,C.safeStringify)(S):S instanceof Date?v[o]=S.toISOString():(0,b.isObject)(S)?p<2?h(S,v,p+1,o+"."):v[o]=(0,C.safeStringify)(S):v[o]=S}}function E(l){if(!l)return[];const v=[];return P(v,"",l),v}function P(l,v,p){p&&typeof p=="object"&&!Array.isArray(p)?Object.keys(p).forEach(y=>P(l,v?`${v}.${y}`:y,p[y])):l.push(v)}}),define(Q[120],Z([0,1,15,22,55]),function($,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function w(R){const d=await new Promise((O,h)=>{$(["applicationinsights"],O,h)});let f;return d.defaultClient?(f=new d.TelemetryClient(R),f.channel.setUseDiskRetryCaching(!0)):(d.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),f=d.defaultClient),R.indexOf("AIF-")===0&&(f.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),f}class T{constructor(d,f,O){this._eventPrefix=d,this._defaultData=f,this._defaultData||(this._defaultData=Object.create(null)),typeof O=="function"?this._aiClient=O():this._aiClient=O,this._asyncAIClient=null}_withAIClient(d){if(!!this._aiClient){if(typeof this._aiClient!="string"){d(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=w(this._aiClient)),this._asyncAIClient.then(f=>{d(f)},f=>{(0,m.onUnexpectedError)(f),console.error(f)})}}log(d,f){!this._aiClient||(f=(0,C.mixin)(f,this._defaultData),f=(0,b.validateTelemetryData)(f),this._withAIClient(O=>O.trackEvent({name:this._eventPrefix+"/"+d,properties:f.properties,measurements:f.measurements})))}flush(){return this._aiClient?new Promise(d=>{this._withAIClient(f=>{f.flush({callback:()=>{this._aiClient=void 0,d(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(Q[121],Z([0,1,12,16,3]),function($,t,m,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function w(T,R){const d=Object.create(null),f=(h,E)=>{const P=JSON.parse(h);d[E]=P};if(R){const h=(0,m.readdirSync)(R).filter(P=>{try{return(0,C.statSync)((0,b.join)(R,P)).isDirectory()}catch(l){return!1}}),E=[];h.forEach(P=>{(0,m.readdirSync)((0,b.join)(R,P)).filter(v=>v==="telemetry.json").length===1&&E.push(P)}),E.forEach(P=>{const l=(0,C.readFileSync)((0,b.join)(R,P,"telemetry.json")).toString();f(l,P)})}let O=(0,C.readFileSync)((0,b.join)(T,"telemetry-core.json")).toString();return f(O,"vscode-core"),O=(0,C.readFileSync)((0,b.join)(T,"telemetry-extensions.json")).toString(),f(O,"vscode-extensions"),JSON.stringify(d,null,4)}t.buildTelemetryMessage=w}),define(Q[43],Z([0,1,73,3,16,4,12,133,134,8]),function($,t,m,C,b,w,T,R,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class O extends Error{constructor(e,n){let r=n.message;switch(e){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=e,this.cause=n}}t.ExtractError=O;function h(i){const e=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,r)=>n+r,e&61440)}function E(i){if(i instanceof O)return i;let e;return/end of central directory record signature not found/.test(i.message)&&(e="CorruptZip"),new O(e,i)}function P(i,e,n,r,a,s){const g=C.dirname(e),F=C.join(r,g);if(!F.startsWith(r))return Promise.reject(new Error(m.localize(0,null,e)));const U=C.join(r,e);let N;return s.onCancellationRequested(()=>{N&&N.destroy()}),Promise.resolve(b.promises.mkdir(F,{recursive:!0})).then(()=>new Promise((A,j)=>{if(!s.isCancellationRequested)try{N=(0,b.createWriteStream)(U,{mode:n}),N.once("close",()=>A()),N.once("error",j),i.once("error",j),i.pipe(N)}catch(x){j(x)}}))}function l(i,e,n,r){let a=(0,w.createCancelablePromise)(()=>Promise.resolve()),s=0;return r.onCancellationRequested(()=>{a.cancel(),i.close()}),new Promise((g,F)=>{const U=new w.Sequencer,N=A=>{A.isCancellationRequested||(s++,i.readEntry())};i.once("error",F),i.once("close",()=>a.then(()=>{r.isCancellationRequested||i.entryCount===s?g():F(new O("Incomplete",new Error(m.localize(1,null,s,i.entryCount))))},F)),i.readEntry(),i.on("entry",A=>{if(!r.isCancellationRequested){if(!n.sourcePathRegex.test(A.fileName)){N(r);return}const j=A.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(j)){const ne=C.join(e,j);a=(0,w.createCancelablePromise)(ee=>b.promises.mkdir(ne,{recursive:!0}).then(()=>N(ee)).then(void 0,F));return}const x=p(i,A),X=h(A);a=(0,w.createCancelablePromise)(ne=>U.queue(()=>x.then(ee=>P(ee,j,X,e,n,ne).then(()=>N(ne)))).then(null,F))}})})}function v(i,e=!1){return new Promise((n,r)=>{(0,R.open)(i,e?{lazyEntries:!0}:void 0,(a,s)=>{a?r(E(a)):n((0,f.assertIsDefined)(s))})})}function p(i,e){return new Promise((n,r)=>{i.openReadStream(e,(a,s)=>{a?r(E(a)):n((0,f.assertIsDefined)(s))})})}function y(i,e){return new Promise((n,r)=>{const a=new d.ZipFile;e.forEach(g=>{g.contents?a.addBuffer(typeof g.contents=="string"?Buffer.from(g.contents,"utf8"):g.contents,g.path):g.localPath&&a.addFile(g.localPath,g.path)}),a.end();const s=(0,b.createWriteStream)(i);a.outputStream.pipe(s),a.outputStream.once("error",r),s.once("error",r),s.once("finish",()=>n(i))})}t.zip=y;function I(i,e,n={},r){const a=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let s=v(i,!0);return n.overwrite&&(s=s.then(g=>(0,T.rimraf)(e).then(()=>g))),s.then(g=>l(g,e,{sourcePathRegex:a},r))}t.extract=I;function S(i,e){return v(i).then(n=>new Promise((r,a)=>{n.on("entry",s=>{s.fileName===e&&p(n,s).then(g=>r(g),g=>a(g))}),n.once("close",()=>a(new Error(m.localize(2,null,e))))}))}function o(i,e){return S(i,e).then(n=>new Promise((r,a)=>{const s=[];n.once("error",a),n.on("data",g=>s.push(g)),n.on("end",()=>r(Buffer.concat(s)))}))}t.buffer=o}),define(Q[122],Z([0,1,43,78]),function($,t,m,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(w){return(0,m.buffer)(w,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(R){throw new Error((0,C.localize)(0,null))}})}t.getManifest=b}),define(Q[123],Z([0,1,16,40,2,12,3,13,24,25,4,9,19,89,79,41,43,14,23,10,20,18,30,15]),function($,t,m,C,b,w,T,R,d,f,O,h,E,P,l,v,p,y,I,S,o,i,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const r="scanningSystem",a="scanningUser",s="extracting",g="deleting",F="renaming";let U=class extends b.Disposable{constructor(A,j,x,X,ne){super();this.beforeRemovingExtension=A,this.fileService=j,this.logService=x,this.environmentService=X,this.productService=ne,this._devSystemExtensionsPath=null,this.systemExtensionsPath=X.builtinExtensionsPath,this.extensionsPath=X.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new O.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(A){const j=[];(A===null||A===0)&&j.push(this.scanSystemExtensions().then(null,x=>Promise.reject(new d.ExtensionManagementError(this.joinErrors(x).message,r)))),(A===null||A===1)&&j.push(this.scanUserExtensions(!0).then(null,x=>Promise.reject(new d.ExtensionManagementError(this.joinErrors(x).message,a))));try{const x=await Promise.all(j);return(0,I.flatten)(x)}catch(x){throw this.joinErrors(x)}}async scanUserExtensions(A){this.logService.trace("Started scanning user extensions");let[j,x]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return x=x.filter(X=>!j[new f.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).key()]),A&&(x=(0,f.groupByExtension)(x,ne=>ne.identifier).map(ne=>ne.sort((ee,te)=>C.rcompare(ee.manifest.version,te.manifest.version))[0])),this.logService.trace("Scanned user extensions:",x.length),x}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(A,j,x){const X=A.key(),ne=T.join(this.extensionsPath,`.${(0,e.generateUuid)()}`),ee=T.join(this.extensionsPath,X);try{await w.rimraf(ee)}catch(ae){try{await w.rimraf(ee)}catch(W){}throw new d.ExtensionManagementError((0,l.localize)(0,null,ee,A.id),g)}await this.extractAtLocation(A,j,ne,x);let te=await this.scanExtension(h.URI.file(ne),1);if(!te)throw new Error((0,l.localize)(1,null,ne));await this.storeMetadata(te,{installedTimestamp:Date.now()});try{await this.rename(A,ne,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(ae){try{await w.rimraf(ne)}catch(W){}if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(ae)}. Deleted from extracted location`,ne),ae}try{te=await this.scanExtension(h.URI.file(ee),1)}catch(ae){}if(te)return te;throw new Error((0,l.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(A,j){return this.setMetadata(A,j),await this.storeMetadata(A,Object.assign(Object.assign({},j),{installedTimestamp:A.installedTimestamp})),A}async storeMetadata(A,j){j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0;const x=T.join(A.location.fsPath,"package.json"),X=await m.promises.readFile(x,"utf8"),{manifest:ne}=await this.parseManifest(X);return ne.__metadata=j,await w.writeFile(x,JSON.stringify(ne,null,"	")),A}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const j=A.map(x=>new f.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version));await this.withUninstalledExtensions(x=>{j.forEach(X=>x[X.key()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(X=>delete X[A.key()]);const x=(await this.scanExtensions(1)).find(X=>new f.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).equals(A))||null;return x?(await this.storeMetadata(x,{installedTimestamp:Date.now()}),this.scanExtension(x.location,1)):null}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let j;try{j=await m.promises.readFile(this.uninstalledPath,"utf8")}catch(X){if(X.code!=="ENOENT")throw X}let x={};if(j)try{x=JSON.parse(j)}catch(X){}return A&&(A(x),Object.keys(x).length?await w.writeFile(this.uninstalledPath,JSON.stringify(x)):await w.rimraf(this.uninstalledPath)),x})}async removeExtension(A,j){this.logService.trace(`Deleting ${j} extension from disk`,A.identifier.id,A.location.fsPath),await w.rimraf(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(j=>delete j[new f.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version).key()])}async extractAtLocation(A,j,x,X){this.logService.trace(`Started extracting the extension from ${j} to ${x}`);try{await w.rimraf(x)}catch(ne){throw new d.ExtensionManagementError(this.joinErrors(ne).message,g)}try{await(0,p.extract)(j,x,{sourcePath:"extension",overwrite:!0},X),this.logService.info(`Extracted extension to ${x}:`,A.id)}catch(ne){try{await w.rimraf(x)}catch(ee){}throw new d.ExtensionManagementError(ne.message,ne instanceof p.ExtractError&&ne.type?ne.type:s)}}async rename(A,j,x,X){try{await m.promises.rename(j,x)}catch(ne){if(y.isWindows&&ne&&ne.code==="EPERM"&&Date.now()<X)return this.logService.info(`Failed renaming ${j} to ${x} with 'EPERM' error. Trying again...`,A.id),this.rename(A,j,x,X);throw new d.ExtensionManagementError(ne.message||(0,l.localize)(3,null,j,x),ne.code||F)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const A=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return A;const j=this.scanDevSystemExtensions(),[x,X]=await Promise.all([A,j]);return[...x,...X]}async scanExtensionsInDir(A,j){const x=new O.Limiter(10),X=await this.fileService.resolve(h.URI.file(A));return X.children?(await Promise.all(X.children.filter(ee=>ee.isDirectory).map(ee=>x.queue(async()=>j===1&&(0,i.basename)(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,j))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(A,j){var x,X;try{const ne=await this.fileService.resolve(A);if(ne.children){const{manifest:ee,metadata:te}=await this.readManifest(A.fsPath),ae=(x=ne.children.find(({name:c})=>/^readme(\.txt|\.md|)$/i.test(c)))===null||x===void 0?void 0:x.resource,W=(X=ne.children.find(({name:c})=>/^changelog(\.txt|\.md|)$/i.test(c)))===null||X===void 0?void 0:X.resource,G={id:(0,f.getGalleryExtensionId)(ee.publisher,ee.name)},_={type:j,identifier:G,manifest:ee,location:A,readmeUrl:ae,changelogUrl:W,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:j===0};return te&&(this.setMetadata(_,te),_.installedTimestamp=te.installedTimestamp),_}}catch(ne){j!==0&&this.logService.trace(ne)}return null}async scanDefaultSystemExtensions(){const A=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",A.length),A}async scanDevSystemExtensions(){const A=this.getDevSystemExtensionsList();if(A.length){const j=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",j.length),j.filter(x=>A.some(X=>(0,f.areSameExtensions)(x.identifier,{id:X})))}else return[]}setMetadata(A,j){A.publisherDisplayName=j.publisherDisplayName||null,A.publisherId=j.publisherId||null,A.identifier.uuid=j.id,A.isMachineScoped=!!j.isMachineScoped,A.isBuiltin=A.type===0||!!j.isBuiltin}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),j=await this.scanAllUserExtensions(),x=new Set;for(const ee of j)A[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||x.add(ee.identifier.id.toLowerCase());const X=(0,f.groupByExtension)(j,ee=>ee.identifier);await O.Promises.settled(X.map(async ee=>{const te=ee.sort((ae,W)=>C.rcompare(ae.manifest.version,W.manifest.version))[0];x.has(te.identifier.id.toLowerCase())||await this.beforeRemovingExtension(te)}));const ne=j.filter(ee=>A[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await O.Promises.settled(ne.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const A=await this.scanAllUserExtensions(),j=[],x=(0,f.groupByExtension)(A,X=>X.identifier);j.push(...(0,I.flatten)(x.map(X=>X.sort((ne,ee)=>C.rcompare(ne.manifest.version,ee.manifest.version)).slice(1)))),await O.Promises.settled(j.map(X=>this.removeExtension(X,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(A=>A.name)}joinErrors(A){const j=Array.isArray(A)?A:[A];return j.length===1?j[0]instanceof Error?j[0]:new Error(j[0]):j.reduce((x,X)=>new Error(`${x.message}${x.message?",":""}${X instanceof Error?X.message:X}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(S.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(A){const j=[m.promises.readFile(T.join(A,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),m.promises.readFile(T.join(A,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:x,metadata:X},ne]=await Promise.all(j);return{manifest:(0,P.localizeManifest)(x,ne),metadata:X}}parseManifest(A){return new Promise((j,x)=>{try{const X=JSON.parse(A),ne=X.__metadata||null;j({manifest:X,metadata:ne})}catch(X){x(new Error((0,l.localize)(4,null)))}})}};U=ue([ce(1,o.IFileService),ce(2,R.ILogService),ce(3,E.INativeEnvironmentService),ce(4,v.IProductService)],U),t.ExtensionsScanner=U}),define(Q[124],Z([0,1,16,77,3,12,2,23,43,24,25,19,4,11,40,9,54,14,13,96,29,42,48,18,30,95,7,10,28,122,101,123,102,103,20]),function($,t,m,C,b,w,T,R,d,f,O,h,E,P,l,v,p,y,I,S,o,i,e,n,r,a,s,g,F,U,N,A,j,x,X){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const ne="unsetUninstalled",ee="downloading",te="validating",ae="local",W="unknown";let G=class extends T.Disposable{constructor(c,u,D,L,k,M,z){super();this.environmentService=c,this.galleryService=u,this.logService=D,this.downloadService=L,this.telemetryService=k,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new P.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new P.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new P.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new P.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const B=this._register(M.createInstance(j.ExtensionsLifecycle));this.extensionsScanner=this._register(M.createInstance(A.ExtensionsScanner,J=>B.postUninstall(J))),this.manifestCache=this._register(new S.ExtensionsManifestCache(c,this)),this.extensionsDownloader=this._register(M.createInstance(N.ExtensionsDownloader));const q=this._register(new x.ExtensionsWatcher(this,z,c,D));this._register(q.onDidChangeExtensionsByAnotherSource(({added:J,removed:Y})=>{J.forEach(ie=>this._onDidInstallExtension.fire({identifier:ie.identifier,operation:0,local:ie})),Y.forEach(ie=>this._onDidUninstallExtension.fire({identifier:ie}))})),this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(J=>J.cancel()),this.uninstallingExtensions.forEach(J=>J.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(c){this.logService.trace("ExtensionManagementService#zip",c.identifier.id);const u=await this.collectFiles(c),D=await(0,d.zip)((0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)()).fsPath,u);return v.URI.file(D)}async unzip(c){return this.logService.trace("ExtensionManagementService#unzip",c.toString()),(await this.install(c)).identifier}async getManifest(c){const u=await this.downloadVsix(c),D=b.resolve(u.fsPath);return(0,U.getManifest)(D)}async collectFiles(c){const u=async L=>{let k=await w.readdir(L);k=k.map(B=>b.join(L,B));const M=await Promise.all(k.map(B=>m.promises.stat(B)));let z=Promise.resolve([]);return M.forEach((B,q)=>{const J=k[q];B.isFile()&&(z=z.then(Y=>[...Y,J])),B.isDirectory()&&(z=z.then(Y=>u(J).then(ie=>[...Y,...ie])))}),z};return(await u(c.location.fsPath)).map(L=>({path:`extension/${b.relative(c.location.fsPath,L)}`,localPath:L}))}async install(c,u={}){return this.logService.trace("ExtensionManagementService#install",c.toString()),(0,E.createCancelablePromise)(async D=>{const L=await this.downloadVsix(c),k=b.resolve(L.fsPath),M=await(0,U.getManifest)(k),z={id:(0,O.getGalleryExtensionId)(M.publisher,M.name)};let B=1;if(M.engines&&M.engines.vscode&&!(0,e.isEngineValid)(M.engines.vscode,p.default.version))throw new Error(C.localize(0,null,z.id,p.default.version));const q=new O.ExtensionIdentifierWithVersion(z,M.version),Y=(await this.getInstalled(1)).find(re=>(0,O.areSameExtensions)(z,re.identifier));if(Y)if(u.isMachineScoped=u.isMachineScoped||Y.isMachineScoped,u.isBuiltin=u.isBuiltin||Y.isBuiltin,B=2,q.equals(new O.ExtensionIdentifierWithVersion(Y.identifier,Y.manifest.version)))try{await this.extensionsScanner.removeExtension(Y,"existing")}catch(re){throw new Error(C.localize(1,null,M.displayName||M.name))}else l.gt(Y.manifest.version,M.version)&&await this.uninstallExtension(Y);else{const re=await this.unsetUninstalledAndGetLocal(q);if(re)try{await this.extensionsScanner.removeExtension(re,"existing")}catch(he){throw new Error(C.localize(2,null,M.displayName||M.name))}}this.logService.info("Installing the extension:",z.id),this._onInstallExtension.fire({identifier:z,zipPath:k});let ie;try{ie=await this.getGalleryMetadata((0,O.getGalleryExtensionId)(M.publisher,M.name))}catch(re){}try{const re=await this.installFromZipPath(q,k,Object.assign(Object.assign({},ie||{}),u),u,B,D);return this.logService.info("Successfully installed the extension:",z.id),re}catch(re){throw this.logService.error("Failed to install the extension:",z.id,re.message),re}})}async downloadVsix(c){if(c.scheme===g.Schemas.file)return c;if(!this.downloadService)throw new Error("Download service is not available");const u=(0,n.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)());return await this.downloadService.download(c,u),u}async installFromZipPath(c,u,D,L,k,M){try{const z=await this.installExtension({zipPath:u,identifierWithVersion:c,metadata:D},M);try{await this.installDependenciesAndPackExtensions(z,void 0,L)}catch(B){(0,R.isNonEmptyArray)(z.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",z.identifier.id,B.message),(0,R.isNonEmptyArray)(z.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",z.identifier.id,B.message)}return this._onDidInstallExtension.fire({identifier:c,zipPath:u,local:z,operation:k}),z}catch(z){throw this._onDidInstallExtension.fire({identifier:c,zipPath:u,operation:k,error:z}),z}}async canInstall(c){return!0}async installFromGallery(c,u={}){if(!this.galleryService.isEnabled())throw new Error(C.localize(3,null));try{c=await this.checkAndGetCompatibleVersion(c)}catch(k){const M=k&&k.code?k.code:W;throw this.logService.error("Failed to install extension:",c.identifier.id,k?k.message:M),this.reportTelemetry(this.getTelemetryEvent(1),(0,O.getGalleryExtensionTelemetryData)(c),void 0,k),k instanceof Error&&(k.name=M),k}const D=new O.ExtensionIdentifierWithVersion(c.identifier,c.version).key();let L=this.installingExtensions.get(D);return L||(L=(0,E.createCancelablePromise)(k=>this.doInstallFromGallery(c,u,k)),this.installingExtensions.set(D,L),L.finally(()=>this.installingExtensions.delete(D))),L}async doInstallFromGallery(c,u,D){const L=new Date().getTime();let k=1;this.logService.info("Installing extension:",c.identifier.id),this._onInstallExtension.fire({identifier:c.identifier,gallery:c});try{const z=(await this.getInstalled(1)).find(J=>(0,O.areSameExtensions)(J.identifier,c.identifier));z&&(k=2);const B=await this.downloadInstallableExtension(c,k);B.metadata.isMachineScoped=u.isMachineScoped||(z==null?void 0:z.isMachineScoped),B.metadata.isBuiltin=u.isBuiltin||(z==null?void 0:z.isBuiltin);const q=await this.installExtension(B,D);try{await this.extensionsDownloader.delete(v.URI.file(B.zipPath))}catch(J){}if(!u.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(q,z,u)}catch(J){try{await this.uninstall(q)}catch(Y){}throw J}return z&&l.neq(z.manifest.version,c.version)&&await this.extensionsScanner.setUninstalled(z),this.logService.info("Extensions installed successfully:",c.identifier.id),this._onDidInstallExtension.fire({identifier:c.identifier,gallery:c,local:q,operation:k}),this.reportTelemetry(this.getTelemetryEvent(k),(0,O.getGalleryExtensionTelemetryData)(c),new Date().getTime()-L,void 0),q}catch(M){const z=M&&M.code?M.code:W;throw this.logService.error("Failed to install extension:",c.identifier.id,M?M.message:z),this._onDidInstallExtension.fire({identifier:c.identifier,gallery:c,operation:k,error:z}),this.reportTelemetry(this.getTelemetryEvent(k),(0,O.getGalleryExtensionTelemetryData)(c),new Date().getTime()-L,M),M instanceof Error&&(M.name=z),M}}async checkAndGetCompatibleVersion(c){if(await this.isMalicious(c))throw new f.ExtensionManagementError(C.localize(4,null),f.INSTALL_ERROR_MALICIOUS);const u=await this.galleryService.getCompatibleExtension(c);if(!u)throw new f.ExtensionManagementError(C.localize(5,null,c.identifier.id,p.default.version),f.INSTALL_ERROR_INCOMPATIBLE);return u}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(6,null));const u=await this.findGalleryExtension(c);if(!u)throw new Error(C.localize(7,null));await this.extensionsScanner.setUninstalled(c);try{await this.extensionsScanner.removeUninstalledExtension(c)}catch(D){throw new Error(C.localize(8,null,(0,o.toErrorMessage)(D)))}await this.installFromGallery(u)}getTelemetryEvent(c){return c===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(c){const u=await this.getExtensionsReport();return(0,O.getMaliciousExtensionsSet)(u).has(c.identifier.id)}async downloadInstallableExtension(c,u){const D={id:c.identifier.uuid,publisherId:c.publisherId,publisherDisplayName:c.publisherDisplayName};let L;try{this.logService.trace("Started downloading extension:",c.identifier.id);const k=await this.extensionsDownloader.downloadExtension(c,u);this.logService.info("Downloaded extension:",c.identifier.id,L),L=k.fsPath}catch(k){throw new f.ExtensionManagementError(this.joinErrors(k).message,ee)}try{const k=await(0,U.getManifest)(L);return{zipPath:L,identifierWithVersion:new O.ExtensionIdentifierWithVersion(c.identifier,k.version),metadata:D}}catch(k){throw new f.ExtensionManagementError(this.joinErrors(k).message,te)}}async installExtension(c,u){try{const D=await this.unsetUninstalledAndGetLocal(c.identifierWithVersion);if(D)return c.metadata?this.extensionsScanner.saveMetadataForLocalExtension(D,c.metadata):D}catch(D){throw y.isMacintosh?new f.ExtensionManagementError(C.localize(9,null),ne):new f.ExtensionManagementError(C.localize(10,null),ne)}return this.extractAndInstall(c,u)}async unsetUninstalledAndGetLocal(c){if(!await this.isUninstalled(c))return null;this.logService.trace("Removing the extension from uninstalled list:",c.id);const D=await this.extensionsScanner.setInstalled(c);return this.logService.info("Removed the extension from uninstalled list:",c.id),D}async extractAndInstall({zipPath:c,identifierWithVersion:u,metadata:D},L){let k=await this.extensionsScanner.extractUserExtension(u,c,L);return this.logService.info("Installation completed.",u.id),D&&(k=await this.extensionsScanner.saveMetadataForLocalExtension(k,D)),k}async installDependenciesAndPackExtensions(c,u,D){if(!!this.galleryService.isEnabled()){const L=c.manifest.extensionDependencies||[];if(c.manifest.extensionPack)for(const k of c.manifest.extensionPack)u&&u.manifest.extensionPack&&u.manifest.extensionPack.some(M=>(0,O.areSameExtensions)({id:M},{id:k}))||L.every(M=>!(0,O.areSameExtensions)({id:M},{id:k}))&&L.push(k);if(L.length){const k=await this.getInstalled(),M=L.filter(z=>k.every(({identifier:B})=>!(0,O.areSameExtensions)(B,{id:z})));if(M.length){const B=(await this.galleryService.query({names:M,pageSize:L.length},F.CancellationToken.None)).firstPage;try{await E.Promises.settled(B.map(q=>this.installFromGallery(q,D)))}catch(q){try{await this.rollback(B)}catch(J){}throw q}}}}}async rollback(c){const D=(await this.getInstalled(1)).filter(L=>c.some(k=>new O.ExtensionIdentifierWithVersion(L.identifier,L.manifest.version).equals(new O.ExtensionIdentifierWithVersion(k.identifier,k.version))));await E.Promises.settled(D.map(L=>this.uninstall(L)))}async uninstall(c,u={}){this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id);const D=await this.getInstalled(1),L=D.find(k=>(0,O.areSameExtensions)(k.identifier,c.identifier));if(!L)throw new Error(C.localize(11,null,c.manifest.displayName||c.manifest.name));try{await this.checkForDependenciesAndUninstall(L,D,u)}catch(k){throw this.joinErrors(k)}}async updateMetadata(c,u){return this.logService.trace("ExtensionManagementService#updateMetadata",c.identifier.id),c=await this.extensionsScanner.saveMetadataForLocalExtension(c,Object.assign(Object.assign({},c.manifest.__metadata||{}),u)),this.manifestCache.invalidate(),c}async updateExtensionScope(c,u){return this.logService.trace("ExtensionManagementService#updateExtensionScope",c.identifier.id),c=await this.extensionsScanner.saveMetadataForLocalExtension(c,Object.assign(Object.assign({},c.manifest.__metadata||{}),{isMachineScoped:u})),this.manifestCache.invalidate(),c}async getGalleryMetadata(c){const u=await this.findGalleryExtensionByName(c);return u?{id:u.identifier.uuid,publisherDisplayName:u.publisherDisplayName,publisherId:u.publisherId}:void 0}async findGalleryExtension(c){if(c.identifier.uuid){const u=await this.findGalleryExtensionById(c.identifier.uuid);return u||this.findGalleryExtensionByName(c.identifier.id)}return this.findGalleryExtensionByName(c.identifier.id)}async findGalleryExtensionById(c){return(await this.galleryService.query({ids:[c],pageSize:1},F.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(c){return(await this.galleryService.query({names:[c],pageSize:1},F.CancellationToken.None)).firstPage[0]}joinErrors(c){const u=Array.isArray(c)?c:[c];return u.length===1?u[0]instanceof Error?u[0]:new Error(u[0]):u.reduce((D,L)=>new Error(`${D.message}${D.message?",":""}${L instanceof Error?L.message:L}`),new Error(""))}async checkForDependenciesAndUninstall(c,u,D){try{await this.preUninstallExtension(c);const L=D.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(c,u);await this.uninstallExtensions(c,L,u,D)}catch(L){throw await this.postUninstallExtension(c,new f.ExtensionManagementError(L instanceof Error?L.message:L,ae)),L}await this.postUninstallExtension(c)}async uninstallExtensions(c,u,D,L){const k=[c,...u];if(!L.donotCheckDependents)for(const M of k)this.checkForDependents(M,k,D,c);await E.Promises.settled([this.uninstallExtension(c),...u.map(M=>this.doUninstall(M))])}checkForDependents(c,u,D,L){const k=this.getDependents(c,D);if(k.length){const M=k.filter(z=>u.indexOf(z)===-1);if(M.length)throw new Error(this.getDependentsErrorMessage(c,M,L))}}getDependentsErrorMessage(c,u,D){return D===c?u.length===1?C.localize(12,null,D.manifest.displayName||D.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?C.localize(13,null,D.manifest.displayName||D.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):C.localize(14,null,D.manifest.displayName||D.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):u.length===1?C.localize(15,null,D.manifest.displayName||D.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?C.localize(16,null,D.manifest.displayName||D.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):C.localize(17,null,D.manifest.displayName||D.manifest.name,c.manifest.displayName||c.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name)}getAllPackExtensionsToUninstall(c,u,D=[]){if(D.indexOf(c)!==-1)return[];D.push(c);const L=c.manifest.extensionPack?c.manifest.extensionPack:[];if(L.length){const k=u.filter(z=>!z.isBuiltin&&L.some(B=>(0,O.areSameExtensions)({id:B},z.identifier))),M=[];for(const z of k)M.push(...this.getAllPackExtensionsToUninstall(z,u,D));return[...k,...M]}return[]}getDependents(c,u){return u.filter(D=>D.manifest.extensionDependencies&&D.manifest.extensionDependencies.some(L=>(0,O.areSameExtensions)({id:L},c.identifier)))}async doUninstall(c){try{await this.preUninstallExtension(c),await this.uninstallExtension(c)}catch(u){throw await this.postUninstallExtension(c,new f.ExtensionManagementError(u instanceof Error?u.message:u,ae)),u}await this.postUninstallExtension(c)}async preUninstallExtension(c){if(!await w.exists(c.location.fsPath))throw new Error(C.localize(18,null));this.logService.info("Uninstalling extension:",c.identifier.id),this._onUninstallExtension.fire(c.identifier)}async uninstallExtension(c){let u=this.uninstallingExtensions.get(c.identifier.id);return u||(u=(0,E.createCancelablePromise)(async()=>{const D=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...D.filter(L=>(0,O.areSameExtensions)(L.identifier,c.identifier)))}),this.uninstallingExtensions.set(c.identifier.id,u),u.finally(()=>this.uninstallingExtensions.delete(c.identifier.id))),u}async postUninstallExtension(c,u){if(u)this.logService.error("Failed to uninstall extension:",c.identifier.id,u.message);else if(this.logService.info("Successfully uninstalled extension:",c.identifier.id),c.identifier.uuid)try{await this.galleryService.reportStatistic(c.manifest.publisher,c.manifest.name,c.manifest.version,"uninstall")}catch(L){}this.reportTelemetry("extensionGallery:uninstall",(0,O.getLocalExtensionTelemetryData)(c),void 0,u);const D=u?u instanceof f.ExtensionManagementError?u.code:W:void 0;this._onDidUninstallExtension.fire({identifier:c.identifier,error:D})}getInstalled(c=null){return this.extensionsScanner.scanExtensions(c)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(c){return(await this.filterUninstalled(c)).length===1}async filterUninstalled(...c){const u=[],D=await this.extensionsScanner.getUninstalledExtensions();for(const L of c)D[L.key()]&&u.push(L.key());return u}getExtensionsReport(){const c=new Date().getTime();return(!this.reportedExtensions||c-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=c),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${c.length} reported extensions from service`),c}catch(c){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(c,u,D,L){const k=L?L instanceof f.ExtensionManagementError?L.code:W:void 0;this.telemetryService.publicLogError(c,Object.assign(Object.assign({},u),{success:!L,duration:D,errorcode:k}))}};G=ue([ce(0,h.INativeEnvironmentService),ce(1,f.IExtensionGalleryService),ce(2,I.ILogService),ce(3,(0,s.optional)(a.IDownloadService)),ce(4,i.ITelemetryService),ce(5,s.IInstantiationService),ce(6,X.IFileService)],G),t.ExtensionManagementService=G}),define(Q[125],Z([0,1,135,112,2,8,15,111,27,13,17,19,97]),function($,t,m,C,b,w,T,R,d,f,O,h,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let P=class extends b.Disposable{constructor(v,p,y){super();this.environmentService=p,this.logService=y,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,p){this.logService.trace("RequestService#request",v.url);const{proxyUrl:y,strictSSL:I}=this,S=v.agent?v.agent:await(0,R.getProxyAgent)(v.url||"",await(0,E.resolveShellEnv)(this.logService,this.environmentService.args,process.env),{proxyUrl:y,strictSSL:I});return v.agent=S,v.strictSSL=I,this.authorization&&(v.headers=Object.assign(Object.assign({},v.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(v,p)}async getNodeRequest(v){return((0,C.parse)(v.url).protocol==="https:"?await new Promise((I,S)=>{$(["https"],I,S)}):await new Promise((I,S)=>{$(["http"],I,S)})).request}_request(v,p){return new Promise(async(y,I)=>{let S;const o=(0,C.parse)(v.url),i=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,w.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(e.auth=v.user+":"+v.password),S=i(e,n=>{const r=(0,w.isNumber)(v.followRedirects)?v.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&r>0&&n.headers.location)this._request(Object.assign(Object.assign({},v),{url:n.headers.location,followRedirects:r-1}),p).then(y,I);else{let a=n;n.headers["content-encoding"]==="gzip"&&(a=n.pipe((0,m.createGunzip)())),y({res:n,stream:(0,O.streamToBufferReadableStream)(a)})}}),S.on("error",I),v.timeout&&S.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&S.write(v.data),S.end(),p.onCancellationRequested(()=>{S.abort(),I((0,T.canceled)())})})}async resolveProxy(v){}};P=ue([ce(0,d.IConfigurationService),ce(1,h.INativeEnvironmentService),ce(2,f.ILogService)],P),t.RequestService=P}),define(Q[136],Z([0,1,32,16,137,3,4,54,52,49,99,19,88,24,124,118,42,55,119,117,53,125,27,110,120,114,115,13,10,107,121,104,20,105,2,41,100,9,106,39,15,29,17,37]),function($,t,m,C,b,w,T,R,d,f,O,h,E,P,l,v,p,y,I,S,o,i,e,n,r,a,s,g,F,U,N,A,j,x,X,ne,ee,te,ae,W,G,_,c,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class D extends X.Disposable{constructor(M){super();this.argv=M,(0,b.gracefulify)(C),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[M,z]=await this.initServices();return M.invokeFunction(async B=>{const q=B.get(g.ILogService),J=B.get(j.IFileService),Y=B.get(h.INativeEnvironmentService),ie=B.get(P.IExtensionManagementCLIService);return q.info("CLI main",this.argv),this.registerErrorHandler(q),await this.doRun(Y,ie,J),(0,T.raceTimeout)((0,y.combinedAppender)(...z).flush(),1e3)})}async initServices(){const M=new d.ServiceCollection,z=Object.assign({_serviceBrand:void 0},R.default);M.set(ne.IProductService,z);const B=new E.NativeEnvironmentService(this.argv,z);M.set(h.INativeEnvironmentService,B),await Promise.all([B.appSettingsHome.fsPath,B.extensionsPath].map(Se=>Se?C.promises.mkdir(Se,{recursive:!0}):void 0));const q=(0,g.getLogLevel)(B),J=[];J.push(new U.SpdLogLogger("cli",(0,w.join)(B.logsPath,"cli.log"),!0,q)),q===g.LogLevel.Trace&&J.push(new g.ConsoleLogger(q));const Y=this._register(new g.MultiplexLogService(J));M.set(g.ILogService,Y);const ie=this._register(new A.FileService(Y));M.set(j.IFileService,ie);const re=this._register(new x.DiskFileSystemProvider(Y));ie.registerProvider(F.Schemas.file,re);const he=this._register(new n.ConfigurationService(B.settingsResource,ie));M.set(e.IConfigurationService,he),await he.initialize();const ge=new s.StateService(B,Y);M.set(a.IStateService,ge);const{appRoot:De,extensionsPath:Oe,extensionDevelopmentLocationURI:Fe,isBuilt:Re,installSourcePath:Me}=B;M.set(o.IRequestService,new f.SyncDescriptor(i.RequestService)),M.set(P.IExtensionManagementService,new f.SyncDescriptor(l.ExtensionManagementService)),M.set(P.IExtensionGalleryService,new f.SyncDescriptor(v.ExtensionGalleryService)),M.set(P.IExtensionManagementCLIService,new f.SyncDescriptor(ee.ExtensionManagementCLIService)),M.set(W.ILocalizationsService,new f.SyncDescriptor(ae.LocalizationsService));const ve=[];if(Re&&!Fe&&!B.disableTelemetry&&z.enableTelemetry){z.aiConfig&&z.aiConfig.asimovKey&&ve.push(new r.AppInsightsAppender("monacoworkbench",null,z.aiConfig.asimovKey));const Se={appender:(0,y.combinedAppender)(...ve),sendErrorTelemetry:!1,commonProperties:(0,S.resolveCommonProperties)(ie,(0,m.release)(),process.arch,z.commit,z.version,ge.getItem("telemetry.machineId"),z.msftInternalDomains,Me),piiPaths:[De,Oe]};M.set(p.ITelemetryService,new f.SyncDescriptor(I.TelemetryService,[Se]))}else M.set(p.ITelemetryService,y.NullTelemetryService);return[new O.InstantiationService(M),ve]}registerErrorHandler(M){(0,G.setUnexpectedErrorHandler)(z=>{const B=(0,_.toErrorMessage)(z,!0);!B||M.error(`[uncaught exception in CLI]: ${B}`)})}async doRun(M,z,B){if(this.argv["install-source"])return this.setInstallSource(M,B,this.argv["install-source"]);if(this.argv["list-extensions"])return z.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return z.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return z.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return z.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log((0,N.buildTelemetryMessage)(M.appRoot,M.extensionsPath))}asExtensionIdOrVSIX(M){return M.map(z=>/\.vsix$/i.test(z)?te.URI.file((0,w.isAbsolute)(z)?z:(0,w.join)((0,u.cwd)(),z)):z)}async setInstallSource(M,z,B){await z.writeFile(te.URI.file(M.installSourcePath),c.VSBuffer.fromString(B.slice(0,30)))}}async function L(k){const M=new D(k);try{await M.run()}finally{M.dispose()}}t.main=L})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8437d38d364ba93b53c1e659c20b1c86f710ec28/core/vs/code/node/cliProcessMain.js.map
