/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/network","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/process","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],we=function(ae){for(var e=[],E=0,S=ae.length;E<S;E++)e[E]=be[ae[E]];return e};define(be[43],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(S,R){if(!S)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=E}),define(be[50],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const E=Object.prototype.hasOwnProperty;function S(T){const k=[];for(let b in T)E.call(T,b)&&k.push(T[b]);return k}e.values=S;function R(T,k){for(let b in T)if(E.call(T,b)&&k({key:b,value:T[b]},function(){delete T[b]})===!1)return}e.forEach=R;function A(T,k){const b=Object.create(null);for(const m of T){const r=k(m);let d=b[r];d||(d=b[r]=[]),d.push(m)}return b}e.groupBy=A;function D(T){const k=Object.create(null);return T&&T.forEach((b,m)=>{k[m]=b}),k}e.fromMap=D;function I(T,k){const b=[],m=[];for(let r of T)k.has(r)||b.push(r);for(let r of k)T.has(r)||m.push(r);return{removed:b,added:m}}e.diffSets=I;function y(T,k){const b=[],m=[];for(let[r,d]of T)k.has(r)||b.push(d);for(let[r,d]of k)T.has(r)||m.push(d);return{removed:b,added:m}}e.diffMaps=y;class n{constructor(){this.map=new Map}add(k,b){let m=this.map.get(k);m||(m=new Set,this.map.set(k,m)),m.add(b)}delete(k,b){const m=this.map.get(k);!m||(m.delete(b),m.size===0&&this.map.delete(k))}forEach(k,b){const m=this.map.get(k);!m||m.forEach(b)}}e.SetMap=n}),define(be[51],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function E(y){return(n,T,k)=>{let b=null,m=null;if(typeof k.value=="function"?(b="value",m=k.value):typeof k.get=="function"&&(b="get",m=k.get),!m)throw new Error("not supported");k[b]=y(m,T)}}e.createDecorator=E;let S=0;function R(){const y=`$memoize${S++}`;let n;const T=function(b,m,r){let d=null,_=null;if(typeof r.value=="function"?(d="value",_=r.value,_.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof r.get=="function"&&(d="get",_=r.get),!_)throw new Error("not supported");const g=`${y}:${m}`;r[d]=function(...w){return n=this,this.hasOwnProperty(g)||Object.defineProperty(this,g,{configurable:!0,enumerable:!1,writable:!0,value:_.apply(this,w)}),this[g]}};return T.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(k=>{k.indexOf(y)===0&&delete n[k]})},T}e.createMemoizer=R;function A(y,n,T){return R()(y,n,T)}e.memoize=A;function D(y,n,T){return E((k,b)=>{const m=`$debounce$${b}`,r=`$debounce$result$${b}`;return function(...d){this[r]||(this[r]=T?T():void 0),clearTimeout(this[m]),n&&(this[r]=n(this[r],...d),d=[this[r]]),this[m]=setTimeout(()=>{k.apply(this,d),this[r]=T?T():void 0},y)}})}e.debounce=D;function I(y,n,T){return E((k,b)=>{const m=`$throttle$timer$${b}`,r=`$throttle$result$${b}`,d=`$throttle$lastRun$${b}`,_=`$throttle$pending$${b}`;return function(...g){if(this[r]||(this[r]=T?T():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),n&&(this[r]=n(this[r],...g)),!this[_]){const w=this[d]+y;w<=Date.now()?(this[d]=Date.now(),k.apply(this,[this[r]]),this[r]=T?T():void 0):(this[_]=!0,this[m]=setTimeout(()=>{this[_]=!1,this[d]=Date.now(),k.apply(this,[this[r]]),this[r]=T?T():void 0},w-Date.now()))}}})}e.throttle=I}),define(be[10],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function S(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=S;function R(s){y(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=R;function A(s){y(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=A;function D(s){if(s instanceof Error){let{name:t,message:i}=s;const l=s.stacktrace||s.stack;return{$isError:!0,name:t,message:i,stack:l}}return s}e.transformErrorForSerialization=D;const I="Canceled";function y(s){return s instanceof Error&&s.name===I&&s.message===I}e.isPromiseCanceledError=y;class n extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=n;function T(){const s=new Error(I);return s.name=s.message,s}e.canceled=T;function k(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=k;function b(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=b;function m(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function r(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function d(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=d;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class g extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=g;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function u(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function c(s,t=Object.create(null)){const i=new Error(s);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=c}),define(be[15],we([0,1,10]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function S(L,U=0){return L[L.length-(1+U)]}e.tail=S;function R(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}e.tail2=R;function A(L,U,x=(Q,$)=>Q===$){if(L===U)return!0;if(!L||!U||L.length!==U.length)return!1;for(let Q=0,$=L.length;Q<$;Q++)if(!x(L[Q],U[Q]))return!1;return!0}e.equals=A;function D(L,U,x){let Q=0,$=L.length-1;for(;Q<=$;){const Z=(Q+$)/2|0,ie=x(L[Z],U);if(ie<0)Q=Z+1;else if(ie>0)$=Z-1;else return Z}return-(Q+1)}e.binarySearch=D;function I(L,U){let x=0,Q=L.length;if(Q===0)return 0;for(;x<Q;){const $=Math.floor((x+Q)/2);U(L[$])?Q=$:x=$+1}return x}e.findFirstInSorted=I;function y(L,U,x){if(L=L|0,L>=U.length)throw new TypeError("invalid index");let Q=U[Math.floor(U.length*Math.random())],$=[],Z=[],ie=[];for(let re of U){const ye=x(re,Q);ye<0?$.push(re):ye>0?Z.push(re):ie.push(re)}return L<$.length?y(L,$,x):L<$.length+ie.length?ie[0]:y(L-($.length+ie.length),Z,x)}e.quickSelect=y;function n(L,U){const x=[];let Q;for(const $ of L.slice(0).sort(U))!Q||U(Q[0],$)!==0?(Q=[$],x.push(Q)):Q.push($);return x}e.groupBy=n;function T(L,U,x){const Q=[];function $(re,ye,Ie){if(!(ye===0&&Ie.length===0)){const Ue=Q[Q.length-1];Ue&&Ue.start+Ue.deleteCount===re?(Ue.deleteCount+=ye,Ue.toInsert.push(...Ie)):Q.push({start:re,deleteCount:ye,toInsert:Ie})}}let Z=0,ie=0;for(;;){if(Z===L.length){$(Z,0,U.slice(ie));break}if(ie===U.length){$(Z,L.length-Z,[]);break}const re=L[Z],ye=U[ie],Ie=x(re,ye);Ie===0?(Z+=1,ie+=1):Ie<0?($(Z,1,[]),Z+=1):Ie>0&&($(Z,0,[ye]),ie+=1)}return Q}e.sortedDiff=T;function k(L,U,x){const Q=T(L,U,x),$=[],Z=[];for(const ie of Q)$.push(...L.slice(ie.start,ie.start+ie.deleteCount)),Z.push(...ie.toInsert);return{removed:$,added:Z}}e.delta=k;function b(L,U,x){if(x===0)return[];const Q=L.slice(0,x).sort(U);return r(L,U,Q,x,L.length),Q}e.top=b;function m(L,U,x,Q,$){return x===0?Promise.resolve([]):new Promise((Z,ie)=>{(async()=>{const re=L.length,ye=L.slice(0,x).sort(U);for(let Ie=x,Ue=Math.min(x+Q,re);Ie<re;Ie=Ue,Ue=Math.min(Ue+Q,re)){if(Ie>x&&await new Promise(Fe=>setTimeout(Fe)),$&&$.isCancellationRequested)throw(0,E.canceled)();r(L,U,ye,Ie,Ue)}return ye})().then(Z,ie)})}e.topAsync=m;function r(L,U,x,Q,$){for(const Z=x.length;Q<$;Q++){const ie=L[Q];if(U(ie,x[Z-1])<0){x.pop();const re=I(x,ye=>U(ie,ye)<0);x.splice(re,0,ie)}}}function d(L){return L.filter(U=>!!U)}e.coalesce=d;function _(L){let U=0;for(let x=0;x<L.length;x++)L[x]&&(L[U]=L[x],U+=1);L.length=U}e.coalesceInPlace=_;function g(L,U,x){L.splice(x,0,L.splice(U,1)[0])}e.move=g;function w(L){return!Array.isArray(L)||L.length===0}e.isFalsyOrEmpty=w;function u(L){return Array.isArray(L)&&L.length>0}e.isNonEmptyArray=u;function c(L,U){if(!U)return L.filter((Q,$)=>L.indexOf(Q)===$);const x=Object.create(null);return L.filter(Q=>{const $=U(Q);return x[$]?!1:(x[$]=!0,!0)})}e.distinct=c;function s(L){const U=new Set;return L.filter(x=>U.has(x)?!1:(U.add(x),!0))}e.distinctES6=s;function t(L){const U=Object.create(null);return x=>{const Q=L(x);return U[Q]?!1:(U[Q]=!0,!0)}}e.uniqueFilter=t;function i(L,U){for(let x=L.length-1;x>=0;x--){const Q=L[x];if(U(Q))return x}return-1}e.lastIndex=i;function l(L,U){return L.length>0?L[0]:U}e.firstOrDefault=l;function o(L,U,x=(Q,$)=>Q===$){let Q=0;for(let $=0,Z=Math.min(L.length,U.length);$<Z&&x(L[$],U[$]);$++)Q++;return Q}e.commonPrefixLength=o;function a(L){return[].concat(...L)}e.flatten=a;function f(L,U){let x=typeof U=="number"?L:0;typeof U=="number"?x=L:(x=0,U=L);const Q=[];if(x<=U)for(let $=x;$<U;$++)Q.push($);else for(let $=x;$>U;$--)Q.push($);return Q}e.range=f;function v(L,U,x){return L.reduce((Q,$)=>(Q[U($)]=x?x($):$,Q),Object.create(null))}e.index=v;function C(L,U){return L.push(U),()=>h(L,U)}e.insert=C;function h(L,U){const x=L.indexOf(U);if(x>-1)return L.splice(x,1),U}e.remove=h;function p(L,U,x){const Q=L.slice(0,U),$=L.slice(U);return Q.concat(x,$)}e.arrayInsert=p;function P(L,U){let x;if(typeof U=="number"){let Q=U;x=()=>{const $=Math.sin(Q++)*179426549;return $-Math.floor($)}}else x=Math.random;for(let Q=L.length-1;Q>0;Q-=1){const $=Math.floor(x()*(Q+1)),Z=L[Q];L[Q]=L[$],L[$]=Z}}e.shuffle=P;function F(L,U){const x=L.indexOf(U);x>-1&&(L.splice(x,1),L.unshift(U))}e.pushToStart=F;function z(L,U){const x=L.indexOf(U);x>-1&&(L.splice(x,1),L.push(U))}e.pushToEnd=z;function le(L,U){return Array.isArray(L)?L.map(U):U(L)}e.mapArrayOrNot=le;function H(L){return Array.isArray(L)?L:[L]}e.asArray=H;function W(L){return L[Math.floor(Math.random()*L.length)]}e.getRandomElement=W;function G(L,U){for(const x of L){const Q=U(x);if(Q!==void 0)return Q}}e.mapFind=G}),define(be[52],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(S){const R=this;let A=!1,D;return function(){return A||(A=!0,D=S.apply(R,arguments)),D}}e.once=E}),define(be[53],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class E{constructor(R){this._prefix=R,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=E,e.defaultGenerator=new E("id#")}),define(be[54],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(S){function R(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}S.is=R;const A=Object.freeze([]);function D(){return A}S.empty=D;function*I(s){yield s}S.single=I;function y(s){return s||A}S.from=y;function n(s){return!s||s[Symbol.iterator]().next().done===!0}S.isEmpty=n;function T(s){return s[Symbol.iterator]().next().value}S.first=T;function k(s,t){for(const i of s)if(t(i))return!0;return!1}S.some=k;function b(s,t){for(const i of s)if(t(i))return i}S.find=b;function*m(s,t){for(const i of s)t(i)&&(yield i)}S.filter=m;function*r(s,t){for(const i of s)yield t(i)}S.map=r;function*d(...s){for(const t of s)for(const i of t)yield i}S.concat=d;function*_(s){for(const t of s)for(const i of t)yield i}S.concatNested=_;function g(s,t,i){let l=i;for(const o of s)l=t(l,o);return l}S.reduce=g;function*w(s,t,i=s.length){for(t<0&&(t+=s.length),i<0?i+=s.length:i>s.length&&(i=s.length);t<i;t++)yield s[t]}S.slice=w;function u(s,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,s];const l=s[Symbol.iterator]();for(let o=0;o<t;o++){const a=l.next();if(a.done)return[i,S.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return l}}]}S.consume=u;function c(s,t,i=(l,o)=>l===o){const l=s[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const a=l.next(),f=o.next();if(a.done!==f.done)return!1;if(a.done)return!0;if(!i(a.value,f.value))return!1}}S.equals=c})(E=e.Iterable||(e.Iterable={}))}),define(be[44],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var S;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(S=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function D(t,i=!1){let l=0,o=t.length,a="",f=0,v=16,C=0;function h(W){let G=0,L=0;for(;G<W;){const U=t.charCodeAt(l);if(U>=48&&U<=57)L=L*16+U-48;else if(U>=65&&U<=70)L=L*16+U-65+10;else if(U>=97&&U<=102)L=L*16+U-97+10;else break;l++,G++}return G<W&&(L=-1),L}function p(W){l=W,a="",f=0,v=16,C=0}function P(){const W=l;if(t.charCodeAt(l)===48)l++;else for(l++;l<t.length&&n(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===46)if(l++,l<t.length&&n(t.charCodeAt(l)))for(l++;l<t.length&&n(t.charCodeAt(l));)l++;else return C=3,t.substring(W,l);let G=l;if(l<t.length&&(t.charCodeAt(l)===69||t.charCodeAt(l)===101))if(l++,(l<t.length&&t.charCodeAt(l)===43||t.charCodeAt(l)===45)&&l++,l<t.length&&n(t.charCodeAt(l))){for(l++;l<t.length&&n(t.charCodeAt(l));)l++;G=l}else C=3;return t.substring(W,G)}function F(){let W="",G=l;for(;;){if(l>=o){W+=t.substring(G,l),C=2;break}const L=t.charCodeAt(l);if(L===34){W+=t.substring(G,l),l++;break}if(L===92){if(W+=t.substring(G,l),l++,l>=o){C=2;break}switch(t.charCodeAt(l++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const x=h(4);x>=0?W+=String.fromCharCode(x):C=4;break;default:C=5}G=l;continue}if(L>=0&&L<=31)if(y(L)){W+=t.substring(G,l),C=2;break}else C=6;l++}return W}function z(){if(a="",C=0,f=l,l>=o)return f=o,v=17;let W=t.charCodeAt(l);if(I(W)){do l++,a+=String.fromCharCode(W),W=t.charCodeAt(l);while(I(W));return v=15}if(y(W))return l++,a+=String.fromCharCode(W),W===13&&t.charCodeAt(l)===10&&(l++,a+=`
`),v=14;switch(W){case 123:return l++,v=1;case 125:return l++,v=2;case 91:return l++,v=3;case 93:return l++,v=4;case 58:return l++,v=6;case 44:return l++,v=5;case 34:return l++,a=F(),v=10;case 47:const G=l-1;if(t.charCodeAt(l+1)===47){for(l+=2;l<o&&!y(t.charCodeAt(l));)l++;return a=t.substring(G,l),v=12}if(t.charCodeAt(l+1)===42){l+=2;const L=o-1;let U=!1;for(;l<L;){if(t.charCodeAt(l)===42&&t.charCodeAt(l+1)===47){l+=2,U=!0;break}l++}return U||(l++,C=1),a=t.substring(G,l),v=13}return a+=String.fromCharCode(W),l++,v=16;case 45:if(a+=String.fromCharCode(W),l++,l===o||!n(t.charCodeAt(l)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=P(),v=11;default:for(;l<o&&le(W);)l++,W=t.charCodeAt(l);if(f!==l){switch(a=t.substring(f,l),a){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return a+=String.fromCharCode(W),l++,v=16}}function le(W){if(I(W)||y(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let W;do W=z();while(W>=12&&W<=15);return W}return{setPosition:p,getPosition:()=>l,scan:i?H:z,getToken:()=>v,getTokenValue:()=>a,getTokenOffset:()=>f,getTokenLength:()=>l-f,getTokenError:()=>C}}e.createScanner=D;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,i){const l=[],o=new Object;let a;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function C(h,p,P,F){f.value=h,f.offset=p,f.length=P,f.type=F,f.colonOffset=void 0,a=f}try{u(t,{onObjectBegin:(h,p)=>{if(i<=h)throw o;a=void 0,v=i>h,l.push("")},onObjectProperty:(h,p,P)=>{if(i<p||(C(h,p,P,"property"),l[l.length-1]=h,i<=p+P))throw o},onObjectEnd:(h,p)=>{if(i<=h)throw o;a=void 0,l.pop()},onArrayBegin:(h,p)=>{if(i<=h)throw o;a=void 0,l.push(0)},onArrayEnd:(h,p)=>{if(i<=h)throw o;a=void 0,l.pop()},onLiteralValue:(h,p,P)=>{if(i<p||(C(h,p,P,s(h)),i<=p+P))throw o},onSeparator:(h,p,P)=>{if(i<=p)throw o;if(h===":"&&a&&a.type==="property")a.colonOffset=p,v=!1,a=void 0;else if(h===","){const F=l[l.length-1];typeof F=="number"?l[l.length-1]=F+1:(v=!0,l[l.length-1]=""),a=void 0}}})}catch(h){if(h!==o)throw h}return{path:l,previousNode:a,isAtPropertyKey:v,matches:h=>{let p=0;for(let P=0;p<h.length&&P<l.length;P++)if(h[p]===l[P]||h[p]==="*")p++;else if(h[p]!=="**")return!1;return p===h.length}}}e.getLocation=k;function b(t,i=[],l=A.DEFAULT){let o=null,a=[];const f=[];function v(h){Array.isArray(a)?a.push(h):o!==null&&(a[o]=h)}return u(t,{onObjectBegin:()=>{const h={};v(h),f.push(a),a=h,o=null},onObjectProperty:h=>{o=h},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const h=[];v(h),f.push(a),a=h,o=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:v,onError:(h,p,P)=>{i.push({error:h,offset:p,length:P})}},l),a[0]}e.parse=b;function m(t,i=[],l=A.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(h){o.type==="property"&&(o.length=h-o.offset,o=o.parent)}function f(h){return o.children.push(h),h}u(t,{onObjectBegin:h=>{o=f({type:"object",offset:h,length:-1,parent:o,children:[]})},onObjectProperty:(h,p,P)=>{o=f({type:"property",offset:p,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:h,offset:p,length:P,parent:o})},onObjectEnd:(h,p)=>{o.length=h+p-o.offset,o=o.parent,a(h+p)},onArrayBegin:(h,p)=>{o=f({type:"array",offset:h,length:-1,parent:o,children:[]})},onArrayEnd:(h,p)=>{o.length=h+p-o.offset,o=o.parent,a(h+p)},onLiteralValue:(h,p,P)=>{f({type:s(h),offset:p,length:P,parent:o,value:h}),a(p+P)},onSeparator:(h,p,P)=>{o.type==="property"&&(h===":"?o.colonOffset=p:h===","&&a(p))},onError:(h,p,P)=>{i.push({error:h,offset:p,length:P})}},l);const C=o.children[0];return C&&delete C.parent,C}e.parseTree=m;function r(t,i){if(!!t){let l=t;for(let o of i)if(typeof o=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let a=!1;for(const f of l.children)if(Array.isArray(f.children)&&f.children[0].value===o){l=f.children[1],a=!0;break}if(!a)return}else{const a=o;if(l.type!=="array"||a<0||!Array.isArray(l.children)||a>=l.children.length)return;l=l.children[a]}return l}}e.findNodeAtLocation=r;function d(t){if(!t.parent||!t.parent.children)return[];const i=d(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;i.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&i.push(l)}return i}e.getNodePath=d;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const i=Object.create(null);for(let l of t.children){const o=l.children[1];o&&(i[l.children[0].value]=_(o))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function g(t,i,l=!1){return i>=t.offset&&i<t.offset+t.length||l&&i===t.offset+t.length}e.contains=g;function w(t,i,l=!1){if(g(t,i,l)){const o=t.children;if(Array.isArray(o))for(let a=0;a<o.length&&o[a].offset<=i;a++){const f=w(o[a],i,l);if(f)return f}return t}}e.findNodeAtOffset=w;function u(t,i,l=A.DEFAULT){const o=D(t,!1);function a(ye){return ye?()=>ye(o.getTokenOffset(),o.getTokenLength()):()=>!0}function f(ye){return ye?Ie=>ye(Ie,o.getTokenOffset(),o.getTokenLength()):()=>!0}const v=a(i.onObjectBegin),C=f(i.onObjectProperty),h=a(i.onObjectEnd),p=a(i.onArrayBegin),P=a(i.onArrayEnd),F=f(i.onLiteralValue),z=f(i.onSeparator),le=a(i.onComment),H=f(i.onError),W=l&&l.disallowComments,G=l&&l.allowTrailingComma;function L(){for(;;){const ye=o.scan();switch(o.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:W||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(ye){case 12:case 13:W?U(10):le();break;case 16:U(1);break;case 15:case 14:break;default:return ye}}}function U(ye,Ie=[],Ue=[]){if(H(ye),Ie.length+Ue.length>0){let Fe=o.getToken();for(;Fe!==17;){if(Ie.indexOf(Fe)!==-1){L();break}else if(Ue.indexOf(Fe)!==-1)break;Fe=L()}}}function x(ye){const Ie=o.getTokenValue();return ye?F(Ie):C(Ie),L(),!0}function Q(){switch(o.getToken()){case 11:let ye=0;try{ye=JSON.parse(o.getTokenValue()),typeof ye!="number"&&(U(2),ye=0)}catch(Ie){U(2)}F(ye);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return L(),!0}function $(){return o.getToken()!==10?(U(3,[],[2,5]),!1):(x(!1),o.getToken()===6?(z(":"),L(),re()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function Z(){v(),L();let ye=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ye||U(4,[],[]),z(","),L(),o.getToken()===2&&G)break}else ye&&U(6,[],[]);$()||U(4,[],[2,5]),ye=!0}return h(),o.getToken()!==2?U(7,[2],[]):L(),!0}function ie(){p(),L();let ye=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ye||U(4,[],[]),z(","),L(),o.getToken()===4&&G)break}else ye&&U(6,[],[]);re()||U(4,[],[4,5]),ye=!0}return P(),o.getToken()!==4?U(8,[4],[]):L(),!0}function re(){switch(o.getToken()){case 3:return ie();case 1:return Z();case 10:return x(!0);default:return Q()}}return L(),o.getToken()===17?l.allowEmptyContent?!0:(U(4,[],[]),!1):re()?(o.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=u;function c(t,i){let l=D(t),o=[],a,f=0,v;do switch(v=l.getPosition(),a=l.scan(),a){case 12:case 13:case 17:f!==v&&o.push(t.substring(f,v)),i!==void 0&&o.push(l.getTokenValue().replace(/[^\r\n]/g,i)),f=l.getPosition();break}while(a!==17);return o.join("")}e.stripComments=c;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(be[104],we([0,1,44]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function S(y,n,T){let k,b,m,r,d;if(n){for(r=n.offset,d=r+n.length,m=r;m>0&&!I(y,m-1);)m--;let f=d;for(;f<y.length&&!I(y,f);)f++;b=y.substring(m,f),k=A(b,T)}else b=y,k=0,m=0,r=0,d=y.length;const _=D(T,y);let g=!1,w=0,u;T.insertSpaces?u=R(" ",T.tabSize||4):u="	";const c=(0,E.createScanner)(b,!1);let s=!1;function t(){return _+R(u,k+w)}function i(){let f=c.scan();for(g=!1;f===15||f===14;)g=g||f===14,f=c.scan();return s=f===16||c.getTokenError()!==0,f}const l=[];function o(f,v,C){!s&&v<d&&C>r&&y.substring(v,C)!==f&&l.push({offset:v,length:C-v,content:f})}let a=i();if(a!==17){const f=c.getTokenOffset()+m,v=R(u,k);o(v,m,f)}for(;a!==17;){let f=c.getTokenOffset()+c.getTokenLength()+m,v=i(),C="";for(;!g&&(v===12||v===13);){const p=c.getTokenOffset()+m;o(" ",f,p),f=c.getTokenOffset()+c.getTokenLength()+m,C=v===12?t():"",v=i()}if(v===2)a!==1&&(w--,C=t());else if(v===4)a!==3&&(w--,C=t());else{switch(a){case 3:case 1:w++,C=t();break;case 5:case 12:C=t();break;case 13:g?C=t():C=" ";break;case 6:C=" ";break;case 10:if(v===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?C=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}g&&(v===12||v===13)&&(C=t())}const h=c.getTokenOffset()+m;o(C,f,h),a=v}return l}e.format=S;function R(y,n){let T="";for(let k=0;k<n;k++)T+=y;return T}function A(y,n){let T=0,k=0;const b=n.tabSize||4;for(;T<y.length;){const m=y.charAt(T);if(m===" ")k++;else if(m==="	")k+=b;else break;T++}return Math.floor(k/b)}function D(y,n){for(let T=0;T<n.length;T++){const k=n.charAt(T);if(k==="\r")return T+1<n.length&&n.charAt(T+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=D;function I(y,n){return`\r
`.indexOf(y.charAt(n))!==-1}e.isEOL=I}),define(be[105],we([0,1,44,104]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(n,T,k){return A(n,T,void 0,k)}e.removeProperty=R;function A(n,T,k,b,m){const r=T.slice(),d=[],_=(0,E.parseTree)(n,d);let g,w;for(;r.length>0&&(w=r.pop(),g=(0,E.findNodeAtLocation)(_,r),g===void 0&&k!==void 0);)typeof w=="string"?k={[w]:k}:k=[k];if(g)if(g.type==="object"&&typeof w=="string"&&Array.isArray(g.children)){const u=(0,E.findNodeAtLocation)(g,[w]);if(u!==void 0)if(k===void 0){if(!u.parent)throw new Error("Malformed AST");const c=g.children.indexOf(u.parent);let s,t=u.parent.offset+u.parent.length;if(c>0){const i=g.children[c-1];s=i.offset+i.length}else s=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return D(n,{offset:s,length:t-s,content:""},b)}else return D(n,{offset:u.offset,length:u.length,content:JSON.stringify(k)},b);else{if(k===void 0)return[];const c=`${JSON.stringify(w)}: ${JSON.stringify(k)}`,s=m?m(g.children.map(i=>i.children[0].value)):g.children.length;let t;if(s>0){const i=g.children[s-1];t={offset:i.offset+i.length,length:0,content:","+c}}else g.children.length===0?t={offset:g.offset+1,length:0,content:c}:t={offset:g.offset+1,length:0,content:c+","};return D(n,t,b)}}else if(g.type==="array"&&typeof w=="number"&&Array.isArray(g.children))if(k!==void 0){const u=`${JSON.stringify(k)}`;let c;if(g.children.length===0||w===0)c={offset:g.offset+1,length:0,content:g.children.length===0?u:u+","};else{const s=w===-1||w>g.children.length?g.children.length:w,t=g.children[s-1];c={offset:t.offset+t.length,length:0,content:","+u}}return D(n,c,b)}else{const u=w,c=g.children[u];let s;if(g.children.length===1)s={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===u){const t=g.children[u-1],i=t.offset+t.length,l=g.offset+g.length;s={offset:i,length:l-2-i,content:""}}else s={offset:c.offset,length:g.children[u+1].offset-c.offset,content:""};return D(n,s,b)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${g.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return D(n,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(k)},b)}}e.setProperty=A;function D(n,T,k){let b=I(n,T),m=T.offset,r=T.offset+T.content.length;if(T.length===0||T.content.length===0){for(;m>0&&!(0,S.isEOL)(b,m-1);)m--;for(;r<b.length&&!(0,S.isEOL)(b,r);)r++}const d=(0,S.format)(b,{offset:m,length:r-m},k);for(let g=d.length-1;g>=0;g--){const w=d[g];b=I(b,w),m=Math.min(m,w.offset),r=Math.max(r,w.offset+w.length),r+=w.content.length-w.length}const _=n.length-(b.length-r)-m;return[{offset:m,length:_,content:b.substring(m,r)}]}e.withFormatting=D;function I(n,T){return n.substring(0,T.offset)+T.content+n.substring(T.offset+T.length)}e.applyEdit=I;function y(n,T){let k=T.slice(0).sort((m,r)=>{const d=m.offset-r.offset;return d===0?m.length-r.length:d}),b=n.length;for(let m=k.length-1;m>=0;m--){let r=k[m];if(r.offset+r.length<=b)n=I(n,r);else throw new Error("Overlapping edit");b=r.offset}return n}e.applyEdits=y}),define(be[106],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new E(()=>R(this.getValue()))}}e.Lazy=E}),define(be[6],we([0,1,52,54]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const R=!1;let A=null;function D(u){A=u}if(e.setDisposableTracker=D,R){const u="__is_disposable_tracked__";A=new class{trackDisposable(c){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[u]||console.log(s)},3e3)}markTracked(c){if(c&&c!==d.None)try{c[u]=!0}catch(s){}}}}function I(u){!A||A.markTracked(u)}function y(u){return A&&A.trackDisposable(u),u}e.trackDisposable=y;class n extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=n;function T(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=T;function k(u){if(S.Iterable.is(u)){let c=[];for(const s of u)if(s){I(s);try{s.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new n(c);return Array.isArray(u)?[]:u}else if(u)return I(u),u.dispose(),u}e.dispose=k;function b(...u){return u.forEach(I),m(()=>k(u))}e.combinedDisposable=b;function m(u){const c=y({dispose:()=>{I(c),u()}});return c}e.toDisposable=m;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return I(c),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new r,y(this)}dispose(){I(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var s;this._isDisposed||c===this._value||((s=this._value)===null||s===void 0||s.dispose(),c&&I(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,I(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=_;class g{constructor(){this.references=new Map}acquire(c,...s){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...s)},this.references.set(c,t));const{object:i}=t,l=(0,E.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:i,dispose:l}}}e.ReferenceCollection=g;class w{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=w}),define(be[45],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(A){this.element=A,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class S{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,D){const I=new E(A);if(this._first===E.Undefined)this._first=I,this._last=I;else if(D){const n=this._last;this._last=I,I.prev=n,n.next=I}else{const n=this._first;this._first=I,I.next=n,n.prev=I}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(I))}}shift(){if(this._first!==E.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==E.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==E.Undefined&&A.next!==E.Undefined){const D=A.prev;D.next=A.next,A.next.prev=D}else A.prev===E.Undefined&&A.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):A.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):A.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==E.Undefined;)yield A.element,A=A.next}}e.LinkedList=S}),function(ae,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ae=typeof globalThis!="undefined"?globalThis:ae||self,ae.marked=e())}(this,function(){"use strict";function ae(B,te){for(var he=0;he<te.length;he++){var q=te[he];q.enumerable=q.enumerable||!1,q.configurable=!0,"value"in q&&(q.writable=!0),Object.defineProperty(B,q.key,q)}}function e(B,te,he){return te&&ae(B.prototype,te),he&&ae(B,he),B}function E(B,te){if(!!B){if(typeof B=="string")return S(B,te);var he=Object.prototype.toString.call(B).slice(8,-1);if(he==="Object"&&B.constructor&&(he=B.constructor.name),he==="Map"||he==="Set")return Array.from(B);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return S(B,te)}}function S(B,te){(te==null||te>B.length)&&(te=B.length);for(var he=0,q=new Array(te);he<te;he++)q[he]=B[he];return q}function R(B,te){var he;if(typeof Symbol=="undefined"||B[Symbol.iterator]==null){if(Array.isArray(B)||(he=E(B))||te&&B&&typeof B.length=="number"){he&&(B=he);var q=0;return function(){return q>=B.length?{done:!0}:{done:!1,value:B[q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return he=B[Symbol.iterator](),he.next.bind(he)}function A(B){var te={exports:{}};return B(te,te.exports),te.exports}var D=A(function(B){function te(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function he(q){B.exports.defaults=q}B.exports={defaults:te(),getDefaults:te,changeDefaults:he}}),I=/[&<>"']/,y=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(te){return k[te]};function m(B,te){if(te){if(I.test(B))return B.replace(y,b)}else if(n.test(B))return B.replace(T,b);return B}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(B){return B.replace(r,function(te,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var _=/(^|[^\[])\^/g;function g(B,te){B=B.source||B,te=te||"";var he={replace:function(J,se){return se=se.source||se,se=se.replace(_,"$1"),B=B.replace(J,se),he},getRegex:function(){return new RegExp(B,te)}};return he}var w=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(B,te,he){if(B){var q;try{q=decodeURIComponent(d(he)).replace(w,"").toLowerCase()}catch(J){return null}if(q.indexOf("javascript:")===0||q.indexOf("vbscript:")===0||q.indexOf("data:")===0)return null}te&&!u.test(he)&&(he=o(te,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch(J){return null}return he}var s={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(B,te){s[" "+B]||(t.test(B)?s[" "+B]=B+"/":s[" "+B]=C(B,"/",!0)),B=s[" "+B];var he=B.indexOf(":")===-1;return te.substring(0,2)==="//"?he?te:B.replace(i,"$1")+te:te.charAt(0)==="/"?he?te:B.replace(l,"$1")+te:B+te}var a={exec:function(){}};function f(B){for(var te=1,he,q;te<arguments.length;te++){he=arguments[te];for(q in he)Object.prototype.hasOwnProperty.call(he,q)&&(B[q]=he[q])}return B}function v(B,te){var he=B.replace(/\|/g,function(se,fe,pe){for(var We=!1,Ne=fe;--Ne>=0&&pe[Ne]==="\\";)We=!We;return We?"|":" |"}),q=he.split(/ \|/),J=0;if(q.length>te)q.splice(te);else for(;q.length<te;)q.push("");for(;J<q.length;J++)q[J]=q[J].trim().replace(/\\\|/g,"|");return q}function C(B,te,he){var q=B.length;if(q===0)return"";for(var J=0;J<q;){var se=B.charAt(q-J-1);if(se===te&&!he)J++;else if(se!==te&&he)J++;else break}return B.substr(0,q-J)}function h(B,te){if(B.indexOf(te[1])===-1)return-1;for(var he=B.length,q=0,J=0;J<he;J++)if(B[J]==="\\")J++;else if(B[J]===te[0])q++;else if(B[J]===te[1]&&(q--,q<0))return J;return-1}function p(B){B&&B.sanitize&&!B.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(B,te){if(te<1)return"";for(var he="";te>1;)te&1&&(he+=B),te>>=1,B+=B;return he+B}var F={escape:m,unescape:d,edit:g,cleanUrl:c,resolveUrl:o,noopTest:a,merge:f,splitCells:v,rtrim:C,findClosingBracket:h,checkSanitizeDeprecation:p,repeatString:P},z=D.defaults,le=F.rtrim,H=F.splitCells,W=F.escape,G=F.findClosingBracket;function L(B,te,he){var q=te.href,J=te.title?W(te.title):null,se=B[1].replace(/\\([\[\]])/g,"$1");return B[0].charAt(0)!=="!"?{type:"link",raw:he,href:q,title:J,text:se}:{type:"image",raw:he,href:q,title:J,text:W(se)}}function U(B,te){var he=B.match(/^(\s+)(?:```)/);if(he===null)return te;var q=he[1];return te.split(`
`).map(function(J){var se=J.match(/^\s+/);if(se===null)return J;var fe=se[0];return fe.length>=q.length?J.slice(q.length):J}).join(`
`)}var x=function(){function B(he){this.options=he||z}var te=B.prototype;return te.space=function(q){var J=this.rules.block.newline.exec(q);if(J)return J[0].length>1?{type:"space",raw:J[0]}:{raw:`
`}},te.code=function(q){var J=this.rules.block.code.exec(q);if(J){var se=J[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:J[0],codeBlockStyle:"indented",text:this.options.pedantic?se:le(se,`
`)}}},te.fences=function(q){var J=this.rules.block.fences.exec(q);if(J){var se=J[0],fe=U(se,J[3]||"");return{type:"code",raw:se,lang:J[2]?J[2].trim():J[2],text:fe}}},te.heading=function(q){var J=this.rules.block.heading.exec(q);if(J){var se=J[2].trim();if(/#$/.test(se)){var fe=le(se,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(se=fe.trim())}return{type:"heading",raw:J[0],depth:J[1].length,text:se}}},te.nptable=function(q){var J=this.rules.block.nptable.exec(q);if(J){var se={type:"table",header:H(J[1].replace(/^ *| *\| *$/g,"")),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:J[3]?J[3].replace(/\n$/,"").split(`
`):[],raw:J[0]};if(se.header.length===se.align.length){var fe=se.align.length,pe;for(pe=0;pe<fe;pe++)/^ *-+: *$/.test(se.align[pe])?se.align[pe]="right":/^ *:-+: *$/.test(se.align[pe])?se.align[pe]="center":/^ *:-+ *$/.test(se.align[pe])?se.align[pe]="left":se.align[pe]=null;for(fe=se.cells.length,pe=0;pe<fe;pe++)se.cells[pe]=H(se.cells[pe],se.header.length);return se}}},te.hr=function(q){var J=this.rules.block.hr.exec(q);if(J)return{type:"hr",raw:J[0]}},te.blockquote=function(q){var J=this.rules.block.blockquote.exec(q);if(J){var se=J[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:J[0],text:se}}},te.list=function(q){var J=this.rules.block.list.exec(q);if(J){var se=J[0],fe=J[2],pe=fe.length>1,We={type:"list",raw:se,ordered:pe,start:pe?+fe.slice(0,-1):"",loose:!1,items:[]},Ne=J[0].match(this.rules.block.item),Ve=!1,Je,Ze,ct,ot,nt,ue,De,ce,j=Ne.length;ct=this.rules.block.listItemStart.exec(Ne[0]);for(var Ae=0;Ae<j;Ae++){if(Je=Ne[Ae],se=Je,Ae!==j-1){if(ot=this.rules.block.listItemStart.exec(Ne[Ae+1]),this.options.pedantic?ot[1].length>ct[1].length:ot[1].length>ct[0].length||ot[1].length>3){Ne.splice(Ae,2,Ne[Ae]+`
`+Ne[Ae+1]),Ae--,j--;continue}else(!this.options.pedantic||this.options.smartLists?ot[2][ot[2].length-1]!==fe[fe.length-1]:pe===(ot[2].length===1))&&(nt=Ne.slice(Ae+1).join(`
`),We.raw=We.raw.substring(0,We.raw.length-nt.length),Ae=j-1);ct=ot}Ze=Je.length,Je=Je.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Je.indexOf(`
 `)&&(Ze-=Je.length,Je=this.options.pedantic?Je.replace(/^ {1,4}/gm,""):Je.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),ue=Ve||/\n\n(?!\s*$)/.test(Je),Ae!==j-1&&(Ve=Je.charAt(Je.length-1)===`
`,ue||(ue=Ve)),ue&&(We.loose=!0),this.options.gfm&&(De=/^\[[ xX]\] /.test(Je),ce=void 0,De&&(ce=Je[1]!==" ",Je=Je.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:se,task:De,checked:ce,loose:ue,text:Je})}return We}},te.html=function(q){var J=this.rules.block.html.exec(q);if(J)return{type:this.options.sanitize?"paragraph":"html",raw:J[0],pre:!this.options.sanitizer&&(J[1]==="pre"||J[1]==="script"||J[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):W(J[0]):J[0]}},te.def=function(q){var J=this.rules.block.def.exec(q);if(J){J[3]&&(J[3]=J[3].substring(1,J[3].length-1));var se=J[1].toLowerCase().replace(/\s+/g," ");return{tag:se,raw:J[0],href:J[2],title:J[3]}}},te.table=function(q){var J=this.rules.block.table.exec(q);if(J){var se={type:"table",header:H(J[1].replace(/^ *| *\| *$/g,"")),align:J[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:J[3]?J[3].replace(/\n$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=J[0];var fe=se.align.length,pe;for(pe=0;pe<fe;pe++)/^ *-+: *$/.test(se.align[pe])?se.align[pe]="right":/^ *:-+: *$/.test(se.align[pe])?se.align[pe]="center":/^ *:-+ *$/.test(se.align[pe])?se.align[pe]="left":se.align[pe]=null;for(fe=se.cells.length,pe=0;pe<fe;pe++)se.cells[pe]=H(se.cells[pe].replace(/^ *\| *| *\| *$/g,""),se.header.length);return se}}},te.lheading=function(q){var J=this.rules.block.lheading.exec(q);if(J)return{type:"heading",raw:J[0],depth:J[2].charAt(0)==="="?1:2,text:J[1]}},te.paragraph=function(q){var J=this.rules.block.paragraph.exec(q);if(J)return{type:"paragraph",raw:J[0],text:J[1].charAt(J[1].length-1)===`
`?J[1].slice(0,-1):J[1]}},te.text=function(q){var J=this.rules.block.text.exec(q);if(J)return{type:"text",raw:J[0],text:J[0]}},te.escape=function(q){var J=this.rules.inline.escape.exec(q);if(J)return{type:"escape",raw:J[0],text:W(J[1])}},te.tag=function(q,J,se){var fe=this.rules.inline.tag.exec(q);if(fe)return!J&&/^<a /i.test(fe[0])?J=!0:J&&/^<\/a>/i.test(fe[0])&&(J=!1),!se&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?se=!0:se&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(se=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:J,inRawBlock:se,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):W(fe[0]):fe[0]}},te.link=function(q){var J=this.rules.inline.link.exec(q);if(J){var se=J[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var fe=le(se.slice(0,-1),"\\");if((se.length-fe.length)%2==0)return}else{var pe=G(J[2],"()");if(pe>-1){var We=J[0].indexOf("!")===0?5:4,Ne=We+J[1].length+pe;J[2]=J[2].substring(0,pe),J[0]=J[0].substring(0,Ne).trim(),J[3]=""}}var Ve=J[2],Je="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);Ze&&(Ve=Ze[1],Je=Ze[3])}else Je=J[3]?J[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(se)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),L(J,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:Je&&Je.replace(this.rules.inline._escapes,"$1")},J[0])}},te.reflink=function(q,J){var se;if((se=this.rules.inline.reflink.exec(q))||(se=this.rules.inline.nolink.exec(q))){var fe=(se[2]||se[1]).replace(/\s+/g," ");if(fe=J[fe.toLowerCase()],!fe||!fe.href){var pe=se[0].charAt(0);return{type:"text",raw:pe,text:pe}}return L(se,fe,se[0])}},te.emStrong=function(q,J,se){se===void 0&&(se="");var fe=this.rules.inline.emStrong.lDelim.exec(q);if(!!fe&&!(fe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var pe=fe[1]||fe[2]||"";if(!pe||pe&&(se===""||this.rules.inline.punctuation.exec(se))){var We=fe[0].length-1,Ne,Ve,Je=We,Ze=0,ct=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ct.lastIndex=0,J=J.slice(-1*q.length+We);(fe=ct.exec(J))!=null;)if(Ne=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ne){if(Ve=Ne.length,fe[3]||fe[4]){Je+=Ve;continue}else if((fe[5]||fe[6])&&We%3&&!((We+Ve)%3)){Ze+=Ve;continue}if(Je-=Ve,!(Je>0)){if(Je+Ze-Ve<=0&&!J.slice(ct.lastIndex).match(ct)&&(Ve=Math.min(Ve,Ve+Je+Ze)),Math.min(We,Ve)%2)return{type:"em",raw:q.slice(0,We+fe.index+Ve+1),text:q.slice(1,We+fe.index+Ve)};if(Math.min(We,Ve)%2==0)return{type:"strong",raw:q.slice(0,We+fe.index+Ve+1),text:q.slice(2,We+fe.index+Ve-1)}}}}}},te.codespan=function(q){var J=this.rules.inline.code.exec(q);if(J){var se=J[2].replace(/\n/g," "),fe=/[^ ]/.test(se),pe=/^ /.test(se)&&/ $/.test(se);return fe&&pe&&(se=se.substring(1,se.length-1)),se=W(se,!0),{type:"codespan",raw:J[0],text:se}}},te.br=function(q){var J=this.rules.inline.br.exec(q);if(J)return{type:"br",raw:J[0]}},te.del=function(q){var J=this.rules.inline.del.exec(q);if(J)return{type:"del",raw:J[0],text:J[2]}},te.autolink=function(q,J){var se=this.rules.inline.autolink.exec(q);if(se){var fe,pe;return se[2]==="@"?(fe=W(this.options.mangle?J(se[1]):se[1]),pe="mailto:"+fe):(fe=W(se[1]),pe=fe),{type:"link",raw:se[0],text:fe,href:pe,tokens:[{type:"text",raw:fe,text:fe}]}}},te.url=function(q,J){var se;if(se=this.rules.inline.url.exec(q)){var fe,pe;if(se[2]==="@")fe=W(this.options.mangle?J(se[0]):se[0]),pe="mailto:"+fe;else{var We;do We=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(We!==se[0]);fe=W(se[0]),se[1]==="www."?pe="http://"+fe:pe=fe}return{type:"link",raw:se[0],text:fe,href:pe,tokens:[{type:"text",raw:fe,text:fe}]}}},te.inlineText=function(q,J,se){var fe=this.rules.inline.text.exec(q);if(fe){var pe;return J?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):W(fe[0]):fe[0]:pe=W(this.options.smartypants?se(fe[0]):fe[0]),{type:"text",raw:fe[0],text:pe}}},B}(),Q=F.noopTest,$=F.edit,Z=F.merge,ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:Q,table:Q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=$(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,ie.item=$(ie.item,"gm").replace(/bull/g,ie.bullet).getRegex(),ie.listItemStart=$(/^( *)(bull)/).replace("bull",ie.bullet).getRegex(),ie.list=$(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=$(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=$(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=$(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=Z({},ie),ie.gfm=Z({},ie.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.nptable=$(ie.gfm.nptable).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.table=$(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=Z({},ie.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Q,paragraph:$(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=$(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=$(ie._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=$(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=$(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=$(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=$(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=$(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=$(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=$(re.reflink).replace("label",re._label).getRegex(),re.reflinkSearch=$(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=Z({},re),re.pedantic=Z({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=Z({},re.normal,{escape:$(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),re.gfm.url=$(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=Z({},re.gfm,{br:$(re.br).replace("{2,}","*").getRegex(),text:$(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ye={block:ie,inline:re},Ie=D.defaults,Ue=ye.block,Fe=ye.inline,ze=F.repeatString;function N(B){return B.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(B){var te="",he,q,J=B.length;for(he=0;he<J;he++)q=B.charCodeAt(he),Math.random()>.5&&(q="x"+q.toString(16)),te+="&#"+q+";";return te}var ee=function(){function B(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||Ie,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var q={block:Ue.normal,inline:Fe.normal};this.options.pedantic?(q.block=Ue.pedantic,q.inline=Fe.pedantic):this.options.gfm&&(q.block=Ue.gfm,this.options.breaks?q.inline=Fe.breaks:q.inline=Fe.gfm),this.tokenizer.rules=q}B.lex=function(q,J){var se=new B(J);return se.lex(q)},B.lexInline=function(q,J){var se=new B(J);return se.inlineTokens(q)};var te=B.prototype;return te.lex=function(q){return q=q.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(q,this.tokens,!0),this.inline(this.tokens),this.tokens},te.blockTokens=function(q,J,se){J===void 0&&(J=[]),se===void 0&&(se=!0),this.options.pedantic&&(q=q.replace(/^ +$/gm,""));for(var fe,pe,We,Ne;q;){if(fe=this.tokenizer.space(q)){q=q.substring(fe.raw.length),fe.type&&J.push(fe);continue}if(fe=this.tokenizer.code(q)){q=q.substring(fe.raw.length),Ne=J[J.length-1],Ne&&Ne.type==="paragraph"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text):J.push(fe);continue}if(fe=this.tokenizer.fences(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.heading(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.nptable(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.hr(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.blockquote(q)){q=q.substring(fe.raw.length),fe.tokens=this.blockTokens(fe.text,[],se),J.push(fe);continue}if(fe=this.tokenizer.list(q)){for(q=q.substring(fe.raw.length),We=fe.items.length,pe=0;pe<We;pe++)fe.items[pe].tokens=this.blockTokens(fe.items[pe].text,[],!1);J.push(fe);continue}if(fe=this.tokenizer.html(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(se&&(fe=this.tokenizer.def(q))){q=q.substring(fe.raw.length),this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.lheading(q)){q=q.substring(fe.raw.length),J.push(fe);continue}if(se&&(fe=this.tokenizer.paragraph(q))){q=q.substring(fe.raw.length),J.push(fe);continue}if(fe=this.tokenizer.text(q)){q=q.substring(fe.raw.length),Ne=J[J.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text):J.push(fe);continue}if(q){var Ve="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return J},te.inline=function(q){var J,se,fe,pe,We,Ne,Ve=q.length;for(J=0;J<Ve;J++)switch(Ne=q[J],Ne.type){case"paragraph":case"text":case"heading":{Ne.tokens=[],this.inlineTokens(Ne.text,Ne.tokens);break}case"table":{for(Ne.tokens={header:[],cells:[]},pe=Ne.header.length,se=0;se<pe;se++)Ne.tokens.header[se]=[],this.inlineTokens(Ne.header[se],Ne.tokens.header[se]);for(pe=Ne.cells.length,se=0;se<pe;se++)for(We=Ne.cells[se],Ne.tokens.cells[se]=[],fe=0;fe<We.length;fe++)Ne.tokens.cells[se][fe]=[],this.inlineTokens(We[fe],Ne.tokens.cells[se][fe]);break}case"blockquote":{this.inline(Ne.tokens);break}case"list":{for(pe=Ne.items.length,se=0;se<pe;se++)this.inline(Ne.items[se].tokens);break}}return q},te.inlineTokens=function(q,J,se,fe){J===void 0&&(J=[]),se===void 0&&(se=!1),fe===void 0&&(fe=!1);var pe,We,Ne=q,Ve,Je,Ze;if(this.tokens.links){var ct=Object.keys(this.tokens.links);if(ct.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)ct.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,Ve.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;q;){if(Je||(Ze=""),Je=!1,pe=this.tokenizer.escape(q)){q=q.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.tag(q,se,fe)){q=q.substring(pe.raw.length),se=pe.inLink,fe=pe.inRawBlock;var ot=J[J.length-1];ot&&pe.type==="text"&&ot.type==="text"?(ot.raw+=pe.raw,ot.text+=pe.text):J.push(pe);continue}if(pe=this.tokenizer.link(q)){q=q.substring(pe.raw.length),pe.type==="link"&&(pe.tokens=this.inlineTokens(pe.text,[],!0,fe)),J.push(pe);continue}if(pe=this.tokenizer.reflink(q,this.tokens.links)){q=q.substring(pe.raw.length);var nt=J[J.length-1];pe.type==="link"?(pe.tokens=this.inlineTokens(pe.text,[],!0,fe),J.push(pe)):nt&&pe.type==="text"&&nt.type==="text"?(nt.raw+=pe.raw,nt.text+=pe.text):J.push(pe);continue}if(pe=this.tokenizer.emStrong(q,Ne,Ze)){q=q.substring(pe.raw.length),pe.tokens=this.inlineTokens(pe.text,[],se,fe),J.push(pe);continue}if(pe=this.tokenizer.codespan(q)){q=q.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.br(q)){q=q.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.del(q)){q=q.substring(pe.raw.length),pe.tokens=this.inlineTokens(pe.text,[],se,fe),J.push(pe);continue}if(pe=this.tokenizer.autolink(q,K)){q=q.substring(pe.raw.length),J.push(pe);continue}if(!se&&(pe=this.tokenizer.url(q,K))){q=q.substring(pe.raw.length),J.push(pe);continue}if(pe=this.tokenizer.inlineText(q,fe,N)){q=q.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(Ze=pe.raw.slice(-1)),Je=!0,We=J[J.length-1],We&&We.type==="text"?(We.raw+=pe.raw,We.text+=pe.text):J.push(pe);continue}if(q){var ue="Infinite loop on byte: "+q.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return J},e(B,null,[{key:"rules",get:function(){return{block:Ue,inline:Fe}}}]),B}(),oe=D.defaults,me=F.cleanUrl,Se=F.escape,Me=function(){function B(he){this.options=he||oe}var te=B.prototype;return te.code=function(q,J,se){var fe=(J||"").match(/\S*/)[0];if(this.options.highlight){var pe=this.options.highlight(q,fe);pe!=null&&pe!==q&&(se=!0,q=pe)}return q=q.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+Se(fe,!0)+'">'+(se?q:Se(q,!0))+`</code></pre>
`:"<pre><code>"+(se?q:Se(q,!0))+`</code></pre>
`},te.blockquote=function(q){return`<blockquote>
`+q+`</blockquote>
`},te.html=function(q){return q},te.heading=function(q,J,se,fe){return this.options.headerIds?"<h"+J+' id="'+this.options.headerPrefix+fe.slug(se)+'">'+q+"</h"+J+`>
`:"<h"+J+">"+q+"</h"+J+`>
`},te.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},te.list=function(q,J,se){var fe=J?"ol":"ul",pe=J&&se!==1?' start="'+se+'"':"";return"<"+fe+pe+`>
`+q+"</"+fe+`>
`},te.listitem=function(q){return"<li>"+q+`</li>
`},te.checkbox=function(q){return"<input "+(q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},te.paragraph=function(q){return"<p>"+q+`</p>
`},te.table=function(q,J){return J&&(J="<tbody>"+J+"</tbody>"),`<table>
<thead>
`+q+`</thead>
`+J+`</table>
`},te.tablerow=function(q){return`<tr>
`+q+`</tr>
`},te.tablecell=function(q,J){var se=J.header?"th":"td",fe=J.align?"<"+se+' align="'+J.align+'">':"<"+se+">";return fe+q+"</"+se+`>
`},te.strong=function(q){return"<strong>"+q+"</strong>"},te.em=function(q){return"<em>"+q+"</em>"},te.codespan=function(q){return"<code>"+q+"</code>"},te.br=function(){return this.options.xhtml?"<br/>":"<br>"},te.del=function(q){return"<del>"+q+"</del>"},te.link=function(q,J,se){if(q=me(this.options.sanitize,this.options.baseUrl,q),q===null)return se;var fe='<a href="'+Se(q)+'"';return J&&(fe+=' title="'+J+'"'),fe+=">"+se+"</a>",fe},te.image=function(q,J,se){if(q=me(this.options.sanitize,this.options.baseUrl,q),q===null)return se;var fe='<img src="'+q+'" alt="'+se+'"';return J&&(fe+=' title="'+J+'"'),fe+=this.options.xhtml?"/>":">",fe},te.text=function(q){return q},B}(),ge=function(){function B(){}var te=B.prototype;return te.strong=function(q){return q},te.em=function(q){return q},te.codespan=function(q){return q},te.del=function(q){return q},te.html=function(q){return q},te.text=function(q){return q},te.link=function(q,J,se){return""+se},te.image=function(q,J,se){return""+se},te.br=function(){return""},B}(),Ce=function(){function B(){this.seen={}}var te=B.prototype;return te.serialize=function(q){return q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},te.getNextSafeSlug=function(q,J){var se=q,fe=0;if(this.seen.hasOwnProperty(se)){fe=this.seen[q];do fe++,se=q+"-"+fe;while(this.seen.hasOwnProperty(se))}return J||(this.seen[q]=fe,this.seen[se]=0),se},te.slug=function(q,J){J===void 0&&(J={});var se=this.serialize(q);return this.getNextSafeSlug(se,J.dryrun)},B}(),Pe=D.defaults,xe=F.unescape,_e=function(){function B(he){this.options=he||Pe,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ce}B.parse=function(q,J){var se=new B(J);return se.parse(q)},B.parseInline=function(q,J){var se=new B(J);return se.parseInline(q)};var te=B.prototype;return te.parse=function(q,J){J===void 0&&(J=!0);var se="",fe,pe,We,Ne,Ve,Je,Ze,ct,ot,nt,ue,De,ce,j,Ae,Te,Xe,Ge,rt=q.length;for(fe=0;fe<rt;fe++)switch(nt=q[fe],nt.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(nt.tokens),nt.depth,xe(this.parseInline(nt.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(nt.text,nt.lang,nt.escaped);continue}case"table":{for(ct="",Ze="",Ne=nt.header.length,pe=0;pe<Ne;pe++)Ze+=this.renderer.tablecell(this.parseInline(nt.tokens.header[pe]),{header:!0,align:nt.align[pe]});for(ct+=this.renderer.tablerow(Ze),ot="",Ne=nt.cells.length,pe=0;pe<Ne;pe++){for(Je=nt.tokens.cells[pe],Ze="",Ve=Je.length,We=0;We<Ve;We++)Ze+=this.renderer.tablecell(this.parseInline(Je[We]),{header:!1,align:nt.align[We]});ot+=this.renderer.tablerow(Ze)}se+=this.renderer.table(ct,ot);continue}case"blockquote":{ot=this.parse(nt.tokens),se+=this.renderer.blockquote(ot);continue}case"list":{for(ue=nt.ordered,De=nt.start,ce=nt.loose,Ne=nt.items.length,ot="",pe=0;pe<Ne;pe++)Ae=nt.items[pe],Te=Ae.checked,Xe=Ae.task,j="",Ae.task&&(Ge=this.renderer.checkbox(Te),ce?Ae.tokens.length>0&&Ae.tokens[0].type==="text"?(Ae.tokens[0].text=Ge+" "+Ae.tokens[0].text,Ae.tokens[0].tokens&&Ae.tokens[0].tokens.length>0&&Ae.tokens[0].tokens[0].type==="text"&&(Ae.tokens[0].tokens[0].text=Ge+" "+Ae.tokens[0].tokens[0].text)):Ae.tokens.unshift({type:"text",text:Ge}):j+=Ge),j+=this.parse(Ae.tokens,ce),ot+=this.renderer.listitem(j,Xe,Te);se+=this.renderer.list(ot,ue,De);continue}case"html":{se+=this.renderer.html(nt.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(nt.tokens));continue}case"text":{for(ot=nt.tokens?this.parseInline(nt.tokens):nt.text;fe+1<rt&&q[fe+1].type==="text";)nt=q[++fe],ot+=`
`+(nt.tokens?this.parseInline(nt.tokens):nt.text);se+=J?this.renderer.paragraph(ot):ot;continue}default:{var at='Token with "'+nt.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}return se},te.parseInline=function(q,J){J=J||this.renderer;var se="",fe,pe,We=q.length;for(fe=0;fe<We;fe++)switch(pe=q[fe],pe.type){case"escape":{se+=J.text(pe.text);break}case"html":{se+=J.html(pe.text);break}case"link":{se+=J.link(pe.href,pe.title,this.parseInline(pe.tokens,J));break}case"image":{se+=J.image(pe.href,pe.title,pe.text);break}case"strong":{se+=J.strong(this.parseInline(pe.tokens,J));break}case"em":{se+=J.em(this.parseInline(pe.tokens,J));break}case"codespan":{se+=J.codespan(pe.text);break}case"br":{se+=J.br();break}case"del":{se+=J.del(this.parseInline(pe.tokens,J));break}case"text":{se+=J.text(pe.text);break}default:{var Ne='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}return se},B}(),qe=F.merge,V=F.checkSanitizeDeprecation,Y=F.escape,ve=D.getDefaults,Le=D.changeDefaults,Be=D.defaults;function Oe(B,te,he){if(typeof B=="undefined"||B===null)throw new Error("marked(): input parameter is undefined or null");if(typeof B!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(B)+", string expected");if(typeof te=="function"&&(he=te,te=null),te=qe({},Oe.defaults,te||{}),V(te),he){var q=te.highlight,J;try{J=ee.lex(B,te)}catch(We){return he(We)}var se=function(Ne){var Ve;if(!Ne)try{Ve=_e.parse(J,te)}catch(Je){Ne=Je}return te.highlight=q,Ne?he(Ne):he(null,Ve)};if(!q||q.length<3||(delete te.highlight,!J.length))return se();var fe=0;Oe.walkTokens(J,function(We){We.type==="code"&&(fe++,setTimeout(function(){q(We.text,We.lang,function(Ne,Ve){if(Ne)return se(Ne);Ve!=null&&Ve!==We.text&&(We.text=Ve,We.escaped=!0),fe--,fe===0&&se()})},0))}),fe===0&&se();return}try{var pe=ee.lex(B,te);return te.walkTokens&&Oe.walkTokens(pe,te.walkTokens),_e.parse(pe,te)}catch(We){if(We.message+=`
Please report this to https://github.com/markedjs/marked.`,te.silent)return"<p>An error occurred:</p><pre>"+Y(We.message+"",!0)+"</pre>";throw We}}Oe.options=Oe.setOptions=function(B){return qe(Oe.defaults,B),Le(Oe.defaults),Oe},Oe.getDefaults=ve,Oe.defaults=Be,Oe.use=function(B){var te=qe({},B);if(B.renderer&&function(){var q=Oe.defaults.renderer||new Me,J=function(pe){var We=q[pe];q[pe]=function(){for(var Ne=arguments.length,Ve=new Array(Ne),Je=0;Je<Ne;Je++)Ve[Je]=arguments[Je];var Ze=B.renderer[pe].apply(q,Ve);return Ze===!1&&(Ze=We.apply(q,Ve)),Ze}};for(var se in B.renderer)J(se);te.renderer=q}(),B.tokenizer&&function(){var q=Oe.defaults.tokenizer||new x,J=function(pe){var We=q[pe];q[pe]=function(){for(var Ne=arguments.length,Ve=new Array(Ne),Je=0;Je<Ne;Je++)Ve[Je]=arguments[Je];var Ze=B.tokenizer[pe].apply(q,Ve);return Ze===!1&&(Ze=We.apply(q,Ve)),Ze}};for(var se in B.tokenizer)J(se);te.tokenizer=q}(),B.walkTokens){var he=Oe.defaults.walkTokens;te.walkTokens=function(q){B.walkTokens(q),he&&he(q)}}Oe.setOptions(te)},Oe.walkTokens=function(B,te){for(var he=R(B),q;!(q=he()).done;){var J=q.value;switch(te(J),J.type){case"table":{for(var se=R(J.tokens.header),fe;!(fe=se()).done;){var pe=fe.value;Oe.walkTokens(pe,te)}for(var We=R(J.tokens.cells),Ne;!(Ne=We()).done;)for(var Ve=Ne.value,Je=R(Ve),Ze;!(Ze=Je()).done;){var ct=Ze.value;Oe.walkTokens(ct,te)}break}case"list":{Oe.walkTokens(J.items,te);break}default:J.tokens&&Oe.walkTokens(J.tokens,te)}}},Oe.parseInline=function(B,te){if(typeof B=="undefined"||B===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof B!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(B)+", string expected");te=qe({},Oe.defaults,te||{}),V(te);try{var he=ee.lexInline(B,te);return te.walkTokens&&Oe.walkTokens(he,te.walkTokens),_e.parseInline(he,te)}catch(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,te.silent)return"<p>An error occurred:</p><pre>"+Y(q.message+"",!0)+"</pre>";throw q}},Oe.Parser=_e,Oe.parser=_e.parse,Oe.Renderer=Me,Oe.TextRenderer=ge,Oe.Lexer=ee,Oe.lexer=ee.lex,Oe.Tokenizer=x,Oe.Slugger=Ce,Oe.parse=Oe;var et=Oe;return et}),define(be[78],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(D,I,y){return Math.min(Math.max(D,I),y)}e.clamp=E;function S(D,I){return(I+D%I)%I}e.rot=S;class R{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=R;class A{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A});"use strict";(function(){function ae(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function D(y){A.push(y,Date.now())}function I(){const y=[];for(let n=0;n<A.length;n+=2)y.push({name:A[n],startTime:A[n+1]});return y}return{mark:D,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(R+D.startTime)});return A}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function E(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=E(S))})(),define(be[21],we([0,1]),function(ae,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const S="en";let R=!1,A=!1,D=!1,I=!1,y=!1,n=!1,T=!1,k,b=S,m,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof process!="undefined"?d=process:typeof e.globals.vscode!="undefined"&&(d=e.globals.vscode.process);const _=typeof((E=d==null?void 0:d.versions)===null||E===void 0?void 0:E.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=_&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=d==null?void 0:d.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!_)r=navigator.userAgent,R=r.indexOf("Windows")>=0,A=r.indexOf("Macintosh")>=0,T=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=r.indexOf("Linux")>=0,n=!0,k=navigator.language,b=k;else if(typeof d=="object"){R=d.platform==="win32",A=d.platform==="darwin",D=d.platform==="linux",I=D&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,k=S,b=S;const o=d.env.VSCODE_NLS_CONFIG;if(o)try{const a=JSON.parse(o),f=a.availableLanguages["*"];k=a.locale,b=f||S,m=a._translationsConfigFile}catch(a){}y=!0}else console.error("Unable to resolve platform.");var g;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(g=e.Platform||(e.Platform={}));function w(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let u=0;A?u=1:R?u=3:D&&(u=2),e.isWindows=R,e.isMacintosh=A,e.isLinux=D,e.isLinuxSnap=I,e.isNative=y,e.isWeb=n,e.isIOS=T,e.platform=u,e.userAgent=r,e.language=b;var c;(function(o){function a(){return e.language}o.value=a;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=f;function v(){return e.language==="en"}o.isDefault=v})(c=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeSetImmediateId)for(let h=0,p=f.length;h<p;h++){const P=f[h];if(P.id===C.data.vscodeSetImmediateId){f.splice(h,1),P.callback();return}}});let v=0;return C=>{const h=++v;f.push({id:h,callback:C}),e.globals.postMessage({vscodeSetImmediateId:h},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const a=Promise.resolve();return f=>a.then(f)}();var s;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||T?2:R?1:3;let t=!0,i=!1;function l(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=l}),define(be[32],we([0,1,21]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let S;if(typeof process!="undefined")S={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}};else if(typeof E.globals.vscode!="undefined"){const R=E.globals.vscode.process;S={get platform(){return R.platform},get env(){return R.env},cwd(){return R.cwd()},nextTick(A){return(0,E.setImmediate)(A)}}}else S={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(R){return(0,E.setImmediate)(R)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=S.cwd,e.env=S.env,e.platform=S.platform,e.nextTick=S.nextTick}),define(be[11],we([0,1,32]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const S=65,R=97,A=90,D=122,I=46,y=47,n=92,T=58,k=63;class b extends Error{constructor(c,s,t){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const l=c.indexOf(".")!==-1?"property":"argument";let o=`The "${c}" ${l} ${i} of type ${s}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function m(u,c){if(typeof u!="string")throw new b(c,"string",u)}function r(u){return u===y||u===n}function d(u){return u===y}function _(u){return u>=S&&u<=A||u>=R&&u<=D}function g(u,c,s,t){let i="",l=0,o=-1,a=0,f=0;for(let v=0;v<=u.length;++v){if(v<u.length)f=u.charCodeAt(v);else{if(t(f))break;f=y}if(t(f)){if(!(o===v-1||a===1))if(a===2){if(i.length<2||l!==2||i.charCodeAt(i.length-1)!==I||i.charCodeAt(i.length-2)!==I){if(i.length>2){const C=i.lastIndexOf(s);C===-1?(i="",l=0):(i=i.slice(0,C),l=i.length-1-i.lastIndexOf(s)),o=v,a=0;continue}else if(i.length!==0){i="",l=0,o=v,a=0;continue}}c&&(i+=i.length>0?`${s}..`:"..",l=2)}else i.length>0?i+=`${s}${u.slice(o+1,v)}`:i=u.slice(o+1,v),l=v-o-1;o=v,a=0}else f===I&&a!==-1?++a:a=-1}return i}function w(u,c){if(c===null||typeof c!="object")throw new b("pathObject","Object",c);const s=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return s?s===c.root?`${s}${t}`:`${s}${u}${t}`:t}e.win32={resolve(...u){let c="",s="",t=!1;for(let i=u.length-1;i>=-1;i--){let l;if(i>=0){if(l=u[i],m(l,"path"),l.length===0)continue}else c.length===0?l=E.cwd():(l=E.env[`=${c}`]||E.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==c.toLowerCase()&&l.charCodeAt(2)===n)&&(l=`${c}\\`));const o=l.length;let a=0,f="",v=!1;const C=l.charCodeAt(0);if(o===1)r(C)&&(a=1,v=!0);else if(r(C))if(v=!0,r(l.charCodeAt(1))){let h=2,p=h;for(;h<o&&!r(l.charCodeAt(h));)h++;if(h<o&&h!==p){const P=l.slice(p,h);for(p=h;h<o&&r(l.charCodeAt(h));)h++;if(h<o&&h!==p){for(p=h;h<o&&!r(l.charCodeAt(h));)h++;(h===o||h!==p)&&(f=`\\\\${P}\\${l.slice(p,h)}`,a=h)}}}else a=1;else _(C)&&l.charCodeAt(1)===T&&(f=l.slice(0,2),a=2,o>2&&r(l.charCodeAt(2))&&(v=!0,a=3));if(f.length>0)if(c.length>0){if(f.toLowerCase()!==c.toLowerCase())continue}else c=f;if(t){if(c.length>0)break}else if(s=`${l.slice(a)}\\${s}`,t=v,v&&c.length>0)break}return s=g(s,!t,"\\",r),t?`${c}\\${s}`:`${c}${s}`||"."},normalize(u){m(u,"path");const c=u.length;if(c===0)return".";let s=0,t,i=!1;const l=u.charCodeAt(0);if(c===1)return d(l)?"\\":u;if(r(l))if(i=!0,r(u.charCodeAt(1))){let a=2,f=a;for(;a<c&&!r(u.charCodeAt(a));)a++;if(a<c&&a!==f){const v=u.slice(f,a);for(f=a;a<c&&r(u.charCodeAt(a));)a++;if(a<c&&a!==f){for(f=a;a<c&&!r(u.charCodeAt(a));)a++;if(a===c)return`\\\\${v}\\${u.slice(f)}\\`;a!==f&&(t=`\\\\${v}\\${u.slice(f,a)}`,s=a)}}}else s=1;else _(l)&&u.charCodeAt(1)===T&&(t=u.slice(0,2),s=2,c>2&&r(u.charCodeAt(2))&&(i=!0,s=3));let o=s<c?g(u.slice(s),!i,"\\",r):"";return o.length===0&&!i&&(o="."),o.length>0&&r(u.charCodeAt(c-1))&&(o+="\\"),t===void 0?i?`\\${o}`:o:i?`${t}\\${o}`:`${t}${o}`},isAbsolute(u){m(u,"path");const c=u.length;if(c===0)return!1;const s=u.charCodeAt(0);return r(s)||c>2&&_(s)&&u.charCodeAt(1)===T&&r(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let c,s;for(let l=0;l<u.length;++l){const o=u[l];m(o,"path"),o.length>0&&(c===void 0?c=s=o:c+=`\\${o}`)}if(c===void 0)return".";let t=!0,i=0;if(typeof s=="string"&&r(s.charCodeAt(0))){++i;const l=s.length;l>1&&r(s.charCodeAt(1))&&(++i,l>2&&(r(s.charCodeAt(2))?++i:t=!1))}if(t){for(;i<c.length&&r(c.charCodeAt(i));)i++;i>=2&&(c=`\\${c.slice(i)}`)}return e.win32.normalize(c)},relative(u,c){if(m(u,"from"),m(c,"to"),u===c)return"";const s=e.win32.resolve(u),t=e.win32.resolve(c);if(s===t||(u=s.toLowerCase(),c=t.toLowerCase(),u===c))return"";let i=0;for(;i<u.length&&u.charCodeAt(i)===n;)i++;let l=u.length;for(;l-1>i&&u.charCodeAt(l-1)===n;)l--;const o=l-i;let a=0;for(;a<c.length&&c.charCodeAt(a)===n;)a++;let f=c.length;for(;f-1>a&&c.charCodeAt(f-1)===n;)f--;const v=f-a,C=o<v?o:v;let h=-1,p=0;for(;p<C;p++){const F=u.charCodeAt(i+p);if(F!==c.charCodeAt(a+p))break;F===n&&(h=p)}if(p!==C){if(h===-1)return t}else{if(v>C){if(c.charCodeAt(a+p)===n)return t.slice(a+p+1);if(p===2)return t.slice(a+p)}o>C&&(u.charCodeAt(i+p)===n?h=p:p===2&&(h=3)),h===-1&&(h=0)}let P="";for(p=i+h+1;p<=l;++p)(p===l||u.charCodeAt(p)===n)&&(P+=P.length===0?"..":"\\..");return a+=h,P.length>0?`${P}${t.slice(a,f)}`:(t.charCodeAt(a)===n&&++a,t.slice(a,f))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const c=e.win32.resolve(u);if(c.length<=2)return u;if(c.charCodeAt(0)===n){if(c.charCodeAt(1)===n){const s=c.charCodeAt(2);if(s!==k&&s!==I)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(_(c.charCodeAt(0))&&c.charCodeAt(1)===T&&c.charCodeAt(2)===n)return`\\\\?\\${c}`;return u},dirname(u){m(u,"path");const c=u.length;if(c===0)return".";let s=-1,t=0;const i=u.charCodeAt(0);if(c===1)return r(i)?u:".";if(r(i)){if(s=t=1,r(u.charCodeAt(1))){let a=2,f=a;for(;a<c&&!r(u.charCodeAt(a));)a++;if(a<c&&a!==f){for(f=a;a<c&&r(u.charCodeAt(a));)a++;if(a<c&&a!==f){for(f=a;a<c&&!r(u.charCodeAt(a));)a++;if(a===c)return u;a!==f&&(s=t=a+1)}}}}else _(i)&&u.charCodeAt(1)===T&&(s=c>2&&r(u.charCodeAt(2))?3:2,t=s);let l=-1,o=!0;for(let a=c-1;a>=t;--a)if(r(u.charCodeAt(a))){if(!o){l=a;break}}else o=!1;if(l===-1){if(s===-1)return".";l=s}return u.slice(0,l)},basename(u,c){c!==void 0&&m(c,"ext"),m(u,"path");let s=0,t=-1,i=!0,l;if(u.length>=2&&_(u.charCodeAt(0))&&u.charCodeAt(1)===T&&(s=2),c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let o=c.length-1,a=-1;for(l=u.length-1;l>=s;--l){const f=u.charCodeAt(l);if(r(f)){if(!i){s=l+1;break}}else a===-1&&(i=!1,a=l+1),o>=0&&(f===c.charCodeAt(o)?--o==-1&&(t=l):(o=-1,t=a))}return s===t?t=a:t===-1&&(t=u.length),u.slice(s,t)}for(l=u.length-1;l>=s;--l)if(r(u.charCodeAt(l))){if(!i){s=l+1;break}}else t===-1&&(i=!1,t=l+1);return t===-1?"":u.slice(s,t)},extname(u){m(u,"path");let c=0,s=-1,t=0,i=-1,l=!0,o=0;u.length>=2&&u.charCodeAt(1)===T&&_(u.charCodeAt(0))&&(c=t=2);for(let a=u.length-1;a>=c;--a){const f=u.charCodeAt(a);if(r(f)){if(!l){t=a+1;break}continue}i===-1&&(l=!1,i=a+1),f===I?s===-1?s=a:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||i===-1||o===0||o===1&&s===i-1&&s===t+1?"":u.slice(s,i)},format:w.bind(null,"\\"),parse(u){m(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const s=u.length;let t=0,i=u.charCodeAt(0);if(s===1)return r(i)?(c.root=c.dir=u,c):(c.base=c.name=u,c);if(r(i)){if(t=1,r(u.charCodeAt(1))){let h=2,p=h;for(;h<s&&!r(u.charCodeAt(h));)h++;if(h<s&&h!==p){for(p=h;h<s&&r(u.charCodeAt(h));)h++;if(h<s&&h!==p){for(p=h;h<s&&!r(u.charCodeAt(h));)h++;h===s?t=h:h!==p&&(t=h+1)}}}}else if(_(i)&&u.charCodeAt(1)===T){if(s<=2)return c.root=c.dir=u,c;if(t=2,r(u.charCodeAt(2))){if(s===3)return c.root=c.dir=u,c;t=3}}t>0&&(c.root=u.slice(0,t));let l=-1,o=t,a=-1,f=!0,v=u.length-1,C=0;for(;v>=t;--v){if(i=u.charCodeAt(v),r(i)){if(!f){o=v+1;break}continue}a===-1&&(f=!1,a=v+1),i===I?l===-1?l=v:C!==1&&(C=1):l!==-1&&(C=-1)}return a!==-1&&(l===-1||C===0||C===1&&l===a-1&&l===o+1?c.base=c.name=u.slice(o,a):(c.name=u.slice(o,l),c.base=u.slice(o,a),c.ext=u.slice(l,a))),o>0&&o!==t?c.dir=u.slice(0,o-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let c="",s=!1;for(let t=u.length-1;t>=-1&&!s;t--){const i=t>=0?u[t]:E.cwd();m(i,"path"),i.length!==0&&(c=`${i}/${c}`,s=i.charCodeAt(0)===y)}return c=g(c,!s,"/",d),s?`/${c}`:c.length>0?c:"."},normalize(u){if(m(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===y,s=u.charCodeAt(u.length-1)===y;return u=g(u,!c,"/",d),u.length===0?c?"/":s?"./":".":(s&&(u+="/"),c?`/${u}`:u)},isAbsolute(u){return m(u,"path"),u.length>0&&u.charCodeAt(0)===y},join(...u){if(u.length===0)return".";let c;for(let s=0;s<u.length;++s){const t=u[s];m(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(u,c){if(m(u,"from"),m(c,"to"),u===c||(u=e.posix.resolve(u),c=e.posix.resolve(c),u===c))return"";const s=1,t=u.length,i=t-s,l=1,o=c.length-l,a=i<o?i:o;let f=-1,v=0;for(;v<a;v++){const h=u.charCodeAt(s+v);if(h!==c.charCodeAt(l+v))break;h===y&&(f=v)}if(v===a)if(o>a){if(c.charCodeAt(l+v)===y)return c.slice(l+v+1);if(v===0)return c.slice(l+v)}else i>a&&(u.charCodeAt(s+v)===y?f=v:v===0&&(f=0));let C="";for(v=s+f+1;v<=t;++v)(v===t||u.charCodeAt(v)===y)&&(C+=C.length===0?"..":"/..");return`${C}${c.slice(l+f)}`},toNamespacedPath(u){return u},dirname(u){if(m(u,"path"),u.length===0)return".";const c=u.charCodeAt(0)===y;let s=-1,t=!0;for(let i=u.length-1;i>=1;--i)if(u.charCodeAt(i)===y){if(!t){s=i;break}}else t=!1;return s===-1?c?"/":".":c&&s===1?"//":u.slice(0,s)},basename(u,c){c!==void 0&&m(c,"ext"),m(u,"path");let s=0,t=-1,i=!0,l;if(c!==void 0&&c.length>0&&c.length<=u.length){if(c===u)return"";let o=c.length-1,a=-1;for(l=u.length-1;l>=0;--l){const f=u.charCodeAt(l);if(f===y){if(!i){s=l+1;break}}else a===-1&&(i=!1,a=l+1),o>=0&&(f===c.charCodeAt(o)?--o==-1&&(t=l):(o=-1,t=a))}return s===t?t=a:t===-1&&(t=u.length),u.slice(s,t)}for(l=u.length-1;l>=0;--l)if(u.charCodeAt(l)===y){if(!i){s=l+1;break}}else t===-1&&(i=!1,t=l+1);return t===-1?"":u.slice(s,t)},extname(u){m(u,"path");let c=-1,s=0,t=-1,i=!0,l=0;for(let o=u.length-1;o>=0;--o){const a=u.charCodeAt(o);if(a===y){if(!i){s=o+1;break}continue}t===-1&&(i=!1,t=o+1),a===I?c===-1?c=o:l!==1&&(l=1):c!==-1&&(l=-1)}return c===-1||t===-1||l===0||l===1&&c===t-1&&c===s+1?"":u.slice(c,t)},format:w.bind(null,"/"),parse(u){m(u,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return c;const s=u.charCodeAt(0)===y;let t;s?(c.root="/",t=1):t=0;let i=-1,l=0,o=-1,a=!0,f=u.length-1,v=0;for(;f>=t;--f){const C=u.charCodeAt(f);if(C===y){if(!a){l=f+1;break}continue}o===-1&&(a=!1,o=f+1),C===I?i===-1?i=f:v!==1&&(v=1):i!==-1&&(v=-1)}if(o!==-1){const C=l===0&&s?1:l;i===-1||v===0||v===1&&i===o-1&&i===l+1?c.base=c.name=u.slice(C,o):(c.name=u.slice(C,i),c.base=u.slice(C,o),c.ext=u.slice(i,o))}return l>0?c.dir=u.slice(0,l-1):s&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[55],we([0,1,21]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const S=E.globals.performance&&typeof E.globals.performance.now=="function";class R{constructor(D){this._highResolution=S&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new R(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=R}),define(be[3],we([0,1,10,52,6,45,55]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(g){g.None=()=>R.Disposable.None;function w(H){return(W,G=null,L)=>{let U=!1,x;return x=H(Q=>{if(!U)return x?x.dispose():U=!0,W.call(G,Q)},null,L),U&&x.dispose(),x}}g.once=w;function u(H,W){return o((G,L=null,U)=>H(x=>G.call(L,W(x)),null,U))}g.map=u;function c(H,W){return o((G,L=null,U)=>H(x=>{W(x),G.call(L,x)},null,U))}g.forEach=c;function s(H,W){return o((G,L=null,U)=>H(x=>W(x)&&G.call(L,x),null,U))}g.filter=s;function t(H){return H}g.signal=t;function i(...H){return(W,G=null,L)=>(0,R.combinedDisposable)(...H.map(U=>U(x=>W.call(G,x),null,L)))}g.any=i;function l(H,W,G){let L=G;return u(H,U=>(L=W(L,U),L))}g.reduce=l;function o(H){let W;const G=new b({onFirstListenerAdd(){W=H(G.fire,G)},onLastListenerRemove(){W.dispose()}});return G.event}g.snapshot=o;function a(H,W,G=100,L=!1,U){let x,Q,$,Z=0;const ie=new b({leakWarningThreshold:U,onFirstListenerAdd(){x=H(re=>{Z++,Q=W(Q,re),L&&!$&&(ie.fire(Q),Q=void 0),clearTimeout($),$=setTimeout(()=>{const ye=Q;Q=void 0,$=void 0,(!L||Z>1)&&ie.fire(ye),Z=0},G)})},onLastListenerRemove(){x.dispose()}});return ie.event}g.debounce=a;function f(H){const W=new Date().getTime();return u(w(H),G=>new Date().getTime()-W)}g.stopwatch=f;function v(H){let W=!0,G;return s(H,L=>{const U=W||L!==G;return W=!1,G=L,U})}g.latch=v;function C(H,W=!1,G=[]){let L=G.slice(),U=H($=>{L?L.push($):Q.fire($)});const x=()=>{L&&L.forEach($=>Q.fire($)),L=null},Q=new b({onFirstListenerAdd(){U||(U=H($=>Q.fire($)))},onFirstListenerDidAdd(){L&&(W?setTimeout(x):x())},onLastListenerRemove(){U&&U.dispose(),U=null}});return Q.event}g.buffer=C;class h{constructor(W){this.event=W}map(W){return new h(u(this.event,W))}forEach(W){return new h(c(this.event,W))}filter(W){return new h(s(this.event,W))}reduce(W,G){return new h(l(this.event,W,G))}latch(){return new h(v(this.event))}debounce(W,G=100,L=!1,U){return new h(a(this.event,W,G,L,U))}on(W,G,L){return this.event(W,G,L)}once(W,G,L){return w(this.event)(W,G,L)}}function p(H){return new h(H)}g.chain=p;function P(H,W,G=L=>L){const L=(...$)=>Q.fire(G(...$)),U=()=>H.on(W,L),x=()=>H.removeListener(W,L),Q=new b({onFirstListenerAdd:U,onLastListenerRemove:x});return Q.event}g.fromNodeEventEmitter=P;function F(H,W,G=L=>L){const L=(...$)=>Q.fire(G(...$)),U=()=>H.addEventListener(W,L),x=()=>H.removeEventListener(W,L),Q=new b({onFirstListenerAdd:U,onLastListenerRemove:x});return Q.event}g.fromDOMEventEmitter=F;function z(H){const W=new b;let G=!1;return H.then(void 0,()=>null).then(()=>{G?W.fire(void 0):setTimeout(()=>W.fire(void 0),0)}),G=!0,W.event}g.fromPromise=z;function le(H){return new Promise(W=>w(H)(W))}g.toPromise=le})(I=e.Event||(e.Event={}));class y{constructor(w){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${w}_${y._idPool++}`}start(w){this._stopWatch=new D.StopWatch(!0),this._listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this._elapsedOverall+=w,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${w.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let n=-1;function T(g){const w=n;return n=g,{dispose(){n=w}}}e.setGlobalLeakWarningThreshold=T;class k{constructor(w,u=Math.random().toString(18).slice(2,5)){this.customThreshold=w,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(w){let u=n;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),!(u<=0||w<u)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(c)||0;if(this._stacks.set(c,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,i=0;for(const[l,o]of this._stacks)(!t||i<o)&&(t=l,i=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class b{constructor(w){var u;this._disposed=!1,this._options=w,this._leakageMon=n>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(w,u,c)=>{var s;this._listeners||(this._listeners=new A.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(u?[w,u]:w);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,w,u);const l=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let o;return o={dispose:()=>{l&&l(),o.dispose=b._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof R.DisposableStore?c.add(o):Array.isArray(c)&&c.push(o),o}),this._event}fire(w){var u,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,w]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(i){(0,E.onUnexpectedError)(i)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var w,u,c;(w=this._listeners)===null||w===void 0||w.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=b,b._noop=function(){};class m extends b{constructor(w){super(w);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=w==null?void 0:w.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._listeners&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}e.PauseableEmitter=m;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const u={event:w,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const c=()=>{this.hasListeners&&this.unhook(u);const s=this.events.indexOf(u);this.events.splice(s,1)};return(0,R.toDisposable)((0,S.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(u=>this.emitter.fire(u))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class d{constructor(){this.buffers=[]}wrapEvent(w){return(u,c,s)=>w(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>u.call(c,t)):u.call(c,t)},void 0,s)}bufferEvents(w){const u=[];this.buffers.push(u);const c=w();return this.buffers.pop(),u.forEach(s=>s()),c}}e.EventBufferer=d;class _{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=R.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_}),define(be[20],we([0,1,3]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const S=Object.freeze(function(I,y){const n=setTimeout(I.bind(y),0);return{dispose(){clearTimeout(n)}}});var R;(function(I){function y(n){return n===I.None||n===I.Cancelled||n instanceof A?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}I.isCancellationToken=y,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:S})})(R=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?S:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=R.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=D}),define(be[37],we([0,1,3]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class S{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(T){const k=this._icons.get(T.id);k?T.description?k.description=T.description:console.error(`Duplicate registration of codicon ${T.id}`):(this._icons.set(T.id,T),this._onDidRegister.fire(T))}get(T){return this._icons.get(T)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new S;e.iconRegistry=R;function A(n,T){return new D(n,T)}e.registerCodicon=A;class D{constructor(T,k,b){this.id=T,this.definition=k,this.description=b,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function I(n,T){const k=["codicon","codicon-"+n];return T&&k.push("codicon-modifier-"+T),k}e.getClassNamesArray=I;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const T=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function k(r){if(r instanceof D)return["codicon","codicon-"+r.id];const d=T.exec(r.id);if(!d)return k(D.error);let[,_,g]=d;const w=["codicon","codicon-"+_];return g&&w.push("codicon-modifier-"+g.substr(1)),w}n.asClassNameArray=k;function b(r){return k(r).join(" ")}n.asClassName=b;function m(r){return"."+k(r).join(".")}n.asCSSSelector=m})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnknown=new n("workspace-unknown",{fontCharacter:"\\ebc3"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(be[107],we([0,1,10,6]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(_){const g=_;return g&&[g.on,g.pause,g.resume,g.destroy].every(w=>typeof w=="function")}e.isReadableStream=R;function A(_){const g=_;return g&&R(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean"}e.isReadableBufferedStream=A;function D(_,g){return new I(_,g)}e.newWriteableStream=D;class I{constructor(g,w){this.reducer=g,this.options=w,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){var w;if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof((w=this.options)===null||w===void 0?void 0:w.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(w=>w(g))}emitError(g){this.listeners.error.length===0?(0,E.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(w=>w(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,w){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(w),this.resume();break;case"end":this.listeners.end.push(w),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(w),this.state.flowing&&this.flowErrors();break}}removeListener(g,w){if(!this.state.destroyed){let u;switch(g){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const c=u.indexOf(w);c>=0&&u.splice(c,1)}}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const w=[...this.pendingWritePromises];this.pendingWritePromises.length=0,w.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(_,g){const w=[];let u;for(;(u=_.read())!==null;)w.push(u);return g(w)}e.consumeReadable=y;function n(_,g,w){const u=[];let c;for(;(c=_.read())!==null&&u.length<w;)u.push(c);return c===null&&u.length>0?g(u):{read:()=>{if(u.length>0)return u.shift();if(typeof c!="undefined"){const s=c;return c=void 0,s}return _.read()}}}e.peekReadable=n;function T(_,g){return new Promise((w,u)=>{const c=[];k(_,{onData:s=>{g&&c.push(s)},onError:s=>{g?u(s):w(void 0)},onEnd:()=>{w(g?g(c):void 0)}})})}e.consumeStream=T;function k(_,g){_.on("error",w=>g.onError(w)),_.on("end",()=>g.onEnd()),_.on("data",w=>g.onData(w))}e.listenStream=k;function b(_,g){return new Promise((w,u)=>{const c=new S.DisposableStore,s=[],t=o=>{if(s.push(o),s.length>g)return c.dispose(),_.pause(),w({stream:_,buffer:s,ended:!1})},i=o=>u(o),l=()=>w({stream:_,buffer:s,ended:!0});c.add((0,S.toDisposable)(()=>_.removeListener("error",i))),_.on("error",i),c.add((0,S.toDisposable)(()=>_.removeListener("end",l))),_.on("end",l),c.add((0,S.toDisposable)(()=>_.removeListener("data",t))),_.on("data",t)})}e.peekStream=b;function m(_,g){const w=D(g);return w.end(_),w}e.toStream=m;function r(_){let g=!1;return{read:()=>g?null:(g=!0,_)}}e.toReadable=r;function d(_,g,w){const u=D(w);return k(_,{onData:c=>u.write(g.data(c)),onError:c=>u.error(g.error?g.error(c):c),onEnd:()=>u.end()}),u}e.transform=d}),define(be[8],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function E(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=E;const S=/{(\d+)}/g;function R(B,...te){return te.length===0?B:B.replace(S,function(he,q){const J=parseInt(q,10);return isNaN(J)||J<0||J>=te.length?he:te[J]})}e.format=R;function A(B){return B.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=A;function D(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function I(B,te){let he=0;const q=te.charCodeAt(0);for(let J=B.length-1;J>=0;J--)B.charCodeAt(J)===q&&he++;return he}e.count=I;function y(B,te,he="\u2026"){return B.length<=te?B:`${B.substr(0,te)}${he}`}e.truncate=y;function n(B,te=" "){const he=T(B,te);return k(he,te)}e.trim=n;function T(B,te){if(!B||!te)return B;const he=te.length;if(he===0||B.length===0)return B;let q=0;for(;B.indexOf(te,q)===q;)q=q+he;return B.substring(q)}e.ltrim=T;function k(B,te){if(!B||!te)return B;const he=te.length,q=B.length;if(he===0||q===0)return B;let J=q,se=-1;for(;se=B.lastIndexOf(te,J-1),!(se===-1||se+he!==J);){if(se===0)return"";J=se}return B.substring(0,J)}e.rtrim=k;function b(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=b;function m(B){return B.replace(/\*/g,"")}e.stripWildcards=m;function r(B,te,he={}){if(!B)throw new Error("Cannot create regex from empty string");te||(B=D(B)),he.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let q="";return he.global&&(q+="g"),he.matchCase||(q+="i"),he.multiline&&(q+="m"),he.unicode&&(q+="u"),new RegExp(B,q)}e.createRegExp=r;function d(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function _(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function g(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=g;function w(B){return B.split(/\r\n|\r|\n/)}e.splitLines=w;function u(B){for(let te=0,he=B.length;te<he;te++){const q=B.charCodeAt(te);if(q!==32&&q!==9)return te}return-1}e.firstNonWhitespaceIndex=u;function c(B,te=0,he=B.length){for(let q=te;q<he;q++){const J=B.charCodeAt(q);if(J!==32&&J!==9)return B.substring(te,q)}return B.substring(te,he)}e.getLeadingWhitespace=c;function s(B,te=B.length-1){for(let he=te;he>=0;he--){const q=B.charCodeAt(he);if(q!==32&&q!==9)return he}return-1}e.lastNonWhitespaceIndex=s;function t(B,te){return B<te?-1:B>te?1:0}e.compare=t;function i(B,te,he=0,q=B.length,J=0,se=te.length){for(;he<q&&J<se;he++,J++){let We=B.charCodeAt(he),Ne=te.charCodeAt(J);if(We<Ne)return-1;if(We>Ne)return 1}const fe=q-he,pe=se-J;return fe<pe?-1:fe>pe?1:0}e.compareSubstring=i;function l(B,te){return o(B,te,0,B.length,0,te.length)}e.compareIgnoreCase=l;function o(B,te,he=0,q=B.length,J=0,se=te.length){for(;he<q&&J<se;he++,J++){let We=B.charCodeAt(he),Ne=te.charCodeAt(J);if(We!==Ne){const Ve=We-Ne;if(!(Ve===32&&f(Ne))&&!(Ve===-32&&f(We)))return a(We)&&a(Ne)?Ve:i(B.toLowerCase(),te.toLowerCase(),he,q,J,se)}}const fe=q-he,pe=se-J;return fe<pe?-1:fe>pe?1:0}e.compareSubstringIgnoreCase=o;function a(B){return B>=97&&B<=122}e.isLowerAsciiLetter=a;function f(B){return B>=65&&B<=90}e.isUpperAsciiLetter=f;function v(B){return a(B)||f(B)}function C(B,te){return B.length===te.length&&h(B,te)}e.equalsIgnoreCase=C;function h(B,te,he=B.length){for(let q=0;q<he;q++){const J=B.charCodeAt(q),se=te.charCodeAt(q);if(J!==se){if(v(J)&&v(se)){const fe=Math.abs(J-se);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(J).toLowerCase()!==String.fromCharCode(se).toLowerCase())return!1}}return!0}function p(B,te){const he=te.length;return te.length>B.length?!1:h(B,te,he)}e.startsWithIgnoreCase=p;function P(B,te){let he,q=Math.min(B.length,te.length);for(he=0;he<q;he++)if(B.charCodeAt(he)!==te.charCodeAt(he))return he;return q}e.commonPrefixLength=P;function F(B,te){let he,q=Math.min(B.length,te.length);const J=B.length-1,se=te.length-1;for(he=0;he<q;he++)if(B.charCodeAt(J-he)!==te.charCodeAt(se-he))return he;return q}e.commonSuffixLength=F;function z(B){return 55296<=B&&B<=56319}e.isHighSurrogate=z;function le(B){return 56320<=B&&B<=57343}e.isLowSurrogate=le;function H(B,te){return(B-55296<<10)+(te-56320)+65536}e.computeCodePoint=H;function W(B,te,he){const q=B.charCodeAt(he);if(z(q)&&he+1<te){const J=B.charCodeAt(he+1);if(le(J))return H(q,J)}return q}e.getNextCodePoint=W;function G(B,te){const he=B.charCodeAt(te-1);if(le(he)&&te>1){const q=B.charCodeAt(te-2);if(z(q))return H(q,he)}return he}function L(B,te){const he=Oe.getInstance(),q=te,J=B.length,se=W(B,J,te);te+=se>=65536?2:1;let fe=he.getGraphemeBreakType(se);for(;te<J;){const pe=W(B,J,te),We=he.getGraphemeBreakType(pe);if(Le(fe,We))break;te+=pe>=65536?2:1,fe=We}return te-q}e.nextCharLength=L;function U(B,te){const he=Oe.getInstance(),q=te,J=G(B,te);te-=J>=65536?2:1;let se=he.getGraphemeBreakType(J);for(;te>0;){const fe=G(B,te),pe=he.getGraphemeBreakType(fe);if(Le(pe,se))break;te-=fe>=65536?2:1,se=pe}return q-te}e.prevCharLength=U;function x(B,te){const he=Oe.getInstance(),q=B.length,J=te,se=W(B,q,te),fe=he.getGraphemeBreakType(se);te+=se>=65536?2:1;let pe=fe;for(;te<q;){const Ne=W(B,q,te),Ve=he.getGraphemeBreakType(Ne);if(Le(pe,Ve))break;te+=Ne>=65536?2:1,pe=Ve}const We=te;for(te=J,pe=fe;te>0;){const Ne=G(B,te),Ve=he.getGraphemeBreakType(Ne);if(Le(Ve,pe))break;te-=Ne>=65536?2:1,pe=Ve}return[te,We]}function Q(B,te){return te>0&&le(B.charCodeAt(te))?x(B,te-1):x(B,te)}e.getCharContainingOffset=Q;function $(B){const te=B.length;let he=0,q=0;for(;q<te;){const fe=W(B,te,q);q+=fe>=65536?2:1,fe<128?he+=1:fe<2048?he+=2:fe<65536?he+=3:he+=4}const J=new Uint8Array(he);q=0;let se=0;for(;q<te;){const fe=W(B,te,q);q+=fe>=65536?2:1,fe<128?J[se++]=fe:fe<2048?(J[se++]=192|(fe&1984)>>>6,J[se++]=128|(fe&63)>>>0):fe<65536?(J[se++]=224|(fe&61440)>>>12,J[se++]=128|(fe&4032)>>>6,J[se++]=128|(fe&63)>>>0):(J[se++]=240|(fe&1835008)>>>18,J[se++]=128|(fe&258048)>>>12,J[se++]=128|(fe&4032)>>>6,J[se++]=128|(fe&63)>>>0)}return J}e.encodeUTF8=$;function Z(B){const te=B.byteLength,he=[];let q=0;for(;q<te;){const J=B[q];let se;if(J>=240&&q+3<te?se=(B[q++]&7)<<18>>>0|(B[q++]&63)<<12>>>0|(B[q++]&63)<<6>>>0|(B[q++]&63)<<0>>>0:J>=224&&q+2<te?se=(B[q++]&15)<<12>>>0|(B[q++]&63)<<6>>>0|(B[q++]&63)<<0>>>0:J>=192&&q+1<te?se=(B[q++]&31)<<6>>>0|(B[q++]&63)<<0>>>0:se=B[q++],se>=0&&se<=55295||se>=57344&&se<=65535)he.push(String.fromCharCode(se));else if(se>=65536&&se<=1114111){const fe=se-65536,pe=55296+((fe&1047552)>>>10),We=56320+((fe&1023)>>>0);he.push(String.fromCharCode(pe)),he.push(String.fromCharCode(We))}else he.push(String.fromCharCode(65533))}return he.join("")}e.decodeUTF8=Z;const ie=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function re(B){return ie.test(B)}e.containsRTL=re;const ye=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ie(B){return ye.test(B)}e.containsEmoji=Ie;const Ue=/^[\t\n\r\x20-\x7E]*$/;function Fe(B){return Ue.test(B)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=ze;function N(B){for(let te=0,he=B.length;te<he;te++)if(K(B.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=N;function K(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=K;function ee(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=ee;function oe(B,te){if(B.length<te)return B;const he=/\b/g;let q=0;for(;he.test(B)&&!(B.length-he.lastIndex<te);)q=he.lastIndex,he.lastIndex+=1;return B.substring(q).replace(/^\s/,"")}e.lcut=oe;const me=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,Me=/\x1b\[0?m/g;function ge(B){return B&&(B=B.replace(me,""),B=B.replace(Se,""),B=B.replace(Me,"")),B}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Pe(B){return Ce(B)?B.substr(1):B}e.stripUTF8BOM=Pe;function xe(B,te){if(!B||!te||B.length<te.length)return!1;const he=te.length,q=B.toLowerCase();let J=0,se=-1;for(;J<he;){const fe=q.indexOf(te[J],se+1);if(fe<0)return!1;se=fe,J++}return!0}e.fuzzyContains=xe;function _e(B,te=!1){return B?(te&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=_e;function qe(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=qe;function V(B,te=1){if(te===0)return"";let he=-1;do he=B.indexOf(`
`,he+1),te--;while(te>0&&he>=0);return he===-1?B:(B[he-1]==="\r"&&he--,B.substr(0,he))}e.getNLines=V;function Y(B){const te=90-65+1;return B=B%(2*te),B<te?String.fromCharCode(97+B):String.fromCharCode(65+B-te)}e.singleLetterHash=Y;function ve(B){return Oe.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=ve;function Le(B,te){return B===0?te!==5&&te!==7:B===2&&te===3?!1:B===4||B===2||B===3||te===4||te===2||te===3?!0:!(B===8&&(te===8||te===9||te===11||te===12)||(B===11||B===9)&&(te===9||te===10)||(B===12||B===10)&&te===10||te===5||te===13||te===7||B===1||B===13&&te===14||B===6&&te===6)}e.breakBetweenGraphemeBreakType=Le;var Be;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(Be=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=et()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const he=this._data,q=he.length/3;let J=1;for(;J<=q;)if(te<he[3*J])J=2*J;else if(te>he[3*J+1])J=2*J+1;else return he[3*J+2];return 0}}Oe._INSTANCE=null;function et(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(be[26],we([0,1,8,107]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",D=typeof TextDecoder!="undefined";let I,y;class n{constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}static alloc(a){return R?new n(Buffer.allocUnsafe(a)):new n(new Uint8Array(a))}static wrap(a){return R&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new n(a)}static fromString(a,f){return!((f==null?void 0:f.dontUseNodeBuffer)||!1)&&R?new n(Buffer.from(a)):A?(I||(I=new TextEncoder),new n(I.encode(a))):new n(E.encodeUTF8(a))}static concat(a,f){if(typeof f=="undefined"){f=0;for(let h=0,p=a.length;h<p;h++)f+=a[h].byteLength}const v=n.alloc(f);let C=0;for(let h=0,p=a.length;h<p;h++){const P=a[h];v.set(P,C),C+=P.byteLength}return v}toString(){return R?this.buffer.toString():D?(y||(y=new TextDecoder),y.decode(this.buffer)):E.decodeUTF8(this.buffer)}slice(a,f){return new n(this.buffer.subarray(a,f))}set(a,f){a instanceof n?this.buffer.set(a.buffer,f):this.buffer.set(a,f)}readUInt32BE(a){return b(this.buffer,a)}writeUInt32BE(a,f){m(this.buffer,a,f)}readUInt32LE(a){return r(this.buffer,a)}writeUInt32LE(a,f){d(this.buffer,a,f)}readUInt8(a){return _(this.buffer,a)}writeUInt8(a,f){g(this.buffer,a,f)}}e.VSBuffer=n;function T(o,a){return o[a+0]<<0>>>0|o[a+1]<<8>>>0}e.readUInt16LE=T;function k(o,a,f){o[f+0]=a&255,a=a>>>8,o[f+1]=a&255}e.writeUInt16LE=k;function b(o,a){return o[a]*2**24+o[a+1]*2**16+o[a+2]*2**8+o[a+3]}e.readUInt32BE=b;function m(o,a,f){o[f+3]=a,a=a>>>8,o[f+2]=a,a=a>>>8,o[f+1]=a,a=a>>>8,o[f]=a}e.writeUInt32BE=m;function r(o,a){return o[a+0]<<0>>>0|o[a+1]<<8>>>0|o[a+2]<<16>>>0|o[a+3]<<24>>>0}e.readUInt32LE=r;function d(o,a,f){o[f+0]=a&255,a=a>>>8,o[f+1]=a&255,a=a>>>8,o[f+2]=a&255,a=a>>>8,o[f+3]=a&255}e.writeUInt32LE=d;function _(o,a){return o[a]}e.readUInt8=_;function g(o,a,f){o[f]=a}e.writeUInt8=g;function w(o){return S.consumeReadable(o,a=>n.concat(a))}e.readableToBuffer=w;function u(o){return S.toReadable(o)}e.bufferToReadable=u;function c(o){return S.consumeStream(o,a=>n.concat(a))}e.streamToBuffer=c;async function s(o){return o.ended?n.concat(o.buffer):n.concat([...o.buffer,await c(o.stream)])}e.bufferedStreamToBuffer=s;function t(o){return S.toStream(o,a=>n.concat(a))}e.bufferToStream=t;function i(o){return S.transform(o,{data:a=>typeof a=="string"?n.fromString(a):n.wrap(a)},a=>n.concat(a))}e.streamToBufferReadableStream=i;function l(o){return S.newWriteableStream(a=>n.concat(a),o)}e.newWriteableBufferStream=l}),define(be[56],we([0,1,8]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function S(g){return R(g,0)}e.hash=S;function R(g,w){switch(typeof g){case"object":return g===null?A(349,w):Array.isArray(g)?y(g,w):n(g,w);case"string":return I(g,w);case"boolean":return D(g,w);case"number":return A(g,w);case"undefined":return A(937,w);default:return A(617,w)}}e.doHash=R;function A(g,w){return(w<<5)-w+g|0}function D(g,w){return A(g?433:863,w)}function I(g,w){w=A(149417,w);for(let u=0,c=g.length;u<c;u++)w=A(g.charCodeAt(u),w);return w}e.stringHash=I;function y(g,w){return w=A(104579,w),g.reduce((u,c)=>R(c,u),w)}function n(g,w){return w=A(181387,w),Object.keys(g).sort().reduce((u,c)=>(u=I(c,u),R(g[c],u)),w)}class T{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=R(w,this._value),this._value}}e.Hasher=T;var k;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function b(g,w,u=32){const c=u-w,s=~((1<<c)-1);return(g<<w|(s&g)>>>c)>>>0}function m(g,w=0,u=g.byteLength,c=0){for(let s=0;s<u;s++)g[w+s]=c}function r(g,w,u="0"){for(;g.length<w;)g=u+g;return g}function d(g,w=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(u=>u.toString(16).padStart(2,"0")).join(""):r((g>>>0).toString(16),w/4)}e.toHexString=d;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const u=w.length;if(u!==0){const c=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,i,l;for(t!==0?(i=t,l=-1,t=0):(i=w.charCodeAt(0),l=0);;){let o=i;if(E.isHighSurrogate(i))if(l+1<u){const a=w.charCodeAt(l+1);E.isLowSurrogate(a)?(l++,o=E.computeCodePoint(i,a)):o=65533}else{t=i;break}else E.isLowSurrogate(i)&&(o=65533);if(s=this._push(c,s,o),l++,l<u)i=w.charCodeAt(l);else break}this._buffLen=s,this._leftoverHighSurrogate=t}}_push(w,u,c){return c<128?w[u++]=c:c<2048?(w[u++]=192|(c&1984)>>>6,w[u++]=128|(c&63)>>>0):c<65536?(w[u++]=224|(c&61440)>>>12,w[u++]=128|(c&4032)>>>6,w[u++]=128|(c&63)>>>0):(w[u++]=240|(c&1835008)>>>18,w[u++]=128|(c&258048)>>>12,w[u++]=128|(c&4032)>>>6,w[u++]=128|(c&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=_._bigBlock32,u=this._buffDV;for(let v=0;v<64;v+=4)w.setUint32(v,u.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)w.setUint32(v,b(w.getUint32(v-12,!1)^w.getUint32(v-32,!1)^w.getUint32(v-56,!1)^w.getUint32(v-64,!1),1),!1);let c=this._h0,s=this._h1,t=this._h2,i=this._h3,l=this._h4,o,a,f;for(let v=0;v<80;v++)v<20?(o=s&t|~s&i,a=1518500249):v<40?(o=s^t^i,a=1859775393):v<60?(o=s&t|s&i|t&i,a=2400959708):(o=s^t^i,a=3395469782),f=b(c,5)+o+l+a+w.getUint32(v*4,!1)&4294967295,l=i,i=t,t=b(s,30),s=c,c=f;this._h0=this._h0+c&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+l&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[46],we([0,1,8]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var S;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(S||(S={})),function(R){const A="error",D="warning",I="warn",y="info";function n(T){return T?E.equalsIgnoreCase(A,T)?R.Error:E.equalsIgnoreCase(D,T)||E.equalsIgnoreCase(I,T)?R.Warning:E.equalsIgnoreCase(y,T)?R.Info:R.Ignore:R.Ignore}R.fromValue=n}(S||(S={})),e.default=S}),define(be[12],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(f){return Array.isArray(f)}e.isArray=E;function S(f){return typeof f=="string"}e.isString=S;function R(f){return Array.isArray(f)&&f.every(v=>S(v))}e.isStringArray=R;function A(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=A;function D(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=D;function I(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=I;function y(f){return f===!0||f===!1}e.isBoolean=y;function n(f){return typeof f=="undefined"}e.isUndefined=n;function T(f){return!k(f)}e.isDefined=T;function k(f){return n(f)||f===null}e.isUndefinedOrNull=k;function b(f,v){if(!f)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=b;function m(f){if(k(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=m;function r(...f){const v=[];for(let C=0;C<f.length;C++){const h=f[C];if(k(h))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);v.push(h)}return v}e.assertAllDefined=r;const d=Object.prototype.hasOwnProperty;function _(f){if(!A(f))return!1;for(let v in f)if(d.call(f,v))return!1;return!0}e.isEmptyObject=_;function g(f){return typeof f=="function"}e.isFunction=g;function w(...f){return f.length>0&&f.every(g)}e.areFunctions=w;function u(f,v){const C=Math.min(f.length,v.length);for(let h=0;h<C;h++)c(f[h],v[h])}e.validateConstraints=u;function c(f,v){if(S(v)){if(typeof f!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(g(v)){try{if(f instanceof v)return}catch(C){}if(!k(f)&&f.constructor===v||v.length===1&&v.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function s(f){let v=[],C=Object.getPrototypeOf(f);for(;Object.prototype!==C;)v=v.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return v}e.getAllPropertyNames=s;function t(f){const v=[];for(const C of s(f))typeof f[C]=="function"&&v.push(C);return v}e.getAllMethodNames=t;function i(f,v){const C=p=>function(){const P=Array.prototype.slice.call(arguments,0);return v(p,P)};let h={};for(const p of f)h[p]=C(p);return h}e.createProxyObject=i;function l(f){return f===null?void 0:f}e.withNullAsUndefined=l;function o(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=o;function a(f){return class{constructor(){return new Proxy({},{get(v,C){if(v[C])return v[C];throw new Error(`Not Implemented: ${f}->${String(C)}`)}})}}}e.NotImplementedProxy=a}),define(be[38],we([0,1,21,8,11,12]),function(ae,e,E,S,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function D(i){return i===47||i===92}e.isPathSeparator=D;function I(i){return i.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=I;function y(i,l=R.posix.sep){if(!i)return"";const o=i.length,a=i.charCodeAt(0);if(D(a)){if(D(i.charCodeAt(1))&&!D(i.charCodeAt(2))){let v=3;const C=v;for(;v<o&&!D(i.charCodeAt(v));v++);if(C!==v&&!D(i.charCodeAt(v+1))){for(v+=1;v<o;v++)if(D(i.charCodeAt(v)))return i.slice(0,v+1).replace(/[\\/]/g,l)}}return l}else if(_(a)&&i.charCodeAt(1)===58)return D(i.charCodeAt(2))?i.slice(0,2)+l:i.slice(0,2);let f=i.indexOf("://");if(f!==-1){for(f+=3;f<o;f++)if(D(i.charCodeAt(f)))return i.slice(0,f+1)}return""}e.getRoot=y;function n(i){if(!E.isWindows||!i||i.length<5)return!1;let l=i.charCodeAt(0);if(l!==92||(l=i.charCodeAt(1),l!==92))return!1;let o=2;const a=o;for(;o<i.length&&(l=i.charCodeAt(o),l!==92);o++);return!(a===o||(l=i.charCodeAt(o+1),isNaN(l)||l===92))}e.isUNC=n;const T=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(i,l=E.isWindows){const o=l?T:k;return!(!i||i.length===0||/^\s+$/.test(i)||(o.lastIndex=0,o.test(i))||l&&b.test(i)||i==="."||i===".."||l&&i[i.length-1]==="."||l&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=m;function r(i,l,o){const a=i===l;return!o||a?a:!i||!l?!1:(0,S.equalsIgnoreCase)(i,l)}e.isEqual=r;function d(i,l,o,a=R.sep){if(i===l)return!0;if(!i||!l||l.length>i.length)return!1;if(o){if(!(0,S.startsWithIgnoreCase)(i,l))return!1;if(l.length===i.length)return!0;let v=l.length;return l.charAt(l.length-1)===a&&v--,i.charAt(v)===a}return l.charAt(l.length-1)!==a&&(l+=a),i.indexOf(l)===0}e.isEqualOrParent=d;function _(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=_;function g(i,l){return E.isWindows&&i.endsWith(":")&&(i+=R.sep),(0,R.isAbsolute)(i)||(i=(0,R.join)(l,i)),i=(0,R.normalize)(i),E.isWindows?(i=(0,S.rtrim)(i,R.sep),i.endsWith(":")&&(i+=R.sep)):(i=(0,S.rtrim)(i,R.sep),i||(i=R.sep)),i}e.sanitizeFilePath=g;function w(i){const l=(0,R.normalize)(i);return E.isWindows?i.length>3?!1:u(l)&&(i.length===2||l.charCodeAt(2)===92):l===R.posix.sep}e.isRootOrDriveLetter=w;function u(i){return E.isWindows?_(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function c(i){return u(i)?i[0]:void 0}e.getDriveLetter=c;function s(i,l,o){return l.length>i.length?-1:i===l?0:(o&&(i=i.toLowerCase(),l=l.toLowerCase()),i.indexOf(l))}e.indexOfPath=s;function t(i){const l=i.split(":");let o,a,f;if(l.forEach(v=>{const C=Number(v);(0,A.isNumber)(C)?a===void 0?a=C:f===void 0&&(f=C):o=o?[o,v].join(":"):v}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:a!==void 0?a:void 0,column:f!==void 0?f:a!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(be[23],we([0,1,12]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function S(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const d=Array.isArray(r)?[]:{};return Object.keys(r).forEach(_=>{r[_]&&typeof r[_]=="object"?d[_]=S(r[_]):d[_]=r[_]}),d}e.deepClone=S;function R(r){if(!r||typeof r!="object")return r;const d=[r];for(;d.length>0;){const _=d.shift();Object.freeze(_);for(const g in _)if(A.call(_,g)){const w=_[g];typeof w=="object"&&!Object.isFrozen(w)&&d.push(w)}}return r}e.deepFreeze=R;const A=Object.prototype.hasOwnProperty;function D(r,d){return I(r,d,new Set)}e.cloneAndChange=D;function I(r,d,_){if((0,E.isUndefinedOrNull)(r))return r;const g=d(r);if(typeof g!="undefined")return g;if((0,E.isArray)(r)){const w=[];for(const u of r)w.push(I(u,d,_));return w}if((0,E.isObject)(r)){if(_.has(r))throw new Error("Cannot clone recursive data-structure");_.add(r);const w={};for(let u in r)A.call(r,u)&&(w[u]=I(r[u],d,_));return _.delete(r),w}return r}function y(r,d,_=!0){return(0,E.isObject)(r)?((0,E.isObject)(d)&&Object.keys(d).forEach(g=>{g in r?_&&((0,E.isObject)(r[g])&&(0,E.isObject)(d[g])?y(r[g],d[g],_):r[g]=d[g]):r[g]=d[g]}),r):d}e.mixin=y;function n(r,d){if(r===d)return!0;if(r==null||d===null||d===void 0||typeof r!=typeof d||typeof r!="object"||Array.isArray(r)!==Array.isArray(d))return!1;let _,g;if(Array.isArray(r)){if(r.length!==d.length)return!1;for(_=0;_<r.length;_++)if(!n(r[_],d[_]))return!1}else{const w=[];for(g in r)w.push(g);w.sort();const u=[];for(g in d)u.push(g);if(u.sort(),!n(w,u))return!1;for(_=0;_<w.length;_++)if(!n(r[w[_]],d[w[_]]))return!1}return!0}e.equals=n;function T(r){const d=new Set;return JSON.stringify(r,(_,g)=>{if((0,E.isObject)(g)||Array.isArray(g)){if(d.has(g))return"[Circular]";d.add(g)}return g})}e.safeStringify=T;function k(r,d,_){const g=d(r);return typeof g=="undefined"?_:g}e.getOrDefault=k;function b(r,d){const _=Object.create(null);return!r||!d||Object.keys(d).forEach(w=>{const u=r[w],c=d[w];n(u,c)||(_[w]=c)}),_}e.distinct=b;function m(r,d){const _=d.toLowerCase(),g=Object.keys(r).find(w=>w.toLowerCase()===_);return g?r[g]:r[d]}e.getCaseInsensitive=m}),define(be[79],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var E;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(E=e.Constants||(e.Constants={}));function S(A){return A<0?0:A>255?255:A|0}e.toUint8=S;function R(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=R}),define(be[2],we([0,1,21,11]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,A=/^\//,D=/^\/\//;function I(l,o){if(!l.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!R.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!A.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(l,o){return!l&&!o?"file":l}function n(l,o){switch(l){case"https":case"http":case"file":o?o[0]!==k&&(o=k+o):o=k;break}return o}const T="",k="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(o,a,f,v,C,h=!1){typeof o=="object"?(this.scheme=o.scheme||T,this.authority=o.authority||T,this.path=o.path||T,this.query=o.query||T,this.fragment=o.fragment||T):(this.scheme=y(o,h),this.authority=a||T,this.path=n(this.scheme,f||T),this.query=v||T,this.fragment=C||T,I(this,h))}static isUri(o){return o instanceof m?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return u(this,!1)}with(o){if(!o)return this;let{scheme:a,authority:f,path:v,query:C,fragment:h}=o;return a===void 0?a=this.scheme:a===null&&(a=T),f===void 0?f=this.authority:f===null&&(f=T),v===void 0?v=this.path:v===null&&(v=T),C===void 0?C=this.query:C===null&&(C=T),h===void 0?h=this.fragment:h===null&&(h=T),a===this.scheme&&f===this.authority&&v===this.path&&C===this.query&&h===this.fragment?this:new d(a,f,v,C,h)}static parse(o,a=!1){const f=b.exec(o);return f?new d(f[2]||T,i(f[4]||T),i(f[5]||T),i(f[7]||T),i(f[9]||T),a):new d(T,T,T,T,T)}static file(o){let a=T;if(E.isWindows&&(o=o.replace(/\\/g,k)),o[0]===k&&o[1]===k){const f=o.indexOf(k,2);f===-1?(a=o.substring(2),o=k):(a=o.substring(2,f),o=o.substring(f)||k)}return new d("file",a,o,T,T)}static from(o){return new d(o.scheme,o.authority,o.path,o.query,o.fragment)}static joinPath(o,...a){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return E.isWindows&&o.scheme==="file"?f=m.file(S.win32.join(u(o,!0),...a)).path:f=S.posix.join(o.path,...a),o.with({path:f})}toString(o=!1){return c(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof m)return o;{const a=new d(o);return a._formatted=o.external,a._fsPath=o._sep===r?o.fsPath:null,a}}else return o}}e.URI=m;const r=E.isWindows?1:void 0;class d extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(o=!1){return o?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=r),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(l,o){let a,f=-1;for(let v=0;v<l.length;v++){const C=l.charCodeAt(v);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||o&&C===47)f!==-1&&(a+=encodeURIComponent(l.substring(f,v)),f=-1),a!==void 0&&(a+=l.charAt(v));else{a===void 0&&(a=l.substr(0,v));const h=_[C];h!==void 0?(f!==-1&&(a+=encodeURIComponent(l.substring(f,v)),f=-1),a+=h):f===-1&&(f=v)}}return f!==-1&&(a+=encodeURIComponent(l.substring(f))),a!==void 0?a:l}function w(l){let o;for(let a=0;a<l.length;a++){const f=l.charCodeAt(a);f===35||f===63?(o===void 0&&(o=l.substr(0,a)),o+=_[f]):o!==void 0&&(o+=l[a])}return o!==void 0?o:l}function u(l,o){let a;return l.authority&&l.path.length>1&&l.scheme==="file"?a=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?o?a=l.path.substr(1):a=l.path[1].toLowerCase()+l.path.substr(2):a=l.path,E.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=u;function c(l,o){const a=o?w:g;let f="",{scheme:v,authority:C,path:h,query:p,fragment:P}=l;if(v&&(f+=v,f+=":"),(C||v==="file")&&(f+=k,f+=k),C){let F=C.indexOf("@");if(F!==-1){const z=C.substr(0,F);C=C.substr(F+1),F=z.indexOf(":"),F===-1?f+=a(z,!1):(f+=a(z.substr(0,F),!1),f+=":",f+=a(z.substr(F+1),!1)),f+="@"}C=C.toLowerCase(),F=C.indexOf(":"),F===-1?f+=a(C,!1):(f+=a(C.substr(0,F),!1),f+=C.substr(F))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const F=h.charCodeAt(1);F>=65&&F<=90&&(h=`/${String.fromCharCode(F+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const F=h.charCodeAt(0);F>=65&&F<=90&&(h=`${String.fromCharCode(F+32)}:${h.substr(2)}`)}f+=a(h,!0)}return p&&(f+="?",f+=a(p,!1)),P&&(f+="#",f+=o?P:g(P,!1)),f}function s(l){try{return decodeURIComponent(l)}catch(o){return l.length>3?l.substr(0,3)+s(l.substr(3)):l}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(l){return l.match(t)?l.replace(t,o=>s(o)):l}}),define(be[22],we([0,1,2,8]),function(ae,e,E,S){"use strict";var R,A;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(c,s,t){let i=c.get(s);return i===void 0&&(i=t,c.set(s,i)),i}e.getOrSet=D;function I(c){const s=[];return c.forEach((t,i)=>{s.push(`${i} => ${t}`)}),`Map(${c.size}) {${s.join(", ")}}`}e.mapToString=I;function y(c){const s=[];return c.forEach(t=>{s.push(t)}),`Set(${c.size}) {${s.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const t=s.charCodeAt(0),i=this._value.charCodeAt(this._pos);return t-i}value(){return this._value[this._pos]}}e.StringIterator=n;class T{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,S.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,S.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class k{constructor(s=!0,t=!0){this._splitOnBackslash=s,this._caseSensitive=t}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,S.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,S.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var b;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(b||(b={}));class m{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,S.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,S.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,S.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,S.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class r{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class d{constructor(s){this._iter=s}static forUris(s=()=>!1){return new d(new m(s))}static forPaths(){return new d(new k)}static forStrings(){return new d(new n)}static forConfigKeys(){return new d(new T)}clear(){this._root=void 0}set(s,t){const i=this._iter.reset(s);let l;for(this._root||(this._root=new r,this._root.segment=i.value()),l=this._root;;){const a=i.cmp(l.segment);if(a>0)l.left||(l.left=new r,l.left.segment=i.value()),l=l.left;else if(a<0)l.right||(l.right=new r,l.right.segment=i.value()),l=l.right;else if(i.hasNext())i.next(),l.mid||(l.mid=new r,l.mid.segment=i.value()),l=l.mid;else break}const o=l.value;return l.value=t,l.key=s,o}get(s){var t;return(t=this._getNode(s))===null||t===void 0?void 0:t.value}_getNode(s){const t=this._iter.reset(s);let i=this._root;for(;i;){const l=t.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else break}return i}has(s){const t=this._getNode(s);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,t){const i=this._iter.reset(s),l=[];let o=this._root;for(;o;){const a=i.cmp(o.segment);if(a>0)l.push([1,o]),o=o.left;else if(a<0)l.push([-1,o]),o=o.right;else if(i.hasNext())i.next(),l.push([0,o]),o=o.mid;else{for(t?(o.left=void 0,o.mid=void 0,o.right=void 0):o.value=void 0;l.length>0&&o.isEmpty();){let[f,v]=l.pop();switch(f){case 1:v.left=void 0;break;case 0:v.mid=void 0;break;case-1:v.right=void 0;break}o=v}break}}}findSubstr(s){const t=this._iter.reset(s);let i=this._root,l;for(;i;){const o=t.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(t.hasNext())t.next(),l=i.value||l,i=i.mid;else break}return i&&i.value||l}findSuperstr(s){const t=this._iter.reset(s);let i=this._root;for(;i;){const l=t.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(s){for(const[t,i]of this)s(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){s&&(yield*this._entries(s.left),s.value&&(yield[s.key,s.value]),yield*this._entries(s.mid),yield*this._entries(s.right))}}e.TernarySearchTree=d;class _{constructor(s,t){this[R]="ResourceMap",s instanceof _?(this.map=new Map(s.map),this.toKey=t!=null?t:_.defaultToKey):(this.map=new Map,this.toKey=s!=null?s:_.defaultToKey)}set(s,t){return this.map.set(this.toKey(s),t),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,t){typeof t!="undefined"&&(s=s.bind(t));for(let[i,l]of this.map)s(l,E.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield E.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[E.URI.parse(s[0]),s[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[E.URI.parse(s[0]),s[1]]}}e.ResourceMap=_,_.defaultToKey=c=>c.toString();var g;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class w{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,t=0){const i=this._map.get(s);if(!!i)return t!==0&&this.touch(i,t),i.value}set(s,t,i=0){let l=this._map.get(s);if(l)l.value=t,i!==0&&this.touch(l,i);else{switch(l={key:s,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(s,l),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const t=this._map.get(s);if(!!t)return this._map.delete(s),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}}forEach(s,t){const i=this._state;let l=this._head;for(;l;){if(t?s.bind(t)(l.value,l.key,this):s(l.value,l.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const s=this,t=this._state;let i=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const o={value:i.key,done:!1};return i=i.next,o}else return{value:void 0,done:!0}}};return l}values(){const s=this,t=this._state;let i=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const o={value:i.value,done:!1};return i=i.next,o}else return{value:void 0,done:!0}}};return l}entries(){const s=this,t=this._state;let i=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const o={value:[i.key,i.value],done:!1};return i=i.next,o}else return{value:void 0,done:!0}}};return l}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(!(s>=this.size)){if(s===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>s;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const t=s.next,i=s.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}s.next=void 0,s.previous=void 0,this._state++}touch(s,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(s===this._head)return;const i=s.next,l=s.previous;s===this._tail?(l.next=void 0,this._tail=l):(i.previous=l,l.next=i),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(t===2){if(s===this._tail)return;const i=s.next,l=s.previous;s===this._head?(i.previous=void 0,this._head=i):(i.previous=l,l.next=i),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((t,i)=>{s.push([i,t])}),s}fromJSON(s){this.clear();for(const[t,i]of s)this.set(t,i)}}e.LinkedMap=w;class u extends w{constructor(s,t=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,t=2){return super.get(s,t)}peek(s){return super.get(s,0)}set(s,t){return super.set(s,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(be[108],we([0,1,22,8]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function R(...ge){return function(Ce,Pe){for(let xe=0,_e=ge.length;xe<_e;xe++){const qe=ge[xe](Ce,Pe);if(qe)return qe}return null}}e.or=R,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ge,Ce,Pe){if(!Pe||Pe.length<Ce.length)return null;let xe;return ge?xe=S.startsWithIgnoreCase(Pe,Ce):xe=Pe.indexOf(Ce)===0,xe?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function D(ge,Ce){const Pe=Ce.toLowerCase().indexOf(ge.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+ge.length}]}e.matchesContiguousSubString=D;function I(ge,Ce){return y(ge.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=I;function y(ge,Ce,Pe,xe){if(Pe===ge.length)return[];if(xe===Ce.length)return null;if(ge[Pe]===Ce[xe]){let _e=null;return(_e=y(ge,Ce,Pe+1,xe+1))?g({start:xe,end:xe+1},_e):null}return y(ge,Ce,Pe,xe+1)}function n(ge){return 97<=ge&&ge<=122}function T(ge){return 65<=ge&&ge<=90}e.isUpper=T;function k(ge){return 48<=ge&&ge<=57}function b(ge){return ge===32||ge===9||ge===10||ge===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>m.add(ge.charCodeAt(0)));function r(ge){return b(ge)||m.has(ge)}function d(ge,Ce){return ge===Ce||r(ge)&&r(Ce)}function _(ge){return n(ge)||T(ge)||k(ge)}function g(ge,Ce){return Ce.length===0?Ce=[ge]:ge.end===Ce[0].start?Ce[0].start=ge.start:Ce.unshift(ge),Ce}function w(ge,Ce){for(let Pe=Ce;Pe<ge.length;Pe++){const xe=ge.charCodeAt(Pe);if(T(xe)||k(xe)||Pe>0&&!_(ge.charCodeAt(Pe-1)))return Pe}return ge.length}function u(ge,Ce,Pe,xe){if(Pe===ge.length)return[];if(xe===Ce.length)return null;if(ge[Pe]!==Ce[xe].toLowerCase())return null;{let _e=null,qe=xe+1;for(_e=u(ge,Ce,Pe+1,xe+1);!_e&&(qe=w(Ce,qe))<Ce.length;)_e=u(ge,Ce,Pe+1,qe),qe++;return _e===null?null:g({start:xe,end:xe+1},_e)}}function c(ge){let Ce=0,Pe=0,xe=0,_e=0,qe=0;for(let Be=0;Be<ge.length;Be++)qe=ge.charCodeAt(Be),T(qe)&&Ce++,n(qe)&&Pe++,_(qe)&&xe++,k(qe)&&_e++;const V=Ce/ge.length,Y=Pe/ge.length,ve=xe/ge.length,Le=_e/ge.length;return{upperPercent:V,lowerPercent:Y,alphaPercent:ve,numericPercent:Le}}function s(ge){const{upperPercent:Ce,lowerPercent:Pe}=ge;return Pe===0&&Ce>.6}function t(ge){const{upperPercent:Ce,lowerPercent:Pe,alphaPercent:xe,numericPercent:_e}=ge;return Pe>.2&&Ce<.8&&xe>.6&&_e<.2}function i(ge){let Ce=0,Pe=0,xe=0,_e=0;for(let qe=0;qe<ge.length;qe++)xe=ge.charCodeAt(qe),T(xe)&&Ce++,n(xe)&&Pe++,b(xe)&&_e++;return(Ce===0||Pe===0)&&_e===0?ge.length<=30:Ce<=5}function l(ge,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!i(ge)||Ce.length>60)return null;const Pe=c(Ce);if(!t(Pe)){if(!s(Pe))return null;Ce=Ce.toLowerCase()}let xe=null,_e=0;for(ge=ge.toLowerCase();_e<Ce.length&&(xe=u(ge,Ce,0,_e))===null;)_e=w(Ce,_e+1);return xe}e.matchesCamelCase=l;function o(ge,Ce,Pe=!1){if(!Ce||Ce.length===0)return null;let xe=null,_e=0;for(ge=ge.toLowerCase(),Ce=Ce.toLowerCase();_e<Ce.length&&(xe=a(ge,Ce,0,_e,Pe))===null;)_e=f(Ce,_e+1);return xe}e.matchesWords=o;function a(ge,Ce,Pe,xe,_e){if(Pe===ge.length)return[];if(xe===Ce.length)return null;if(d(ge.charCodeAt(Pe),Ce.charCodeAt(xe))){let qe=null,V=xe+1;if(qe=a(ge,Ce,Pe+1,xe+1,_e),!_e)for(;!qe&&(V=f(Ce,V))<Ce.length;)qe=a(ge,Ce,Pe+1,V,_e),V++;return qe===null?null:g({start:xe,end:xe+1},qe)}else return null}function f(ge,Ce){for(let Pe=Ce;Pe<ge.length;Pe++)if(r(ge.charCodeAt(Pe))||Pe>0&&r(ge.charCodeAt(Pe-1)))return Pe;return ge.length}const v=R(e.matchesPrefix,l,D),C=R(e.matchesPrefix,l,I),h=new E.LRUCache(1e4);function p(ge,Ce,Pe=!1){if(typeof ge!="string"||typeof Ce!="string")return null;let xe=h.get(ge);xe||(xe=new RegExp(S.convertSimple2RegExpPattern(ge),"i"),h.set(ge,xe));const _e=xe.exec(Ce);return _e?[{start:_e.index,end:_e.index+_e[0].length}]:Pe?C(ge,Ce):v(ge,Ce)}e.matchesFuzzy=p;function P(ge,Ce){const Pe=N(ge,ge.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Pe?z(Pe):null}e.matchesFuzzy2=P;function F(ge,Ce,Pe,xe,_e,qe){const V=Math.min(13,ge.length);for(;Pe<V;Pe++){const Y=N(ge,Ce,Pe,xe,_e,qe,!1);if(Y)return Y}return[0,qe]}e.anyScore=F;function z(ge){if(typeof ge=="undefined")return[];const Ce=[],Pe=ge[1];for(let xe=ge.length-1;xe>1;xe--){const _e=ge[xe]+Pe,qe=Ce[Ce.length-1];qe&&qe.end===_e?qe.end=_e+1:Ce.push({start:_e,end:_e+1})}return Ce}e.createMatches=z;const le=128;function H(){const ge=[],Ce=[];for(let Pe=0;Pe<=le;Pe++)Ce[Pe]=0;for(let Pe=0;Pe<=le;Pe++)ge.push(Ce.slice(0));return ge}function W(ge){const Ce=[];for(let Pe=0;Pe<=ge;Pe++)Ce[Pe]=0;return Ce}const G=W(2*le),L=W(2*le),U=H(),x=H(),Q=H(),$=!1;function Z(ge,Ce,Pe,xe,_e){function qe(Y,ve,Le=" "){for(;Y.length<ve;)Y=Le+Y;return Y}let V=` |   |${xe.split("").map(Y=>qe(Y,3)).join("|")}
`;for(let Y=0;Y<=Pe;Y++)Y===0?V+=" |":V+=`${Ce[Y-1]}|`,V+=ge[Y].slice(0,_e+1).map(ve=>qe(ve.toString(),3)).join("|")+`
`;return V}function ie(ge,Ce,Pe,xe){ge=ge.substr(Ce),Pe=Pe.substr(xe),console.log(Z(x,ge,ge.length,Pe,Pe.length)),console.log(Z(Q,ge,ge.length,Pe,Pe.length)),console.log(Z(U,ge,ge.length,Pe,Pe.length))}function re(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;const Pe=ge.codePointAt(Ce);switch(Pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!S.isEmojiImprecise(Pe)}}function ye(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;switch(ge.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Ie(ge,Ce,Pe){return Ce[ge]!==Pe[ge]}function Ue(ge,Ce,Pe,xe,_e,qe,V=!1){for(;Ce<Pe&&_e<qe;)ge[Ce]===xe[_e]&&(V&&(G[Ce]=_e),Ce+=1),_e+=1;return Ce===Pe}e.isPatternInWord=Ue;var Fe;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var ze;(function(ge){ge.Default=[-100,0];function Ce(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}ge.isDefault=Ce})(ze=e.FuzzyScore||(e.FuzzyScore={}));function N(ge,Ce,Pe,xe,_e,qe,V){const Y=ge.length>le?le:ge.length,ve=xe.length>le?le:xe.length;if(!(Pe>=Y||qe>=ve||Y-Pe>ve-qe)&&!!Ue(Ce,Pe,Y,_e,qe,ve,!0)){K(Y,ve,Pe,qe,Ce,_e);let Le=1,Be=1,Oe=Pe,et=qe;const B=[!1];for(Le=1,Oe=Pe;Oe<Y;Le++,Oe++){const se=G[Oe],fe=L[Oe],pe=Oe+1<Y?L[Oe+1]:ve;for(Be=se-qe+1,et=se;et<pe;Be++,et++){let We=Number.MIN_SAFE_INTEGER,Ne=!1;et<=fe&&(We=ee(ge,Ce,Oe,Pe,xe,_e,et,ve,qe,U[Le-1][Be-1]===0,B));let Ve=0;We!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Ve=We+x[Le-1][Be-1]);const Je=et>se,Ze=Je?x[Le][Be-1]+(U[Le][Be-1]>0?-5:0):0,ct=et>se+1&&U[Le][Be-1]>0,ot=ct?x[Le][Be-2]+(U[Le][Be-2]>0?-5:0):0;if(ct&&(!Je||ot>=Ze)&&(!Ne||ot>=Ve))x[Le][Be]=ot,Q[Le][Be]=3,U[Le][Be]=0;else if(Je&&(!Ne||Ze>=Ve))x[Le][Be]=Ze,Q[Le][Be]=2,U[Le][Be]=0;else if(Ne)x[Le][Be]=Ve,Q[Le][Be]=1,U[Le][Be]=U[Le-1][Be-1]+1;else throw new Error("not possible")}}if($&&ie(ge,Pe,xe,qe),!(!B[0]&&!V)){Le--,Be--;const te=[x[Le][Be],qe];let he=0,q=0;for(;Le>=1;){let se=Be;do{const fe=Q[Le][se];if(fe===3)se=se-2;else if(fe===2)se=se-1;else break}while(se>=1);he>1&&Ce[Pe+Le-1]===_e[qe+Be-1]&&!Ie(se+qe-1,xe,_e)&&he+1>U[Le][se]&&(se=Be),se===Be?he++:he=1,q||(q=se),Le--,Be=se-1,te.push(Be)}ve===Y&&(te[0]+=2);const J=q-Y;return te[0]-=J,te}}}e.fuzzyScore=N;function K(ge,Ce,Pe,xe,_e,qe){let V=ge-1,Y=Ce-1;for(;V>=Pe&&Y>=xe;)_e[V]===qe[Y]&&(L[V]=Y,V--),Y--}function ee(ge,Ce,Pe,xe,_e,qe,V,Y,ve,Le,Be){if(Ce[Pe]!==qe[V])return Number.MIN_SAFE_INTEGER;let Oe=1,et=!1;return V===Pe-xe?Oe=ge[Pe]===_e[V]?7:5:Ie(V,_e,qe)&&(V===0||!Ie(V-1,_e,qe))?(Oe=ge[Pe]===_e[V]?7:5,et=!0):re(qe,V)&&(V===0||!re(qe,V-1))?Oe=5:(re(qe,V-1)||ye(qe,V-1))&&(Oe=5,et=!0),Oe>1&&Pe===xe&&(Be[0]=!0),et||(et=Ie(V,_e,qe)||re(qe,V-1)||ye(qe,V-1)),Pe===xe?V>ve&&(Oe-=et?3:5):Le?Oe+=et?2:0:Oe+=et?0:1,V+1===Y&&(Oe-=et?3:5),Oe}function oe(ge,Ce,Pe,xe,_e,qe,V){return Se(ge,Ce,Pe,xe,_e,qe,!0,V)}e.fuzzyScoreGracefulAggressive=oe;function me(ge,Ce,Pe,xe,_e,qe,V){return Se(ge,Ce,Pe,xe,_e,qe,!1,V)}e.fuzzyScoreGraceful=me;function Se(ge,Ce,Pe,xe,_e,qe,V,Y){let ve=N(ge,Ce,Pe,xe,_e,qe,Y);if(ve&&!V)return ve;if(ge.length>=3){const Le=Math.min(7,ge.length-1);for(let Be=Pe+1;Be<Le;Be++){const Oe=Me(ge,Be);if(Oe){const et=N(Oe,Oe.toLowerCase(),Pe,xe,_e,qe,Y);et&&(et[0]-=3,(!ve||et[0]>ve[0])&&(ve=et))}}}return ve}function Me(ge,Ce){if(!(Ce+1>=ge.length)){const Pe=ge[Ce],xe=ge[Ce+1];if(Pe!==xe)return ge.slice(0,Ce)+xe+Pe+ge.slice(Ce+2)}}}),define(be[109],we([0,1,37,108,8]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${A.source}`,"g");function I(d){return d.replace(D,(_,g)=>g?_:`\\${_}`)}e.escapeIcons=I;const y=new RegExp(`\\\\${A.source}`,"g");function n(d){return d.replace(y,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=n;const T=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function k(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(T,(_,g,w,u)=>w?_:g||u||"")}e.stripIcons=k;function b(d){const _=d.indexOf(e.iconStartMarker);return _===-1?{text:d}:m(d,_)}e.parseLabelWithIcons=b;function m(d,_){const g=[];let w="";function u(f){if(f){w+=f;for(const v of f)g.push(t)}}let c=-1,s="",t=0,i,l,o=_;const a=d.length;for(u(d.substr(0,_));o<a;)i=d[o],l=d[o+1],i===e.iconStartMarker[0]&&l===e.iconStartMarker[1]?(c=o,u(s),s=e.iconStartMarker,o++):i===")"&&c!==-1?(t+=o-c+1,c=-1,s=""):c!==-1?/^[a-z0-9\-]$/i.test(i)?s+=i:(u(s),c=-1,s=""):u(i),o++;return u(s),{text:w,iconOffsets:g}}function r(d,_,g=!1){const{text:w,iconOffsets:u}=_;if(!u||u.length===0)return(0,S.matchesFuzzy)(d,w,g);const c=(0,R.ltrim)(w," "),s=w.length-c.length,t=(0,S.matchesFuzzy)(d,c,g);if(t)for(const i of t){const l=u[i.start+s]+s;i.start+=l,i.end+=l}return t}e.matchesFuzzyIconAware=r}),define(be[80],we([0,1,15,109,10]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(d="",_=!1){var g,w;if(this.value=d,typeof this.value!="string")throw(0,R.illegalArgument)("value");typeof _=="boolean"?(this.isTrusted=_,this.supportThemeIcons=!1):(this.isTrusted=(g=_.isTrusted)!==null&&g!==void 0?g:void 0,this.supportThemeIcons=(w=_.supportThemeIcons)!==null&&w!==void 0?w:!1)}appendText(d,_=0){return this.value+=k(this.supportThemeIcons?(0,S.escapeIcons)(d):d).replace(/([ \t]+)/g,(g,w)=>"&nbsp;".repeat(w.length)).replace(/^>/gm,"\\>").replace(/\n/g,_===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,_){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=_,this.value+="\n```\n",this}}e.MarkdownString=D;function I(r){return y(r)?!r.value:Array.isArray(r)?r.every(I):!0}e.isEmptyMarkdownString=I;function y(r){return r instanceof D?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function n(r,d){return!r&&!d?!0:!r||!d?!1:Array.isArray(r)&&Array.isArray(d)?(0,E.equals)(r,d,T):y(r)&&y(d)?T(r,d):!1}e.markedStringsEquals=n;function T(r,d){return r===d?!0:!r||!d?!1:r.value===d.value&&r.isTrusted===d.isTrusted&&r.supportThemeIcons===d.supportThemeIcons}function k(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function b(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=b;function m(r){const d=[],_=r.split("|").map(w=>w.trim());r=_[0];const g=_[1];if(g){const w=/height=(\d+)/.exec(g),u=/width=(\d+)/.exec(g),c=w?w[1]:"",s=u?u[1]:"",t=isFinite(parseInt(s)),i=isFinite(parseInt(c));t&&d.push(`width="${s}"`),i&&d.push(`height="${c}"`)}return{href:r,dimensions:d}}e.parseHrefAndDimensions=m}),define(be[57],we([0,1,26,8,2]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(n){return JSON.stringify(n,I)}e.stringify=A;function D(n){let T=JSON.parse(n);return T=y(T),T}e.parse=D;function I(n,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,S.regExpFlags)(T)}:T}function y(n,T=0){if(!n||T>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return R.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof E.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let k=0;k<n.length;++k)n[k]=y(n[k],T+1);else for(const k in n)Object.hasOwnProperty.call(n,k)&&(n[k]=y(n[k],T+1))}return n}e.revive=y}),define(be[16],we([0,1,2,21]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.vscodeWebviewResource="vscode-webview-resource",I.extension="extension",I.vscodeFileResource="vscode-file"})(R=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,n,T){this._hosts[y]=n,this._ports[y]=T}setConnectionToken(y,n){this._connectionTokens[y]=n}rewrite(y){if(this._delegate)return this._delegate(y);const n=y.authority;let T=this._hosts[n];T&&T.indexOf(":")!==-1&&(T=`[${T}]`);const k=this._ports[n],b=this._connectionTokens[n];let m=`path=${encodeURIComponent(y.path)}`;return typeof b=="string"&&(m+=`&tkn=${encodeURIComponent(b)}`),E.URI.from({scheme:S.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${T}:${k}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new A;class D{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,n,T){const k=this.toUri(y,n);return k.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(k):S.isNative&&(T||S.isPreferringBrowserCodeLoad)&&k.scheme===R.file?k.with({scheme:R.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(y,n){const T=this.toUri(y,n);return T.scheme===R.vscodeFileResource?T.with({scheme:R.file,authority:T.authority!==this.FALLBACK_AUTHORITY?T.authority:null,query:null,fragment:null}):T}toUri(y,n){return E.URI.isUri(y)?y:E.URI.parse(n.toUrl(y))}}e.FileAccess=new D}),define(be[24],we([0,1,38,11,2,8,16,21]),function(ae,e,E,S,R,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(m){return(0,R.uriToFsPath)(m,!0)}e.originalFSPath=y;class n{constructor(r){this._ignorePathCasing=r}compare(r,d,_=!1){return r===d?0:(0,A.compare)(this.getComparisonKey(r,_),this.getComparisonKey(d,_))}isEqual(r,d,_=!1){return r===d?!0:!r||!d?!1:this.getComparisonKey(r,_)===this.getComparisonKey(d,_)}getComparisonKey(r,d=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,d,_=!1){if(r.scheme===d.scheme){if(r.scheme===D.Schemas.file)return E.isEqualOrParent(y(r),y(d),this._ignorePathCasing(r))&&r.query===d.query&&(_||r.fragment===d.fragment);if((0,e.isEqualAuthority)(r.authority,d.authority))return E.isEqualOrParent(r.path,d.path,this._ignorePathCasing(r),"/")&&r.query===d.query&&(_||r.fragment===d.fragment)}return!1}joinPath(r,...d){return R.URI.joinPath(r,...d)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return S.posix.basename(r.path)}extname(r){return S.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let d;return r.scheme===D.Schemas.file?d=R.URI.file(S.dirname(y(r))).path:(d=S.posix.dirname(r.path),r.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),d="/")),r.with({path:d})}normalizePath(r){if(!r.path.length)return r;let d;return r.scheme===D.Schemas.file?d=R.URI.file(S.normalize(y(r))).path:d=S.posix.normalize(r.path),r.with({path:d})}relativePath(r,d){if(!(r.scheme!==d.scheme||!(0,e.isEqualAuthority)(r.authority,d.authority))){if(r.scheme===D.Schemas.file){const w=S.relative(y(r),y(d));return I.isWindows?E.toSlashes(w):w}let _=r.path||"/",g=d.path||"/";if(this._ignorePathCasing(r)){let w=0;for(const u=Math.min(_.length,g.length);w<u&&!(_.charCodeAt(w)!==g.charCodeAt(w)&&_.charAt(w).toLowerCase()!==g.charAt(w).toLowerCase());w++);_=g.substr(0,w)+_.substr(w)}return S.posix.relative(_,g)}}resolvePath(r,d){if(r.scheme===D.Schemas.file){const _=R.URI.file(S.resolve(y(r),d));return r.with({authority:_.authority,path:_.path})}return d.indexOf("/")===-1&&(d=E.toSlashes(d),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d)),r.with({path:S.posix.resolve(r.path,d)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,d){return r===d||(0,A.equalsIgnoreCase)(r,d)}hasTrailingPathSeparator(r,d=S.sep){if(r.scheme===D.Schemas.file){const _=y(r);return _.length>E.getRoot(_).length&&_[_.length-1]===d}else{const _=r.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,d=S.sep){return(0,e.hasTrailingPathSeparator)(r,d)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,d=S.sep){let _=!1;if(r.scheme===D.Schemas.file){const g=y(r);_=g!==void 0&&g.length===E.getRoot(g).length&&g[g.length-1]===d}else{d="/";const g=r.path;_=g.length===1&&g.charCodeAt(g.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(r,d)?r.with({path:r.path+"/"}):r}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(m=>m.scheme===D.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new n(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(m,r){const d=[];for(let _=0;_<m.length;_++){const g=r(m[_]);m.some((w,u)=>u===_?!1:(0,e.isEqualOrParent)(g,r(w)))||d.push(m[_])}return d}e.distinctParents=T;var k;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function r(d){const _=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(u=>{const[c,s]=u.split(":");c&&s&&_.set(c,s)});const w=d.path.substring(0,d.path.indexOf(";"));return w&&_.set(m.META_DATA_MIME,w),_}m.parseMetaData=r})(k=e.DataUri||(e.DataUri={}));function b(m,r,d){if(r){let _=m.path;return _&&_[0]!==S.posix.sep&&(_=S.posix.sep+_),m.with({scheme:d,authority:r,path:_})}return m.with({scheme:d})}e.toLocalResource=b}),define(be[13],we([0,1,20,10,3,6,45,24]),function(ae,e,E,S,R,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(x){return!!x&&typeof x.then=="function"}e.isThenable=y;function n(x){const Q=new E.CancellationTokenSource,$=x(Q.token),Z=new Promise((ie,re)=>{Q.token.onCancellationRequested(()=>{re((0,S.canceled)())}),Promise.resolve($).then(ye=>{Q.dispose(),ie(ye)},ye=>{Q.dispose(),re(ye)})});return new class{cancel(){Q.cancel()}then(ie,re){return Z.then(ie,re)}catch(ie){return this.then(void 0,ie)}finally(ie){return Z.finally(ie)}}}e.createCancelablePromise=n;function T(x,Q,$){return Promise.race([x,new Promise(Z=>Q.onCancellationRequested(()=>Z($)))])}e.raceCancellation=T;async function k(x){let Q=-1;const $=x.map((ie,re)=>ie.then(ye=>(Q=re,ye))),Z=await Promise.race($);return x.forEach((ie,re)=>{re!==Q&&ie.cancel()}),Z}e.raceCancellablePromises=k;function b(x,Q,$){let Z;const ie=setTimeout(()=>{Z==null||Z(void 0),$==null||$()},Q);return Promise.race([x.finally(()=>clearTimeout(ie)),new Promise(re=>Z=re)])}e.raceTimeout=b;function m(x){return new Promise((Q,$)=>{const Z=x();y(Z)?Z.then(Q,$):Q(Z)})}e.asPromise=m;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const Z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Z};this.queuedPromise=new Promise(Z=>{this.activePromise.then($,$).then(Z)})}return new Promise(($,Z)=>{this.queuedPromise.then($,Z)})}return this.activePromise=Q(),new Promise(($,Z)=>{this.activePromise.then(ie=>{this.activePromise=null,$(ie)},ie=>{this.activePromise=null,Z(ie)})})}}e.Throttler=r;class d{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=d;class _{constructor(){this.promiseMap=new Map}queue(Q,$){var Z;const re=((Z=this.promiseMap.get(Q))!==null&&Z!==void 0?Z:Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(Q)===re&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,re),re}}e.SequencerByKey=_;class g{constructor(Q){this.defaultDelay=Q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,$=this.defaultDelay){return this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Z,ie)=>{this.doResolve=Z,this.doReject=ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Z=this.task;return this.task=null,Z()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,S.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=g;class w{constructor(Q){this.delayer=new g(Q),this.throttler=new r}trigger(Q,$){return this.delayer.trigger(()=>this.throttler.queue(Q),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class u{constructor(){this._isOpen=!1,this._promise=new Promise((Q,$)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class c extends u{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function s(x,Q){return Q?new Promise(($,Z)=>{const ie=setTimeout($,x);Q.onCancellationRequested(()=>{clearTimeout(ie),Z((0,S.canceled)())})}):n($=>s(x,$))}e.timeout=s;function t(x,Q=0){const $=setTimeout(x,Q);return(0,A.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=t;function i(x){return x.then(void 0,Q=>{})}e.ignoreErrors=i;function l(x){const Q=[];let $=0;const Z=x.length;function ie(){return $<Z?x[$++]():null}function re(ye){ye!=null&&Q.push(ye);const Ie=ie();return Ie?Ie.then(re):Promise.resolve(Q)}return Promise.resolve(null).then(re)}e.sequence=l;function o(x,Q=Z=>!!Z,$=null){let Z=0;const ie=x.length,re=()=>{if(Z>=ie)return Promise.resolve($);const ye=x[Z++];return Promise.resolve(ye()).then(Ue=>Q(Ue)?Promise.resolve(Ue):re())};return re()}e.first=o;function a(x,Q=Z=>!!Z,$=null){if(x.length===0)return Promise.resolve($);let Z=x.length;const ie=()=>{var re,ye;Z=-1;for(const Ie of x)(ye=(re=Ie).cancel)===null||ye===void 0||ye.call(re)};return new Promise((re,ye)=>{for(const Ie of x)Ie.then(Ue=>{--Z>=0&&Q(Ue)?(ie(),re(Ue)):Z===0&&re($)}).catch(Ue=>{--Z>=0&&(ie(),ye(Ue))})})}e.firstParallel=a;class f{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise(($,Z)=>{this.outstandingPromises.push({factory:Q,c:$,e:Z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const $=Q.factory();$.then(Q.c,Q.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class v extends f{constructor(){super(1)}}e.Queue=v;class C{constructor(){this.queues=new Map}queueFor(Q,$=I.extUri){const Z=$.getComparisonKey(Q);let ie=this.queues.get(Z);return ie||(ie=new v,R.Event.once(ie.onFinished)(()=>{ie==null||ie.dispose(),this.queues.delete(Z)}),this.queues.set(Z,ie)),ie}dispose(){this.queues.forEach(Q=>Q.dispose()),this.queues.clear()}}e.ResourceQueue=C;class h{constructor(Q,$){this._token=-1,typeof Q=="function"&&typeof $=="number"&&this.setIfNotSet(Q,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},$)}setIfNotSet(Q,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},$))}}e.TimeoutTimer=h;class p{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,$){this.cancel(),this._token=setInterval(()=>{Q()},$)}}e.IntervalTimer=p;class P{constructor(Q,$){this.timeoutToken=-1,this.runner=Q,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class F extends P{constructor(Q,$){super(Q,$);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=Q=>{const $=setTimeout(()=>Q(x));let Z=!1;return{dispose(){Z||(Z=!0,clearTimeout($))}}}}else e.runWhenIdle=(x,Q)=>{const $=requestIdleCallback(x,typeof Q=="number"?{timeout:Q}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,cancelIdleCallback($))}}}}();class z{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function le(x,Q,$){let Z;for(let ie=0;ie<$;ie++)try{return await x()}catch(re){Z=re,await s(Q)}throw Z}e.retry=le;class H{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var Q;(Q=this._pending)===null||Q===void 0||Q.cancel()}setPending(Q,$,Z){return this._pending={taskId:Q,cancel:()=>Z==null?void 0:Z(),promise:$},$.then(()=>this.donePending(Q),()=>this.donePending(Q)),$}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let $,Z;const ie=new Promise((re,ye)=>{$=re,Z=ye});this._next={run:Q,promise:ie,promiseResolve:$,promiseReject:Z}}return this._next.promise}}e.TaskSequentializer=H;class W{constructor(Q){this.interval=Q,this.lastIncrementTime=0,this.value=0}increment(){const Q=Date.now();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class G{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,$)=>{this.completeCallback=Q,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise($=>{this.completeCallback(Q),this.resolved=!0,$()})}error(Q){return new Promise($=>{this.errorCallback(Q),this.rejected=!0,$()})}cancel(){new Promise(Q=>{this.errorCallback((0,S.canceled)()),this.rejected=!0,Q()})}}e.DeferredPromise=G;class L extends R.Emitter{async fireAsync(Q,$,Z){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const ie of this._listeners)this._asyncDeliveryQueue.push([ie,Q]);for(;this._asyncDeliveryQueue.size>0&&!$.isCancellationRequested;){const[ie,re]=this._asyncDeliveryQueue.shift(),ye=[],Ie=Object.assign(Object.assign({},re),{waitUntil:Ue=>{if(Object.isFrozen(ye))throw new Error("waitUntil can NOT be called asynchronous");Z&&(Ue=Z(Ue,typeof ie=="function"?ie:ie[0])),ye.push(Ue)}});try{typeof ie=="function"?ie.call(void 0,Ie):ie[0].call(ie[1],Ie)}catch(Ue){(0,S.onUnexpectedError)(Ue);continue}Object.freeze(ye),await U.settled(ye).catch(Ue=>(0,S.onUnexpectedError)(Ue))}}}}e.AsyncEmitter=L;var U;(function(x){async function Q(re){return typeof Promise.allSettled=="function"?$(re):Z(re)}x.allSettled=Q;async function $(re){return Promise.allSettled(re)}async function Z(re){return Promise.all(re.map(ye=>ye.then(Ie=>({status:"fulfilled",value:Ie}),Ie=>({status:"rejected",reason:Ie}))))}async function ie(re){let ye;const Ie=await Promise.all(re.map(Ue=>Ue.then(Fe=>Fe,Fe=>{ye||(ye=Fe)})));if(typeof ye!="undefined")throw ye;return Ie}x.settled=ie})(U=e.Promises||(e.Promises={}))}),define(be[110],we([0,1,11,13]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const R=new S.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),A=new S.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new S.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(c,s,t=!1){const i=c||"",l=s||"",o=R.value.collator.compare(i,l);return R.value.collatorIsNumeric&&o===0&&i!==l?i<l?-1:1:o}e.compareFileNames=I;function y(c,s){const t=A.value.collator;return c=c||"",s=s||"",d(t,c,s)}e.compareFileNamesDefault=y;function n(c,s,t=!1){t||(c=c&&c.toLowerCase(),s=s&&s.toLowerCase());const[i,l]=m(c),[o,a]=m(s);return i!==o?i<o?-1:1:l===a?0:l<a?-1:1}e.noIntlCompareFileNames=n;function T(c,s){const[t,i]=m(c),[l,o]=m(s);let a=R.value.collator.compare(i,o);if(a===0){if(R.value.collatorIsNumeric&&i!==o)return i<o?-1:1;if(a=R.value.collator.compare(t,l),R.value.collatorIsNumeric&&a===0&&t!==l)return t<l?-1:1}return a}e.compareFileExtensions=T;function k(c,s){c=c||"",s=s||"";const t=r(c),i=r(s),l=A.value.collator,o=D.value.collator;let a;return a=d(o,t,i),a!==0?a:d(l,c,s)}e.compareFileExtensionsDefault=k;const b=/^(.*?)(\.([^.]*))?$/;function m(c,s=!1){const t=c?b.exec(c):[];let i=[t&&t[1]||"",t&&t[3]||""];return s&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function r(c){const s=c?b.exec(c):[];return s&&s[1]&&s[1].charAt(0)!=="."&&s[3]||""}function d(c,s,t){let i=c.compare(s,t);return i!==0?i:s.length!==t.length?s.length<t.length?-1:1:0}function _(c,s,t=!1){return t||(c=c&&c.toLowerCase(),s=s&&s.toLowerCase()),c===s?0:c<s?-1:1}function g(c,s,t=!1){const i=c.split(E.sep),l=s.split(E.sep),o=i.length-1,a=l.length-1;let f,v;for(let C=0;;C++){if(f=o===C,v=a===C,f&&v)return I(i[C],l[C],t);if(f)return-1;if(v)return 1;const h=_(i[C],l[C],t);if(h!==0)return h}}e.comparePaths=g;function w(c,s,t){const i=c.toLowerCase(),l=s.toLowerCase(),o=u(c,s,t);if(o)return o;const a=i.endsWith(t),f=l.endsWith(t);if(a!==f)return a?-1:1;const v=I(i,l);return v!==0?v:i.localeCompare(l)}e.compareAnything=w;function u(c,s,t){const i=c.toLowerCase(),l=s.toLowerCase(),o=i.startsWith(t),a=l.startsWith(t);if(o!==a)return o?-1:1;if(o&&a){if(i.length<l.length)return-1;if(i.length>l.length)return 1}return 0}e.compareByPrefix=u}),define(be[28],we([0,1,8,38,11,22,13]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const y="**",n="/",T="[/\\\\]",k="[^/\\\\]",b=/\//g;function m($){switch($){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}|${T}${k}+)*?`}}function r($,Z){if(!$)return[];const ie=[];let re=!1,ye=!1,Ie="";for(const Ue of $){switch(Ue){case Z:if(!re&&!ye){ie.push(Ie),Ie="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}Ie+=Ue}return Ie&&ie.push(Ie),ie}e.splitGlobAware=r;function d($){if(!$)return"";let Z="";const ie=r($,n);if(ie.every(re=>re===y))Z=".*";else{let re=!1;ie.forEach((ye,Ie)=>{if(ye===y){re||(Z+=m(2),re=!0);return}let Ue=!1,Fe="",ze=!1,N="";for(const K of ye){if(K!=="}"&&Ue){Fe+=K;continue}if(ze&&(K!=="]"||!N)){let ee;K==="-"?ee=K:(K==="^"||K==="!")&&!N?ee="^":K===n?ee="":ee=E.escapeRegExpCharacters(K),N+=ee;continue}switch(K){case"{":Ue=!0;continue;case"[":ze=!0;continue;case"}":Z+=`(?:${r(Fe,",").map(me=>d(me)).join("|")})`,Ue=!1,Fe="";break;case"]":Z+="["+N+"]",ze=!1,N="";break;case"?":Z+=k;continue;case"*":Z+=m(1);continue;default:Z+=E.escapeRegExpCharacters(K)}}Ie<ie.length-1&&(ie[Ie+1]!==y||Ie+2<ie.length)&&(Z+=T),re=!1})}return Z}const _=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),i=function(){return!1},l=function(){return null};function o($,Z){if(!$)return l;let ie;typeof $!="string"?ie=$.pattern:ie=$,ie=ie.trim();const re=`${ie}_${!!Z.trimForExclusions}`;let ye=t.get(re);if(ye)return a(ye,$);let Ie;if(_.test(ie)){const Ue=ie.substr(4);ye=function(Fe,ze){return typeof Fe=="string"&&Fe.endsWith(Ue)?ie:null}}else(Ie=g.exec(f(ie,Z)))?ye=v(Ie[1],ie):(Z.trimForExclusions?u:w).test(ie)?ye=C(ie,Z):(Ie=c.exec(f(ie,Z)))?ye=h(Ie[1].substr(1),ie,!0):(Ie=s.exec(f(ie,Z)))?ye=h(Ie[1],ie,!1):ye=p(ie);return t.set(re,ye),a(ye,$)}function a($,Z){return typeof Z=="string"?$:function(ie,re){return S.isEqualOrParent(ie,Z.base)?$(R.relative(Z.base,ie),re):null}}function f($,Z){return Z.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function v($,Z){const ie=`/${$}`,re=`\\${$}`,ye=function(Ue,Fe){return typeof Ue!="string"?null:Fe?Fe===$?Z:null:Ue===$||Ue.endsWith(ie)||Ue.endsWith(re)?Z:null},Ie=[$];return ye.basenames=Ie,ye.patterns=[Z],ye.allBasenames=Ie,ye}function C($,Z){const ie=Q($.slice(1,-1).split(",").map(Fe=>o(Fe,Z)).filter(Fe=>Fe!==l),$),re=ie.length;if(!re)return l;if(re===1)return ie[0];const ye=function(Fe,ze){for(let N=0,K=ie.length;N<K;N++)if(ie[N](Fe,ze))return $;return null},Ie=ie.find(Fe=>!!Fe.allBasenames);Ie&&(ye.allBasenames=Ie.allBasenames);const Ue=ie.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return Ue.length&&(ye.allPaths=Ue),ye}function h($,Z,ie){const re=R.sep===R.posix.sep,ye=re?$:$.replace(b,R.sep),Ie=R.sep+ye,Ue=R.posix.sep+$,Fe=ie?function(ze,N){return typeof ze=="string"&&(ze===ye||ze.endsWith(Ie)||!re&&(ze===$||ze.endsWith(Ue)))?Z:null}:function(ze,N){return typeof ze=="string"&&(ze===ye||!re&&ze===$)?Z:null};return Fe.allPaths=[(ie?"*/":"./")+$],Fe}function p($){try{const Z=new RegExp(`^${d($)}$`);return function(ie){return Z.lastIndex=0,typeof ie=="string"&&Z.test(ie)?$:null}}catch(Z){return l}}function P($,Z,ie){return!$||typeof Z!="string"?!1:F($)(Z,void 0,ie)}e.match=P;function F($,Z={}){if(!$)return i;if(typeof $=="string"||W($)){const ie=o($,Z);if(ie===l)return i;const re=function(ye,Ie){return!!ie(ye,Ie)};return ie.allBasenames&&(re.allBasenames=ie.allBasenames),ie.allPaths&&(re.allPaths=ie.allPaths),re}return U($,Z)}e.parse=F;function z($){if(!!$){let Z;return ie=>(Z||(Z=($()||Promise.resolve([])).then(re=>re?H(re):{})),Z.then(re=>!!re[ie]))}}e.hasSiblingPromiseFn=z;function le($){if(!!$){let Z;return ie=>{if(!Z){const re=$();Z=re?H(re):{}}return!!Z[ie]}}}e.hasSiblingFn=le;function H($){const Z={};for(const ie of $)Z[ie]=!0;return Z}function W($){const Z=$;return Z&&typeof Z.base=="string"&&typeof Z.pattern=="string"}e.isRelativePattern=W;function G($){return $.allBasenames||[]}e.getBasenameTerms=G;function L($){return $.allPaths||[]}e.getPathTerms=L;function U($,Z){const ie=Q(Object.getOwnPropertyNames($).map(Fe=>x(Fe,$[Fe],Z)).filter(Fe=>Fe!==l)),re=ie.length;if(!re)return l;if(!ie.some(Fe=>!!Fe.requiresSiblings)){if(re===1)return ie[0];const Fe=function(K,ee){for(let oe=0,me=ie.length;oe<me;oe++){const Se=ie[oe](K,ee);if(Se)return Se}return null},ze=ie.find(K=>!!K.allBasenames);ze&&(Fe.allBasenames=ze.allBasenames);const N=ie.reduce((K,ee)=>ee.allPaths?K.concat(ee.allPaths):K,[]);return N.length&&(Fe.allPaths=N),Fe}const ye=function(Fe,ze,N){let K;for(let ee=0,oe=ie.length;ee<oe;ee++){const me=ie[ee];me.requiresSiblings&&N&&(ze||(ze=R.basename(Fe)),K||(K=ze.substr(0,ze.length-R.extname(Fe).length)));const Se=me(Fe,ze,K,N);if(Se)return Se}return null},Ie=ie.find(Fe=>!!Fe.allBasenames);Ie&&(ye.allBasenames=Ie.allBasenames);const Ue=ie.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return Ue.length&&(ye.allPaths=Ue),ye}function x($,Z,ie){if(Z===!1)return l;const re=o($,ie);if(re===l)return l;if(typeof Z=="boolean")return re;if(Z){const ye=Z.when;if(typeof ye=="string"){const Ie=(Ue,Fe,ze,N)=>{if(!N||!re(Ue,Fe))return null;const K=ye.replace("$(basename)",ze),ee=N(K);return(0,D.isThenable)(ee)?ee.then(oe=>oe?$:null):ee?$:null};return Ie.requiresSiblings=!0,Ie}}return re}function Q($,Z){const ie=$.filter(Fe=>!!Fe.basenames);if(ie.length<2)return $;const re=ie.reduce((Fe,ze)=>{const N=ze.basenames;return N?Fe.concat(N):Fe},[]);let ye;if(Z){ye=[];for(let Fe=0,ze=re.length;Fe<ze;Fe++)ye.push(Z)}else ye=ie.reduce((Fe,ze)=>{const N=ze.patterns;return N?Fe.concat(N):Fe},[]);const Ie=function(Fe,ze){if(typeof Fe!="string")return null;if(!ze){let K;for(K=Fe.length;K>0;K--){const ee=Fe.charCodeAt(K-1);if(ee===47||ee===92)break}ze=Fe.substr(K)}const N=re.indexOf(ze);return N!==-1?ye[N]:null};Ie.basenames=re,Ie.patterns=ye,Ie.allBasenames=re;const Ue=$.filter(Fe=>!Fe.basenames);return Ue.push(Ie),Ue}}),define(be[58],we([0,1,2,11,8,16,21,24,38]),function(ae,e,E,S,R,A,D,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(o,a,f){if(typeof o=="string"&&(o=E.URI.file(o)),f){const C=f.getWorkspaceFolder(o);if(C){const h=f.getWorkspace().folders.length>1;let p;if((0,I.isEqual)(C.uri,o)?p="":p=(0,I.relativePath)(C.uri,o),h){const P=C.name?C.name:(0,I.basename)(C.uri);p=p?P+" \u2022 "+p:P}return p}}if(o.scheme!==A.Schemas.file&&o.scheme!==A.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(o.fsPath))return(0,S.normalize)(k(o.fsPath));let v=(0,S.normalize)(o.fsPath);return!D.isWindows&&(a==null?void 0:a.userHome)&&(v=m(v,a.userHome.fsPath)),v}e.getPathLabel=n;function T(o){if(!!o){typeof o=="string"&&(o=E.URI.file(o));const a=(0,I.basename)(o)||(o.scheme===A.Schemas.file?o.fsPath:o.path);return D.isWindows&&(0,y.isRootOrDriveLetter)(a)?k(a):a}}e.getBaseLabel=T;function k(o){return(0,y.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=k;let b=Object.create(null);function m(o,a){if(D.isWindows||!o||!a)return o;let f=b.original===a?b.normalized:void 0;return f||(f=`${(0,R.rtrim)(a,S.posix.sep)}${S.posix.sep}`,b={original:a,normalized:f}),(D.isLinux?o.startsWith(f):(0,R.startsWithIgnoreCase)(o,f))&&(o=`~/${o.substr(f.length)}`),o}e.tildify=m;function r(o,a){return o.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=r;const d="\u2026",_="\\\\",g="~";function w(o,a=S.sep){const f=new Array(o.length);let v=!1;for(let C=0;C<o.length;C++){let h=o[C];if(h===""){f[C]=`.${a}`;continue}if(!h){f[C]=h;continue}v=!0;let p="";h.indexOf(_)===0?(p=h.substr(0,h.indexOf(_)+_.length),h=h.substr(h.indexOf(_)+_.length)):h.indexOf(a)===0?(p=h.substr(0,h.indexOf(a)+a.length),h=h.substr(h.indexOf(a)+a.length)):h.indexOf(g)===0&&(p=h.substr(0,h.indexOf(g)+g.length),h=h.substr(h.indexOf(g)+g.length));const P=h.split(a);for(let F=1;v&&F<=P.length;F++)for(let z=P.length-F;v&&z>=0;z--){v=!1;let le=P.slice(z,z+F).join(a);for(let H=0;!v&&H<o.length;H++)if(H!==C&&o[H]&&o[H].indexOf(le)>-1){const W=z+F===P.length,G=z>0&&o[H].indexOf(a)>-1?a+le:le,L=o[H].endsWith(G);v=!W||L}if(!v){let H="";(P[0].endsWith(":")||p!=="")&&(z===1&&(z=0,F++,le=P[0]+a+le),z>0&&(H=P[0]+a),H=p+H),z>0&&(H=H+d+a),H=H+le,z+F<P.length&&(H=H+a+d),f[C]=H}}v&&(f[C]=h)}return f}e.shorten=w;var u;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function c(o,a=Object.create(null)){const f=[];let v=!1,C="";for(const h of o)if(h==="$"||v&&h==="{")C&&f.push({value:C,type:u.TEXT}),C="",v=!0;else if(h==="}"&&v){const p=a[C];if(typeof p=="string")p.length&&f.push({value:p,type:u.VARIABLE});else if(p){const P=f[f.length-1];(!P||P.type!==u.SEPARATOR)&&f.push({value:p.label,type:u.SEPARATOR})}C="",v=!1}else C+=h;return C&&!v&&f.push({value:C,type:u.TEXT}),f.filter((h,p)=>{if(h.type===u.SEPARATOR){const P=f[p-1],F=f[p+1];return[P,F].every(z=>z&&(z.type===u.VARIABLE||z.type===u.TEXT)&&z.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=c;function s(o,a){return D.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):o.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function t(o,a){return D.isMacintosh||a?o.replace(/\(&&\w\)|&&/g,""):D.isWindows?o.replace(/&&|&/g,f=>f==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=i;function l(o){const a=o.indexOf("/")!==-1?S.posix:S.win32,f=a.basename(o),v=a.dirname(o);return f.length?{name:f,parentPath:v}:{name:v,parentPath:""}}e.splitName=l}),define(be[111],we([0,1,2]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function S(T){return T.toJSON()}class R{constructor(k){this._uriTransformer=k}transformIncoming(k){const b=this._uriTransformer.transformIncoming(k);return b===k?k:S(E.URI.from(b))}transformOutgoing(k){const b=this._uriTransformer.transformOutgoing(k);return b===k?k:S(E.URI.from(b))}transformOutgoingURI(k){const b=this._uriTransformer.transformOutgoing(k);return b===k?k:E.URI.from(b)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function A(T,k,b){if(!T||b>200)return null;if(typeof T=="object"){if(T instanceof E.URI)return k.transformOutgoing(T);for(let m in T)if(Object.hasOwnProperty.call(T,m)){const r=A(T[m],k,b+1);r!==null&&(T[m]=r)}}return null}function D(T,k){const b=A(T,k,0);return b===null?T:b}e.transformOutgoingURIs=D;function I(T,k,b,m){if(!T||m>200)return null;if(typeof T=="object"){if(T.$mid===1)return b?E.URI.revive(k.transformIncoming(T)):k.transformIncoming(T);for(let r in T)if(Object.hasOwnProperty.call(T,r)){const d=I(T[r],k,b,m+1);d!==null&&(T[r]=d)}}return null}function y(T,k){const b=I(T,k,!1,0);return b===null?T:b}e.transformIncomingURIs=y;function n(T,k){const b=I(T,k,!0,0);return b===null?T:b}e.transformAndReviveIncomingURIs=n}),define(be[29],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(y){return E.test(y)}e.isUUID=S;const R=new Uint8Array(16),A=[];for(let y=0;y<256;y++)A.push(y.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(y){for(let n=0;n<y.length;n++)y[n]=Math.floor(Math.random()*256);return y};function I(){D(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,n="";return n+=A[R[y++]],n+=A[R[y++]],n+=A[R[y++]],n+=A[R[y++]],n+="-",n+=A[R[y++]],n+=A[R[y++]],n+="-",n+=A[R[y++]],n+=A[R[y++]],n+="-",n+=A[R[y++]],n+=A[R[y++]],n+="-",n+=A[R[y++]],n+=A[R[y++]],n+=A[R[y++]],n+=A[R[y++]],n+=A[R[y++]],n+=A[R[y++]],n}e.generateUuid=I}),define(be[81],we([0,1,79]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class S{constructor(I){let y=(0,E.toUint8)(I);this._defaultValue=y,this._asciiMap=S._createAsciiMap(y),this._map=new Map}static _createAsciiMap(I){let y=new Uint8Array(256);for(let n=0;n<256;n++)y[n]=I;return y}set(I,y){let n=(0,E.toUint8)(y);I>=0&&I<256?this._asciiMap[I]=n:this._map.set(I,n)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=S;var R;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(R||(R={}));class A{constructor(){this._actual=new S(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=A}),define(be[112],we([0,1,81]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var S;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(S=e.WordCharacterClass||(e.WordCharacterClass={}));class R extends E.CharacterClassifier{constructor(I){super(0);for(let y=0,n=I.length;y<n;y++)this.set(I.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=R;function A(D){let I={};return y=>(I.hasOwnProperty(y)||(I[y]=D(y)),I[y])}e.getMapForWordSeparators=A(D=>new R(D))}),define(be[39],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(R,A){this.lineNumber=R,this.column=A}with(R=this.lineNumber,A=this.column){return R===this.lineNumber&&A===this.column?this:new E(R,A)}delta(R=0,A=0){return this.with(this.lineNumber+R,this.column+A)}equals(R){return E.equals(this,R)}static equals(R,A){return!R&&!A?!0:!!R&&!!A&&R.lineNumber===A.lineNumber&&R.column===A.column}isBefore(R){return E.isBefore(this,R)}static isBefore(R,A){return R.lineNumber<A.lineNumber?!0:A.lineNumber<R.lineNumber?!1:R.column<A.column}isBeforeOrEqual(R){return E.isBeforeOrEqual(this,R)}static isBeforeOrEqual(R,A){return R.lineNumber<A.lineNumber?!0:A.lineNumber<R.lineNumber?!1:R.column<=A.column}static compare(R,A){let D=R.lineNumber|0,I=A.lineNumber|0;if(D===I){let y=R.column|0,n=A.column|0;return y-n}return D-I}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(R){return new E(R.lineNumber,R.column)}static isIPosition(R){return R&&typeof R.lineNumber=="number"&&typeof R.column=="number"}}e.Position=E}),define(be[33],we([0,1,39]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class S{constructor(A,D,I,y){A>I||A===I&&D>y?(this.startLineNumber=I,this.startColumn=y,this.endLineNumber=A,this.endColumn=D):(this.startLineNumber=A,this.startColumn=D,this.endLineNumber=I,this.endColumn=y)}isEmpty(){return S.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return S.containsPosition(this,A)}static containsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<A.startColumn||D.lineNumber===A.endLineNumber&&D.column>A.endColumn)}containsRange(A){return S.containsRange(this,A)}static containsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>A.endColumn)}strictContainsRange(A){return S.strictContainsRange(this,A)}static strictContainsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<=A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>=A.endColumn)}plusRange(A){return S.plusRange(this,A)}static plusRange(A,D){let I,y,n,T;return D.startLineNumber<A.startLineNumber?(I=D.startLineNumber,y=D.startColumn):D.startLineNumber===A.startLineNumber?(I=D.startLineNumber,y=Math.min(D.startColumn,A.startColumn)):(I=A.startLineNumber,y=A.startColumn),D.endLineNumber>A.endLineNumber?(n=D.endLineNumber,T=D.endColumn):D.endLineNumber===A.endLineNumber?(n=D.endLineNumber,T=Math.max(D.endColumn,A.endColumn)):(n=A.endLineNumber,T=A.endColumn),new S(I,y,n,T)}intersectRanges(A){return S.intersectRanges(this,A)}static intersectRanges(A,D){let I=A.startLineNumber,y=A.startColumn,n=A.endLineNumber,T=A.endColumn,k=D.startLineNumber,b=D.startColumn,m=D.endLineNumber,r=D.endColumn;return I<k?(I=k,y=b):I===k&&(y=Math.max(y,b)),n>m?(n=m,T=r):n===m&&(T=Math.min(T,r)),I>n||I===n&&y>T?null:new S(I,y,n,T)}equalsRange(A){return S.equalsRange(this,A)}static equalsRange(A,D){return!!A&&!!D&&A.startLineNumber===D.startLineNumber&&A.startColumn===D.startColumn&&A.endLineNumber===D.endLineNumber&&A.endColumn===D.endColumn}getEndPosition(){return S.getEndPosition(this)}static getEndPosition(A){return new E.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return S.getStartPosition(this)}static getStartPosition(A){return new E.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,D){return new S(this.startLineNumber,this.startColumn,A,D)}setStartPosition(A,D){return new S(A,D,this.endLineNumber,this.endColumn)}collapseToStart(){return S.collapseToStart(this)}static collapseToStart(A){return new S(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}static fromPositions(A,D=A){return new S(A.lineNumber,A.column,D.lineNumber,D.column)}static lift(A){return A?new S(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<A.startColumn)}static areIntersecting(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<=D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,D){if(A&&D){const n=A.startLineNumber|0,T=D.startLineNumber|0;if(n===T){const k=A.startColumn|0,b=D.startColumn|0;if(k===b){const m=A.endLineNumber|0,r=D.endLineNumber|0;if(m===r){const d=A.endColumn|0,_=D.endColumn|0;return d-_}return m-r}return k-b}return n-T}return(A?1:0)-(D?1:0)}static compareRangesUsingEnds(A,D){return A.endLineNumber===D.endLineNumber?A.endColumn===D.endColumn?A.startLineNumber===D.startLineNumber?A.startColumn-D.startColumn:A.startLineNumber-D.startLineNumber:A.endColumn-D.endColumn:A.endLineNumber-D.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}}e.Range=S}),define(be[113],we([0,1,39,33]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var R;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(R=e.SelectionDirection||(e.SelectionDirection={}));class A extends S.Range{constructor(I,y,n,T){super(I,y,n,T);this.selectionStartLineNumber=I,this.selectionStartColumn=y,this.positionLineNumber=n,this.positionColumn=T}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return A.selectionsEqual(this,I)}static selectionsEqual(I,y){return I.selectionStartLineNumber===y.selectionStartLineNumber&&I.selectionStartColumn===y.selectionStartColumn&&I.positionLineNumber===y.positionLineNumber&&I.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,y){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,I,y):new A(I,y,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(I,y){return this.getDirection()===0?new A(I,y,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,I,y)}static fromPositions(I,y=I){return new A(I.lineNumber,I.column,y.lineNumber,y.column)}static liftSelection(I){return new A(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,y){if(I&&!y||!I&&y)return!1;if(!I&&!y)return!0;if(I.length!==y.length)return!1;for(let n=0,T=I.length;n<T;n++)if(!this.selectionsEqual(I[n],y[n]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,y,n,T,k){return k===0?new A(I,y,n,T):new A(n,T,I,y)}}e.Selection=A}),define(be[82],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var E;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(E=e.OverviewRulerLane||(e.OverviewRulerLane={}));var S;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(S=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(R=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class y{constructor(r,d){this.range=r,this.matches=d}}e.FindMatch=y;var n;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var T;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class k{constructor(r,d,_,g,w,u){this.identifier=r,this.range=d,this.text=_,this.forceMoveMarkers=g,this.isAutoWhitespaceEdit=w,this._isTracked=u}}e.ValidAnnotatedEditOperation=k;class b{constructor(r,d,_){this.reverseEdits=r,this.changes=d,this.trimAutoWhitespaceLineNumbers=_}}e.ApplyEditsResult=b}),define(be[114],we([0,1,8,112,39,33,82]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class y{constructor(u,c,s,t){this.searchString=u,this.isRegex=c,this.matchCase=s,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=n(this.searchString):u=this.searchString.indexOf(`
`)>=0;let c=null;try{c=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let s=!this.isRegex&&!u;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new T(c,this.wordSeparators?(0,S.getMapForWordSeparators)(this.wordSeparators):null,s?this.searchString:null)}}e.SearchParams=y;function n(w){if(!w||w.length===0)return!1;for(let u=0,c=w.length;u<c;u++)if(w.charCodeAt(u)===92){if(u++,u>=c)break;const t=w.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class T{constructor(u,c,s){this.regex=u,this.wordSeparators=c,this.simpleSearch=s}}e.SearchData=T;function k(w,u,c){if(!c)return new D.FindMatch(w,null);let s=[];for(let t=0,i=u.length;t<i;t++)s[t]=u[t];return new D.FindMatch(w,s)}e.createFindMatch=k;class b{constructor(u){let c=[],s=0;for(let t=0,i=u.length;t<i;t++)u.charCodeAt(t)===10&&(c[s++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(u){const c=this._lineFeedsOffsets;let s=0,t=c.length-1;if(t===-1||u<=c[0])return 0;for(;s<t;){const i=s+((t-s)/2>>0);c[i]>=u?t=i-1:c[i+1]>=u?(s=i,t=i):s=i+1}return s+1}}class m{static findMatches(u,c,s,t,i){const l=c.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(u,s,new g(l.wordSeparators,l.regex),t,i):this._doFindMatchesLineByLine(u,s,l,t,i):[]}static _getMultilineMatchRange(u,c,s,t,i,l){let o,a=0;t?(a=t.findLineFeedCountBeforeOffset(i),o=c+i+a):o=c+i;let f;if(t){let p=t.findLineFeedCountBeforeOffset(i+l.length)-a;f=o+l.length+p}else f=o+l.length;const v=u.getPositionAt(o),C=u.getPositionAt(f);return new A.Range(v.lineNumber,v.column,C.lineNumber,C.column)}static _doFindMatchesMultiline(u,c,s,t,i){const l=u.getOffsetAt(c.getStartPosition()),o=u.getValueInRange(c,1),a=u.getEOL()===`\r
`?new b(o):null,f=[];let v=0,C;for(s.reset(0);C=s.next(o);)if(f[v++]=k(this._getMultilineMatchRange(u,l,o,a,C.index,C[0]),C,t),v>=i)return f;return f}static _doFindMatchesLineByLine(u,c,s,t,i){const l=[];let o=0;if(c.startLineNumber===c.endLineNumber){const f=u.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return o=this._findMatchesInLine(s,f,c.startLineNumber,c.startColumn-1,o,l,t,i),l}const a=u.getLineContent(c.startLineNumber).substring(c.startColumn-1);o=this._findMatchesInLine(s,a,c.startLineNumber,c.startColumn-1,o,l,t,i);for(let f=c.startLineNumber+1;f<c.endLineNumber&&o<i;f++)o=this._findMatchesInLine(s,u.getLineContent(f),f,0,o,l,t,i);if(o<i){const f=u.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);o=this._findMatchesInLine(s,f,c.endLineNumber,0,o,l,t,i)}return l}static _findMatchesInLine(u,c,s,t,i,l,o,a){const f=u.wordSeparators;if(!o&&u.simpleSearch){const h=u.simpleSearch,p=h.length,P=c.length;let F=-p;for(;(F=c.indexOf(h,F+p))!==-1;)if((!f||_(f,c,P,F,p))&&(l[i++]=new D.FindMatch(new A.Range(s,F+1+t,s,F+1+p+t),null),i>=a))return i;return i}const v=new g(u.wordSeparators,u.regex);let C;v.reset(0);do if(C=v.next(c),C&&(l[i++]=k(new A.Range(s,C.index+1+t,s,C.index+1+C[0].length+t),C,o),i>=a))return i;while(C);return i}static findNextMatch(u,c,s,t){const i=c.parseSearchRequest();if(!i)return null;const l=new g(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(u,s,l,t):this._doFindNextMatchLineByLine(u,s,l,t)}static _doFindNextMatchMultiline(u,c,s,t){const i=new R.Position(c.lineNumber,1),l=u.getOffsetAt(i),o=u.getLineCount(),a=u.getValueInRange(new A.Range(i.lineNumber,i.column,o,u.getLineMaxColumn(o)),1),f=u.getEOL()===`\r
`?new b(a):null;s.reset(c.column-1);let v=s.next(a);return v?k(this._getMultilineMatchRange(u,l,a,f,v.index,v[0]),v,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(u,new R.Position(1,1),s,t):null}static _doFindNextMatchLineByLine(u,c,s,t){const i=u.getLineCount(),l=c.lineNumber,o=u.getLineContent(l),a=this._findFirstMatchInLine(s,o,l,c.column,t);if(a)return a;for(let f=1;f<=i;f++){const v=(l+f-1)%i,C=u.getLineContent(v+1),h=this._findFirstMatchInLine(s,C,v+1,1,t);if(h)return h}return null}static _findFirstMatchInLine(u,c,s,t,i){u.reset(t-1);const l=u.next(c);return l?k(new A.Range(s,l.index+1,s,l.index+1+l[0].length),l,i):null}static findPreviousMatch(u,c,s,t){const i=c.parseSearchRequest();if(!i)return null;const l=new g(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(u,s,l,t):this._doFindPreviousMatchLineByLine(u,s,l,t)}static _doFindPreviousMatchMultiline(u,c,s,t){const i=this._doFindMatchesMultiline(u,new A.Range(1,1,c.lineNumber,c.column),s,t,10*I);if(i.length>0)return i[i.length-1];const l=u.getLineCount();return c.lineNumber!==l||c.column!==u.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(u,new R.Position(l,u.getLineMaxColumn(l)),s,t):null}static _doFindPreviousMatchLineByLine(u,c,s,t){const i=u.getLineCount(),l=c.lineNumber,o=u.getLineContent(l).substring(0,c.column-1),a=this._findLastMatchInLine(s,o,l,t);if(a)return a;for(let f=1;f<=i;f++){const v=(i+l-f-1)%i,C=u.getLineContent(v+1),h=this._findLastMatchInLine(s,C,v+1,t);if(h)return h}return null}static _findLastMatchInLine(u,c,s,t){let i=null,l;for(u.reset(0);l=u.next(c);)i=k(new A.Range(s,l.index+1,s,l.index+1+l[0].length),l,t);return i}}e.TextModelSearch=m;function r(w,u,c,s,t){if(s===0)return!0;const i=u.charCodeAt(s-1);if(w.get(i)!==0||i===13||i===10)return!0;if(t>0){const l=u.charCodeAt(s);if(w.get(l)!==0)return!0}return!1}function d(w,u,c,s,t){if(s+t===c)return!0;const i=u.charCodeAt(s+t);if(w.get(i)!==0||i===13||i===10)return!0;if(t>0){const l=u.charCodeAt(s+t-1);if(w.get(l)!==0)return!0}return!1}function _(w,u,c,s,t){return r(w,u,c,s,t)&&d(w,u,c,s,t)}e.isValidMatch=_;class g{constructor(u,c){this._wordSeparators=u,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const c=u.length;let s;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(s=this._searchRegex.exec(u),!s))return null;const t=s.index,i=s[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){E.getNextCodePoint(u,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||_(this._wordSeparators,u,c,t,i))return s}while(s);return null}}e.Searcher=g}),define(be[83],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(I=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)I.indexOf(n)>=0||(y+="\\"+n);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=E();function S(I){let y=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)y=I;else{let n="g";I.ignoreCase&&(n+="i"),I.multiline&&(n+="m"),I.unicode&&(n+="u"),y=new RegExp(I.source,n)}return y.lastIndex=0,y}e.ensureValidWordDefinition=S;const R={maxLen:1e3,windowSize:15,timeBudget:150};function A(I,y,n,T,k=R){if(n.length>k.maxLen){let _=I-k.maxLen/2;return _<0?_=0:T+=_,n=n.substring(_,I+k.maxLen/2),A(I,y,n,T,k)}const b=Date.now(),m=I-1-T;let r=-1,d=null;for(let _=1;!(Date.now()-b>=k.timeBudget);_++){const g=m-k.windowSize*_;y.lastIndex=Math.max(0,g);const w=D(y,n,m,r);if(!w&&d||(d=w,g<=0))break;r=g}if(d){let _={word:d[0],startColumn:T+1+d.index,endColumn:T+1+d.index+d[0].length};return y.lastIndex=0,_}return null}e.getWordAtText=A;function D(I,y,n,T){let k;for(;k=I.exec(y);){const b=k.index||0;if(b<=n&&I.lastIndex>=n)return k;if(T>0&&b>T)return null}return null}}),define(be[115],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var E;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(E=e.IndentAction||(e.IndentAction={}));class S{constructor(I){if(this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let y=0,n=I.notIn.length;y<n;y++)switch(I.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=S;class R{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of I)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=R;function A(D,I,y){D.has(I)?D.get(I).push(y):D.set(I,[y])}}),define(be[59],we([0,1,28,11]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function R(A,D,I,y){if(Array.isArray(A)){let n=0;for(const T of A){const k=R(T,D,I,y);if(k===10)return k;k>n&&(n=k)}return n}else{if(typeof A=="string")return y?A==="*"?5:A===I?10:0:0;if(A){const{language:n,pattern:T,scheme:k,hasAccessToAllModels:b}=A;if(!y&&!b)return 0;let m=0;if(k)if(k===D.scheme)m=10;else if(k==="*")m=5;else return 0;if(n)if(n===I)m=10;else if(n==="*")m=Math.max(m,5);else return 0;if(T){let r;if(typeof T=="string"?r=T:r=Object.assign(Object.assign({},T),{base:(0,S.normalize)(T.base)}),r===D.fsPath||(0,E.match)(r,D.fsPath))m=10;else return 0}return m}else return 0}}e.score=R}),define(be[116],we([0,1,81]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var S;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(S=e.State||(e.State={}));class R{constructor(r,d,_){const g=new Uint8Array(r*d);for(let w=0,u=r*d;w<u;w++)g[w]=_;this._data=g,this.rows=r,this.cols=d}get(r,d){return this._data[r*this.cols+d]}set(r,d,_){this._data[r*this.cols+d]=_}}e.Uint8Matrix=R;class A{constructor(r){let d=0,_=0;for(let w=0,u=r.length;w<u;w++){let[c,s,t]=r[w];s>d&&(d=s),c>_&&(_=c),t>_&&(_=t)}d++,_++;let g=new R(_,d,0);for(let w=0,u=r.length;w<u;w++){let[c,s,t]=r[w];g.set(c,s,t)}this._states=g,this._maxCharCode=d}nextState(r,d){return d<0||d>=this._maxCharCode?0:this._states.get(r,d)}}e.StateMachine=A;let D=null;function I(){return D===null&&(D=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var y;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let n=null;function T(){if(n===null){n=new E.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<m.length;d++)n.set(m.charCodeAt(d),1);const r=".,;";for(let d=0;d<r.length;d++)n.set(r.charCodeAt(d),2)}return n}class k{static _createLink(r,d,_,g,w){let u=w-1;do{const c=d.charCodeAt(u);if(r.get(c)!==2)break;u--}while(u>g);if(g>0){const c=d.charCodeAt(g-1),s=d.charCodeAt(u);(c===40&&s===41||c===91&&s===93||c===123&&s===125)&&u--}return{range:{startLineNumber:_,startColumn:g+1,endLineNumber:_,endColumn:u+2},url:d.substring(g,u+1)}}static computeLinks(r,d=I()){const _=T();let g=[];for(let w=1,u=r.getLineCount();w<=u;w++){const c=r.getLineContent(w),s=c.length;let t=0,i=0,l=0,o=1,a=!1,f=!1,v=!1,C=!1;for(;t<s;){let h=!1;const p=c.charCodeAt(t);if(o===13){let P;switch(p){case 40:a=!0,P=0;break;case 41:P=a?0:1;break;case 91:v=!0,f=!0,P=0;break;case 93:v=!1,P=f?0:1;break;case 123:C=!0,P=0;break;case 125:P=C?0:1;break;case 39:P=l===34||l===96?0:1;break;case 34:P=l===39||l===96?0:1;break;case 96:P=l===39||l===34?0:1;break;case 42:P=l===42?1:0;break;case 124:P=l===124?1:0;break;case 32:P=v?0:1;break;default:P=_.get(p)}P===1&&(g.push(k._createLink(_,c,w,i,t)),h=!0)}else if(o===12){let P;p===91?(f=!0,P=0):P=_.get(p),P===1?h=!0:o=13}else o=d.nextState(o,p),o===0&&(h=!0);h&&(o=1,a=!1,f=!1,C=!1,i=t+1,l=p),t++}o===13&&g.push(k._createLink(_,c,w,i,s))}return g}}e.LinkComputer=k;function b(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:k.computeLinks(m)}e.computeLinks=b}),define(be[117],we([0,1,3,6]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class R{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(D){this._onDidChange.fire({changedLanguages:D,changedColorMap:!1})}register(D,I){return this._map.set(D,I),this.fire([D]),(0,S.toDisposable)(()=>{this._map.get(D)===I&&(this._map.delete(D),this.fire([D]))})}registerPromise(D,I){let y=null,n=!1;return this._promises.set(D,I.then(T=>{this._promises.delete(D),!(n||!T)&&(y=this.register(D,T))})),(0,S.toDisposable)(()=>{n=!0,y&&y.dispose()})}getPromise(D){const I=this.get(D);if(I)return Promise.resolve(I);const y=this._promises.get(D);return y?y.then(n=>this.get(D)):null}get(D){return this._map.get(D)||null}setColorMap(D){this._colorMap=D,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=R}),define(be[84],we([0,1,26,21]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var R;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(R||(R={}));function A(k){for(let b=0,m=k.length;b<m;b+=4){const r=k[b+0],d=k[b+1],_=k[b+2],g=k[b+3];k[b+0]=g,k[b+1]=_,k[b+2]=d,k[b+3]=r}}function D(k){const b=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return S.isLittleEndian()||A(b),E.VSBuffer.wrap(b)}function I(k){const b=k.buffer;if(S.isLittleEndian()||A(b),b.byteOffset%4==0)return new Uint32Array(b.buffer,b.byteOffset,b.length/4);{const m=new Uint8Array(b.byteLength);return m.set(b),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function y(k){const b=new Uint32Array(n(k));let m=0;if(b[m++]=k.id,k.type==="full")b[m++]=1,b[m++]=k.data.length,b.set(k.data,m),m+=k.data.length;else{b[m++]=2,b[m++]=k.deltas.length;for(const r of k.deltas)b[m++]=r.start,b[m++]=r.deleteCount,r.data?(b[m++]=r.data.length,b.set(r.data,m),m+=r.data.length):b[m++]=0}return D(b)}e.encodeSemanticTokensDto=y;function n(k){let b=0;if(b+=1+1,k.type==="full")b+=1+k.data.length;else{b+=1,b+=(1+1+1)*k.deltas.length;for(const m of k.deltas)m.data&&(b+=m.data.length)}return b}function T(k){const b=I(k);let m=0;const r=b[m++];if(b[m++]===1){const w=b[m++],u=b.subarray(m,m+w);return m+=w,{id:r,type:"full",data:u}}const _=b[m++];let g=[];for(let w=0;w<_;w++){const u=b[m++],c=b[m++],s=b[m++];let t;s>0&&(t=b.subarray(m,m+s),m+=s),g[w]={start:u,deleteCount:c,data:t}}return{id:r,type:"delta",deltas:g}}e.decodeSemanticTokensDto=T}),define(be[85],we([0,1,79]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class S{constructor(D,I){this.index=D,this.remainder=I}}e.PrefixSumIndexOfResult=S;class R{constructor(D){this.values=D,this.prefixSum=new Uint32Array(D.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(D,I){D=(0,E.toUint32)(D);const y=this.values,n=this.prefixSum,T=I.length;return T===0?!1:(this.values=new Uint32Array(y.length+T),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D),D+T),this.values.set(I,D),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(D,I){return D=(0,E.toUint32)(D),I=(0,E.toUint32)(I),this.values[D]===I?!1:(this.values[D]=I,D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),!0)}removeValues(D,I){D=(0,E.toUint32)(D),I=(0,E.toUint32)(I);const y=this.values,n=this.prefixSum;if(D>=y.length)return!1;let T=y.length-D;return I>=T&&(I=T),I===0?!1:(this.values=new Uint32Array(y.length-I),this.values.set(y.subarray(0,D),0),this.values.set(y.subarray(D+I),D),this.prefixSum=new Uint32Array(this.values.length),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(D){return D<0?0:(D=(0,E.toUint32)(D),this._getAccumulatedValue(D))}_getAccumulatedValue(D){if(D<=this.prefixSumValidIndex[0])return this.prefixSum[D];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),D>=this.values.length&&(D=this.values.length-1);for(let y=I;y<=D;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],D),this.prefixSum[D]}getIndexOf(D){D=Math.floor(D),this.getTotalValue();let I=0,y=this.values.length-1,n=0,T=0,k=0;for(;I<=y;)if(n=I+(y-I)/2|0,T=this.prefixSum[n],k=T-this.values[n],D<k)y=n-1;else if(D>=T)I=n+1;else break;return new S(n,D-k)}}e.PrefixSumComputer=R}),define(be[118],we([0,1,8,39,85]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(I,y,n,T){this._uri=I,this._lines=y,this._eol=n,this._versionId=T,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const y=I.changes;for(const n of y)this._acceptDeleteRange(n.range),this._acceptInsertText(new S.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,y=this._lines.length,n=new Uint32Array(y);for(let T=0;T<y;T++)n[T]=this._lines[T].length+I;this._lineStarts=new R.PrefixSumComputer(n)}}_setLineText(I,y){this._lines[I]=y,this._lineStarts&&this._lineStarts.changeValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,y){if(y.length!==0){let n=(0,E.splitLines)(y);if(n.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+n[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}n[n.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+n[0]);let T=new Uint32Array(n.length-1);for(let k=1;k<n.length;k++)this._lines.splice(I.lineNumber+k-1,0,n[k]),T[k-1]=n[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,T)}}}e.MirrorTextModel=A}),define(be[119],we([17,18]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(be[60],we([0,1,119,12,15]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(n,T){return T&&(n.stack||n.stacktrace)?E.localize(0,null,I(n),D(n.stack)||D(n.stacktrace)):I(n)}function D(n){return Array.isArray(n)?n.join(`
`):n}function I(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?E.localize(1,null,n.message):n.message||E.localize(2,null)}function y(n=null,T=!1){if(!n)return E.localize(3,null);if(Array.isArray(n)){const k=R.coalesce(n),b=y(k[0],T);return k.length>1?E.localize(4,null,b,k.length):b}if(S.isString(n))return n;if(n.detail){const k=n.detail;if(k.error)return A(k.error,T);if(k.exception)return A(k.exception,T)}return n.stack?A(n,T):n.message?n.message:E.localize(5,null)}e.toErrorMessage=y}),define(be[120],we([17,18]),function(ae,e){return ae.create("vs/editor/common/config/editorOptions",e)}),define(be[121],we([0,1,120,21,83]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(Y){this._values=Y}hasChanged(Y){return this._values[Y]}}e.ConfigurationChangedEvent=D;class I{constructor(){this._values=[]}_read(Y){return this._values[Y]}get(Y){return this._values[Y]}_write(Y,ve){this._values[Y]=ve}}e.ValidatedEditorOptions=I;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class n{constructor(Y,ve,Le,Be){this.id=Y,this.name=ve,this.defaultValue=Le,this.schema=Be}compute(Y,ve,Le){return Le}}class T{constructor(Y,ve=null){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(Y){return this.defaultValue}}class k{constructor(Y,ve,Le,Be){this.id=Y,this.name=ve,this.defaultValue=Le,this.schema=Be}validate(Y){return typeof Y=="undefined"?this.defaultValue:Y}compute(Y,ve,Le){return Le}}function b(V,Y){return typeof V=="undefined"?Y:V==="false"?!1:Boolean(V)}e.boolean=b;class m extends k{constructor(Y,ve,Le,Be=void 0){typeof Be!="undefined"&&(Be.type="boolean",Be.default=Le),super(Y,ve,Le,Be)}validate(Y){return b(Y,this.defaultValue)}}class r extends k{constructor(Y,ve,Le,Be,Oe,et=void 0){typeof et!="undefined"&&(et.type="integer",et.default=Le,et.minimum=Be,et.maximum=Oe),super(Y,ve,Le,et),this.minimum=Be,this.maximum=Oe}static clampedInt(Y,ve,Le,Be){if(typeof Y=="undefined")return ve;let Oe=parseInt(Y,10);return isNaN(Oe)?ve:(Oe=Math.max(Le,Oe),Oe=Math.min(Be,Oe),Oe|0)}validate(Y){return r.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}class d extends k{constructor(Y,ve,Le,Be,Oe){typeof Oe!="undefined"&&(Oe.type="number",Oe.default=Le),super(Y,ve,Le,Oe),this.validationFn=Be}static clamp(Y,ve,Le){return Y<ve?ve:Y>Le?Le:Y}static float(Y,ve){if(typeof Y=="number")return Y;if(typeof Y=="undefined")return ve;const Le=parseFloat(Y);return isNaN(Le)?ve:Le}validate(Y){return this.validationFn(d.float(Y,this.defaultValue))}}class _ extends k{static string(Y,ve){return typeof Y!="string"?ve:Y}constructor(Y,ve,Le,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.default=Le),super(Y,ve,Le,Be)}validate(Y){return _.string(Y,this.defaultValue)}}function g(V,Y,ve){return typeof V!="string"||ve.indexOf(V)===-1?Y:V}e.stringSet=g;class w extends k{constructor(Y,ve,Le,Be,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="string",Oe.enum=Be,Oe.default=Le),super(Y,ve,Le,Oe),this._allowedValues=Be}validate(Y){return g(Y,this.defaultValue,this._allowedValues)}}class u extends n{constructor(Y,ve,Le,Be,Oe,et,B=void 0){typeof B!="undefined"&&(B.type="string",B.enum=Oe,B.default=Be),super(Y,ve,Le,B),this._allowedValues=Oe,this._convert=et}validate(Y){return typeof Y!="string"?this.defaultValue:this._allowedValues.indexOf(Y)===-1?this.defaultValue:this._convert(Y)}}function c(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[E.localize(0,null),E.localize(1,null),E.localize(2,null)],default:"auto",description:E.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,ve,Le){return Le===0?Y.accessibilitySupport:Le}}class t extends n{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:E.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:E.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{insertSpace:b(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(V){switch(V){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function f(V){switch(V){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class v extends T{constructor(){super(123,[62,31])}compute(Y,ve,Le){const Be=["monaco-editor"];return ve.get(31)&&Be.push(ve.get(31)),Y.extraEditorClassName&&Be.push(Y.extraEditorClassName),ve.get(62)==="default"?Be.push("mouse-default"):ve.get(62)==="copy"&&Be.push("mouse-copy"),ve.get(97)&&Be.push("showUnused"),ve.get(121)&&Be.push("showDeprecated"),Be.join(" ")}}class C extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:E.localize(6,null)})}compute(Y,ve,Le){return Le&&Y.emptySelectionClipboard}}class h extends n{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:E.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Y.seedSearchStringFromSelection,description:E.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[E.localize(9,null),E.localize(10,null),E.localize(11,null)],description:E.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:E.localize(13,null),included:S.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:E.localize(14,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:E.localize(15,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{cursorMoveOnType:b(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:b(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":g(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(ve.loop,this.defaultValue.loop)}}}class p extends n{constructor(){super(41,"fontLigatures",p.OFF,{anyOf:[{type:"boolean",description:E.localize(16,null)},{type:"string",description:E.localize(17,null)}],description:E.localize(18,null),default:!1})}validate(Y){return typeof Y=="undefined"?this.defaultValue:typeof Y=="string"?Y==="false"?p.OFF:Y==="true"?p.ON:Y:Boolean(Y)?p.ON:p.OFF}}e.EditorFontLigatures=p,p.OFF='"liga" off, "calt" off',p.ON='"liga" on, "calt" on';class P extends T{constructor(){super(40)}compute(Y,ve,Le){return Y.fontInfo}}class F extends k{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:E.localize(19,null)})}validate(Y){let ve=d.float(Y,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ve,6,100)}compute(Y,ve,Le){return Y.fontInfo.fontSize}}class z extends n{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:E.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:E.localize(21,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(r.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class le extends n{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[E.localize(22,null),E.localize(23,null),E.localize(24,null)]};super(47,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:E.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:E.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:E.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:E.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:E.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:E.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,description:E.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,description:E.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,description:E.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,description:E.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,description:E.localize(35,null)}})}validate(Y){var ve,Le,Be,Oe,et;if(!Y||typeof Y!="object")return this.defaultValue;const B=Y;return{multiple:g(B.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=B.multipleDefinitions)!==null&&ve!==void 0?ve:g(B.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Le=B.multipleTypeDefinitions)!==null&&Le!==void 0?Le:g(B.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Be=B.multipleDeclarations)!==null&&Be!==void 0?Be:g(B.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Oe=B.multipleImplementations)!==null&&Oe!==void 0?Oe:g(B.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(et=B.multipleReferences)!==null&&et!==void 0?et:g(B.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(B.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(B.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(B.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(B.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(B.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends n{constructor(){const Y={enabled:!0,delay:300,sticky:!0};super(50,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:E.localize(36,null)},"editor.hover.delay":{type:"number",default:Y.delay,description:E.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:E.localize(38,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{enabled:b(ve.enabled,this.defaultValue.enabled),delay:r.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:b(ve.sticky,this.defaultValue.sticky)}}}var W;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(W=e.RenderMinimap||(e.RenderMinimap={}));class G extends T{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(Y,ve,Le){return G.computeLayout(ve,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio})}static computeContainedMinimapLineCount(Y){const ve=Y.height/Y.lineHeight,Le=Y.scrollBeyondLastLine?ve-1:0,Be=(Y.viewLineCount+Le)/(Y.pixelRatio*Y.height),Oe=Math.floor(Y.viewLineCount/Be);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Le,desiredRatio:Be,minimapLineCount:Oe}}static _computeMinimapLayout(Y,ve){const Le=Y.outerWidth,Be=Y.outerHeight,Oe=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Oe*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const et=ve.stableMinimapLayoutInput,B=et&&Y.outerHeight===et.outerHeight&&Y.lineHeight===et.lineHeight&&Y.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&Y.pixelRatio===et.pixelRatio&&Y.scrollBeyondLastLine===et.scrollBeyondLastLine&&Y.minimap.enabled===et.minimap.enabled&&Y.minimap.side===et.minimap.side&&Y.minimap.size===et.minimap.size&&Y.minimap.showSlider===et.minimap.showSlider&&Y.minimap.renderCharacters===et.minimap.renderCharacters&&Y.minimap.maxColumn===et.minimap.maxColumn&&Y.minimap.scale===et.minimap.scale&&Y.verticalScrollbarWidth===et.verticalScrollbarWidth&&Y.isViewportWrapping===et.isViewportWrapping,te=Y.lineHeight,he=Y.typicalHalfwidthCharacterWidth,q=Y.scrollBeyondLastLine,J=Y.minimap.renderCharacters;let se=Oe>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const fe=Y.minimap.maxColumn,pe=Y.minimap.size,We=Y.minimap.side,Ne=Y.verticalScrollbarWidth,Ve=Y.viewLineCount,Je=Y.remainingWidth,Ze=Y.isViewportWrapping,ct=J?2:3;let ot=Math.floor(Oe*Be);const nt=ot/Oe;let ue=!1,De=!1,ce=ct*se,j=se/Oe,Ae=1;if(pe==="fill"||pe==="fit"){const{typicalViewportLineCount:ut,extraLinesBeyondLastLine:st,desiredRatio:gt,minimapLineCount:wt}=G.computeContainedMinimapLineCount({viewLineCount:Ve,scrollBeyondLastLine:q,height:Be,lineHeight:te,pixelRatio:Oe});if(Ve/wt>1)ue=!0,De=!0,se=1,ce=1,j=se/Oe;else{let vt=!1,Et=se+1;if(pe==="fit"){const pt=Math.ceil((Ve+st)*ce);Ze&&B&&Je<=ve.stableFitRemainingWidth?(vt=!0,Et=ve.stableFitMaxMinimapScale):(vt=pt>ot,Ze&&vt?(ve.stableMinimapLayoutInput=Y,ve.stableFitRemainingWidth=Je):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(pe==="fill"||vt){ue=!0;const pt=se;ce=Math.min(te*Oe,Math.max(1,Math.floor(1/gt))),se=Math.min(Et,Math.max(1,Math.floor(ce/ct))),se>pt&&(Ae=Math.min(2,se/pt)),j=se/Oe/Ae,ot=Math.ceil(Math.max(ut,Ve+st)*ce),Ze&&vt&&(ve.stableFitMaxMinimapScale=se)}}}const Te=Math.floor(fe*j),Xe=Math.min(Te,Math.max(0,Math.floor((Je-Ne-2)*j/(he+j)))+e.MINIMAP_GUTTER_WIDTH);let Ge=Math.floor(Oe*Xe);const rt=Ge/Oe;Ge=Math.floor(Ge*Ae);const at=J?1:2,Qe=We==="left"?0:Le-Xe-Ne;return{renderMinimap:at,minimapLeft:Qe,minimapWidth:Xe,minimapHeightIsEditorHeight:ue,minimapIsSampling:De,minimapScale:se,minimapLineHeight:ce,minimapCanvasInnerWidth:Ge,minimapCanvasInnerHeight:ot,minimapCanvasOuterWidth:rt,minimapCanvasOuterHeight:nt}}static computeLayout(Y,ve){const Le=ve.outerWidth|0,Be=ve.outerHeight|0,Oe=ve.lineHeight|0,et=ve.lineNumbersDigitCount|0,B=ve.typicalHalfwidthCharacterWidth,te=ve.maxDigitWidth,he=ve.pixelRatio,q=ve.viewLineCount,J=Y.get(118),se=J==="inherit"?Y.get(117):J,fe=se==="inherit"?Y.get(113):se,pe=Y.get(116),We=Y.get(2),Ne=ve.isDominatedByLongLines,Ve=Y.get(46),Je=Y.get(56).renderType!==0,Ze=Y.get(57),ct=Y.get(91),ot=Y.get(61),nt=Y.get(89),ue=nt.verticalScrollbarSize,De=nt.verticalHasArrows,ce=nt.arrowSize,j=nt.horizontalScrollbarSize,Ae=Y.get(54),Te=Y.get(35);let Xe;if(typeof Ae=="string"&&/^\d+(\.\d+)?ch$/.test(Ae)){const ft=parseFloat(Ae.substr(0,Ae.length-2));Xe=r.clampedInt(ft*B,0,0,1e3)}else Xe=r.clampedInt(Ae,0,0,1e3);Te&&(Xe+=16);let Ge=0;if(Je){const ft=Math.max(et,Ze);Ge=Math.round(ft*te)}let rt=0;Ve&&(rt=Oe);let at=0,Qe=at+rt,ut=Qe+Ge,st=ut+Xe;const gt=Le-rt-Ge-Xe;let wt=!1,Dt=!1,vt=-1;We!==2&&(se==="inherit"&&Ne?(wt=!0,Dt=!0):fe==="on"||fe==="bounded"?Dt=!0:fe==="wordWrapColumn"&&(vt=pe));const Et=G._computeMinimapLayout({outerWidth:Le,outerHeight:Be,lineHeight:Oe,typicalHalfwidthCharacterWidth:B,pixelRatio:he,scrollBeyondLastLine:ct,minimap:ot,verticalScrollbarWidth:ue,viewLineCount:q,remainingWidth:gt,isViewportWrapping:Dt},ve.memory||new y);Et.renderMinimap!==0&&Et.minimapLeft===0&&(at+=Et.minimapWidth,Qe+=Et.minimapWidth,ut+=Et.minimapWidth,st+=Et.minimapWidth);const pt=gt-Et.minimapWidth,Ft=Math.max(1,Math.floor((pt-ue-2)/B)),Lt=De?ce:0;return Dt&&(vt=Math.max(1,Ft),fe==="bounded"&&(vt=Math.min(vt,pe))),{width:Le,height:Be,glyphMarginLeft:at,glyphMarginWidth:rt,lineNumbersLeft:Qe,lineNumbersWidth:Ge,decorationsLeft:ut,decorationsWidth:Xe,contentLeft:st,contentWidth:pt,minimap:Et,viewportColumn:Ft,isWordWrapMinified:wt,isViewportWrapping:Dt,wrappingColumn:vt,verticalScrollbarWidth:ue,horizontalScrollbarHeight:j,overviewRuler:{top:Lt,width:ue,height:Be-2*Lt,right:0}}}}e.EditorLayoutInfoComputer=G;class L extends n{constructor(){const Y={enabled:!0};super(53,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:E.localize(39,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:b(Y.enabled,this.defaultValue.enabled)}}}class U extends n{constructor(){const Y={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",Y,{"editor.inlineHints.enabled":{type:"boolean",default:Y.enabled,description:E.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:Y.fontSize,description:E.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:Y.fontFamily,description:E.localize(42,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{enabled:b(ve.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class x extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:E.localize(43,null)})}compute(Y,ve,Le){return Y.fontInfo.lineHeight}}class Q extends n{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:E.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[E.localize(45,null),E.localize(46,null),E.localize(47,null)],default:Y.size,description:E.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:E.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:E.localize(50,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:E.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:E.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:E.localize(53,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{enabled:b(ve.enabled,this.defaultValue.enabled),size:g(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:g(ve.side,this.defaultValue.side,["right","left"]),showSlider:g(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(ve.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ve.scale,1,1,3),maxColumn:r.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function $(V){return V==="ctrlCmd"?S.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Z extends n{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:E.localize(55,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{top:r.clampedInt(ve.top,0,0,1e3),bottom:r.clampedInt(ve.bottom,0,0,1e3)}}}class ie extends n{constructor(){const Y={enabled:!0,cycle:!1};super(72,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:E.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:E.localize(57,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{enabled:b(ve.enabled,this.defaultValue.enabled),cycle:b(ve.cycle,this.defaultValue.cycle)}}}class re extends T{constructor(){super(124)}compute(Y,ve,Le){return Y.pixelRatio}}class ye extends n{constructor(){const Y={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",Y,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Y.strings,description:E.localize(58,null)},comments:{type:"boolean",default:Y.comments,description:E.localize(59,null)},other:{type:"boolean",default:Y.other,description:E.localize(60,null)}}}],default:Y,description:E.localize(61,null)});this.defaultValue=Y}validate(Y){if(typeof Y=="boolean")return Y;if(Y&&typeof Y=="object"){const ve=Y,Le={other:b(ve.other,this.defaultValue.other),comments:b(ve.comments,this.defaultValue.comments),strings:b(ve.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Ie;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ue extends n{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[E.localize(62,null),E.localize(63,null),E.localize(64,null),E.localize(65,null)],default:"on",description:E.localize(66,null)})}validate(Y){let ve=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Y!="undefined"&&(typeof Y=="function"?(ve=4,Le=Y):Y==="interval"?ve=3:Y==="relative"?ve=2:Y==="on"?ve=1:ve=0),{renderType:ve,renderFn:Le}}}function Fe(V){const Y=V.get(84);return Y==="editable"?V.get(77):Y!=="on"}e.filterValidationDecorations=Fe;class ze extends n{constructor(){const Y=[],ve={type:"number",description:E.localize(67,null)};super(88,"rulers",Y,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:E.localize(68,null),format:"color-hex"}}}]},default:Y,description:E.localize(69,null)})}validate(Y){if(Array.isArray(Y)){let ve=[];for(let Le of Y)if(typeof Le=="number")ve.push({column:r.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Be=Le;ve.push({column:r.clampedInt(Be.column,0,0,1e4),color:Be.color})}return ve.sort((Le,Be)=>Le.column-Be.column),ve}return this.defaultValue}}function N(V,Y){if(typeof V!="string")return Y;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class K extends n{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y,Le=r.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=r.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(ve.vertical,this.defaultValue.vertical),horizontal:N(ve.horizontal,this.defaultValue.horizontal),useShadows:b(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:r.clampedInt(ve.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:r.clampedInt(ve.verticalSliderSize,Be,0,1e3),scrollByPage:b(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends n{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[E.localize(70,null),E.localize(71,null)],default:Y.insertMode,description:E.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:E.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:E.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:E.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:E.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:E.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:E.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:E.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:E.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:E.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:E.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:E.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:E.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:E.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:E.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:E.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:E.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:E.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:E.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:E.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:E.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:E.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:E.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:E.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:E.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:E.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:E.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:E.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:E.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:E.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:E.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:E.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:E.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:E.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:E.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:E.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:E.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:E.localize(109,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const ve=Y;return{insertMode:g(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:b(ve.showIcons,this.defaultValue.showIcons),showStatusBar:b(ve.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:b(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(ve.showMethods,this.defaultValue.showMethods),showFunctions:b(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:b(ve.showConstructors,this.defaultValue.showConstructors),showFields:b(ve.showFields,this.defaultValue.showFields),showVariables:b(ve.showVariables,this.defaultValue.showVariables),showClasses:b(ve.showClasses,this.defaultValue.showClasses),showStructs:b(ve.showStructs,this.defaultValue.showStructs),showInterfaces:b(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:b(ve.showModules,this.defaultValue.showModules),showProperties:b(ve.showProperties,this.defaultValue.showProperties),showEvents:b(ve.showEvents,this.defaultValue.showEvents),showOperators:b(ve.showOperators,this.defaultValue.showOperators),showUnits:b(ve.showUnits,this.defaultValue.showUnits),showValues:b(ve.showValues,this.defaultValue.showValues),showConstants:b(ve.showConstants,this.defaultValue.showConstants),showEnums:b(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:b(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(ve.showKeywords,this.defaultValue.showKeywords),showWords:b(ve.showWords,this.defaultValue.showWords),showColors:b(ve.showColors,this.defaultValue.showColors),showFiles:b(ve.showFiles,this.defaultValue.showFiles),showReferences:b(ve.showReferences,this.defaultValue.showReferences),showFolders:b(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:b(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(ve.showSnippets,this.defaultValue.showSnippets),showUsers:b(ve.showUsers,this.defaultValue.showUsers),showIssues:b(ve.showIssues,this.defaultValue.showIssues)}}}class oe extends n{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:E.localize(110,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends T{constructor(){super(125,[77])}compute(Y,ve,Le){return ve.get(77)?!0:Y.tabFocusMode}}var Se;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(Se=e.WrappingIndent||(e.WrappingIndent={}));function Me(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends T{constructor(){super(127,[126])}compute(Y,ve,Le){const Be=ve.get(126);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",xe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:S.isMacintosh?Pe:S.isLinux?xe:Ce,fontWeight:"normal",fontSize:S.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(V){return e.editorOptionsRegistry[V.id]=V,V}var qe;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.codeLens=12]="codeLens",V[V.codeLensFontFamily=13]="codeLensFontFamily",V[V.codeLensFontSize=14]="codeLensFontSize",V[V.colorDecorators=15]="colorDecorators",V[V.columnSelection=16]="columnSelection",V[V.comments=17]="comments",V[V.contextmenu=18]="contextmenu",V[V.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",V[V.cursorBlinking=20]="cursorBlinking",V[V.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",V[V.cursorStyle=22]="cursorStyle",V[V.cursorSurroundingLines=23]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",V[V.cursorWidth=25]="cursorWidth",V[V.disableLayerHinting=26]="disableLayerHinting",V[V.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",V[V.domReadOnly=28]="domReadOnly",V[V.dragAndDrop=29]="dragAndDrop",V[V.emptySelectionClipboard=30]="emptySelectionClipboard",V[V.extraEditorClassName=31]="extraEditorClassName",V[V.fastScrollSensitivity=32]="fastScrollSensitivity",V[V.find=33]="find",V[V.fixedOverflowWidgets=34]="fixedOverflowWidgets",V[V.folding=35]="folding",V[V.foldingStrategy=36]="foldingStrategy",V[V.foldingHighlight=37]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=39]="fontFamily",V[V.fontInfo=40]="fontInfo",V[V.fontLigatures=41]="fontLigatures",V[V.fontSize=42]="fontSize",V[V.fontWeight=43]="fontWeight",V[V.formatOnPaste=44]="formatOnPaste",V[V.formatOnType=45]="formatOnType",V[V.glyphMargin=46]="glyphMargin",V[V.gotoLocation=47]="gotoLocation",V[V.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",V[V.hover=50]="hover",V[V.inDiffEditor=51]="inDiffEditor",V[V.letterSpacing=52]="letterSpacing",V[V.lightbulb=53]="lightbulb",V[V.lineDecorationsWidth=54]="lineDecorationsWidth",V[V.lineHeight=55]="lineHeight",V[V.lineNumbers=56]="lineNumbers",V[V.lineNumbersMinChars=57]="lineNumbersMinChars",V[V.linkedEditing=58]="linkedEditing",V[V.links=59]="links",V[V.matchBrackets=60]="matchBrackets",V[V.minimap=61]="minimap",V[V.mouseStyle=62]="mouseStyle",V[V.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=64]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",V[V.multiCursorModifier=66]="multiCursorModifier",V[V.multiCursorPaste=67]="multiCursorPaste",V[V.occurrencesHighlight=68]="occurrencesHighlight",V[V.overviewRulerBorder=69]="overviewRulerBorder",V[V.overviewRulerLanes=70]="overviewRulerLanes",V[V.padding=71]="padding",V[V.parameterHints=72]="parameterHints",V[V.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",V[V.quickSuggestions=75]="quickSuggestions",V[V.quickSuggestionsDelay=76]="quickSuggestionsDelay",V[V.readOnly=77]="readOnly",V[V.renameOnType=78]="renameOnType",V[V.renderControlCharacters=79]="renderControlCharacters",V[V.renderIndentGuides=80]="renderIndentGuides",V[V.renderFinalNewline=81]="renderFinalNewline",V[V.renderLineHighlight=82]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=84]="renderValidationDecorations",V[V.renderWhitespace=85]="renderWhitespace",V[V.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",V[V.roundedSelection=87]="roundedSelection",V[V.rulers=88]="rulers",V[V.scrollbar=89]="scrollbar",V[V.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=91]="scrollBeyondLastLine",V[V.scrollPredominantAxis=92]="scrollPredominantAxis",V[V.selectionClipboard=93]="selectionClipboard",V[V.selectionHighlight=94]="selectionHighlight",V[V.selectOnLineNumbers=95]="selectOnLineNumbers",V[V.showFoldingControls=96]="showFoldingControls",V[V.showUnused=97]="showUnused",V[V.snippetSuggestions=98]="snippetSuggestions",V[V.smartSelect=99]="smartSelect",V[V.smoothScrolling=100]="smoothScrolling",V[V.stickyTabStops=101]="stickyTabStops",V[V.stopRenderingLineAfter=102]="stopRenderingLineAfter",V[V.suggest=103]="suggest",V[V.suggestFontSize=104]="suggestFontSize",V[V.suggestLineHeight=105]="suggestLineHeight",V[V.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",V[V.suggestSelection=107]="suggestSelection",V[V.tabCompletion=108]="tabCompletion",V[V.tabIndex=109]="tabIndex",V[V.unusualLineTerminators=110]="unusualLineTerminators",V[V.useTabStops=111]="useTabStops",V[V.wordSeparators=112]="wordSeparators",V[V.wordWrap=113]="wordWrap",V[V.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=116]="wordWrapColumn",V[V.wordWrapOverride1=117]="wordWrapOverride1",V[V.wordWrapOverride2=118]="wordWrapOverride2",V[V.wrappingIndent=119]="wrappingIndent",V[V.wrappingStrategy=120]="wrappingStrategy",V[V.showDeprecated=121]="showDeprecated",V[V.inlineHints=122]="inlineHints",V[V.editorClassName=123]="editorClassName",V[V.pixelRatio=124]="pixelRatio",V[V.tabFocusMode=125]="tabFocusMode",V[V.layoutInfo=126]="layoutInfo",V[V.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:E.localize(111,null)})),acceptSuggestionOnEnter:_e(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",E.localize(112,null),""],markdownDescription:E.localize(113,null)})),accessibilitySupport:_e(new s),accessibilityPageSize:_e(new r(3,"accessibilityPageSize",10,1,1073741824,{description:E.localize(114,null),deprecationMessage:E.localize(115,null)})),ariaLabel:_e(new _(4,"ariaLabel",E.localize(116,null))),autoClosingBrackets:_e(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(117,null),E.localize(118,null),""],description:E.localize(119,null)})),autoClosingDelete:_e(new w(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",E.localize(120,null),""],description:E.localize(121,null)})),autoClosingOvertype:_e(new w(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",E.localize(122,null),""],description:E.localize(123,null)})),autoClosingQuotes:_e(new w(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",E.localize(124,null),E.localize(125,null),""],description:E.localize(126,null)})),autoIndent:_e(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[E.localize(127,null),E.localize(128,null),E.localize(129,null),E.localize(130,null),E.localize(131,null)],description:E.localize(132,null)})),automaticLayout:_e(new m(10,"automaticLayout",!1)),autoSurround:_e(new w(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[E.localize(133,null),E.localize(134,null),E.localize(135,null),""],description:E.localize(136,null)})),stickyTabStops:_e(new m(101,"stickyTabStops",!1,{description:E.localize(137,null)})),codeLens:_e(new m(12,"codeLens",!0,{description:E.localize(138,null)})),codeLensFontFamily:_e(new _(13,"codeLensFontFamily","",{description:E.localize(139,null)})),codeLensFontSize:_e(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:E.localize(140,null)})),colorDecorators:_e(new m(15,"colorDecorators",!0,{description:E.localize(141,null)})),columnSelection:_e(new m(16,"columnSelection",!1,{description:E.localize(142,null)})),comments:_e(new t),contextmenu:_e(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new m(19,"copyWithSyntaxHighlighting",!0,{description:E.localize(143,null)})),cursorBlinking:_e(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:E.localize(144,null)})),cursorSmoothCaretAnimation:_e(new m(21,"cursorSmoothCaretAnimation",!1,{description:E.localize(145,null)})),cursorStyle:_e(new u(22,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:E.localize(146,null)})),cursorSurroundingLines:_e(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:E.localize(147,null)})),cursorSurroundingLinesStyle:_e(new w(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[E.localize(148,null),E.localize(149,null)],description:E.localize(150,null)})),cursorWidth:_e(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:E.localize(151,null)})),disableLayerHinting:_e(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new m(28,"domReadOnly",!1)),dragAndDrop:_e(new m(29,"dragAndDrop",!0,{description:E.localize(152,null)})),emptySelectionClipboard:_e(new C),extraEditorClassName:_e(new _(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new d(32,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:E.localize(153,null)})),find:_e(new h),fixedOverflowWidgets:_e(new m(34,"fixedOverflowWidgets",!1)),folding:_e(new m(35,"folding",!0,{description:E.localize(154,null)})),foldingStrategy:_e(new w(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[E.localize(155,null),E.localize(156,null)],description:E.localize(157,null)})),foldingHighlight:_e(new m(37,"foldingHighlight",!0,{description:E.localize(158,null)})),unfoldOnClickAfterEndOfLine:_e(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:E.localize(159,null)})),fontFamily:_e(new _(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:E.localize(160,null)})),fontInfo:_e(new P),fontLigatures2:_e(new p),fontSize:_e(new F),fontWeight:_e(new z),formatOnPaste:_e(new m(44,"formatOnPaste",!1,{description:E.localize(161,null)})),formatOnType:_e(new m(45,"formatOnType",!1,{description:E.localize(162,null)})),glyphMargin:_e(new m(46,"glyphMargin",!0,{description:E.localize(163,null)})),gotoLocation:_e(new le),hideCursorInOverviewRuler:_e(new m(48,"hideCursorInOverviewRuler",!1,{description:E.localize(164,null)})),highlightActiveIndentGuide:_e(new m(49,"highlightActiveIndentGuide",!0,{description:E.localize(165,null)})),hover:_e(new H),inDiffEditor:_e(new m(51,"inDiffEditor",!1)),letterSpacing:_e(new d(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>d.clamp(V,-5,20),{description:E.localize(166,null)})),lightbulb:_e(new L),lineDecorationsWidth:_e(new k(54,"lineDecorationsWidth",10)),lineHeight:_e(new x),lineNumbers:_e(new Ue),lineNumbersMinChars:_e(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new m(58,"linkedEditing",!1,{description:E.localize(167,null)})),links:_e(new m(59,"links",!0,{description:E.localize(168,null)})),matchBrackets:_e(new w(60,"matchBrackets","always",["always","near","never"],{description:E.localize(169,null)})),minimap:_e(new Q),mouseStyle:_e(new w(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new d(63,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:E.localize(170,null)})),mouseWheelZoom:_e(new m(64,"mouseWheelZoom",!1,{markdownDescription:E.localize(171,null)})),multiCursorMergeOverlapping:_e(new m(65,"multiCursorMergeOverlapping",!0,{description:E.localize(172,null)})),multiCursorModifier:_e(new u(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$,{markdownEnumDescriptions:[E.localize(173,null),E.localize(174,null)],markdownDescription:E.localize(175,null)})),multiCursorPaste:_e(new w(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[E.localize(176,null),E.localize(177,null)],markdownDescription:E.localize(178,null)})),occurrencesHighlight:_e(new m(68,"occurrencesHighlight",!0,{description:E.localize(179,null)})),overviewRulerBorder:_e(new m(69,"overviewRulerBorder",!0,{description:E.localize(180,null)})),overviewRulerLanes:_e(new r(70,"overviewRulerLanes",3,0,3)),padding:_e(new Z),parameterHints:_e(new ie),peekWidgetDefaultFocus:_e(new w(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[E.localize(181,null),E.localize(182,null)],description:E.localize(183,null)})),definitionLinkOpensInPeek:_e(new m(74,"definitionLinkOpensInPeek",!1,{description:E.localize(184,null)})),quickSuggestions:_e(new ye),quickSuggestionsDelay:_e(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:E.localize(185,null)})),readOnly:_e(new m(77,"readOnly",!1)),renameOnType:_e(new m(78,"renameOnType",!1,{description:E.localize(186,null),markdownDeprecationMessage:E.localize(187,null)})),renderControlCharacters:_e(new m(79,"renderControlCharacters",!1,{description:E.localize(188,null)})),renderIndentGuides:_e(new m(80,"renderIndentGuides",!0,{description:E.localize(189,null)})),renderFinalNewline:_e(new m(81,"renderFinalNewline",!0,{description:E.localize(190,null)})),renderLineHighlight:_e(new w(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",E.localize(191,null)],description:E.localize(192,null)})),renderLineHighlightOnlyWhenFocus:_e(new m(83,"renderLineHighlightOnlyWhenFocus",!1,{description:E.localize(193,null)})),renderValidationDecorations:_e(new w(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new w(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",E.localize(194,null),E.localize(195,null),E.localize(196,null),""],description:E.localize(197,null)})),revealHorizontalRightPadding:_e(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new m(87,"roundedSelection",!0,{description:E.localize(198,null)})),rulers:_e(new ze),scrollbar:_e(new K),scrollBeyondLastColumn:_e(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:E.localize(199,null)})),scrollBeyondLastLine:_e(new m(91,"scrollBeyondLastLine",!0,{description:E.localize(200,null)})),scrollPredominantAxis:_e(new m(92,"scrollPredominantAxis",!0,{description:E.localize(201,null)})),selectionClipboard:_e(new m(93,"selectionClipboard",!0,{description:E.localize(202,null),included:S.isLinux})),selectionHighlight:_e(new m(94,"selectionHighlight",!0,{description:E.localize(203,null)})),selectOnLineNumbers:_e(new m(95,"selectOnLineNumbers",!0)),showFoldingControls:_e(new w(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[E.localize(204,null),E.localize(205,null)],description:E.localize(206,null)})),showUnused:_e(new m(97,"showUnused",!0,{description:E.localize(207,null)})),showDeprecated:_e(new m(121,"showDeprecated",!0,{description:E.localize(208,null)})),inlineHints:_e(new U),snippetSuggestions:_e(new w(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[E.localize(209,null),E.localize(210,null),E.localize(211,null),E.localize(212,null)],description:E.localize(213,null)})),smartSelect:_e(new oe),smoothScrolling:_e(new m(100,"smoothScrolling",!1,{description:E.localize(214,null)})),stopRenderingLineAfter:_e(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new ee),suggestFontSize:_e(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:E.localize(215,null)})),suggestLineHeight:_e(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:E.localize(216,null)})),suggestOnTriggerCharacters:_e(new m(106,"suggestOnTriggerCharacters",!0,{description:E.localize(217,null)})),suggestSelection:_e(new w(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[E.localize(218,null),E.localize(219,null),E.localize(220,null)],description:E.localize(221,null)})),tabCompletion:_e(new w(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[E.localize(222,null),E.localize(223,null),E.localize(224,null)],description:E.localize(225,null)})),tabIndex:_e(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new w(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[E.localize(226,null),E.localize(227,null),E.localize(228,null)],description:E.localize(229,null)})),useTabStops:_e(new m(111,"useTabStops",!0,{description:E.localize(230,null)})),wordSeparators:_e(new _(112,"wordSeparators",R.USUAL_WORD_SEPARATORS,{description:E.localize(231,null)})),wordWrap:_e(new w(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[E.localize(232,null),E.localize(233,null),E.localize(234,null),E.localize(235,null)],description:E.localize(236,null)})),wordWrapBreakAfterCharacters:_e(new _(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new _(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:E.localize(237,null)})),wordWrapOverride1:_e(new w(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new w(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new u(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Me,{enumDescriptions:[E.localize(238,null),E.localize(239,null),E.localize(240,null),E.localize(241,null)],description:E.localize(242,null)})),wrappingStrategy:_e(new w(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[E.localize(243,null),E.localize(244,null)],description:E.localize(245,null)})),editorClassName:_e(new v),pixelRatio:_e(new re),tabFocusMode:_e(new me),layoutInfo:_e(new G),wrappingInfo:_e(new ge)}}),define(be[122],we([17,18]),function(ae,e){return ae.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[123],we([17,18]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(be[124],we([17,18]),function(ae,e){return ae.create("vs/platform/markers/common/markers",e)}),define(be[125],we([17,18]),function(ae,e){return ae.create("vs/platform/theme/common/iconRegistry",e)}),define(be[126],we([17,18]),function(ae,e){return ae.create("vs/platform/workspaces/common/workspaces",e)}),define(be[127],we([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHost.api.impl",e)}),define(be[128],we([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[129],we([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(be[130],we([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[131],we([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostProgress",e)}),define(be[132],we([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[133],we([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[134],we([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[135],we([17,18]),function(ae,e){return ae.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[136],we([17,18]),function(ae,e){return ae.create("vs/workbench/common/views",e)}),define(be[137],we([17,18]),function(ae,e){return ae.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[138],we([17,18]),function(ae,e){return ae.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[139],we([17,18]),function(ae,e){return ae.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[140],we([17,18]),function(ae,e){return ae.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[141],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var E;(function(D){D[D.ACTIVATE=0]="ACTIVATE",D[D.RESTORE=1]="RESTORE",D[D.PRESERVE=2]="PRESERVE"})(E=e.EditorActivation||(e.EditorActivation={}));var S;(function(D){D[D.PICK=1]="PICK",D[D.DISABLED=2]="DISABLED"})(S=e.EditorOverride||(e.EditorOverride={}));var R;(function(D){D[D.API=0]="API",D[D.USER=1]="USER"})(R=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(D){D[D.Center=0]="Center",D[D.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",D[D.NearTop=2]="NearTop",D[D.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[86],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class E{constructor(A,D=[],I=!1){this.ctor=A,this.staticArguments=D,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=E;const S=(R,...A)=>new E(R,A);e.createSyncDescriptor=S}),define(be[61],we([0,1,86]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const S=[];function R(D,I,y){I instanceof E.SyncDescriptor||(I=new E.SyncDescriptor(I,[],y)),S.push([D,I])}e.registerSingleton=R;function A(){return S}e.getSingletonServiceDescriptors=A}),define(be[142],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=E;class S{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let D of this._nodes.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const I=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(D);I.outgoing.set(this._hashFn(D),y),y.incoming.set(this._hashFn(A),I)}removeNode(A){const D=this._hashFn(A);this._nodes.delete(D);for(let I of this._nodes.values())I.outgoing.delete(D),I.incoming.delete(D)}lookupOrInsertNode(A){const D=this._hashFn(A);let I=this._nodes.get(D);return I||(I=new E(A),this._nodes.set(D,I)),I}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[D,I]of this._nodes)A.push(`${D}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return A.join(`
`)}}e.Graph=S}),define(be[4],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function y(n){return n[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=y})(E=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function S(I,y,n,T){y[E.DI_TARGET]===y?y[E.DI_DEPENDENCIES].push({id:I,index:n,optional:T}):(y[E.DI_DEPENDENCIES]=[{id:I,index:n,optional:T}],y[E.DI_TARGET]=y)}function R(I){if(E.serviceIds.has(I))return E.serviceIds.get(I);const y=function(n,T,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");S(y,n,k,!1)};return y.toString=()=>I,E.serviceIds.set(I,y),y}e.createDecorator=R;function A(I){return I}e.refineServiceDecorator=A;function D(I){return function(y,n,T){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");S(I,y,T,!0)}}e.optional=D}),define(be[143],we([0,1,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,E.createDecorator)("modelService");function S(R){return!R.isTooLargeForSyncing()&&!R.isForSimpleWidget}e.shouldSynchronizeModel=S}),define(be[144],we([0,1,3,56,6,22,78,59,143]),function(ae,e,E,S,R,A,D,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(b){return typeof b=="string"?!1:Array.isArray(b)?b.every(n):!!b.exclusive}class T{constructor(){this._clock=0,this._entries=[],this._onDidChange=new E.Emitter}get onDidChange(){return this._onDidChange.event}register(m,r){let d={selector:m,provider:r,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,R.toDisposable)(()=>{if(d){let _=this._entries.indexOf(d);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const r=[];for(let d of this._entries)d._score>0&&r.push(d.provider);return r}ordered(m){const r=[];return this._orderedForEach(m,d=>r.push(d.provider)),r}orderedGroups(m){const r=[];let d,_;return this._orderedForEach(m,g=>{d&&_===g._score?d.push(g.provider):(_=g._score,d=[g.provider],r.push(d))}),r}_orderedForEach(m,r){if(!!m){this._updateScores(m);for(const d of this._entries)d._score>0&&r(d)}}_updateScores(m){let r={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let d of this._entries)if(d._score=(0,I.score)(d.selector,m.uri,m.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(m)),n(d.selector)&&d._score>0){for(let _ of this._entries)_._score=0;d._score=1e3;break}this._entries.sort(T._compareByScoreAndTime)}}static _compareByScoreAndTime(m,r){return m._score<r._score?1:m._score>r._score?-1:m._time<r._time?1:m._time>r._time?-1:0}}e.LanguageFeatureRegistry=T;class k{constructor(m,r,d=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=r,this.max=d,this._cache=new A.LRUCache(50,.7)}_key(m){return m.id+(0,S.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const r=this._key(m),d=this._cache.get(r);return this._clamp(d==null?void 0:d.value)}update(m,r){const d=this._key(m);let _=this._cache.get(d);return _||(_=new D.MovingAverage,this._cache.set(d,_)),_.update(r),this.get(m)}}e.LanguageFeatureRequestDelays=k}),define(be[62],we([0,1,2,33,144,117,37]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class y{constructor(p,P){this.language=p,this.id=P}}e.LanguageIdentifier=y;var n;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var T;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var k;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var b;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(b=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(p){return(p&255)>>>0}static getTokenType(p){return(p&1792)>>>8}static getFontStyle(p){return(p&14336)>>>11}static getForeground(p){return(p&8372224)>>>14}static getBackground(p){return(p&4286578688)>>>23}static getClassNameFromMetadata(p){let P=this.getForeground(p),F="mtk"+P,z=this.getFontStyle(p);return z&1&&(F+=" mtki"),z&2&&(F+=" mtkb"),z&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(p,P){const F=this.getForeground(p),z=this.getFontStyle(p);let le=`color: ${P[F]};`;return z&1&&(le+="font-style: italic;"),z&2&&(le+="font-weight: bold;"),z&4&&(le+="text-decoration: underline;"),le}}e.TokenMetadata=m;var r;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(p){const P=h[p];let F=P&&D.iconRegistry.get(P);return F||(console.info("No codicon found for CompletionItemKind "+p),F=D.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(p,P){let F=h[p];return typeof F=="undefined"&&!P&&(F=9),F}}();var d;(function(h){h[h.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var g;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function s(h){return h&&E.URI.isUri(h.uri)&&S.Range.isIRange(h.range)&&(S.Range.isIRange(h.originSelectionRange)||S.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=s;var t;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(h){h[h.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var l;(function(h){const p=new Map;p.set("file",0),p.set("module",1),p.set("namespace",2),p.set("package",3),p.set("class",4),p.set("method",5),p.set("property",6),p.set("field",7),p.set("constructor",8),p.set("enum",9),p.set("interface",10),p.set("function",11),p.set("variable",12),p.set("constant",13),p.set("string",14),p.set("number",15),p.set("boolean",16),p.set("array",17),p.set("object",18),p.set("key",19),p.set("null",20),p.set("enum-member",21),p.set("struct",22),p.set("event",23),p.set("operator",24),p.set("type-parameter",25);const P=new Map;P.set(0,"file"),P.set(1,"module"),P.set(2,"namespace"),P.set(3,"package"),P.set(4,"class"),P.set(5,"method"),P.set(6,"property"),P.set(7,"field"),P.set(8,"constructor"),P.set(9,"enum"),P.set(10,"interface"),P.set(11,"function"),P.set(12,"variable"),P.set(13,"constant"),P.set(14,"string"),P.set(15,"number"),P.set(16,"boolean"),P.set(17,"array"),P.set(18,"object"),P.set(19,"key"),P.set(20,"null"),P.set(21,"enum-member"),P.set(22,"struct"),P.set(23,"event"),P.set(24,"operator"),P.set(25,"type-parameter");function F(H){return p.get(H)}h.fromString=F;function z(H){return P.get(H)}h.toString=z;function le(H,W){const G=P.get(H);let L=G&&D.iconRegistry.get("symbol-"+G);return L||(console.info("No codicon found for SymbolKind "+H),L=D.Codicon.symbolProperty),`${W?"inline":"block"} ${L.classNames}`}h.toCssClassName=le})(l=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(p){this.value=p}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var a;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var v;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(v=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new R.LanguageFeatureRegistry,e.RenameProviderRegistry=new R.LanguageFeatureRegistry,e.CompletionProviderRegistry=new R.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new R.LanguageFeatureRegistry,e.HoverProviderRegistry=new R.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new R.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new R.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new R.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new R.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new R.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new R.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new R.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new R.LanguageFeatureRegistry,e.LinkProviderRegistry=new R.LanguageFeatureRegistry,e.ColorProviderRegistry=new R.LanguageFeatureRegistry,e.SelectionRangeRegistry=new R.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new R.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var C;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(C=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[145],we([0,1,6,12,4,3,45,54]),function(ae,e,E,S,R,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,R.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new A.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,n){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:y,handler:n})}if(y.description){const r=[];for(let _ of y.description.args)r.push(_.constraint);const d=y.handler;y.handler=function(_,...g){return(0,S.validateConstraints)(g,r),d(_,...g)}}const{id:T}=y;let k=this._commands.get(T);k||(k=new D.LinkedList,this._commands.set(T,k));let b=k.unshift(y),m=(0,E.toDisposable)(()=>{b();const r=this._commands.get(T);(r==null?void 0:r.isEmpty())&&this._commands.delete(T)});return this._onDidRegisterCommand.fire(T),m}registerCommandAlias(y,n){return e.CommandsRegistry.registerCommand(y,(T,...k)=>T.get(e.ICommandService).executeCommand(n,...k))}getCommand(y){const n=this._commands.get(y);if(!(!n||n.isEmpty()))return I.Iterable.first(n)}getCommands(){const y=new Map;for(const n of this._commands.keys()){const T=this.getCommand(n);T&&y.set(n,T)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>E.Disposable.None,onDidExecuteCommand:()=>E.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(be[63],we([0,1,8,4,21]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=R.userAgent||"";const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",R.isMacintosh),D.set("isLinux",R.isLinux),D.set("isWindows",R.isWindows),D.set("isWeb",R.isWeb),D.set("isMacNative",R.isMacintosh&&!R.isWeb),D.set("isEdge",A.indexOf("Edg/")>=0),D.set("isFirefox",A.indexOf("Firefox")>=0),D.set("isChrome",A.indexOf("Chrome")>=0),D.set("isSafari",A.indexOf("Safari")>=0),D.set("isIPad",A.indexOf("iPad")>=0);const I=Object.prototype.hasOwnProperty;var y;(function(h){h[h.False=0]="False",h[h.True=1]="True",h[h.Defined=2]="Defined",h[h.Not=3]="Not",h[h.Equals=4]="Equals",h[h.NotEquals=5]="NotEquals",h[h.And=6]="And",h[h.Regex=7]="Regex",h[h.NotRegex=8]="NotRegex",h[h.Or=9]="Or",h[h.In=10]="In",h[h.NotIn=11]="NotIn",h[h.Greater=12]="Greater",h[h.GreaterEquals=13]="GreaterEquals",h[h.Smaller=14]="Smaller",h[h.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return k.INSTANCE}static true(){return b.INSTANCE}static has(p){return m.create(p)}static equals(p,P){return r.create(p,P)}static notEquals(p,P){return g.create(p,P)}static regex(p,P){return i.create(p,P)}static in(p,P){return d.create(p,P)}static not(p){return w.create(p)}static and(...p){return o.create(p)}static or(...p){return a.create(p)}static greater(p,P){return u.create(p,P)}static less(p,P){return s.create(p,P)}static deserialize(p,P=!1){if(!!p)return this._deserializeOrExpression(p,P)}static _deserializeOrExpression(p,P){let F=p.split("||");return a.create(F.map(z=>this._deserializeAndExpression(z,P)))}static _deserializeAndExpression(p,P){let F=p.split("&&");return o.create(F.map(z=>this._deserializeOne(z,P)))}static _deserializeOne(p,P){if(p=p.trim(),p.indexOf("!=")>=0){let F=p.split("!=");return g.create(F[0].trim(),this._deserializeValue(F[1],P))}if(p.indexOf("==")>=0){let F=p.split("==");return r.create(F[0].trim(),this._deserializeValue(F[1],P))}if(p.indexOf("=~")>=0){let F=p.split("=~");return i.create(F[0].trim(),this._deserializeRegexValue(F[1],P))}if(p.indexOf(" in ")>=0){let F=p.split(" in ");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const F=p.split(">=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const F=p.split(">");return u.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const F=p.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const F=p.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(p)?w.create(p.substr(1).trim()):m.create(p)}static _deserializeValue(p,P){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let F=/^'([^']*)'$/.exec(p);return F?F[1].trim():p}static _deserializeRegexValue(p,P){if((0,E.isFalsyOrWhitespace)(p)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=p.indexOf("/"),z=p.lastIndexOf("/");if(F===z||F<0){if(P)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let le=p.slice(F+1,z),H=p[z+1]==="i"?"i":"";try{return new RegExp(le,H)}catch(W){if(P)throw new Error(`bad regexp-value '${p}', parse error: ${W}`);return console.warn(`bad regexp-value '${p}', parse error: ${W}`),null}}}e.ContextKeyExpr=n;function T(h,p){return h.cmp(p)}class k{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class b{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class m{constructor(p){this.key=p,this.type=2}static create(p){const P=D.get(p);return typeof P=="boolean"?P?b.INSTANCE:k.INSTANCE:new m(p)}cmp(p){return p.type!==this.type?this.type-p.type:v(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return w.create(this.key)}}e.ContextKeyDefinedExpr=m;class r{constructor(p,P){this.key=p,this.value=P,this.type=4}static create(p,P){if(typeof P=="boolean")return P?m.create(p):w.create(p);const F=D.get(p);return typeof F=="boolean"?P===(F?"true":"false")?b.INSTANCE:k.INSTANCE:new r(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:C(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class d{constructor(p,P){this.key=p,this.valueKey=P,this.type=10}static create(p,P){return new d(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:C(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}evaluate(p){const P=p.getValue(this.valueKey),F=p.getValue(this.key);return Array.isArray(P)?P.indexOf(F)>=0:typeof F=="string"&&typeof P=="object"&&P!==null?I.call(P,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=d;class _{constructor(p){this._actual=p,this.type=11}static create(p){return new _(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new _(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class g{constructor(p,P){this.key=p,this.value=P,this.type=5}static create(p,P){if(typeof P=="boolean")return P?w.create(p):m.create(p);const F=D.get(p);return typeof F=="boolean"?P===(F?"true":"false")?k.INSTANCE:b.INSTANCE:new g(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:C(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=g;class w{constructor(p){this.key=p,this.type=3}static create(p){const P=D.get(p);return typeof P=="boolean"?P?k.INSTANCE:b.INSTANCE:new w(p)}cmp(p){return p.type!==this.type?this.type-p.type:v(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=w;class u{constructor(p,P){this.key=p,this.value=P,this.type=12}static create(p,P){return new u(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:C(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class c{constructor(p,P){this.key=p,this.value=P,this.type=13}static create(p,P){return new c(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:C(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class s{constructor(p,P){this.key=p,this.value=P,this.type=14}static create(p,P){return new s(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:C(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=s;class t{constructor(p,P){this.key=p,this.value=P,this.type=15}static create(p,P){return new t(p,P)}cmp(p){return p.type!==this.type?this.type-p.type:C(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(p,P){this.key=p,this.regexp=P,this.type=7}static create(p,P){return new i(p,P)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const P=this.regexp?this.regexp.source:"",F=p.regexp?p.regexp.source:"";return P<F?-1:P>F?1:0}equals(p){if(p.type===this.type){const P=this.regexp?this.regexp.source:"",F=p.regexp?p.regexp.source:"";return this.key===p.key&&P===F}return!1}evaluate(p){let P=p.getValue(this.key);return this.regexp?this.regexp.test(P):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return l.create(this)}}e.ContextKeyRegexExpr=i;class l{constructor(p){this._actual=p,this.type=8}static create(p){return new l(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new l(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;class o{constructor(p){this.expr=p,this.type=6}static create(p){return o._normalizeArr(p)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const z=T(this.expr[P],p.expr[P]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(p.expr[P]))return!1;return!0}return!1}evaluate(p){for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].evaluate(p))return!1;return!0}static _normalizeArr(p){const P=[];let F=!1;for(const z of p)if(!!z){if(z.type===1){F=!0;continue}if(z.type===0)return k.INSTANCE;if(z.type===6){P.push(...z.expr);continue}P.push(z)}if(P.length===0&&F)return b.INSTANCE;if(P.length!==0){if(P.length===1)return P[0];for(P.sort(T);P.length>1;){const z=P[P.length-1];if(z.type!==9)break;P.pop();const le=P.pop(),H=a.create(z.expr.map(W=>o.create([W,le])));H&&(P.push(H),P.sort(T))}return P.length===1?P[0]:new o(P)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let P of this.expr)p.push(...P.keys());return p}map(p){return new o(this.expr.map(P=>P.map(p)))}negate(){let p=[];for(let P of this.expr)p.push(P.negate());return a.create(p)}}e.ContextKeyAndExpr=o;class a{constructor(p){this.expr=p,this.type=9}static create(p){const P=a._normalizeArr(p);if(P.length!==0)return P.length===1?P[0]:new a(P)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const z=T(this.expr[P],p.expr[P]);if(z!==0)return z}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(p.expr[P]))return!1;return!0}return!1}evaluate(p){for(let P=0,F=this.expr.length;P<F;P++)if(this.expr[P].evaluate(p))return!0;return!1}static _normalizeArr(p){let P=[],F=!1;if(p){for(let z=0,le=p.length;z<le;z++){const H=p[z];if(!!H){if(H.type===0){F=!0;continue}if(H.type===1)return[b.INSTANCE];if(H.type===9){P=P.concat(H.expr);continue}P.push(H)}}if(P.length===0&&F)return[k.INSTANCE];P.sort(T)}return P}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let P of this.expr)p.push(...P.keys());return p}map(p){return new a(this.expr.map(P=>P.map(p)))}negate(){let p=[];for(let F of this.expr)p.push(F.negate());const P=F=>F.type===9?F.expr:[F];for(;p.length>1;){const F=p.shift(),z=p.shift(),le=[];for(const H of P(F))for(const W of P(z))le.push(n.and(H,W));p.unshift(n.or(...le))}return p[0]}}e.ContextKeyOrExpr=a;class f extends m{constructor(p,P,F){super(p);this.key=p,this._defaultValue=P,typeof F=="object"?f._info.push(Object.assign(Object.assign({},F),{key:p})):F!==!0&&f._info.push({key:p,description:F,type:P!=null?typeof P:void 0})}static all(){return f._info.values()}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(p){return n.equals(this.key,p)}notEqualsTo(p){return n.notEquals(this.key,p)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(h,p){return h<p?-1:h>p?1:0}function C(h,p,P,F){return h<P?-1:h>P?1:p<F?-1:p>F?1:0}}),define(be[146],we([0,1,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(be[25],we([0,1,8,4]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function R(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class D{constructor(T){this.value=T,this._lower=T.toLowerCase()}static equals(T,k){if(typeof T=="undefined"||T===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof T=="string"||typeof k=="string"){let b=typeof T=="string"?T:T.value,m=typeof k=="string"?k:k.value;return E.equalsIgnoreCase(b,m)}return T._lower===k._lower}static toKey(T){return typeof T=="string"?T.toLowerCase():T._lower}}e.ExtensionIdentifier=D;function I(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function y(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,S.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[147],we([0,1,8,25]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(m,r){return m.uuid&&r.uuid?m.uuid===r.uuid:m.id===r.id?!0:(0,E.compareIgnoreCase)(m.id,r.id)===0}e.areSameExtensions=R;class A{constructor(r,d){this.version=d,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof A?R(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=A;function D(m,r){return`${m}.${r}`}e.getExtensionId=D;function I(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function y(m,r){return I(D(m,r))}e.getGalleryExtensionId=y;function n(m,r){const d=[],_=g=>{for(const w of d)if(w.some(u=>R(r(u),r(g))))return w;return null};for(const g of m){const w=_(g);w?w.push(g):d.push([g])}return d}e.groupByExtension=n;function T(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=T;function k(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function b(m){const r=new Set;for(const d of m)d.malicious&&r.add(d.id.id);return r}e.getMaliciousExtensionsSet=b}),define(be[64],we([0,1,123,11,2,4,8,12,22]),function(ae,e,E,S,R,A,D,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,A.createDecorator)("fileService");function n(H){return H.create===!0}e.isFileOpenForWriteOptions=n;var T;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(T=e.FileType||(e.FileType={}));var k;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=b;function m(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=m;function r(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function d(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=d;var _;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(_=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(W,G){super(W);this.code=G}}e.FileSystemProviderError=g;function w(H,W){const G=new g(H.toString(),W);return c(G,W),G}e.createFileSystemProviderError=w;function u(H){return H||w((0,E.localize)(0,null),_.Unknown)}e.ensureFileSystemProviderError=u;function c(H,W){return H.name=W?`${W} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=c;function s(H){if(!H)return _.Unknown;if(H instanceof g)return H.code;const W=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!W)return _.Unknown;switch(W[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileExceedsMemoryLimit:return _.FileExceedsMemoryLimit;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}e.toFileSystemProviderErrorCode=s;function t(H){if(H instanceof v)return H.fileOperationResult;switch(s(H)){case _.FileNotFound:return 1;case _.FileIsADirectory:return 0;case _.FileNotADirectory:return 10;case _.FileWriteLocked:return 5;case _.NoPermissions:return 6;case _.FileExists:return 4;case _.FileExceedsMemoryLimit:return 9;case _.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class l{constructor(W,G,L){this.resource=W,this.operation=G,this.target=L}isOperation(W){return this.operation===W}}e.FileOperationEvent=l;var o;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class a{constructor(W,G){this.ignorePathCasing=G,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=W;for(const L of W)switch(L.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(L.resource,L);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(L.resource,L);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(L.resource,L);break}}contains(W,...G){return this.doContains(W,{includeChildren:!1},...G)}affects(W,...G){return this.doContains(W,{includeChildren:!0},...G)}doContains(W,G,...L){var U,x,Q,$,Z,ie;if(!W)return!1;const re=L.length>0;return!!((!re||L.includes(1))&&(((U=this.added)===null||U===void 0?void 0:U.get(W))||G.includeChildren&&((x=this.added)===null||x===void 0?void 0:x.findSuperstr(W)))||(!re||L.includes(0))&&(((Q=this.updated)===null||Q===void 0?void 0:Q.get(W))||G.includeChildren&&(($=this.updated)===null||$===void 0?void 0:$.findSuperstr(W)))||(!re||L.includes(2))&&(((Z=this.deleted)===null||Z===void 0?void 0:Z.findSubstr(W))||G.includeChildren&&((ie=this.deleted)===null||ie===void 0?void 0:ie.findSuperstr(W))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(W){const G=[],L=W===1?this.added:W===0?this.updated:this.deleted;if(L)for(const[,U]of L)G.push(U);return G}filter(W){return new a(this.changes.filter(G=>W(G)),this.ignorePathCasing)}}e.FileChangesEvent=a;function f(H,W,G){return!H||!W||H===W||W.length>H.length?!1:(W.charAt(W.length-1)!==S.sep&&(W+=S.sep),G?(0,D.startsWithIgnoreCase)(H,W):H.indexOf(W)===0)}e.isParent=f;class v extends Error{constructor(W,G,L){super(W);this.fileOperationResult=G,this.options=L}static isFileOperationError(W){return W instanceof Error&&!(0,I.isUndefinedOrNull)(W.fileOperationResult)}}e.FileOperationError=v;var C;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(C=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var h;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(h=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function p(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=p;async function P(H,W){if(!W.canHandleResource(R.URI.from({scheme:H.scheme})))return new Promise(G=>{const L=W.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===H.scheme&&U.added&&(L.dispose(),G())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(W){return(0,I.isNumber)(W)||(W=0),W<F.KB?(0,E.localize)(1,null,W.toFixed(0)):W<F.MB?(0,E.localize)(2,null,(W/F.KB).toFixed(2)):W<F.GB?(0,E.localize)(3,null,(W/F.MB).toFixed(2)):W<F.TB?(0,E.localize)(4,null,(W/F.GB).toFixed(2)):(0,E.localize)(5,null,(W/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var z;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function le(H){return{maxFileSize:H===0?300*F.MB:16*F.GB,maxHeapSize:H===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=le}),define(be[65],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...R){this._entries=new Map;for(let[A,D]of R)this.set(A,D)}set(R,A){const D=this._entries.get(R);return this._entries.set(R,A),D}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=E}),define(be[148],we([0,1,10,142,86,4,65,13]),function(ae,e,E,S,R,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class n extends Error{constructor(r){super("cyclic dependency between services");this.message=r.toString()}}class T{constructor(r=new D.ServiceCollection,d=!1,_){this._activeInstantiations=new Set,this._services=r,this._strict=d,this._parent=_,this._services.set(A.IInstantiationService,this)}createChild(r){return new T(r,this._strict,this)}invokeFunction(r,...d){let _=b.traceInvocation(r),g=!1;try{return r({get:(u,c)=>{if(g)throw(0,E.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(u,_);if(!s&&c!==A.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return s}},...d)}finally{g=!0,_.stop()}}createInstance(r,...d){let _,g;return r instanceof R.SyncDescriptor?(_=b.traceCreation(r.ctor),g=this._createInstance(r.ctor,r.staticArguments.concat(d),_)):(_=b.traceCreation(r),g=this._createInstance(r,d,_)),_.stop(),g}_createInstance(r,d=[],_){let g=A._util.getServiceDependencies(r).sort((c,s)=>c.index-s.index),w=[];for(const c of g){let s=this._getOrCreateServiceInstance(c.id,_);if(!s&&this._strict&&!c.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${c.id}.`);w.push(s)}let u=g.length>0?g[0].index:d.length;if(d.length!==u){console.warn(`[createInstance] First service dependency of ${r.name} at position ${u+1} conflicts with ${d.length} static arguments`);let c=u-d.length;c>0?d=d.concat(new Array(c)):d=d.slice(0,u)}return new r(...[...d,...w])}_setServiceInstance(r,d){if(this._services.get(r)instanceof R.SyncDescriptor)this._services.set(r,d);else if(this._parent)this._parent._setServiceInstance(r,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let d=this._services.get(r);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):d}_getOrCreateServiceInstance(r,d){let _=this._getServiceInstanceOrDescriptor(r);return _ instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,_,d.branch(r,!0)):(d.branch(r,!1),_)}_safeCreateAndCacheServiceInstance(r,d,_){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,d,_)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,d,_){const g=new S.Graph(c=>c.id.toString());let w=0;const u=[{id:r,desc:d,_trace:_}];for(;u.length;){const c=u.pop();if(g.lookupOrInsertNode(c),w++>1e3)throw new n(g);for(let s of A._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${r} depends on ${s.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const i={id:s.id,desc:t,_trace:c._trace.branch(s.id,!0)};g.insertEdge(c,i),u.push(i)}}}for(;;){const c=g.roots();if(c.length===0){if(!g.isEmpty())throw new n(g);break}for(const{data:s}of c){if(this._getServiceInstanceOrDescriptor(s.id)instanceof R.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}g.removeNode(s)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,d,_=[],g,w){if(this._services.get(r)instanceof R.SyncDescriptor)return this._createServiceInstance(d,_,g,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,d,_,g,w);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(r,d=[],_,g){if(_){const w=new I.IdleValue(()=>this._createInstance(r,d,g));return new Proxy(Object.create(null),{get(u,c){if(c in u)return u[c];let s=w.value,t=s[c];return typeof t!="function"||(t=t.bind(s),u[c]=t),t},set(u,c,s){return w.value[c]=s,!0}})}else return this._createInstance(r,d,g)}}e.InstantiationService=T;var k;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(k||(k={}));class b{constructor(r,d){this.type=r,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return y?new b(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(r){return y?new b(0,r.name):b._None}branch(r,d){let _=new b(2,r.toString());return this._dep.push([r,d,_]),_}stop(){let r=Date.now()-this._start;b._totals+=r;let d=!1;function _(w,u){let c=[],s=new Array(w+1).join("	");for(const[t,i,l]of u._dep)if(i&&l){d=!0,c.push(`${s}CREATES -> ${t}`);let o=_(w+1,l);o&&c.push(o)}else c.push(`${s}uses -> ${t}`);return c.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(r>2||d)&&console.log(g.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(be[19],we([0,1,4,6,21,3,60]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function I(){return new Date().toISOString()}var y;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class n extends S.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class T extends n{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...t){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([s,...t]))}debug(s,...t){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([s,...t]))}info(s,...t){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([s,...t]))}warn(s,...t){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([s,...t]))}error(s,...t){if(this.checkLogLevel(y.Error))if(s instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=s.stack,this.log(y.Error,this.format(i))}else this.log(y.Error,this.format([s,...t]))}critical(s,...t){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([s,...t]))}flush(){}format(s){let t="";for(let i=0;i<s.length;i++){let l=s[i];if(typeof l=="object")try{l=JSON.stringify(l)}catch(o){}t+=(i>0?" ":"")+l}return t}}e.AbstractMessageLogger=T;class k extends n{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!R.isWindows}trace(s,...t){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,s,...t):console.log(`[main ${I()}]`,s,...t))}debug(s,...t){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,s,...t):console.log(`[main ${I()}]`,s,...t))}info(s,...t){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,s,...t):console.log(`[main ${I()}]`,s,...t))}warn(s,...t){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,s,...t):console.warn(`[main ${I()}]`,s,...t))}error(s,...t){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,s,...t):console.error(`[main ${I()}]`,s,...t))}critical(s,...t){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,s,...t):console.error(`[main ${I()}]`,s,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class b extends n{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...t){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",s,...t)}debug(s,...t){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...t)}info(s,...t){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",s,...t)}warn(s,...t){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",s,...t)}error(s,...t){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",s,...t)}critical(s,...t){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...t)}dispose(){}flush(){}}e.ConsoleLogger=b;class m extends n{constructor(s,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(t)}trace(s,...t){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(s),...t])}debug(s,...t){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(s),...t])}info(s,...t){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(s),...t])}warn(s,...t){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(s),...t])}error(s,...t){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(s),...t])}critical(s,...t){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(s),...t])}extractMessage(s){return typeof s=="string"?s:(0,D.toErrorMessage)(s,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class r extends n{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const t of this.logServices)t.setLevel(s);super.setLevel(s)}trace(s,...t){for(const i of this.logServices)i.trace(s,...t)}debug(s,...t){for(const i of this.logServices)i.debug(s,...t)}info(s,...t){for(const i of this.logServices)i.info(s,...t)}warn(s,...t){for(const i of this.logServices)i.warn(s,...t)}error(s,...t){for(const i of this.logServices)i.error(s,...t)}critical(s,...t){for(const i of this.logServices)i.critical(s,...t)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=r;class d extends S.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...t){this.logger.trace(s,...t)}debug(s,...t){this.logger.debug(s,...t)}info(s,...t){this.logger.info(s,...t)}warn(s,...t){this.logger.warn(s,...t)}error(s,...t){this.logger.error(s,...t)}critical(s,...t){this.logger.critical(s,...t)}flush(){this.logger.flush()}}e.LogService=d;class _{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(s){}getLevel(){return y.Info}trace(s,...t){}debug(s,...t){}info(s,...t){}warn(s,...t){}error(s,...t){}critical(s,...t){}dispose(){}flush(){}}e.NullLogService=_;function g(c){if(c.verbose)return y.Trace;if(typeof c.logLevel=="string"){const s=w(c.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function w(c){switch(c){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=w;function u(c){switch(c){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=u}),define(be[87],we([0,1,4,124,46]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function n(r,d){return d-r}y.compare=n;const T=Object.create(null);T[y.Error]=(0,S.localize)(0,null),T[y.Warning]=(0,S.localize)(1,null),T[y.Info]=(0,S.localize)(2,null);function k(r){return T[r]||""}y.toString=k;function b(r){switch(r){case R.default.Error:return y.Error;case R.default.Warning:return y.Warning;case R.default.Info:return y.Info;case R.default.Ignore:return y.Hint}}y.fromSeverity=b;function m(r){switch(r){case y.Error:return R.default.Error;case y.Warning:return R.default.Warning;case y.Info:return R.default.Info;case y.Hint:return R.default.Ignore}}y.toSeverity=m}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(y){const n="";function T(b){return k(b,!0)}y.makeKey=T;function k(b,m){let r=[n];return b.source?r.push(b.source.replace("\xA6","\\\xA6")):r.push(n),b.code?typeof b.code=="string"?r.push(b.code.replace("\xA6","\\\xA6")):r.push(b.code.value.replace("\xA6","\\\xA6")):r.push(n),b.severity!==void 0&&b.severity!==null?r.push(D.toString(b.severity)):r.push(n),b.message&&m?r.push(b.message.replace("\xA6","\\\xA6")):r.push(n),b.startLineNumber!==void 0&&b.startLineNumber!==null?r.push(b.startLineNumber.toString()):r.push(n),b.startColumn!==void 0&&b.startColumn!==null?r.push(b.startColumn.toString()):r.push(n),b.endLineNumber!==void 0&&b.endLineNumber!==null?r.push(b.endLineNumber.toString()):r.push(n),b.endColumn!==void 0&&b.endColumn!==null?r.push(b.endColumn.toString()):r.push(n),r.push(n),r.join("\xA6")}y.makeKeyOptionalMessage=k})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(be[149],we([0,1,46,4,3]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=E.default,e.INotificationService=(0,S.createDecorator)("notificationService");var A;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new y,this.onDidClose=R.Event.None,this.onDidChangeVisibility=R.Event.None}updateSeverity(T){}updateMessage(T){}updateActions(T){}close(){}}e.NoOpNotification=I;class y{infinite(){}done(){}total(T){}worked(T){}}e.NoOpProgress=y});var je=this&&this.__decorate||function(ae,e,E,S){var R=arguments.length,A=R<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,E):S,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ae,e,E,S);else for(var I=ae.length-1;I>=0;I--)(D=ae[I])&&(A=(R<3?D(A):R>3?D(e,E,A):D(e,E))||A);return R>3&&A&&Object.defineProperty(e,E,A),A},Ke=this&&this.__param||function(ae,e){return function(E,S){e(E,S,ae)}};define(be[150],we([0,1,4,20,6,13]),function(ae,e,E,S,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,E.createDecorator)("progressService");var D;(function(T){T[T.Explorer=1]="Explorer",T[T.Scm=3]="Scm",T[T.Extensions=5]="Extensions",T[T.Window=10]="Window",T[T.Notification=15]="Notification",T[T.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let y=class extends R.Disposable{constructor(k,b){super();this.deferred=new A.DeferredPromise,b.withProgress(k,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,R.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};y=je([Ke(1,e.IProgressService)],y),e.UnmanagedProgress=y;class n extends R.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new R.DisposableStore)}start(k){this.stop();const b=++this.currentOperationId,m=new S.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{b===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,R.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,R.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,R.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:b,token:m.token,stop:()=>this.doStop(b),isCurrent:()=>this.currentOperationId===b}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,E.createDecorator)("editorProgressService")}),define(be[30],we([0,1,12,43]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(D,I){S.ok(E.isString(D)),S.ok(E.isObject(I)),S.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,I)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new R}),define(be[88],we([0,1,30,3]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,n){this.schemasById[R(y)]=n,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new A;E.Registry.add(e.Extensions.JSONContribution,D)}),define(be[66],we([0,1,122,3,30,12,88]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=R.Registry.as(D.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new S.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new S.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(g,w=!0){this.registerConfigurations([g],w)}registerConfigurations(g,w=!0){const u=[];g.forEach(c=>{u.push(...this.validateAndRegisterProperties(c,w)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(g){const w=[],u=c=>{if(c.properties)for(const s in c.properties)w.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,c.properties[s]);c.allOf&&c.allOf.forEach(s=>u(s))};for(const c of g){u(c);const s=this.configurationContributors.indexOf(c);s!==-1&&this.configurationContributors.splice(s,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}registerDefaultConfigurations(g){const w=[],u=[];for(const c of g)for(const s in c)if(w.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),c[s]);const t={type:"object",default:this.defaultValues[s],description:E.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};u.push(k(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=c[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}deregisterDefaultConfigurations(g){const w=[];for(const u of g)for(const c in u)if(w.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const s=this.configurationProperties[c];s&&(this.updatePropertyDefaultValue(c,s),this.updateSchema(c,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const w of g)this.overrideIdentifiers.add(w);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(g,w=!0,u=3){u=A.isUndefinedOrNull(g.scope)?u:g.scope;let c=[],s=g.properties;if(s)for(let i in s){if(w&&r(i)){delete s[i];continue}const l=s[i];if(this.updatePropertyDefaultValue(i,l),e.OVERRIDE_PROPERTY_PATTERN.test(i)?l.scope=void 0:l.scope=A.isUndefinedOrNull(l.scope)?u:l.scope,s[i].hasOwnProperty("included")&&!s[i].included){this.excludedConfigurationProperties[i]=s[i],delete s[i];continue}else this.configurationProperties[i]=s[i];!s[i].deprecationMessage&&s[i].markdownDeprecationMessage&&(s[i].deprecationMessage=s[i].markdownDeprecationMessage),c.push(i)}let t=g.allOf;if(t)for(let i of t)c.push(...this.validateAndRegisterProperties(i,w,u));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(g){const w=u=>{let c=u.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let s=u.allOf;s&&s.forEach(w)};w(g)}updateSchema(g,w){switch(e.allSettings.properties[g]=w,w.scope){case 1:e.applicationSettings.properties[g]=w;break;case 2:e.machineSettings.properties[g]=w;break;case 6:e.machineOverridableSettings.properties[g]=w;break;case 3:e.windowSettings.properties[g]=w;break;case 4:e.resourceSettings.properties[g]=w;break;case 5:e.resourceSettings.properties[g]=w,this.resourceLanguageSettingsSchema.properties[g]=w;break}}removeFromSchema(g,w){switch(delete e.allSettings.properties[g],w.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const w=`[${g}]`,u={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(w,u),e.allSettings.properties[w]=u,e.applicationSettings.properties[w]=u,e.machineSettings.properties[w]=u,e.machineOverridableSettings.properties[w]=u,e.windowSettings.properties[w]=u,e.resourceSettings.properties[w]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,w){let u=this.defaultValues[g];A.isUndefined(u)&&(u=w.default),A.isUndefined(u)&&(u=b(w.type)),w.default=u}}const T="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(T);function k(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=k;function b(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const m=new n;R.Registry.add(e.Extensions.Configuration,m);function r(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?E.localize(5,null,_):m.getConfigurationProperties()[_]!==void 0?E.localize(6,null,_):null:E.localize(4,null)}e.validateProperty=r;function d(){const _=[],g=m.getConfigurationProperties();for(const w of Object.keys(g))_.push([w,g[w].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=d}),define(be[89],we([0,1,23,12,2,30,4,66]),function(ae,e,E,S,R,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function y(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof R.URI)}e.isConfigurationOverrides=y;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function T(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=T;function k(i,l){const o=l?i?l.keys.filter(P=>i.keys.indexOf(P)===-1):[...l.keys]:[],a=i?l?i.keys.filter(P=>l.keys.indexOf(P)===-1):[...i.keys]:[],f=[];if(l&&i){for(const P of i.keys)if(l.keys.indexOf(P)!==-1){const F=g(i.contents,P),z=g(l.contents,P);E.equals(F,z)||f.push(P)}}const v=[],C=P=>{const F={};for(const z of P)for(const le of z.identifiers)F[s(le)]=z;return F},h=l?C(l.overrides):{},p=i?C(i.overrides):{};if(Object.keys(h).length)for(const P of o){const F=h[P];F&&v.push([(0,I.overrideIdentifierFromKey)(P),F.keys])}if(Object.keys(p).length)for(const P of a){const F=p[P];F&&v.push([(0,I.overrideIdentifierFromKey)(P),F.keys])}if(Object.keys(h).length&&Object.keys(p).length)for(const P of f){const F=p[P],z=h[P];if(F&&z){const le=k({contents:F.contents,keys:F.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});v.push([(0,I.overrideIdentifierFromKey)(P),[...le.added,...le.removed,...le.updated]])}}return{added:o,removed:a,updated:f,overrides:v}}e.compare=k;function b(i,l){const o=[];for(const a of Object.keys(i))if(I.OVERRIDE_PROPERTY_PATTERN.test(a)){const f={};for(const v in i[a])f[v]=i[a][v];o.push({identifiers:[(0,I.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(f),contents:m(f,l)})}return o}e.toOverrides=b;function m(i,l){const o=Object.create(null);for(let a in i)r(o,a,i[a],l);return o}e.toValuesTree=m;function r(i,l,o,a){const f=l.split("."),v=f.pop();let C=i;for(let h=0;h<f.length;h++){let p=f[h],P=C[p];switch(typeof P){case"undefined":P=C[p]=Object.create(null);break;case"object":break;default:a(`Ignoring ${l} as ${f.slice(0,h+1).join(".")} is ${JSON.stringify(P)}`);return}C=P}if(typeof C=="object"&&C!==null)try{C[v]=o}catch(h){a(`Ignoring ${l} as ${f.join(".")} is ${JSON.stringify(C)}`)}else a(`Ignoring ${l} as ${f.join(".")} is ${JSON.stringify(C)}`)}e.addToValueTree=r;function d(i,l){const o=l.split(".");_(i,o)}e.removeFromValueTree=d;function _(i,l){const o=l.shift();if(l.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const a=i[o];typeof a=="object"&&!Array.isArray(a)&&(_(a,l),Object.keys(a).length===0&&delete i[o])}}function g(i,l,o){function a(C,h){let p=C;for(const P of h){if(typeof p!="object"||p===null)return;p=p[P]}return p}const f=l.split("."),v=a(i,f);return typeof v=="undefined"?o:v}e.getConfigurationValue=g;function w(i,l,o){Object.keys(l).forEach(a=>{a!=="__proto__"&&(a in i?S.isObject(i[a])&&S.isObject(l[a])?w(i[a],l[a],o):o&&(i[a]=l[a]):i[a]=l[a])})}e.merge=w;function u(){const i=A.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=u;function c(){const i=Object.create(null),l=A.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let o in l){let a=l[o].default;r(i,o,a,f=>console.error(`Conflict in default settings: ${f}`))}return i}e.getDefaultValues=c;function s(i){return`[${i}]`}e.keyFromOverrideIdentifier=s;function t(i,l,o){const a=i.inspect(l),f=i.inspect(o);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:a.defaultValue}e.getMigratedSettingValue=t}),define(be[151],we([0,1,44,22,15,12,23,2,66,89,30,6,3]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},i=[],l=[]){this._contents=t,this._keys=i,this._overrides=l,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const l=this.getContentsForOverrideIdentifer(i);return l?t?(0,n.getConfigurationValue)(l,t):l:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let l={};for(const o of R.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[o],f=i[o];f&&(typeof a=="object"&&typeof f=="object"?(a=D.deepClone(a),this.mergeContents(a,f)):a=f),l[o]=a}return new m(l,this.keys,this.overrides)}merge(...t){const i=D.deepClone(this.contents),l=D.deepClone(this.overrides),o=[...this.keys];for(const a of t){this.mergeContents(i,a.contents);for(const f of a.overrides){const[v]=l.filter(C=>R.equals(C.identifiers,f.identifiers));v?this.mergeContents(v.contents,f.contents):l.push(D.deepClone(f))}for(const f of a.keys)o.indexOf(f)===-1&&o.push(f)}return new m(i,o,l)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const l of Object.keys(i)){if(l in t&&A.isObject(t[l])&&A.isObject(i[l])){this.mergeContents(t[l],i[l]);continue}t[l]=D.deepClone(i[l])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?D.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,n.addToValueTree)(this.contents,t,i,l=>{throw new Error(l)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let l=0;l<i;l++)t.indexOf(this.keys[l])===0&&(i=l);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class r extends m{constructor(){const t=(0,n.getDefaultValues)(),i=(0,n.getConfigurationKeys)(),l=[];for(const o of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(o)&&l.push({identifiers:[(0,y.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,n.toValuesTree)(t[o],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,i,l)}}e.DefaultConfigurationModel=r;class d{constructor(t,i){this._name=t,this._scopes=i,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get errors(){return this._parseErrors}parseContent(t){if(!A.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i)}}parseRaw(t){this._raw=t;const i=this.doParseRaw(t);this._configurationModel=new m(i.contents,i.keys,i.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let i={},l=null,o=[],a=[],f=[];function v(h){Array.isArray(o)?o.push(h):l&&(o[l]=h)}let C={onObjectBegin:()=>{let h={};v(h),a.push(o),o=h,l=null},onObjectProperty:h=>{l=h},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{let h=[];v(h),a.push(o),o=h,l=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:v,onError:(h,p,P)=>{f.push({error:h,offset:p,length:P})}};if(t)try{E.visit(t,C),i=o[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return i}doParseRaw(t){if(this._scopes){const a=T.Registry.as(y.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,a,!0,this._scopes)}const i=(0,n.toValuesTree)(t,a=>console.error(`Conflict in settings file ${this._name}: ${a}`)),l=Object.keys(t),o=(0,n.toOverrides)(t,a=>console.error(`Conflict in settings file ${this._name}: ${a}`));return{contents:i,keys:l,overrides:o}}filterByScope(t,i,l,o){const a={};for(let f in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(f)&&l)a[f]=this.filterByScope(t[f],i,!1,o);else{const v=this.getScope(f,i);(v===void 0||o.indexOf(v)!==-1)&&(a[f]=t[f])}return a}getScope(t,i){const l=i[t];return l?typeof l.scope!="undefined"?l.scope:3:void 0}}e.ConfigurationModelParser=d;class _ extends k.Disposable{constructor(t,i,l,o){super();this.userSettingsResource=t,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(b.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new m}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=_;class g{constructor(t,i,l=new m,o=new m,a=new S.ResourceMap,f=new m,v=new S.ResourceMap,C=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=l,this._workspaceConfiguration=o,this._folderConfigurations=a,this._memoryConfiguration=f,this._memoryConfigurationByResource=v,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new S.ResourceMap,this._userConfiguration=null}getValue(t,i,l){return this.getConsolidateConfigurationModel(i,l).getValue(t)}updateValue(t,i,l={}){let o;l.resource?(o=this._memoryConfigurationByResource.get(l.resource),o||(o=new m,this._memoryConfigurationByResource.set(l.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(t):o.setValue(t,i),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,l){const o=this.getConsolidateConfigurationModel(i,l),a=this.getFolderConfigurationModelForResource(i.resource,l),f=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,v=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),C=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),h=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),p=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=l?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,z=i.overrideIdentifier?f.override(i.overrideIdentifier).getValue(t):f.getValue(t),le=o.getValue(t),H=R.distinct(R.flatten(o.overrides.map(W=>W.identifiers))).filter(W=>o.getOverrideValue(t,W)!==void 0);return{defaultValue:v,userValue:C,userLocalValue:h,userRemoteValue:p,workspaceValue:P,workspaceFolderValue:F,memoryValue:z,value:le,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:p!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:i.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:f.getValue(t),override:i.overrideIdentifier?f.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const l=i.filter(o=>y.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const a=(0,y.overrideIdentifierFromKey)(o),f=this._defaultConfiguration.getKeysForOverrideIdentifier(a),v=t.getKeysForOverrideIdentifier(a),C=[...v.filter(h=>f.indexOf(h)===-1),...f.filter(h=>v.indexOf(h)===-1),...f.filter(h=>!D.equals(this._defaultConfiguration.override(a).getValue(h),t.override(a).getValue(h)))];return[a,C]});return this.updateDefaultConfiguration(t),{keys:i,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:l,removed:o,overrides:a}=(0,n.compare)(this.localUserConfiguration,t),f=[...i,...l,...o];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:l,removed:o,overrides:a}=(0,n.compare)(this.remoteUserConfiguration,t);let f=[...i,...l,...o];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:l,removed:o,overrides:a}=(0,n.compare)(this.workspaceConfiguration,t);let f=[...i,...l,...o];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:a}}compareAndUpdateFolderConfiguration(t,i){const l=this.folderConfigurations.get(t),{added:o,updated:a,removed:f,overrides:v}=(0,n.compare)(l,i);let C=[...o,...a,...f];return(C.length||!l)&&this.updateFolderConfiguration(t,i),{keys:C,overrides:v}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:l,updated:o,removed:a,overrides:f}=(0,n.compare)(i,void 0);return{keys:[...l,...o,...a],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let l=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?l.override(t.overrideIdentifier):l}getConsolidatedConfigurationModelForResource({resource:t},i){let l=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const o=i.getFolder(t);o&&(l=this.getFolderConsolidatedConfiguration(o.uri)||l);const a=this._memoryConfigurationByResource.get(t);a&&(l=l.merge(a))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const l=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(i=l.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=l}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const l=i.getFolder(t);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:l,overrides:o,keys:a}=this._folderConfigurations.get(i);return t.push([i,{contents:l,overrides:o,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(l=>t.add(l))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>i.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>i.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>i.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),l=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((f,v)=>(f.set(I.URI.revive(v[0]),this.parseConfigurationModel(v[1])),f),new S.ResourceMap);return new g(i,l,new m,o,a,new m,new S.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=g;function w(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,i=new Map;for(const o of s)o.keys.forEach(a=>t.add(a)),o.overrides.forEach(([a,f])=>{const v=(0,S.getOrSet)(i,a,new Set);f.forEach(C=>v.add(C))});const l=[];return i.forEach((o,a)=>l.push([a,[...o.values()]])),{keys:[...t.values()],overrides:l}}e.mergeChanges=w;class u{constructor(t,i,l,o){this.change=t,this.previous=i,this.currentConfiguraiton=l,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(v=>a.add(v)),t.overrides.forEach(([,v])=>v.forEach(C=>a.add(C))),this.affectedKeys=[...a.values()];const f=new m;this.affectedKeys.forEach(v=>f.setValue(v,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var l;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(l=this.previous)===null||l===void 0?void 0:l.workspace):void 0,a=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!D.equals(o,a)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let l=(0,n.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof l=="object"&&(o=Object.keys(l)[0]);){if(t=t[o],!t)return!1;l=l[o]}return!0}}e.ConfigurationChangeEvent=u;class c extends u{constructor(t,i,l,o){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=l,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=c}),define(be[90],we([0,1,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,E.createDecorator)("remoteAuthorityResolverService");var S;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(D,I=S.Unknown,y){super(D);this._message=D,this._code=I,this._detail=y,this.isHandled=I===S.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(D){return D instanceof R&&D._code===S.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof R&&D._code===S.NoResolverFound}static isHandled(D){return D instanceof R&&D.isHandled}}e.RemoteAuthorityResolverError=R}),define(be[91],we([0,1,16]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function S(A){return A.scheme===E.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=S;function R(A){if(!!A){const D=A.indexOf("+");return D<0?A:A.substr(0,D)}}e.getRemoteName=R}),define(be[152],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class E{constructor(R){this._callback=R,this._terminalBufferMap=new Map}dispose(){for(const R of this._terminalBufferMap.values())R.dispose()}startBuffering(R,A,D=5){let I;return I=A(y=>{const n=typeof y=="string"?y:y.data;let T=this._terminalBufferMap.get(R);if(T){T.data.push(n);return}const k=setTimeout(()=>this._flushBuffer(R),D);T={data:[n],timeoutId:k,dispose:()=>{clearTimeout(k),this._flushBuffer(R),I.dispose()}},this._terminalBufferMap.set(R,T)}),I}stopBuffering(R){const A=this._terminalBufferMap.get(R);A&&A.dispose()}_flushBuffer(R){const A=this._terminalBufferMap.get(R);A&&(this._terminalBufferMap.delete(R),this._callback(R,A.data.join("")))}}e.TerminalDataBufferer=E}),define(be[153],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var E;(function(S){S.DARK="dark",S.LIGHT="light",S.HIGH_CONTRAST="hc"})(E=e.ColorScheme||(e.ColorScheme={}))}),define(be[154],we([0,1,4,6,30,3,153,37]),function(ae,e,E,S,R,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,E.createDecorator)("themeService");var y;(function(_){function g(w){return w&&typeof w=="object"&&typeof w.id=="string"}_.isThemeColor=g})(y=e.ThemeColor||(e.ThemeColor={}));function n(_){return{id:_}}e.themeColorFromId=n;var T;(function(_){function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}_.isThemeIcon=g;const w=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function u(t){const i=w.exec(t);if(!!i){let[,l]=i;return{id:l}}}_.fromString=u;function c(t,i){let l=t.id;const o=l.lastIndexOf("~");return o!==-1&&(l=l.substring(0,o)),i&&(l=`${l}~${i}`),{id:l}}_.modify=c;function s(t,i){var l,o;return t.id===i.id&&((l=t.color)===null||l===void 0?void 0:l.id)===((o=i.color)===null||o===void 0?void 0:o.id)}_.isEqual=s,_.asClassNameArray=I.CSSIcon.asClassNameArray,_.asClassName=I.CSSIcon.asClassName,_.asCSSSelector=I.CSSIcon.asCSSSelector})(T=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function k(_){switch(_){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,S.toDisposable)(()=>{const w=this.themingParticipants.indexOf(g);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new b;R.Registry.add(e.Extensions.ThemingContribution,m);function r(_){return m.onColorThemeChange(_)}e.registerThemingParticipant=r;class d extends S.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,w){let u=this.theme.getColor(g);return u&&w&&(u=w(u,this.theme)),u?u.toString():null}}e.Themable=d}),define(be[155],we([0,1,30,154,3,125,88,13,37]),function(ae,e,E,S,R,A,D,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(g,w,u,c){const s=this.iconsById[g];if(s){if(u&&!s.description){s.description=u,this.iconSchema.properties[g].markdownDescription=`${u} $(${g})`;const l=this.iconReferenceSchema.enum.indexOf(g);l!==-1&&(this.iconReferenceSchema.enumDescriptions[l]=u),this._onDidChange.fire()}return s}let t={id:g,description:u,defaults:w,deprecationMessage:c};this.iconsById[g]=t;let i={$ref:"#/definitions/icons"};return c&&(i.deprecationMessage=c),u&&(i.markdownDescription=`${u}: $(${g})`),this.iconSchema.properties[g]=i,this.iconReferenceSchema.enum.push(g),this.iconReferenceSchema.enumDescriptions.push(u||""),this._onDidChange.fire(),{id:g}}deregisterIcon(g){delete this.iconsById[g],delete this.iconSchema.properties[g];const w=this.iconReferenceSchema.enum.indexOf(g);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(g=>this.iconsById[g])}getIcon(g){return this.iconsById[g]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(g,w){const u=this.iconFontsById[g];if(u)return u;let c={id:g,definition:w};return this.iconFontsById[g]=c,this._onDidChange.fire(),c}deregisterIconFont(g){delete this.iconFontsById[g]}getIconFonts(){return Object.keys(this.iconFontsById).map(g=>this.iconFontsById[g])}getIconFont(g){return this.iconFontsById[g]}toString(){const g=(s,t)=>s.id.localeCompare(t.id),w=s=>{for(;S.ThemeIcon.isThemeIcon(s.defaults);)s=this.iconsById[s.defaults.id];return`codicon codicon-${s?s.id:""}`};let u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(s=>this.iconsById[s]);for(const s of c.filter(t=>!!t.description).sort(g))u.push(`|<i class="${w(s)}"></i>|${s.id}|${S.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const s of c.filter(t=>!S.ThemeIcon.isThemeIcon(t.defaults)).sort(g))u.push(`|<i class="${w(s)}"></i>|${s.id}|`);return u.join(`
`)}}const T=new n;E.Registry.add(e.Extensions.IconContribution,T);function k(_,g,w,u){return T.registerIcon(_,g,w,u)}e.registerIcon=k;function b(){return T}e.getIconRegistry=b;function m(){for(const _ of y.iconRegistry.all)T.registerIcon(_.id,_.definition,_.description);y.iconRegistry.onDidRegister(_=>T.registerIcon(_.id,_.definition,_.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let r=E.Registry.as(D.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,T.getIconSchema());const d=new I.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);T.onDidChange(()=>{d.isScheduled()||d.schedule()}),e.widgetClose=k("widget-close",y.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",y.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",y.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=S.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(be[47],we([0,1,2,24,4,22]),function(ae,e,E,S,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");var D;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function I(b){const m=b;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=I;function y(b){const m=b;return!!(m&&typeof m=="object"&&E.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=y;class n{constructor(m,r,d,_){this._id=m,this._configuration=d,this._ignorePathCasing=_,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class T{constructor(m,r){this.raw=r,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,S.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=T;function k(b){return new T({uri:b,index:0,name:(0,S.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=k}),define(be[156],we([0,1,4,126,47,2,21,11,24,105,44,16,58,38,91]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(G){return(typeof G=="string"?(0,I.extname)(G):(0,y.extname)(G))===d}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function g(G){return G.hasOwnProperty("workspace")}e.isRecentWorkspace=g;function w(G){return G.hasOwnProperty("folderUri")}e.isRecentFolder=w;function u(G){return G.hasOwnProperty("fileUri")}e.isRecentFile=u;function c(G){const L=G;return typeof(L==null?void 0:L.id)=="string"&&A.URI.isUri(L.uri)}e.isSingleFolderWorkspaceIdentifier=c;function s(G){if(G.configuration)return{id:G.id,configPath:G.configuration};if(G.folders.length===1)return{id:G.id,uri:G.folders[0].uri}}e.toWorkspaceIdentifier=s;function t(G){const L=G;return typeof(L==null?void 0:L.id)=="string"&&A.URI.isUri(L.configPath)}e.isWorkspaceIdentifier=t;function i(G){const L=G;if(L==null?void 0:L.uri)return{id:L.id,uri:A.URI.revive(L.uri)};const U=G;if(U==null?void 0:U.configPath)return{id:U.id,configPath:A.URI.revive(U.configPath)};if(G==null?void 0:G.id)return{id:G.id}}e.reviveIdentifier=i;function l(G,L){return y.extUriBiasedIgnorePathCase.isEqualOrParent(G,L.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function o(G){return a(G)||f(G)}e.isStoredWorkspaceFolder=o;function a(G){const L=G;return typeof(L==null?void 0:L.path)=="string"&&(!L.name||typeof L.name=="string")}e.isRawFileWorkspaceFolder=a;function f(G){const L=G;return typeof(L==null?void 0:L.uri)=="string"&&(!L.name||typeof L.name=="string")}e.isRawUriWorkspaceFolder=f;function v(G,L,U,x,Q=!D.isWindows,$){if(G.scheme!==x.scheme)return{name:U,uri:G.toString(!0)};let Z=L?void 0:$.relativePath(x,G);if(Z!==void 0)Z.length===0?Z=".":D.isWindows&&G.scheme===k.Schemas.file&&!Q&&(Z=Z.replace(/\//g,"\\"));else if(G.scheme===k.Schemas.file)Z=G.fsPath,D.isWindows&&(Z=(0,b.normalizeDriveLetter)(Z),Q&&(Z=(0,m.toSlashes)(Z)));else{if(!$.isEqualAuthority(G.authority,x.authority))return{name:U,uri:G.toString(!0)};Z=G.path}return{name:U,path:Z}}e.getStoredWorkspaceFolder=v;function C(G,L,U){let x=[],Q=new Set;const $=U.dirname(L);for(let Z of G){let ie=null;if(a(Z))Z.path&&(ie=U.resolvePath($,Z.path));else if(f(Z))try{ie=A.URI.parse(Z.uri),ie.path[0]!=="/"&&(ie=ie.with({path:"/"+ie.path}))}catch(re){console.warn(re)}if(ie){let re=U.getComparisonKey(ie);if(!Q.has(re)){Q.add(re);const ye=Z.name||U.basenameOrAuthority(ie);x.push(new R.WorkspaceFolder({uri:ie,name:ye,index:x.length},Z))}}}return x}e.toWorkspaceFolders=C;function h(G,L,U,x,Q){let $=p(L,G);const Z=Q.dirname(L),ie=Q.dirname(x),re=[],ye=P($.folders);for(const ze of $.folders){const N=a(ze)?Q.resolvePath(Z,ze.path):A.URI.parse(ze.uri);let K;U?K=!1:K=!a(ze)||(0,I.isAbsolute)(ze.path),re.push(v(N,K,ze.name,ie,ye,Q))}const Ie={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},Ue=n.setProperty(G,["folders"],re,Ie);let Fe=n.applyEdits(G,Ue);return $.remoteAuthority===(0,r.getRemoteAuthority)(x)&&(Fe=n.applyEdits(Fe,n.removeProperty(Fe,["remoteAuthority"],Ie))),Fe}e.rewriteWorkspaceFileForNewLocation=h;function p(G,L){let U=T.parse(L);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(x=>o(x));else throw new Error(`${G} looks like an invalid workspace file.`);return U}function P(G){return D.isWindows?G.some(L=>a(L)&&L.path.indexOf("/")>=0):!0}e.useSlashForPath=P;function F(G){return G.workspace&&typeof G.workspace=="object"&&typeof G.workspace.id=="string"&&typeof G.workspace.configPath=="string"}function z(G){return typeof G.folderUri=="string"}function le(G){return typeof G.fileUri=="string"}function H(G,L){const U={workspaces:[],files:[]};if(G){const x=function($,Z){for(let ie=0;ie<$.length;ie++)try{Z($[ie],ie)}catch(re){L.warn(`Error restoring recent entry ${JSON.stringify($[ie])}: ${re.toString()}. Skip entry.`)}},Q=G;if(Array.isArray(Q.entries))x(Q.entries,$=>{const Z=$.label,ie=$.remoteAuthority;F($)?U.workspaces.push({label:Z,remoteAuthority:ie,workspace:{id:$.workspace.id,configPath:A.URI.parse($.workspace.configPath)}}):z($)?U.workspaces.push({label:Z,remoteAuthority:ie,folderUri:A.URI.parse($.folderUri)}):le($)&&U.files.push({label:Z,remoteAuthority:ie,fileUri:A.URI.parse($.fileUri)})});else{const $=G;Array.isArray($.workspaces3)&&x($.workspaces3,(Z,ie)=>{const re=Array.isArray($.workspaceLabels)&&$.workspaceLabels[ie]||void 0;typeof Z=="object"&&typeof Z.id=="string"&&typeof Z.configURIPath=="string"?U.workspaces.push({label:re,workspace:{id:Z.id,configPath:A.URI.parse(Z.configURIPath)}}):typeof Z=="string"&&U.workspaces.push({label:re,folderUri:A.URI.parse(Z)})}),Array.isArray($.files2)&&x($.files2,(Z,ie)=>{const re=Array.isArray($.fileLabels)&&$.fileLabels[ie]||void 0;typeof Z=="string"&&U.files.push({label:re,fileUri:A.URI.parse(Z)})})}}return U}e.restoreRecentlyOpened=H;function W(G){const L={entries:[]};for(const U of G.workspaces)w(U)?L.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):L.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of G.files)L.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return L}e.toStoreData=W}),define(be[92],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class E{constructor(R){this.id=R,this._data=new Map,this._idPool=1}add(R){const A=this._idPool++;return this._data.set(A,R),this.logDebugInfo(),A}get(R,A){return this._data.has(R)?this._data.get(R)[A]:void 0}delete(R){this._data.delete(R),this.logDebugInfo()}logDebugInfo(){!E.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=E,E.enableDebugLogging=!1}),define(be[157],we([0,1,2,3]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class R{constructor(){this._onDidChangeTabs=new S.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(I=>({name:I.name,group:I.group,resource:E.URI.revive(I.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=R}),define(be[48],we([0,1,16,4]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this._systemSchemes=new Set(Object.keys(E.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(D,I){I===null?this._providerInfo.delete(D):this._providerInfo.set(D,I)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],we([0,1,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,E.createDecorator)("IExtHostInitDataService")}),define(be[158],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class E{constructor(A,D,I){this._id=A,this._shared=D,this._storage=I,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(A,D){let I=this._value[A];return typeof I=="undefined"&&(I=D),I}update(A,D){return this._value[A]=D,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=E;class S extends E{constructor(A,D){super(A.identifier.value,!0,D);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=S}),define(be[14],we([0,1,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class S{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=S});var tt=this&&this.__classPrivateFieldSet||function(ae,e,E){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,E),E},$e=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(be[159],we([0,1,25,3]),function(ae,e,E,S){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(I,y){R.set(this,void 0),this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this._id=E.ExtensionIdentifier.toKey(I.identifier),tt(this,R,y),$e(this,R).onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(I){return $e(this,R).get(this._id,I)}store(I,y){return $e(this,R).store(this._id,I,y)}delete(I){return $e(this,R).delete(this._id,I)}}e.ExtensionSecrets=A,R=new WeakMap}),define(be[93],we([0,1,4,3]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class R{constructor(){this._onDidChangeTelemetryEnabled=new S.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(D){this._enabled=D}$onDidChangeTelemetryEnabled(D){this._enabled=D,this._onDidChangeTelemetryEnabled.fire(D)}}e.ExtHostTelemetry=R,e.IExtHostTelemetry=(0,E.createDecorator)("IExtHostTelemetry")}),define(be[67],we([0,1,4,3,14]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(I){function y(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public}}I.fromApiTunnel=y;function n(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.public}}I.fromServiceTunnel=n})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,E.createDecorator)("IExtHostTunnelService");let D=class{constructor(y){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,n){return{dispose:()=>{}}}async $providePortAttributes(y,n,T,k,b){return[]}async $forwardPort(y,n){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=je([Ke(0,R.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var tt=this&&this.__classPrivateFieldSet||function(ae,e,E){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,E),E},$e=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(be[7],we([0,1,15,10,80,22,12,2,29,64,90]),function(ae,e,E,S,R,A,D,I,y,n,T){"use strict";var k,b,m,r,d,_,g,w,u,c,s,t,i,l,o,a,f,v;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestState=e.TestItem=e.TestChildrenCollection=e.TestItemHookProperty=e.TestMessageSeverity=e.TestResult=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function C(O){function M(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(M,O),Object.setPrototypeOf(M.prototype,O.prototype),M}let h=d=class{constructor(M){k.set(this,void 0),tt(this,k,M)}static from(...M){let ne=M;return new d(function(){if(ne){for(const Ee of ne)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ne=void 0}})}dispose(){typeof $e(this,k)=="function"&&($e(this,k).call(this),tt(this,k,void 0))}};k=new WeakMap,h=d=je([C],h),e.Disposable=h;let p=_=class{constructor(M,ne){if(M<0)throw(0,S.illegalArgument)("line must be non-negative");if(ne<0)throw(0,S.illegalArgument)("character must be non-negative");this._line=M,this._character=ne}static Min(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let Ee=1;Ee<M.length;Ee++){const He=M[Ee];He.isBefore(ne)&&(ne=He)}return ne}static Max(...M){if(M.length===0)throw new TypeError;let ne=M[0];for(let Ee=1;Ee<M.length;Ee++){const He=M[Ee];He.isAfter(ne)&&(ne=He)}return ne}static isPosition(M){if(!M)return!1;if(M instanceof _)return!0;let{line:ne,character:Ee}=M;return typeof ne=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,ne=0){if(M===null||ne===null)throw(0,S.illegalArgument)();let Ee;return typeof M=="undefined"?Ee=0:typeof M=="number"?Ee=M:(Ee=typeof M.lineDelta=="number"?M.lineDelta:0,ne=typeof M.characterDelta=="number"?M.characterDelta:0),Ee===0&&ne===0?this:new _(this.line+Ee,this.character+ne)}with(M,ne=this.character){if(M===null||ne===null)throw(0,S.illegalArgument)();let Ee;return typeof M=="undefined"?Ee=this.line:typeof M=="number"?Ee=M:(Ee=typeof M.line=="number"?M.line:this.line,ne=typeof M.character=="number"?M.character:this.character),Ee===this.line&&ne===this.character?this:new _(Ee,ne)}toJSON(){return{line:this.line,character:this.character}}};p=_=je([C],p),e.Position=p;let P=g=class{constructor(M,ne,Ee,He){let Ye,it;if(typeof M=="number"&&typeof ne=="number"&&typeof Ee=="number"&&typeof He=="number"?(Ye=new p(M,ne),it=new p(Ee,He)):M instanceof p&&ne instanceof p&&(Ye=M,it=ne),!Ye||!it)throw new Error("Invalid arguments");Ye.isBefore(it)?(this._start=Ye,this._end=it):(this._start=it,this._end=Ye)}static isRange(M){return M instanceof g?!0:M?p.isPosition(M.start)&&p.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof g?this.contains(M._start)&&this.contains(M._end):M instanceof p?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const ne=p.Max(M.start,this._start),Ee=p.Min(M.end,this._end);if(!ne.isAfter(Ee))return new g(ne,Ee)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ne=p.Min(M.start,this._start),Ee=p.Max(M.end,this.end);return new g(ne,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,ne=this.end){if(M===null||ne===null)throw(0,S.illegalArgument)();let Ee;return M?p.isPosition(M)?Ee=M:(Ee=M.start||this.start,ne=M.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&ne.isEqual(this.end)?this:new g(Ee,ne)}toJSON(){return[this.start,this.end]}};P=g=je([C],P),e.Range=P;let F=w=class extends P{constructor(M,ne,Ee,He){let Ye,it;if(typeof M=="number"&&typeof ne=="number"&&typeof Ee=="number"&&typeof He=="number"?(Ye=new p(M,ne),it=new p(Ee,He)):M instanceof p&&ne instanceof p&&(Ye=M,it=ne),!Ye||!it)throw new Error("Invalid arguments");super(Ye,it);this._anchor=Ye,this._active=it}static isSelection(M){return M instanceof w?!0:M?P.isRange(M)&&p.isPosition(M.anchor)&&p.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};F=w=je([C],F),e.Selection=F;class z{constructor(M,ne,Ee){if(typeof M!="string"||M.length===0)throw(0,S.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,S.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,S.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(ne),this.connectionToken=Ee}}e.ResolvedAuthority=z;class le extends Error{constructor(M,ne=T.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(M);this._message=M,this._code=ne,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,le.prototype)}static NotAvailable(M,ne){return new le(M,T.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(M){return new le(M,T.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=le;var H;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var W;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=u=class{constructor(M,ne){this._range=M,this._newText=ne}static isTextEdit(M){return M instanceof u?!0:M?P.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ne){return new u(M,ne)}static insert(M,ne){return u.replace(new P(M,M),ne)}static delete(M){return u.replace(M,"")}static setEndOfLine(M){const ne=new u(new P(new p(0,0),new p(0,0)),"");return ne.newEol=M,ne}get range(){return this._range}set range(M){if(M&&!P.isRange(M))throw(0,S.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,S.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,S.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};G=u=je([C],G),e.TextEdit=G;var L;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellOutput=4]="CellOutput",O[O.CellReplace=5]="CellReplace",O[O.CellOutputItem=6]="CellOutputItem"})(L=e.FileEditType||(e.FileEditType={}));let U=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,ne,Ee,He){this._edits.push({_type:1,from:M,to:ne,options:Ee,metadata:He})}createFile(M,ne,Ee){this._edits.push({_type:1,from:void 0,to:M,options:ne,metadata:Ee})}deleteFile(M,ne,Ee){this._edits.push({_type:1,from:M,to:void 0,options:ne,metadata:Ee})}replaceNotebookMetadata(M,ne,Ee){this._edits.push({_type:3,metadata:Ee,uri:M,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(M,ne,Ee,He,Ye){(ne!==Ee||He.length>0)&&this._edits.push({_type:5,uri:M,index:ne,count:Ee-ne,cells:He,metadata:Ye})}replaceNotebookCellOutput(M,ne,Ee,He){this._editNotebookCellOutput(M,ne,!1,Ee,He)}appendNotebookCellOutput(M,ne,Ee,He){this._editNotebookCellOutput(M,ne,!0,Ee,He)}replaceNotebookCellOutputItems(M,ne,Ee,He,Ye){this._editNotebookCellOutputItems(M,ne,Ee,!1,He,Ye)}appendNotebookCellOutputItems(M,ne,Ee,He,Ye){this._editNotebookCellOutputItems(M,ne,Ee,!0,He,Ye)}_editNotebookCellOutputItems(M,ne,Ee,He,Ye,it){this._edits.push({_type:6,metadata:it,uri:M,index:ne,outputId:Ee,append:He,newOutputItems:Ye})}_editNotebookCellOutput(M,ne,Ee,He,Ye){this._edits.push({_type:4,metadata:Ye,uri:M,index:ne,append:Ee,newOutputs:He,newMetadata:void 0})}replaceNotebookCellMetadata(M,ne,Ee,He){this._edits.push({_type:3,metadata:He,uri:M,edit:{editType:11,index:ne,metadata:Ee}})}replace(M,ne,Ee,He){this._edits.push({_type:2,uri:M,edit:new G(ne,Ee),metadata:He})}insert(M,ne,Ee,He){this.replace(M,new P(ne,ne),Ee,He)}delete(M,ne,Ee){this.replace(M,ne,"",Ee)}has(M){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===M.toString())}set(M,ne){if(ne)for(const Ee of ne)Ee&&this._edits.push({_type:2,uri:M,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const He=this._edits[Ee];He._type===2&&He.uri.toString()===M.toString()&&(this._edits[Ee]=void 0)}(0,E.coalesceInPlace)(this._edits)}}get(M){const ne=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===M.toString()&&ne.push(Ee.edit);return ne}entries(){const M=new A.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Ee=M.get(ne.uri);Ee||(Ee=[ne.uri,[]],M.set(ne.uri,Ee)),Ee[1].push(ne.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=je([C],U),e.WorkspaceEdit=U;let x=c=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof c?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=c._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ne=this._tabstop++){if(typeof M=="function"){const Ee=new c;Ee._tabstop=this._tabstop,M(Ee),this._tabstop=Ee._tabstop,M=Ee.value}else M=c._escape(M);return this.value+="${",this.value+=ne,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ne=this._tabstop++){const Ee=M.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(M,ne){if(typeof ne=="function"){const Ee=new c;Ee._tabstop=this._tabstop,ne(Ee),this._tabstop=Ee._tabstop,ne=Ee.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};x=c=je([C],x),e.SnippetString=x;var Q;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})(Q=e.DiagnosticTag||(e.DiagnosticTag={}));var $;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})($=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=s=class{constructor(M,ne){if(this.uri=M,ne)if(ne instanceof P)this.range=ne;else if(ne instanceof p)this.range=new P(ne,ne);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof s?!0:M?P.isRange(M.range)&&I.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=s=je([C],Z),e.Location=Z;let ie=class{constructor(M,ne){this.location=M,this.message=ne}static is(M){return M?typeof M.message=="string"&&M.location&&P.isRange(M.location.range)&&I.URI.isUri(M.location.uri):!1}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.location.range.isEqual(ne.location.range)&&M.location.uri.toString()===ne.location.uri.toString()}};ie=je([C],ie),e.DiagnosticRelatedInformation=ie;let re=class{constructor(M,ne,Ee=$.Error){if(!P.isRange(M))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=M,this.message=ne,this.severity=Ee}toJSON(){return{severity:$[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ne){return M===ne?!0:!M||!ne?!1:M.message===ne.message&&M.severity===ne.severity&&M.code===ne.code&&M.severity===ne.severity&&M.source===ne.source&&M.range.isEqual(ne.range)&&(0,E.equals)(M.tags,ne.tags)&&(0,E.equals)(M.relatedInformation,ne.relatedInformation,ie.isEqual)}};re=je([C],re),e.Diagnostic=re;let ye=class{constructor(M,ne){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:(0,R.isMarkdownString)(M)?this.contents=[M]:this.contents=[M],this.range=ne}};ye=je([C],ye),e.Hover=ye;var Ie;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ue=class{constructor(M,ne=Ie.Text){this.range=M,this.kind=ne}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};Ue=je([C],Ue),e.DocumentHighlight=Ue;var Fe;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(Fe=e.SymbolKind||(e.SymbolKind={}));var ze;(function(O){O[O.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let N=t=class{constructor(M,ne,Ee,He,Ye){this.name=M,this.kind=ne,this.containerName=Ye,typeof Ee=="string"&&(this.containerName=Ee),He instanceof Z?this.location=He:Ee instanceof P&&(this.location=new Z(He,Ee)),t.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};N=t=je([C],N),e.SymbolInformation=N;let K=i=class{constructor(M,ne,Ee,He,Ye){this.name=M,this.detail=ne,this.kind=Ee,this.range=He,this.selectionRange=Ye,this.children=[],i.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(i.validate)}};K=i=je([C],K),e.DocumentSymbol=K;var ee;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(M,ne){this.title=M,this.kind=ne}};oe=je([C],oe),e.CodeAction=oe;let me=l=class{constructor(M){this.value=M}append(M){return new l(this.value?this.value+l.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+l.sep)}};me.sep=".",me=l=je([C],me),e.CodeActionKind=me,me.Empty=new me(""),me.QuickFix=me.Empty.append("quickfix"),me.Refactor=me.Empty.append("refactor"),me.RefactorExtract=me.Refactor.append("extract"),me.RefactorInline=me.Refactor.append("inline"),me.RefactorRewrite=me.Refactor.append("rewrite"),me.Source=me.Empty.append("source"),me.SourceOrganizeImports=me.Source.append("organizeImports"),me.SourceFixAll=me.Source.append("fixAll");let Se=class{constructor(M,ne){if(this.range=M,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Se=je([C],Se),e.SelectionRange=Se;class Me{constructor(M,ne,Ee,He,Ye,it){this.kind=M,this.name=ne,this.detail=Ee,this.uri=He,this.range=Ye,this.selectionRange=it}}e.CallHierarchyItem=Me;class ge{constructor(M,ne){this.fromRanges=ne,this.from=M}}e.CallHierarchyIncomingCall=ge;class Ce{constructor(M,ne){this.fromRanges=ne,this.to=M}}e.CallHierarchyOutgoingCall=Ce;let Pe=class{constructor(M,ne){this.range=M,this.command=ne}get isResolved(){return!!this.command}};Pe=je([C],Pe),e.CodeLens=Pe;let xe=o=class{constructor(M,ne=!1){b.set(this,void 0),tt(this,b,new R.MarkdownString(M,{supportThemeIcons:ne}))}static isMarkdownString(M){return M instanceof o?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return $e(this,b).value}set value(M){$e(this,b).value=M}get isTrusted(){return $e(this,b).isTrusted}set isTrusted(M){$e(this,b).isTrusted=M}get supportThemeIcons(){return $e(this,b).supportThemeIcons}appendText(M){return $e(this,b).appendText(M),this}appendMarkdown(M){return $e(this,b).appendMarkdown(M),this}appendCodeblock(M,ne){return $e(this,b).appendCodeblock(ne!=null?ne:"",M),this}};b=new WeakMap,xe=o=je([C],xe),e.MarkdownString=xe;let _e=class{constructor(M,ne){this.label=M,this.documentation=ne}};_e=je([C],_e),e.ParameterInformation=_e;let qe=class{constructor(M,ne){this.label=M,this.documentation=ne,this.parameters=[]}};qe=je([C],qe),e.SignatureInformation=qe;let V=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};V=je([C],V),e.SignatureHelp=V;var Y;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(Y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ve;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(ve=e.InlineHintKind||(e.InlineHintKind={}));let Le=class{constructor(M,ne,Ee){this.text=M,this.range=ne,this.kind=Ee}};Le=je([C],Le),e.InlineHint=Le;var Be;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(Oe=e.CompletionItemKind||(e.CompletionItemKind={}));var et;(function(O){O[O.Deprecated=1]="Deprecated"})(et=e.CompletionItemTag||(e.CompletionItemTag={}));let B=class{constructor(M,ne){this.label=M,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};B=je([C],B),e.CompletionItem=B;let te=class{constructor(M=[],ne=!1){this.items=M,this.isIncomplete=ne}};te=je([C],te),e.CompletionList=te;var he;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var q;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(q=e.StatusBarAlignment||(e.StatusBarAlignment={}));var J;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var se;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(se=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var fe;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(fe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pe;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var We;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(We=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function M(ne){switch(ne){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=M}(pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ne=class{constructor(M,ne){if(ne&&!I.URI.isUri(ne))throw(0,S.illegalArgument)("target");if(!P.isRange(M)||M.isEmpty)throw(0,S.illegalArgument)("range");this.range=M,this.target=ne}};Ne=je([C],Ne),e.DocumentLink=Ne;let Ve=class{constructor(M,ne,Ee,He){this.red=M,this.green=ne,this.blue=Ee,this.alpha=He}};Ve=je([C],Ve),e.Color=Ve;let Je=class{constructor(M,ne){if(ne&&!(ne instanceof Ve))throw(0,S.illegalArgument)("color");if(!P.isRange(M)||M.isEmpty)throw(0,S.illegalArgument)("range");this.range=M,this.color=ne}};Je=je([C],Je),e.ColorInformation=Je;let Ze=class{constructor(M){if(!M||typeof M!="string")throw(0,S.illegalArgument)("label");this.label=M}};Ze=je([C],Ze),e.ColorPresentation=Ze;var ct;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(ct=e.ColorFormat||(e.ColorFormat={}));var ot;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var nt;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(nt=e.TaskRevealKind||(e.TaskRevealKind={}));var ue;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(ue=e.TaskPanelKind||(e.TaskPanelKind={}));let De=a=class{constructor(M,ne){if(typeof M!="string"||typeof ne!="string")throw(0,S.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};De.Clean=new a("clean","Clean"),De.Build=new a("build","Build"),De.Rebuild=new a("rebuild","Rebuild"),De.Test=new a("test","Test"),De=a=je([C],De),e.TaskGroup=De;function ce(O){let M="";for(let ne=0;ne<O.length;ne++)M+=O[ne].replace(/,/g,",,")+",";return M}let j=class{constructor(M,ne,Ee){if(typeof M!="string")throw(0,S.illegalArgument)("process");this._args=[],this._process=M,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Ee):this._options=ne)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,S.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)M.push(ne);return ce(M)}};j=je([C],j),e.ProcessExecution=j;let Ae=class{constructor(M,ne,Ee){if(this._args=[],Array.isArray(ne)){if(!M)throw(0,S.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,S.illegalArgument)("command");this._command=M,this._args=ne,this._options=Ee}else{if(typeof M!="string")throw(0,S.illegalArgument)("commandLine");this._commandLine=M,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,S.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,S.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)M.push(typeof ne=="string"?ne:ne.value);return ce(M)}};Ae=je([C],Ae),e.ShellExecution=Ae;var Te;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(Te=e.ShellQuoting||(e.ShellQuoting={}));var Xe;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(Xe=e.TaskScope||(e.TaskScope={}));class Ge{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=Ge;let rt=f=class{constructor(M,ne,Ee,He,Ye,it){this.__deprecated=!1,this._definition=this.definition=M;let dt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Ee,this.execution=He,dt=Ye,this.__deprecated=!0):ne===Xe.Global||ne===Xe.Workspace?(this.target=ne,this._name=this.name=Ee,this._source=this.source=He,this.execution=Ye,dt=it):(this.target=ne,this._name=this.name=Ee,this._source=this.source=He,this.execution=Ye,dt=it),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof j?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ae?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,S.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,S.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const ne=this._definition.type;(f.EmptyType===ne||f.ProcessType===ne||f.ShellType===ne||f.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,S.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};rt.ExtensionCallbackType="customExecution",rt.ProcessType="process",rt.ShellType="shell",rt.EmptyType="$empty",rt=f=je([C],rt),e.Task=rt;var at;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(at=e.ProgressLocation||(e.ProgressLocation={}));let Qe=class{constructor(M,ne=ut.None){this.collapsibleState=ne,I.URI.isUri(M)?this.resourceUri=M:this.label=M}};Qe=je([C],Qe),e.TreeItem=Qe;var ut;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let st=class{constructor(M,ne){this.id=M,this.color=ne}};st=je([C],st),e.ThemeIcon=st,st.File=new st("file"),st.Folder=new st("folder");let gt=class{constructor(M){this.id=M}};gt=je([C],gt),e.ThemeColor=gt;var wt;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(wt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Dt=class{constructor(M,ne){if(typeof M!="string"&&(!M||!I.URI.isUri(M)&&!I.URI.isUri(M.uri)))throw(0,S.illegalArgument)("base");if(typeof ne!="string")throw(0,S.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=I.URI.file(M),this.base=M):I.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=ne}};Dt=je([C],Dt),e.RelativePattern=Dt;let vt=class{constructor(M,ne,Ee,He){this.enabled=typeof M=="boolean"?M:!0,typeof ne=="string"&&(this.condition=ne),typeof Ee=="string"&&(this.hitCondition=Ee),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};vt=je([C],vt),e.Breakpoint=vt;let Et=class extends vt{constructor(M,ne,Ee,He,Ye){super(ne,Ee,He,Ye);if(M===null)throw(0,S.illegalArgument)("location");this.location=M}};Et=je([C],Et),e.SourceBreakpoint=Et;let pt=class extends vt{constructor(M,ne,Ee,He,Ye){super(ne,Ee,He,Ye);this.functionName=M}};pt=je([C],pt),e.FunctionBreakpoint=pt;let Ft=class extends vt{constructor(M,ne,Ee,He,Ye,it,dt){super(He,Ye,it,dt);if(!ne)throw(0,S.illegalArgument)("dataId");this.label=M,this.dataId=ne,this.canPersist=Ee}};Ft=je([C],Ft),e.DataBreakpoint=Ft;let Lt=class{constructor(M,ne,Ee){this.command=M,this.args=ne||[],this.options=Ee}};Lt=je([C],Lt),e.DebugAdapterExecutable=Lt;let ft=class{constructor(M,ne){this.port=M,this.host=ne}};ft=je([C],ft),e.DebugAdapterServer=ft;let yt=class{constructor(M){this.path=M}};yt=je([C],yt),e.DebugAdapterNamedPipeServer=yt;let Ht=class{constructor(M){this.implementation=M}};Ht=je([C],Ht),e.DebugAdapterInlineImplementation=Ht;let qt=class{constructor(M,ne){this.range=M,this.expression=ne}};qt=je([C],qt),e.EvaluatableExpression=qt;let Mt=class{constructor(M,ne){this.range=M,this.text=ne}};Mt=je([C],Mt),e.InlineValueText=Mt;let ht=class{constructor(M,ne,Ee=!0){this.range=M,this.variableName=ne,this.caseSensitiveLookup=Ee}};ht=je([C],ht),e.InlineValueVariableLookup=ht;let Kt=class{constructor(M,ne){this.range=M,this.expression=ne}};Kt=je([C],Kt),e.InlineValueEvaluatableExpression=Kt;let kt=class{constructor(M,ne){this.frameId=M,this.stoppedLocation=ne}};kt=je([C],kt),e.InlineValueContext=kt;var Nt;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let zt=v=class extends Error{constructor(M,ne=n.FileSystemProviderErrorCode.Unknown,Ee){var He;super(I.URI.isUri(M)?M.toString(!0):M);this.code=(He=Ee==null?void 0:Ee.name)!==null&&He!==void 0?He:"Unknown",(0,n.markAsFileSystemProviderError)(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(M){return new v(M,n.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(M){return new v(M,n.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(M){return new v(M,n.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(M){return new v(M,n.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(M){return new v(M,n.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(M){return new v(M,n.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}};zt=v=je([C],zt),e.FileSystemError=zt;let Gt=class{constructor(M,ne,Ee){this.start=M,this.end=ne,this.kind=Ee}};Gt=je([C],Gt),e.FoldingRange=Gt;var en;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(en=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var tn;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(tn=e.CommentMode||(e.CommentMode={}));class Ot{constructor(M,ne=[]){this.tokenTypes=M,this.tokenModifiers=ne}}e.SemanticTokensLegend=Ot;function fn(O){return typeof O=="undefined"||(0,D.isStringArray)(O)}class Ut{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let ne=0,Ee=M.tokenTypes.length;ne<Ee;ne++)this._tokenTypeStrToInt.set(M.tokenTypes[ne],ne);for(let ne=0,Ee=M.tokenModifiers.length;ne<Ee;ne++)this._tokenModifierStrToInt.set(M.tokenModifiers[ne],ne)}}push(M,ne,Ee,He,Ye){if(typeof M=="number"&&typeof ne=="number"&&typeof Ee=="number"&&typeof He=="number"&&(typeof Ye=="number"||typeof Ye=="undefined"))return typeof Ye=="undefined"&&(Ye=0),this._pushEncoded(M,ne,Ee,He,Ye);if(P.isRange(M)&&typeof ne=="string"&&fn(Ee))return this._push(M,ne,Ee);throw(0,S.illegalArgument)()}_push(M,ne,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const He=M.start.line,Ye=M.start.character,it=M.end.character-M.start.character,dt=this._tokenTypeStrToInt.get(ne);let bt=0;if(Ee)for(const Ct of Ee){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(Ct);bt|=1<<It>>>0}this._pushEncoded(He,Ye,it,dt,bt)}_pushEncoded(M,ne,Ee,He,Ye){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const bt=this._data.length/5|0;let Ct=0,It=0;for(let Pt=0;Pt<bt;Pt++){let Tt=this._data[5*Pt],Xt=this._data[5*Pt+1];Tt===0?(Tt=Ct,Xt+=It):Tt+=Ct,this._data[5*Pt]=Tt,this._data[5*Pt+1]=Xt,Ct=Tt,It=Xt}}let it=M,dt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(it-=this._prevLine,it===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=it,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Ye,this._prevLine=M,this._prevChar=ne}static _sortAndDeltaEncode(M){let ne=[];const Ee=M.length/5|0;for(let dt=0;dt<Ee;dt++)ne[dt]=dt;ne.sort((dt,bt)=>{const Ct=M[5*dt],It=M[5*bt];if(Ct===It){const Pt=M[5*dt+1],Tt=M[5*bt+1];return Pt-Tt}return Ct-It});const He=new Uint32Array(M.length);let Ye=0,it=0;for(let dt=0;dt<Ee;dt++){const bt=5*ne[dt],Ct=M[bt+0],It=M[bt+1],Pt=M[bt+2],Tt=M[bt+3],Xt=M[bt+4],kn=Ct-Ye,Tn=kn===0?It-it:It,Zt=5*dt;He[Zt+0]=kn,He[Zt+1]=Tn,He[Zt+2]=Pt,He[Zt+3]=Tt,He[Zt+4]=Xt,Ye=Ct,it=It}return He}build(M){return this._dataIsSortedAndDeltaEncoded?new xt(new Uint32Array(this._data),M):new xt(Ut._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Ut;class xt{constructor(M,ne){this.resultId=ne,this.data=M}}e.SemanticTokens=xt;class mn{constructor(M,ne,Ee){this.start=M,this.deleteCount=ne,this.data=Ee}}e.SemanticTokensEdit=mn;class gn{constructor(M,ne){this.resultId=ne,this.edits=M}}e.SemanticTokensEdits=gn;var At;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(At=e.DebugConsoleMode||(e.DebugConsoleMode={}));var pn;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(pn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Vt=class{constructor(){}};Vt.Back={iconPath:new st("arrow-left")},Vt=je([C],Vt),e.QuickInputButtons=Vt;var vn;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(vn=e.ExtensionKind||(e.ExtensionKind={}));class _n{constructor(M,ne,Ee){this.badge=M,this.tooltip=ne,this.color=Ee}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=_n;let $t=class{constructor(M){this.kind=M}};$t=je([C],$t),e.ColorTheme=$t;var nn;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(nn=e.ColorThemeKind||(e.ColorThemeKind={}));class rn{constructor(M,ne){if(M<0)throw(0,S.illegalArgument)("start must be positive");if(ne<M)throw(0,S.illegalArgument)("end cannot be smaller than start");this._start=M,this._end=ne}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}}e.NotebookCellRange=rn;class Wt{constructor(M,ne,Ee,He,Ye,it,dt){this.editable=M,this.breakpointMargin=ne,this.hasExecutionOrder=Ee,this.statusMessage=He,this.inputCollapsed=Ye,this.outputCollapsed=it,this.custom=dt}with(M){let{editable:ne,breakpointMargin:Ee,hasExecutionOrder:He,statusMessage:Ye,inputCollapsed:it,outputCollapsed:dt,custom:bt}=M;return ne===void 0?ne=this.editable:ne===null&&(ne=void 0),Ee===void 0?Ee=this.breakpointMargin:Ee===null&&(Ee=void 0),He===void 0?He=this.hasExecutionOrder:He===null&&(He=void 0),Ye===void 0?Ye=this.statusMessage:Ye===null&&(Ye=void 0),it===void 0?it=this.inputCollapsed:it===null&&(it=void 0),dt===void 0?dt=this.outputCollapsed:dt===null&&(dt=void 0),bt===void 0?bt=this.custom:bt===null&&(bt=void 0),ne===this.editable&&Ee===this.breakpointMargin&&He===this.hasExecutionOrder&&Ye===this.statusMessage&&it===this.inputCollapsed&&dt===this.outputCollapsed&&bt===this.custom?this:new Wt(ne,Ee,He,Ye,it,dt,bt)}}e.NotebookCellMetadata=Wt;class Re{constructor(M=!0,ne=!0,Ee=!0,He={},Ye=!0){this.editable=M,this.cellEditable=ne,this.cellHasExecutionOrder=Ee,this.custom=He,this.trusted=Ye}with(M){let{editable:ne,cellEditable:Ee,cellHasExecutionOrder:He,custom:Ye,trusted:it}=M;return ne===void 0?ne=this.editable:ne===null&&(ne=void 0),Ee===void 0?Ee=this.cellEditable:Ee===null&&(Ee=void 0),He===void 0?He=this.cellHasExecutionOrder:He===null&&(He=void 0),Ye===void 0?Ye=this.custom:Ye===null&&(Ye=void 0),it===void 0?it=this.trusted:it===null&&(it=void 0),ne===this.editable&&Ee===this.cellEditable&&He===this.cellHasExecutionOrder&&Ye===this.custom&&it===this.trusted?this:new Re(ne,Ee,He,Ye,it)}}e.NotebookDocumentMetadata=Re;class Qt{constructor(M,ne,Ee,He,Ye,it){this.kind=M,this.source=ne,this.language=Ee,this.outputs=He!=null?He:[],this.metadata=Ye,this.latestExecutionSummary=it}}e.NotebookCellData=Qt;class Jt{constructor(M,ne){this.cells=M,this.metadata=ne!=null?ne:new Re}}e.NotebookData=Jt;class mt{constructor(M,ne,Ee){this.mime=M,this.value=ne,this.metadata=Ee}static isNotebookCellOutputItem(M){return M instanceof mt}}e.NotebookCellOutputItem=mt;class bn{constructor(M,ne,Ee){this.outputs=M,typeof ne=="string"?(this.id=ne,this.metadata=Ee):(this.id=(0,y.generateUuid)(),this.metadata=ne!=null?ne:Ee)}}e.NotebookCellOutput=bn;var wn;(function(O){O[O.Markdown=1]="Markdown",O[O.Code=2]="Code"})(wn=e.NotebookCellKind||(e.NotebookCellKind={}));var sn;(function(O){O[O.Idle=1]="Idle",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(sn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var on;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(on=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var En;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(En=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Yt=class{constructor(M,ne){this.label=M,this.timestamp=ne}};Yt=je([C],Yt),e.TimelineItem=Yt;var yn;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(yn=e.ExtensionMode||(e.ExtensionMode={}));var Sn;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(Sn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class Dn{constructor(M,ne){this.ranges=M,this.wordPattern=ne}}e.LinkedEditingRanges=Dn;var Cn;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(Cn=e.TestResult||(e.TestResult={}));var ln;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information",O[O.Hint=3]="Hint"})(ln=e.TestMessageSeverity||(e.TestMessageSeverity={})),e.TestItemHookProperty=Symbol("TestItemHookProperty");const jt=(O,M,ne)=>{let Ee=ne;return{enumerable:!0,configurable:!1,get(){return Ee},set(He){var Ye;(Ye=O[e.TestItemHookProperty])===null||Ye===void 0||Ye.setProp(M,He),Ee=He}}};class un{constructor(M){m.set(this,new Map),r.set(this,void 0),tt(this,r,M)}get size(){return $e(this,m).size}add(M){const ne=$e(this,m),Ee=$e(this,r).call(this),He=ne.get(M.id);He!==M&&(He&&(Ee==null||Ee.delete(M.id)),ne.set(M.id,M),Ee==null||Ee.created(M))}get(M){return $e(this,m).get(M)}clear(){for(const M of $e(this,m).keys())this.delete(M)}delete(M){var ne;const Ee=typeof M=="string"?M:M.id;$e(this,m).has(Ee)&&($e(this,m).delete(Ee),(ne=$e(this,r).call(this))===null||ne===void 0||ne.delete(Ee))}toJSON(){return[...$e(this,m).values()]}[(m=new WeakMap,r=new WeakMap,Symbol.iterator)](){return $e(this,m).values()}}e.TestChildrenCollection=un;class X{constructor(M,ne,Ee){this.label=ne,this.expandable=Ee,Object.defineProperties(this,{id:{value:M,enumerable:!0,writable:!1},children:{value:new un(()=>this[e.TestItemHookProperty]),enumerable:!0,writable:!1},[e.TestItemHookProperty]:{enumerable:!1,writable:!0,configurable:!1},location:jt(this,"location",void 0),description:jt(this,"description",void 0),runnable:jt(this,"runnable",!0),debuggable:jt(this,"debuggable",!0)})}invalidate(){var M;(M=this[e.TestItemHookProperty])===null||M===void 0||M.invalidate(this.id)}discoverChildren(M,ne){M.report({busy:!1})}}e.TestItem=X;class de{constructor(M){this.state=M,this.messages=[]}}e.TestState=de;class ke{constructor(M){this.message=M,this.severity=ln.Error}static diff(M,ne,Ee){const He=new ke(M);return He.expectedOutput=ne,He.actualOutput=Ee,He}}e.TestMessage=ke;var lt;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(lt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var _t;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unknown=2]="Unknown"})(_t=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var St;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore"})(St=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(be[94],we([0,1,43,16,8,118,83,7,15]),function(ae,e,E,S,R,A,D,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function T(r,d){d?n.set(r,d):n.delete(r)}e.setWordDefinitionFor=T;function k(r){return n.get(r)}e.getWordDefinitionFor=k;class b extends A.MirrorTextModel{constructor(d,_,g,w,u,c,s,t){super(_,g,w,u);this._proxy=d,this._languageId=c,this._isDirty=s,this._notebook=t,this._isDisposed=!1}dispose(){(0,E.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,y.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===S.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(_){return _?d._getTextInRange(_):d.getText()},get eol(){return d._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(_){return d._lineAt(_)},offsetAt(_){return d._offsetAt(_)},positionAt(_){return d._positionAt(_)},validateRange(_){return d._validateRange(_)},validatePosition(_){return d._validatePosition(_)},getWordRangeAtPosition(_,g){return d._getWordRangeAtPosition(_,g)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,E.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,E.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const _=this._validateRange(d);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const g=this._eol,w=_.start.line,u=_.end.line,c=[];c.push(this._lines[w].substring(_.start.character));for(let s=w+1;s<u;s++)c.push(this._lines[s]);return c.push(this._lines[u].substring(0,_.end.character)),c.join(g)}_lineAt(d){let _;if(d instanceof I.Position?_=d.line:typeof d=="number"&&(_=d),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new m(_,this._lines[_],_===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(d),g=this._lines[_.index].length;return new I.Position(_.index,Math.min(_.remainder,g))}_validateRange(d){if(!(d instanceof I.Range))throw new Error("Invalid argument");const _=this._validatePosition(d.start),g=this._validatePosition(d.end);return _===d.start&&g===d.end?d:new I.Range(_.line,_.character,g.line,g.character)}_validatePosition(d){if(!(d instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:_,character:g}=d,w=!1;if(_<0)_=0,g=0,w=!0;else if(_>=this._lines.length)_=this._lines.length-1,g=this._lines[_].length,w=!0;else{const u=this._lines[_].length;g<0?(g=0,w=!0):g>u&&(g=u,w=!0)}return w?new I.Position(_,g):d}_getWordRangeAtPosition(d,_){const g=this._validatePosition(d);if(!_)_=k(this._languageId);else if((0,R.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const w=(0,D.getWordAtText)(g.character+1,(0,D.ensureValidWordDefinition)(_),this._lines[g.line],0);if(w)return new I.Range(g.line,w.startColumn-1,g.line,w.endColumn-1)}}e.ExtHostDocumentData=b;class m{constructor(d,_,g){this._line=d,this._text=_,this._isLastLine=g}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(be[160],we([0,1,7,3,85,6,59,22,2,29]),function(ae,e,E,S,R,A,D,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class T{constructor(b,m,r,d){this._notebook=r,this._selector=d,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(g=>{const w=this._cellUris.get(g.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=g=>{g===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(b.onDidChangeNotebookCells(g=>_(g.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const b=[],m=[];for(const r of this._notebook.cells)r.kind===E.NotebookCellKind.Code&&(!this._selector||(0,D.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),b.push(r.document.getText().length+1),m.push(r.document.lineCount));this._cellLengths=new R.PrefixSumComputer(new Uint32Array(b)),this._cellLines=new R.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(b){var m,r;if(!b){let u="";for(const c of this._cells)u+=c.document.getText()+`
`;return u=u.slice(0,-1),u}if(b.isEmpty)return"";const d=this.locationAt(b.start),_=this.locationAt(b.end),g=this._cells[(m=this._cellUris.get(d.uri))!==null&&m!==void 0?m:-1],w=this._cells[(r=this._cellUris.get(_.uri))!==null&&r!==void 0?r:-1];if(!g||!w)return"";if(g===w)return g.document.getText(new E.Range(d.range.start,_.range.end));{const u=g.document.getText(new E.Range(d.range.start,new E.Position(g.document.lineCount,0))),c=w.document.getText(new E.Range(new E.Position(0,0),_.range.end));return u+`
`+c}}offsetAt(b){const m=this._cellLines.getIndexOf(b.line),r=this._cellLengths.getAccumulatedValue(m.index-1),d=this._cells[m.index].document.offsetAt(b.with(m.remainder));return r+d}positionAt(b){if(typeof b=="number"){const r=this._cellLengths.getIndexOf(b),d=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(d)}const m=this._cellUris.get(b.uri);if(m!==void 0){const r=this._cellLines.getAccumulatedValue(m-1);return new E.Position(r+b.range.start.line,b.range.start.character)}return new E.Position(0,0)}locationAt(b){E.Range.isRange(b)||(b=new E.Range(b,b));const m=this._cellLines.getIndexOf(b.start.line);let r=m;b.isEmpty||(r=this._cellLines.getIndexOf(b.end.line));const d=new E.Position(m.remainder,b.start.character),_=new E.Position(r.remainder,b.end.character),g=new E.Range(d,_),w=this._cells[m.index];return new E.Location(w.document.uri,w.document.validateRange(g))}contains(b){return this._cellUris.has(b)}validateRange(b){const m=this.validatePosition(b.start),r=this.validatePosition(b.end);return b.with(m,r)}validatePosition(b){const m=this._cellLines.getIndexOf(b.line),r=new E.Position(m.remainder,b.character),d=this._cells[m.index].document.validatePosition(r),_=this._cellLines.getAccumulatedValue(m.index-1);return new E.Position(_+d.line,d.character)}}e.ExtHostNotebookConcatDocument=T}),define(be[161],we([0,1,7,14,3]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(I){this._actual=new E.ColorTheme(E.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new R.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let y=I==="light"?E.ColorThemeKind.Light:I==="dark"?E.ColorThemeKind.Dark:E.ColorThemeKind.HighContrast;this._actual=new E.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=je([Ke(0,S.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[68],we([0,1,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,E.createDecorator)("IURITransformerService");class S{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=S}),define(be[69],we([0,1,2]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function S(A,D,I){const y=A.webviewResourceRoot.replace("{{resource}}",I.scheme+R(I)).replace("{{uuid}}",D);return E.URI.parse(y)}e.asWebviewUri=S;function R(A){return A.toString().replace(/^\S+?:/,"")}}),define(be[162],we([0,1,3,6,69,29]),function(ae,e,E,S,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class D{constructor(y,n,T){this._proxy=y,this._editors=n,this._initData=T,this._handlePool=0,this._disposables=new S.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const k=n.getVisibleTextEditors();for(const b of this._insets.values())k.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,n,T,k,b){let m;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===y){m=c;break}if(!m)throw new Error("not a visible editor");const r=this,d=this._handlePool++,_=new E.Emitter,g=new E.Emitter,w=new class{constructor(){this._uuid=(0,A.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,R.asWebviewUri)(r._initData,this._uuid,c)}get cspSource(){return r._initData.webviewCspSource}set options(c){this._options=c,r._proxy.$setOptions(d,c)}get options(){return this._options}set html(c){this._html=c,r._proxy.$setHtml(d,c)}get html(){return this._html}get onDidReceiveMessage(){return _.event}postMessage(c){return r._proxy.$postMessage(d,c)}},u=new class{constructor(){this.editor=y,this.line=n,this.height=T,this.webview=w,this.onDidDispose=g.event}dispose(){r._insets.has(d)&&(r._insets.delete(d),r._proxy.$disposeEditorInset(d),g.fire(),g.dispose(),_.dispose())}};return this._proxy.$createEditorInset(d,m.id,m.value.document.uri,n+1,T,k||{},b.identifier,b.extensionLocation),this._insets.set(d,{editor:y,inset:u,onDidReceiveMessage:_}),u}$onDidDispose(y){const n=this._insets.get(y);n&&n.inset.dispose()}$onDidReceiveMessage(y,n){const T=this._insets.get(y);T&&T.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=D}),define(be[163],we([0,1,3,63,136,4,6,22,30,15,50,23,37,155]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",b.Codicon.window,(0,R.localize)(0,null));var r;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var d;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(d=e.ViewContainerLocation||(e.ViewContainerLocation={}));function _(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=_;function g(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=g;class w extends D.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new E.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new E.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(f,v,C){var h;const p=this.get(f.id);if(p)return p;const P=f;return P.openCommandActionDescriptor=(C==null?void 0:C.donotRegisterOpenCommand)?void 0:(h=P.openCommandActionDescriptor)!==null&&h!==void 0?h:{id:P.id},(0,I.getOrSet)(this.viewContainers,v,[]).push(P),(C==null?void 0:C.isDefault)&&this.defaultViewContainers.push(P),this._onDidRegister.fire({viewContainer:P,viewContainerLocation:v}),P}deregisterViewContainer(f){for(const v of this.viewContainers.keys()){const C=this.viewContainers.get(v),h=C==null?void 0:C.indexOf(f);if(h!==-1){C==null||C.splice(h,1),C.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:f,viewContainerLocation:v});return}}}get(f){return this.all.filter(v=>v.id===f)[0]}getViewContainers(f){return[...this.viewContainers.get(f)||[]]}getViewContainerLocation(f){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(C=>(C==null?void 0:C.id)===f.id).length>0)[0]}getDefaultViewContainer(f){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===f)}}y.Registry.add(r.ViewContainersRegistry,new w);var u;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function c(a,f){var v,C,h,p;const P=(v=a.group)!==null&&v!==void 0?v:u.More,F=(C=f.group)!==null&&C!==void 0?C:u.More;return P!==F?P.localeCompare(F):((h=a.order)!==null&&h!==void 0?h:5)-((p=f.order)!==null&&p!==void 0?p:5)}class s extends D.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new E.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new E.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new E.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new E.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new T.SetMap}registerViews(f,v){this.registerViews2([{views:f,viewContainer:v}])}registerViews2(f){f.forEach(({views:v,viewContainer:C})=>this.addViews(v,C)),this._onViewsRegistered.fire(f)}deregisterViews(f,v){const C=this.removeViews(f,v);C.length&&this._onViewsDeregistered.fire({views:C,viewContainer:v})}moveViews(f,v){for(const C of this._views.keys())if(C!==v){const h=this.removeViews(f,C);h.length&&(this.addViews(h,v),this._onDidChangeContainer.fire({views:h,from:C,to:v}))}}getViews(f){return this._views.get(f)||[]}getView(f){for(const v of this._viewContainers){const C=(this._views.get(v)||[]).filter(h=>h.id===f)[0];if(C)return C}return null}getViewContainer(f){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(h=>h.id===f)[0])return v;return null}registerViewWelcomeContent(f,v){return this._viewWelcomeContents.add(f,v),this._onDidChangeViewWelcomeContent.fire(f),(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(f,v),this._onDidChangeViewWelcomeContent.fire(f)})}registerViewWelcomeContent2(f,v){const C=new Map;for(const[h,p]of v)this._viewWelcomeContents.add(f,p),C.set(h,(0,D.toDisposable)(()=>{this._viewWelcomeContents.delete(f,p),this._onDidChangeViewWelcomeContent.fire(f)}));return this._onDidChangeViewWelcomeContent.fire(f),C}getViewWelcomeContent(f){const v=[];return this._viewWelcomeContents.forEach(f,C=>v.push(C)),v.sort(c)}addViews(f,v){let C=this._views.get(v);C||(C=[],this._views.set(v,C),this._viewContainers.push(v));for(const h of f){if(this.getView(h.id)!==null)throw new Error((0,R.localize)(1,null,h.id));C.push(h)}}removeViews(f,v){const C=this._views.get(v);if(!C)return[];const h=[],p=[];for(const P of C)f.includes(P)?h.push(P):p.push(P);return h.length&&(p.length?this._views.set(v,p):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),h}}y.Registry.add(r.ViewsRegistry,new s),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new S.RawContextKey("focusedView","",(0,R.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var i;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var l;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(l=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(f,v){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,f),this._hasResolve=!!v,this.resolve=async C=>{var h,p;if(v&&!this.resolved){const P=await v(C);P&&(this.tooltip=(h=this.tooltip)!==null&&h!==void 0?h:P.tooltip,this.command=(p=this.command)!==null&&p!==void 0?p:P.command)}C.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o}),define(be[164],we([0,1,2,145,156,19,146,163]),function(ae,e,E,S,R,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(d){return(_,...g)=>d(_.get(S.ICommandService),...g)}class n{static execute(_,g){const w={forceReuseWindow:g&&g.reuseWindow,remoteAuthority:g&&g.remoteAuthority};return _.executeCommand("_files.newWindow",w)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",S.CommandsRegistry.registerCommand({id:n.ID,handler:y(n.execute),description:{description:"Opens an new window",args:[]}}),S.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(d,_){return d.get(R.IWorkspacesService).removeRecentlyOpened([_])});class T{static execute(_,g){return typeof g=="string"?g=g.match(/^[^:/?#]+:\/\//)?E.URI.parse(g):E.URI.file(g):g=E.URI.revive(g),_.executeCommand("_workbench.removeFromRecentlyOpened",g)}}e.RemoveFromRecentlyOpenedAPICommand=T,T.ID="vscode.removeFromRecentlyOpened",S.CommandsRegistry.registerCommand(T.ID,y(T.execute));class k{static execute(_,g){const w=typeof g=="string"?{extensionId:g}:g;return _.executeCommand("workbench.action.openIssueReporter",w)}}e.OpenIssueReporter=k,k.ID="vscode.openIssueReporter",S.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(d,_){const g=d.get(R.IWorkspacesService);let w;const u=_.uri,c=_.label,s=_.remoteAuthority;return _.type==="workspace"?w={workspace:await g.getWorkspaceIdentifier(u),label:c,remoteAuthority:s}:_.type==="folder"?w={folderUri:u,label:c,remoteAuthority:s}:w={fileUri:u,label:c,remoteAuthority:s},g.addRecentlyOpened([w])}),S.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(d){return d.get(R.IWorkspacesService).getRecentlyOpened()}),S.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(d,_){const g=d.get(A.ILogService),w=d.get(D.IEnvironmentService);w.isExtensionDevelopment&&!!w.extensionTestsLocationURI&&g.setLevel(_)}),S.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(d){return d.get(A.ILogService).getLevel()}),S.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(d,_){const g=d.get(I.IViewDescriptorService),w=g.getViewContainerById(_.destinationId);if(!!w){for(const u of _.viewIds){const c=g.getViewDescriptorById(u);(c==null?void 0:c.canMoveView)&&g.moveViewsToContainer([c],w,I.ViewVisibilityState.Default)}await d.get(I.IViewsService).openViewContainer(w.id,!0)}});class b{static execute(_,g){return!Array.isArray(g==null?void 0:g.viewIds)||typeof(g==null?void 0:g.destinationId)!="string"?Promise.reject("Invalid arguments"):_.executeCommand("_workbench.action.moveViews",g)}}e.MoveViewsAPICommand=b,b.ID="vscode.moveViews",S.CommandsRegistry.registerCommand({id:b.ID,handler:y(b.execute),description:{description:"Move Views",args:[]}});class m{static execute(_,g){return _.executeCommand("_workbench.open",g)}}m.ID="vscode.open",S.CommandsRegistry.registerCommand(m.ID,y(m.execute));class r{static execute(_,g,w,u,c){return _.executeCommand("_workbench.diff",[g,w,u])}}r.ID="vscode.diff",S.CommandsRegistry.registerCommand(r.ID,y(r.execute))}),define(be[165],we([0,1,3,13,137]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new E.Emitter,this._onExit=new E.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,y,n,T){const k={command:I};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.internalSend("request",k),typeof T=="number"){const b=setTimeout(()=>{clearTimeout(b);const m=this.pendingRequests.get(k.seq);if(m){this.pendingRequests.delete(k.seq);const r={type:"response",seq:0,request_seq:k.seq,success:!1,command:I,message:(0,R.localize)(0,null,T,I)};m(r)}},T)}return n&&this.pendingRequests.set(k.seq,n),k.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,y){return I.type!=="event"||y.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,S.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const y=I,n=this.pendingRequests.get(y.request_seq);n&&(this.pendingRequests.delete(y.request_seq),n(y));break}}}internalSend(I,y){y.type=I,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((y,n)=>I.set(n,y)),await(0,S.timeout)(500),I.forEach((y,n)=>{y({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[166],we([0,1,8,2,11,23,16]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function y(i,l,o){return i.replace(I,function(a,f){return l&&f.length>0&&f[0]!=="_"?a:o&&o.hasOwnProperty(f)?o[f]:a})}e.formatPII=y;function n(i){const l={};for(const o of Object.keys(i))o.startsWith("!")||(l[o]=i[o]);return l}e.filterExceptionsFromTelemetry=n;function T(i){return i.configuration.request==="attach"&&!k(i)}e.isSessionAttach=T;function k(i){let l=i.configuration.type;if(!!l)return l==="vslsShare"&&(l=i.configuration.adapterProxy.configuration.type),(0,E.equalsIgnoreCase)(l,"extensionhost")||(0,E.equalsIgnoreCase)(l,"pwa-extensionhost")?i:i.parentSession?k(i.parentSession):void 0}e.getExtensionHostDebugSession=k;function b(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=b;function m(i,l,o){let a,f=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,C=null;for(;C=v.exec(i);){let h=C.index+1,p=h+C[0].length;if(h<=l&&p>=o){a=C[0],f=h;break}}if(a){let h=/\w+/g,p=null;for(;(p=h.exec(a))&&!(p.index+1+f+p[0].length>=o););p&&(a=a.substring(0,h.lastIndex))}return a?{start:f,end:f+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(i){return!!(i&&i.match(r))}e.isUri=d;function _(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(d(i.path))return S.URI.parse(i.path);if((0,R.isAbsolute)(i.path))return S.URI.file(i.path)}return i.path}function g(i){if(typeof i.path=="object"){const l=S.URI.revive(i.path);if(l)return l.scheme===D.Schemas.file?l.fsPath:l.toString()}return i.path}function w(i,l){const o=l?_:g,a=(0,A.deepClone)(i);return c(a,(f,v)=>{f&&v&&(v.path=o(v))}),a}e.convertToDAPaths=w;function u(i,l){const o=l?_:g,a=(0,A.deepClone)(i);return c(a,(f,v)=>{!f&&v&&(v.path=o(v))}),a}e.convertToVSCPaths=u;function c(i,l){switch(i.type){case"event":const o=i;switch(o.event){case"output":l(!1,o.body.source);break;case"loadedSource":l(!1,o.body.source);break;case"breakpoint":l(!1,o.body.breakpoint.source);break;default:break}break;case"request":const a=i;switch(a.command){case"setBreakpoints":l(!0,a.arguments.source);break;case"breakpointLocations":l(!0,a.arguments.source);break;case"source":l(!0,a.arguments.source);break;case"gotoTargets":l(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(v=>l(!1,v));break;default:break}break;case"response":const f=i;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(v=>l(!1,v.source));break;case"loadedSources":f.body.sources.forEach(v=>l(!1,v));break;case"scopes":f.body.scopes.forEach(v=>l(!1,v.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(v=>l(!1,v.source));break;case"setBreakpoints":f.body.breakpoints.forEach(v=>l(!1,v.source));break;default:break}break}}function s(i){return i.filter(l=>{var o;return!((o=l.presentation)===null||o===void 0?void 0:o.hidden)}).sort((l,o)=>l.presentation?o.presentation?l.presentation.group?o.presentation.group?l.presentation.group!==o.presentation.group?l.presentation.group.localeCompare(o.presentation.group):t(l.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(l.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=s;function t(i,l){return typeof i!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:i-l}}),define(be[70],we([0,1,28,16,11,21,63]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var I;(function(P){P[P.Markdown=1]="Markdown",P[P.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(P){P[P.Running=1]="Running",P[P.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},trusted:!0};var n;(function(P){P[P.Idle=1]="Idle",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(P){P[P.ModelChange=1]="ModelChange",P[P.Move=2]="Move",P[P.CellClearOutput=3]="CellClearOutput",P[P.CellsClearOutput=4]="CellsClearOutput",P[P.ChangeLanguage=5]="ChangeLanguage",P[P.Initialize=6]="Initialize",P[P.ChangeCellMetadata=7]="ChangeCellMetadata",P[P.Output=8]="Output",P[P.OutputItem=9]="OutputItem",P[P.ChangeCellContent=10]="ChangeCellContent",P[P.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",P[P.Unknown=12]="Unknown"})(T=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var k;(function(P){P[P.Handle=0]="Handle",P[P.Index=1]="Index"})(k=e.SelectionStateType||(e.SelectionStateType={}));var b;(function(P){P[P.Replace=1]="Replace",P[P.Output=2]="Output",P[P.Metadata=3]="Metadata",P[P.CellLanguage=4]="CellLanguage",P[P.DocumentMetadata=5]="DocumentMetadata",P[P.OutputsSplice=6]="OutputsSplice",P[P.Move=7]="Move",P[P.Unknown=8]="Unknown",P[P.CellContent=9]="CellContent",P[P.OutputItems=10]="OutputItems",P[P.PartialMetadata=11]="PartialMetadata"})(b=e.CellEditType||(e.CellEditType={}));function m(P){const F=r.parse(P);return F?F.notebook.toString():P.toString()}e.getCellUndoRedoComparisonKey=m;var r;(function(P){P.scheme=S.Schemas.vscodeNotebookCell;const F=/^ch(\d{7,})/;function z(G,L){return G.with({scheme:P.scheme,fragment:`ch${L.toString().padStart(7,"0")}${G.scheme!==S.Schemas.file?G.scheme:""}`})}P.generate=z;function le(G){if(G.scheme===P.scheme){const L=F.exec(G.fragment);if(!!L)return{handle:Number(L[1]),notebook:G.with({scheme:G.fragment.substr(L[0].length)||S.Schemas.file,fragment:null})}}}P.parse=le;function H(G,L){return G.with({scheme:S.Schemas.vscodeNotebookCellMetadata,fragment:`ch${L.toString().padStart(7,"0")}${G.scheme!==S.Schemas.file?G.scheme:""}`})}P.generateCellMetadataUri=H;function W(G){if(G.scheme===S.Schemas.vscodeNotebookCellMetadata){const L=F.exec(G.fragment);if(!!L)return{handle:Number(L[1]),notebook:G.with({scheme:G.fragment.substr(L[0].length)||S.Schemas.file,fragment:null})}}}P.parseCellMetadataUri=W})(r=e.CellUri||(e.CellUri={}));const d=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function _(P){var F,z;return(z=(F=d.get(P))===null||F===void 0?void 0:F.alwaysSecure)!==null&&z!==void 0?z:!1}e.mimeTypeIsAlwaysSecure=_;function g(P){var F,z;return(z=(F=d.get(P))===null||F===void 0?void 0:F.supportedByCore)!==null&&z!==void 0?z:!1}e.mimeTypeSupportedByCore=g;function w(P){var F,z;return(z=(F=d.get(P))===null||F===void 0?void 0:F.mergeable)!==null&&z!==void 0?z:!1}e.mimeTypeIsMergeable=w;function u(P,F){return A.isWindows&&(P=P.replace(/\//g,"\\"),F=F.replace(/\//g,"\\")),E.match(P,F)}function c(P,F,z){let le=0;for(let H=0;H<F.length;H++){if(u(F[H],P))return le;le++}for(let H=0;H<z.length;H++){if(u(z[H],P))return le;le++}return le}function s(P,F,z){return P.sort((le,H)=>c(le,F,z)-c(H,F,z))}e.sortMimeTypes=s;function t(P,F,z,le=(H,W)=>H===W){const H=[];function W(U,x,Q){if(!(x===0&&Q.length===0)){const $=H[H.length-1];$&&$.start+$.deleteCount===U?($.deleteCount+=x,$.toInsert.push(...Q)):H.push({start:U,deleteCount:x,toInsert:Q})}}let G=0,L=0;for(;;){if(G===P.length){W(G,0,F.slice(L));break}if(L===F.length){W(G,P.length-G,[]);break}const U=P[G],x=F[L];if(le(U,x)){G+=1,L+=1;continue}z(x)?(W(G,1,[]),G+=1):(W(G,0,[x]),L+=1)}return H}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new D.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var i;(function(P){P.default="default",P.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(P){const F=P;return!!((typeof F.include=="string"||E.isRelativePattern(F.include))&&(typeof F.exclude=="string"||E.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=l;function o(P,F,z){if(Array.isArray(P.viewType)&&P.viewType.indexOf(F)>=0||P.viewType===F)return!0;if(P.filenamePattern){let le=l(P.filenamePattern)?P.filenamePattern.include:P.filenamePattern,H=l(P.filenamePattern)?P.filenamePattern.exclude:void 0;if(E.match(le,(0,R.basename)(z.fsPath).toLowerCase()))return!(H&&E.match(H,(0,R.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class a{constructor(F){this.textModel=F}getElements(){const F=new Int32Array(this.textModel.cells.length);for(let z=0;z<this.textModel.cells.length;z++)F[z]=this.textModel.cells[z].getHashValue();return F}}e.CellSequence=a,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var f;(function(P){P[P.LEFT=0]="LEFT",P[P.RIGHT=1]="RIGHT"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function v(P){P.sort((z,le)=>z-le);const F=P.shift();return F===void 0?[]:P.reduce(function(z,le){return le<=z[0][1]?z[0][1]=le+1:z.unshift([le,le+1]),z},[[F,F+1]]).reverse().map(z=>({start:z[0],end:z[1]}))}e.cellIndexesToRanges=v;function C(P){return P.reduce((z,le)=>{for(let H=le.start;H<le.end;H++)z.push(H);return z},[])}e.cellRangesToIndexes=C;function h(P){const F=P.sort((le,H)=>le.start-H.start),z=F[0];return z?F.reduce((le,H)=>{const W=le[le.length-1];return W.end>=H.start?W.end=Math.max(W.end,H.end):le.push(H),le},[z]):[]}e.reduceRanges=h;function p(P,F){return F.start>=P.start&&F.end<=P.end}e.cellRangeContains=p}),define(be[167],we([0,1,139,4,63]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new R.RawContextKey("customExecutionSupported",!0,E.localize(0,null)),e.ShellExecutionSupportedContext=new R.RawContextKey("shellExecutionSupported",!1,E.localize(1,null)),e.ProcessExecutionSupportedContext=new R.RawContextKey("processExecutionSupported",!1,E.localize(2,null)),e.ITaskService=(0,S.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[168],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(R){return[...R.entries()]}e.serializeEnvironmentVariableCollection=E;function S(R){return new Map(R)}e.deserializeEnvironmentVariableCollection=S}),define(be[95],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var E;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));const S=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&Object.assign(y.item,n.item)};e.applyTestItemUpdate=S;var R;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.DeltaRootsComplete=3]="DeltaRootsComplete",y[y.Retire=4]="Retire"})(R=e.TestDiffOpType||(e.TestDiffOpType={}));const A=(y,n)=>`${y}:${n.toString()}`;e.getTestSubscriptionKey=A;class D{add(n){}update(n){}remove(n,T){}complete(){}}e.IncrementalChangeCollector=D;class I{constructor(){this.items=new Map,this.roots=new Set,this.busyProviderCount=0,this.pendingRootCount=0}apply(n){const T=this.createChangeCollector();for(const k of n)switch(k[0]){case 0:{const b=k[1];if(b.parent){if(this.items.has(b.parent)){const m=this.items.get(b.parent);m.children.add(b.item.extId);const r=this.createItem(b,m);this.items.set(b.item.extId,r),T.add(r)}}else{this.roots.add(b.item.extId);const m=this.createItem(b);this.items.set(b.item.extId,m),T.add(m)}b.expand===2&&this.updateBusyProviders(1);break}case 1:{const b=k[1],m=this.items.get(b.extId);if(!m)break;(0,e.applyTestItemUpdate)(m,b),T.update(m),b.expand!==void 0&&m.expand===2&&b.expand!==2&&this.updateBusyProviders(-1);break}case 2:{const b=this.items.get(k[1]);if(!b)break;b.parent?this.items.get(b.parent).children.delete(b.item.extId):this.roots.delete(b.item.extId);const m=[[k[1]]];for(;m.length;)for(const r of m.pop()){const d=this.items.get(r);d&&(m.push(d.children),this.items.delete(r),T.remove(d,d!==b),d.expand===2&&this.updateBusyProviders(-1))}break}case 4:this.retireTest(k[1]);break;case 3:this.updatePendingRoots(k[1]);break}T.complete()}retireTest(n){}updateBusyProviders(n){this.busyProviderCount+=n}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=I}),define(be[169],we([0,1,11,32,12,23,21,58,140]),function(ae,e,E,S,R,A,D,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(k,b,m){if(this._contributedVariables=new Map,this._context=k,this._labelService=b,m)if(D.isWindows){const r=Object.create(null);this._envVariables=r,Object.keys(m).forEach(d=>{r[d.toLowerCase()]=m[d]})}else this._envVariables=m}resolve(k,b){return this.recursiveResolve(k?k.uri:void 0,b)}resolveAnyBase(k,b,m,r){const d=A.deepClone(b);return D.isWindows&&d.windows?Object.keys(d.windows).forEach(_=>d[_]=d.windows[_]):D.isMacintosh&&d.osx?Object.keys(d.osx).forEach(_=>d[_]=d.osx[_]):D.isLinux&&d.linux&&Object.keys(d.linux).forEach(_=>d[_]=d.linux[_]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(k?k.uri:void 0,d,m,r)}resolveAny(k,b,m){return this.resolveAnyBase(k,b,m)}resolveAnyMap(k,b,m){const r=new Map;return{newConfig:this.resolveAnyBase(k,b,m,r),resolvedVariables:r}}resolveWithInteractionReplace(k,b,m,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,b,m,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,b){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,b)}recursiveResolve(k,b,m,r){if(R.isString(b))return this.resolveString(k,b,m,r);if(R.isArray(b))return b.map(d=>this.recursiveResolve(k,d,m,r));if(R.isObject(b)){let d=Object.create(null);return Object.keys(b).forEach(_=>{const g=this.resolveString(k,_,m,r);d[g]=this.recursiveResolve(k,b[_],m,r)}),d}return b}resolveString(k,b,m,r){return b.replace(n.VARIABLE_REGEXP,(_,g)=>{if(g.includes(n.VARIABLE_LHS))return _;let w=this.evaluateSingleVariable(_,g,k,m);return r&&r.set(g,w),w})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,b,m,r){let d;const _=b.split(":");_.length>1&&(b=_[0],d=_[1]);const g=()=>{const c=this._context.getFilePath();if(c)return c;throw new Error((0,y.localize)(0,null,k))},w=()=>{const c=g();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error((0,y.localize)(1,null,k,E.basename(c)))},u=()=>{if(d){const c=this._context.getFolderUri(d);if(c)return c;throw new Error((0,y.localize)(2,null,k,d))}if(m)return m;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,k)):new Error((0,y.localize)(4,null,k))};switch(b){case"env":if(d){if(this._envVariables){const c=this._envVariables[D.isWindows?d.toLowerCase():d];if(R.isString(c))return c}return""}throw new Error((0,y.localize)(5,null,k));case"config":if(d){const c=this._context.getConfigurationValue(m,d);if(R.isUndefinedOrNull(c))throw new Error((0,y.localize)(6,null,k,d));if(R.isObject(c))throw new Error((0,y.localize)(7,null,k,d));return c}throw new Error((0,y.localize)(8,null,k));case"command":return this.resolveFromMap(k,d,r,"command");case"input":return this.resolveFromMap(k,d,r,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return m||d?(0,I.normalizeDriveLetter)(this.fsPath(u())):S.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return E.basename(this.fsPath(u()));case"lineNumber":const c=this._context.getLineNumber();if(c)return c;throw new Error((0,y.localize)(9,null,k));case"selectedText":const s=this._context.getSelectedText();if(s)return s;throw new Error((0,y.localize)(10,null,k));case"file":return g();case"fileWorkspaceFolder":return w();case"relativeFile":return m||d?E.relative(this.fsPath(u()),g()):g();case"relativeFileDirname":const t=E.dirname(g());if(m||d){const a=E.relative(this.fsPath(u()),t);return a.length===0?".":a}return t;case"fileDirname":return E.dirname(g());case"fileExtname":return E.extname(g());case"fileBasename":return E.basename(g());case"fileBasenameNoExtension":const i=E.basename(g());return i.slice(0,i.length-E.extname(i).length);case"fileDirnameBasename":return E.basename(E.dirname(g()));case"execPath":const l=this._context.getExecPath();return l||k;case"execInstallFolder":const o=this._context.getAppRoot();return o||k;case"pathSeparator":return E.sep;default:try{const a=d?`${b}:${d}`:b;return this.resolveFromMap(k,a,r,void 0)}catch(a){return k}}}}resolveFromMap(k,b,m,r){if(b&&m){const d=r===void 0?m[b]:m[r+":"+b];if(typeof d=="string")return d;throw new Error((0,y.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[170],we([0,1,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var S;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var R;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var D;(function(b){b[b.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",b[b.EVEN=1]="EVEN",b[b.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var I;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(I=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(b){b[b.GROUP_ACTIVE=0]="GROUP_ACTIVE",b[b.GROUP_INDEX=1]="GROUP_INDEX",b[b.EDITOR_OPEN=2]="EDITOR_OPEN",b[b.EDITOR_CLOSE=3]="EDITOR_CLOSE",b[b.EDITOR_MOVE=4]="EDITOR_MOVE",b[b.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",b[b.EDITOR_LABEL=6]="EDITOR_LABEL",b[b.EDITOR_PIN=7]="EDITOR_PIN",b[b.EDITOR_STICKY=8]="EDITOR_STICKY",b[b.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var T;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function k(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(be[171],we([0,1,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(be[9],we([0,1,62,7,141,2,33,80,87,171,12,224,57,23,15,70]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(ue){function De(j){const{selectionStartLineNumber:Ae,selectionStartColumn:Te,positionLineNumber:Xe,positionColumn:Ge}=j,rt=new S.Position(Ae-1,Te-1),at=new S.Position(Xe-1,Ge-1);return new S.Selection(rt,at)}ue.to=De;function ce(j){const{anchor:Ae,active:Te}=j;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}ue.from=ce})(_=e.Selection||(e.Selection={}));var g;(function(ue){function De(j){if(!!j){const{start:Ae,end:Te}=j;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}ue.from=De;function ce(j){if(!!j){const{startLineNumber:Ae,startColumn:Te,endLineNumber:Xe,endColumn:Ge}=j;return new S.Range(Ae-1,Te-1,Xe-1,Ge-1)}}ue.to=ce})(g=e.Range||(e.Range={}));var w;(function(ue){function De(ce){switch(ce){case 1:return S.StandardTokenType.Comment;case 0:return S.StandardTokenType.Other;case 4:return S.StandardTokenType.RegEx;case 2:return S.StandardTokenType.String}}ue.to=De})(w=e.TokenType||(e.TokenType={}));var u;(function(ue){function De(j){return new S.Position(j.lineNumber-1,j.column-1)}ue.to=De;function ce(j){return{lineNumber:j.line+1,column:j.character+1}}ue.from=ce})(u=e.Position||(e.Position={}));var c;(function(ue){function De(j){switch(j){case S.DiagnosticTag.Unnecessary:return 1;case S.DiagnosticTag.Deprecated:return 2}}ue.from=De;function ce(j){switch(j){case 1:return S.DiagnosticTag.Unnecessary;case 2:return S.DiagnosticTag.Deprecated;default:return}}ue.to=ce})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(ue){function De(j){let Ae;return j.code&&((0,T.isString)(j.code)||(0,T.isNumber)(j.code)?Ae=String(j.code):Ae={value:String(j.code.value),target:j.code.target}),Object.assign(Object.assign({},g.from(j.range)),{message:j.message,source:j.source,code:Ae,severity:i.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(t.from),tags:Array.isArray(j.tags)?(0,r.coalesce)(j.tags.map(c.from)):void 0})}ue.from=De;function ce(j){var Ae;const Te=new S.Diagnostic(g.to(j),j.message,i.to(j.severity));return Te.source=j.source,Te.code=(0,T.isString)(j.code)?j.code:(Ae=j.code)===null||Ae===void 0?void 0:Ae.value,Te.relatedInformation=j.relatedInformation&&j.relatedInformation.map(t.to),Te.tags=j.tags&&(0,r.coalesce)(j.tags.map(c.to)),Te}ue.to=ce})(s=e.Diagnostic||(e.Diagnostic={}));var t;(function(ue){function De(j){return Object.assign(Object.assign({},g.from(j.location.range)),{message:j.message,resource:j.location.uri})}ue.from=De;function ce(j){return new S.DiagnosticRelatedInformation(new S.Location(j.resource,g.to(j)),j.message)}ue.to=ce})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(ue){function De(j){switch(j){case S.DiagnosticSeverity.Error:return y.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return y.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return y.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return y.MarkerSeverity.Hint}return y.MarkerSeverity.Error}ue.from=De;function ce(j){switch(j){case y.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case y.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case y.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case y.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}ue.to=ce})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(ue){function De(j){return typeof j=="number"&&j>=S.ViewColumn.One?j-1:j===S.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}ue.from=De;function ce(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=ce})(l=e.ViewColumn||(e.ViewColumn={}));function o(ue){return typeof ue.range!="undefined"}function a(ue){return ue.length===0?!0:!!o(ue[0])}e.isDecorationOptionsArr=a;var f;(function(ue){function De(Ge){return Ge.map(ue.from)}ue.fromMany=De;function ce(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function j(Ge){let rt;if(ce(Ge)){const{language:st,value:gt}=Ge;rt={value:"```"+st+`
`+gt+"\n```\n"}}else S.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const at=Object.create(null);rt.uris=at;const Qe=st=>{try{let gt=A.URI.parse(st,!0);gt=gt.with({query:Ae(gt.query,at)}),at[st]=gt}catch(gt){}return""},ut=new k.Renderer;return ut.link=Qe,ut.image=st=>Qe(I.parseHrefAndDimensions(st).href),k(rt.value,{renderer:ut}),rt}ue.from=j;function Ae(Ge,rt){if(!Ge)return Ge;let at;try{at=(0,b.parse)(Ge)}catch(ut){}if(!at)return Ge;let Qe=!1;return at=(0,m.cloneAndChange)(at,ut=>{if(A.URI.isUri(ut)){const st=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[st]=ut,Qe=!0,st}else return}),Qe?JSON.stringify(at):Ge}function Te(Ge){const rt=new S.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt}ue.to=Te;function Xe(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ue.from(Ge)}ue.fromStrict=Xe})(f=e.MarkdownString||(e.MarkdownString={}));function v(ue){return a(ue)?ue.map(De=>({range:g.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?f.fromMany(De.hoverMessage):De.hoverMessage?f.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ue.map(De=>({range:g.from(De)}))}e.fromRangeOrRangeWithMessage=v;function C(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?A.URI.file(ue):ue}e.pathOrURIToURI=C;var h;(function(ue){function De(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?C(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}ue.from=De})(h=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var p;(function(ue){function De(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?C(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?h.from(ce.before):void 0,after:ce.after?h.from(ce.after):void 0}}ue.from=De})(p=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var P;(function(ue){function De(ce){if(typeof ce=="undefined")return ce;switch(ce){case S.DecorationRangeBehavior.OpenOpen:return 0;case S.DecorationRangeBehavior.ClosedClosed:return 1;case S.DecorationRangeBehavior.OpenClosed:return 2;case S.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=De})(P=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(ue){function De(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?P.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?p.from(ce.light):void 0,dark:ce.dark?p.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?C(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?h.from(ce.before):void 0,after:ce.after?h.from(ce.after):void 0}}ue.from=De})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(ue){function De(j){return{text:j.newText,eol:j.newEol&&Y.from(j.newEol),range:g.from(j.range)}}ue.from=De;function ce(j){const Ae=new S.TextEdit(g.to(j.range),j.text);return Ae.newEol=typeof j.eol=="undefined"?void 0:Y.to(j.eol),Ae}ue.to=ce})(z=e.TextEdit||(e.TextEdit={}));var le;(function(ue){function De(j,Ae,Te){var Xe,Ge,rt;const at={edits:[]};if(j instanceof S.WorkspaceEdit)for(let Qe of j._allEntries())if(Qe._type===1)at.edits.push({_type:1,oldUri:Qe.from,newUri:Qe.to,options:Qe.options,metadata:Qe.metadata});else if(Qe._type===2){const ut=Ae==null?void 0:Ae.getDocument(Qe.uri);at.edits.push({_type:2,resource:Qe.uri,edit:z.from(Qe.edit),modelVersionId:ut==null?void 0:ut.version,metadata:Qe.metadata})}else Qe._type===3?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:(Xe=Te==null?void 0:Te.lookupNotebookDocument(Qe.uri))===null||Xe===void 0?void 0:Xe.notebookDocument.version}):Qe._type===4?(Qe.newOutputs&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:2,index:Qe.index,append:Qe.append,outputs:Qe.newOutputs.map(We.from)}}),Qe.newMetadata&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:11,index:Qe.index,metadata:Qe.newMetadata}})):Qe._type===5?at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:(Ge=Te==null?void 0:Te.lookupNotebookDocument(Qe.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(fe.from)}}):Qe._type===6&&at.edits.push({_type:3,metadata:Qe.metadata,resource:Qe.uri,edit:{editType:10,outputId:Qe.outputId,items:((rt=Qe.newOutputItems)===null||rt===void 0?void 0:rt.map(pe.from))||[],append:Qe.append}});return at}ue.from=De;function ce(j){const Ae=new S.WorkspaceEdit;for(const Te of j.edits)Te.edit?Ae.replace(A.URI.revive(Te.resource),g.to(Te.edit.range),Te.edit.text):Ae.renameFile(A.URI.revive(Te.oldUri),A.URI.revive(Te.newUri),Te.options);return Ae}ue.to=ce})(le=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(ue){const De=Object.create(null);De[S.SymbolKind.File]=0,De[S.SymbolKind.Module]=1,De[S.SymbolKind.Namespace]=2,De[S.SymbolKind.Package]=3,De[S.SymbolKind.Class]=4,De[S.SymbolKind.Method]=5,De[S.SymbolKind.Property]=6,De[S.SymbolKind.Field]=7,De[S.SymbolKind.Constructor]=8,De[S.SymbolKind.Enum]=9,De[S.SymbolKind.Interface]=10,De[S.SymbolKind.Function]=11,De[S.SymbolKind.Variable]=12,De[S.SymbolKind.Constant]=13,De[S.SymbolKind.String]=14,De[S.SymbolKind.Number]=15,De[S.SymbolKind.Boolean]=16,De[S.SymbolKind.Array]=17,De[S.SymbolKind.Object]=18,De[S.SymbolKind.Key]=19,De[S.SymbolKind.Null]=20,De[S.SymbolKind.EnumMember]=21,De[S.SymbolKind.Struct]=22,De[S.SymbolKind.Event]=23,De[S.SymbolKind.Operator]=24,De[S.SymbolKind.TypeParameter]=25;function ce(Ae){return typeof De[Ae]=="number"?De[Ae]:6}ue.from=ce;function j(Ae){for(const Te in De)if(De[Te]===Ae)return Number(Te);return S.SymbolKind.Property}ue.to=j})(H=e.SymbolKind||(e.SymbolKind={}));var W;(function(ue){function De(j){switch(j){case S.SymbolTag.Deprecated:return 1}}ue.from=De;function ce(j){switch(j){case 1:return S.SymbolTag.Deprecated}}ue.to=ce})(W=e.SymbolTag||(e.SymbolTag={}));var G;(function(ue){function De(j){return{name:j.name,kind:H.from(j.kind),tags:j.tags&&j.tags.map(W.from),containerName:j.containerName,location:$.from(j.location)}}ue.from=De;function ce(j){const Ae=new S.SymbolInformation(j.name,H.to(j.kind),j.containerName,$.to(j.location));return Ae.tags=j.tags&&j.tags.map(W.to),Ae}ue.to=ce})(G=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var L;(function(ue){function De(j){var Ae,Te;const Xe={name:j.name||"!!MISSING: name!!",detail:j.detail,range:g.from(j.range),selectionRange:g.from(j.selectionRange),kind:H.from(j.kind),tags:(Te=(Ae=j.tags)===null||Ae===void 0?void 0:Ae.map(W.from))!==null&&Te!==void 0?Te:[]};return j.children&&(Xe.children=j.children.map(De)),Xe}ue.from=De;function ce(j){const Ae=new S.DocumentSymbol(j.name,j.detail,H.to(j.kind),g.to(j.range),g.to(j.selectionRange));return(0,r.isNonEmptyArray)(j.tags)&&(Ae.tags=j.tags.map(W.to)),j.children&&(Ae.children=j.children.map(ce)),Ae}ue.to=ce})(L=e.DocumentSymbol||(e.DocumentSymbol={}));var U;(function(ue){function De(ce){const j=new S.CallHierarchyItem(H.to(ce.kind),ce.name,ce.detail||"",A.URI.revive(ce.uri),g.to(ce.range),g.to(ce.selectionRange));return j._sessionId=ce._sessionId,j._itemId=ce._itemId,j}ue.to=De})(U=e.CallHierarchyItem||(e.CallHierarchyItem={}));var x;(function(ue){function De(ce){return new S.CallHierarchyIncomingCall(U.to(ce.from),ce.fromRanges.map(j=>g.to(j)))}ue.to=De})(x=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(ue){function De(ce){return new S.CallHierarchyOutgoingCall(U.to(ce.to),ce.fromRanges.map(j=>g.to(j)))}ue.to=De})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(ue){function De(j){return{range:j.range&&g.from(j.range),uri:j.uri}}ue.from=De;function ce(j){return new S.Location(A.URI.revive(j.uri),g.to(j.range))}ue.to=ce})($=e.location||(e.location={}));var Z;(function(ue){function De(j){const Ae=j,Te=j;return{originSelectionRange:Ae.originSelectionRange?g.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Te.uri,range:g.from(Ae.targetRange?Ae.targetRange:Te.range),targetSelectionRange:Ae.targetSelectionRange?g.from(Ae.targetSelectionRange):void 0}}ue.from=De;function ce(j){return{targetUri:A.URI.revive(j.uri),targetRange:g.to(j.range),targetSelectionRange:j.targetSelectionRange?g.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?g.to(j.originSelectionRange):void 0}}ue.to=ce})(Z=e.DefinitionLink||(e.DefinitionLink={}));var ie;(function(ue){function De(j){return{range:g.from(j.range),contents:f.fromMany(j.contents)}}ue.from=De;function ce(j){return new S.Hover(j.contents.map(f.to),g.to(j.range))}ue.to=ce})(ie=e.Hover||(e.Hover={}));var re;(function(ue){function De(j){return{range:g.from(j.range),expression:j.expression}}ue.from=De;function ce(j){return new S.EvaluatableExpression(g.to(j.range),j.expression)}ue.to=ce})(re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(ue){function De(j){if(j instanceof S.InlineValueText)return{type:"text",range:g.from(j.range),text:j.text};if(j instanceof S.InlineValueVariableLookup)return{type:"variable",range:g.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=De;function ce(j){switch(j.type){case"text":return{range:g.to(j.range),text:j.text};case"variable":return{range:g.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:g.to(j.range),expression:j.expression}}}ue.to=ce})(ye=e.InlineValue||(e.InlineValue={}));var Ie;(function(ue){function De(j){return{frameId:j.frameId,stoppedLocation:g.from(j.stoppedLocation)}}ue.from=De;function ce(j){return new S.InlineValueContext(j.frameId,g.to(j.stoppedLocation))}ue.to=ce})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Ue;(function(ue){function De(j){return{range:g.from(j.range),kind:j.kind}}ue.from=De;function ce(j){return new S.DocumentHighlight(g.to(j.range),j.kind)}ue.to=ce})(Ue=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(ue){function De(ce){switch(ce){case 1:return S.CompletionTriggerKind.TriggerCharacter;case 2:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return S.CompletionTriggerKind.Invoke}}ue.to=De})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(ue){function De(ce){return{triggerKind:Fe.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}ue.to=De})(ze=e.CompletionContext||(e.CompletionContext={}));var N;(function(ue){function De(j){switch(j){case S.CompletionItemTag.Deprecated:return 1}}ue.from=De;function ce(j){switch(j){case 1:return S.CompletionItemTag.Deprecated}}ue.to=ce})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var K;(function(ue){const De=new Map([[S.CompletionItemKind.Method,0],[S.CompletionItemKind.Function,1],[S.CompletionItemKind.Constructor,2],[S.CompletionItemKind.Field,3],[S.CompletionItemKind.Variable,4],[S.CompletionItemKind.Class,5],[S.CompletionItemKind.Interface,7],[S.CompletionItemKind.Struct,6],[S.CompletionItemKind.Module,8],[S.CompletionItemKind.Property,9],[S.CompletionItemKind.Unit,12],[S.CompletionItemKind.Value,13],[S.CompletionItemKind.Constant,14],[S.CompletionItemKind.Enum,15],[S.CompletionItemKind.EnumMember,16],[S.CompletionItemKind.Keyword,17],[S.CompletionItemKind.Snippet,27],[S.CompletionItemKind.Text,18],[S.CompletionItemKind.Color,19],[S.CompletionItemKind.File,20],[S.CompletionItemKind.Reference,21],[S.CompletionItemKind.Folder,23],[S.CompletionItemKind.Event,10],[S.CompletionItemKind.Operator,11],[S.CompletionItemKind.TypeParameter,24],[S.CompletionItemKind.Issue,26],[S.CompletionItemKind.User,25]]);function ce(Te){var Xe;return(Xe=De.get(Te))!==null&&Xe!==void 0?Xe:9}ue.from=ce;const j=new Map([[0,S.CompletionItemKind.Method],[1,S.CompletionItemKind.Function],[2,S.CompletionItemKind.Constructor],[3,S.CompletionItemKind.Field],[4,S.CompletionItemKind.Variable],[5,S.CompletionItemKind.Class],[7,S.CompletionItemKind.Interface],[6,S.CompletionItemKind.Struct],[8,S.CompletionItemKind.Module],[9,S.CompletionItemKind.Property],[12,S.CompletionItemKind.Unit],[13,S.CompletionItemKind.Value],[14,S.CompletionItemKind.Constant],[15,S.CompletionItemKind.Enum],[16,S.CompletionItemKind.EnumMember],[17,S.CompletionItemKind.Keyword],[27,S.CompletionItemKind.Snippet],[18,S.CompletionItemKind.Text],[19,S.CompletionItemKind.Color],[20,S.CompletionItemKind.File],[21,S.CompletionItemKind.Reference],[23,S.CompletionItemKind.Folder],[10,S.CompletionItemKind.Event],[11,S.CompletionItemKind.Operator],[24,S.CompletionItemKind.TypeParameter],[25,S.CompletionItemKind.User],[26,S.CompletionItemKind.Issue]]);function Ae(Te){var Xe;return(Xe=j.get(Te))!==null&&Xe!==void 0?Xe:S.CompletionItemKind.Property}ue.to=Ae})(K=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ue){function De(ce,j){var Ae;const Te=new S.CompletionItem(typeof ce.label=="string"?ce.label:ce.label.name);return typeof ce.label!="string"&&(Te.label2=ce.label),Te.insertText=ce.insertText,Te.kind=K.to(ce.kind),Te.tags=(Ae=ce.tags)===null||Ae===void 0?void 0:Ae.map(N.to),Te.detail=ce.detail,Te.documentation=I.isMarkdownString(ce.documentation)?f.to(ce.documentation):ce.documentation,Te.sortText=ce.sortText,Te.filterText=ce.filterText,Te.preselect=ce.preselect,Te.commitCharacters=ce.commitCharacters,D.Range.isIRange(ce.range)?Te.range=g.to(ce.range):typeof ce.range=="object"&&(Te.range={inserting:g.to(ce.range.insert),replacing:g.to(ce.range.replace)}),Te.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Te.insertText=new S.SnippetString(ce.insertText):(Te.insertText=ce.insertText,Te.textEdit=Te.range instanceof S.Range?new S.TextEdit(Te.range,Te.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=ce.additionalTextEdits.map(Xe=>z.to(Xe))),Te.command=j&&ce.command?j.fromInternal(ce.command):void 0,Te}ue.to=De})(ee=e.CompletionItem||(e.CompletionItem={}));var oe;(function(ue){function De(j){return{label:j.label,documentation:j.documentation?f.fromStrict(j.documentation):void 0}}ue.from=De;function ce(j){return{label:j.label,documentation:I.isMarkdownString(j.documentation)?f.to(j.documentation):j.documentation}}ue.to=ce})(oe=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(ue){function De(j){return{label:j.label,documentation:j.documentation?f.fromStrict(j.documentation):void 0,parameters:Array.isArray(j.parameters)?j.parameters.map(oe.from):[],activeParameter:j.activeParameter}}ue.from=De;function ce(j){return{label:j.label,documentation:I.isMarkdownString(j.documentation)?f.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(oe.to):[],activeParameter:j.activeParameter}}ue.to=ce})(me=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(ue){function De(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(me.from):[]}}ue.from=De;function ce(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(me.to):[]}}ue.to=ce})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ue){function De(j){var Ae;return{text:j.text,range:g.from(j.range),kind:ge.from((Ae=j.kind)!==null&&Ae!==void 0?Ae:S.InlineHintKind.Other),description:j.description&&f.fromStrict(j.description),whitespaceBefore:j.whitespaceBefore,whitespaceAfter:j.whitespaceAfter}}ue.from=De;function ce(j){const Ae=new S.InlineHint(j.text,g.to(j.range),ge.to(j.kind));return Ae.whitespaceAfter=j.whitespaceAfter,Ae.whitespaceBefore=j.whitespaceBefore,Ae.description=I.isMarkdownString(j.description)?f.to(j.description):j.description,Ae}ue.to=ce})(Me=e.InlineHint||(e.InlineHint={}));var ge;(function(ue){function De(j){return j}ue.from=De;function ce(j){return j}ue.to=ce})(ge=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(ue){function De(j){return{range:g.from(j.range),url:j.target,tooltip:j.tooltip}}ue.from=De;function ce(j){let Ae;if(j.url)try{Ae=typeof j.url=="string"?A.URI.parse(j.url,!0):A.URI.revive(j.url)}catch(Te){}return new S.DocumentLink(g.to(j.range),Ae)}ue.to=ce})(Ce=e.DocumentLink||(e.DocumentLink={}));var Pe;(function(ue){function De(j){const Ae=new S.ColorPresentation(j.label);return j.textEdit&&(Ae.textEdit=z.to(j.textEdit)),j.additionalTextEdits&&(Ae.additionalTextEdits=j.additionalTextEdits.map(Te=>z.to(Te))),Ae}ue.to=De;function ce(j){return{label:j.label,textEdit:j.textEdit?z.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Ae=>z.from(Ae)):void 0}}ue.from=ce})(Pe=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(ue){function De(j){return new S.Color(j[0],j[1],j[2],j[3])}ue.to=De;function ce(j){return[j.red,j.green,j.blue,j.alpha]}ue.from=ce})(xe=e.Color||(e.Color={}));var _e;(function(ue){function De(j){return{range:g.from(j.range)}}ue.from=De;function ce(j){return new S.SelectionRange(g.to(j.range))}ue.to=ce})(_e=e.SelectionRange||(e.SelectionRange={}));var qe;(function(ue){function De(ce){switch(ce){case 2:return S.TextDocumentSaveReason.AfterDelay;case 1:return S.TextDocumentSaveReason.Manual;case 3:case 4:return S.TextDocumentSaveReason.FocusOut}}ue.to=De})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(ue){function De(j){switch(j){case S.TextEditorLineNumbersStyle.Off:return 0;case S.TextEditorLineNumbersStyle.Relative:return 2;case S.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=De;function ce(j){switch(j){case 0:return S.TextEditorLineNumbersStyle.Off;case 2:return S.TextEditorLineNumbersStyle.Relative;case 1:default:return S.TextEditorLineNumbersStyle.On}}ue.to=ce})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Y;(function(ue){function De(j){if(j===S.EndOfLine.CRLF)return 1;if(j===S.EndOfLine.LF)return 0}ue.from=De;function ce(j){if(j===1)return S.EndOfLine.CRLF;if(j===0)return S.EndOfLine.LF}ue.to=ce})(Y=e.EndOfLine||(e.EndOfLine={}));var ve;(function(ue){function De(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case S.ProgressLocation.SourceControl:return 3;case S.ProgressLocation.Window:return 10;case S.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=De})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(ue){function De(ce){const j={start:ce.start+1,end:ce.end+1};return ce.kind&&(j.kind=Be.from(ce.kind)),j}ue.from=De})(Le=e.FoldingRange||(e.FoldingRange={}));var Be;(function(ue){function De(ce){if(ce)switch(ce){case S.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}ue.from=De})(Be=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Oe;(function(ue){function De(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?g.from(ce.selection):void 0,override:typeof ce.override=="boolean"?R.EditorOverride.DISABLED:void 0}}ue.from=De})(Oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var et;(function(ue){function De(j){return j instanceof S.RelativePattern||typeof j=="string"?j:ce(j)?new S.RelativePattern(j.base,j.pattern):j}ue.from=De;function ce(j){const Ae=j;return Ae&&typeof Ae.base=="string"&&typeof Ae.pattern=="string"}})(et=e.GlobPattern||(e.GlobPattern={}));var B;(function(ue){function De(ce){if(ce){if(Array.isArray(ce))return ce.map(De);if(typeof ce=="string")return ce;{const j=ce;return{language:j.language,scheme:j.scheme,pattern:typeof j.pattern=="undefined"?void 0:et.from(j.pattern),exclusive:j.exclusive}}}else return}ue.from=De})(B=e.LanguageSelector||(e.LanguageSelector={}));var te;(function(ue){function De(j){return{start:j.start,end:j.end}}ue.from=De;function ce(j){return new S.NotebookCellRange(j.start,j.end)}ue.to=ce})(te=e.NotebookCellRange||(e.NotebookCellRange={}));var he;(function(ue){function De(ce){return new S.NotebookCellMetadata(ce.editable,ce.breakpointMargin,ce.hasExecutionOrder,ce.statusMessage,ce.inputCollapsed,ce.outputCollapsed,ce.custom)}ue.to=De})(he=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var q;(function(ue){function De(j){return j}ue.from=De;function ce(j){return new S.NotebookDocumentMetadata(j.editable,j.cellEditable,j.cellHasExecutionOrder,j.custom,j.trusted)}ue.to=ce})(q=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var J;(function(ue){function De(j){return{duration:j.lastRunDuration,executionOrder:j.executionOrder,success:j.lastRunSuccess}}ue.to=De;function ce(j){return{lastRunSuccess:j.success,lastRunDuration:j.duration,executionOrder:j.executionOrder}}ue.from=ce})(J=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var se;(function(ue){function De(j){switch(j){case S.NotebookCellKind.Markdown:return d.CellKind.Markdown;case S.NotebookCellKind.Code:default:return d.CellKind.Code}}ue.from=De;function ce(j){switch(j){case d.CellKind.Markdown:return S.NotebookCellKind.Markdown;case d.CellKind.Code:default:return S.NotebookCellKind.Code}}ue.to=ce})(se=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(ue){function De(j){var Ae;return{cellKind:se.from(j.kind),language:j.language,source:j.source,metadata:Object.assign(Object.assign({},j.metadata),J.from((Ae=j.latestExecutionSummary)!==null&&Ae!==void 0?Ae:{})),outputs:j.outputs?j.outputs.map(We.from):[]}}ue.from=De;function ce(j){return new S.NotebookCellData(se.to(j.cellKind),j.source,j.language,j.outputs?j.outputs.map(We.to):void 0,j.metadata?he.to(j.metadata):void 0)}ue.to=ce})(fe=e.NotebookCellData||(e.NotebookCellData={}));var pe;(function(ue){function De(j){return{mime:j.mime,value:j.value,metadata:j.metadata}}ue.from=De;function ce(j){return new S.NotebookCellOutputItem(j.mime,j.value,j.metadata)}ue.to=ce})(pe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var We;(function(ue){function De(j){return{outputId:j.id,outputs:j.outputs.map(pe.from),metadata:j.metadata}}ue.from=De;function ce(j){const Ae=j.outputs.map(pe.to);return new S.NotebookCellOutput(Ae,j.outputId,j.metadata)}ue.to=ce})(We=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ne;(function(ue){function De(Te){if(Te!=null){if(Te instanceof S.RelativePattern||typeof Te=="string")return Te;if(Ae(Te))return new S.RelativePattern(Te.base,Te.pattern);if(j(Te))return{include:et.from(Te.include)||void 0,exclude:et.from(Te.exclude)||void 0}}}ue.from=De;function ce(Te){return typeof Te=="string"?Te:Ae(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}ue.to=ce;function j(Te){const Xe=Te,Ge=et.from(Xe.include);if(!(Ge&&Ge instanceof S.RelativePattern||typeof Ge=="string"))return!1;const rt=et.from(Xe.exclude);return!!(rt&&rt instanceof S.RelativePattern||typeof rt=="string")}function Ae(Te){const Xe=Te;return Xe&&typeof Xe.base=="string"&&typeof Xe.pattern=="string"}})(Ne=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ve;(function(ue){function De(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?h.from(ce.top):void 0}}ue.from=De})(Ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Je;(function(ue){function De(j){return{state:j.state,duration:j.duration,messages:j.messages.map(Ze.from)}}ue.from=De;function ce(j){const Ae=new S.TestState(j.state);return Ae.duration=j.duration,Ae.messages=j.messages.map(Ze.to),Ae}ue.to=ce})(Je=e.TestState||(e.TestState={}));var Ze;(function(ue){function De(j){return{message:f.fromStrict(j.message)||"",severity:j.severity,expectedOutput:j.expectedOutput,actualOutput:j.actualOutput,location:j.location?$.from(j.location):void 0}}ue.from=De;function ce(j){const Ae=new S.TestMessage(typeof j.message=="string"?j.message:f.to(j.message));return Ae.severity=j.severity,Ae.actualOutput=j.actualOutput,Ae.expectedOutput=j.expectedOutput,Ae}ue.to=ce})(Ze=e.TestMessage||(e.TestMessage={}));var ct;(function(ue){function De(Te){var Xe,Ge;return{extId:Te.id,label:Te.label,location:Te.location?$.from(Te.location):void 0,debuggable:(Xe=Te.debuggable)!==null&&Xe!==void 0?Xe:!1,description:Te.description,runnable:(Ge=Te.runnable)!==null&&Ge!==void 0?Ge:!0,expandable:Te.expandable}}ue.from=De;function ce(Te){return{extId:Te.id,label:Te.label,location:Te.location?$.from(Te.location):void 0,debuggable:!1,description:Te.description,runnable:!0,expandable:!0}}ue.fromResultSnapshot=ce;function j(Te){return{id:Te.extId,label:Te.label,location:Te.location&&$.to({range:Te.location.range,uri:A.URI.revive(Te.location.uri)}),expandable:Te.expandable,debuggable:Te.debuggable,description:Te.description,runnable:Te.runnable}}ue.toPlain=j;function Ae(Te){const Xe=new S.TestItem(Te.extId,Te.label,Te.expandable);return Te.location&&(Xe.location=$.to({range:Te.location.range,uri:A.URI.revive(Te.location.uri)})),Xe.debuggable=Te.debuggable,Xe.description=Te.description,Xe.runnable=Te.runnable,Xe}ue.to=Ae})(ct=e.TestItem||(e.TestItem={}));var ot;(function(ue){function De(Ae,Te){var Xe,Ge,rt;const at={completedAt:Te.completedAt,id:Ae,items:[]},Qe=[[null,Te.results]];for(;Qe.length;){const[ut,st]=Qe.pop();for(const gt of st){const wt={children:(Ge=(Xe=gt.children)===null||Xe===void 0?void 0:Xe.map(Dt=>Dt.id))!==null&&Ge!==void 0?Ge:[],computedState:gt.result.state,item:ct.fromResultSnapshot(gt),state:Je.from(gt.result),retired:void 0,expand:3,parent:(rt=ut==null?void 0:ut.item.extId)!==null&&rt!==void 0?rt:null,src:{provider:"",tree:-1},direct:!ut};at.items.push(wt),gt.children&&Qe.push([wt,gt.children])}}return at}ue.from=De;const ce=(Ae,Te)=>Object.assign(Object.assign({},ct.toPlain(Ae.item)),{result:Je.to(Ae.state),children:Ae.children.map(Xe=>Te.get(Xe)).filter(T.isDefined).map(Xe=>ce(Xe,Te))});function j(Ae){const Te=[],Xe=new Map;for(const Ge of Ae.items)Xe.set(Ge.item.extId,Ge),Ge.direct&&Te.push(Ge);return{completedAt:Ae.completedAt,results:Te.map(Ge=>ce(Ge,Xe))}}ue.to=j})(ot=e.TestResults||(e.TestResults={}));var nt;(function(ue){function De(ce){switch(ce){case 1:return S.CodeActionTriggerKind.Invoke;case 2:return S.CodeActionTriggerKind.Automatic}}ue.to=De})(nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(be[172],we([0,1,2,10,7,9,45]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(n,T,k,b={timeout:1500,errors:3}){this._logService=n,this._documents=T,this._mainThreadBulkEdits=k,this._thresholds=b,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(T,k,b)=>{const r={dispose:this._callbacks.push([T,k,n])};return Array.isArray(b)&&b.push(r),r}}async $participateInSave(n,T){const k=E.URI.revive(n);let b=!1;const m=setTimeout(()=>b=!0,this._thresholds.timeout),r=[];try{for(let d of[...this._callbacks]){if(b)break;const _=this._documents.getDocument(k),g=await this._deliverEventAsyncAndBlameBadListeners(d,{document:_,reason:A.TextDocumentSaveReason.to(T)});r.push(g)}}finally{clearTimeout(m)}return r}_deliverEventAsyncAndBlameBadListeners([n,T,k],b){const m=this._badListeners.get(n);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,n,T,b).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const d=this._badListeners.get(n);this._badListeners.set(n,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,T,k,b){const m=[],r=Date.now(),{document:d,reason:_}=b,{version:g}=d,w=Object.freeze({document:d,reason:_,waitUntil(u){if(Object.isFrozen(m))throw(0,S.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(u))}});try{T.apply(k,[w])}catch(u){return Promise.reject(u)}return Object.freeze(m),new Promise((u,c)=>{const s=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(s),u(t)}).catch(t=>{clearTimeout(s),c(t)})}).then(u=>{const c={edits:[]};for(const s of u)if(Array.isArray(s)&&s.every(t=>t instanceof R.TextEdit))for(const{newText:t,newEol:i,range:l}of s)c.edits.push({_type:2,resource:d.uri,edit:{range:l&&A.Range.from(l),text:t,eol:i&&A.EndOfLine.from(i)}});if(c.edits.length!==0)return g===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(be[173],we([0,1,3,13,28,2,9,7]),function(ae,e,E,S,R,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(k,b,m,r,d){this._onDidCreate=new E.Emitter,this._onDidChange=new E.Emitter,this._onDidDelete=new E.Emitter,this._config=0,m&&(this._config+=1),r&&(this._config+=2),d&&(this._config+=4);const _=(0,R.parse)(b),g=k(w=>{if(!m)for(let u of w.created){const c=A.URI.revive(u);_(c.fsPath)&&this._onDidCreate.fire(c)}if(!r)for(let u of w.changed){const c=A.URI.revive(u);_(c.fsPath)&&this._onDidChange.fire(c)}if(!d)for(let u of w.deleted){const c=A.URI.revive(u);_(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=I.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,g)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(k,b,m){this._logService=b,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new E.Emitter,this._onDidRenameFile=new E.Emitter,this._onDidCreateFile=new E.Emitter,this._onDidDeleteFile=new E.Emitter,this._onWillRenameFile=new S.AsyncEmitter,this._onWillCreateFile=new S.AsyncEmitter,this._onWillDeleteFile=new S.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,b,m,r){return new y(this._onFileSystemEvent.event,k,b,m,r)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,b){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(m=>({oldUri:A.URI.revive(m.source),newUri:A.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(m=>A.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:b.map(m=>A.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,b){return(m,r,d)=>{const _=function(w){m.call(r,w)};return _.extension=k,b.event(_,void 0,d)}}async $onWillRunFileOperation(k,b,m,r){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(d=>({oldUri:A.URI.revive(d.source),newUri:A.URI.revive(d.target)}))},m,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(d=>A.URI.revive(d.target))},m,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(d=>A.URI.revive(d.target))},m,r)}}async _fireWillEvent(k,b,m,r){const d=new Set,_=[];if(await k.fireAsync(b,r,async(w,u)=>{var c;const s=Date.now(),t=await Promise.resolve(w);t instanceof I.WorkspaceEdit&&(_.push(t),d.add((c=u.extension.displayName)!==null&&c!==void 0?c:u.extension.identifier.value)),Date.now()-s>m&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),!r.isCancellationRequested&&_.length!==0){const g={edits:[]};for(let w of _){let{edits:u}=D.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);g.edits=g.edits.concat(u)}return{edit:g,extensionNames:Array.from(d)}}}}e.ExtHostFileSystemEventService=n}),define(be[174],we([0,1,3,6,16,23,2,9,7,70]),function(ae,e,E,S,R,A,D,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(r,d,_,g){this.start=r,this.deletedCount=d,this.deletedItems=_,this.items=g}static asApiEvents(r){return r.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(_=>_.cell)}))}}class k{constructor(r,d,_){var g;this._notebook=r,this._extHostDocument=d,this._cellData=_,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=_.handle,this.uri=D.URI.revive(_.uri),this.cellKind=_.cellKind,this._outputs=_.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=(g=_.metadata)!==null&&g!==void 0?g:{},this._metadata=I.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=I.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(r,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:r}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get internalMetadata(){return this._internalMetadata}get cell(){if(!this._cell){const r=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return r._notebook.getCellIndex(r)},notebook:r._notebook.notebookDocument,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get outputs(){return r._outputs.slice(0)},get metadata(){return r._metadata},get latestExecutionSummary(){return r._previousResult}})}return this._cell}setOutputs(r){this._outputs=r.map(I.NotebookCellOutput.to)}setOutputItems(r,d,_){const g=_.map(I.NotebookCellOutputItem.to),w=this._outputs.find(u=>u.id===r);w&&(d||(w.outputs.length=0),w.outputs.push(...g))}setMetadata(r){this._internalMetadata=r,this._metadata=I.NotebookCellMetadata.to(r),this._previousResult=I.NotebookCellPreviousExecutionResult.to(r)}}e.ExtHostCell=k;class b extends S.Disposable{constructor(r,d,_,g,w,u,c){super();this._proxy=r,this._textDocumentsAndEditors=d,this._textDocuments=_,this._emitter=g,this._viewType=w,this._metadata=u,this.uri=c,this.handle=b._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,S.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const r=this;this._notebook=Object.freeze({get uri(){return r.uri},get version(){return r._versionId},get fileName(){return r.uri.fsPath},get viewType(){return r._viewType},get isDirty(){return r._isDirty},get isUntitled(){return r.uri.scheme===R.Schemas.untitled},get cells(){return r._cells.map(d=>d.cell)},get metadata(){return r._metadata},set metadata(d){throw new Error("Use WorkspaceEdit to update metadata.")},save(){return r._save()}})}return this._notebook}updateBackup(r){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=r}disposeBackup(){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(r){r.metadata&&(this._metadata=this._metadata.with(r.metadata))}acceptModelChanged(r,d){this._versionId=r.versionId,this._isDirty=d;for(const _ of r.rawEvents)_.kind===n.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(_.changes,!0),_.kind===n.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(_.changes,!1):_.kind===n.NotebookCellsChangeType.Move?this._moveCell(_.index,_.newIdx):_.kind===n.NotebookCellsChangeType.Output?this._setCellOutputs(_.index,_.outputs):_.kind===n.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(_.index,_.outputId,_.append,_.outputItems):_.kind===n.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(_.index,_.language):_.kind===n.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(_.index,_.metadata)}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(r,d){if(!this._disposed){const _=[],g=[],w=[];r.reverse().forEach(u=>{var c;const t=u[2].map(o=>{const a=new k(this,this._textDocumentsAndEditors,o);if(d||g.push(k.asModelAddData(this.notebookDocument,o)),!this._cellDisposableMapping.has(a.handle)){const f=new S.DisposableStore;f.add(a),this._cellDisposableMapping.set(a.handle,f)}return a});for(let o=u[0];o<u[0]+u[1];o++)(c=this._cellDisposableMapping.get(this._cells[o].handle))===null||c===void 0||c.dispose(),this._cellDisposableMapping.delete(this._cells[o].handle);const i=new T(u[0],u[1],[],t),l=this._cells.splice(u[0],u[1],...t);for(let o of l)w.push(o.uri),i.deletedItems.push(o.cell);_.push(i)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:w}),d||this._emitter.emitModelChange((0,A.deepFreeze)({document:this.notebookDocument,changes:T.asApiEvents(_)}))}}_moveCell(r,d){const _=this._cells.splice(r,1);this._cells.splice(d,0,..._);const g=[new T(r,1,_.map(w=>w.cell),[]),new T(d,0,[],_)];this._emitter.emitModelChange((0,A.deepFreeze)({document:this.notebookDocument,changes:T.asApiEvents(g)}))}_setCellOutputs(r,d){const _=this._cells[r];_.setOutputs(d),this._emitter.emitCellOutputsChange((0,A.deepFreeze)({document:this.notebookDocument,cells:[_.cell]}))}_setCellOutputItems(r,d,_,g){const w=this._cells[r];w.setOutputItems(d,_,g),this._emitter.emitCellOutputsChange((0,A.deepFreeze)({document:this.notebookDocument,cells:[w.cell]}))}_changeCellLanguage(r,d){const _=this._cells[r];_.cell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(_.uri,d)}_changeCellMetadata(r,d){var _;const g=this._cells[r],w=g.internalMetadata,u=g.cell.metadata;g.setMetadata(d);const c=g.cell.metadata;if((0,A.equals)(u,c)||this._emitter.emitCellMetadataChange((0,A.deepFreeze)({document:this.notebookDocument,cell:g.cell})),w.runState!==d.runState){const s=(_=d.runState)!==null&&_!==void 0?_:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,A.deepFreeze)({document:this.notebookDocument,cell:g.cell,executionState:s}))}}getCellFromIndex(r){return this._cells[r]}getCell(r){return this._cells.find(d=>d.handle===r)}getCellIndex(r){return this._cells.indexOf(r)}}e.ExtHostNotebookDocument=b,b._handlePool=0}),define(be[175],we([0,1,3,7,9]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,n){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:y,metadata:n})}replaceCellOutput(y,n){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:y,outputs:n.map(T=>R.NotebookCellOutput.from(T))})}replaceCells(y,n,T){this._throwIfFinalized(),!(y===n&&T.length===0)&&this._collectedEdits.push({editType:1,index:y,count:n-y,cells:T.map(R.NotebookCellData.from)})}}class D{constructor(y,n,T,k,b,m,r){this.id=y,this._viewType=n,this._proxy=T,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=m,this._visibleRanges=b,this._viewColumn=r}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.notebookDocument},get selection(){var n;const T=y._selections[0];return T&&((n=y.notebookData.getCellFromIndex(T.start))===null||n===void 0?void 0:n.cell)},get selections(){return y._selections},get visibleRanges(){return y._visibleRanges},revealRange(n,T){y._proxy.$tryRevealRange(y.id,R.NotebookCellRange.from(n),T!=null?T:S.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},get onDidDispose(){return y.onDidDispose},edit(n){const T=new A(this.document.version);return n(T),y._applyEdit(T.finalize())},get kernel(){return y._kernel},setDecorations(n,T){return y.setDecorations(n,T)}}}return this._editor}_acceptKernel(y){this._kernel=y}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const n=[];let T=-1;for(let k=0;k<y.cellEdits.length;k++){if(T<0){n.push(y.cellEdits[k]),T++;continue}const m=n[T],r=y.cellEdits[k];if(m.editType===1&&r.editType===1&&m.index===r.index){m.cells.push(...y.cellEdits[k].cells),m.count+=y.cellEdits[k].count;continue}n.push(y.cellEdits[k]),T++}return this._proxy.$tryApplyEdits(this._viewType,this.notebookData.uri,y.documentVersionId,n)}setDecorations(y,n){if(!(n.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return n.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,R.NotebookCellRange.from(n),y.key)}}e.ExtHostNotebookEditor=D}),define(be[176],we([0,1,9,150,131,20,51]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,b,m){const r=this._handles++,{title:d,location:_,cancellable:g}=b,w={label:(0,R.localize)(0,null,k.displayName||k.name),id:k.identifier.value};return this._proxy.$startProgress(r,{location:E.ProgressLocation.from(_),title:d,source:w,cancellable:g},k),this._withProgress(r,m,!!g)}_withProgress(k,b,m){let r;m&&(r=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,r));const d=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),r&&r.dispose()};let _;try{_=b(new n(this._proxy,k),m&&r?r.token:A.CancellationToken.None)}catch(g){throw d(k),g}return _.then(g=>d(k),g=>d(k)),_}$acceptProgressCanceled(k){const b=this._mapHandleToCancellationSource.get(k);b&&(b.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=I;function y(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class n extends S.Progress{constructor(k,b){super(m=>this.throttledReport(m));this._proxy=k,this._handle=b}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}je([(0,D.throttle)(100,(T,k)=>y(T,k),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(be[96],we([0,1,43,10,53,9,7]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(b,m){const r=I._Keys.nextId();b.$registerTextEditorDecorationType(r,A.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:r,dispose(){b.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=I,I._Keys=new R.IdGenerator("TextEditorDecorationType");class y{constructor(b,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=b,this._documentVersionId=b.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(b,m){this._throwIfFinalized();let r=null;if(b instanceof D.Position)r=new D.Range(b,b);else if(b instanceof D.Range)r=b;else throw new Error("Unrecognized location");this._pushEdit(r,m,!1)}insert(b,m){this._throwIfFinalized(),this._pushEdit(new D.Range(b,b),m,!0)}delete(b){this._throwIfFinalized();let m=null;if(b instanceof D.Range)m=b;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(b,m,r){const d=this._document.validateRange(b);this._collectedEdits.push({range:d,text:m,forceMoveMarkers:r})}setEndOfLine(b){if(this._throwIfFinalized(),b!==D.EndOfLine.LF&&b!==D.EndOfLine.CRLF)throw(0,S.illegalArgument)("endOfLine");this._setEndOfLine=b}}e.TextEditorEdit=y;class n{constructor(b,m,r,d){this._proxy=b,this._id=m,this._accept(r),this._logService=d;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(g){_._setTabSize(g)},get insertSpaces(){return _._insertSpaces},set insertSpaces(g){_._setInsertSpaces(g)},get cursorStyle(){return _._cursorStyle},set cursorStyle(g){_._setCursorStyle(g)},get lineNumbers(){return _._lineNumbers},set lineNumbers(g){_._setLineNumbers(g)}}}_accept(b){this._tabSize=b.tabSize,this._insertSpaces=b.insertSpaces,this._cursorStyle=b.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(b.lineNumbers)}_validateTabSize(b){if(b==="auto")return"auto";if(typeof b=="number"){const m=Math.floor(b);return m>0?m:null}if(typeof b=="string"){const m=parseInt(b,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(b){const m=this._validateTabSize(b);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(b){return b==="auto"?"auto":b==="false"?!1:Boolean(b)}_setInsertSpaces(b){const m=this._validateInsertSpaces(b);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(b){this._cursorStyle!==b&&(this._cursorStyle=b,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:b})))}_setLineNumbers(b){this._lineNumbers!==b&&(this._lineNumbers=b,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(b)})))}assign(b){const m={};let r=!1;if(typeof b.tabSize!="undefined"){const d=this._validateTabSize(b.tabSize);d==="auto"?(r=!0,m.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,r=!0,m.tabSize=d)}if(typeof b.insertSpaces!="undefined"){const d=this._validateInsertSpaces(b.insertSpaces);d==="auto"?(r=!0,m.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,r=!0,m.insertSpaces=d)}typeof b.cursorStyle!="undefined"&&this._cursorStyle!==b.cursorStyle&&(this._cursorStyle=b.cursorStyle,r=!0,m.cursorStyle=b.cursorStyle),typeof b.lineNumbers!="undefined"&&this._lineNumbers!==b.lineNumbers&&(this._lineNumbers=b.lineNumbers,r=!0,m.lineNumbers=A.TextEditorLineNumbersStyle.from(b.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(b){b.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=n;class T{constructor(b,m,r,d,_,g,w,u){this.id=b,this._proxy=m,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new n(this._proxy,this.id,g,r),this._visibleRanges=w,this._viewColumn=u;const c=this;this.value=Object.freeze({get document(){return d.getValue()},set document(s){throw(0,S.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(s){if(!(s instanceof D.Selection))throw(0,S.illegalArgument)("selection");c._selections=[s],c._trySetSelection()},get selections(){return c._selections},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof D.Selection)))throw(0,S.illegalArgument)("selections");c._selections=s,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(s){throw(0,S.readonly)("visibleRanges")},get options(){return c._options.value},set options(s){c._disposed||c._options.assign(s)},get viewColumn(){return c._viewColumn},set viewColumn(s){throw(0,S.readonly)("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new y(d.getValue(),t);return s(i),c._applyEdit(i)},insertSnippet(s,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!t||Array.isArray(t)&&t.length===0)l=c._selections.map(o=>A.Range.from(o));else if(t instanceof D.Position){const{lineNumber:o,column:a}=A.Position.from(t);l=[{startLineNumber:o,startColumn:a,endLineNumber:o,endColumn:a}]}else if(t instanceof D.Range)l=[A.Range.from(t)];else{l=[];for(const o of t)if(o instanceof D.Range)l.push(A.Range.from(o));else{const{lineNumber:a,column:f}=A.Position.from(o);l.push({startLineNumber:a,startColumn:f,endLineNumber:a,endColumn:f})}}return m.$tryInsertSnippet(b,s.value,l,i)},setDecorations(s,t){const i=t.length===0;i&&!c._hasDecorationsForKey.has(s.key)||(i?c._hasDecorationsForKey.delete(s.key):c._hasDecorationsForKey.add(s.key),c._runOnProxy(()=>{if(A.isDecorationOptionsArr(t))return m.$trySetDecorations(b,s.key,A.fromRangeOrRangeWithMessage(t));{const l=new Array(4*t.length);for(let o=0,a=t.length;o<a;o++){const f=t[o];l[4*o]=f.start.line+1,l[4*o+1]=f.start.character+1,l[4*o+2]=f.end.line+1,l[4*o+3]=f.end.character+1}return m.$trySetDecorationsFast(b,s.key,l)}}))},revealRange(s,t){c._runOnProxy(()=>m.$tryRevealRange(b,A.Range.from(s),t||D.TextEditorRevealType.Default))},show(s){m.$tryShowEditor(b,A.ViewColumn.from(s))},hide(){m.$tryHideEditor(b)}})}dispose(){(0,E.ok)(!this._disposed),this._disposed=!0}_acceptOptions(b){(0,E.ok)(!this._disposed),this._options._accept(b)}_acceptVisibleRanges(b){(0,E.ok)(!this._disposed),this._visibleRanges=b}_acceptViewColumn(b){(0,E.ok)(!this._disposed),this._viewColumn=b}_acceptSelections(b){(0,E.ok)(!this._disposed),this._selections=b}async _trySetSelection(){const b=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,b)),this.value}_applyEdit(b){const m=b.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const r=m.edits.map(_=>_.range);r.sort((_,g)=>_.end.line===g.end.line?_.end.character===g.end.character?_.start.line===g.start.line?_.start.character-g.start.character:_.start.line-g.start.line:_.end.character-g.end.character:_.end.line-g.end.line);for(let _=0,g=r.length-1;_<g;_++){const w=r[_].end;if(r[_+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=m.edits.map(_=>({range:A.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,d,{setEndOfLine:typeof m.setEndOfLine=="number"?A.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(b){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):b().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=T}),define(be[177],we([0,1,134,24,2,3,6,13,7,12,15,9,20]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(_,g){if((0,n.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let w;return Array.isArray(_.highlights)&&(w=_.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),w=w.length?w:void 0),{label:_.label,highlights:w}}}class r{constructor(g,w,u){this._proxy=g,this.commands=w,this.logService=u,this.treeViews=new Map;function c(s){return s&&s.$treeViewId&&s.$treeItemHandle}w.registerArgumentProcessor({processArgument:s=>c(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(t=>c(t)?this.convertArgument(t):t):s})}registerTreeDataProvider(g,w,u){const c=this.createTreeView(g,{treeDataProvider:w},u);return{dispose:()=>c.dispose()}}createTreeView(g,w,u){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(g,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany}),s=this.createExtHostTreeView(g,w,u);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(t){s.message=t},get title(){return s.title},set title(t){s.title=t},get description(){return s.description},set description(t){s.description=t},reveal:(t,i)=>s.reveal(t,i),dispose:async()=>{await c,this.treeViews.delete(g),s.dispose()}}}$getChildren(g,w){const u=this.treeViews.get(g);return u?u.getChildren(w):Promise.reject(new Error((0,E.localize)(0,null,g)))}async $hasResolve(g){const w=this.treeViews.get(g);if(!w)throw new Error((0,E.localize)(1,null,g));return w.hasResolve}$resolve(g,w,u){const c=this.treeViews.get(g);if(!c)throw new Error((0,E.localize)(2,null,g));return c.resolveTreeItem(w,u)}$setExpanded(g,w,u){const c=this.treeViews.get(g);if(!c)throw new Error((0,E.localize)(3,null,g));c.setExpanded(w,u)}$setSelection(g,w){const u=this.treeViews.get(g);if(!u)throw new Error((0,E.localize)(4,null,g));u.setSelection(w)}$setVisible(g,w){const u=this.treeViews.get(g);if(!u)throw new Error((0,E.localize)(5,null,g));u.setVisible(w)}createExtHostTreeView(g,w,u){const c=new d(g,w,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(g,c),c}convertArgument(g){const w=this.treeViews.get(g.$treeViewId);return w?w.getExtensionElement(g.$treeItemHandle):null}}e.ExtHostTreeViews=r;class d extends D.Disposable{constructor(g,w,u,c,s,t){super();if(this.viewId=g,this.proxy=u,this.commands=c,this.logService=s,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new b.CancellationTokenSource,t.contributes&&t.contributes.views)for(const o in t.contributes.views)for(const a of t.contributes.views[o])a.id===g&&(this._title=a.name);this.dataProvider=w.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let i,l;this._register(A.Event.debounce(this._onDidChangeData.event,(o,a)=>(o||(o={message:!1,elements:[]}),a.element!==!1&&(i||(i=new Promise(f=>l=f),this.refreshPromise=this.refreshPromise.then(()=>i)),o.elements.push(a.element)),a.message&&(o.message=!0),o),200,!0)(({message:o,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=l;return i=null,this.refresh(a).then(()=>f())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(g=>this.getExtensionElement(g)).filter(g=>!(0,n.isUndefinedOrNull)(g))}getChildren(g){const w=g?this.getExtensionElement(g):void 0;if(g&&!w)return this.logService.error(`No tree item with id '${g}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(g);return(u?Promise.resolve(u):this.fetchChildrenNodes(w)).then(c=>c.map(s=>s.item))}getExtensionElement(g){return this.elements.get(g)}reveal(g,w){w=w||{select:!0,focus:!1};const u=(0,n.isUndefinedOrNull)(w.select)?!0:w.select,c=(0,n.isUndefinedOrNull)(w.focus)?!1:w.focus,s=(0,n.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.refreshPromise.then(()=>this.resolveUnknownParentChain(g)).then(t=>this.resolveTreeNode(g,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(l=>l.item)},{select:u,focus:c,expand:s})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:c,expand:s})}get message(){return this._message}set message(g){this._message=g,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(g){this._title=g,this.proxy.$setTitle(this.viewId,g,this._description)}get description(){return this._description}set description(g){this._description=g,this.proxy.$setTitle(this.viewId,this._title,g)}setExpanded(g,w){const u=this.getExtensionElement(g);u&&(w?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(g){(0,T.equals)(this._selectedHandles,g)||(this._selectedHandles=g,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(g){g!==this._visible&&(this._visible=g,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(g,w){var u;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(g);if(c){const s=this.nodes.get(c);if(s){const t=(u=await this.dataProvider.resolveTreeItem(s.extensionItem,c,w))!==null&&u!==void 0?u:s.extensionItem;return s.item.tooltip=this.getTooltip(t.tooltip),s.item.command=this.getCommand(s.disposableStore,t.command),s.item}}}}resolveUnknownParentChain(g){return this.resolveParent(g).then(w=>w?this.resolveUnknownParentChain(w).then(u=>this.resolveTreeNode(w,u[u.length-1]).then(c=>(u.push(c),u))):Promise.resolve([]))}resolveParent(g){const w=this.nodes.get(g);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(g))}resolveTreeNode(g,w){const u=this.nodes.get(g);return u?Promise.resolve(u):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(c=>this.createHandle(g,c,w,!0)).then(c=>this.getChildren(w?w.item.handle:void 0).then(()=>{const s=this.getExtensionElement(c);if(s){const t=this.nodes.get(s);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(g){if(g){let w;if(typeof g=="string"){const u=this.getExtensionElement(g);w=u?this.nodes.get(u):void 0}else w=g;return w&&w.children||null}return this.roots}async fetchChildrenNodes(g){this.clearChildren(g);const w=new b.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=g?this.nodes.get(g):void 0,c=await this.dataProvider.getChildren(g);if(w.token.isCancellationRequested)return[];const s=await Promise.all((0,T.coalesce)(c||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,u):null}));return w.token.isCancellationRequested?[]:(0,T.coalesce)(s)}finally{w.dispose()}}refresh(g){if(g.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new b.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(g);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(g){const w=new Set;for(const c of g){const s=this.nodes.get(c);if(s&&!w.has(s.item.handle)){let t=s;for(;t&&t.parent&&!w.has(t.parent.item.handle);){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&w.add(s.item.handle)}}const u=[];return w.forEach(c=>{const s=this.elements.get(c);if(s){const t=this.nodes.get(s);t&&(!t.parent||!w.has(t.parent.item.handle))&&u.push(c)}}),u}refreshHandles(g){const w={};return Promise.all(g.map(u=>this.refreshNode(u).then(c=>{c&&(w[u]=c.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(g){const w=this.getExtensionElement(g);if(w){const u=this.nodes.get(w);if(u)return this.clearChildren(w),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(c=>{if(c){const s=this.createTreeNode(w,c,u.parent);return this.updateNodeCache(w,s,u,u.parent),u.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(g,w,u){const c=this.createTreeNode(g,w,u);if(w.id&&this.elements.has(c.item.handle))throw new Error((0,E.localize)(6,null,w.id));return this.addNodeToCache(g,c),this.addNodeToParentCache(c,u),c}getTooltip(g){return y.MarkdownString.isMarkdownString(g)?k.MarkdownString.from(g):g}getCommand(g,w){return w?this.commands.toInternal(w,g):void 0}createTreeNode(g,w,u){const c=new D.DisposableStore,s=this.createHandle(g,w,u),t=this.getLightIconPath(w);return{item:{handle:s,parentHandle:u?u.item.handle:void 0,label:m(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(c,w.command),contextValue:w.contextValue,icon:t,iconDark:this.getDarkIconPath(w)||t,themeIcon:this.getThemeIcon(w),collapsibleState:(0,n.isUndefinedOrNull)(w.collapsibleState)?y.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation},extensionItem:w,parent:u,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(g){return g.iconPath instanceof y.ThemeIcon?g.iconPath:void 0}createHandle(g,{id:w,label:u,resourceUri:c},s,t){if(w)return`${d.ID_HANDLE_PREFIX}/${w}`;const i=m(u,this.extension),l=s?s.item.handle:d.LABEL_HANDLE_PREFIX;let o=i?i.label:c?(0,S.basename)(c):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const a=this.nodes.has(g)?this.nodes.get(g).item.handle:void 0,f=this.getChildrenNodes(s)||[];let v,C=0;do{if(v=`${l}/${C}:${o}`,t||!this.elements.has(v)||a===v)break;C++}while(C<=f.length);return v}getLightIconPath(g){if(g.iconPath&&!(g.iconPath instanceof y.ThemeIcon))return typeof g.iconPath=="string"||R.URI.isUri(g.iconPath)?this.getIconPath(g.iconPath):this.getIconPath(g.iconPath.light)}getDarkIconPath(g){if(g.iconPath&&!(g.iconPath instanceof y.ThemeIcon)&&g.iconPath.dark)return this.getIconPath(g.iconPath.dark)}getIconPath(g){return R.URI.isUri(g)?g:R.URI.file(g)}addNodeToCache(g,w){this.elements.set(w.item.handle,g),this.nodes.set(g,w)}updateNodeCache(g,w,u,c){this.elements.delete(w.item.handle),this.nodes.delete(g),w.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(g,w);const s=this.getChildrenNodes(c)||[],t=s.filter(i=>i.item.handle===u.item.handle)[0];t&&s.splice(s.indexOf(t),1,w)}addNodeToParentCache(g,w){w?(w.children||(w.children=[]),w.children.push(g)):(this.roots||(this.roots=[]),this.roots.push(g))}clearChildren(g){if(g){const w=this.nodes.get(g);if(w){if(w.children)for(const u of w.children){const c=this.elements.get(u.item.handle);c&&this.clear(c)}w.children=void 0}}else this.clearAll()}clear(g){const w=this.nodes.get(g);if(w){if(w.children)for(const u of w.children){const c=this.elements.get(u.item.handle);c&&this.clear(c)}this.nodes.delete(g),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(g=>g.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(be[178],we([0,1,15,13,20,9,7,95]),function(ae,e,E,S,R,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class y{constructor(){this.testIdsToInternal=new Map}getTestById(r,d){if(d!==void 0){const _=this.testIdsToInternal.get(d),g=_==null?void 0:_.get(r);if(g)return[_,g]}return(0,E.mapFind)(this.testIdsToInternal.values(),_=>{const g=_.get(r);return g&&[_,g]})}createForHierarchy(r=()=>{}){return new b(this.createIdMap(T++),r)}createIdMap(r){const d=new k(r);return this.testIdsToInternal.set(d.id,d),{object:d,dispose:()=>this.testIdsToInternal.delete(d.id)}}}e.OwnedTestCollection=y;var n;(function(m){m[m.Disconnected=0]="Disconnected",m[m.IsChild=1]="IsChild",m[m.IsParent=2]="IsParent",m[m.IsSame=3]="IsSame"})(n=e.TestPosition||(e.TestPosition={}));let T=0;class k{constructor(r){this.id=r,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(r){if(this.map.has(r.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${r.item.extId}`);this.map.set(r.item.extId,r),r.parent||this._roots.add(r)}has(r){return this.map.has(r)}delete(r){const d=this.map.get(r);return d?(this.map.delete(r),this._roots.delete(d),!0):!1}get(r){return this.map.get(r)}comparePositions(r,d){const _=typeof r=="string"?this.map.get(r):r,g=typeof d=="string"?this.map.get(d):d;if(!_||!g)return 0;if(_===g)return 3;for(let w=this.map.get(g.parent);w;w=this.map.get(w.parent))if(w===_)return 1;for(let w=this.map.get(_.parent);w;w=this.map.get(w.parent))if(w===g)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=k;class b{constructor(r,d){this.testIdToInternal=r,this.publishDiff=d,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new S.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(r,d){this.addItem(r,d,null)}getTestByReference(r){return this.testItemToInternal.get(r)}collectDiff(){const r=this.diff;return this.diff=[],r}pushDiff(r){const d=this.diff[this.diff.length-1];if(d&&r[0]===1){if(d[0]===1&&d[1].extId===r[1].extId){(0,I.applyTestItemUpdate)(d[1],r[1]);return}if(d[0]===0&&d[1].item.extId===r[1].extId){(0,I.applyTestItemUpdate)(d[1],r[1]);return}}this.diff.push(r),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(r,d){var _;const g=this.testIdToInternal.object.get(r);if(!!g){if((g.expandLevels===void 0||d>g.expandLevels)&&(g.expandLevels=d),g.expand===1){const w=this.refreshChildren(g);return w.isSettled?this.expandChildren(g,d-1):w.p.then(()=>this.expandChildren(g,d-1))}else if(g.expand===3)return((_=g.initialExpand)===null||_===void 0?void 0:_.isSettled)===!1?g.initialExpand.p.then(()=>this.expandChildren(g,d-1)):this.expandChildren(g,d-1)}}dispose(){var r;for(const d of this.testItemToInternal.values())(r=d.discoverCts)===null||r===void 0||r.dispose(!0),d.actual[D.TestItemHookProperty]=void 0;this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}addItem(r,d,_){if(!(r instanceof D.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${r.id} did not`);if(this.testItemToInternal.has(r))throw new Error(`Attempted to add a single TestItem ${r.id} multiple times to the tree`);if(this.testIdToInternal.object.has(r.id))throw new Error(`Attempted to insert a duplicate test item ID ${r.id}`);const g=_?_.item.extId:null,w=r.expandable?1:0,u=_==null?void 0:_.expandLevels,c={provider:d,tree:this.testIdToInternal.object.id},s={actual:r,parent:g,item:A.TestItem.from(r),expandLevels:u&&w===1?u-1:void 0,expand:w,src:c};this.testIdToInternal.object.add(s),this.testItemToInternal.set(r,s),this.pushDiff([0,{parent:g,src:c,expand:w,item:s.item}]),r[D.TestItemHookProperty]={created:t=>this.addItem(t,d,s),delete:t=>this.removeItembyId(t),invalidate:t=>this.pushDiff([4,t]),setProp:(t,i)=>this.pushDiff([1,{extId:r.id,item:{[t]:i}}])};for(const t of r.children)this.addItem(t,d,s)}expandChildren(r,d){if(!(d<0)){const _=[...r.actual.children].map(g=>this.expand(g.id,d-1)).filter(S.isThenable);if(_.length)return Promise.all(_).then(()=>{})}}refreshChildren(r){r.discoverCts&&r.discoverCts.dispose(!0),r.expand=2,r.discoverCts=new R.CancellationTokenSource,this.pushExpandStateUpdate(r);const d=new S.DeferredPromise;return r.initialExpand=d,r.actual.discoverChildren({report:_=>{_.busy?(r.expand=2,this.pushExpandStateUpdate(r)):(r.expand=3,d.isSettled||d.complete(),this.pushExpandStateUpdate(r))}},r.discoverCts.token),d}pushExpandStateUpdate(r){this.pushDiff([1,{extId:r.actual.id,expand:r.expand}])}removeItembyId(r){var d;this.pushDiff([2,r]);const _=[this.testIdToInternal.object.get(r)];for(;_.length;){const g=_.pop();if(!!g){(d=g.discoverCts)===null||d===void 0||d.dispose(!0),this.testIdToInternal.object.delete(g.item.extId),this.testItemToInternal.delete(g.actual);for(const w of g.actual.children)_.push(this.testIdToInternal.object.get(w.id))}}}flushDiff(){const r=this.collectDiff();r.length&&this.publishDiff(r)}}e.SingleUseTestCollection=b}),define(be[179],we([0,1,25,3,11]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=A;class D{constructor(T){this._onDidChange=new S.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=T,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const T of this._extensionDescriptions){if(this._extensionsMap.has(E.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(E.ExtensionIdentifier.toKey(T.identifier),T),this._extensionsArr.push(T),Array.isArray(T.activationEvents))for(let k of T.activationEvents)k==="onUri"&&(k=`onUri:${E.ExtensionIdentifier.toKey(T.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(T)}}keepOnly(T){const k=new Set;T.forEach(b=>k.add(E.ExtensionIdentifier.toKey(b))),this._extensionDescriptions=this._extensionDescriptions.filter(b=>k.has(E.ExtensionIdentifier.toKey(b.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(T,k){T.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(T));const b=D._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(b.map(m=>m.identifier)),k.length>0){const m=new Set;k.forEach(r=>m.add(E.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!m.has(E.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(b)}static _findLoopingExtensions(T){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,g){this.addNode(_),this.addNode(g),this._arcs.has(_)?this._arcs.get(_).push(g):this._arcs.set(_,[g])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,g){const w=k.getArcs(_);for(let u=0;u<w.length;u++)if(!g.has(w[u]))return!1;return!0}getNodes(){return this._nodesArr}};let b=new Map;for(let _ of T){const g=E.ExtensionIdentifier.toKey(_.identifier);if(b.set(g,_),_.extensionDependencies)for(let w of _.extensionDependencies){const u=E.ExtensionIdentifier.toKey(w);k.addArc(g,u)}}let m=new Set;k.getNodes().filter(_=>k.getArcs(_).length===0).forEach(_=>m.add(_));let r=k.getNodes().filter(_=>!m.has(_)),d;do{d=!1;for(let _=0;_<r.length;_++){const g=r[_];k.hasOnlyGoodArcs(g,m)&&(r.splice(_,1),_--,m.add(g),d=!0)}}while(d);return r.map(_=>b.get(_))}containsActivationEvent(T){return this._activationMap.has(T)}containsExtension(T){return this._extensionsMap.has(E.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const k=this._activationMap.get(T);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(T){const k=this._extensionsMap.get(E.ExtensionIdentifier.toKey(T));return k||void 0}}e.ExtensionDescriptionRegistry=D;var I;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(I||(I={}));function y(n,T){const k=n.isBuiltin?0:n.isUnderDevelopment?2:1,b=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(k!==b)return k-b;const m=R.posix.basename(n.extensionLocation.path),r=R.posix.basename(T.extensionLocation.path);return m<r?-1:m>r?1:0}}),define(be[180],we([0,1,26]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var S;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function A(I){const y=E.VSBuffer.alloc(1);switch(I){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=A;function D(I,y){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=D}),define(be[34],we([0,1,3,2,4,25,147]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwRequiresWorkspaceTrustError=e.checkRequiresWorkspaceTrust=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:S.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,R.createDecorator)("extensionService");class I{constructor(c){this.dependency=c}}e.MissingDependencyError=I;var y;(function(u){u[u.LocalProcess=0]="LocalProcess",u[u.LocalWebWorker=1]="LocalWebWorker",u[u.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(c,s,t,i){this.codeLoadingTime=c,this.activateCallTime=s,this.activateResolvedTime=t,this.activationReason=i}}e.ActivationTimes=n;class T{constructor(c,s){this.description=c,this.value=s}}e.ExtensionPointContribution=T,e.ExtensionHostLogFileName="exthost";var k;(function(u){u[u.Normal=0]="Normal",u[u.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function b(u){u.enableProposedApi||m(u)}e.checkProposedApiEnabled=b;function m(u){throw new Error(`[${u.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${u.identifier.value}`)}e.throwProposedApiError=m;function r(u){var c;((c=u.workspaceTrust)===null||c===void 0?void 0:c.required)||d(u)}e.checkRequiresWorkspaceTrust=r;function d(u){throw new Error(`[${u.identifier.value}]: This API is only available when the "workspaceTrust.require" is set to "onStart" or "onDemand" in the extension's package.json.`)}e.throwRequiresWorkspaceTrustError=d;function _(u){return{type:u.isBuiltin?0:1,isBuiltin:u.isBuiltin||u.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(u.publisher,u.name),uuid:u.uuid},manifest:u,location:u.extensionLocation}}e.toExtension=_;function g(u){return Object.assign(Object.assign({identifier:new A.ExtensionIdentifier(u.identifier.id),isBuiltin:u.type===0,isUserBuiltin:u.type===1&&u.isBuiltin,isUnderDevelopment:!1,extensionLocation:u.location},u.manifest),{uuid:u.identifier.uuid})}e.toExtensionDescription=g;class w{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None}activateByEvent(c){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(c){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(c,s){}_activateById(c,s){return Promise.resolve()}_onWillActivateExtension(c){}_onDidActivateExtension(c,s,t,i,l){}_onExtensionRuntimeError(c,s){}_onExtensionHostExit(c){}}e.NullExtensionService=w}),define(be[181],we([0,1,129,25,34,19]),function(ae,e,E,S,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const D=Promise.resolve(void 0);class I{constructor(d,_,g,w){this.startup=d,this.codeLoadingTime=_,this.activateCallTime=g,this.activateResolvedTime=w}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class y{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,_){return d===-1||_===-1?-1:_-d}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class n{constructor(d,_,g,w,u,c){this.activationFailed=d,this.activationFailedError=_,this.activationTimes=g,this.module=w,this.exports=u,this.subscriptions=c}}e.ActivatedExtension=n;class T extends n{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class k extends n{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class b extends n{constructor(d){super(!0,d,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=b;let m=class{constructor(d,_,g,w,u){this._logService=u,this._registry=d,this._resolvedExtensionsSet=new Set,_.forEach(c=>this._resolvedExtensionsSet.add(S.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,g.forEach(c=>this._hostExtensionsMap.set(S.ExtensionIdentifier.toKey(c),c)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const _=S.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(_)}getActivatedExtension(d){const _=S.ExtensionIdentifier.toKey(d),g=this._activatedExtensions.get(_);if(!g)throw new Error("Extension `"+d.value+"` is not known or not activated");return g}activateByEvent(d,_){if(this._alreadyActivatedEvents[d])return D;const g=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(g.map(w=>({id:w.identifier,reason:{startup:_,extensionId:w.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,_){const g=this._registry.getExtensionDescription(d);if(!g)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:g.identifier,reason:_}])}_handleActivateRequest(d,_,g){if(this._hostExtensionsMap.has(S.ExtensionIdentifier.toKey(d.id))){_[S.ExtensionIdentifier.toKey(d.id)]=d;return}const w=this._registry.getExtensionDescription(d.id);if(!w){this._host.onExtensionActivationError(d.id,new R.MissingDependencyError(d.id.value));const s=new Error(`Unknown dependency '${d.id.value}'`);this._activatedExtensions.set(S.ExtensionIdentifier.toKey(d.id),new b(s));return}const u=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let c=!0;for(let s=0,t=u.length;s<t;s++){const i=u[s];if(!this._resolvedExtensionsSet.has(S.ExtensionIdentifier.toKey(i))){const l=this._activatedExtensions.get(S.ExtensionIdentifier.toKey(i));if(!(l&&!l.activationFailed)){if(l&&l.activationFailed){this._host.onExtensionActivationError(w.identifier,E.localize(0,null,w.displayName||w.identifier.value,i));const f=new Error(`Dependency ${i} failed to activate`);f.detail=l.activationFailedError,this._activatedExtensions.set(S.ExtensionIdentifier.toKey(w.identifier),new b(f));return}if(this._hostExtensionsMap.has(S.ExtensionIdentifier.toKey(i))){c=!1,_[S.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(S.ExtensionIdentifier.toKey(i)),reason:d.reason};continue}const o=this._registry.getExtensionDescription(i);if(o){c=!1,_[S.ExtensionIdentifier.toKey(i)]={id:o.identifier,reason:d.reason};continue}this._host.onExtensionActivationError(w.identifier,new R.MissingDependencyError(i));const a=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(S.ExtensionIdentifier.toKey(w.identifier),new b(a));return}}}c?_[S.ExtensionIdentifier.toKey(w.identifier)]=d:g.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(u=>!this._activatedExtensions.has(S.ExtensionIdentifier.toKey(u.id))),d.length===0))return Promise.resolve(void 0);const _=Object.create(null),g=[];for(let u=0,c=d.length;u<c;u++)this._handleActivateRequest(d[u],_,g);for(let u=0,c=g.length;u<c;u++){const s=S.ExtensionIdentifier.toKey(g[u].id);_[s]&&delete _[s]}const w=Object.keys(_).map(u=>_[u]);return g.length===0?Promise.all(w.map(u=>this._activateExtension(u.id,u.reason))).then(u=>{}):this._activateExtensions(w).then(u=>this._activateExtensions(g))}_activateExtension(d,_){const g=S.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(g))return Promise.resolve(void 0);const w=this._activatingExtensions.get(g);if(w)return w;const u=this._host.actualActivateExtension(d,_).then(void 0,c=>(this._host.onExtensionActivationError(d,E.localize(1,null,d.value,c.message)),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(c),new b(c))).then(c=>{this._activatedExtensions.set(g,c),this._activatingExtensions.delete(g)});return this._activatingExtensions.set(g,u),u}};m=je([Ke(4,A.ILogService)],m),e.ExtensionsActivator=m}),define(be[182],we([0,1,10]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class S{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,D)=>{this._actualOk=A,this._actualErr=D,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,E.onUnexpectedError)(A))}then(A,D){return this._ensureActual().then(A,D)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=S}),define(be[97],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(y,n){this.isMain=y,this.sid=n,this.nid=++E.count}}e.ProxyIdentifier=E,E.count=0;const S=[];function R(I){const y=new E(!0,I);return S[y.nid]=y,y}e.createMainContextProxyIdentifier=R;function A(I){const y=new E(!1,I);return S[y.nid]=y,y}e.createExtHostContextProxyIdentifier=A;function D(I){return S[I].sid}e.getStringIdentifierForProxy=D}),define(be[5],we([0,1,2,97,57]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var D;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(D=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(u){u[u.Markdown=1]="Markdown",u[u.Code=2]="Code"})(y=e.CellKind||(e.CellKind={}));var n;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var b;(function(u){u.name="$ident";function c(t,i){return Object.defineProperty(t,u.name,{value:i,enumerable:!0}),t}u.mixin=c;function s(t){return t[u.name]}u.of=s})(b=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(c){return c._id=m._n++,c}}e.IdObject=m,m._n=0;var r;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(r=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function g(u){if(u&&u.edits)for(const c of u.edits)typeof c.resource=="object"?c.resource=E.URI.revive(c.resource):(c.newUri=E.URI.revive(c.newUri),c.oldUri=E.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,R.revive)(c.metadata));return u}e.reviveWorkspaceEditDto=g;var w;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,S.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,S.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,S.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,S.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,S.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,S.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,S.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,S.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,S.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,S.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,S.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,S.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,S.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,S.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,S.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,S.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,S.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,S.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,S.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,S.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,S.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,S.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,S.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,S.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,S.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,S.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,S.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,S.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,S.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,S.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadTheming:(0,S.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,S.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,S.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,S.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,S.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,S.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,S.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,S.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,S.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,S.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,S.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,S.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,S.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,S.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,S.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,S.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,S.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,S.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,S.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,S.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,S.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,S.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,S.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,S.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,S.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,S.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,S.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,S.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,S.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,S.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,S.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[71],we([0,1,5,3,4]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(I){this._onDidChangePassword=new S.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(E.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,y){return this._proxy.$getPassword(I,y)}store(I,y,n){return this._proxy.$setPassword(I,y,n)}delete(I,y){return this._proxy.$deletePassword(I,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,R.createDecorator)("IExtHostSecretState")}),define(be[72],we([0,1,4,19,5,14]),function(ae,e,E,S,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,E.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(R.MainContext.MainThreadTelemetry)}report(y,n,T){const k=this.getUsageKey(y,n);this._reportedUsages.has(k)||(this._reportedUsages.add(k),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${T}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:y}))}getUsageKey(y,n){return`${y}-${n.identifier.value}`}};D=je([Ke(0,A.IExtHostRpcService),Ke(1,S.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(I,y,n){}})}),define(be[183],we([0,1,3,5,7,25]),function(ae,e,E,S,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new E.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new E.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(S.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,n,T,k={}){const b=A.ExtensionIdentifier.toKey(y.identifier),m=this._inFlightRequests.get(b)||[],r=T.sort().join(" ");let d=m.find(_=>_.scopes===r);if(d)return d.result;{const _=this._getSession(y,b,n,T,k);d={scopes:r,result:_},m.push(d),this._inFlightRequests.set(b,m);try{await _}finally{const g=m.findIndex(w=>w.scopes===r);g>-1&&(m.splice(g),this._inFlightRequests.set(b,m))}return _}}async _getSession(y,n,T,k,b={}){await this._proxy.$ensureProvider(T);const m=y.displayName||y.name;return this._proxy.$getSession(T,k,n,m,b)}async removeSession(y,n){const T=this._authenticationProviders.get(y);return T?T.provider.removeSession(n):this._proxy.$removeSession(y,n)}registerAuthenticationProvider(y,n,T,k){var b;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:n,provider:T,options:k!=null?k:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===y)||this._providers.push({id:y,label:n});const m=T.onDidChangeSessions(r=>{var d,_,g;this._proxy.$sendDidChangeSessions(y,{added:(d=r.added)!==null&&d!==void 0?d:[],changed:(_=r.changed)!==null&&_!==void 0?_:[],removed:(g=r.removed)!==null&&g!==void 0?g:[]})});return this._proxy.$registerAuthenticationProvider(y,n,(b=k==null?void 0:k.supportsMultipleAccounts)!==null&&b!==void 0?b:!1),new R.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(y);const r=this._providers.findIndex(d=>d.id===y);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,n){const T=this._authenticationProviders.get(y);if(T)return Promise.resolve(T.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,n){return this._onDidChangeSessions.fire({provider:{id:y,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,n){return y.forEach(T=>{this._providers.some(k=>k.id===T.id)||this._providers.push(T)}),n.forEach(T=>{const k=this._providers.findIndex(b=>b.id===T.id);k>-1&&this._providers.splice(k)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(be[184],we([0,1,5,14,9]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(I,y){this._extHostDocumentsAndEditors=y,this._proxy=I.getProxy(E.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const y=R.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};A=je([Ke(0,S.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[185],we([0,1,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class S{constructor(A){const D=A.getProxy(E.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(I){return D.$writeText(I)}})}}e.ExtHostClipboard=S}),define(be[73],we([0,1,12,7,9,23,5,15,19,57,33,39,2,6,4,14]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(D.MainContext.MainThreadCommands),this._logService=i,this.converter=new g(this,l=>{const o=this._apiCommands.get(l);return(o==null?void 0:o.result)===u.Void?o:void 0},i),this._argumentProcessors=[{processArgument(l){return(0,n.revive)(l)}},{processArgument(l){return(0,A.cloneAndChange)(l,function(o){if(T.Range.isIRange(o))return R.Range.to(o);if(k.Position.isIPosition(o))return R.Position.to(o);if(T.Range.isIRange(o.range)&&b.URI.isUri(o.uri))return R.location.to(o);if(!Array.isArray(o))return o})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...l)=>{const o=t.args.map((f,v)=>{if(!f.validate(l[v]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${l[v]}`);return f.convert(l[v])}),a=await this.executeCommand(t.internalId,...o);return t.result.convert(a,l,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new S.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,l,o,a){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:l,thisArg:o,description:a}),t&&this._proxy.$registerCommand(i),new S.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,l){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const o=(0,A.cloneAndChange)(i,function(a){if(a instanceof S.Position)return R.Position.from(a);if(a instanceof S.Range)return R.Range.from(a);if(a instanceof S.Location)return R.location.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,o,l);return(0,n.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw a}}}async _executeContributedCommand(t,i){const l=this._commands.get(t);if(!l)throw new Error("Unknown command");let{callback:o,thisArg:a,description:f}=l;if(f)for(let v=0;v<f.args.length;v++)try{(0,E.validateConstraint)(i[v],f.args[v].constraint)}catch(C){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[v].name}' - ${f.args[v].description}`)}try{return await o.apply(a,i)}catch(v){if(t===this.converter.delegatingCommandId){const C=this.converter.getActualCommand(...i);C&&(t=C.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(l=>this._argumentProcessors.reduce((o,a)=>a.processArgument(o),l)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(l=>l[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,l]of this._commands){let{description:o}=l;o&&(t[i]=o)}return Promise.resolve(t)}};_=je([Ke(0,d.IExtHostRpcService),Ke(1,y.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class g{constructor(t,i,l){this._commands=t,this._lookupApiCommand=i,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const l={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return l;const o=this._lookupApiCommand(t.command);if(o)l.id=o.internalId,l.arguments=o.args.map((a,f)=>a.convert(t.arguments&&t.arguments[f]));else if((0,I.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),i.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),l.$ident=a,l.id=this.delegatingCommandId,l.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return l}}fromInternal(t){const i=D.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class w{constructor(t,i,l,o){this.name=t,this.description=i,this.validate=l,this.convert=o}optional(){return new w(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new w(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=w,w.Uri=new w("uri","Uri of a text document",s=>b.URI.isUri(s),s=>s),w.Position=new w("position","A position in a text document",s=>S.Position.isPosition(s),R.Position.from),w.Range=new w("range","A range in a text document",s=>S.Range.isRange(s),R.Range.from),w.Selection=new w("selection","A selection in a text document",s=>S.Selection.isSelection(s),R.Selection.from),w.Number=new w("number","",s=>typeof s=="number",s=>s),w.String=new w("string","",s=>typeof s=="string",s=>s),w.CallHierarchyItem=new w("item","A call hierarchy item",s=>s instanceof S.CallHierarchyItem,R.CallHierarchyItem.to);class u{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=u,u.Void=new u("no result",s=>s);class c{constructor(t,i,l,o,a){this.id=t,this.internalId=i,this.description=l,this.args=o,this.result=a}}e.ApiCommand=c}),define(be[186],we([0,1,6,9,7,62,73,164,15,84]),function(ae,e,E,S,R,A,D,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",b(S.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(r,d)=>{if(!(0,y.isFalsyOrEmpty)(r)){class _ extends R.SymbolInformation{static to(w){const u=new _(w.name,S.SymbolKind.to(w.kind),w.containerName||"",new R.Location(d[0],S.Range.to(w.range)));return u.detail=w.detail,u.range=u.location.range,u.selectionRange=S.Range.to(w.selectionRange),u.children=w.children?w.children.map(_.to):[],u}}return r.map(_.to)}})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(S.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(S.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new D.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(S.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(S.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(S.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(d=>R.Position.isPosition(d)),r=>r.map(S.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(d=>{let _;for(const g of d.reverse())_=new R.SelectionRange(S.Range.to(g),_);return _}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const d=[];if(Array.isArray(r))for(let _ of r)d.push(..._[1].map(S.WorkspaceSymbol.to));return d})),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(S.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(S.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(S.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return S.WorkspaceEdit.to(r)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(S.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new R.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const d=(0,n.decodeSemanticTokensDto)(r);if(d.type==="full")return new R.SemanticTokens(d.data,void 0)}})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new R.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const d=(0,n.decodeSemanticTokensDto)(r);if(d.type==="full")return new R.SemanticTokens(d.data,void 0)}})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,d,_)=>{if(!r)return new R.CompletionList([]);const g=r.suggestions.map(w=>S.CompletionItem.to(w,_));return new R.CompletionList(g,r.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return S.SignatureHelp.to(r)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,d,_)=>b(g=>new R.CodeLens(S.Range.to(g.range),g.command&&_.fromInternal(g.command)))(r))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>R.Range.isRange(r),r=>R.Selection.isSelection(r)?S.Selection.from(r):S.Range.from(r)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,d,_)=>b(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return _.fromInternal(g.command)}else{const w=new R.CodeAction(g.title,g.kind?new R.CodeActionKind(g.kind):void 0);return g.edit&&(w.edit=S.WorkspaceEdit.to(g.edit)),g.command&&(w.command=_.fromInternal(g.command)),w.isPreferred=g.isPreferred,w}})(r))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(d=>new R.ColorInformation(S.Range.to(d.range),S.Color.to(d.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",r=>r instanceof R.Color,S.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:S.Range.from(r.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(S.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineHint objects",r=>r.map(S.InlineHint.to))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientMetadata:r.options.transientMetadata},filenamePattern:r.filenamePattern.map(d=>S.NotebookExclusiveDocumentPattern.to(d))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(S.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[S.ViewColumn.from(r.viewColumn),S.TextEditorOpenOptions.from(r)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[S.ViewColumn.from(r.viewColumn),S.TextEditorOpenOptions.from(r)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[S.ViewColumn.from(r.viewColumn),S.TextEditorOpenOptions.from(r)]).optional()],D.ApiCommandResult.Void)];class k{constructor(d){this._disposables=new E.DisposableStore,this._commands=d}static register(d){return T.forEach(d.registerApiCommand,d),new k(d).registerCommands()}registerCommands(){const d=_=>(...g)=>_(this._commands,...g);this._register(I.RemoveFromRecentlyOpenedAPICommand.ID,d(I.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:_=>typeof _=="string"}]}),this._register(I.OpenIssueReporter.ID,d(I.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:_=>typeof _=="string"||typeof _=="object"&&typeof _.extensionId=="string"}]})}_register(d,_,g){const w=this._commands.registerCommand(!1,d,_,this,g);this._disposables.add(w)}}e.ExtHostApiCommands=k;function b(r){return d=>{if(Array.isArray(d))return d.map(r)}}function m(r){if(!!Array.isArray(r)){const d=[];for(const _ of r)A.isLocationLink(_)?d.push(S.DefinitionLink.to(_)):d.push(S.location.to(_));return d}}}),define(be[187],we([0,1,13,51,3,6,2,62,25,9,7,5]),function(ae,e,E,S,R,A,D,I,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class b{constructor(c,s,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(k.MainContext.MainThreadComments),s.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const l=this._commentControllers.get(i.handle);return l||i}else if(i&&i.$mid===7){const l=this._commentControllers.get(i.commentControlHandle);if(!l)return i;const o=l.getCommentThread(i.commentThreadHandle);return o||i}else if(i&&i.$mid===8){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const o=l.getCommentThread(i.thread.commentThreadHandle);return o?{thread:o,text:i.text}:i}else if(i&&i.$mid===9){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const o=l.getCommentThread(i.thread.commentThreadHandle);if(!o)return i;let a=i.commentUniqueId,f=o.getCommentByUniqueId(a);return f||i}else if(i&&i.$mid===10){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const o=l.getCommentThread(i.thread.commentThreadHandle);if(!o)return i;let a=i.text,f=i.commentUniqueId,v=o.getCommentByUniqueId(f);return v?(v.body=a,v):i}return i}})}createCommentController(c,s,t){const i=b.handlePool++,l=new r(c,i,this._proxy,s,t);this._commentControllers.set(l.handle,l);const o=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return o.push(l),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(c.identifier),o),l}$createCommentThreadTemplate(c,s,t){const i=this._commentControllers.get(c);!i||i.$createCommentThreadTemplate(s,t)}async $updateCommentThreadTemplate(c,s,t){const i=this._commentControllers.get(c);!i||i.$updateCommentThreadTemplate(s,t)}$deleteCommentThread(c,s){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(s)}$provideCommentingRanges(c,s,t){const i=this._commentControllers.get(c);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const l=this._documents.getDocument(D.URI.revive(s));return(0,E.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(l,t)).then(o=>o?o.map(a=>n.Range.from(a)):void 0)}$toggleReaction(c,s,t,i,l){const o=this._commentControllers.get(c);return!o||!o.reactionHandler?Promise.resolve(void 0):(0,E.asPromise)(()=>{const a=o.getCommentThread(s);if(a){const f=a.getCommentByUniqueId(i.uniqueIdInThread);if(o!==void 0&&f&&o.reactionHandler)return o.reactionHandler(f,g(l))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=b,b.handlePool=0;class m{constructor(c,s,t,i,l,o,a){this._proxy=c,this._commentController=s,this._id=t,this._uri=i,this._range=l,this._comments=o,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new R.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${s.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=o}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),s={};c("range")&&(s.range=n.Range.from(this._range)),c("label")&&(s.label=this.label),c("contextValue")&&(s.contextValue=this.contextValue),c("comments")&&(s.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(s.collapseState=w(this._collapseState)),c("canReply")&&(s.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,s)}}getCommentByUniqueId(c){for(let s of this._commentsMap){let t=s[0],i=s[1];if(c===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,je([(0,S.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class r{constructor(c,s,t,i,l){this._extension=c,this._handle=s,this._proxy=t,this._id=i,this._label=l,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,l)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,s,t,i){if(typeof c=="string"){const l=new m(this._proxy,this,c,s,t,i,this._extension.identifier);return this._threads.set(l.handle,l),l}else{const l=new m(this._proxy,this,void 0,c,s,t,this._extension.identifier);return this._threads.set(l.handle,l),l}}$createCommentThreadTemplate(c,s){const t=new m(this._proxy,this,void 0,D.URI.revive(c),n.Range.to(s),[],this._extension.identifier);return t.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,s){let t=this._threads.get(c);t&&(t.range=n.Range.to(s))}$deleteCommentThread(c){let s=this._threads.get(c);s&&s.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(u,c,s,t){let i=t.get(s);i||(i=++u.commentHandle,t.set(s,i));const l=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:i,body:n.MarkdownString.from(s.body),userName:s.author.name,userIconPath:l,label:s.label,commentReactions:s.reactions?s.reactions.map(o=>_(o)):void 0}}function _(u){return{label:u.label,iconPath:u.iconPath?n.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function g(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?D.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function w(u){if(u!==void 0)switch(u){case T.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}}),define(be[98],we([0,1,2,5,7,4,14,19,15,8,11]),function(ae,e,E,S,R,A,D,I,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class cn{constructor(m,r){this._logService=r,this._provider=new Map,this._proxy=m.getProxy(S.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,r){const d=cn._handlePool++;this._provider.set(d,{provider:m,extensionId:r}),this._proxy.$registerDecorationProvider(d,r.value);const _=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(g=>{if(!g){this._proxy.$onDidChange(d,null);return}let w=(0,y.asArray)(g);if(w.length<=cn._maxEventSize){this._proxy.$onDidChange(d,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,w.length);const u=w.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),c=(0,y.groupBy)(u,(t,i)=>t.rank-i.rank||(0,n.compare)(t.uri.path,i.uri.path));let s=[];e:for(let t of c){let i;for(let l of t){let o=(0,T.dirname)(l.uri.path);if(i!==o&&(i=o,s.push(l.uri)>=cn._maxEventSize))break e}}this._proxy.$onDidChange(d,s)});return new R.Disposable(()=>{_==null||_.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(m,r,d){if(!this._provider.has(m))return Object.create(null);const _=Object.create(null),{provider:g,extensionId:w}=this._provider.get(m);return await Promise.all(r.map(async u=>{try{const{uri:c,id:s}=u,t=await Promise.resolve(g.provideFileDecoration(E.URI.revive(c),d));if(!t)return;try{R.FileDecoration.validate(t),_[s]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${w.value}': ${i}`)}}catch(c){this._logService.error(c)}})),_}};k._handlePool=0,k._maxEventSize=250,k=je([Ke(0,D.IExtHostRpcService),Ke(1,I.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(be[188],we([0,1,128,87,2,5,7,9,3,19,22]),function(ae,e,E,S,R,A,D,I,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(r,d,_,g,w){this._name=r,this._owner=d,this._maxDiagnosticsPerFile=_,this._proxy=g,this._onDidChangeDiagnostics=w,this._isDisposed=!1,this._data=new T.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,d){if(!r){this.clear();return}this._checkDisposed();let _=[];if(R.URI.isUri(r)){if(!d){this.delete(r);return}this._data.set(r,d.slice()),_=[r]}else if(Array.isArray(r)){_=[];let w;r=[...r].sort(k._compareIndexedTuplesByUri);for(const u of r){const[c,s]=u;if((!w||c.toString()!==w.toString())&&(w&&this._data.get(w).length===0&&this._data.delete(w),w=c,_.push(c),this._data.set(c,[])),s){const t=this._data.get(c);t&&t.push(...s)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!!this._proxy){const g=[];for(let w of _){let u=[];const c=this._data.get(w);if(c)if(c.length>this._maxDiagnosticsPerFile){u=[];const s=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of c)if(i.severity===s[t]&&u.push(I.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;u.push({severity:S.MarkerSeverity.Info,message:(0,E.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=c.map(s=>I.Diagnostic.from(s));g.push([w,u])}this._proxy.$changeMany(this._owner,g)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,d){this._checkDisposed();for(let _ of this._data.keys())r.apply(d,[_,this.get(_),this])}get(r){this._checkDisposed();const d=this._data.get(r);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,d){return r[0].toString()<d[0].toString()?-1:r[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=k;let b=class Bt{constructor(r,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,Bt._debouncer,50),Bt._mapper),this._proxy=r.getProxy(A.MainContext.MainThreadDiagnostics)}static _debouncer(r,d){return r?r.concat(d):d}static _mapper(r){const d=[],_=new Set;for(const g of r)typeof g=="string"?_.has(g)||(_.add(g),d.push(R.URI.parse(g))):_.has(g.toString())||(_.add(g.toString()),d.push(g));return Object.freeze(d),{uris:d}}createDiagnosticCollection(r,d){const{_collections:_,_proxy:g,_onDidChangeDiagnostics:w,_logService:u}=this,c=new class{$changeMany(i,l){g.$changeMany(i,l),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,i,l.length===0?"CLEARING":l)}$clear(i){g.$clear(i),u.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,i)}dispose(){g.dispose()}};let s;if(!d)d="_generated_diagnostic_collection_name_#"+Bt._idPool++,s=d;else if(!_.has(d))s=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do s=d+Bt._idPool++;while(_.has(s))}return new class extends k{constructor(){super(d,s,Bt._maxDiagnosticsPerFile,c,w);_.set(s,this)}dispose(){super.dispose(),_.delete(s)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const d=new Map,_=[];for(const g of this._collections.values())g.forEach((w,u)=>{let c=d.get(w.toString());typeof c=="undefined"&&(c=_.length,d.set(w.toString(),c),_.push([w,[]])),_[c][1]=_[c][1].concat(...u)});return _}}_getDiagnostics(r){let d=[];for(let _ of this._collections.values())_.has(r)&&(d=d.concat(_.get(r)));return d}$acceptMarkersChange(r){if(!this._mirrorCollection){const d="_generated_mirror",_=new k(d,d,Bt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,_),this._mirrorCollection=_}for(const[d,_]of r)this._mirrorCollection.set(R.URI.revive(d),_.map(I.Diagnostic.to))}};b._idPool=0,b._maxDiagnosticsPerFile=1e3,b=je([Ke(1,n.ILogService)],b),e.ExtHostDiagnostics=b}),define(be[189],we([0,1,2,5]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(D){this._proxy=D.getProxy(S.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(I=>I?I.map(y=>E.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(I=>I?E.URI.revive(I):void 0)}}e.ExtHostDialogs=R}),define(be[190],we([0,1,10,2,7,5,16,20,8]),function(ae,e,E,S,R,A,D,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(k,b,m){this._documentsAndEditors=b,this._logService=m,this._documentContentProviders=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,b){if(Object.keys(D.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const m=n._handlePool++;this._documentContentProviders.set(m,b),this._proxy.$registerTextContentProvider(m,k);let r;return typeof b.onDidChange=="function"&&(r=b.onDidChange(d=>{if(d.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(m,d).then(_=>{if(!(!_&&typeof _!="string")){const g=this._documentsAndEditors.getDocument(d);if(!!g){const w=(0,y.splitLines)(_);if(!g.equalLines(w))return this._proxy.$onVirtualDocumentChange(d,_)}}},E.onUnexpectedError)})),new R.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(k,b){const m=this._documentContentProviders.get(k);return m?Promise.resolve(m.provideTextDocumentContent(S.URI.revive(b),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${b.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(be[191],we([0,1,3,6,2,5,94,9,12,23]),function(ae,e,E,S,R,A,D,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(b,m){this._onDidAddDocument=new E.Emitter,this._onDidRemoveDocument=new E.Emitter,this._onDidChangeDocument=new E.Emitter,this._onDidSaveDocument=new E.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new S.DisposableStore,this._documentLoader=new Map,this._proxy=b.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const d of r)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const d of r)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(b){if(!!b){const m=this._documentsAndEditors.getDocument(b);if(m)return m}}getDocument(b){const m=this.getDocumentData(b);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${b}'`);return m.document}ensureDocumentData(b){const m=this._documentsAndEditors.getDocument(b);if(m)return Promise.resolve(m);let r=this._documentLoader.get(b.toString());return r||(r=this._proxy.$tryOpenDocument(b).then(d=>{this._documentLoader.delete(b.toString());const _=R.URI.revive(d);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(_))},d=>(this._documentLoader.delete(b.toString()),Promise.reject(d))),this._documentLoader.set(b.toString(),r)),r}createDocumentData(b){return this._proxy.$tryCreateDocument(b).then(m=>R.URI.revive(m))}$acceptModelModeChanged(b,m){const r=R.URI.revive(b),d=this._documentsAndEditors.getDocument(r);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(m),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(b){const m=R.URI.revive(b),r=this._documentsAndEditors.getDocument(m);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(b,m){const r=R.URI.revive(b),d=this._documentsAndEditors.getDocument(r);if(!d)throw new Error("unknown document");d._acceptIsDirty(m),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(b,m,r){const d=R.URI.revive(b),_=this._documentsAndEditors.getDocument(d);if(!_)throw new Error("unknown document");_._acceptIsDirty(r),_.onEvents(m),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:_.document,contentChanges:m.changes.map(g=>({range:I.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text}))}))}setWordDefinitionFor(b,m){(0,D.setWordDefinitionFor)(b,m)}}e.ExtHostDocuments=T}),define(be[40],we([0,1,43,3,6,2,4,5,94,14,96,9,19,22,16,54,106]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class g{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(c,s){this._extHostRpc=c,this._logService=s,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new S.Emitter,this._onDidRemoveDocuments=new S.Emitter,this._onDidChangeVisibleTextEditors=new S.Emitter,this._onDidChangeActiveTextEditor=new S.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const s=[],t=[],i=[];if(c.removedDocuments)for(const l of c.removedDocuments){const o=A.URI.revive(l),a=this._documents.get(o);(a==null?void 0:a.unref())&&(this._documents.delete(o),s.push(a.value))}if(c.addedDocuments)for(const l of c.addedDocuments){const o=A.URI.revive(l.uri);let a=this._documents.get(o);if(a&&o.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${o} already exists!'`);a||(a=new g(new y.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),o,l.lines,l.EOL,l.versionId,l.modeId,l.isDirty,l.notebook)),this._documents.set(o,a),t.push(a.value)),a.ref()}if(c.removedEditors)for(const l of c.removedEditors){const o=this._editors.get(l);this._editors.delete(l),o&&i.push(o)}if(c.addedEditors)for(const l of c.addedEditors){const o=A.URI.revive(l.documentUri);E.ok(this._documents.has(o),`document '${o}' does not exist`),E.ok(!this._editors.has(l.id),`editor '${l.id}' already exists!`);const a=this._documents.get(o).value,f=new T.ExtHostTextEditor(l.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>a.document),l.selections.map(k.Selection.to),l.options,l.visibleRanges.map(v=>k.Range.to(v)),typeof l.editorPosition=="number"?k.ViewColumn.to(l.editorPosition):void 0);this._editors.set(l.id,f)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,R.dispose)(s),(0,R.dispose)(i),c.removedDocuments&&this._onDidRemoveDocuments.fire(s),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(l=>l.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var s;return(s=this._documents.get(c))===null||s===void 0?void 0:s.value}allDocuments(){return d.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const s=this._editors.get(this._activeEditorId);return c?s:s==null?void 0:s.value}}allEditors(){return[...this._editors.values()]}};w=je([Ke(0,n.IExtHostRpcService),Ke(1,b.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[192],we([0,1,2,5,6,7,9,116,8,26]),function(ae,e,E,S,R,A,D,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const r=this._schemes.indexOf(m);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),r=[];let d,_,g=14,w=14;for(const u of m){let c=d?(0,y.commonPrefixLength)(d,u):0;for(c===0?_=1:_=w;c<u.length;c++)c+1===u.length?(g=w,w=9):w+=1,r.push([_,u.toUpperCase().charCodeAt(c),w]),r.push([_,u.toLowerCase().charCodeAt(c),w]),_=w;d=u,w=g}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new I.StateMachine(r)}}provideDocumentLinks(m){this._initStateMachine();const r=[],d=I.LinkComputer.computeLinks({getLineContent(_){return m.lineAt(_-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const _ of d){const g=D.DocumentLink.to(_);g.target&&r.push(g)}return r}}class k{constructor(m,r){this._extHostLanguageFeatures=r,this._linkProvider=new T,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(S.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,r,d,_={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const g=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(g,d);let w=2;_.isCaseSensitive&&(w+=1024),_.isReadonly&&(w+=2048),typeof d.copy=="function"&&(w+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(w+=4),this._proxy.$registerFileSystemProvider(g,r,w).catch(c=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${r}`),console.error(c)});const u=d.onDidChangeFile(c=>{const s=[];for(const t of c){let{uri:i,type:l}=t;if(i.scheme===r){let o;switch(l){case A.FileChangeType.Changed:o=0;break;case A.FileChangeType.Created:o=1;break;case A.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:i,type:o})}}this._proxy.$onFileSystemChange(g,s)});return(0,R.toDisposable)(()=>{u.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(m){const{type:r,ctime:d,mtime:_,size:g}=m;return{type:r,ctime:d,mtime:_,size:g}}$stat(m,r){return Promise.resolve(this._getFsProvider(m).stat(E.URI.revive(r))).then(k._asIStat)}$readdir(m,r){return Promise.resolve(this._getFsProvider(m).readDirectory(E.URI.revive(r)))}$readFile(m,r){return Promise.resolve(this._getFsProvider(m).readFile(E.URI.revive(r))).then(d=>n.VSBuffer.wrap(d))}$writeFile(m,r,d,_){return Promise.resolve(this._getFsProvider(m).writeFile(E.URI.revive(r),d.buffer,_))}$delete(m,r,d){return Promise.resolve(this._getFsProvider(m).delete(E.URI.revive(r),d))}$rename(m,r,d,_){return Promise.resolve(this._getFsProvider(m).rename(E.URI.revive(r),E.URI.revive(d),_))}$copy(m,r,d,_){const g=this._getFsProvider(m);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(E.URI.revive(r),E.URI.revive(d),_))}$mkdir(m,r){return Promise.resolve(this._getFsProvider(m).createDirectory(E.URI.revive(r)))}$watch(m,r,d,_){const g=this._getFsProvider(m).watch(E.URI.revive(d),_);this._watches.set(r,g)}$unwatch(m,r){const d=this._watches.get(r);d&&(d.dispose(),this._watches.delete(r))}$open(m,r,d){const _=this._getFsProvider(m);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(E.URI.revive(r),d))}$close(m,r){const d=this._getFsProvider(m);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(r))}$read(m,r,d,_){const g=this._getFsProvider(m);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const w=n.VSBuffer.alloc(_);return Promise.resolve(g.read(r,d,w.buffer,0,_)).then(u=>w.slice(0,u))}$write(m,r,d,_){const g=this._getFsProvider(m);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(r,d,_.buffer,0,_.byteLength))}_getFsProvider(m){const r=this._fsProvider.get(m);if(!r){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return r}}e.ExtHostFileSystem=k}),define(be[74],we([0,1,5,64,7,26,4,14,48]),function(ae,e,E,S,R,A,D,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Rt{constructor(k,b){const m=k.getProxy(E.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return m.$stat(r).catch(Rt._handleError)},readDirectory(r){return m.$readdir(r).catch(Rt._handleError)},createDirectory(r){return m.$mkdir(r).catch(Rt._handleError)},async readFile(r){return m.$readFile(r).then(d=>d.buffer).catch(Rt._handleError)},writeFile(r,d){return m.$writeFile(r,A.VSBuffer.wrap(d)).catch(Rt._handleError)},delete(r,d){return m.$delete(r,Object.assign({recursive:!1,useTrash:!1},d)).catch(Rt._handleError)},rename(r,d,_){return m.$rename(r,d,Object.assign({overwrite:!1},_)).catch(Rt._handleError)},copy(r,d,_){return m.$copy(r,d,Object.assign({overwrite:!1},_)).catch(Rt._handleError)},isWritableFileSystem(r){const d=b.getCapabilities(r);if(typeof d=="number")return!(d&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new R.FileSystemError(String(k));if(k.name==="ENOPRO")throw R.FileSystemError.Unavailable(k.message);switch(k.name){case S.FileSystemProviderErrorCode.FileExists:throw R.FileSystemError.FileExists(k.message);case S.FileSystemProviderErrorCode.FileNotFound:throw R.FileSystemError.FileNotFound(k.message);case S.FileSystemProviderErrorCode.FileNotADirectory:throw R.FileSystemError.FileNotADirectory(k.message);case S.FileSystemProviderErrorCode.FileIsADirectory:throw R.FileSystemError.FileIsADirectory(k.message);case S.FileSystemProviderErrorCode.NoPermissions:throw R.FileSystemError.NoPermissions(k.message);case S.FileSystemProviderErrorCode.Unavailable:throw R.FileSystemError.Unavailable(k.message);default:throw new R.FileSystemError(k.message,k.name)}}};n=je([Ke(0,I.IExtHostRpcService),Ke(1,y.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(be[193],we([0,1,6,5]),function(ae,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class R{constructor(D){this._handlePool=0,this._proxy=D.getProxy(S.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,D),(0,E.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=R}),define(be[194],we([0,1,2,23,9,7,13,5,8,33,15,12,113,6,84,53,92,55,10]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d,_,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(N,K){this._documents=N,this._provider=K}provideDocumentSymbols(N,K){const ee=this._documents.getDocument(N);return(0,D.asPromise)(()=>this._provider.provideDocumentSymbols(ee,K)).then(oe=>{if(!(0,T.isFalsyOrEmpty)(oe))return oe[0]instanceof A.DocumentSymbol?oe.map(R.DocumentSymbol.from):u._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree(N){var K;N=N.slice(0).sort((me,Se)=>{let Me=me.location.range.start.compareTo(Se.location.range.start);return Me===0&&(Me=Se.location.range.end.compareTo(me.location.range.end)),Me});const ee=[],oe=[];for(const me of N){const Se={name:me.name||"!!MISSING: name!!",kind:R.SymbolKind.from(me.kind),tags:((K=me.tags)===null||K===void 0?void 0:K.map(R.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:R.Range.from(me.location.range),selectionRange:R.Range.from(me.location.range),children:[]};for(;;){if(oe.length===0){oe.push(Se),ee.push(Se);break}const Me=oe[oe.length-1];if(n.Range.containsRange(Me.range,Se.range)&&!n.Range.equalsRange(Me.range,Se.range)){Me.children&&Me.children.push(Se),oe.push(Se);break}oe.pop()}}return ee}}class c{constructor(N,K,ee){this._documents=N,this._commands=K,this._provider=ee,this._cache=new _.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(N,K){const ee=this._documents.getDocument(N),oe=await this._provider.provideCodeLenses(ee,K);if(!(!oe||K.isCancellationRequested)){const me=this._cache.add(oe),Se=new m.DisposableStore;this._disposables.set(me,Se);const Me={cacheId:me,lenses:[]};for(let ge=0;ge<oe.length;ge++)Me.lenses.push({cacheId:[me,ge],range:R.Range.from(oe[ge].range),command:this._commands.toInternal(oe[ge].command,Se)});return Me}}async resolveCodeLens(N,K){var ee;const oe=N.cacheId&&this._cache.get(...N.cacheId);if(!!oe){let me;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?me=oe:me=await this._provider.resolveCodeLens(oe,K),me||(me=oe),!K.isCancellationRequested){const Se=N.cacheId&&this._disposables.get(N.cacheId[0]);if(!!Se)return N.command=this._commands.toInternal((ee=me.command)!==null&&ee!==void 0?ee:c._badCmd,Se),N}}}releaseCodeLenses(N){var K;(K=this._disposables.get(N))===null||K===void 0||K.dispose(),this._disposables.delete(N),this._cache.delete(N)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(ze){return Array.isArray(ze)?ze.map(R.DefinitionLink.from):ze?[R.DefinitionLink.from(ze)]:[]}class t{constructor(N,K){this._documents=N,this._provider=K}provideDefinition(N,K,ee){const oe=this._documents.getDocument(N),me=R.Position.to(K);return(0,D.asPromise)(()=>this._provider.provideDefinition(oe,me,ee)).then(s)}}class i{constructor(N,K){this._documents=N,this._provider=K}provideDeclaration(N,K,ee){const oe=this._documents.getDocument(N),me=R.Position.to(K);return(0,D.asPromise)(()=>this._provider.provideDeclaration(oe,me,ee)).then(s)}}class l{constructor(N,K){this._documents=N,this._provider=K}provideImplementation(N,K,ee){const oe=this._documents.getDocument(N),me=R.Position.to(K);return(0,D.asPromise)(()=>this._provider.provideImplementation(oe,me,ee)).then(s)}}class o{constructor(N,K){this._documents=N,this._provider=K}provideTypeDefinition(N,K,ee){const oe=this._documents.getDocument(N),me=R.Position.to(K);return(0,D.asPromise)(()=>this._provider.provideTypeDefinition(oe,me,ee)).then(s)}}class a{constructor(N,K){this._documents=N,this._provider=K}provideHover(N,K,ee){const oe=this._documents.getDocument(N),me=R.Position.to(K);return(0,D.asPromise)(()=>this._provider.provideHover(oe,me,ee)).then(Se=>{if(!(!Se||(0,T.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=oe.getWordRangeAtPosition(me)),Se.range||(Se.range=new A.Range(me,me)),R.Hover.from(Se)})}}class f{constructor(N,K){this._documents=N,this._provider=K}provideEvaluatableExpression(N,K,ee){const oe=this._documents.getDocument(N),me=R.Position.to(K);return(0,D.asPromise)(()=>this._provider.provideEvaluatableExpression(oe,me,ee)).then(Se=>{if(Se)return R.EvaluatableExpression.from(Se)})}}class v{constructor(N,K){this._documents=N,this._provider=K}provideInlineValues(N,K,ee,oe){const me=this._documents.getDocument(N);return(0,D.asPromise)(()=>this._provider.provideInlineValues(me,R.Range.to(K),R.InlineValueContext.to(ee),oe)).then(Se=>{if(Array.isArray(Se))return Se.map(Me=>R.InlineValue.from(Me))})}}class C{constructor(N,K){this._documents=N,this._provider=K}provideDocumentHighlights(N,K,ee){const oe=this._documents.getDocument(N),me=R.Position.to(K);return(0,D.asPromise)(()=>this._provider.provideDocumentHighlights(oe,me,ee)).then(Se=>{if(Array.isArray(Se))return Se.map(R.DocumentHighlight.from)})}}class h{constructor(N,K){this._documents=N,this._provider=K}provideLinkedEditingRanges(N,K,ee){const oe=this._documents.getDocument(N),me=R.Position.to(K);return(0,D.asPromise)(()=>this._provider.provideLinkedEditingRanges(oe,me,ee)).then(Se=>{if(Se&&Array.isArray(Se.ranges))return{ranges:(0,T.coalesce)(Se.ranges.map(R.Range.from)),wordPattern:Se.wordPattern}})}}class p{constructor(N,K){this._documents=N,this._provider=K}provideReferences(N,K,ee,oe){const me=this._documents.getDocument(N),Se=R.Position.to(K);return(0,D.asPromise)(()=>this._provider.provideReferences(me,Se,ee,oe)).then(Me=>{if(Array.isArray(Me))return Me.map(R.location.from)})}}class P{constructor(N,K,ee,oe,me,Se,Me){this._documents=N,this._commands=K,this._diagnostics=ee,this._provider=oe,this._logService=me,this._extension=Se,this._apiDeprecation=Me,this._cache=new _.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(N,K,ee,oe){const me=this._documents.getDocument(N),Se=b.Selection.isISelection(K)?R.Selection.to(K):R.Range.to(K),Me=[];for(const Ce of this._diagnostics.getDiagnostics(N))if(Se.intersection(Ce.range)&&Me.push(Ce)>P._maxCodeActionsPerFile)break;const ge={diagnostics:Me,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:R.CodeActionTriggerKind.to(ee.trigger)};return(0,D.asPromise)(()=>this._provider.provideCodeActions(me,Se,ge,oe)).then(Ce=>{var Pe;if(!(!(0,T.isNonEmptyArray)(Ce)||oe.isCancellationRequested)){const xe=this._cache.add(Ce),_e=new m.DisposableStore;this._disposables.set(xe,_e);const qe=[];for(let V=0;V<Ce.length;V++){const Y=Ce[V];!Y||(P._isCommand(Y)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Y.title,command:this._commands.toInternal(Y,_e)})):(ge.only&&(Y.kind?ge.only.contains(Y.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${Y.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[xe,V],title:Y.title,command:Y.command&&this._commands.toInternal(Y.command,_e),diagnostics:Y.diagnostics&&Y.diagnostics.map(R.Diagnostic.from),edit:Y.edit&&R.WorkspaceEdit.from(Y.edit),kind:Y.kind&&Y.kind.value,isPreferred:Y.isPreferred,disabled:(Pe=Y.disabled)===null||Pe===void 0?void 0:Pe.reason})))}return{cacheId:xe,actions:qe}}})}async resolveCodeAction(N,K){var ee;const[oe,me]=N,Se=this._cache.get(oe,me);if(!(!Se||P._isCommand(Se))&&!!this._provider.resolveCodeAction){const Me=(ee=await this._provider.resolveCodeAction(Se,K))!==null&&ee!==void 0?ee:Se;return(Me==null?void 0:Me.edit)?R.WorkspaceEdit.from(Me.edit):void 0}}releaseCodeActions(N){var K;(K=this._disposables.get(N))===null||K===void 0||K.dispose(),this._disposables.delete(N),this._cache.delete(N)}static _isCommand(N){return typeof N.command=="string"&&typeof N.title=="string"}}P._maxCodeActionsPerFile=1e3;class F{constructor(N,K){this._documents=N,this._provider=K}provideDocumentFormattingEdits(N,K,ee){const oe=this._documents.getDocument(N);return(0,D.asPromise)(()=>this._provider.provideDocumentFormattingEdits(oe,K,ee)).then(me=>{if(Array.isArray(me))return me.map(R.TextEdit.from)})}}class z{constructor(N,K){this._documents=N,this._provider=K}provideDocumentRangeFormattingEdits(N,K,ee,oe){const me=this._documents.getDocument(N),Se=R.Range.to(K);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,Se,ee,oe)).then(Me=>{if(Array.isArray(Me))return Me.map(R.TextEdit.from)})}}class le{constructor(N,K){this._documents=N,this._provider=K,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(N,K,ee,oe,me){const Se=this._documents.getDocument(N),Me=R.Position.to(K);return(0,D.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Se,Me,ee,oe,me)).then(ge=>{if(Array.isArray(ge))return ge.map(R.TextEdit.from)})}}class H{constructor(N,K){this._provider=N,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(N,K){const ee=I.IdObject.mixin({symbols:[]});return(0,D.asPromise)(()=>this._provider.provideWorkspaceSymbols(N,K)).then(oe=>{if((0,T.isNonEmptyArray)(oe)){for(const me of oe)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const Se=I.IdObject.mixin(R.WorkspaceSymbol.from(me));this._symbolCache.set(Se._id,me),ee.symbols.push(Se)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(N,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return N;const ee=this._symbolCache.get(N._id);if(ee){const oe=await(0,D.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,K));return oe&&(0,S.mixin)(N,R.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(N){const K=this._resultCache.get(N);if(K){for(let[ee,oe]=K;ee<=oe;ee++)this._symbolCache.delete(ee);this._resultCache.delete(N)}}}class W{constructor(N,K,ee){this._documents=N,this._provider=K,this._logService=ee}static supportsResolving(N){return typeof N.prepareRename=="function"}provideRenameEdits(N,K,ee,oe){const me=this._documents.getDocument(N),Se=R.Position.to(K);return(0,D.asPromise)(()=>this._provider.provideRenameEdits(me,Se,ee,oe)).then(Me=>{if(!!Me)return R.WorkspaceEdit.from(Me)},Me=>{const ge=W._asMessage(Me);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Me)})}resolveRenameLocation(N,K,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(N),me=R.Position.to(K);return(0,D.asPromise)(()=>this._provider.prepareRename(oe,me,ee)).then(Se=>{let Me,ge;if(A.Range.isRange(Se)?(Me=Se,ge=oe.getText(Se)):(0,k.isObject)(Se)&&(Me=Se.range,ge=Se.placeholder),!!Me){if(Me.start.line>me.line||Me.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:R.Range.from(Me),text:ge}}},Se=>{const Me=W._asMessage(Se);return Me?{rejectReason:Me,range:void 0,text:void 0}:Promise.reject(Se)})}static _asMessage(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class G{constructor(N,K){this.resultId=N,this.tokens=K}}class L{constructor(N,K){this._documents=N,this._provider=K,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(N,K,ee){const oe=this._documents.getDocument(N),me=K!==0?this._previousResults.get(K):null;return(0,D.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,me.resultId,ee):this._provider.provideDocumentSemanticTokens(oe,ee)).then(Se=>(me&&this._previousResults.delete(K),Se?(Se=L._fixProvidedSemanticTokens(Se),this._send(L._convertToEdits(me,Se),Se)):null))}async releaseDocumentSemanticColoring(N){this._previousResults.delete(N)}static _fixProvidedSemanticTokens(N){return L._isSemanticTokens(N)?L._isCorrectSemanticTokens(N)?N:new A.SemanticTokens(new Uint32Array(N.data),N.resultId):L._isSemanticTokensEdits(N)?L._isCorrectSemanticTokensEdits(N)?N:new A.SemanticTokensEdits(N.edits.map(K=>new A.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),N.resultId):N}static _isSemanticTokens(N){return N&&!!N.data}static _isCorrectSemanticTokens(N){return N.data instanceof Uint32Array}static _isSemanticTokensEdits(N){return N&&Array.isArray(N.edits)}static _isCorrectSemanticTokensEdits(N){for(const K of N.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(N,K){if(!L._isSemanticTokens(K)||!N||!N.tokens)return K;const ee=N.tokens,oe=ee.length,me=K.data,Se=me.length;let Me=0;const ge=Math.min(oe,Se);for(;Me<ge&&ee[Me]===me[Me];)Me++;if(Me===oe&&Me===Se)return new A.SemanticTokensEdits([],K.resultId);let Ce=0;const Pe=ge-Me;for(;Ce<Pe&&ee[oe-Ce-1]===me[Se-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Me,deleteCount:oe-Me-Ce,data:me.subarray(Me,Se-Ce)}],K.resultId)}_send(N,K){if(L._isSemanticTokens(N)){const ee=this._nextResultId++;return this._previousResults.set(ee,new G(N.resultId,N.data)),(0,r.encodeSemanticTokensDto)({id:ee,type:"full",data:N.data})}if(L._isSemanticTokensEdits(N)){const ee=this._nextResultId++;return L._isSemanticTokens(K)?this._previousResults.set(ee,new G(K.resultId,K.data)):this._previousResults.set(ee,new G(N.resultId)),(0,r.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(N.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=L;class U{constructor(N,K){this._documents=N,this._provider=K}provideDocumentRangeSemanticTokens(N,K,ee){const oe=this._documents.getDocument(N);return(0,D.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(oe,R.Range.to(K),ee)).then(me=>me?this._send(me):null)}_send(N){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}e.DocumentRangeSemanticTokensAdapter=U;class x{constructor(N,K,ee,oe,me){this._documents=N,this._commands=K,this._provider=ee,this._apiDeprecation=oe,this._extension=me,this._cache=new _.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}async provideCompletionItems(N,K,ee,oe){const me=this._documents.getDocument(N),Se=R.Position.to(K),Me=me.getWordRangeAtPosition(Se)||new A.Range(Se,Se),ge=Me.with({end:Se}),Ce=new g.StopWatch(!0),Pe=await(0,D.asPromise)(()=>this._provider.provideCompletionItems(me,Se,oe,R.CompletionContext.to(ee)));if(!!Pe&&!oe.isCancellationRequested){const xe=Array.isArray(Pe)?new A.CompletionList(Pe):Pe,_e=x.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),qe=new m.DisposableStore;this._disposables.set(_e,qe);const V=[],Y={x:_e,b:V,a:{replace:R.Range.from(Me),insert:R.Range.from(ge)},c:xe.isIncomplete||void 0,d:Ce.elapsed()};for(let ve=0;ve<xe.items.length;ve++){const Le=xe.items[ve],Be=this._convertCompletionItem(Le,[_e,ve],ge,Me);V.push(Be)}return Y}}async resolveCompletionItem(N,K){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...N);if(!!ee){const oe=await(0,D.asPromise)(()=>this._provider.resolveCompletionItem(ee,K));if(!!oe)return this._convertCompletionItem(oe,N)}}}releaseCompletionItems(N){var K;(K=this._disposables.get(N))===null||K===void 0||K.dispose(),this._disposables.delete(N),this._cache.delete(N)}_convertCompletionItem(N,K,ee,oe){var me;const Se=this._disposables.get(K[0]);if(!Se)throw Error("DisposableStore is missing...");const Me={x:K,a:(me=N.label)!==null&&me!==void 0?me:"",o:N.label2,b:N.kind!==void 0?R.CompletionItemKind.from(N.kind):void 0,n:N.tags&&N.tags.map(R.CompletionItemTag.from),c:N.detail,d:typeof N.documentation=="undefined"?void 0:R.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters,l:N.additionalTextEdits&&N.additionalTextEdits.map(R.TextEdit.from),m:this._commands.toInternal(N.command,Se)};N.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Me.h=N.textEdit.newText):typeof N.insertText=="string"?Me.h=N.insertText:N.insertText instanceof A.SnippetString&&(Me.h=N.insertText.value,Me.i|=4);let ge;return N.textEdit?ge=N.textEdit.range:N.range&&(ge=N.range),A.Range.isRange(ge)?Me.j=R.Range.from(ge):ge&&(!(ee==null?void 0:ee.isEqual(ge.inserting))||!(oe==null?void 0:oe.isEqual(ge.replacing)))&&(Me.j={insert:R.Range.from(ge.inserting),replace:R.Range.from(ge.replacing)}),Me}}class Q{constructor(N,K){this._documents=N,this._provider=K,this._cache=new _.Cache("SignatureHelp")}provideSignatureHelp(N,K,ee,oe){const me=this._documents.getDocument(N),Se=R.Position.to(K),Me=this.reviveContext(ee);return(0,D.asPromise)(()=>this._provider.provideSignatureHelp(me,Se,oe,Me)).then(ge=>{if(ge){const Ce=this._cache.add([ge]);return Object.assign(Object.assign({},R.SignatureHelp.from(ge)),{id:Ce})}})}reviveContext(N){let K;if(N.activeSignatureHelp){const ee=R.SignatureHelp.to(N.activeSignatureHelp),oe=this._cache.get(N.activeSignatureHelp.id,0);oe?(K=oe,K.activeSignature=ee.activeSignature,K.activeParameter=ee.activeParameter):K=ee}return Object.assign(Object.assign({},N),{activeSignatureHelp:K})}releaseSignatureHelp(N){this._cache.delete(N)}}class ${constructor(N,K){this._documents=N,this._provider=K}provideInlineHints(N,K,ee){const oe=this._documents.getDocument(N);return(0,D.asPromise)(()=>this._provider.provideInlineHints(oe,R.Range.to(K),ee)).then(me=>me?{hints:me.map(R.InlineHint.from)}:void 0)}}class Z{constructor(N,K){this._documents=N,this._provider=K,this._cache=new _.Cache("DocumentLink")}provideLinks(N,K){const ee=this._documents.getDocument(N);return(0,D.asPromise)(()=>this._provider.provideDocumentLinks(ee,K)).then(oe=>{if(!(!Array.isArray(oe)||oe.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.map(R.DocumentLink.from)};{const me=this._cache.add(oe),Se={links:[],id:me};for(let Me=0;Me<oe.length;Me++){const ge=R.DocumentLink.from(oe[Me]);ge.cacheId=[me,Me],Se.links.push(ge)}return Se}}})}resolveLink(N,K){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...N);return ee?(0,D.asPromise)(()=>this._provider.resolveDocumentLink(ee,K)).then(oe=>oe&&R.DocumentLink.from(oe)||void 0):Promise.resolve(void 0)}releaseLinks(N){this._cache.delete(N)}}class ie{constructor(N,K){this._documents=N,this._provider=K}provideColors(N,K){const ee=this._documents.getDocument(N);return(0,D.asPromise)(()=>this._provider.provideDocumentColors(ee,K)).then(oe=>Array.isArray(oe)?oe.map(Se=>({color:R.Color.from(Se.color),range:R.Range.from(Se.range)})):[])}provideColorPresentations(N,K,ee){const oe=this._documents.getDocument(N),me=R.Range.to(K.range),Se=R.Color.to(K.color);return(0,D.asPromise)(()=>this._provider.provideColorPresentations(Se,{document:oe,range:me},ee)).then(Me=>{if(!!Array.isArray(Me))return Me.map(R.ColorPresentation.from)})}}class re{constructor(N,K){this._documents=N,this._provider=K}provideFoldingRanges(N,K,ee){const oe=this._documents.getDocument(N);return(0,D.asPromise)(()=>this._provider.provideFoldingRanges(oe,K,ee)).then(me=>{if(!!Array.isArray(me))return me.map(R.FoldingRange.from)})}}class ye{constructor(N,K,ee){this._documents=N,this._provider=K,this._logService=ee}provideSelectionRanges(N,K,ee){const oe=this._documents.getDocument(N),me=K.map(R.Position.to);return(0,D.asPromise)(()=>this._provider.provideSelectionRanges(oe,me,ee)).then(Se=>{if(!(0,T.isNonEmptyArray)(Se))return[];if(Se.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Me=[];for(let ge=0;ge<me.length;ge++){const Ce=[];Me.push(Ce);let Pe=me[ge],xe=Se[ge];for(;;){if(!xe.range.contains(Pe))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(R.SelectionRange.from(xe)),!xe.parent)break;Pe=xe.range,xe=xe.parent}}return Me})}}class Ie{constructor(N,K){this._documents=N,this._provider=K,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(N,K,ee){const oe=this._documents.getDocument(N),me=R.Position.to(K),Se=await this._provider.prepareCallHierarchy(oe,me,ee);if(!!Se){const Me=this._idPool.nextId();return this._cache.set(Me,new Map),Array.isArray(Se)?Se.map(ge=>this._cacheAndConvertItem(Me,ge)):[this._cacheAndConvertItem(Me,Se)]}}async provideCallsTo(N,K,ee){const oe=this._itemFromCache(N,K);if(!oe)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(oe,ee);if(!!me)return me.map(Se=>({from:this._cacheAndConvertItem(N,Se.from),fromRanges:Se.fromRanges.map(Me=>R.Range.from(Me))}))}async provideCallsFrom(N,K,ee){const oe=this._itemFromCache(N,K);if(!oe)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(oe,ee);if(!!me)return me.map(Se=>({to:this._cacheAndConvertItem(N,Se.to),fromRanges:Se.fromRanges.map(Me=>R.Range.from(Me))}))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,K){var ee;const oe=this._cache.get(N),me={_sessionId:N,_itemId:oe.size.toString(36),name:K.name,detail:K.detail,kind:R.SymbolKind.from(K.kind),uri:K.uri,range:R.Range.from(K.range),selectionRange:R.Range.from(K.selectionRange),tags:(ee=K.tags)===null||ee===void 0?void 0:ee.map(R.SymbolTag.from)};return oe.set(me._itemId,K),me}_itemFromCache(N,K){const ee=this._cache.get(N);return ee==null?void 0:ee.get(K)}}class Ue{constructor(N,K){this.adapter=N,this.extension=K}}class Fe{constructor(N,K,ee,oe,me,Se,Me){this._adapter=new Map,this._uriTransformer=K,this._proxy=N.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=oe,this._diagnostics=me,this._logService=Se,this._apiDeprecation=Me}_transformDocumentSelector(N){return(0,T.coalesce)((0,T.asArray)(N).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(N){if(typeof N=="string")return{$serialized:!0,language:N};if(N)return{$serialized:!0,language:N.language,scheme:this._transformScheme(N.scheme),pattern:typeof N.pattern=="undefined"?void 0:R.GlobPattern.from(N.pattern),exclusive:N.exclusive}}_transformScheme(N){return this._uriTransformer&&typeof N=="string"?this._uriTransformer.transformOutgoingScheme(N):N}_createDisposable(N){return new A.Disposable(()=>{this._adapter.delete(N),this._proxy.$unregister(N)})}_nextHandle(){return Fe._handlePool++}_withAdapter(N,K,ee,oe,me=!1){const Se=this._adapter.get(N);if(!Se)return Promise.resolve(oe);if(Se.adapter instanceof K){let Me;Se.extension&&(Me=Date.now(),this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${K.name}'`));const ge=ee(Se.adapter,Se.extension),Ce=Se.extension;return Ce&&Promise.resolve(ge).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Me}ms`),Pe=>{me&&Pe instanceof w.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Pe))}),ge}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(N,K){const ee=this._nextHandle();return this._adapter.set(ee,new Ue(N,K)),ee}static _extLabel(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,K,ee,oe){const me=this._addNewAdapter(new u(this._documents,ee),N),Se=oe&&oe.label||Fe._extLabel(N);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(K),Se),this._createDisposable(me)}$provideDocumentSymbols(N,K,ee){return this._withAdapter(N,u,oe=>oe.provideDocumentSymbols(E.URI.revive(K),ee),void 0)}registerCodeLensProvider(N,K,ee){const oe=this._nextHandle(),me=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ue(new c(this._documents,this._commands.converter,ee),N)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(K),me);let Se=this._createDisposable(oe);if(me!==void 0){const Me=ee.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(me));Se=A.Disposable.from(Se,Me)}return Se}$provideCodeLenses(N,K,ee){return this._withAdapter(N,c,oe=>oe.provideCodeLenses(E.URI.revive(K),ee),void 0)}$resolveCodeLens(N,K,ee){return this._withAdapter(N,c,oe=>oe.resolveCodeLens(K,ee),void 0)}$releaseCodeLenses(N,K){this._withAdapter(N,c,ee=>Promise.resolve(ee.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(N,K,ee){const oe=this._addNewAdapter(new t(this._documents,ee),N);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDefinition(N,K,ee,oe){return this._withAdapter(N,t,me=>me.provideDefinition(E.URI.revive(K),ee,oe),[])}registerDeclarationProvider(N,K,ee){const oe=this._addNewAdapter(new i(this._documents,ee),N);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDeclaration(N,K,ee,oe){return this._withAdapter(N,i,me=>me.provideDeclaration(E.URI.revive(K),ee,oe),[])}registerImplementationProvider(N,K,ee){const oe=this._addNewAdapter(new l(this._documents,ee),N);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideImplementation(N,K,ee,oe){return this._withAdapter(N,l,me=>me.provideImplementation(E.URI.revive(K),ee,oe),[])}registerTypeDefinitionProvider(N,K,ee){const oe=this._addNewAdapter(new o(this._documents,ee),N);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideTypeDefinition(N,K,ee,oe){return this._withAdapter(N,o,me=>me.provideTypeDefinition(E.URI.revive(K),ee,oe),[])}registerHoverProvider(N,K,ee,oe){const me=this._addNewAdapter(new a(this._documents,ee),N);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(K)),this._createDisposable(me)}$provideHover(N,K,ee,oe){return this._withAdapter(N,a,me=>me.provideHover(E.URI.revive(K),ee,oe),void 0)}registerEvaluatableExpressionProvider(N,K,ee,oe){const me=this._addNewAdapter(new f(this._documents,ee),N);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(K)),this._createDisposable(me)}$provideEvaluatableExpression(N,K,ee,oe){return this._withAdapter(N,f,me=>me.provideEvaluatableExpression(E.URI.revive(K),ee,oe),void 0)}registerInlineValuesProvider(N,K,ee,oe){const me=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Se=this._addNewAdapter(new v(this._documents,ee),N);this._proxy.$registerInlineValuesProvider(Se,this._transformDocumentSelector(K),me);let Me=this._createDisposable(Se);if(me!==void 0){const ge=ee.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(me));Me=A.Disposable.from(Me,ge)}return Me}$provideInlineValues(N,K,ee,oe,me){return this._withAdapter(N,v,Se=>Se.provideInlineValues(E.URI.revive(K),ee,oe,me),void 0)}registerDocumentHighlightProvider(N,K,ee){const oe=this._addNewAdapter(new C(this._documents,ee),N);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDocumentHighlights(N,K,ee,oe){return this._withAdapter(N,C,me=>me.provideDocumentHighlights(E.URI.revive(K),ee,oe),void 0)}registerLinkedEditingRangeProvider(N,K,ee){const oe=this._addNewAdapter(new h(this._documents,ee),N);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideLinkedEditingRanges(N,K,ee,oe){return this._withAdapter(N,h,async me=>{const Se=await me.provideLinkedEditingRanges(E.URI.revive(K),ee,oe);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?Fe._serializeRegExp(Se.wordPattern):void 0}},void 0)}registerReferenceProvider(N,K,ee){const oe=this._addNewAdapter(new p(this._documents,ee),N);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideReferences(N,K,ee,oe,me){return this._withAdapter(N,p,Se=>Se.provideReferences(E.URI.revive(K),ee,oe,me),void 0)}registerCodeActionProvider(N,K,ee,oe){var me,Se;const Me=new m.DisposableStore,ge=this._addNewAdapter(new P(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,N,this._apiDeprecation),N);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(K),{providedKinds:(me=oe==null?void 0:oe.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Ce=>Ce.value),documentation:(Se=oe==null?void 0:oe.documentation)===null||Se===void 0?void 0:Se.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Me)}))},Fe._extLabel(N),Boolean(ee.resolveCodeAction)),Me.add(this._createDisposable(ge)),Me}$provideCodeActions(N,K,ee,oe,me){return this._withAdapter(N,P,Se=>Se.provideCodeActions(E.URI.revive(K),ee,oe,me),void 0)}$resolveCodeAction(N,K,ee){return this._withAdapter(N,P,oe=>oe.resolveCodeAction(K,ee),void 0)}$releaseCodeActions(N,K){this._withAdapter(N,P,ee=>Promise.resolve(ee.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(N,K,ee){const oe=this._addNewAdapter(new F(this._documents,ee),N);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(K),N.identifier,N.displayName||N.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(N,K,ee,oe){return this._withAdapter(N,F,me=>me.provideDocumentFormattingEdits(E.URI.revive(K),ee,oe),void 0)}registerDocumentRangeFormattingEditProvider(N,K,ee){const oe=this._addNewAdapter(new z(this._documents,ee),N);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(K),N.identifier,N.displayName||N.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(N,K,ee,oe,me){return this._withAdapter(N,z,Se=>Se.provideDocumentRangeFormattingEdits(E.URI.revive(K),ee,oe,me),void 0)}registerOnTypeFormattingEditProvider(N,K,ee,oe){const me=this._addNewAdapter(new le(this._documents,ee),N);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(K),oe,N.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(N,K,ee,oe,me,Se){return this._withAdapter(N,le,Me=>Me.provideOnTypeFormattingEdits(E.URI.revive(K),ee,oe,me,Se),void 0)}registerWorkspaceSymbolProvider(N,K){const ee=this._addNewAdapter(new H(K,this._logService),N);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(N,K,ee){return this._withAdapter(N,H,oe=>oe.provideWorkspaceSymbols(K,ee),{symbols:[]})}$resolveWorkspaceSymbol(N,K,ee){return this._withAdapter(N,H,oe=>oe.resolveWorkspaceSymbol(K,ee),void 0)}$releaseWorkspaceSymbols(N,K){this._withAdapter(N,H,ee=>ee.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(N,K,ee){const oe=this._addNewAdapter(new W(this._documents,ee,this._logService),N);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(K),W.supportsResolving(ee)),this._createDisposable(oe)}$provideRenameEdits(N,K,ee,oe,me){return this._withAdapter(N,W,Se=>Se.provideRenameEdits(E.URI.revive(K),ee,oe,me),void 0)}$resolveRenameLocation(N,K,ee,oe){return this._withAdapter(N,W,me=>me.resolveRenameLocation(E.URI.revive(K),ee,oe),void 0)}registerDocumentSemanticTokensProvider(N,K,ee,oe){const me=this._nextHandle(),Se=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new Ue(new L(this._documents,ee),N)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(K),oe,Se);let Me=this._createDisposable(me);if(Se){const ge=ee.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Se));Me=A.Disposable.from(Me,ge)}return Me}$provideDocumentSemanticTokens(N,K,ee,oe){return this._withAdapter(N,L,me=>me.provideDocumentSemanticTokens(E.URI.revive(K),ee,oe),null,!0)}$releaseDocumentSemanticTokens(N,K){this._withAdapter(N,L,ee=>ee.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(N,K,ee,oe){const me=this._addNewAdapter(new U(this._documents,ee),N);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(K),oe),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(N,K,ee,oe){return this._withAdapter(N,U,me=>me.provideDocumentRangeSemanticTokens(E.URI.revive(K),ee,oe),null,!0)}registerCompletionItemProvider(N,K,ee,oe){const me=this._addNewAdapter(new x(this._documents,this._commands.converter,ee,this._apiDeprecation,N),N);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(K),oe,x.supportsResolving(ee),`${N.identifier.value}(${oe.join("")})`),this._createDisposable(me)}$provideCompletionItems(N,K,ee,oe,me){return this._withAdapter(N,x,Se=>Se.provideCompletionItems(E.URI.revive(K),ee,oe,me),void 0)}$resolveCompletionItem(N,K,ee){return this._withAdapter(N,x,oe=>oe.resolveCompletionItem(K,ee),void 0)}$releaseCompletionItems(N,K){this._withAdapter(N,x,ee=>ee.releaseCompletionItems(K),void 0)}registerSignatureHelpProvider(N,K,ee,oe){const me=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,Se=this._addNewAdapter(new Q(this._documents,ee),N);return this._proxy.$registerSignatureHelpProvider(Se,this._transformDocumentSelector(K),me),this._createDisposable(Se)}$provideSignatureHelp(N,K,ee,oe,me){return this._withAdapter(N,Q,Se=>Se.provideSignatureHelp(E.URI.revive(K),ee,oe,me),void 0)}$releaseSignatureHelp(N,K){this._withAdapter(N,Q,ee=>ee.releaseSignatureHelp(K),void 0)}registerInlineHintsProvider(N,K,ee){const oe=typeof ee.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new $(this._documents,ee),N);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(K),oe);let Se=this._createDisposable(me);if(oe!==void 0){const Me=ee.onDidChangeInlineHints(ge=>this._proxy.$emitInlineHintsEvent(oe));Se=A.Disposable.from(Se,Me)}return Se}$provideInlineHints(N,K,ee,oe){return this._withAdapter(N,$,me=>me.provideInlineHints(E.URI.revive(K),ee,oe),void 0)}registerDocumentLinkProvider(N,K,ee){const oe=this._addNewAdapter(new Z(this._documents,ee),N);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(K),typeof ee.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(N,K,ee){return this._withAdapter(N,Z,oe=>oe.provideLinks(E.URI.revive(K),ee),void 0)}$resolveDocumentLink(N,K,ee){return this._withAdapter(N,Z,oe=>oe.resolveLink(K,ee),void 0)}$releaseDocumentLinks(N,K){this._withAdapter(N,Z,ee=>ee.releaseLinks(K),void 0)}registerColorProvider(N,K,ee){const oe=this._addNewAdapter(new ie(this._documents,ee),N);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDocumentColors(N,K,ee){return this._withAdapter(N,ie,oe=>oe.provideColors(E.URI.revive(K),ee),[])}$provideColorPresentations(N,K,ee,oe){return this._withAdapter(N,ie,me=>me.provideColorPresentations(E.URI.revive(K),ee,oe),void 0)}registerFoldingRangeProvider(N,K,ee){const oe=this._nextHandle(),me=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ue(new re(this._documents,ee),N)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(K),me);let Se=this._createDisposable(oe);if(me!==void 0){const Me=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));Se=A.Disposable.from(Se,Me)}return Se}$provideFoldingRanges(N,K,ee,oe){return this._withAdapter(N,re,me=>me.provideFoldingRanges(E.URI.revive(K),ee,oe),void 0)}registerSelectionRangeProvider(N,K,ee){const oe=this._addNewAdapter(new ye(this._documents,ee,this._logService),N);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideSelectionRanges(N,K,ee,oe){return this._withAdapter(N,ye,me=>me.provideSelectionRanges(E.URI.revive(K),ee,oe),[])}registerCallHierarchyProvider(N,K,ee){const oe=this._addNewAdapter(new Ie(this._documents,ee),N);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$prepareCallHierarchy(N,K,ee,oe){return this._withAdapter(N,Ie,me=>Promise.resolve(me.prepareSession(E.URI.revive(K),ee,oe)),void 0)}$provideCallHierarchyIncomingCalls(N,K,ee,oe){return this._withAdapter(N,Ie,me=>me.provideCallsTo(K,ee,oe),void 0)}$provideCallHierarchyOutgoingCalls(N,K,ee,oe){return this._withAdapter(N,Ie,me=>me.provideCallsFrom(K,ee,oe),void 0)}$releaseCallHierarchy(N,K){this._withAdapter(N,Ie,ee=>Promise.resolve(ee.releaseSession(K)),void 0)}static _serializeRegExp(N){return{pattern:N.source,flags:(0,y.regExpFlags)(N)}}static _serializeIndentationRule(N){return{decreaseIndentPattern:Fe._serializeRegExp(N.decreaseIndentPattern),increaseIndentPattern:Fe._serializeRegExp(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?Fe._serializeRegExp(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?Fe._serializeRegExp(N.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(N){return{beforeText:Fe._serializeRegExp(N.beforeText),afterText:N.afterText?Fe._serializeRegExp(N.afterText):void 0,previousLineText:N.previousLineText?Fe._serializeRegExp(N.previousLineText):void 0,action:N.action}}static _serializeOnEnterRules(N){return N.map(Fe._serializeOnEnterRule)}setLanguageConfiguration(N,K,ee){let{wordPattern:oe}=ee;if(oe&&(0,y.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(K,oe):this._documents.setWordDefinitionFor(K,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const me=this._nextHandle(),Se={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Fe._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Fe._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Fe._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,K,Se),this._createDisposable(me)}$setWordDefinitions(N){for(const K of N)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Fe,Fe._handlePool=0}),define(be[195],we([0,1,5,9,7]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class A{constructor(I,y){this._proxy=I.getProxy(E.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,y){await this._proxy.$changeLanguage(I,y);const n=this._documents.getDocumentData(I);if(!n)throw new Error(`document '${I.toString}' NOT found`);return n.document}async tokenAtPosition(I,y){var n;const T=I.version,k=S.Position.from(y),b=await this._proxy.$tokensAtPosition(I.uri,k),m={type:R.StandardTokenType.Other,range:(n=I.getWordRangeAtPosition(y))!==null&&n!==void 0?n:new R.Range(y.line,y.character,y.line,y.character)};if(!b)return m;const r={range:S.Range.to(b.range),type:S.TokenType.to(b.type)};return!r.range.contains(y)||T!==I.version?m:r}}e.ExtHostLanguages=A}),define(be[196],we([0,1,5,19,34]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(I){return I&&I.title}let D=class{constructor(y,n){this._logService=n,this._proxy=y.getProxy(E.MainContext.MainThreadMessageService)}showMessage(y,n,T,k,b){const m={extension:y};let r;typeof k=="string"||A(k)?r=[k,...b]:(m.modal=k&&k.modal,m.useCustom=k&&k.useCustom,r=b),m.useCustom&&(0,R.checkProposedApiEnabled)(y);const d=[];for(let _=0;_<r.length;_++){const g=r[_];if(typeof g=="string")d.push({title:g,handle:_,isCloseAffordance:!1});else if(typeof g=="object"){let{title:w,isCloseAffordance:u}=g;d.push({title:w,isCloseAffordance:!!u,handle:_})}else this._logService.warn("Invalid message item:",g)}return this._proxy.$showMessage(n,T,m,d).then(_=>{if(typeof _=="number")return r[_]})}};D=je([Ke(1,S.ILogService)],D),e.ExtHostMessageService=D}),define(be[197],we([0,1,20,3,6,2,29,5,9,7,69,70,22,174,175,53,12,26,56]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d,_,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class u extends R.Disposable{constructor(v,C,h,p,P){super();this._editorId=v,this.uri=C,this._proxy=h,this._webviewInitData=p,this.document=P,this._onDidReceiveDocumentMessage=new S.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:F=>this._proxy.$postMessage(this._editorId,void 0,F),asWebviewUri:F=>this._asWebviewUri(F)}}onDidReceiveMessage(v,C){var h;this._onDidReceiveDocumentMessage.fire(C),v!==void 0&&((h=this._rendererIdToEmitters.get(v))===null||h===void 0||h.fire(C))}getRendererComm(v){const C=new S.Emitter;return this._rendererIdToEmitters.set(v,C),{editorId:this._editorId,onDidReceiveMessage:C.event,postMessage:h=>this._proxy.$postMessage(this._editorId,v,h),asWebviewUri:h=>this._asWebviewUri(h)}}_asWebviewUri(v){return(0,T.asWebviewUri)(this._webviewInitData,this._editorId,v)}}class c extends R.Disposable{constructor(v,C,h,p){super();this._proxy=v,this._handle=C,this._extension=h,this._provider=p,this._kernelToFriendlyId=new b.ResourceMap,this._friendlyIdToKernel=new b.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(P=>{const F=P==null?void 0:P.uri;this._proxy.$onNotebookKernelChange(this._handle,F)}))}async provideKernels(v,C){const h=await this._provider.provideKernels(v.notebookDocument,C)||[],p=new Map;let P=0;const F=new Set,z=this._kernelToFriendlyId.get(v.uri),le=h.map(W=>{let G=z==null?void 0:z.get(W);return G===void 0&&(W.id&&F.has(W.id)?G=`${this._extension.identifier.value}_${W.id}_${P++}`:G=`${this._extension.identifier.value}_${W.id||D.generateUuid()}`),p.set(W,G),{id:W.id,friendlyId:G,label:W.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:W.description,detail:W.detail,isPreferred:W.isPreferred,preloads:W.preloads,supportedLanguages:W.supportedLanguages,implementsInterrupt:!!W.interrupt}});this._kernelToFriendlyId.set(v.uri,p);const H=new Map;return p.forEach((W,G)=>{H.set(W,G)}),this._friendlyIdToKernel.set(v.uri,H),le}getKernelByFriendlyId(v,C){var h;return(h=this._friendlyIdToKernel.get(v))===null||h===void 0?void 0:h.get(C)}async resolveNotebook(v,C,h,p){var P;const F=(P=this._friendlyIdToKernel.get(C.uri))===null||P===void 0?void 0:P.get(v);if(F&&this._provider.resolveKernel)return this._provider.resolveKernel(F,C.notebookDocument,h,p)}async executeNotebook(v,C,h){var p;const P=(p=this._friendlyIdToKernel.get(C.uri))===null||p===void 0?void 0:p.get(v);if(!!P){const F=h.map(z=>y.NotebookCellRange.to(z));return P.executeCellsRequest(C.notebookDocument,F)}}async interruptNotebookExecution(v,C){var h;const p=(h=this._friendlyIdToKernel.get(C.uri))===null||h===void 0?void 0:h.get(v);if(!(!p||!p.interrupt))return p.interrupt(C.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=c;class s{constructor(v,C){const h=s._Keys.nextId();v.$registerNotebookEditorDecorationType(h,y.NotebookDecorationRenderOptions.from(C)),this.value={key:h,dispose(){v.$removeNotebookEditorDecorationType(h)}}}}e.NotebookEditorDecorationType=s,s._Keys=new d.IdGenerator("NotebookEditorDecorationType");class t{constructor(v,C,h,p,P,F,z){this._textDocumentsAndEditors=h,this._textDocuments=p,this._webviewInitData=P,this.logService=F,this._extensionStoragePaths=z,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new b.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new S.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new S.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new S.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new S.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new S.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new S.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new S.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new S.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new S.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new S.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new S.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new S.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new S.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new b.ResourceMap,this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._proxy=v.getProxy(I.MainContext.MainThreadNotebook),this._commandsConverter=C.converter,C.registerArgumentProcessor({processArgument:le=>{var H;if(le&&le.$mid===12){const W=(H=le.notebookEditor)===null||H===void 0?void 0:H.notebookUri,G=le.cell.handle,L=this._documents.get(W),U=L==null?void 0:L.getCell(G);if(U)return U.cell}return le}})}get activeNotebookEditor(){var v;return(v=this._activeNotebookEditor)===null||v===void 0?void 0:v.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(v=>v.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(v){return this._documents.get(v)}_getNotebookDocument(v){const C=this._documents.get(v);if(!C)throw new Error(`NO notebook document for '${v}'`);return C}_getProviderData(v){const C=this._notebookContentProviders.get(v);if(!C)throw new Error(`NO provider for '${v}'`);return C}registerNotebookContentProvider(v,C,h,p){var P,F,z;if(this._notebookContentProviders.has(C))throw new Error(`Notebook provider for '${C}' already registered`);this._notebookContentProviders.set(C,{extension:v,provider:h});let le;h.onDidChangeNotebookContentOptions&&(le=h.onDidChangeNotebookContentOptions(()=>{this._proxy.$updateNotebookProviderOptions(C,h.options)}));const H=(P=p==null?void 0:p.viewOptions)===null||P===void 0?void 0:P.filenamePattern.map(W=>y.NotebookExclusiveDocumentPattern.from(W)).filter(W=>W!==void 0);return((F=p==null?void 0:p.viewOptions)===null||F===void 0?void 0:F.filenamePattern)&&!H&&console.warn(`Notebook content provider view options file name pattern is invalid ${(z=p==null?void 0:p.viewOptions)===null||z===void 0?void 0:z.filenamePattern}`),this._proxy.$registerNotebookProvider({id:v.identifier,location:v.extensionLocation,description:v.description},C,{transientOutputs:(p==null?void 0:p.transientOutputs)||!1,transientMetadata:(p==null?void 0:p.transientMetadata)||{},viewOptions:(p==null?void 0:p.viewOptions)&&H?{displayName:p.viewOptions.displayName,filenamePattern:H,exclusive:p.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{le==null||le.dispose(),this._notebookContentProviders.delete(C),this._proxy.$unregisterNotebookProvider(C)})}registerNotebookKernelProvider(v,C,h){const p=t._notebookKernelProviderHandlePool++,P=new c(this._proxy,p,v,h);return this._notebookKernelProviders.set(p,P),this._proxy.$registerNotebookKernelProvider({id:v.identifier,location:v.extensionLocation,description:v.description},p,{viewType:C.viewType,filenamePattern:C.filenamePattern?y.NotebookExclusiveDocumentPattern.from(C.filenamePattern):void 0}),new n.Disposable(()=>{P.dispose(),this._notebookKernelProviders.delete(p),this._proxy.$unregisterNotebookKernelProvider(p)})}createNotebookEditorDecorationType(v){return new s(this._proxy,v).value}async openNotebookDocument(v){const C=this._documents.get(v);if(C)return C.notebookDocument;const h=await this._proxy.$tryOpenDocument(v),p=this._documents.get(A.URI.revive(h));return(0,_.assertIsDefined)(p==null?void 0:p.notebookDocument)}_withAdapter(v,C,h){const p=this._documents.get(A.URI.revive(C));if(!p)return[];const P=this._notebookKernelProviders.get(v);return P?h(P,p):[]}async showNotebookDocument(v,C){var h;A.URI.isUri(v)&&(v=await this.openNotebookDocument(v));let p;typeof C=="object"?p={position:y.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:C.selection&&y.NotebookCellRange.from(C.selection),pinned:typeof C.preview=="boolean"?!C.preview:void 0}:p={preserveFocus:!1};const P=await this._proxy.$tryShowNotebookDocument(v.uri,v.viewType,p),F=P&&((h=this._editors.get(P))===null||h===void 0?void 0:h.editor);if(F)return F.editor;throw P?new Error(`Could NOT open editor for "${v.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.toString()}".`)}async $provideNotebookKernels(v,C,h){return this._withAdapter(v,C,(p,P)=>p.provideKernels(P,h))}async $resolveNotebookKernel(v,C,h,p,P){await this._withAdapter(v,h,async(F,z)=>{const le=this._webviewComm.get(C);le&&await F.resolveNotebook(p,z,le.contentProviderComm,P)})}async $resolveNotebookEditor(v,C,h){const p=this._notebookContentProviders.get(v),P=A.URI.revive(C),F=this._documents.get(P);if(!(!F||!p)){let z=this._webviewComm.get(h);z||(z=new u(h,P,this._proxy,this._webviewInitData,F),this._webviewComm.set(h,z)),!!p.provider.resolveNotebook&&await p.provider.resolveNotebook(F.notebookDocument,z.contentProviderComm)}}async $executeNotebookKernelFromProvider(v,C,h,p){await this._withAdapter(v,C,async(P,F)=>P.executeNotebook(h,F,p))}registerNotebookSerializer(v,C,h,p){const P=this._handlePool++;return this._notebookSerializer.set(P,h),this._proxy.$registerNotebookSerializer(P,{id:v.identifier,location:v.extensionLocation,description:v.description},C,p!=null?p:{transientOutputs:!1,transientMetadata:{}}),(0,R.toDisposable)(()=>{this._proxy.$unregisterNotebookSerializer(P)})}async $dataToNotebook(v,C){const h=this._notebookSerializer.get(v);if(!h)throw new Error("NO serializer found");const p=await h.dataToNotebook(C.buffer);return{metadata:y.NotebookDocumentMetadata.from(p.metadata),cells:p.cells.map(y.NotebookCellData.from)}}async $notebookToData(v,C){const h=this._notebookSerializer.get(v);if(!h)throw new Error("NO serializer found");const p=await h.notebookToData({metadata:y.NotebookDocumentMetadata.to(C.metadata),cells:C.cells.map(y.NotebookCellData.to)});return g.VSBuffer.wrap(p)}async $cancelNotebookCellExecution(v,C,h,p){await this._withAdapter(v,C,async(F,z)=>F.interruptNotebookExecution(h,z));const P=this._documents.get(A.URI.revive(C));if(!!P)for(let F of p)for(let z=F.start;z<F.end;z++){const le=P.getCellFromIndex(z);le&&this.cancelOneNotebookCellExecution(le)}}cancelOneNotebookCellExecution(v){const C=this._activeExecutions.get(v.uri);C==null||C.cancel()}async $openNotebook(v,C,h,p,P){const{provider:F}=this._getProviderData(v),z=await F.openNotebook(A.URI.revive(C),{backupId:h,untitledDocumentData:p==null?void 0:p.buffer},P);return{metadata:y.NotebookDocumentMetadata.from(z.metadata),cells:z.cells.map(y.NotebookCellData.from)}}async $saveNotebook(v,C,h){const p=this._getNotebookDocument(A.URI.revive(C)),{provider:P}=this._getProviderData(v);return await P.saveNotebook(p.notebookDocument,h),!0}async $saveNotebookAs(v,C,h,p){const P=this._getNotebookDocument(A.URI.revive(C)),{provider:F}=this._getProviderData(v);return await F.saveNotebookAs(A.URI.revive(h),P.notebookDocument,p),!0}async $backupNotebook(v,C,h){var p;const P=this._getNotebookDocument(A.URI.revive(C)),F=this._getProviderData(v),z=(p=this._extensionStoragePaths.workspaceValue(F.extension))!==null&&p!==void 0?p:this._extensionStoragePaths.globalValue(F.extension),le=String((0,w.hash)([P.uri.toString(),this._backupIdPool++])),H=A.URI.joinPath(z,le),W=await F.provider.backupNotebook(P.notebookDocument,{destination:H},h);return P.updateBackup(W),W.id}$acceptNotebookActiveKernelChange(v){v.providerHandle!==void 0&&this._withAdapter(v.providerHandle,v.uri,async(C,h)=>{const p=v.kernelFriendlyId?C.getKernelByFriendlyId(A.URI.revive(v.uri),v.kernelFriendlyId):void 0;this._editors.forEach(P=>{P.editor.notebookData===h&&P.editor._acceptKernel(p)}),this._onDidChangeActiveNotebookKernel.fire({document:h.notebookDocument,kernel:p})})}$onDidReceiveMessage(v,C,h){var p;(p=this._webviewComm.get(v))===null||p===void 0||p.onDidReceiveMessage(C,h)}$acceptModelChanged(v,C,h){this._getNotebookDocument(A.URI.revive(v)).acceptModelChanged(C,h)}$acceptDirtyStateChanged(v,C){const h=this._getNotebookDocument(A.URI.revive(v));h.acceptModelChanged({rawEvents:[],versionId:h.notebookDocument.version},C)}$acceptModelSaved(v){const C=this._getNotebookDocument(A.URI.revive(v));this._onDidSaveNotebookDocument.fire(C.notebookDocument)}$acceptEditorPropertiesChanged(v,C){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,C);const h=this._editors.get(v);if(!h)throw new Error(`unknown text editor: ${v}`);C.visibleRanges&&h.editor._acceptVisibleRanges(C.visibleRanges.ranges.map(y.NotebookCellRange.to)),C.selections&&h.editor._acceptSelections(C.selections.selections.map(y.NotebookCellRange.to)),C.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.editor.editor,visibleRanges:h.editor.editor.visibleRanges}),C.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.editor.editor,selections:h.editor.editor.selections}))}$acceptDocumentPropertiesChanged(v,C){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",v.path,C);const h=this._getNotebookDocument(A.URI.revive(v));h.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:h.notebookDocument})}_createExtHostEditor(v,C,h){var p;const P=v.uri;let F=this._webviewComm.get(C);F||(F=new u(C,P,this._proxy,this._webviewInitData,v),this._webviewComm.set(C,F));const z=new r.ExtHostNotebookEditor(C,v.notebookDocument.viewType,this._proxy,v,h.visibleRanges.map(y.NotebookCellRange.to),h.selections.map(y.NotebookCellRange.to),typeof h.viewColumn=="number"?y.ViewColumn.to(h.viewColumn):void 0);(p=this._editors.get(C))===null||p===void 0||p.editor.dispose(),this._editors.set(C,{editor:z})}$acceptDocumentAndEditorsDelta(v){var C,h,p,P;let F=!1;if(v.removedDocuments)for(const le of v.removedDocuments){const H=A.URI.revive(le),W=this._documents.get(H);W&&(W.dispose(),this._documents.delete(H),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:W.notebookDocument.cells.map(G=>G.document.uri)}),this._onDidCloseNotebookDocument.fire(W.notebookDocument));for(const G of this._editors.values())G.editor.notebookData.uri.toString()===H.toString()&&(G.editor.dispose(),this._editors.delete(G.editor.id),F=!0)}if(v.addedDocuments){const le=[];for(const H of v.addedDocuments){const W=A.URI.revive(H.uri),G=H.viewType;if(this._documents.has(W))throw new Error(`adding EXISTING notebook ${W}`);const L=this,U=new m.ExtHostNotebookDocument(this._proxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(x){L._onDidChangeNotebookCells.fire(x)},emitCellOutputsChange(x){L._onDidChangeCellOutputs.fire(x)},emitCellMetadataChange(x){L._onDidChangeCellMetadata.fire(x)},emitCellExecutionStateChange(x){L._onDidChangeCellExecutionState.fire(x)}},G,H.metadata?y.NotebookDocumentMetadata.to(H.metadata):new n.NotebookDocumentMetadata,W);U.acceptModelChanged({versionId:H.versionId,rawEvents:[{kind:k.NotebookCellsChangeType.Initialize,changes:[[0,0,H.cells]]}]},!1),le.push(...H.cells.map(x=>m.ExtHostCell.asModelAddData(U.notebookDocument,x))),(C=this._documents.get(W))===null||C===void 0||C.dispose(),this._documents.set(W,U),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:le}),this._onDidOpenNotebookDocument.fire(U.notebookDocument)}}if(v.addedEditors)for(const le of v.addedEditors){if(this._editors.has(le.id))return;const H=A.URI.revive(le.documentUri),W=this._documents.get(H);W&&(this._createExtHostEditor(W,le.id,le),F=!0)}const z=[];if(v.removedEditors)for(const le of v.removedEditors){const H=this._editors.get(le);H&&(F=!0,this._editors.delete(le),((h=this._activeNotebookEditor)===null||h===void 0?void 0:h.id)===H.editor.id&&(this._activeNotebookEditor=void 0),z.push(H))}if(F&&z.forEach(le=>{le.editor.dispose()}),v.visibleEditors){this._visibleNotebookEditors=v.visibleEditors.map(H=>this._editors.get(H).editor).filter(H=>!!H);const le=new Set;this._visibleNotebookEditors.forEach(H=>le.add(H.id));for(const H of this._editors.values()){const W=le.has(H.editor.id);H.editor._acceptVisibility(W)}this._visibleNotebookEditors=[...this._editors.values()].map(H=>H.editor).filter(H=>H.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}v.newActiveEditor===null?this._activeNotebookEditor=void 0:v.newActiveEditor&&(this._activeNotebookEditor=(p=this._editors.get(v.newActiveEditor))===null||p===void 0?void 0:p.editor),v.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((P=this._activeNotebookEditor)===null||P===void 0?void 0:P.editor)}createNotebookCellStatusBarItemInternal(v,C,h){const p=new i(this._proxy,this._commandsConverter,v,C,h),P=k.CellUri.parse(v.document.uri);if(P){const F=this._documents.get(P.notebook);if(F){const z=F.getCell(P.handle);z&&S.Event.once(z.onDidDispose)(()=>p.dispose())}}return p}createNotebookCellExecution(v,C,h){const p=this.lookupNotebookDocument(v);if(!p)throw new Error(`Invalid cell uri/index: ${v}, ${C}`);const P=p.getCellFromIndex(C);if(!P)throw new Error(`Invalid cell uri/index: ${v}, ${C}`);if(!this._activeExecutions.has(P.uri)){const F=new a(v,p,P,this._proxy);this._activeExecutions.set(P.uri,F);const z=F.onDidChangeState(()=>{F.state===o.Resolved&&(F.dispose(),z.dispose(),this._activeExecutions.delete(P.uri))});return F.asApiObject()}}}e.ExtHostNotebookController=t,t._notebookKernelProviderHandlePool=0;class i extends R.Disposable{constructor(v,C,h,p,P){super();this._proxy=v,this._commands=C,this._cell=h,this._priority=P,this._id=i.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new R.DisposableStore),this._alignment=p!=null?p:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=l(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(v){this._alignment=v,this.update()}get priority(){return this._priority}set priority(v){this._priority=v,this.update()}get text(){return this._text}set text(v){this._text=v,this.update()}get tooltip(){return this._tooltip}set tooltip(v){this._tooltip=v,this.update()}get command(){var v;return(v=this._command)===null||v===void 0?void 0:v.fromApi}set command(v){var C;((C=this._command)===null||C===void 0?void 0:C.fromApi)!==v&&(this._internalCommandRegistration.clear(),typeof v=="string"?this._command={fromApi:v,internal:this._commands.toInternal({title:"",command:v},this._internalCommandRegistration)}:v?this._command={fromApi:v,internal:this._commands.toInternal(v,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(v){this._accessibilityInformation=v,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var v;if(!this._isDisposed){const C={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(v=this._command)===null||v===void 0?void 0:v.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,C)}}}e.NotebookCellStatusBarItemInternal=i,i.NEXT_ID=0;function l(f){return Object.freeze({cell:f.cell,get alignment(){return f.alignment},set alignment(v){f.alignment=v},get priority(){return f.priority},set priority(v){f.priority=v},get text(){return f.text},set text(v){f.text=v},get tooltip(){return f.tooltip},set tooltip(v){f.tooltip=v},get command(){return f.command},set command(v){f.command=v},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(v){f.accessibilityInformation=v},show(){f.show()},hide(){f.hide()},dispose(){f.dispose()}})}var o;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(o||(o={}));class a extends R.Disposable{constructor(v,C,h,p){super();this._uri=v,this._document=C,this._cell=h,this._proxy=p,this._onDidChangeState=new S.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._executionOrder=h.internalMetadata.executionOrder,this.mixinMetadata({runState:k.NotebookCellExecutionState.Pending,lastRunDuration:null,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEdits(v){return this._proxy.$applyEdits(this._uri,v,!1)}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(v){const C=[{editType:11,handle:this._cell.handle,metadata:v}];this.applyEdits(C)}cellIndexToHandle(v){const C=typeof v=="number"?this._document.getCellFromIndex(v):this._cell;if(!!C)return C.handle}asApiObject(){const v=this;return Object.freeze({get document(){return v._document.notebookDocument},get cell(){return v._cell.cell},get executionOrder(){return v._executionOrder},set executionOrder(C){v._executionOrder=C,v.mixinMetadata({executionOrder:C})},start(C){if(v._state===o.Resolved||v._state===o.Started)throw new Error("Cannot call start again");v._state=o.Started,v._onDidChangeState.fire(),v.mixinMetadata({runState:k.NotebookCellExecutionState.Executing,runStartTime:C==null?void 0:C.startTime})},end(C){var h,p;if(v._state===o.Resolved)throw new Error("Cannot call resolve twice");v._state=o.Resolved,v._onDidChangeState.fire(),v.mixinMetadata({runState:k.NotebookCellExecutionState.Idle,lastRunSuccess:(h=C==null?void 0:C.success)!==null&&h!==void 0?h:null,lastRunDuration:(p=C==null?void 0:C.duration)!==null&&p!==void 0?p:null})},clearOutput(C){return v.verifyStateForOutput(),this.replaceOutput([],C)},async appendOutput(C,h){v.verifyStateForOutput();const p=v.cellIndexToHandle(h);if(typeof p=="number")return v.applyEdits([{editType:2,handle:p,append:!0,outputs:C.map(y.NotebookCellOutput.from)}])},async replaceOutput(C,h){v.verifyStateForOutput();const p=v.cellIndexToHandle(h);if(typeof p=="number")return v.applyEdits([{editType:2,handle:p,outputs:C.map(y.NotebookCellOutput.from)}])},async appendOutputItems(C,h){return v.verifyStateForOutput(),v.applyEdits([{editType:10,append:!0,items:C.map(y.NotebookCellOutputItem.from),outputId:h}])},async replaceOutputItems(C,h){return v.verifyStateForOutput(),v.applyEdits([{editType:10,items:C.map(y.NotebookCellOutputItem.from),outputId:h}])},token:v._tokenSource.token})}}}),define(be[99],we([0,1,5,3,6,26,4,14]),function(ae,e,E,S,R,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends R.Disposable{constructor(r,d,_,g){super();this._onDidAppend=this._register(new S.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=g,this._id=g.$register(this.name,d,_),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?A.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(d=>this._proxy.$clear(d,r))}show(r,d){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof r=="boolean"?r:d)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class n extends y{constructor(r,d){super(r,!1,void 0,d)}append(r){super.append(r),this._id.then(d=>this._proxy.$append(d,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class T extends y{constructor(r,d,_){super(r,!0,d,_)}append(r){throw new Error("Not supported")}}class k{constructor(r,d){this.name=r,this._channel=d}append(r){this._channel.then(d=>d.append(r))}appendLine(r){this._channel.then(d=>d.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,d){this._channel.then(_=>_.show(r,d))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=k;let b=class{constructor(r){this._proxy=r.getProxy(E.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new n(r,this._proxy)}createOutputChannelFromLogFile(r,d){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new T(r,d,this._proxy)}};b=je([Ke(0,I.IExtHostRpcService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(be[198],we([0,1,13,20,3,6,5,2,7,10,15,46]),function(ae,e,E,S,R,A,D,I,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function b(m,r,d){const _=m.getProxy(D.MainContext.MainThreadQuickOpen);class g{constructor(o,a){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=a}showQuickPick(o,a,f,v=S.CancellationToken.None){this._onDidSelectItem=void 0;const C=Promise.resolve(o),h=++this._instances,p=_.$show(h,{title:f==null?void 0:f.title,placeHolder:f==null?void 0:f.placeHolder,matchOnDescription:f==null?void 0:f.matchOnDescription,matchOnDetail:f==null?void 0:f.matchOnDetail,ignoreFocusLost:f==null?void 0:f.ignoreFocusOut,canPickMany:f==null?void 0:f.canPickMany},v),P={},F=p.then(()=>P);return Promise.race([F,C]).then(z=>{if(z!==P)return C.then(le=>{const H=[];for(let W=0;W<le.length;W++){const G=le[W];let L,U,x,Q,$;typeof G=="string"?L=G:(L=G.label,U=G.description,x=G.detail,Q=G.picked,$=G.alwaysShow),H.push({label:L,description:U,handle:W,detail:x,picked:Q,alwaysShow:$})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{f.onDidSelectItem(le[W])}),_.$setItems(h,H),p.then(W=>{if(typeof W=="number")return le[W];if(Array.isArray(W))return W.map(G=>le[G])})})}).then(void 0,z=>{if(!(0,n.isPromiseCanceledError)(z))return _.$setError(h,z),Promise.reject(z)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,a=S.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,_.$input(o,typeof this._validateInput=="function",a).then(void 0,f=>{if(!(0,n.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(o){return this._validateInput?(0,E.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,a=S.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!!f){const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(C=>C.uri.toString()===f.uri.toString())}}createQuickPick(o,a){const f=new t(o,a,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(o){const a=new i(o,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(o,a){const f=this._sessions.get(o);f&&f._fireDidChangeValue(a)}$onDidAccept(o){const a=this._sessions.get(o);a&&a._fireDidAccept()}$onDidChangeActive(o,a){const f=this._sessions.get(o);f instanceof t&&f._fireDidChangeActive(a)}$onDidChangeSelection(o,a){const f=this._sessions.get(o);f instanceof t&&f._fireDidChangeSelection(a)}$onDidTriggerButton(o,a){const f=this._sessions.get(o);f&&f._fireDidTriggerButton(a)}$onDidHide(o){const a=this._sessions.get(o);a&&a._fireDidHide()}}class w{constructor(o,a){this._extensionId=o,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new R.Emitter,this._onDidChangeValueEmitter=new R.Emitter,this._onDidTriggerButtonEmitter=new R.Emitter,this._onDidHideEmitter=new R.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((a,f)=>{const v=a===y.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(v,a)}),this.update({buttons:o.map((a,f)=>({iconPath:u(a.iconPath),tooltip:a.tooltip,handle:a===y.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const a=this._handlesToButtons.get(o);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(o){if(!this._disposed){for(const a of Object.keys(o)){const f=o[a];this._pendingUpdate[a]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}w._nextId=1;function u(l){if(l instanceof y.ThemeIcon)return{id:l.id};const o=s(l),a=c(l);return{dark:typeof o=="string"?I.URI.file(o):o,light:typeof a=="string"?I.URI.file(a):a}}function c(l){return typeof l=="object"&&"light"in l?l.light:l}function s(l){return typeof l=="object"&&"dark"in l?l.dark:l}class t extends w{constructor(o,a,f){super(o,f);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new R.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new R.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((a,f)=>{this._handlesToItems.set(f,a),this._itemsToHandles.set(a,f)}),this.update({items:o.map((a,f)=>({label:a.label,description:a.description,handle:f,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(o){const a=(0,T.coalesce)(o.map(f=>this._handlesToItems.get(f)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(o){const a=(0,T.coalesce)(o.map(f=>this._handlesToItems.get(f)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class i extends w{constructor(o,a){super(o,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?k.default.Error:k.default.Ignore})}}return new g(r,d)}e.createExtHostQuickOpen=b}),define(be[199],we([0,1,2,3,51,6,13,5,15,110,19,25,34]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(o){if(o)return typeof o.iconPath=="string"?E.URI.file(o.iconPath):o.iconPath}function r(o,a){if(!o.iconPath&&!a.iconPath)return 0;if(o.iconPath){if(!a.iconPath)return 1}else return-1;const f=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath,v=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath;return(0,n.comparePaths)(f,v)}function d(o,a){let f=0;if(o.strikeThrough!==a.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==a.faded)return o.faded?1:-1;if(o.tooltip!==a.tooltip)return(o.tooltip||"").localeCompare(a.tooltip||"");if(f=r(o,a),f!==0)return f;if(o.light&&a.light)f=r(o.light,a.light);else{if(o.light)return 1;if(a.light)return-1}if(f!==0)return f;if(o.dark&&a.dark)f=r(o.dark,a.dark);else{if(o.dark)return 1;if(a.dark)return-1}return f}function _(o,a){if(o.command!==a.command)return o.command<a.command?-1:1;if(o.title!==a.title)return o.title<a.title?-1:1;if(o.tooltip!==a.tooltip){if(o.tooltip!==void 0&&a.tooltip!==void 0)return o.tooltip<a.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(o.arguments===a.arguments)return 0;if(o.arguments)if(a.arguments){if(o.arguments.length!==a.arguments.length)return o.arguments.length-a.arguments.length}else return 1;else return-1;for(let f=0;f<o.arguments.length;f++){const v=o.arguments[f],C=a.arguments[f];if(v!==C)return v<C?-1:1}return 0}function g(o,a){let f=(0,n.comparePaths)(o.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(f!==0)return f;if(o.command&&a.command)f=_(o.command,a.command);else{if(o.command)return 1;if(a.command)return-1}if(f!==0)return f;if(o.decorations&&a.decorations)f=d(o.decorations,a.decorations);else{if(o.decorations)return 1;if(a.decorations)return-1}return f}function w(o,a){for(let f=0;f<o.length;f++)if(o[f]!==a[f])return!1;return!0}function u(o,a){return o.command===a.command&&o.title===a.title&&o.tooltip===a.tooltip&&(o.arguments&&a.arguments?w(o.arguments,a.arguments):o.arguments===a.arguments)}function c(o,a){return(0,y.equals)(o,a,u)}class s{constructor(a,f,v){this._extension=a,this._proxy=f,this._sourceControlHandle=v,this._value="",this._onDidChange=new S.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return(0,b.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(a){if((0,b.checkProposedApiEnabled)(this._extension),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=s;class t{constructor(a,f,v,C,h){this._proxy=a,this._commands=f,this._sourceControlHandle=v,this._id=C,this._label=h,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new S.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new S.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,f){const v=this._resourceStatesCommandsMap.get(a);return v?(0,D.asPromise)(()=>this._commands.executeCommand(v.command,...v.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var a;const f=[...this._resourceStates].sort(g),C=(0,y.sortedDiff)(this._resourceSnapshot,f,g).map(P=>{const F=P.toInsert.map(z=>{const le=this._resourceHandlePool++;this._resourceStatesMap.set(le,z);const H=z.resourceUri,W=m(z.decorations),G=z.decorations&&m(z.decorations.light)||W,L=z.decorations&&m(z.decorations.dark)||W,U=[];let x;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const ye=new A.DisposableStore;x=this._commands.converter.toInternal(z.command,ye),this._resourceStatesDisposablesMap.set(le,ye)}else this._resourceStatesCommandsMap.set(le,z.command);G&&U.push(G),L&&L.toString()!==(G==null?void 0:G.toString())&&U.push(L);const Q=z.decorations&&z.decorations.tooltip||"",$=z.decorations&&!!z.decorations.strikeThrough,Z=z.decorations&&!!z.decorations.faded,ie=z.contextValue||"";return{rawResource:[le,H,U,Q,$,Z,ie,x],handle:le}});return{start:P.start,deleteCount:P.deleteCount,toInsert:F}}),h=C.map(({start:P,deleteCount:F,toInsert:z})=>[P,F,z.map(le=>le.rawResource)]),p=C.reverse();for(const{start:P,deleteCount:F,toInsert:z}of p){const le=z.map(W=>W.handle),H=this._handlesSnapshot.splice(P,F,...le);for(const W of H)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),(a=this._resourceStatesDisposablesMap.get(W))===null||a===void 0||a.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=f,h}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(a,f,v,C,h,p){this._proxy=f,this._commands=v,this._id=C,this._label=h,this._rootUri=p,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new S.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new s(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,C,h,p)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=a;const f=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(!(this._statusBarCommands&&a&&c(this._statusBarCommands,a))){this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=a;const f=(a||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}}get selected(){return this._selected}createResourceGroup(a,f){const v=new t(this._proxy,this._commands,this.handle,a,f),C=S.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,C),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const a=[],f=[];for(const[v,C]of this.createdResourceGroups){C.dispose();const h=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});S.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),h.dispose(),this._groups.delete(v.handle),this._proxy.$unregisterGroup(this.handle,v.handle)}),a.push([v.handle,v.id,v.label,v.features]);const p=v._takeResourceStateSnapshot();p.length>0&&f.push([v.handle,p]),this._groups.set(v.handle,v)}this._proxy.$registerGroups(this.handle,a,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(f=>{const v=f._takeResourceStateSnapshot();v.length!==0&&a.push([f.handle,v])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,R.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,R.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let l=class In{constructor(a,f,v){this._commands=f,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new S.Emitter,this._proxy=a.getProxy(I.MainContext.MainThreadSCM),this._telemetry=a.getProxy(I.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const h=this._sourceControls.get(C.sourceControlHandle);if(!h)return C;const p=h.getResourceGroup(C.groupHandle);return p?p.getResourceState(C.handle):C}else if(C&&C.$mid===4){const h=this._sourceControls.get(C.sourceControlHandle);return h?h.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const h=this._sourceControls.get(C.handle);return h||C}return C}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,f,v,C){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,f,v,C),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const h=In._handlePool++,p=new i(a,this._proxy,this._commands,f,v,C);this._sourceControls.set(h,p);const P=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(a.identifier))||[];return P.push(p),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(a.identifier),P),p}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const f=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(a.identifier)),v=f&&f[f.length-1];return v&&v.inputBox}$provideOriginalResource(a,f,v){const C=E.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,C.toString());const h=this._sourceControls.get(a);return!h||!h.quickDiffProvider||!h.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>h.quickDiffProvider.provideOriginalResource(C,v)).then(p=>p||null)}$onInputBoxValueChange(a,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const v=this._sourceControls.get(a);return v&&v.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(a,f,v,C){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,f,v);const h=this._sourceControls.get(a);if(!h)return Promise.resolve(void 0);const p=h.getResourceGroup(f);return p?p.$executeResourceCommand(v,C):Promise.resolve(void 0)}$validateInput(a,f,v){this.logService.trace("ExtHostSCM#$validateInput",a);const C=this._sourceControls.get(a);return!C||!C.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>C.inputBox.validateInput(f,v)).then(h=>h?Promise.resolve([h.message,h.type]):Promise.resolve(void 0))}$setSelectedSourceControl(a){var f,v;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&((f=this._sourceControls.get(a))===null||f===void 0||f.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((v=this._sourceControls.get(this._selectedSourceControlHandle))===null||v===void 0||v.setSelectionState(!1)),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};l._handlePool=0,l=je([Ke(2,T.ILogService)],l),e.ExtHostSCM=l});var tt=this&&this.__classPrivateFieldSet||function(ae,e,E){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,E),E},$e=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(be[200],we([0,1,7,5,132,6]),function(ae,e,E,S,R,A){"use strict";var D,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(b,m,r,d,_=E.StatusBarAlignment.Left,g,w){D.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,tt(this,D,b),tt(this,I,m),this._id=y.ID_GEN++,this._statusId=r,this._statusName=d,this._alignment=_,this._priority=g,this._accessibilityInformation=w}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var b;return(b=this._command)===null||b===void 0?void 0:b.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(b){this._text=b,this.update()}set tooltip(b){this._tooltip=b,this.update()}set color(b){this._color=b,this.update()}set backgroundColor(b){b&&!y.ALLOWED_BACKGROUND_COLORS.has(b.id)&&(b=void 0),this._backgroundColor=b,this.update()}set command(b){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==b&&(this._internalCommandRegistration.clear(),typeof b=="string"?this._command={fromApi:b,internal:$e(this,I).toInternal({title:"",command:b},this._internalCommandRegistration)}:b?this._command={fromApi:b,internal:$e(this,I).toInternal(b,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(b){this._accessibilityInformation=b,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,D).$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var b;this._timeoutHandle=void 0;let m=this._color;this._backgroundColor&&(m=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),$e(this,D).$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(b=this._command)===null||b===void 0?void 0:b.internal,m,this._backgroundColor,this._alignment===E.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,D=new WeakMap,I=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new E.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(b){this._messages=[],this._item=b.createStatusBarEntry("status.extensionMessage",(0,R.localize)(0,null),E.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(b){const m={message:b};return this._messages.unshift(m),this._update(),new E.Disposable(()=>{const r=this._messages.indexOf(m);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class T{constructor(b,m){this._proxy=b.getProxy(S.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new n(this)}createStatusBarEntry(b,m,r,d,_){return new y(this._proxy,this._commands,b,m,r,d,_)}setStatusBarMessage(b,m){const r=this._statusMessage.setMessage(b);let d;return typeof m=="number"?d=setTimeout(()=>r.dispose(),m):typeof m!="undefined"&&m.then(()=>r.dispose(),()=>r.dispose()),new E.Disposable(()=>{r.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=T}),define(be[75],we([0,1,5,3,4]),function(ae,e,E,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(I){this._onDidChangeStorage=new S.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(E.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,y){this._proxy.$registerExtensionStorageKeysToSync(I,y)}getValue(I,y,n){return this._proxy.$getValue(I,y).then(T=>T||n)}setValue(I,y,n){return this._proxy.$setValue(I,y,n)}$acceptValue(I,y,n){this._onDidChangeStorage.fire({shared:I,key:y,value:n})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,R.createDecorator)("IExtHostStorage")}),define(be[76],we([0,1,4,27,19,74,2]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,E.createDecorator)("IExtensionStoragePaths");let I=class{constructor(n,T,k){var b;this._logService=T,this._extHostFileSystem=k,this._workspace=(b=n.workspace)!==null&&b!==void 0?b:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,k=D.URI.joinPath(this._environment.workspaceStorageHome,T);try{return await this._extHostFileSystem.value.stat(k),this._logService.trace("[ExtHostStorage] storage dir already exists",k),k}catch(b){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",k),await this._extHostFileSystem.value.createDirectory(k),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=D.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),k}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(n){if(this._value)return D.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return D.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};I=je([Ke(0,S.IExtHostInitDataService),Ke(1,R.ILogService),Ke(2,A.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(be[41],we([0,1,3,5,4,2,14,6,7,133,10,168,20,29,152]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,R.createDecorator)("IExtHostTerminalService");class d{constructor(t,i,l,o){this._proxy=t,this._id=i,this._creationOptions=l,this._name=o,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(f=>this._pidPromiseComplete=f);const a=this;this.value={get name(){return a._name||""},get processId(){return a._pidPromise},get creationOptions(){return a._creationOptions},get exitStatus(){return a._exitStatus},sendText(f,v=!0){a._checkDisposed(),a._proxy.$sendText(a._id,f,v)},show(f){a._checkDisposed(),a._proxy.$show(a._id,f)},hide(){a._checkDisposed(),a._proxy.$hide(a._id)},dispose(){a._disposed||(a._disposed=!0,a._proxy.$dispose(a._id))},get dimensions(){if(!(a._cols===void 0||a._rows===void 0))return{columns:a._cols,rows:a._rows}}}}async create(t,i,l,o,a,f,v,C,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:l,env:o,waitOnExit:a,strictEnv:f,hideFromUser:v,isFeatureTerminal:C,isExtensionOwnedTerminal:h})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=d;class _{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new E.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new E.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new E.Emitter,this._onProcessTitleChanged=new E.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new E.Emitter,this._onProcessShellTypeChanged=new E.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=_;let g=1,w=class extends I.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new E.Emitter,this._onDidOpenTerminal=new E.Emitter,this._onDidChangeActiveTerminal=new E.Emitter,this._onDidChangeTerminalDimensions=new E.Emitter,this._proxy=i.getProxy(S.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new E.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[l,o]of this._terminalProcesses)o.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new d(this._proxy,(0,m.generateUuid)(),t,t.name),l=new _(t.pty);return i.createExtensionTerminal().then(o=>{const a=this._setupExtHostProcessListeners(o,l);this._terminalProcessDisposables[o]=a}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const o=new _(i),a=this._setupExtHostProcessListeners(t,o);this._terminalProcessDisposables[t]=a}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(t);l&&(this._activeTerminal=l,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const l=this._getTerminalById(t);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:i})}async $acceptTerminalDimensions(t,i,l){const o=this._getTerminalById(t);o&&o.setDimensions(i,l)&&this._onDidChangeTerminalDimensions.fire({terminal:o.value,dimensions:o.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,l){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(i,l)}async $acceptTerminalTitleChange(t,i){const l=this._getTerminalById(t);l&&(l.name=i)}async $acceptTerminalClosed(t,i){const l=this._getTerminalObjectIndexById(this._terminals,t);if(l!==null){const o=this._terminals.splice(l,1)[0];o.setExitCode(i),this._onDidCloseTerminal.fire(o.value)}}$acceptTerminalOpened(t,i,l,o){if(i){const v=this._getTerminalObjectIndexById(this._terminals,i);if(v!==null){this._terminals[v]._id=t,this._onDidOpenTerminal.fire(this.terminals[v]),this._terminals[v].isOpen=!0;return}}const a={name:o.name,shellPath:o.executable,shellArgs:o.args,cwd:typeof o.cwd=="string"?o.cwd:A.URI.revive(o.cwd),env:o.env,hideFromUser:o.hideFromUser},f=new d(this._proxy,t,a,l);this._terminals.push(f),this._onDidOpenTerminal.fire(f.value),f.isOpen=!0}async $acceptTerminalProcessId(t,i){const l=this._getTerminalById(t);l&&l._setProcessId(i)}async $startExtensionTerminal(t,i){const l=this._getTerminalById(t);if(!l)return{message:(0,n.localize)(0,null,t)};l.isOpen||await new Promise(a=>{const f=this.onDidOpenTerminal(async v=>{v===l.value&&(f.dispose(),a())})});const o=this._terminalProcesses.get(t);o?o.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const l=new I.DisposableStore;l.add(i.onProcessReady(a=>this._proxy.$sendProcessReady(t,a.pid,a.cwd))),l.add(i.onProcessTitleChanged(a=>this._proxy.$sendProcessTitle(t,a))),this._bufferer.startBuffering(t,i.onProcessData),l.add(i.onProcessExit(a=>this._onProcessExit(t,a))),i.onProcessOverrideDimensions&&l.add(i.onProcessOverrideDimensions(a=>this._proxy.$sendOverrideDimensions(t,a))),this._terminalProcesses.set(t,i);const o=this._extensionTerminalAwaitingStart[t];return o&&i instanceof _&&(i.startSendingEvents(o.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),l}$acceptProcessAckDataEvent(t,i){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.input(i)}$acceptProcessResize(t,i,l){var o;try{(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(i,l)}catch(a){if(a.code!=="EPIPE"&&a.code!=="ERR_IPC_CHANNEL_CLOSED")throw a}}$acceptProcessShutdown(t,i){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(t,l))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(l=>this._proxy.$sendProcessCwd(t,l))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const l=this._getTerminalById(t);if(!l)return[];this._terminalLinkCache.delete(t);const o=this._terminalLinkCancellationSource.get(t);o&&o.dispose(!0);const a=new b.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,a);const f=[],v={terminal:l.value,line:i},C=[];for(const P of this._linkProviders)C.push(new Promise(async F=>{a.token.onCancellationRequested(()=>F({provider:P,links:[]}));const z=await P.provideTerminalLinks(v,a.token)||[];a.token.isCancellationRequested||F({provider:P,links:z})}));const h=await Promise.all(C);if(a.token.isCancellationRequested)return[];const p=new Map;for(const P of h)P&&P.links.length>0&&f.push(...P.links.map(F=>{const z={id:g++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return p.set(z.id,{provider:P.provider,link:F}),z}));return this._terminalLinkCache.set(t,p),f}$activateLink(t,i){var l;const o=(l=this._terminalLinkCache.get(t))===null||l===void 0?void 0:l.get(i);!o||o.provider.handleTerminalLink(o.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const l=this._terminalProcessDisposables[t];l&&(l.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const l=this._getTerminalObjectIndexById(t,i);return l!==null?t[l]:null}_getTerminalObjectIndexById(t,i){let l=null;return t.some((o,a)=>o._id===i?(l=a,!0):!1),l}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new u,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const l=(0,k.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const l=i[0],o=new u(i[1]);this._setEnvironmentVariableCollection(l,o)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};w=je([Ke(1,D.IExtHostRpcService)],w),e.BaseExtHostTerminalService=w;class u{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new E.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const l=this.map.get(t);(!l||l.value!==i.value||l.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((l,o)=>t.call(i,o,l,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let c=class extends w{constructor(t){super(!1,t)}createTerminal(t,i,l){throw new T.NotSupportedError}createTerminalFromOptions(t){throw new T.NotSupportedError}getDefaultShell(t,i){return""}getDefaultShellArgs(t,i){throw new T.NotSupportedError}$getAvailableProfiles(t){throw new T.NotSupportedError}async $getDefaultShellAndArgs(t){throw new T.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};c=je([Ke(0,D.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(be[201],we([0,1,3,15,5,96,9,7]),function(ae,e,E,S,R,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(T,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new E.Emitter,this._onDidChangeTextEditorOptions=new E.Emitter,this._onDidChangeTextEditorVisibleRanges=new E.Emitter,this._onDidChangeTextEditorViewColumn=new E.Emitter,this._onDidChangeActiveTextEditor=new E.Emitter,this._onDidChangeVisibleTextEditors=new E.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=T.getProxy(R.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(b=>this._onDidChangeVisibleTextEditors.fire(b)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(b=>this._onDidChangeActiveTextEditor.fire(b))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(T){const k=this._extHostDocumentsAndEditors.allEditors();return T?k:k.map(b=>b.value)}async showTextDocument(T,k,b){let m;typeof k=="number"?m={position:D.ViewColumn.from(k),preserveFocus:b}:typeof k=="object"?m={position:D.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?D.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:m={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(T.uri,m),d=r&&this._extHostDocumentsAndEditors.getEditor(r);if(d)return d.value;throw r?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T){return new A.TextEditorDecorationType(this._proxy,T).value}$acceptEditorPropertiesChanged(T,k){const b=this._extHostDocumentsAndEditors.getEditor(T);if(!b)throw new Error("unknown text editor");if(k.options&&b._acceptOptions(k.options),k.selections){const m=k.selections.selections.map(D.Selection.to);b._acceptSelections(m)}if(k.visibleRanges){const m=S.coalesce(k.visibleRanges.map(D.Range.to));b._acceptVisibleRanges(m)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:b.value,options:Object.assign(Object.assign({},k.options),{lineNumbers:D.TextEditorLineNumbersStyle.to(k.options.lineNumbers)})}),k.selections){const m=I.TextEditorSelectionChangeKind.fromValue(k.selections.source),r=k.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:b.value,selections:r,kind:m})}if(k.visibleRanges){const m=S.coalesce(k.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:b.value,visibleRanges:m})}}$acceptEditorPositionData(T){for(const k in T){const b=this._extHostDocumentsAndEditors.getEditor(k);if(!b)throw new Error("Unknown text editor");const m=D.ViewColumn.to(T[k]);b.value.viewColumn!==m&&(b._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:b.value,viewColumn:m}))}}getDiffInformation(T){return Promise.resolve(this._proxy.$getDiffInformation(T))}}e.ExtHostEditors=y});var dn=this&&this.__rest||function(ae,e){var E={};for(var S in ae)Object.prototype.hasOwnProperty.call(ae,S)&&e.indexOf(S)<0&&(E[S]=ae[S]);if(ae!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,S=Object.getOwnPropertySymbols(ae);R<S.length;R++)e.indexOf(S[R])<0&&Object.prototype.propertyIsEnumerable.call(ae,S[R])&&(E[S[R]]=ae[S[R]]);return E};define(be[202],we([0,1,2,4,5,6,7]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,S.createDecorator)("IExtHostTimeline");class I{constructor(T,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=T.getProxy(R.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:b=>{var m,r;if(b&&b.$mid===11){const d=b.uri===void 0?void 0:E.URI.revive(b.uri);return(r=(m=this._itemsBySourceAndUriMap.get(b.source))===null||m===void 0?void 0:m.get(y(d)))===null||r===void 0?void 0:r.get(b.handle)}return b}})}async $getTimeline(T,k,b,m,r){const d=this._providers.get(T);return d==null?void 0:d.provideTimeline(E.URI.revive(k),b,m,r)}registerTimelineProvider(T,k,b,m){const r=new A.DisposableStore,d=this.convertTimelineItem(k.id,m,r).bind(this);let _;k.onDidChange&&(_=k.onDidChange(w=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},w),{id:k.id})),this));const g=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},k),{scheme:T,onDidChange:void 0,async provideTimeline(w,u,c,s){var t;(s==null?void 0:s.resetCache)&&(r.clear(),(t=g.get(k.id))===null||t===void 0||t.clear());const i=await k.provideTimeline(w,u,c);if(i!=null){const l=d(w,s);return Object.assign(Object.assign({},i),{source:k.id,items:i.items.map(l)})}},dispose(){var w;for(const u of g.values())(w=u.get(k.id))===null||w===void 0||w.clear();_==null||_.dispose(),r.dispose()}}))}convertTimelineItem(T,k,b){return(m,r)=>{let d;if(r==null?void 0:r.cacheResults){let _=this._itemsBySourceAndUriMap.get(T);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(T,_));const g=y(m);d=_.get(g),d===void 0&&(d=new Map,_.set(g,d))}return _=>{var g,w;const{iconPath:u}=_,c=dn(_,["iconPath"]),s=`${T}|${(g=_.id)!==null&&g!==void 0?g:_.timestamp}`;d==null||d.set(s,_);let t,i,l;return _.iconPath&&(u instanceof D.ThemeIcon?l={id:u.id}:E.URI.isUri(u)?(t=u,i=u):{light:t,dark:i}=u),Object.assign(Object.assign({},c),{id:(w=c.id)!==null&&w!==void 0?w:void 0,handle:s,source:T,command:_.command?k.toInternal(_.command,b):void 0,icon:t,iconDark:i,themeIcon:l,accessibilityInformation:_.accessibilityInformation})}}}registerTimelineProviderCore(T){if(this._providers.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this._proxy.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this._providers.set(T.id,T),(0,A.toDisposable)(()=>{var b;for(const m of this._itemsBySourceAndUriMap.values())(b=m.get(T.id))===null||b===void 0||b.clear();this._providers.delete(T.id),this._proxy.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=I;function y(n){return n==null?void 0:n.toString()}}),define(be[203],we([0,1,6,16,2,5]),function(ae,e,E,S,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,n,T,k){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const b=k.schemes.find(m=>!D.supportedSchemes.has(m));if(b)throw new Error(`Scheme '${b}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,T),this._proxy.$registerUriOpener(n,k.schemes,y,k.label),(0,E.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(y,n,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const b=R.URI.revive(n);return k.canOpenExternalUri(b,T)}async $openUri(y,n,T){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(R.URI.revive(n.resolvedUri),{sourceUri:R.URI.revive(n.sourceUri)},T)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([S.Schemas.http,S.Schemas.https])}),define(be[204],we([0,1,5,2,6,10,25]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(E.MainContext.MainThreadUrls)}registerUriHandler(n,T){if(this.handles.has(D.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const k=I.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(n)),this.handlers.set(k,T),this._proxy.$registerUriHandler(k,n),(0,R.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(n)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(n,T){const k=this.handlers.get(n);if(!k)return Promise.resolve(void 0);try{k.handleUri(S.URI.revive(T))}catch(b){(0,A.onUnexpectedError)(b)}return Promise.resolve(void 0)}async createAppUri(n){return S.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=I,I.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(ae,e,E){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,E),E},$e=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(be[49],we([0,1,3,2,69,5]),function(ae,e,E,S,R,A){"use strict";var D,I,y,n,T,k,b,m,r,d,_;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class g{constructor(l,o,a,f,v,C,h){D.set(this,void 0),I.set(this,void 0),y.set(this,void 0),n.set(this,void 0),T.set(this,void 0),k.set(this,void 0),b.set(this,""),m.set(this,void 0),r.set(this,!1),d.set(this,!1),this._onMessageEmitter=new E.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,_.set(this,new E.Emitter),this._onDidDispose=$e(this,_).event,tt(this,D,l),tt(this,I,o),tt(this,m,a),tt(this,n,f),tt(this,T,v),tt(this,k,C),tt(this,y,h)}dispose(){tt(this,r,!0),$e(this,_).fire(),$e(this,_).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(l){return tt(this,d,!0),(0,R.asWebviewUri)($e(this,n),$e(this,D),l)}get cspSource(){return $e(this,n).webviewCspSource.replace("{{uuid}}",$e(this,D))}get html(){return this.assertNotDisposed(),$e(this,b)}set html(l){this.assertNotDisposed(),$e(this,b)!==l&&(tt(this,b,l),!$e(this,d)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(l)&&(tt(this,d,!0),$e(this,y).report("Webview vscode-resource: uris",$e(this,k),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,I).$setHtml($e(this,D),l))}get options(){return this.assertNotDisposed(),$e(this,m)}set options(l){this.assertNotDisposed(),$e(this,I).$setOptions($e(this,D),c($e(this,k),$e(this,T),l)),tt(this,m,l)}async postMessage(l){return $e(this,r)?!1:$e(this,I).$postMessage($e(this,D),l)}assertNotDisposed(){if($e(this,r))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,D=new WeakMap,I=new WeakMap,y=new WeakMap,n=new WeakMap,T=new WeakMap,k=new WeakMap,b=new WeakMap,m=new WeakMap,r=new WeakMap,d=new WeakMap,_=new WeakMap;class w{constructor(l,o,a,f,v){this.initData=o,this.workspace=a,this._logService=f,this._deprecationService=v,this._webviews=new Map,this._webviewProxy=l.getProxy(A.MainContext.MainThreadWebviews)}$onMessage(l,o){const a=this.getWebview(l);a&&a._onMessageEmitter.fire(o)}$onMissingCsp(l,o){this._logService.warn(`${o} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(l,o,a){const f=new g(l,this._webviewProxy,s(o),this.initData,this.workspace,a,this._deprecationService);return this._webviews.set(l,f),f._onDidDispose(()=>{this._webviews.delete(l)}),f}deleteWebview(l){this._webviews.delete(l)}getWebview(l){return this._webviews.get(l)}}e.ExtHostWebviews=w;function u(i){return{id:i.identifier,location:i.extensionLocation}}e.toExtensionData=u;function c(i,l,o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots||t(i,l)}}e.serializeWebviewOptions=c;function s(i){var l;return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,portMapping:i.portMapping,localResourceRoots:(l=i.localResourceRoots)===null||l===void 0?void 0:l.map(o=>S.URI.from(o))}}e.reviveOptions=s;function t(i,l){return[...((l==null?void 0:l.getWorkspaceFolders())||[]).map(o=>o.uri),i.extensionLocation]}}),define(be[205],we([0,1,20,56,6,16,24,2,9,49,92,5,7]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new T.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class r{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,l){const o=this.key(t,i.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const a=new m(i,l);return this._documents.set(o,a),a}delete(t,i){const l=this.key(t,i.uri);this._documents.delete(l)}key(t,i){return`${t}@@@${i}`}}var d;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(d||(d={}));class _{constructor(){this._providers=new Map}addTextProvider(t,i,l){return this.add(0,t,i,l)}addCustomProvider(t,i,l){return this.add(1,t,i,l)}get(t){return this._providers.get(t)}add(t,i,l,o){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:l,provider:o}),new b.Disposable(()=>this._providers.delete(i))}}class g{constructor(t,i,l,o,a){this._extHostDocuments=i,this._extensionStoragePaths=l,this._extHostWebview=o,this._extHostWebviewPanels=a,this._editorProviders=new _,this._documents=new r,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,l,o){const a=new R.DisposableStore;return w(l)?(a.add(this._editorProviders.addTextProvider(i,t,l)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),i,o.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor})):(a.add(this._editorProviders.addCustomProvider(i,t,l)),this.supportEditing(l)&&a.add(l.onDidChangeCustomDocument(f=>{const v=this.getCustomDocumentEntry(i,f.document.uri);if(u(f)){const C=v.addEdit(f);this._proxy.$onDidEdit(f.document.uri,i,C,f.label)}else this._proxy.$onContentChange(f.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),i,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument)),b.Disposable.from(a,new b.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,l,o,a){var f;const v=this._editorProviders.get(i);if(!v)throw new Error(`No provider found for '${i}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${i}'`);const C=I.URI.revive(t),h=await v.provider.openCustomDocument(C,{backupId:l,untitledDocumentData:o==null?void 0:o.buffer},a);let p;return this.supportEditing(v.provider)&&this._extensionStoragePaths&&(p=(f=this._extensionStoragePaths.workspaceValue(v.extension))!==null&&f!==void 0?f:this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(i,h,p),{editable:this.supportEditing(v.provider)}}async $disposeCustomDocument(t,i){const l=this._editorProviders.get(i);if(!l)throw new Error(`No provider found for '${i}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${i}'`);const o=I.URI.revive(t),{document:a}=this.getCustomDocumentEntry(i,o);this._documents.delete(i,a),a.dispose()}async $resolveWebviewEditor(t,i,l,o,a,f){const v=this._editorProviders.get(l);if(!v)throw new Error(`No provider found for '${l}'`);const C=y.ViewColumn.to(a),h=this._extHostWebview.createNewWebview(i,o.webviewOptions,v.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(i,l,o.title,C,o.panelOptions,h),P=I.URI.revive(t);switch(v.type){case 1:{const{document:F}=this.getCustomDocumentEntry(l,P);return v.provider.resolveCustomEditor(F,p,f)}case 0:{const F=this._extHostDocuments.getDocument(P);return v.provider.resolveCustomTextEditor(F,p,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,l){this.getCustomDocumentEntry(i,t).disposeEdits(l)}async $onMoveCustomEditor(t,i,l){const o=this._editorProviders.get(l);if(!o)throw new Error(`No provider found for '${l}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const f=I.URI.revive(i),v=this._extHostDocuments.getDocument(f);await o.provider.moveCustomTextEditor(v,a,E.CancellationToken.None)}async $undo(t,i,l,o){return this.getCustomDocumentEntry(i,t).undo(l,o)}async $redo(t,i,l,o){return this.getCustomDocumentEntry(i,t).redo(l,o)}async $revert(t,i,l){const o=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(o.document,l),o.disposeBackup()}async $onSave(t,i,l){const o=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(o.document,l),o.disposeBackup()}async $onSaveAs(t,i,l,o){const a=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(a.document,I.URI.revive(l),o)}async $backup(t,i,l){const o=this.getCustomDocumentEntry(i,t),f=await this.getCustomEditorProvider(i).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},l);return o.updateBackup(f),f.id}getCustomDocumentEntry(t,i){const l=this._documents.get(t,I.URI.revive(i));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(t){const i=this._editorProviders.get(t),l=i==null?void 0:i.provider;if(!l||!this.supportEditing(l))throw new Error("Custom document is not editable");return l}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=g;function w(s){return typeof s.resolveCustomTextEditor=="function"}function u(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function c(s){const t=s.scheme===A.Schemas.file||s.scheme===A.Schemas.untitled?s.fsPath:s.toString();return(0,S.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(ae,e,E){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,E),E},$e=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(be[206],we([0,1,3,6,2,29,9,49,5,7]),function(ae,e,E,S,R,A,D,I,y,n){"use strict";var T,k,b,m,r,d,_,g,w,u,c,s,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends S.Disposable{constructor(f,v,C,h,p,P,F){super();T.set(this,void 0),k.set(this,void 0),b.set(this,void 0),m.set(this,void 0),r.set(this,void 0),d.set(this,void 0),_.set(this,void 0),g.set(this,void 0),w.set(this,!0),u.set(this,!0),c.set(this,!1),s.set(this,this._register(new E.Emitter)),this.onDidDispose=$e(this,s).event,t.set(this,this._register(new E.Emitter)),this.onDidChangeViewState=$e(this,t).event,tt(this,T,f),tt(this,k,v),tt(this,b,C),tt(this,r,P),tt(this,g,p),tt(this,d,h),tt(this,m,F)}dispose(){$e(this,c)||(tt(this,c,!0),$e(this,s).fire(),$e(this,k).$disposeWebview($e(this,T)),$e(this,m).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,m)}get viewType(){return this.assertNotDisposed(),$e(this,b)}get title(){return this.assertNotDisposed(),$e(this,d)}set title(f){this.assertNotDisposed(),$e(this,d)!==f&&(tt(this,d,f),$e(this,k).$setTitle($e(this,T),f))}get iconPath(){return this.assertNotDisposed(),$e(this,_)}set iconPath(f){this.assertNotDisposed(),$e(this,_)!==f&&(tt(this,_,f),$e(this,k).$setIconPath($e(this,T),R.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return $e(this,r)}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,g)=="number"&&$e(this,g)<0))return $e(this,g)}get active(){return this.assertNotDisposed(),$e(this,u)}get visible(){return this.assertNotDisposed(),$e(this,w)}_updateViewState(f){$e(this,c)||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(tt(this,u,f.active),tt(this,w,f.visible),tt(this,g,f.viewColumn),$e(this,t).fire({webviewPanel:this}))}reveal(f,v){this.assertNotDisposed(),$e(this,k).$reveal($e(this,T),{viewColumn:f?D.ViewColumn.from(f):void 0,preserveFocus:!!v})}assertNotDisposed(){if($e(this,c))throw new Error("Webview is disposed")}}T=new WeakMap,k=new WeakMap,b=new WeakMap,m=new WeakMap,r=new WeakMap,d=new WeakMap,_=new WeakMap,g=new WeakMap,w=new WeakMap,u=new WeakMap,c=new WeakMap,s=new WeakMap,t=new WeakMap;class l{constructor(f,v,C){this.webviews=v,this.workspace=C,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(f,v,C,h,p={}){const P=typeof h=="object"?h.viewColumn:h,F={viewColumn:D.ViewColumn.from(P),preserveFocus:typeof h=="object"&&!!h.preserveFocus},z=l.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(f),z,v,{title:C,panelOptions:o(p),webviewOptions:(0,I.serializeWebviewOptions)(f,this.workspace,p)},F);const le=this.webviews.createNewWebview(z,p,f);return this.createNewWebviewPanel(z,v,C,P,p,le)}$onDidChangeWebviewPanelViewStates(f){const v=Object.keys(f);v.sort((C,h)=>{const p=f[C],P=f[h];return p.active?1:P.active?-1:+p.visible-+P.visible});for(const C of v){const h=this.getWebviewPanel(C);if(!!h){const p=f[C];h._updateViewState({active:p.active,visible:p.visible,viewColumn:D.ViewColumn.to(p.position)})}}}async $onDidDisposeWebviewPanel(f){const v=this.getWebviewPanel(f);v==null||v.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,v,C){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:C,extension:f}),this._proxy.$registerSerializer(v),new n.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(f,v,C,h){const p=this._serializers.get(v);if(!p)throw new Error(`No serializer found for '${v}'`);const{serializer:P,extension:F}=p,z=this.webviews.createNewWebview(f,C.webviewOptions,F),le=this.createNewWebviewPanel(f,v,C.title,h,C.panelOptions,z);await P.deserializeWebviewPanel(le,C.state)}createNewWebviewPanel(f,v,C,h,p,P){const F=new i(f,this._proxy,v,C,h,p,P);return this._webviewPanels.set(f,F),F}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=l;function o(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(ae,e,E){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,E),E},$e=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(be[207],we([0,1,3,6,49,5,7]),function(ae,e,E,S,R,A,D){"use strict";var I,y,n,T,k,b,m,r,d,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class g extends S.Disposable{constructor(c,s,t,i,l,o){super();I.set(this,void 0),y.set(this,void 0),n.set(this,void 0),T.set(this,void 0),k.set(this,!1),b.set(this,void 0),m.set(this,void 0),r.set(this,void 0),d.set(this,this._register(new E.Emitter)),this.onDidChangeVisibility=$e(this,d).event,_.set(this,this._register(new E.Emitter)),this.onDidDispose=$e(this,_).event,tt(this,n,t),tt(this,m,i),tt(this,I,c),tt(this,y,s),tt(this,T,l),tt(this,b,o)}dispose(){$e(this,k)||(tt(this,k,!0),$e(this,_).fire(),$e(this,T).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,m)}set title(c){this.assertNotDisposed(),$e(this,m)!==c&&(tt(this,m,c),$e(this,y).$setWebviewViewTitle($e(this,I),c))}get description(){return this.assertNotDisposed(),$e(this,r)}set description(c){this.assertNotDisposed(),$e(this,r)!==c&&(tt(this,r,c),$e(this,y).$setWebviewViewDescription($e(this,I),c))}get visible(){return $e(this,b)}get webview(){return $e(this,T)}get viewType(){return $e(this,n)}_setVisible(c){c===$e(this,b)||$e(this,k)||(tt(this,b,c),$e(this,d).fire())}show(c){this.assertNotDisposed(),$e(this,y).$show($e(this,I),!!c)}assertNotDisposed(){if($e(this,k))throw new Error("Webview is disposed")}}I=new WeakMap,y=new WeakMap,n=new WeakMap,T=new WeakMap,k=new WeakMap,b=new WeakMap,m=new WeakMap,r=new WeakMap,d=new WeakMap,_=new WeakMap;class w{constructor(c,s){this._extHostWebview=s,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,s,t,i){if(this._viewProviders.has(s))throw new Error(`View provider for '${s}' already registered`);return this._viewProviders.set(s,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,R.toExtensionData)(c),s,i),new D.Disposable(()=>{this._viewProviders.delete(s),this._proxy.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(c,s,t,i,l){const o=this._viewProviders.get(s);if(!o)throw new Error(`No view provider found for '${s}'`);const{provider:a,extension:f}=o,v=this._extHostWebview.createNewWebview(c,{},f),C=new g(c,this._proxy,s,t,v,!0);this._webviewViews.set(c,C),await a.resolveWebviewView(C,{state:i},l)}async $onDidChangeWebviewViewVisibility(c,s){this.getWebviewView(c)._setVisible(s)}async $disposeWebviewView(c){const s=this.getWebviewView(c);this._webviewViews.delete(c),s.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const s=this._webviewViews.get(c);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=w}),define(be[100],we([0,1,3,5,2,16,8,4,14]),function(ae,e,E,S,R,A,D,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Pn{constructor(k){this._onDidChangeWindowState=new E.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Pn.InitialState,this._proxy=k.getProxy(S.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(b=>this.$onDidChangeWindowFocus(b))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:k}),this._onDidChangeWindowState.fire(this._state))}openUri(k,b){let m;if(typeof k=="string"){m=k;try{k=R.URI.parse(k)}catch(r){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,D.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,m,b)}async asExternalUri(k,b){if((0,D.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([A.Schemas.http,A.Schemas.https]).has(k.scheme))return Promise.reject(`Invalid scheme '${k.scheme}'`);const m=await this._proxy.$asExternalUri(k,b);return R.URI.from(m)}};n.InitialState={focused:!0},n=je([Ke(0,y.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(be[208],we([0,1,19,5,27,14]),function(ae,e,E,S,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let D=class extends E.AbstractLogger{constructor(y,n){super();this._proxy=y.getProxy(S.MainContext.MainThreadLog),this._logFile=n.logFile.toJSON(),this.setLevel(n.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...n){this.getLevel()<=E.LogLevel.Trace&&this._proxy.$log(this._logFile,E.LogLevel.Trace,Array.from(arguments))}debug(y,...n){this.getLevel()<=E.LogLevel.Debug&&this._proxy.$log(this._logFile,E.LogLevel.Debug,Array.from(arguments))}info(y,...n){this.getLevel()<=E.LogLevel.Info&&this._proxy.$log(this._logFile,E.LogLevel.Info,Array.from(arguments))}warn(y,...n){this.getLevel()<=E.LogLevel.Warning&&this._proxy.$log(this._logFile,E.LogLevel.Warning,Array.from(arguments))}error(y,...n){this.getLevel()<=E.LogLevel.Error&&this._proxy.$log(this._logFile,E.LogLevel.Error,Array.from(arguments))}critical(y,...n){this.getLevel()<=E.LogLevel.Critical&&this._proxy.$log(this._logFile,E.LogLevel.Critical,Array.from(arguments))}flush(){}};D=je([Ke(0,A.IExtHostRpcService),Ke(1,R.IExtHostInitDataService)],D),e.ExtHostLogService=D}),define(be[209],we([0,1,13,20,10,3,6,111,182,97,26]),function(ae,e,E,S,R,A,D,I,y,n,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function b(o,a){try{return JSON.stringify(o,a)}catch(f){return"null"}}function m(o,a){return JSON.stringify(o,a)}function r(o){return o?(a,f)=>f&&f.$mid===1?o.transformOutgoing(f):f:null}var d;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const g=()=>{},w=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class c extends D.Disposable{constructor(a,f=null,v=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=f,this._uriTransformer=v,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let C=0,h=n.ProxyIdentifier.count;C<h;C++)this._locals[C]=null,this._proxies[C]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new E.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(C=>this._receiveOneMessage(C))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(R.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,I.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:f,sid:v}=a;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,v)),this._proxies[f]}_createProxy(a,f){let v={get:(C,h)=>(typeof h=="string"&&!C[h]&&h.charCodeAt(0)===36&&(C[h]=(...p)=>this._remoteCall(a,h,p)),h===u?f:C[h])};return new Proxy(Object.create(null),v)}set(a,f){return this._locals[a.nid]=f,f}assertRegistered(a){for(let f=0,v=a.length;f<v;f++){const C=a[f];if(!this._locals[C.nid])throw new Error(`Missing actor ${C.sid} (isMain: ${C.isMain})`)}}_receiveOneMessage(a){if(!this._isDisposed){const f=a.byteLength,v=s.read(a,0),C=v.readUInt8(),h=v.readUInt32();switch(C){case 1:case 2:{let{rpcId:p,method:P,args:F}=t.deserializeRequestJSONArgs(v);this._uriTransformer&&(F=(0,I.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,h,p,P,F,C===2);break}case 3:case 4:{let{rpcId:p,method:P,args:F}=t.deserializeRequestMixedArgs(v);this._uriTransformer&&(F=(0,I.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,h,p,P,F,C===4);break}case 5:{this._logger&&this._logger.logIncoming(f,h,0,"ack"),this._onDidReceiveAcknowledge(h);break}case 6:{this._receiveCancel(f,h);break}case 7:{this._receiveReply(f,h,void 0);break}case 9:{let p=t.deserializeReplyOKJSON(v);this._uriTransformer&&(p=(0,I.transformIncomingURIs)(p,this._uriTransformer)),this._receiveReply(f,h,p);break}case 8:{let p=t.deserializeReplyOKVSBuffer(v);this._receiveReply(f,h,p);break}case 10:{let p=t.deserializeReplyErrError(v);this._uriTransformer&&(p=(0,I.transformIncomingURIs)(p,this._uriTransformer)),this._receiveReplyErr(f,h,p);break}case 11:{this._receiveReplyErr(f,h,void 0);break}default:console.error("received unexpected message"),console.error(a)}}}_receiveRequest(a,f,v,C,h,p){this._logger&&this._logger.logIncoming(a,f,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(v)}.${C}(`,h);const P=String(f);let F,z;if(p){const H=new S.CancellationTokenSource;h.push(H.token),F=this._invokeHandler(v,C,h),z=()=>H.cancel()}else F=this._invokeHandler(v,C,h),z=g;this._cancelInvokedHandlers[P]=z;const le=t.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(le.byteLength,f,1,"ack"),this._protocol.send(le),F.then(H=>{delete this._cancelInvokedHandlers[P];const W=t.serializeReplyOK(f,H,this._uriReplacer);this._logger&&this._logger.logOutgoing(W.byteLength,f,1,"reply:",H),this._protocol.send(W)},H=>{delete this._cancelInvokedHandlers[P];const W=t.serializeReplyErr(f,H);this._logger&&this._logger.logOutgoing(W.byteLength,f,1,"replyErr:",H),this._protocol.send(W)})}_receiveCancel(a,f){this._logger&&this._logger.logIncoming(a,f,1,"receiveCancel");const v=String(f);this._cancelInvokedHandlers[v]&&this._cancelInvokedHandlers[v]()}_receiveReply(a,f,v){this._logger&&this._logger.logIncoming(a,f,0,"receiveReply:",v);const C=String(f);if(!!this._pendingRPCReplies.hasOwnProperty(C)){const h=this._pendingRPCReplies[C];delete this._pendingRPCReplies[C],h.resolveOk(v)}}_receiveReplyErr(a,f,v){this._logger&&this._logger.logIncoming(a,f,0,"receiveReplyErr:",v);const C=String(f);if(!!this._pendingRPCReplies.hasOwnProperty(C)){const h=this._pendingRPCReplies[C];delete this._pendingRPCReplies[C];let p;v&&(v.$isError?(p=new Error,p.name=v.name,p.message=v.message,p.stack=v.stack):p=v),h.resolveErr(p)}}_invokeHandler(a,f,v){try{return Promise.resolve(this._doInvokeHandler(a,f,v))}catch(C){return Promise.reject(C)}}_doInvokeHandler(a,f,v){const C=this._locals[a];if(!C)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(a));let h=C[f];if(typeof h!="function")throw new Error("Unknown method "+f+" on actor "+(0,n.getStringIdentifierForProxy)(a));return h.apply(C,v)}_remoteCall(a,f,v){if(this._isDisposed)return Promise.reject(R.canceled());let C=null;if(v.length>0&&S.CancellationToken.isCancellationToken(v[v.length-1])&&(C=v.pop()),C&&C.isCancellationRequested)return Promise.reject(R.canceled());const h=t.serializeRequestArguments(v,this._uriReplacer),p=++this._lastMessageId,P=String(p),F=new y.LazyPromise;C&&C.onCancellationRequested(()=>{const le=t.serializeCancel(p);this._logger&&this._logger.logOutgoing(le.byteLength,p,0,"cancel"),this._protocol.send(t.serializeCancel(p))}),this._pendingRPCReplies[P]=F,this._onWillSendRequest(p);const z=t.serializeRequest(p,a,f,h,!!C);return this._logger&&this._logger.logOutgoing(z.byteLength,p,0,`request: ${(0,n.getStringIdentifierForProxy)(a)}.${f}(`,v),this._protocol.send(z),F}}e.RPCProtocol=c,k=w,c.UNRESPONSIVE_TIME=3*1e3;class s{constructor(a,f){this._buff=a,this._offset=f}static alloc(a,f,v){let C=new s(T.VSBuffer.alloc(v+1+4),0);return C.writeUInt8(a),C.writeUInt32(f),C}static read(a,f){return new s(a,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const v=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,v}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,v}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,f}static sizeMixedArray(a,f){let v=0;v+=1;for(let C=0,h=a.length;C<h;C++){const p=a[C],P=f[C];switch(v+=1,P){case 1:v+=this.sizeLongString(p);break;case 2:v+=this.sizeVSBuffer(p);break;case 3:break}}return v}writeMixedArray(a,f){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let v=0,C=a.length;v<C;v++){const h=a[v];switch(f[v]){case 1:this.writeUInt8(1),this.writeLongString(h);break;case 2:this.writeUInt8(2),this.writeVSBuffer(h);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(a);for(let v=0;v<a;v++)switch(this.readUInt8()){case 1:f[v]=this.readLongString();break;case 2:f[v]=this.readVSBuffer();break;case 3:f[v]=void 0;break}return f}}class t{static _arrayContainsBufferOrUndefined(a){for(let f=0,v=a.length;f<v;f++)if(a[f]instanceof T.VSBuffer||typeof a[f]=="undefined")return!0;return!1}static serializeRequestArguments(a,f){if(this._arrayContainsBufferOrUndefined(a)){let v=[],C=[];for(let h=0,p=a.length;h<p;h++){const P=a[h];P instanceof T.VSBuffer?(v[h]=P,C[h]=2):typeof P=="undefined"?(v[h]=T.VSBuffer.alloc(0),C[h]=3):(v[h]=T.VSBuffer.fromString(m(P,f)),C[h]=1)}return{type:"mixed",args:v,argsType:C}}return{type:"simple",args:m(a,f)}}static serializeRequest(a,f,v,C,h){return C.type==="mixed"?this._requestMixedArgs(a,f,v,C.args,C.argsType,h):this._requestJSONArgs(a,f,v,C.args,h)}static _requestJSONArgs(a,f,v,C,h){const p=T.VSBuffer.fromString(v),P=T.VSBuffer.fromString(C);let F=0;F+=s.sizeUInt8(),F+=s.sizeShortString(p),F+=s.sizeLongString(P);let z=s.alloc(h?2:1,a,F);return z.writeUInt8(f),z.writeShortString(p),z.writeLongString(P),z.buffer}static deserializeRequestJSONArgs(a){const f=a.readUInt8(),v=a.readShortString(),C=a.readLongString();return{rpcId:f,method:v,args:JSON.parse(C)}}static _requestMixedArgs(a,f,v,C,h,p){const P=T.VSBuffer.fromString(v);let F=0;F+=s.sizeUInt8(),F+=s.sizeShortString(P),F+=s.sizeMixedArray(C,h);let z=s.alloc(p?4:3,a,F);return z.writeUInt8(f),z.writeShortString(P),z.writeMixedArray(C,h),z.buffer}static deserializeRequestMixedArgs(a){const f=a.readUInt8(),v=a.readShortString(),C=a.readMixedArray(),h=new Array(C.length);for(let p=0,P=C.length;p<P;p++){const F=C[p];typeof F=="string"?h[p]=JSON.parse(F):h[p]=F}return{rpcId:f,method:v,args:h}}static serializeAcknowledged(a){return s.alloc(5,a,0).buffer}static serializeCancel(a){return s.alloc(6,a,0).buffer}static serializeReplyOK(a,f,v){return typeof f=="undefined"?this._serializeReplyOKEmpty(a):f instanceof T.VSBuffer?this._serializeReplyOKVSBuffer(a,f):this._serializeReplyOKJSON(a,b(f,v))}static _serializeReplyOKEmpty(a){return s.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,f){let v=0;v+=s.sizeVSBuffer(f);let C=s.alloc(8,a,v);return C.writeVSBuffer(f),C.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,f){const v=T.VSBuffer.fromString(f);let C=0;C+=s.sizeLongString(v);let h=s.alloc(9,a,C);return h.writeLongString(v),h.buffer}static deserializeReplyOKJSON(a){const f=a.readLongString();return JSON.parse(f)}static serializeReplyErr(a,f){return f?this._serializeReplyErrEror(a,f):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,f){const v=T.VSBuffer.fromString(b(R.transformErrorForSerialization(f),null));let C=0;C+=s.sizeLongString(v);let h=s.alloc(10,a,C);return h.writeLongString(v),h.buffer}static deserializeReplyErrError(a){const f=a.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(a){return s.alloc(11,a,0).buffer}}var i;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyErrError=10]="ReplyErrError",o[o.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var l;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.Undefined=3]="Undefined"})(l||(l={}))}),define(be[210],we([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const E=function(A){const D=I=>{self.removeEventListener("message",D);const y=I.data;Object.defineProperties(self,{postMessage:{value(n,T){y.postMessage(n,T)}},onmessage:{get(){return y.onmessage},set(n){y.onmessage=n}}}),y.addEventListener("message",n=>{self.dispatchEvent(new MessageEvent("message",{data:n.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",D)}.toString();class S extends EventTarget{constructor(A,D,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${E})('${D}'))`,n=new Blob([y],{type:"application/javascript"}),T=URL.createObjectURL(n),k=new MessageChannel,b=T,m={type:"_newWorker",id:b,port:k.port2,url:T,options:I};A(m,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:b};k.port1.postMessage(r),URL.revokeObjectURL(T),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(r){k.port1.onmessage=r}},onmessageerror:{get(){return k.port1.onmessageerror},set(r){k.port1.onmessageerror=r}}}),k.port1.addEventListener("messageerror",r=>{const d=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(d)}),k.port1.addEventListener("message",r=>{const d=new MessageEvent("message",{data:r.data});this.dispatchEvent(d)}),k.port1.start()}}e.NestedWorker=S}),define(be[211],we([0,1,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(be[212],we([0,1,16,11,21,2,4,211]),function(ae,e,E,S,R,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let y=class{constructor(T,k){this.localUserHome=T,this.remoteAgentService=k,this.resolveOS=(async()=>{const b=await this.remoteAgentService.getEnvironment();return(b==null?void 0:b.os)||R.OS})(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(b==null?void 0:b.userHome)||T})()}async userHome(T){return(T==null?void 0:T.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(T=>T===1?S.win32:S.posix)}async fileURI(T){let k="";if(await this.resolveOS===1&&(T=T.replace(/\\/g,"/")),T[0]==="/"&&T[1]==="/"){const m=T.indexOf("/",2);m===-1?(k=T.substring(2),T="/"):(k=T.substring(2,m),T=T.substring(m)||"/")}return A.URI.from({scheme:E.Schemas.file,authority:k,path:T,query:"",fragment:""})}};y=je([Ke(1,I.IRemoteAgentService)],y),e.AbstractPathService=y}),define(be[42],we([0,1,15,28,23,38,8,4,11,10]),function(ae,e,E,S,R,A,D,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const T="\u27EA ",k=" characters skipped \u27EB",b=(T.length+k.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var m;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var r;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(r=e.QueryType||(e.QueryType={}));function d(L){return!!L.preview}e.resultIsMatch=d;function _(L){return!!L.resource}e.isFileMatch=_;function g(L){return!!L.message}e.isProgressMessage=g;var w;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(w=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class u{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=u;class c{constructor(U,x,Q){this.ranges=x;const $=Array.isArray(x)?x:[x];if(Q&&Q.matchLines===1&&s($)){U=(0,D.getNLines)(U,Q.matchLines);let Z="",ie=0,re=0;const ye=Math.floor(Q.charsPerLine/5),Ie=[];for(const Ue of $){const Fe=Math.max(Ue.startColumn-ye,0),ze=Ue.startColumn+Q.charsPerLine;if(Fe>re+ye+b){const N=T+(Fe-re)+k;Z+=N+U.slice(Fe,ze),ie+=Fe-(re+N.length)}else Z+=U.slice(re,ze);Ie.push(new i(0,Ue.startColumn-ie,Ue.endColumn-ie)),re=ze}this.preview={text:Z,matches:Array.isArray(this.ranges)?Ie:Ie[0]}}else{const Z=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:U,matches:(0,E.mapArrayOrNot)(x,ie=>new t(ie.startLineNumber-Z,ie.startColumn,ie.endLineNumber-Z,ie.endColumn))}}}}e.TextSearchMatch=c;function s(L){const U=L[0].startLineNumber;for(const x of L)if(x.startLineNumber!==U||x.endLineNumber!==U)return!1;return!0}class t{constructor(U,x,Q,$){this.startLineNumber=U,this.startColumn=x,this.endLineNumber=Q,this.endColumn=$}}e.SearchRange=t;class i extends t{constructor(U,x,Q){super(U,x,U,Q)}}e.OneLineRange=i;var l;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function o(L,U=!0){const x=L&&L.files&&L.files.exclude,Q=U&&L&&L.search&&L.search.exclude;if(!(!x&&!Q)){if(!x||!Q)return x||Q;let $=Object.create(null);return $=R.mixin($,R.deepClone(x)),$=R.mixin($,R.deepClone(Q),!0),$}}e.getExcludes=o;function a(L,U){return L.excludePattern&&S.match(L.excludePattern,U)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&S.match(L.includePattern,U)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(x=>{const Q=x.folder.fsPath;if(A.isEqualOrParent(U,Q)){const $=y.relative(Q,U);return!x.includePattern||!!S.match(x.includePattern,$)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var f;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class v extends Error{constructor(U,x){super(U);this.code=x}}e.SearchError=v;function C(L){const U=L.message;if((0,n.isPromiseCanceledError)(L))return new v(U,f.canceled);try{const x=JSON.parse(U);return new v(x.message,x.code)}catch(x){return new v(U,f.other)}}e.deserializeSearchError=C;function h(L){const U={message:L.message,code:L.code};return new Error(JSON.stringify(U))}e.serializeSearchError=h;function p(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=p;function P(L){return L.type==="success"}e.isSerializedSearchSuccess=P;function F(L){return!!L.path}e.isSerializedFileMatch=F;function z(L,U){const x=L.searchPath?L.searchPath:L.relativePath;return(0,D.fuzzyContains)(x,U)}e.isFilePatternMatch=z;class le{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=le;function H(L,U){const x=Object.assign(Object.assign({},L||{}),U||{});return Object.keys(x).filter(Q=>{const $=x[Q];return typeof $=="boolean"&&$})}e.resolvePatternsForProvider=H;class W{constructor(U,x){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),x.excludePattern||{}),this._parsedExcludeExpression=S.parse(this._excludeExpression);let Q=U.includePattern;x.includePattern&&(Q?Q=Object.assign(Object.assign({},Q),x.includePattern):Q=x.includePattern),Q&&(this._parsedIncludeExpression=S.parse(Q))}includedInQuerySync(U,x,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,x,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,x,Q))}includedInQuery(U,x,Q){return Promise.resolve(this._parsedExcludeExpression(U,x,Q)).then(Z=>!!Z).then(Z=>Z?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,x,Q)).then(ie=>!!ie):Promise.resolve(!0)).then(Z=>Z)}hasSiblingExcludeClauses(){return G(this._excludeExpression)}}e.QueryGlobTester=W;function G(L){for(const U in L)if(typeof L[U]!="boolean")return!0;return!1}}),define(be[31],we([0,1,15,13,20,3,22,16,78,24,8,12,2,135,4,19,149,47,48,27,14,7,42,5]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d,_,g,w,u,c,s,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(P,F,z){return new n.ExtUri(le=>v(le,z)).isEqual(P,F)}function o(P,F,z){return l(P.uri,F.uri,z)?0:(0,T.compare)(P.uri.toString(),F.uri.toString())}function a(P,F,z){return P.index!==F.index?P.index<F.index?-1:1:l(P.uri,F.uri,z)?(0,T.compare)(P.name,F.name):(0,T.compare)(P.uri.toString(),F.uri.toString())}function f(P,F,z,le){const H=P.slice(0).sort((G,L)=>z(G,L,le)),W=F.slice(0).sort((G,L)=>z(G,L,le));return(0,E.delta)(H,W,(G,L)=>z(G,L,le))}function v(P,F){const z=F.getCapabilities(P.scheme);return!(z&&z&1024)}class C extends g.Workspace{constructor(F,z,le,H,W,G){super(F,le.map(L=>new g.WorkspaceFolder(L)),H,G);this._name=z,this._isUntitled=W,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(G),le.forEach(L=>{this._workspaceFolders.push(L),this._structure.set(L.uri,L)})}static toExtHostWorkspace(F,z,le,H){if(!F)return{workspace:null,added:[],removed:[]};const{id:W,name:G,folders:L,configuration:U,isUntitled:x}=F,Q=[],$=z;z?L.forEach((ye,Ie)=>{const Ue=b.URI.revive(ye.uri),Fe=C._findFolder(le||z,Ue,H);Fe?(Fe.name=ye.name,Fe.index=ye.index,Q.push(Fe)):Q.push({uri:Ue,name:ye.name,index:Ie})}):Q.push(...L.map(({uri:ye,name:Ie,index:Ue})=>({uri:b.URI.revive(ye),name:Ie,index:Ue}))),Q.sort((ye,Ie)=>ye.index<Ie.index?-1:1);const Z=new C(W,G,Q,U?b.URI.revive(U):null,!!x,ye=>v(ye,H)),{added:ie,removed:re}=f($?$.workspaceFolders:[],Z.workspaceFolders,o,H);return{workspace:Z,added:ie,removed:re}}static _findFolder(F,z,le){for(let H=0;H<F.folders.length;H++){const W=F.workspaceFolders[H];if(l(W.uri,z,le))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,z){return z&&this._structure.get(F)&&(F=(0,n.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let h=class{constructor(F,z,le,H){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new A.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=s.WorkspaceTrustState.Unknown,this._logService=H,this._extHostFileSystemInfo=le,this._requestIdProvider=new y.Counter,this._barrier=new S.Barrier,this._proxy=F.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(i.MainContext.MainThreadMessageService);const W=z.workspace;this._confirmedWorkspace=W?new C(W.id,W.name,[],W.configuration?b.URI.revive(W.configuration):null,!!W.isUntitled,G=>v(G,le)):void 0}$initializeWorkspace(F,z){this._workspaceTrustState=z,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?b.URI.from({scheme:I.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,z,le,...H){const W=[];if(Array.isArray(H)&&H.forEach(Q=>{b.URI.isUri(Q.uri)&&!W.some($=>l($.uri,Q.uri,this._extHostFileSystemInfo))&&W.push({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri)})}),this._unconfirmedWorkspace||[z,le].some(Q=>typeof Q!="number"||Q<0)||le===0&&W.length===0)return!1;const G=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+le>G.length)return!1;const L=G.slice(0);L.splice(z,le,...W.map(Q=>({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<L.length;Q++){const $=L[Q];if(L.some((Z,ie)=>ie!==Q&&l($.uri,Z.uri,this._extHostFileSystemInfo)))return!1}L.forEach((Q,$)=>Q.index=$);const{added:U,removed:x}=f(G,L,a,this._extHostFileSystemInfo);if(U.length===0&&x.length===0)return!1;if(this._proxy){const Q=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(Q,z,le,W).then(void 0,$=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,m.localize)(0,null,Q,$.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(L),!0}getWorkspaceFolder(F,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,z)}async getWorkspaceFolder2(F,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,z)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!!this._actualWorkspace){const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}}getRelativePath(F,z){let le,H="";if(typeof F=="string"?(le=b.URI.file(F),H=F):typeof F!="undefined"&&(le=F,H=F.fsPath),!le)return H;const W=this.getWorkspaceFolder(le,!0);if(!W)return H;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let G=(0,n.relativePath)(W.uri,le);return z&&W.name&&(G=`${W.name}/${G}`),G}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=C.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:z,added:le,removed:H}=C.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:le,removed:H}))}findFiles(F,z,le,H,W=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${H.value}, entryPoint: findFiles`);let G;if(z===null?G=!1:z&&(typeof z=="string"?G=z:G=z.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:L,folder:U}=p(F);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(L),(0,k.withUndefinedAsNull)(U),(0,k.withUndefinedAsNull)(G),(0,k.withUndefinedAsNull)(le),W).then(x=>Array.isArray(x)?x.map(Q=>b.URI.revive(Q)):[])}async findTextInFiles(F,z,le,H,W=R.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${H.value}, entryPoint: findTextInFiles`);const G=this._requestIdProvider.getNext(),L=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:U,folder:x}=p(z.include),Q=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,$={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:L,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:U,excludePattern:Q},Z=!1;if(this._activeSearchCallbacks[G]=ie=>{if(!Z){const re=b.URI.revive(ie.resource);ie.results.forEach(ye=>{(0,t.resultIsMatch)(ye)?le({uri:re,preview:{text:ye.preview.text,matches:(0,E.mapArrayOrNot)(ye.preview.matches,Ie=>new s.Range(Ie.startLineNumber,Ie.startColumn,Ie.endLineNumber,Ie.endColumn))},ranges:(0,E.mapArrayOrNot)(ye.ranges,Ie=>new s.Range(Ie.startLineNumber,Ie.startColumn,Ie.endLineNumber,Ie.endColumn))}):le({uri:re,text:ye.text,lineNumber:ye.lineNumber})})}},W.isCancellationRequested)return{};try{const ie=await this._proxy.$startTextSearch(F,(0,k.withUndefinedAsNull)(x),$,G,W);return delete this._activeSearchCallbacks[G],ie||{}}catch(ie){throw delete this._activeSearchCallbacks[G],ie}}$handleTextSearchResult(F,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trustState(){return this._workspaceTrustState}requireWorkspaceTrust(F){return this._proxy.$requireWorkspaceTrust(F)}$onDidChangeWorkspaceTrustState(F){this._workspaceTrustState=F.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze(F))}};h=je([Ke(0,c.IExtHostRpcService),Ke(1,u.IExtHostInitDataService),Ke(2,w.IExtHostFileSystemInfo),Ke(3,d.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function p(P){let F,z;return P&&(typeof P=="string"?F=P:(F=P.pattern,z=P.baseFolder||b.URI.file(P.base))),{includePattern:F,folder:z}}}),define(be[35],we([0,1,23,3,31,5,7,151,66,12,13,4,14,19,2]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(i,l){if(l){const o=l.split(".");let a=i;for(let f=0;a&&f<o.length;f++)a=a[o[f]];return a}}function _(i){return i instanceof r.URI}function g(i){return i&&i.uri instanceof r.URI&&i.languageId&&typeof i.languageId=="string"}function w(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function u(i){return i&&i.uri instanceof r.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function c(i){if(_(i))return{resource:i};if(g(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(w(i))return{overrideIdentifier:i.languageId};if(u(i))return{resource:i.uri};if(i===null)return{resource:null}}let s=class{constructor(l,o,a){this._proxy=l.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=a,this._barrier=new T.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(l=>this._actual)}$initializeConfiguration(l){this._actual=new t(this._proxy,this._extHostWorkspace,l,this._logService),this._barrier.open()}$acceptConfigurationChanged(l,o){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(l,o))}};s=je([Ke(0,b.IExtHostRpcService),Ke(1,R.IExtHostWorkspace),Ke(2,m.ILogService)],s),e.ExtHostConfiguration=s;class t{constructor(l,o,a,f){this._onDidChangeConfiguration=new S.Emitter,this._proxy=l,this._logService=f,this._extHostWorkspace=o,this._configuration=I.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(l,o){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,a))}getConfiguration(l,o,a){const f=c(o)||{},v=this._toReadonlyValue(l?d(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),l):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));l&&this._validateConfigurationAccess(l,f,a==null?void 0:a.identifier);function C(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case D.ConfigurationTarget.Global:return 1;case D.ConfigurationTarget.Workspace:return 4;case D.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(p){return typeof d(v,p)!="undefined"},get:(p,P)=>{this._validateConfigurationAccess(l?`${l}.${p}`:p,f,a==null?void 0:a.identifier);let F=d(v,p);if(typeof F=="undefined")F=P;else{let z;const le=(H,W)=>{let G;const L=()=>{z=z||(0,E.deepClone)(v),G=G||d(z,W)};return(0,n.isObject)(H)?new Proxy(H,{get:(U,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return L(),()=>G;if(z)return G=G||d(z,W),G[x];const Q=U[x];return typeof x=="string"?le(Q,`${W}.${x}`):Q},set:(U,x,Q)=>(L(),G&&(G[x]=Q),!0),deleteProperty:(U,x)=>(L(),G&&delete G[x],!0),defineProperty:(U,x,Q)=>(L(),G&&Object.defineProperty(G,x,Q),!0)}):H};F=le(F,p)}return F},update:(p,P,F,z)=>{p=l?`${l}.${p}`:p;const le=C(F);return P!==void 0?this._proxy.$updateConfigurationOption(le,p,P,f,z):this._proxy.$removeConfigurationOption(le,p,f,z)},inspect:p=>{var P,F,z,le,H,W,G,L;p=l?`${l}.${p}`:p;const U=(0,E.deepClone)(this._configuration.inspect(p,f,this._extHostWorkspace.workspace));if(U)return{key:p,defaultValue:(P=U.default)===null||P===void 0?void 0:P.value,globalValue:(F=U.user)===null||F===void 0?void 0:F.value,workspaceValue:(z=U.workspace)===null||z===void 0?void 0:z.value,workspaceFolderValue:(le=U.workspaceFolder)===null||le===void 0?void 0:le.value,defaultLanguageValue:(H=U.default)===null||H===void 0?void 0:H.override,globalLanguageValue:(W=U.user)===null||W===void 0?void 0:W.override,workspaceLanguageValue:(G=U.workspace)===null||G===void 0?void 0:G.override,workspaceFolderLanguageValue:(L=U.workspaceFolder)===null||L===void 0?void 0:L.override,languageIds:U.overrideIdentifiers}}};return typeof v=="object"&&(0,E.mixin)(h,v,!1),Object.freeze(h)}_toReadonlyValue(l){const o=a=>(0,n.isObject)(a)?new Proxy(a,{get:(f,v)=>o(f[v]),set:(f,v,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(f,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(f,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return o(l)}_validateConfigurationAccess(l,o,a){const f=y.OVERRIDE_PROPERTY_PATTERN.test(l)?4:this._configurationScopes.get(l),v=a?`[${a.value}] `:"";if(f===4){typeof(o==null?void 0:o.resource)=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){(o==null?void 0:o.resource)&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(l,o){const a=new I.ConfigurationChangeEvent(l,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,v)=>a.affectsConfiguration(f,c(v))})}_toMap(l){return l.reduce((o,a)=>(o.set(a[0],a[1]),o),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(ae,e,E){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,E),E},$e=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(be[101],we([0,1,2,13,3,5,7,31,40,35,20,41,14,27,4,16,21,19,72,167,10]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d,_,g,w,u,c){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(H){function W(L){if(L!=null)return L}H.from=W;function G(L){if(L!=null)return L}H.to=G})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(H){function W(L){if(L!=null)return L}H.from=W;function G(L){if(L!=null)return L}H.to=G})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var l;(function(H){function W(L){if(L!=null)return L}H.from=W;function G(L){if(L!=null)return L}H.to=G})(l=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(H){function W(U){if(U){const x=U;return x&&!!x.process}else return!1}H.is=W;function G(U){if(U!=null){const x={process:U.process,args:U.args};return U.options&&(x.options=l.from(U.options)),x}}H.from=G;function L(U){if(U!=null)return new D.ProcessExecution(U.process,U.args,U.options)}H.to=L})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(H){function W(L){if(L!=null)return L}H.from=W;function G(L){if(L!=null)return L}H.to=G})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(H){function W(U){if(U){const x=U;return x&&(!!x.commandLine||!!x.command)}else return!1}H.is=W;function G(U){if(U!=null){const x={};return U.commandLine!==void 0?x.commandLine=U.commandLine:(x.command=U.command,x.args=U.args),U.options&&(x.options=a.from(U.options)),x}}H.from=G;function L(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new D.ShellExecution(U.commandLine,U.options):new D.ShellExecution(U.command,U.args?U.args:[],U.options)}H.to=L})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(H){function W(U){if(U){let x=U;return x&&x.customExecution==="customExecution"}else return!1}H.is=W;function G(U){return{customExecution:"customExecution"}}H.from=G;function L(U,x){return x.get(U)}H.to=L})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var C;(function(H){function W(G,L){let U;return G.scope!==void 0&&typeof G.scope!="number"?U=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===D.TaskScope.Workspace&&L&&L.workspaceFile?U=L.workspaceFile:U=u.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:U}}H.from=W})(C=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(H){function W(U,x){if(U==null)return[];const Q=[];for(let $ of U){const Z=G($,x);Z&&Q.push(Z)}return Q}H.fromMany=W;function G(U,x){if(U!=null){let Q;U.execution instanceof D.ProcessExecution?Q=o.from(U.execution):U.execution instanceof D.ShellExecution?Q=f.from(U.execution):U.execution&&U.execution instanceof D.CustomExecution&&(Q=v.from(U.execution));const $=t.from(U.definition);let Z;if(U.scope?typeof U.scope=="number"?Z=U.scope:Z=U.scope.uri:Z=D.TaskScope.Workspace,!(!$||!Z)){const ie=U.group?U.group.id:void 0;return{_id:U._id,definition:$,name:U.name,source:{extensionId:x.identifier.value,label:U.source,scope:Z},execution:Q,isBackground:U.isBackground,group:ie,presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}}}H.from=G;async function L(U,x,Q){if(U!=null){let $;o.is(U.execution)?$=o.to(U.execution):f.is(U.execution)?$=f.to(U.execution):v.is(U.execution)&&($=v.to(U._id,Q));const Z=t.to(U.definition);let ie;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?ie=U.source.scope:ie=await x.resolveWorkspaceFolder(E.URI.revive(U.source.scope)):ie=D.TaskScope.Workspace),!(!Z||!ie)){const re=new D.Task(Z,ie,U.name,U.source.label,$,U.problemMatchers);return U.isBackground!==void 0&&(re.isBackground=U.isBackground),U.group!==void 0&&(re.group=D.TaskGroup.from(U.group)),U.presentationOptions&&(re.presentationOptions=i.to(U.presentationOptions)),U._id&&(re._id=U._id),U.detail&&(re.detail=U.detail),re}}}H.to=L})(h=e.TaskDTO||(e.TaskDTO={}));var p;(function(H){function W(L){return L}H.from=W;function G(L){if(!!L)return Object.assign(Object.create(null),L)}H.to=G})(p=e.TaskFilterDTO||(e.TaskFilterDTO={}));class P{constructor(W,G,L){this._id=G,this._task=L,s.set(this,void 0),tt(this,s,W)}get task(){return this._task}terminate(){$e(this,s).terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}s=new WeakMap;var F;(function(H){function W(G){return{id:G._id,task:void 0}}H.from=W})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let z=class{constructor(W,G,L,U,x,Q,$,Z){this._onDidExecuteTask=new R.Emitter,this._onDidTerminateTask=new R.Emitter,this._onDidTaskProcessStarted=new R.Emitter,this._onDidTaskProcessEnded=new R.Emitter,this._proxy=W.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=L,this._editorService=U,this._configurationService=x,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,G,L){if(!L)return new D.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:G,provider:L,extension:W}),this._proxy.$registerTaskProvider(U,G),new D.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(W,G){this._proxy.$registerTaskSystem(W,G)}fetchTasks(W){return this._proxy.$fetchTasks(p.from(W)).then(async G=>{const L=[];for(let U of G){const x=await h.to(U,this._workspaceProvider,this._providedCustomExecutions2);x&&L.push(x)}return L})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(G=>W.push(G)),W}terminateTask(W){if(!(W instanceof P))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,G,L){const U=this._providedCustomExecutions2.get(W.id);if(U){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,U),this._terminalService.attachPtyToTerminal(G,await U.callback(L))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const G=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const G=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:G,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const G=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:W.exitCode})}$provideTasks(W,G){const L=this._handlers.get(W);if(!L)return Promise.reject(new Error("no handler found"));const U=[],x=(0,S.asPromise)(()=>L.provider.provideTasks(T.CancellationToken.None)).then(Q=>this.provideTasksInternal(G,U,L,Q));return new Promise(Q=>{x.then($=>{Promise.all(U).then(()=>{Q($)})})})}async $resolveTask(W,G){const L=this._handlers.get(W);if(!L)return Promise.reject(new Error("no handler found"));if(G.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${L.type}].`);const U=await h.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const x=await L.provider.resolveTask(U,T.CancellationToken.None);if(!!x){this.checkDeprecation(x,L);const Q=h.from(x,L.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(Q.execution)&&await this.addCustomExecution(Q,x,!0),await this.resolveTaskInternal(Q)}}nextHandle(){return this._handleCounter++}async addCustomExecution(W,G,L){const U=await this._proxy.$createTaskId(W);!L&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,G.execution)}async getTaskExecution(W,G){if(typeof W=="string"){const x=this._taskExecutionPromises.get(W);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let L=this._taskExecutionPromises.get(W.id);if(L)return L;const U=new Promise(async(x,Q)=>{const $=G||await h.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);$?x(new P(this,W.id,$)):Q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,U),U.then(x=>(this._taskExecutions.set(W.id,x),x),x=>Promise.reject(x))}checkDeprecation(W,G){W._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let L=this._notProvidedCustomExecutions.values(),U=L.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=L.next()}};z=je([Ke(0,b.IExtHostRpcService),Ke(1,m.IExtHostInitDataService),Ke(2,I.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,n.IExtHostConfiguration),Ke(5,k.IExtHostTerminalService),Ke(6,g.ILogService),Ke(7,w.IExtHostApiDeprecationService)],z),e.ExtHostTaskBase=z;let le=class extends z{constructor(W,G,L,U,x,Q,$,Z){super(W,G,L,U,x,Q,$,Z);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(W,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const L=h.from(G,W);if(L===void 0)throw new Error("Task is not valid");if(v.is(L.execution))await this.addCustomExecution(L,G,!1);else throw new c.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(L),G);return this._proxy.$executeTask(L).catch(x=>{throw new Error(x)}),U}provideTasksInternal(W,G,L,U){const x=[];if(U)for(let Q of U){this.checkDeprecation(Q,L),(!Q.definition||!W[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const $=h.from(Q,L.extension);$&&v.is($.execution)?(x.push($),G.push(this.addCustomExecution($,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:L.extension}}async resolveTaskInternal(W){if(v.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,G){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(W,G,L){}};le=je([Ke(0,b.IExtHostRpcService),Ke(1,m.IExtHostInitDataService),Ke(2,I.IExtHostWorkspace),Ke(3,y.IExtHostDocumentsAndEditors),Ke(4,n.IExtHostConfiguration),Ke(5,k.IExtHostTerminalService),Ke(6,g.ILogService),Ke(7,w.IExtHostApiDeprecationService)],le),e.WorkerExtHostTask=le,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var dn=this&&this.__rest||function(ae,e){var E={};for(var S in ae)Object.prototype.hasOwnProperty.call(ae,S)&&e.indexOf(S)<0&&(E[S]=ae[S]);if(ae!=null&&typeof Object.getOwnPropertySymbols=="function")for(var R=0,S=Object.getOwnPropertySymbols(ae);R<S.length;R++)e.indexOf(S[R])<0&&Object.prototype.propertyIsEnumerable.call(ae,S[R])&&(E[S[R]]=ae[S[R]]);return E};define(be[213],we([0,1,15,13,20,3,52,6,23,12,2,29,5,40,14,9,7,31,178,95]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d,_,g,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const c=(C,h)=>`${C}:${h.toString()}`;let s=class{constructor(h,p,P){this.documents=p,this.workspace=P,this.resultsChangedEmitter=new A.Emitter,this.providers=new Map,this.ownedTests=new w.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=h.getProxy(b.MainContext.MainThreadTesting),this.workspaceObservers=new f(this.proxy),this.textDocumentObservers=new v(this.proxy,p)}registerTestProvider(h){const p=(0,k.generateUuid)();this.providers.set(p,h),this.proxy.$registerTestProvider(p);const P=[...this.testSubscriptions.keys()];return setTimeout(()=>{var F;for(const z of P)(F=this.testSubscriptions.get(z))===null||F===void 0||F.subscribeFn(p,h)},0),new _.Disposable(()=>{this.providers.delete(p),this.proxy.$unregisterTestProvider(p)})}createTextDocumentTestObserver(h){return this.textDocumentObservers.checkout(h.uri)}createWorkspaceTestObserver(h){return this.workspaceObservers.checkout(h.uri)}async runTests(h,p=R.CancellationToken.None){const P=F=>F.map(this.getInternalTestForReference,this).filter(n.isDefined).map(z=>({src:z.src,testId:z.item.extId}));await this.proxy.$runTests({exclude:h.exclude?P(h.exclude).map(F=>F.testId):void 0,tests:P(h.tests),debug:h.debug},p)}publishExtensionProvidedResults(h,p){this.proxy.$publishExtensionProvidedResults(d.TestResults.from((0,k.generateUuid)(),h),p)}$publishTestResults(h){this.results=Object.freeze(h.map(p=>(0,y.deepFreeze)(d.TestResults.to(p))).concat(this.results).sort((p,P)=>P.completedAt-p.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(h,p){const P=T.URI.revive(p),F=c(h,P);if(!this.testSubscriptions.has(F)){const z=new R.CancellationTokenSource;let le;if(h===1){let L=this.documents.getDocument(P);if(!L){const U=new I.DisposableStore;L=await new Promise(x=>{U.add((0,S.disposableTimeout)(()=>x(void 0),5e3)),U.add(this.documents.onDidAddDocuments(Q=>{const $=Q.find(Z=>Z.document.uri.toString()===P.toString());$&&x($)}))}).finally(()=>U.dispose())}if(L){const U=await this.workspace.getWorkspaceFolder2(P,!1);le=x=>x.provideDocumentTestRoot?x.provideDocumentTestRoot(L.document,z.token):(0,e.createDefaultDocumentTestRoot)(x,L.document,U,z.token)}}else{const L=await this.workspace.getWorkspaceFolder2(P,!1);L&&(le=U=>U.provideWorkspaceTestRoot(L,z.token))}if(!!le){const H=async(L,U)=>{try{const x=await le(U);x&&G.addRoot(x,L)}catch(x){console.error(x)}},W=new I.DisposableStore,G=W.add(this.ownedTests.createForHierarchy(L=>this.proxy.$publishDiff(h,p,L)));W.add((0,I.toDisposable)(()=>z.dispose(!0)));for(const[L,U]of this.providers)H(L,U);G.pushDiff([3,-1]),this.testSubscriptions.set(F,{store:W,collection:G,subscribeFn:H})}}}async $expandTest(h,p){const P=(0,E.mapFind)(this.testSubscriptions.values(),F=>F.collection.treeId===h.src.tree?F:void 0);await(P==null?void 0:P.collection.expand(h.testId,p<0?Infinity:p)),this.flushCollectionDiffs()}$unsubscribeFromTests(h,p){var P;const F=T.URI.revive(p),z=c(h,F);(P=this.testSubscriptions.get(z))===null||P===void 0||P.store.dispose(),this.testSubscriptions.delete(z)}$acceptDiff(h,p,P){h===1?this.textDocumentObservers.acceptDiff(T.URI.revive(p),P):this.workspaceObservers.acceptDiff(T.URI.revive(p),P)}async $runTestsForProvider(h,p){const P=this.providers.get(h.tests[0].src.provider);if(!!P){const F=h.tests.map(({testId:le,src:H})=>this.ownedTests.getTestById(le,H.tree)).filter(n.isDefined).map(([le,H])=>H),z=h.excludeExtIds.map(le=>this.ownedTests.getTestById(le)).filter(n.isDefined).filter(([le,H])=>F.some(W=>le.comparePositions(W,H)===1));if(!!F.length)try{await P.runTests({setState:(le,H)=>{for(const[W,G]of z){const L=W.comparePositions(G,le.id);if(L===1||L===3)return}this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(h.runId,le.id,d.TestState.from(H))},tests:F.map(le=>i.unwrap(le.actual)),exclude:z.map(([,le])=>i.unwrap(le.actual)),debug:h.debug},p);for(const{collection:le}of this.testSubscriptions.values())le.flushDiff();return}catch(le){throw console.error(le),le}}}$lookupTest(h){const p=this.ownedTests.getTestById(h.testId);if(!p)return Promise.resolve(void 0);const P=p[1],{actual:F,discoverCts:z,expandLevels:le}=P,H=dn(P,["actual","discoverCts","expandLevels"]);return Promise.resolve(H)}flushCollectionDiffs(){for(const{collection:h}of this.testSubscriptions.values())h.flushDiff()}getInternalTestForReference(h){var p,P;return(P=(p=this.workspaceObservers.getMirroredTestDataByReference(h))!==null&&p!==void 0?p:(0,E.mapFind)(this.testSubscriptions.values(),F=>F.collection.getTestByReference(h)))!==null&&P!==void 0?P:this.textDocumentObservers.getMirroredTestDataByReference(h)}};s=je([Ke(0,r.IExtHostRpcService),Ke(1,m.IExtHostDocumentsAndEditors),Ke(2,g.IExtHostWorkspace)],s),e.ExtHostTesting=s;const t=async(C,h,p,P)=>{if(!!p){const F=await C.provideWorkspaceTestRoot(p,P);if(!!F)return P.onCancellationRequested(()=>{i.removeFilter(h)}),i.getWrapperForTestItem(F,h)}};e.createDefaultDocumentTestRoot=t;class i extends _.TestItem{constructor(h,p,P){super(h.id,h.label,h.expandable);if(this.actual=h,this.filterDocument=p,this.parent=P,!(h instanceof _.TestItem))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${h.id} did not`);h[_.TestItemHookProperty]={setProp:(F,z)=>{this[F]=z,F==="location"&&this.refreshMatch()},created:F=>i.getWrapperForTestItem(F,this.filterDocument,this).refreshMatch(),invalidate:()=>this.invalidate(),delete:F=>this.children.delete(F)}}static removeFilter(h){this.wrapperMap.delete(h)}static getWrapperForTestItem(h,p,P){let F=this.wrapperMap.get(p);if(F==null?void 0:F.has(h))return F.get(h);F||(F=new WeakMap,this.wrapperMap.set(p,F));const z=new i(h,p,P);return F.set(h,z),z}static unwrap(h){return h instanceof i?h.actual:h}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var h,p;const P=this._cachedMatchesFilter;for(const z of this.actual.children){const le=i.getWrapperForTestItem(z,this.filterDocument,this);le.hasNodeMatchingFilter?this.children.add(le):this.children.delete(le)}const F=this.children.size>0||((h=this.actual.location)===null||h===void 0?void 0:h.uri.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=F,F!==P&&((p=this.parent)===null||p===void 0||p.refreshMatch()),this._cachedMatchesFilter}}e.TestItemFilteredWrapper=i,i.wrapperMap=new WeakMap;class l extends u.IncrementalChangeCollector{constructor(h){super();this.emitter=h,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(h){this.added.add(h)}update(h){Object.assign(h.revived,d.TestItem.toPlain(h.item)),this.added.has(h)||this.updated.add(h)}remove(h){if(this.added.has(h)){this.added.delete(h);return}if(this.updated.delete(h),h.parent&&this.alreadyRemoved.has(h.parent)){this.alreadyRemoved.add(h.item.extId);return}this.removed.add(h)}getChangeEvent(){const{added:h,updated:p,removed:P}=this;return{get added(){return[...h].map(F=>F.revived)},get updated(){return[...p].map(F=>F.revived)},get removed(){return[...P].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class o extends u.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(h){let p=[];for(const P of h){const F=this.items.get(P);F&&p.push(F.revived)}return p}getMirroredTestDataById(h){return this.items.get(h)}getMirroredTestDataByReference(h){return this.items.get(h.id)}createItem(h,p){return Object.assign(Object.assign({},h),{revived:d.TestItem.toPlain(h.item),depth:p?p.depth+1:0,children:new Set})}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=o;class a{constructor(){this.resources=new Map}checkout(h){var p,P;const F=h.toString(),z=(p=this.resources.get(F))!==null&&p!==void 0?p:this.createObserverData(h);return(P=z.pendingDeletion)===null||P===void 0||P.dispose(),z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,onDidDiscoverInitialTests:new A.Emitter().event,get tests(){return z.tests.rootTestItems},dispose:(0,D.once)(()=>{--z.observers||(z.pendingDeletion=this.eventuallyDispose(h))})}}getMirroredTestDataByReference(h){for(const{tests:p}of this.resources.values()){const P=p.getMirroredTestDataByReference(h);if(P)return P}}eventuallyDispose(h){return(0,S.disposableTimeout)(()=>this.unlisten(h),10*1e3)}createObserverData(h){const p=new o,P=this.listen(h,z=>p.apply(z)),F={observers:0,tests:p,listener:P};return this.resources.set(h.toString(),F),F}unlisten(h){var p;const P=h.toString(),F=this.resources.get(P);F&&(F.observers=-1,(p=F.pendingDeletion)===null||p===void 0||p.dispose(),F.listener.dispose(),this.resources.delete(P))}}class f extends a{constructor(h){super();this.proxy=h,this.diffListeners=new Map}acceptDiff(h,p){var P;(P=this.diffListeners.get(h.toString()))===null||P===void 0||P(p)}listen(h,p){this.proxy.$subscribeToDiffs(0,h);const P=h.toString();return this.diffListeners.set(P,p),new _.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,h),this.diffListeners.delete(P)})}}class v extends a{constructor(h,p){super();this.proxy=h,this.documents=p,this.diffListeners=new Map}acceptDiff(h,p){var P;(P=this.diffListeners.get(h.toString()))===null||P===void 0||P(p)}listen(h,p){if(!this.documents.getDocument(h))return new _.Disposable(()=>{});const F=h.toString();return this.diffListeners.set(F,p),this.proxy.$subscribeToDiffs(1,h),new _.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,h),this.diffListeners.delete(F)})}}}),define(be[214],we([0,1,15,50,28,58,22,16,11,24,8,12,2,114,138,89,47,170,212,42]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d,_,g,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(C,h,p,P){this.configurationService=C,this.workspaceContextService=h,this.editorGroupsService=p,this.pathService=P}text(C,h,p={}){C=this.getContentPattern(C,p);const P=this.configurationService.getValue(),F=h&&h.some(le=>!this.configurationService.getValue({resource:le}).search.useRipgrep),z=this.commonQuery(h==null?void 0:h.map(_.toWorkspaceFolder),p);return Object.assign(Object.assign({},z),{type:2,contentPattern:C,previewOptions:p.previewOptions,maxFileSize:p.maxFileSize,usePCRE2:P.search.usePCRE2||F||!1,beforeContext:p.beforeContext,afterContext:p.afterContext,userDisabledExcludesAndIgnoreFiles:p.disregardExcludeSettings&&p.disregardIgnoreFiles})}getContentPattern(C,h){const p=this.configurationService.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const P=Object.assign(Object.assign({},C),{wordSeparators:p.editor.wordSeparators});return this.isCaseSensitive(C,h)&&(P.isCaseSensitive=!0),this.isMultiline(C)&&(P.isMultiline=!0),P}file(C,h={}){const p=this.commonQuery(C,h);return Object.assign(Object.assign({},p),{type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey})}handleIncludeExclude(C,h){return C?(C=Array.isArray(C)?C.map(o):o(C),h?this.parseSearchPaths(C):{pattern:t(...Array.isArray(C)?C:[C])}):{}}commonQuery(C=[],h={}){const p=this.handleIncludeExclude(h.includePattern,h.expandPatterns),P=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),F=C.length>1,z=(p.searchPaths&&p.searchPaths.length?p.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,h,P)):C.map(W=>this.getFolderQueryForRoot(W,h,P,F))).filter(W=>!!W),le={_reason:h._reason,folderQueries:z,usingSearchPaths:!!(p.searchPaths&&p.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:P.pattern,includePattern:p.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const G=E.coalesce(E.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(x=>x.resource)))).filter(U=>(0,u.pathIncludedInQuery)(le,U.fsPath)),L=this.commonQueryFromFileList(G);return Object.assign(Object.assign({},le),L)}const H=h.extraFileResources&&h.extraFileResources.filter(W=>(0,u.pathIncludedInQuery)(le,W.fsPath));return le.extraFileResources=H&&H.length?H:void 0,le}commonQueryFromFileList(C){const h=[],p=new D.ResourceMap,P={};let F=!1;return C.forEach(z=>{var le,H;if(z.scheme!==I.Schemas.walkThrough)if((0,n.isAbsolutePath)(z)){const G=(H=(le=this.workspaceContextService.getWorkspaceFolder(z))===null||le===void 0?void 0:le.uri)!==null&&H!==void 0?H:z.with({path:y.dirname(z.fsPath)});let L=p.get(G);L||(F=!0,L={folder:G,includePattern:{}},h.push(L),p.set(G,L));const U=y.relative(G.fsPath,z.fsPath);(0,k.assertIsDefined)(L.includePattern)[U.replace(/\\/g,"/")]=!0}else z.fsPath&&(F=!0,P[z.fsPath]=!0)}),{folderQueries:h,includePattern:P,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(C,h){if(h.isSmartCase){if(C.isRegExp){if(T.containsUppercaseCharacter(C.pattern,!0))return!0}else if(T.containsUppercaseCharacter(C.pattern))return!0}return!!C.isCaseSensitive}isMultiline(C){return C.isMultiline||C.isRegExp&&(0,m.isMultilineRegexSource)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const h=L=>y.isAbsolute(L)||/^\.\.?([\/\\]|$)/.test(L),P=(Array.isArray(C)?C:i(C)).map(L=>{const U=this.pathService.resolvedUserHome;return U?(0,A.untildify)(L,U.scheme===I.Schemas.file?U.fsPath:U.path):L}),F=S.groupBy(P,L=>h(L)?"searchPaths":"exprSegments"),z=(F.exprSegments||[]).map(L=>T.rtrim(L,"/")).map(L=>T.rtrim(L,"\\")).map(L=>(L[0]==="."&&(L="*"+L),l(L))),le={},H=this.expandSearchPathPatterns(F.searchPaths||[]);H&&H.length&&(le.searchPaths=H);const W=E.flatten(z),G=t(...W);return G&&(le.pattern=G),le}getExcludesForFolder(C,h){return h.disregardExcludeSettings?void 0:(0,u.getExcludes)(C,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(C){if(!C||!C.length)return[];const h=E.flatten(C.map(P=>{let{pathPortion:F,globPortion:z}=s(P);z&&(z=a(z));const le=this.expandOneSearchPath(F);return E.flatten(le.map(H=>this.resolveOneSearchPathPattern(H,z)))})),p=new Map;return h.forEach(P=>{const F=P.searchPath.toString(),z=p.get(F);z?P.pattern&&(z.pattern=z.pattern||{},z.pattern[P.pattern]=!0):p.set(F,{searchPath:P.searchPath,pattern:P.pattern?t(P.pattern):void 0})}),Array.from(p.values())}expandOneSearchPath(C){if(y.isAbsolute(C)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==I.Schemas.file?[{searchPath:h[0].uri.with({path:C})}]:[{searchPath:b.URI.file(y.normalize(C))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(C=o(C),C.startsWith("../")||C===".."){const P=y.posix.resolve(h.path,C);return[{searchPath:h.with({path:P})}]}const p=a(C);return[{searchPath:h,pattern:p}]}else{if(C==="./"||C===".\\")return[];{const h=C.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(h){const p=h[1],P=this.workspaceContextService.getWorkspace().folders.filter(F=>F.name===p);if(P.length)return P.map(F=>{const z=h[2];return{searchPath:F.uri,pattern:z&&a(z)}});{const F=r.localize(0,null,p);throw new Error(F)}}}}return[]}resolveOneSearchPathPattern(C,h){const p=C.pattern&&h?`${C.pattern}/${h}`:C.pattern||h,P=[{searchPath:C.searchPath,pattern:p}];return p&&!p.endsWith("**")&&P.push({searchPath:C.searchPath,pattern:p+"/**"}),P}getFolderQueryForSearchPath(C,h,p){const P=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(C.searchPath),h,p,!1);return P?Object.assign(Object.assign({},P),{includePattern:C.pattern}):null}getFolderQueryForRoot(C,h,p,P){let F;const z=b.URI.isUri(C)?C:C.uri;if(p.searchPaths){const L=p.searchPaths.filter(U=>(0,n.isEqual)(U.searchPath,z))[0];if(L&&!L.pattern)return null;L&&(F=L.pattern)}const le=this.configurationService.getValue({resource:z}),H=this.getExcludesForFolder(le,h),W=Object.assign(Object.assign({},H||{}),F||{}),G=b.URI.isUri(C)?(0,n.basename)(C):C.name;return{folder:z,folderName:P?G:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:le.files&&le.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!le.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!le.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!le.search.followSymlinks}}};c=je([Ke(0,d.IConfigurationService),Ke(1,_.IWorkspaceContextService),Ke(2,g.IEditorGroupsService),Ke(3,w.IPathService)],c),e.QueryBuilder=c;function s(v){const C=v.match(/[\*\{\}\(\)\[\]\?]/);if(C){const h=C.index,p=v.substr(0,h).match(/[/|\\][^/\\]*$/);if(p){let P=v.substr(0,p.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:v.substr((p.index||0)+1)}}}return{pathPortion:v}}function t(...v){return v.length?v.reduce((C,h)=>(C[h]=!0,C),Object.create(null)):void 0}function i(v){return R.splitGlobAware(v,",").map(C=>C.trim()).filter(C=>!!C.length)}function l(v){return[`**/${v}/**`,`**/${v}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function o(v){return v.replace(/\\/g,"/")}function a(v){return o(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(v,C){v=E.distinct(v,P=>P.toString());const h=[],p=C.getWorkspace();return v&&v.forEach(P=>{let F;if(C.getWorkbenchState()===2)F=(0,n.relativePath)(p.folders[0].uri,P),F&&F!=="."&&(F="./"+F);else{const z=C.getWorkspaceFolder(P);if(z){const le=z.name;if(p.folders.filter(W=>W.name===le).length===1){const W=(0,n.relativePath)(z.uri,P);W===""?F=`./${z.name}`:F=`./${z.name}/${W}`}else F=P.fsPath}}F&&h.push(F)}),h}e.resolveResourcesForSearchIncludes=f}),define(be[215],we([0,1,24,2,20,10,4,214,42,47]),function(ae,e,E,S,R,A,D,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const T=7e3;function k(d,_){const g=_.activationEvents;if(!g)return Promise.resolve(void 0);const w=[],u=[];for(const o of g)if(/^workspaceContains:/.test(o)){const a=o.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||d.forceUsingSearch?u.push(a):w.push(a)}if(w.length===0&&u.length===0)return Promise.resolve(void 0);let c;const s=new Promise((o,a)=>{c=o}),t=o=>c({activationEvent:o}),i=Promise.all(w.map(o=>b(d,o,t))).then(()=>{}),l=m(d,_.identifier,u,t);return Promise.all([i,l]).then(()=>{c(void 0)}),s}e.checkActivateWorkspaceContainsExtension=k;async function b(d,_,g){for(const w of d.folders)if(await d.exists(E.joinPath(S.URI.revive(w),_))){g(`workspaceContains:${_}`);return}}async function m(d,_,g,w){if(g.length===0)return Promise.resolve(void 0);const u=new R.CancellationTokenSource,c=d.checkExists(d.folders,g,u.token),s=setTimeout(async()=>{u.cancel(),w(`workspaceContainsTimeout:${g.join(",")}`)},T);let t=!1;try{t=await c}catch(i){A.isPromiseCanceledError(i)||A.onUnexpectedError(i)}u.dispose(),clearTimeout(s),t&&w(`workspaceContains:${g.join(",")}`)}function r(d,_,g,w){const u=d.get(D.IInstantiationService),c=d.get(y.ISearchService),t=u.createInstance(I.QueryBuilder).file(_.map(i=>(0,n.toWorkspaceFolder)(S.URI.revive(i))),{_reason:"checkExists",includePattern:g,exists:!0});return c.fileSearch(t,w).then(i=>!!i.limitHit,i=>A.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=r});var tt=this&&this.__classPrivateFieldSet||function(ae,e,E){if(!e.has(ae))throw new TypeError("attempted to set private field on non-instance");return e.set(ae,E),E},$e=this&&this.__classPrivateFieldGet||function(ae,e){if(!e.has(ae))throw new TypeError("attempted to get private field on non-instance");return e.get(ae)};define(be[36],we([0,1,130,11,77,24,13,6,22,2,19,5,35,181,75,31,34,179,10,25,16,26,158,7,90,4,27,76,14,65,67,41,3,215,71,159]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d,_,g,w,u,c,s,t,i,l,o,a,f,v,C,h,p,P,F,z,le){"use strict";var H,W,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let L=class An extends I.Disposable{constructor($,Z,ie,re,ye,Ie,Ue,Fe,ze,N){super();this._onDidChangeRemoteConnectionData=this._register(new P.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Z,this._extHostContext=ie,this._initData=Ue,this._extHostWorkspace=re,this._extHostConfiguration=ye,this._logService=Ie,this._extHostTunnelService=ze,this._extHostTerminalService=N,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._registry=new g.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new z.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=$.createChild(new C.ServiceCollection([r.IExtHostStorage,this._storage],[z.IExtHostSecretState,this._secretState]));const K=new Set;this._initData.hostExtensions.forEach(ee=>K.add(u.ExtensionIdentifier.toKey(ee))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ee,oe)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,oe)},actualActivateExtension:async(ee,oe)=>{if(K.has(u.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,oe),new m.HostExtension;const me=this._registry.getExtensionDescription(ee);return this._activateExtension(me,oe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),R.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch($){w.onUnexpectedError($)}}async deactivateAll(){let $=[];try{$=this._registry.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this._deactivate(ye))}catch(Z){}await Promise.all($)}isActivated($){return this._readyToRunExtensions.isOpen()?this._activator.isActivated($):!1}_activateByEvent($,Z){return this._activator.activateByEvent($,Z)}_activateById($,Z){return this._activator.activateById($,Z)}activateByIdWithErrors($,Z){return this._activateById($,Z).then(()=>{const ie=this._activator.getActivatedExtension($);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then($=>this._registry)}getExtensionExports($){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension($).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const $=y.TernarySearchTree.forPaths(),Z=this._registry.getAllExtensionDescriptions().map(ie=>{if(!!this._getEntryPoint(ie))return this._hostUtils.realpath(ie.extensionLocation.fsPath).then(re=>$.set(n.URI.file(re).fsPath,ie))});this._extensionPathIndex=Promise.all(Z).then(()=>$)}return this._extensionPathIndex}_deactivate($){let Z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated($))return Z;const ie=this._activator.getActivatedExtension($);if(!ie)return Z;try{typeof ie.module.deactivate=="function"&&(Z=Promise.resolve(ie.module.deactivate()).then(void 0,re=>Promise.resolve(void 0)))}catch(re){}try{(0,I.dispose)(ie.subscriptions)}catch(re){}return Z}async _activateExtension($,Z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension($.identifier),this._doActivateExtension($,Z).then(ie=>{const re=ie.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension($.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,Z),this._logExtensionActivationTimes($,Z,"success",re),ie},ie=>{throw this._logExtensionActivationTimes($,Z,"failure"),ie})}_logExtensionActivationTimes($,Z,ie,re){const ye=U($,Z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ye),re||{}),{outcome:ie}))}_doActivateExtension($,Z){const ie=U($,Z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ie);const re=this._getEntryPoint($);if(!re)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${$.identifier.value} ${JSON.stringify(Z)}`),this._logService.flush();const ye=new m.ExtensionActivationTimesBuilder(Z.startup);return Promise.all([this._loadCommonJSModule($.identifier,(0,A.joinPath)($.extensionLocation,re),ye),this._loadExtensionContext($)]).then(Ie=>(R.mark(`code/extHost/willActivateExtension/${$.identifier.value}`),An._callActivate(this._logService,$.identifier,Ie[0],Ie[1],ye))).then(Ie=>(R.mark(`code/extHost/didActivateExtension/${$.identifier.value}`),Ie))}_loadExtensionContext($){const Z=new t.ExtensionGlobalMemento($,this._storage),ie=new t.ExtensionMemento($.identifier.value,!1,this._storage),re=new le.ExtensionSecrets($,this._secretState),ye=$.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ie=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${$.identifier.value}`),Promise.all([Z.whenReady,ie.whenReady,this._storagePath.whenReady]).then(()=>{const Ue=this;let Fe;return Object.freeze({globalState:Z,workspaceState:ie,secrets:re,subscriptions:[],get extensionUri(){return $.extensionLocation},get extensionPath(){return $.extensionLocation.fsPath},asAbsolutePath(ze){return S.join($.extensionLocation.fsPath,ze)},get storagePath(){var ze;return(ze=Ue._storagePath.workspaceValue($))===null||ze===void 0?void 0:ze.fsPath},get globalStoragePath(){return Ue._storagePath.globalValue($).fsPath},get logPath(){return S.join(Ue._initData.logsLocation.fsPath,$.identifier.value)},get logUri(){return n.URI.joinPath(Ue._initData.logsLocation,$.identifier.value)},get storageUri(){return Ue._storagePath.workspaceValue($)},get globalStorageUri(){return Ue._storagePath.globalValue($)},get extensionMode(){return ye},get extension(){return Fe===void 0&&(Fe=new x(Ue,$.identifier,$,Ie)),Fe},get extensionRuntime(){return(0,_.checkProposedApiEnabled)($),Ue.extensionRuntime},get environmentVariableCollection(){return Ue._extHostTerminalService.getEnvironmentVariableCollection($)}})})}static _callActivate($,Z,ie,re,ye){return ie=ie||{activate:void 0,deactivate:void 0},this._callActivateOptional($,Z,ie,re,ye).then(Ie=>new m.ActivatedExtension(!1,null,ye.build(),ie,Ie,re.subscriptions))}static _callActivateOptional($,Z,ie,re,ye){if(typeof ie.activate=="function")try{ye.activateCallStart(),$.trace(`ExtensionService#_callActivateOptional ${Z.value}`);const Ie=typeof global=="object"?global:self,Ue=ie.activate.apply(Ie,[re]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(Ue).then(Fe=>(ye.activateResolveStop(),Fe))}catch(Ie){return Promise.reject(Ie)}else return Promise.resolve(ie)}_activateOneStartupFinished($,Z){this._activateById($.identifier,{startup:!1,extensionId:$.identifier,activationEvent:Z}).then(void 0,ie=>{this._logService.error(ie)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(R.getMarks());for(const $ of this._registry.getAllExtensionDescriptions())if($.activationEvents)for(const Z of $.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished($,Z)}_handleEagerExtensions(){const $=this._activateByEvent("*",!0).then(void 0,ye=>{this._logService.error(ye)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ye=>this._handleWorkspaceContainsEagerExtensions(ye.added)));const Z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ie=this._handleWorkspaceContainsEagerExtensions(Z),re=Promise.all([$,ie]).then(()=>{});return Promise.race([re,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),re}_handleWorkspaceContainsEagerExtensions($){return $.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Z=>this._handleWorkspaceContainsEagerExtension($,Z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension($,Z){if(!this.isActivated(Z.identifier)){const ie=!this._initData.remote.isRemote&&!!this._initData.remote.authority,re={folders:$.map(Ie=>Ie.uri),forceUsingSearch:ie,exists:Ie=>this._hostUtils.exists(Ie.fsPath),checkExists:(Ie,Ue,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(Ie,Ue,Fe)},ye=await(0,F.checkActivateWorkspaceContainsExtension)(re,Z);if(!!ye)return this._activateById(Z.identifier,{startup:!0,extensionId:Z.identifier,activationEvent:ye.activationEvent}).then(void 0,Ie=>this._logService.error(Ie))}}async $extensionTestsExecute(){await this._readyToRunExtensions.wait();try{return this._doHandleExtensionTests()}catch($){throw console.error($),$}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:$,extensionTestsLocationURI:Z}=this._initData.environment;if(!$||!Z||Z.scheme!==c.Schemas.file)throw new Error(E.localize(0,null));const ie=(0,A.originalFSPath)(Z),re=await this._loadCommonJSModule(null,Z,new m.ExtensionActivationTimesBuilder(!1));if(!re||typeof re.run!="function")throw new Error(E.localize(1,null,ie));return new Promise((ye,Ie)=>{const Ue=(ze,N)=>{ze?Ie(ze):ye(typeof N=="number"&&N>0?1:0)},Fe=re.run(ie,Ue);Fe&&Fe.then&&Fe.then(()=>{ye(0)}).catch(ze=>{Ie(ze.toString())})})}async $extensionTestsExit($){this._logService.info(`extension host terminating: test runner requested exit with code ${$}`),this._logService.info(`exiting with code ${$}`),this._logService.flush(),this._hostUtils.exit($)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver($,Z){return this._resolvers[$]=Z,(0,I.toDisposable)(()=>{delete this._resolvers[$]})}async $resolveAuthority($,Z){const ie=$.indexOf("+");if(ie===-1)throw new Error("Not an authority that can be resolved!");const re=$.substr(0,ie);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${re}`,!1);const ye=this._resolvers[re];if(!ye)return{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${re}.`,detail:void 0}};try{R.mark(`code/extHost/willResolveAuthority/${re}`);const Ie=await ye.resolve($,{resolveAttempt:Z});R.mark(`code/extHost/didResolveAuthorityOK/${re}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ye));const Ue={authority:$,host:Ie.host,port:Ie.port,connectionToken:Ie.connectionToken},Fe={extensionHostEnv:Ie.extensionHostEnv};return{type:"ok",value:{authority:Ue,options:Fe,tunnelInformation:{environmentTunnels:Ie.environmentTunnels}}}}catch(Ie){if(R.mark(`code/extHost/didResolveAuthorityError/${re}`),Ie instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:Ie._code,message:Ie._message,detail:Ie._detail}};throw Ie}}$startExtensionHost($){return this._registry.keepOnly($),this._startExtensionHost()}$activateByEvent($,Z){return Z===1?this._activateByEvent($,!1):this._readyToRunExtensions.wait().then(ie=>this._activateByEvent($,!1))}async $activate($,Z){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription($)?(await this._activateById($,Z),!0):!1}async $deltaExtensions($,Z){$.forEach(re=>re.extensionLocation=n.URI.revive(re.extensionLocation));const ie=await this.getExtensionPathIndex();return await Promise.all(Z.map(async re=>{const ye=this._registry.getExtensionDescription(re);if(!!ye){const Ie=await this._hostUtils.realpath(ye.extensionLocation.fsPath);ie.delete(n.URI.file(Ie).fsPath)}})),await Promise.all($.map(async re=>{const ye=await this._hostUtils.realpath(re.extensionLocation.fsPath);ie.set(n.URI.file(ye).fsPath,re)})),this._registry.deltaExtensions($,Z),Promise.resolve(void 0)}async $test_latency($){return $}async $test_up($){return $.byteLength}async $test_down($){let Z=s.VSBuffer.alloc($),ie=Math.random()%256;for(let re=0;re<$;re++)Z.writeUInt8(ie,re);return Z}async $updateRemoteConnectionData($){this._remoteConnectionData=$,this._onDidChangeRemoteConnectionData.fire()}};L=je([Ke(0,o.IInstantiationService),Ke(1,e.IHostUtils),Ke(2,v.IExtHostRpcService),Ke(3,d.IExtHostWorkspace),Ke(4,b.IExtHostConfiguration),Ke(5,T.ILogService),Ke(6,a.IExtHostInitDataService),Ke(7,f.IExtensionStoragePaths),Ke(8,h.IExtHostTunnelService),Ke(9,p.IExtHostTerminalService)],L),e.AbstractExtHostExtensionService=L;function U(Q,$){return{id:Q.identifier.value,name:Q.name,extensionVersion:Q.version,publisherDisplayName:Q.publisher,activationEvents:Q.activationEvents?Q.activationEvents.join(","):null,isBuiltin:Q.isBuiltin,reason:$.activationEvent,reasonId:$.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class x{constructor($,Z,ie,re){H.set(this,void 0),W.set(this,void 0),G.set(this,void 0),tt(this,H,$),tt(this,W,Z),tt(this,G,ie.identifier),this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=S.normalize((0,A.originalFSPath)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=re}get isActive(){return $e(this,H).isActivated($e(this,G))}get exports(){if(this.packageJSON.api!=="none")return $e(this,H).getExtensionExports($e(this,G))}activate(){return $e(this,H).activateByIdWithErrors($e(this,G),{startup:!1,extensionId:$e(this,W),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,H=new WeakMap,W=new WeakMap,G=new WeakMap}),define(be[102],we([0,1,11,2,3,13,5,7,165,31,36,40,169,35,166,14,4,12,32]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d,_,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let u=class{constructor(f,v,C,h,p){this._workspaceService=v,this._extensionService=C,this._editorsService=h,this._configurationService=p,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new R.Emitter,this._onDidTerminateDebugSession=new R.Emitter,this._onDidChangeActiveDebugSession=new R.Emitter,this._onDidReceiveDebugSessionCustomEvent=new R.Emitter,this._debugServiceProxy=f.getProxy(D.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new R.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new s(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(P=>{P.onDidChange(F=>{this.registerAllDebugTypes(P)}),this.registerAllDebugTypes(P)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,v){const C=f;if(typeof C.sourceReference=="number"&&C.sourceReference>0){let h=`debug:${encodeURIComponent(C.path||"")}`,p="?";return v&&(h+=`${p}session=${encodeURIComponent(v.id)}`,p="&"),h+=`${p}ref=${C.sourceReference}`,S.URI.parse(h)}else{if(C.path)return S.URI.file(C.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const v=[];for(const C of f.getAllExtensionDescriptions())if(C.contributes){const h=C.contributes.debuggers;if(h&&h.length>0)for(const p of h)(0,r.isDebuggerMainContribution)(p)&&v.push(p.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(v=>f.push(v)),f}addBreakpoints(f){this.startBreakpoints();const v=f.filter(p=>{const P=p.id;return this._breakpoints.has(P)?!1:(this._breakpoints.set(P,p),!0)});this.fireBreakpointChanges(v,[],[]);const C=[],h=new Map;for(const p of v)if(p instanceof I.SourceBreakpoint){let P=h.get(p.location.uri.toString());P||(P={type:"sourceMulti",uri:p.location.uri,lines:[]},h.set(p.location.uri.toString(),P),C.push(P)),P.lines.push({id:p.id,enabled:p.enabled,condition:p.condition,hitCondition:p.hitCondition,logMessage:p.logMessage,line:p.location.range.start.line,character:p.location.range.start.character})}else p instanceof I.FunctionBreakpoint&&C.push({type:"function",id:p.id,enabled:p.enabled,hitCondition:p.hitCondition,logMessage:p.logMessage,condition:p.condition,functionName:p.functionName});return this._debugServiceProxy.$registerBreakpoints(C)}removeBreakpoints(f){this.startBreakpoints();const v=f.filter(P=>this._breakpoints.delete(P.id));this.fireBreakpointChanges([],v,[]);const C=v.filter(P=>P instanceof I.SourceBreakpoint).map(P=>P.id),h=v.filter(P=>P instanceof I.FunctionBreakpoint).map(P=>P.id),p=v.filter(P=>P instanceof I.DataBreakpoint).map(P=>P.id);return this._debugServiceProxy.$unregisterBreakpoints(C,h,p)}startDebugging(f,v,C){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,v,{parentSessionID:C.parentSession?C.parentSession.id:void 0,repl:C.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:C.noDebug,compact:C.compact})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,v,C){if(!v)return new I.Disposable(()=>{});const h=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:h,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,C,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,h),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(p=>p.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(h)})}registerDebugAdapterDescriptorFactory(f,v,C){if(!C)return new I.Disposable(()=>{});if(!this.definesDebugType(f,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const h=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:h,factory:C}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,h),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(p=>p.factory!==C),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(h)})}registerDebugAdapterTrackerFactory(f,v){if(!v)return new I.Disposable(()=>{});const C=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:C,factory:v}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(h=>h.factory!==v)})}async $runInTerminal(f,v){return Promise.resolve(void 0)}async $substituteVariables(f,v){if(!this._variableResolver){const[p,P]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(p||[],this._editorsService,P)}let C;const h=await this.getFolder(f);return h&&(C={uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(C,v)}createDebugAdapter(f,v){if(f.type==="implementation")return new l(f.implementation)}createSignService(){}async $startDASession(f,v){const C=this,h=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(h.type),h).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}' (extension might have failed to activate)`);const P=this.convertToDto(p),F=this.createDebugAdapter(P,h);if(!F)throw new Error(`Couldn't create a debug adapter for type '${h.type}'.`);const z=F;return this._debugAdapters.set(f,z),this.getDebugAdapterTrackers(h).then(le=>(le&&this._debugAdaptersTrackers.set(f,le),z.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const W=H,G={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(W.arguments.value);G.body={signature:L},z.sendResponse(G)}else throw new Error("no signer")}catch(L){G.success=!1,G.message=L.message,z.sendResponse(G)}}else le&&le.onDidSendMessage&&le.onDidSendMessage(H),H=(0,r.convertToVSCPaths)(H,!0),C._debugServiceProxy.$acceptDAMessage(f,H)}),z.onError(H=>{le&&le.onError&&le.onError(H),this._debugServiceProxy.$acceptDAError(f,H.name,H.message,H.stack)}),z.onExit(H=>{le&&le.onExit&&le.onExit((0,g.withNullAsUndefined)(H),void 0),this._debugServiceProxy.$acceptDAExit(f,(0,g.withNullAsUndefined)(H),void 0)}),le&&le.onWillStartSession&&le.onWillStartSession(),z.startSession()))})}$sendDAMessage(f,v){v=(0,r.convertToDAPaths)(v,!1);const C=this._debugAdaptersTrackers.get(f);C&&C.onWillReceiveMessage&&C.onWillReceiveMessage(v);const h=this._debugAdapters.get(f);h&&h.sendMessage(v)}$stopDASession(f){const v=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),v&&v.onWillStopSession&&v.onWillStopSession();const C=this._debugAdapters.get(f);return this._debugAdapters.delete(f),C?C.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const v=[],C=[],h=[];if(f.added)for(const p of f.added){const P=p.id;if(P&&!this._breakpoints.has(P)){let F;if(p.type==="function")F=new I.FunctionBreakpoint(p.functionName,p.enabled,p.condition,p.hitCondition,p.logMessage);else if(p.type==="data")F=new I.DataBreakpoint(p.label,p.dataId,p.canPersist,p.enabled,p.hitCondition,p.condition,p.logMessage);else{const z=S.URI.revive(p.uri);F=new I.SourceBreakpoint(new I.Location(z,new I.Position(p.line,p.character)),p.enabled,p.condition,p.hitCondition,p.logMessage)}F._id=P,this._breakpoints.set(P,F),v.push(F)}}if(f.removed)for(const p of f.removed){const P=this._breakpoints.get(p);P&&(this._breakpoints.delete(p),C.push(P))}if(f.changed){for(const p of f.changed)if(p.id){const P=this._breakpoints.get(p.id);if(P){if(P instanceof I.FunctionBreakpoint&&p.type==="function"){const F=P;F.enabled=p.enabled,F.condition=p.condition,F.hitCondition=p.hitCondition,F.logMessage=p.logMessage,F.functionName=p.functionName}else if(P instanceof I.SourceBreakpoint&&p.type==="source"){const F=P;F.enabled=p.enabled,F.condition=p.condition,F.hitCondition=p.hitCondition,F.logMessage=p.logMessage,F.location=new I.Location(S.URI.revive(p.uri),new I.Position(p.line,p.character))}h.push(P)}}}this.fireBreakpointChanges(v,C,h)}$provideDebugConfigurations(f,v,C){return(0,A.asPromise)(async()=>{const h=this.getConfigProviderByHandle(f);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const p=await this.getFolder(v);return h.provideDebugConfigurations(p,C)}).then(h=>{if(!h)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return h})}$resolveDebugConfiguration(f,v,C,h){return(0,A.asPromise)(async()=>{const p=this.getConfigProviderByHandle(f);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.getFolder(v);return p.resolveDebugConfiguration(P,C,h)})}$resolveDebugConfigurationWithSubstitutedVariables(f,v,C,h){return(0,A.asPromise)(async()=>{const p=this.getConfigProviderByHandle(f);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.getFolder(v);return p.resolveDebugConfigurationWithSubstitutedVariables(P,C,h)})}async $provideDebugAdapter(f,v){const C=this.getAdapterDescriptorFactoryByHandle(f);if(!C)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const h=await this.getSession(v);return this.getAdapterDescriptor(C,h).then(p=>{if(!p)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}'`);return this.convertToDto(p)})}async $acceptDebugSessionStarted(f){const v=await this.getSession(f);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(f){const v=await this.getSession(f);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,v){const C=await this.getSession(f);C&&C._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(f,v){const h={session:await this.getSession(f),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(h)}convertToDto(f){if(f instanceof I.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof I.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const v=this._adapterFactories.filter(C=>C.type===f);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(f){const v=this._adapterFactories.filter(C=>C.handle===f);if(v.length>0)return v[0].factory}getConfigProviderByHandle(f){const v=this._configProviders.filter(C=>C.handle===f);if(v.length>0)return v[0].provider}definesDebugType(f,v){if(f.contributes){const C=f.contributes.debuggers;if(C&&C.length>0){for(const h of C)if(h.label&&h.type&&h.type===v)return!0}}return!1}getDebugAdapterTrackers(f){const C=f.configuration.type,h=this._trackerFactories.filter(p=>p.type===C||p.type==="*").map(p=>(0,A.asPromise)(()=>p.factory.createDebugAdapterTracker(f)).then(P=>P,P=>null));return Promise.race([Promise.all(h).then(p=>{const P=p.filter(F=>!!F);if(P.length>0)return new i(P)}),new Promise((p,P)=>{const F=setTimeout(()=>{clearTimeout(F),P(new Error("timeout"))},1e3)})]).catch(p=>{})}async getAdapterDescriptor(f,v){const C=v.configuration.debugServer;if(typeof C=="number")return Promise.resolve(new I.DebugAdapterServer(C));if(f){const p=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>f.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,p))).then(P=>{if(P)return P})}const h=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,h))}daExecutableFromPackage(f,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,v,C){(f.length>0||v.length>0||C.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:v,changed:C}))}async getSession(f){if(f)if(typeof f=="string"){const v=this._debugSessions.get(f);if(v)return v}else{let v=this._debugSessions.get(f.id);if(!v){const C=await this.getFolder(f.folderUri);v=new c(this._debugServiceProxy,f.id,f.type,f.name,C,f.configuration),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(f){if(f){const v=S.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};u=je([Ke(0,d.IExtHostRpcService),Ke(1,n.IExtHostWorkspace),Ke(2,T.IExtHostExtensionService),Ke(3,k.IExtHostDocumentsAndEditors),Ke(4,m.IExtHostConfiguration)],u),e.ExtHostDebugServiceBase=u;class c{constructor(f,v,C,h,p,P){this._debugServiceProxy=f,this._id=v,this._type=C,this._name=h,this._workspaceFolder=p,this._configuration=P}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,v)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=c;class s{constructor(f){this.value=Object.freeze({append(v){f.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=s;class t extends b.AbstractVariableResolverService{constructor(f,v,C,h){super({getFolderUri:p=>{const P=f.filter(F=>F.name===p);if(P&&P.length>0)return P[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(p,P)=>C.getConfiguration(void 0,p).get(P),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(v){const p=v.activeEditor();if(p)return E.normalize(p.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(v&&h){const p=v.activeEditor();if(p){const P=h.getWorkspaceFolder(p.document.uri);if(P)return E.normalize(P.uri.fsPath)}}},getSelectedText:()=>{if(v){const p=v.activeEditor();if(p&&!p.selection.isEmpty)return p.document.getText(p.selection)}},getLineNumber:()=>{if(v){const p=v.activeEditor();if(p)return String(p.selection.end.line+1)}}},void 0,w.env)}}e.ExtHostVariableResolverService=t;class i{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(v=>v.onError?v.onError(f):void 0)}onExit(f,v){this.trackers.forEach(C=>C.onExit?C.onExit(f,v):void 0)}}class l extends y.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends u{constructor(f,v,C,h,p){super(f,v,C,h,p)}createVariableResolver(f,v,C){return new t(f,v,C)}};o=je([Ke(0,d.IExtHostRpcService),Ke(1,n.IExtHostWorkspace),Ke(2,T.IExtHostExtensionService),Ke(3,k.IExtHostDocumentsAndEditors),Ke(4,m.IExtHostConfiguration)],o),e.WorkerExtHostDebugService=o}),define(be[216],we([0,1,77,2,5,35,34,25,14,27,4,36,32,19]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(u,c,s,t,i,l,o){this._apiFactory=u,this._extensionRegistry=c,this._instaService=s,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=l,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),E.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,c,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(g,c,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let c of u.nodeModuleName)this._factories.set(c,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(c=>u.alternativeModuleName(c))}};r=je([Ke(2,T.IInstantiationService),Ke(3,A.IExtHostConfiguration),Ke(4,k.IExtHostExtensionService),Ke(5,n.IExtHostInitDataService),Ke(6,m.ILogService)],r),e.RequireInterceptor=r;class d{constructor(u,c,s,t,i){this._apiFactory=u,this._extensionPaths=c,this._extensionRegistry=s,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,c){const s=this._extensionPaths.findSubstr(c.fsPath);if(s){let t=this._extApiImpl.get(I.ExtensionIdentifier.toKey(s.identifier));return t||(t=this._apiFactory(s,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(s.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,l)=>t+=`	${l} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(u,c){this.nodeModuleName="keytar";const{environment:s}=c,t=u.getProxy(R.MainContext.MainThreadKeytar);if(s.appRoot){let i=s.appRoot.fsPath;b.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,l)=>t.$getPassword(i,l),setPassword:(i,l,o)=>t.$setPassword(i,l,o),deletePassword:(i,l)=>t.$deletePassword(i,l),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(u,c){return this._impl}alternativeModuleName(u){const c=u.length;if(!(c<=7||!this.alternativeNames)){const s=c-7;if((u.charAt(s)==="/"||u.charAt(s)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}}};_=je([Ke(0,y.IExtHostRpcService),Ke(1,n.IExtHostInitDataService)],_);let g=class{constructor(u,c,s){this._extensionPaths=u,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=s.getProxy(R.MainContext.MainThreadTelemetry);const t=s.getProxy(R.MainContext.MainThreadWindow);this._impl=(i,l)=>{const o=S.URI.parse(i);return l?this.callOriginal(i,l):o.scheme==="http"||o.scheme==="https"?t.$openUri(o,i,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?t.$openUri(o,i,{}):this.callOriginal(i,l)}}load(u,c,s){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=s(u),this._impl}callOriginal(u,c){return this.sendNoForwardTelemetry(),this._original(u,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};g=je([Ke(2,y.IExtHostRpcService)],g)}),define(be[217],we([0,1,13,10,77,6,2,5,209,19,61,65,27,148,14,68,36,41]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(c,s,t,i){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const l=new y.RPCProtocol(c,null,i);s=w._transform(s,l);const o=new k.ServiceCollection(...(0,T.getSingletonServiceDescriptors)());o.set(b.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},s)),o.set(r.IExtHostRpcService,new r.ExtHostRpcService(l)),o.set(d.IURITransformerService,new d.URITransformerService(i)),o.set(_.IHostUtils,t);const a=new m.InstantiationService(o,!0),f=a.invokeFunction(p=>p.get(g.IExtHostTerminalService));this._disposables.add(f),this._logService=a.invokeFunction(p=>p.get(n.ILogService)),R.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",s),this._extensionService=a.invokeFunction(p=>p.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(p=>{Error.prepareStackTrace=(P,F)=>{let z="",le,H;for(const W of F)z+=`
	at ${W.toString()}`,H=W.getFileName(),!le&&H&&(le=p.findSubstr(H));return v.set(P,le),`${P.name||"Error"}: ${P.message||""}${z}`}});const C=l.getProxy(I.MainContext.MainThreadExtensionService),h=l.getProxy(I.MainContext.MainThreadErrors);S.setUnexpectedErrorHandler(p=>{const P=S.transformErrorForSerialization(p),F=v.get(p);F?C.$onExtensionRuntimeError(F.identifier,P):h.$onUnexpectedError(P)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),S.setUnexpectedErrorHandler(t=>{});const s=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,E.timeout)(4e3),s]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,s){c.extensions.forEach(i=>i.extensionLocation=D.URI.revive(s.transformIncomingURIs(i.extensionLocation))),c.environment.appRoot=D.URI.revive(s.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(i=>D.URI.revive(s.transformIncomingURIs(i)))),c.environment.extensionTestsLocationURI=D.URI.revive(s.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=D.URI.revive(s.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=D.URI.revive(s.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=D.URI.revive(s.transformIncomingURIs(c.logsLocation)),c.logFile=D.URI.revive(s.transformIncomingURIs(c.logFile)),c.workspace=s.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=w}),define(be[218],we([0,1,11,20,60,28,24,55,42,32]),function(ae,e,E,S,R,A,D,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(m,r,d){this.config=m,this.provider=r,this.sessionToken=d,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&A.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&A.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const r=this.config.folderQueries||[];return new Promise((d,_)=>{const g=w=>{this.resultCount++,m(w)};if(this.isCanceled)return d({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const u=w.toString(),c=E.basename(u);this.globalExcludePattern&&this.globalExcludePattern(u,c)||this.matchFile(g,{base:w,basename:c})}),Promise.all(r.map(w=>this.searchInFolder(w,g))).then(w=>{d({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{_(new Error((0,R.toErrorMessage)(w)))})})}searchInFolder(m,r){const d=new S.CancellationTokenSource;return new Promise((_,g)=>{const w=this.getSearchOptionsForFolder(m),u=this.initDirectoryTree(),c=new y.QueryGlobTester(this.config,m),s=!c.hasSiblingExcludeClauses();let t;new Promise(i=>(0,n.nextTick)(i)).then(()=>(this.activeCancellationTokens.add(d),t=I.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,d.token))).then(i=>{const l=t.elapsed(),o=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(i&&i.forEach(a=>{const f=E.posix.relative(m.folder.path,a.path);if(s){const v=E.basename(a.path);this.matchFile(r,{base:m.folder,relativePath:f,basename:v});return}this.addDirectoryEntries(u,m.folder,f,r)}),this.activeCancellationTokens.delete(d),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(u,c,r),{providerTime:l,postProcessTime:o.elapsed()})}).then(i=>{d.dispose(),_(i)},i=>{d.dispose(),g(i)})})}getSearchOptionsForFolder(m){const r=(0,y.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),d=(0,y.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:d,includes:r,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},r,d,_){if(d===this.filePattern){const w=E.basename(this.filePattern);this.matchFile(_,{base:r,relativePath:this.filePattern,basename:w})}function g(w){const u=E.basename(w),c=E.dirname(w);let s=m[c];s||(s=m[c]=[],g(c)),s.push({base:r,relativePath:w,basename:u})}g(d)}matchDirectoryTree({rootEntries:m,pathToEntries:r},d,_){const g=this,w=this.filePattern;function u(c){const s=A.hasSiblingFn(()=>c.map(t=>t.basename));for(let t=0,i=c.length;t<i;t++){const l=c[t],{relativePath:o,basename:a}=l;if(!!d.includedInQuerySync(o,a,w!==a?s:void 0)){const f=r[o];if(f)u(f);else{if(o===w)continue;g.matchFile(_,l)}if(g.isLimitHit)break}}}u(m)}matchFile(m,r){(!this.includePattern||r.relativePath&&this.includePattern(r.relativePath,r.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(r))}}class k{constructor(){this.sessions=new Map}fileSearch(m,r,d,_){const g=this.getSessionTokenSource(m.cacheKey),w=new T(m,r,g&&g.token);let u=0;const c=s=>{u+=s.length,d(s.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(w,k.BATCH_SIZE,c,_).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:u,detailStats:s.stats}}))}clearCache(m){const r=this.getSessionTokenSource(m);r&&r.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new S.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:D.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,r,d,_){_.onCancellationRequested(()=>{m.cancel()});const g=u=>{u&&(w.push(u),r>0&&w.length>=r&&(d(w),w=[]))};let w=[];return m.search(g).then(u=>(w.length&&d(w),u),u=>(w.length&&d(w),Promise.reject(u)))}}e.FileSearchManager=k,k.BATCH_SIZE=512}),define(be[219],we([0,1,11,15,20,60,24,28,2,42,32,16]),function(ae,e,E,S,R,A,D,I,y,n,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(u,c,s){this.query=u,this.provider=c,this.fileUtils=s,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,c){const s=this.query.folderQueries||[],t=new R.CancellationTokenSource;return c.onCancellationRequested(()=>t.cancel()),new Promise((i,l)=>{this.collector=new r(u);let o=!1;const a=(f,v)=>{if(!o&&!this.isLimitHit){const C=this.resultSize(f);_(f)&&typeof this.query.maxResults=="number"&&this.resultCount+C>this.query.maxResults&&(this.isLimitHit=!0,o=!0,t.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const h=this.resultSize(f);this.resultCount+=h,(h>0||!_(f))&&this.collector.add(f,v)}};Promise.all(s.map((f,v)=>this.searchInFolder(f,C=>a(C,v),t.token))).then(f=>{t.dispose(),this.collector.flush();const v=f.some(C=>!!C&&!!C.limitHit);i({limitHit:this.isLimitHit||v,stats:{type:"textSearchProvider"}})},f=>{t.dispose();const v=(0,A.toErrorMessage)(f);l(new Error(v))})})}resultSize(u){return _(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,c){const s=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:s.slice(0,c),preview:{matches:t.slice(0,c),text:u.preview.text},uri:u.uri}}searchInFolder(u,c,s){const t=new n.QueryGlobTester(this.query,u),i=[],l={report:a=>{if(!!this.validateProviderResult(a)){const f=u.folder.scheme===k.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(a.uri))):void 0,v=D.relativePath(u.folder,a.uri);v&&i.push(t.includedInQuery(v,E.basename(v),f).then(C=>{C&&c(a)}))}}},o=this.getSearchOptionsForFolder(u);return new Promise(a=>(0,T.nextTick)(a)).then(()=>this.provider.provideTextSearchResults(m(this.query.contentPattern),o,l,s)).then(a=>Promise.all(i).then(()=>a))}validateProviderResult(u){if(_(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const c=(0,n.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),s=(0,n.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),t={folder:y.URI.from(u.folder),excludes:s,includes:c,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=b;function m(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class r{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new g(512,c=>this.sendItems(c))}add(u,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!D.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(d(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=r;function d(w){return _(w)?{preview:{matches:(0,S.mapArrayOrNot)(w.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:w.preview.text},ranges:(0,S.mapArrayOrNot)(w.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function _(w){return!!w.preview}e.extensionResultIsMatch=_;class g{constructor(u,c){this.maxBatchSize=u,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,c){!u||this.addItemToBatch(u,c)}addItems(u,c){!u||this.addItemsToBatch(u,c)}addItemToBatch(u,c){this.batch.push(u),this.batchSize+=c,this.onUpdate()}addItemsToBatch(u,c){this.batch=this.batch.concat(u),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<g.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},g.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=g,g.TIMEOUT=4e3,g.START_BATCH_AFTER_COUNT=50}),define(be[103],we([0,1,6,5,4,218,14,68,19,2,219]),function(ae,e,E,S,R,A,D,I,y,n,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,R.createDecorator)("IExtHostSearch");let k=class{constructor(d,_,g){this.extHostRpc=d,this._uriTransformer=_,this._logService=g,this._proxy=this.extHostRpc.getProxy(S.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,_){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const g=this._handlePool++;return this._textSearchProvider.set(g,_),this._proxy.$registerTextSearchProvider(g,this._transformScheme(d)),(0,E.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}registerFileSearchProvider(d,_){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const g=this._handlePool++;return this._fileSearchProvider.set(g,_),this._proxy.$registerFileSearchProvider(g,this._transformScheme(d)),(0,E.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(g),this._proxy.$unregisterProvider(g)})}$provideFileSearchResults(d,_,g,w){const u=b(g),c=this._fileSearchProvider.get(d);if(c)return this._fileSearchManager.fileSearch(u,c,s=>{this._proxy.$handleFileMatch(d,_,s.map(t=>t.resource))},w);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,_,g,w){const u=this._textSearchProvider.get(d);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const c=b(g);return this.createTextSearchManager(c,u).search(t=>this._proxy.$handleTextMatch(d,_,t),w)}createTextSearchManager(d,_){return new T.TextSearchManager(d,_,{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g})}};k=je([Ke(0,D.IExtHostRpcService),Ke(1,I.IURITransformerService),Ke(2,y.ILogService)],k),e.ExtHostSearch=k;function b(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(m),extraFileResources:r.extraFileResources&&r.extraFileResources.map(d=>n.URI.revive(d))})}e.reviveQuery=b;function m(r){return Object.assign(Object.assign({},r),{folder:n.URI.revive(r.folder)})}}),define(be[220],we([0,1,127,20,10,3,46,2,121,82,115,59,64,5,186,185,73,187,35,188,189,190,172,191,40,36,192,173,194,195,196,99,176,198,199,200,75,41,201,177,9,7,204,49,100,31,34,50,162,193,91,98,101,102,103,19,68,14,27,197,161,67,72,183,202,160,76,74,207,205,206,184,48,213,203,71,157,93]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d,_,g,w,u,c,s,t,i,l,o,a,f,v,C,h,p,P,F,z,le,H,W,G,L,U,x,Q,$,Z,ie,re,ye,Ie,Ue,Fe,ze,N,K,ee,oe,me,Se,Me,ge,Ce,Pe,xe,_e,qe,V,Y,ve,Le,Be,Oe,et,B,te,he,q,J,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function fe(pe){const We=pe.get(Me.IExtHostInitDataService),Ne=pe.get(B.IExtHostFileSystemInfo),Ve=pe.get(ve.IExtHostConsumerFileSystem),Je=pe.get(o.IExtHostExtensionService),Ze=pe.get(ie.IExtHostWorkspace),ct=pe.get(se.IExtHostTelemetry),ot=pe.get(w.IExtHostConfiguration),nt=pe.get(me.IURITransformerService),ue=pe.get(Se.IExtHostRpcService),De=pe.get(H.IExtHostStorage),ce=pe.get(Y.IExtensionStoragePaths),j=pe.get(oe.ILogService),Ae=pe.get(Pe.IExtHostTunnelService),Te=pe.get(xe.IExtHostApiDeprecationService),Xe=pe.get(Z.IExtHostWindow),Ge=pe.get(q.IExtHostSecretState);ue.set(m.ExtHostContext.ExtHostFileSystemInfo,Ne),ue.set(m.ExtHostContext.ExtHostLogService,j),ue.set(m.ExtHostContext.ExtHostWorkspace,Ze),ue.set(m.ExtHostContext.ExtHostConfiguration,ot),ue.set(m.ExtHostContext.ExtHostExtensionService,Je),ue.set(m.ExtHostContext.ExtHostStorage,De),ue.set(m.ExtHostContext.ExtHostTunnelService,Ae),ue.set(m.ExtHostContext.ExtHostWindow,Xe),ue.set(m.ExtHostContext.ExtHostSecretState,Ge),ue.set(m.ExtHostContext.ExtHostTelemetry,ct);const rt=ue.set(m.ExtHostContext.ExtHostDecorations,pe.get(ze.IExtHostDecorations)),at=ue.set(m.ExtHostContext.ExtHostDocumentsAndEditors,pe.get(l.IExtHostDocumentsAndEditors)),Qe=ue.set(m.ExtHostContext.ExtHostCommands,pe.get(_.IExtHostCommands)),ut=ue.set(m.ExtHostContext.ExtHostTerminalService,pe.get(W.IExtHostTerminalService)),st=ue.set(m.ExtHostContext.ExtHostDebugService,pe.get(K.IExtHostDebugService)),gt=ue.set(m.ExtHostContext.ExtHostSearch,pe.get(ee.IExtHostSearch)),wt=ue.set(m.ExtHostContext.ExtHostTask,pe.get(N.IExtHostTask)),Dt=ue.set(m.ExtHostContext.ExtHostOutputService,pe.get(p.IExtHostOutputService)),vt=ue.set(m.ExtHostContext.ExtHostEditorTabs,new J.ExtHostEditorTabs),Et=ue.set(m.ExtHostContext.ExtHostUrls,new Q.ExtHostUrls(ue)),pt=ue.set(m.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ue,at)),Ft=ue.set(m.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider(ue,at,j)),Lt=ue.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(j,pt,ue.getProxy(m.MainContext.MainThreadBulkEdits))),ft=ue.set(m.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(ue,Qe,at,pt,We.environment,j,ce)),yt=ue.set(m.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(ue,at)),Ht=ue.set(m.ExtHostContext.ExtHostTreeViews,new L.ExtHostTreeViews(ue.getProxy(m.MainContext.MainThreadTreeViews),Qe,j)),qt=ue.set(m.ExtHostContext.ExtHostEditorInsets,new Ie.ExtHostEditorInsets(ue.getProxy(m.MainContext.MainThreadEditorInsets),yt,We.environment)),Mt=ue.set(m.ExtHostContext.ExtHostDiagnostics,new u.ExtHostDiagnostics(ue,j)),ht=ue.set(m.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(ue,nt,pt,Qe,Mt,j,Te)),Kt=ue.set(m.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(ue,ht)),kt=ue.set(m.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(ue,j,at)),Nt=ue.set(m.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(ue,Ze,Qe)),zt=ue.set(m.ExtHostContext.ExtHostSCM,new z.ExtHostSCM(ue,Qe,j)),Gt=ue.set(m.ExtHostContext.ExtHostComments,new g.ExtHostComments(ue,Qe,pt)),en=ue.set(m.ExtHostContext.ExtHostProgress,new P.ExtHostProgress(ue.getProxy(m.MainContext.MainThreadProgress))),hn=ue.set(m.ExtHostContext.ExtHosLabelService,new Ue.ExtHostLabelService(ue)),tn=ue.set(m.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(ue)),Ot=ue.set(m.ExtHostContext.ExtHostAuthentication,new _e.ExtHostAuthentication(ue)),fn=ue.set(m.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(ue,Qe)),Ut=ue.set(m.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(ue,We.environment,Ze,j,Te)),xt=ue.set(m.ExtHostContext.ExtHostWebviewPanels,new Oe.ExtHostWebviewPanels(ue,Ut,Ze)),mn=ue.set(m.ExtHostContext.ExtHostCustomEditors,new Be.ExtHostCustomEditors(ue,pt,ce,Ut,xt)),gn=ue.set(m.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(ue,Ut)),At=ue.set(m.ExtHostContext.ExtHostTesting,new te.ExtHostTesting(ue,at,Ze)),pn=ue.set(m.ExtHostContext.ExtHostUriOpeners,new he.ExtHostUriOpeners(ue)),Vt=(0,ye.values)(m.ExtHostContext);ue.assertRegistered(Vt);const vn=new et.ExtHostBulkEdits(ue,at),_n=new d.ExtHostClipboard(ue),$t=new h.ExtHostMessageService(ue,j),nn=new c.ExtHostDialogs(ue),rn=new le.ExtHostStatusBar(ue,Qe.converter),Wt=new C.ExtHostLanguages(ue,pt);return r.ExtHostApiCommands.register(Qe),function(Re,Qt,Jt){const mt=function(){let X=!Re.isUnderDevelopment;function de(ke){X||(j.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(lt){if(Array.isArray(lt))lt.forEach(ke);else if(typeof lt=="string")de(lt);else{const _t=lt;typeof _t.scheme=="undefined"&&de(lt),!Re.enableProposedApi&&typeof _t.exclusive=="boolean"&&(0,re.throwProposedApiError)(Re)}return lt}}(),bn={getSession(X,de,ke){return Ot.getSession(Re,X,de,ke)},get onDidChangeSessions(){return Ot.onDidChangeSessions},registerAuthenticationProvider(X,de,ke,lt){return Ot.registerAuthenticationProvider(X,de,ke,lt)},get onDidChangeAuthenticationProviders(){return(0,re.checkProposedApiEnabled)(Re),Ot.onDidChangeAuthenticationProviders},get providers(){return(0,re.checkProposedApiEnabled)(Re),Ot.providers},logout(X,de){return(0,re.checkProposedApiEnabled)(Re),Ot.removeSession(X,de)}},wn={registerCommand(X,de,ke){return Qe.registerCommand(!0,X,de,ke)},registerTextEditorCommand(X,de,ke){return Qe.registerCommand(!0,X,(...lt)=>{const _t=yt.getActiveTextEditor();if(!_t){j.warn("Cannot execute "+X+" because there is no active text editor.");return}return _t.edit(St=>{de.apply(ke,[_t,St,...lt])}).then(St=>{St||j.warn("Edits from command "+X+" were not applied.")},St=>{j.warn("An error occurred while running command "+X,St)})})},registerDiffInformationCommand:(X,de,ke)=>((0,re.checkProposedApiEnabled)(Re),Qe.registerCommand(!0,X,async(...lt)=>{const _t=at.activeEditor(!0);if(!_t){j.warn("Cannot execute "+X+" because there is no active text editor.");return}const St=await yt.getDiffInformation(_t.id);de.apply(ke,[St,...lt])})),executeCommand(X,...de){return Qe.executeCommand(X,...de)},getCommands(X=!1){return Qe.getCommands(X)}},sn={get machineId(){return We.telemetryInfo.machineId},get sessionId(){return We.telemetryInfo.sessionId},get language(){return We.environment.appLanguage},get appName(){return We.environment.appName},get appRoot(){var X,de;return(de=(X=We.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return We.environment.appUriScheme},get clipboard(){return _n.value},get shell(){return ut.getDefaultShell(!1,Jt)},get isTelemetryEnabled(){return ct.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ct.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(We.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,de){return Xe.openUri(X,{allowTunneling:!!We.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(X){return X.scheme===We.environment.appUriScheme?Et.createAppUri(X):Xe.asExternalUri(X,{allowTunneling:!!We.remote.authority})},get remoteName(){return(0,Fe.getRemoteName)(We.remote.authority)},get uiKind(){return We.uiKind}};We.environment.extensionTestsLocationURI||Object.freeze(sn);const on=We.remote.isRemote?x.ExtensionKind.Workspace:x.ExtensionKind.UI,En={registerTestProvider(X){return(0,re.checkProposedApiEnabled)(Re),At.registerTestProvider(X)},createDocumentTestObserver(X){return(0,re.checkProposedApiEnabled)(Re),At.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return(0,re.checkProposedApiEnabled)(Re),At.createWorkspaceTestObserver(X)},runTests(X){return(0,re.checkProposedApiEnabled)(Re),At.runTests(X)},publishTestResult(X,de=!0){return(0,re.checkProposedApiEnabled)(Re),At.publishExtensionProvidedResults(X,de)},get onDidChangeTestResults(){return(0,re.checkProposedApiEnabled)(Re),At.onResultsChanged},get testResults(){return(0,re.checkProposedApiEnabled)(Re),At.results}},Yt={getExtension(X){const de=Qt.getExtensionDescription(X);if(de)return new o.Extension(Je,Re.identifier,de,on)},get all(){return Qt.getAllExtensionDescriptions().map(X=>new o.Extension(Je,Re.identifier,X,on))},get onDidChange(){return Qt.onDidChange}},yn={createDiagnosticCollection(X){return Mt.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return Mt.onDidChangeDiagnostics},getDiagnostics:X=>Mt.getDiagnostics(X),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(X,de){return Wt.changeLanguage(X.uri,de)},match(X,de){return(0,k.score)(U.LanguageSelector.from(X),de.uri,de.languageId,!0)},registerCodeActionsProvider(X,de,ke){return ht.registerCodeActionProvider(Re,mt(X),de,ke)},registerCodeLensProvider(X,de){return ht.registerCodeLensProvider(Re,mt(X),de)},registerDefinitionProvider(X,de){return ht.registerDefinitionProvider(Re,mt(X),de)},registerDeclarationProvider(X,de){return ht.registerDeclarationProvider(Re,mt(X),de)},registerImplementationProvider(X,de){return ht.registerImplementationProvider(Re,mt(X),de)},registerTypeDefinitionProvider(X,de){return ht.registerTypeDefinitionProvider(Re,mt(X),de)},registerHoverProvider(X,de){return ht.registerHoverProvider(Re,mt(X),de,Re.identifier)},registerEvaluatableExpressionProvider(X,de){return ht.registerEvaluatableExpressionProvider(Re,mt(X),de,Re.identifier)},registerInlineValuesProvider(X,de){return ht.registerInlineValuesProvider(Re,mt(X),de,Re.identifier)},registerDocumentHighlightProvider(X,de){return ht.registerDocumentHighlightProvider(Re,mt(X),de)},registerLinkedEditingRangeProvider(X,de){return ht.registerLinkedEditingRangeProvider(Re,mt(X),de)},registerReferenceProvider(X,de){return ht.registerReferenceProvider(Re,mt(X),de)},registerRenameProvider(X,de){return ht.registerRenameProvider(Re,mt(X),de)},registerDocumentSymbolProvider(X,de,ke){return ht.registerDocumentSymbolProvider(Re,mt(X),de,ke)},registerWorkspaceSymbolProvider(X){return ht.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,de){return ht.registerDocumentFormattingEditProvider(Re,mt(X),de)},registerDocumentRangeFormattingEditProvider(X,de){return ht.registerDocumentRangeFormattingEditProvider(Re,mt(X),de)},registerOnTypeFormattingEditProvider(X,de,ke,...lt){return ht.registerOnTypeFormattingEditProvider(Re,mt(X),de,[ke].concat(lt))},registerDocumentSemanticTokensProvider(X,de,ke){return ht.registerDocumentSemanticTokensProvider(Re,mt(X),de,ke)},registerDocumentRangeSemanticTokensProvider(X,de,ke){return ht.registerDocumentRangeSemanticTokensProvider(Re,mt(X),de,ke)},registerSignatureHelpProvider(X,de,ke,...lt){return typeof ke=="object"?ht.registerSignatureHelpProvider(Re,mt(X),de,ke):ht.registerSignatureHelpProvider(Re,mt(X),de,typeof ke=="undefined"?[]:[ke,...lt])},registerCompletionItemProvider(X,de,...ke){return ht.registerCompletionItemProvider(Re,mt(X),de,ke)},registerDocumentLinkProvider(X,de){return ht.registerDocumentLinkProvider(Re,mt(X),de)},registerColorProvider(X,de){return ht.registerColorProvider(Re,mt(X),de)},registerFoldingRangeProvider(X,de){return ht.registerFoldingRangeProvider(Re,mt(X),de)},registerSelectionRangeProvider(X,de){return ht.registerSelectionRangeProvider(Re,X,de)},registerCallHierarchyProvider(X,de){return ht.registerCallHierarchyProvider(Re,X,de)},setLanguageConfiguration:(X,de)=>ht.setLanguageConfiguration(Re,X,de),getTokenInformationAtPosition(X,de){return(0,re.checkProposedApiEnabled)(Re),Wt.tokenAtPosition(X,de)},registerInlineHintsProvider(X,de){return(0,re.checkProposedApiEnabled)(Re),ht.registerInlineHintsProvider(Re,X,de)}},Sn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(X,de,ke){const lt=await(I.URI.isUri(X)?Promise.resolve(an.openTextDocument(X)):Promise.resolve(X));return yt.showTextDocument(lt,de,ke)},createTextEditorDecorationType(X){return yt.createTextEditorDecorationType(X)},onDidChangeActiveTextEditor(X,de,ke){return yt.onDidChangeActiveTextEditor(X,de,ke)},onDidChangeVisibleTextEditors(X,de,ke){return yt.onDidChangeVisibleTextEditors(X,de,ke)},onDidChangeTextEditorSelection(X,de,ke){return yt.onDidChangeTextEditorSelection(X,de,ke)},onDidChangeTextEditorOptions(X,de,ke){return yt.onDidChangeTextEditorOptions(X,de,ke)},onDidChangeTextEditorVisibleRanges(X,de,ke){return yt.onDidChangeTextEditorVisibleRanges(X,de,ke)},onDidChangeTextEditorViewColumn(X,de,ke){return yt.onDidChangeTextEditorViewColumn(X,de,ke)},onDidCloseTerminal(X,de,ke){return ut.onDidCloseTerminal(X,de,ke)},onDidOpenTerminal(X,de,ke){return ut.onDidOpenTerminal(X,de,ke)},onDidChangeActiveTerminal(X,de,ke){return ut.onDidChangeActiveTerminal(X,de,ke)},onDidChangeTerminalDimensions(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ut.onDidChangeTerminalDimensions(X,de,ke)},onDidWriteTerminalData(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ut.onDidWriteTerminalData(X,de,ke)},get state(){return Xe.state},onDidChangeWindowState(X,de,ke){return Xe.onDidChangeWindowState(X,de,ke)},showInformationMessage(X,...de){return $t.showMessage(Re,D.default.Info,X,de[0],de.slice(1))},showWarningMessage(X,...de){return $t.showMessage(Re,D.default.Warning,X,de[0],de.slice(1))},showErrorMessage(X,...de){return $t.showMessage(Re,D.default.Error,X,de[0],de.slice(1))},showQuickPick(X,de,ke){return Nt.showQuickPick(X,!!Re.enableProposedApi,de,ke)},showWorkspaceFolderPick(X){return Nt.showWorkspaceFolderPick(X)},showInputBox(X,de){return Nt.showInput(X,de)},showOpenDialog(X){return nn.showOpenDialog(X)},showSaveDialog(X){return nn.showSaveDialog(X)},createStatusBarItem(X,de){let ke,lt,_t,St;return X&&typeof X!="number"?(ke=X.id,lt=X.name,_t=X.alignment,de=X.priority,St=X.accessibilityInformation):(ke=Re.identifier.value,lt=E.localize(0,null,Re.displayName||Re.name),_t=X),rn.createStatusBarEntry(ke,lt,_t,de,St)},setStatusBarMessage(X,de){return rn.setStatusBarMessage(X,de)},withScmProgress(X){return Te.report("window.withScmProgress",Re,"Use 'withProgress' instead."),en.withProgress(Re,{location:x.ProgressLocation.SourceControl},(de,ke)=>X({report(lt){}}))},withProgress(X,de){return en.withProgress(Re,X,de)},createOutputChannel(X){return Dt.createOutputChannel(X)},createWebviewPanel(X,de,ke,lt){return xt.createWebviewPanel(Re,X,de,ke,lt)},createWebviewTextEditorInset(X,de,ke,lt){return(0,re.checkProposedApiEnabled)(Re),qt.createWebviewEditorInset(X,de,ke,lt,Re)},createTerminal(X,de,ke){return typeof X=="object"?"pty"in X?ut.createExtensionTerminal(X):ut.createTerminalFromOptions(X):ut.createTerminal(X,de,ke)},registerTerminalLinkProvider(X){return ut.registerLinkProvider(X)},registerTreeDataProvider(X,de){return Ht.registerTreeDataProvider(X,de,Re)},createTreeView(X,de){return Ht.createTreeView(X,de,Re)},registerWebviewPanelSerializer:(X,de)=>xt.registerWebviewPanelSerializer(Re,X,de),registerCustomEditorProvider:(X,de,ke={})=>mn.registerCustomEditorProvider(Re,X,de,ke),registerFileDecorationProvider(X){return rt.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return Et.registerUriHandler(Re.identifier,X)},createQuickPick(){return Nt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Nt.createInputBox(Re.identifier)},get activeColorTheme(){return tn.activeColorTheme},onDidChangeActiveColorTheme(X,de,ke){return tn.onDidChangeActiveColorTheme(X,de,ke)},registerWebviewViewProvider(X,de,ke){return gn.registerWebviewViewProvider(Re,X,de,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,re.checkProposedApiEnabled)(Re),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ft.onDidChangeActiveNotebookEditor(X,de,ke)},get visibleNotebookEditors(){return(0,re.checkProposedApiEnabled)(Re),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,re.checkProposedApiEnabled)(Re),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookEditorSelection(X,de,ke)},onDidChangeNotebookEditorVisibleRanges(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookEditorVisibleRanges(X,de,ke)},showNotebookDocument(X,de){return(0,re.checkProposedApiEnabled)(Re),ft.showNotebookDocument(X,de)},registerExternalUriOpener(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),pn.registerExternalUriOpener(Re.identifier,X,de,ke)},get openEditors(){return(0,re.checkProposedApiEnabled)(Re),vt.tabs},get onDidChangeOpenEditors(){return(0,re.checkProposedApiEnabled)(Re),vt.onDidChangeTabs}},an={get rootPath(){return Te.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(X){throw R.readonly()},getWorkspaceFolder(X){return Ze.getWorkspaceFolder(X)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(X){throw R.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(X){throw R.readonly()},updateWorkspaceFolders:(X,de,...ke)=>Ze.updateWorkspaceFolders(Re,X,de||0,...ke),onDidChangeWorkspaceFolders:function(X,de,ke){return Ze.onDidChangeWorkspace(X,de,ke)},asRelativePath:(X,de)=>Ze.getRelativePath(X,de),findFiles:(X,de,ke,lt)=>Ze.findFiles(U.GlobPattern.from(X),U.GlobPattern.from(de),ke,Re.identifier,lt),findTextInFiles:(X,de,ke,lt)=>{let _t,St;return typeof de=="object"?(_t=de,St=ke):(_t={},St=de,lt=ke),Ze.findTextInFiles(X,_t||{},St,Re.identifier,lt)},saveAll:X=>Ze.saveAll(X),applyEdit(X){return vn.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,de,ke,lt)=>kt.createFileSystemWatcher(U.GlobPattern.from(X),de,ke,lt),get textDocuments(){return pt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw R.readonly()},openTextDocument(X){let de;const ke=X;if(typeof X=="string")de=Promise.resolve(I.URI.file(X));else if(I.URI.isUri(X))de=Promise.resolve(X);else if(!ke||typeof ke=="object")de=pt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(lt=>pt.ensureDocumentData(lt).then(_t=>_t.document))},onDidOpenTextDocument:(X,de,ke)=>pt.onDidAddDocument(X,de,ke),onDidCloseTextDocument:(X,de,ke)=>pt.onDidRemoveDocument(X,de,ke),onDidChangeTextDocument:(X,de,ke)=>pt.onDidChangeDocument(X,de,ke),onDidSaveTextDocument:(X,de,ke)=>pt.onDidSaveDocument(X,de,ke),onWillSaveTextDocument:(X,de,ke)=>Lt.getOnWillSaveTextDocumentEvent(Re)(X,de,ke),onDidChangeConfiguration:(X,de,ke)=>Jt.onDidChangeConfiguration(X,de,ke),getConfiguration(X,de){return de=arguments.length===1?void 0:de,Jt.getConfiguration(X,de,Re)},registerTextDocumentContentProvider(X,de){return Ft.registerTextDocumentContentProvider(X,de)},registerTaskProvider:(X,de)=>(Te.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider(Re,X,de)),registerFileSystemProvider(X,de,ke){return Kt.registerFileSystemProvider(Re.identifier,X,de,ke)},get fs(){return Ve.value},registerFileSearchProvider:(X,de)=>((0,re.checkProposedApiEnabled)(Re),gt.registerFileSearchProvider(X,de)),registerTextSearchProvider:(X,de)=>((0,re.checkProposedApiEnabled)(Re),gt.registerTextSearchProvider(X,de)),registerRemoteAuthorityResolver:(X,de)=>((0,re.checkProposedApiEnabled)(Re),Je.registerRemoteAuthorityResolver(X,de)),registerResourceLabelFormatter:X=>((0,re.checkProposedApiEnabled)(Re),hn.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,de,ke)=>kt.onDidCreateFile(X,de,ke),onDidDeleteFiles:(X,de,ke)=>kt.onDidDeleteFile(X,de,ke),onDidRenameFiles:(X,de,ke)=>kt.onDidRenameFile(X,de,ke),onWillCreateFiles:(X,de,ke)=>kt.getOnWillCreateFileEvent(Re)(X,de,ke),onWillDeleteFiles:(X,de,ke)=>kt.getOnWillDeleteFileEvent(Re)(X,de,ke),onWillRenameFiles:(X,de,ke)=>kt.getOnWillRenameFileEvent(Re)(X,de,ke),openTunnel:X=>((0,re.checkProposedApiEnabled)(Re),Ae.openTunnel(Re,X).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,re.checkProposedApiEnabled)(Re),Ae.getTunnels()},onDidChangeTunnels:(X,de,ke)=>((0,re.checkProposedApiEnabled)(Re),Ae.onDidChangeTunnels(X,de,ke)),registerPortAttributesProvider:(X,de)=>((0,re.checkProposedApiEnabled)(Re),Ae.registerPortsAttributesProvider(X,de)),registerTimelineProvider:(X,de)=>((0,re.checkProposedApiEnabled)(Re),fn.registerTimelineProvider(X,de,Re.identifier,Qe.converter)),get trustState(){return(0,re.checkProposedApiEnabled)(Re),(0,re.checkRequiresWorkspaceTrust)(Re),Ze.trustState},requireWorkspaceTrust:X=>((0,re.checkProposedApiEnabled)(Re),(0,re.checkRequiresWorkspaceTrust)(Re),Ze.requireWorkspaceTrust(X)),onDidChangeWorkspaceTrustState:(X,de,ke)=>Ze.onDidChangeWorkspaceTrustState(X,de,ke)},Dn={get inputBox(){return Te.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),zt.getLastInputBox(Re)},createSourceControl(X,de,ke){return zt.createSourceControl(Re,X,de,ke)}},Cn={createCommentController(X,de){return Gt.createCommentController(Re,X,de)}},ln={get activeDebugSession(){return st.activeDebugSession},get activeDebugConsole(){return st.activeDebugConsole},get breakpoints(){return st.breakpoints},onDidStartDebugSession(X,de,ke){return st.onDidStartDebugSession(X,de,ke)},onDidTerminateDebugSession(X,de,ke){return st.onDidTerminateDebugSession(X,de,ke)},onDidChangeActiveDebugSession(X,de,ke){return st.onDidChangeActiveDebugSession(X,de,ke)},onDidReceiveDebugSessionCustomEvent(X,de,ke){return st.onDidReceiveDebugSessionCustomEvent(X,de,ke)},onDidChangeBreakpoints(X,de,ke){return st.onDidChangeBreakpoints(X,de,ke)},registerDebugConfigurationProvider(X,de,ke){return st.registerDebugConfigurationProvider(X,de,ke||x.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,de){return st.registerDebugAdapterDescriptorFactory(Re,X,de)},registerDebugAdapterTrackerFactory(X,de){return st.registerDebugAdapterTrackerFactory(X,de)},startDebugging(X,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?st.startDebugging(X,de,{parentSession:ke}):st.startDebugging(X,de,ke||{})},stopDebugging(X){return st.stopDebugging(X)},addBreakpoints(X){return st.addBreakpoints(X)},removeBreakpoints(X){return st.removeBreakpoints(X)},asDebugSourceUri(X,de){return st.asDebugSourceUri(X,de)}},jt={registerTaskProvider:(X,de)=>wt.registerTaskProvider(Re,X,de),fetchTasks:X=>wt.fetchTasks(X),executeTask:X=>wt.executeTask(Re,X),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(X,de,ke)=>wt.onDidStartTask(X,de,ke),onDidEndTask:(X,de,ke)=>wt.onDidEndTask(X,de,ke),onDidStartTaskProcess:(X,de,ke)=>wt.onDidStartTaskProcess(X,de,ke),onDidEndTaskProcess:(X,de,ke)=>wt.onDidEndTaskProcess(X,de,ke)},un={openNotebookDocument:X=>((0,re.checkProposedApiEnabled)(Re),ft.openNotebookDocument(X)),get onDidOpenNotebookDocument(){return(0,re.checkProposedApiEnabled)(Re),ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,re.checkProposedApiEnabled)(Re),ft.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,re.checkProposedApiEnabled)(Re),ft.onDidSaveNotebookDocument},get notebookDocuments(){return(0,re.checkProposedApiEnabled)(Re),ft.notebookDocuments.map(X=>X.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,re.checkProposedApiEnabled)(Re),ft.onDidChangeActiveNotebookKernel},registerNotebookSerializer(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ft.registerNotebookSerializer(Re,X,de,ke)},registerNotebookContentProvider:(X,de,ke)=>((0,re.checkProposedApiEnabled)(Re),ft.registerNotebookContentProvider(Re,X,de,ke)),registerNotebookKernelProvider:(X,de)=>((0,re.checkProposedApiEnabled)(Re),ft.registerNotebookKernelProvider(Re,X,de)),createNotebookEditorDecorationType(X){return(0,re.checkProposedApiEnabled)(Re),ft.createNotebookEditorDecorationType(X)},onDidChangeNotebookDocumentMetadata(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookDocumentMetadata(X,de,ke)},onDidChangeNotebookCells(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookCells(X,de,ke)},onDidChangeCellExecutionState(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ft.onDidChangeNotebookCellExecutionState(X,de,ke)},onDidChangeCellOutputs(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ft.onDidChangeCellOutputs(X,de,ke)},onDidChangeCellMetadata(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ft.onDidChangeCellMetadata(X,de,ke)},createConcatTextDocument(X,de){return(0,re.checkProposedApiEnabled)(Re),new V.ExtHostNotebookConcatDocument(ft,pt,X,de)},createCellStatusBarItem(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ft.createNotebookCellStatusBarItemInternal(X,de,ke)},createNotebookCellExecutionTask(X,de,ke){return(0,re.checkProposedApiEnabled)(Re),ft.createNotebookCellExecution(X,de,ke)}};return{version:We.version,authentication:bn,commands:wn,comments:Cn,debug:ln,env:sn,extensions:Yt,languages:yn,notebook:un,scm:Dn,tasks:jt,test:En,window:Sn,workspace:an,Breakpoint:x.Breakpoint,CallHierarchyIncomingCall:x.CallHierarchyIncomingCall,CallHierarchyItem:x.CallHierarchyItem,CallHierarchyOutgoingCall:x.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:S.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:x.CodeAction,CodeActionKind:x.CodeActionKind,CodeActionTriggerKind:x.CodeActionTriggerKind,CodeLens:x.CodeLens,Color:x.Color,ColorInformation:x.ColorInformation,ColorPresentation:x.ColorPresentation,ColorThemeKind:x.ColorThemeKind,CommentMode:x.CommentMode,CommentThreadCollapsibleState:x.CommentThreadCollapsibleState,CompletionItem:x.CompletionItem,CompletionItemKind:x.CompletionItemKind,CompletionItemTag:x.CompletionItemTag,CompletionList:x.CompletionList,CompletionTriggerKind:x.CompletionTriggerKind,ConfigurationTarget:x.ConfigurationTarget,CustomExecution:x.CustomExecution,DebugAdapterExecutable:x.DebugAdapterExecutable,DebugAdapterInlineImplementation:x.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:x.DebugAdapterNamedPipeServer,DebugAdapterServer:x.DebugAdapterServer,DebugConfigurationProviderTriggerKind:x.DebugConfigurationProviderTriggerKind,DebugConsoleMode:x.DebugConsoleMode,DecorationRangeBehavior:x.DecorationRangeBehavior,Diagnostic:x.Diagnostic,DiagnosticRelatedInformation:x.DiagnosticRelatedInformation,DiagnosticSeverity:x.DiagnosticSeverity,DiagnosticTag:x.DiagnosticTag,Disposable:x.Disposable,DocumentHighlight:x.DocumentHighlight,DocumentHighlightKind:x.DocumentHighlightKind,DocumentLink:x.DocumentLink,DocumentSymbol:x.DocumentSymbol,EndOfLine:x.EndOfLine,EnvironmentVariableMutatorType:x.EnvironmentVariableMutatorType,EvaluatableExpression:x.EvaluatableExpression,InlineValueText:x.InlineValueText,InlineValueVariableLookup:x.InlineValueVariableLookup,InlineValueEvaluatableExpression:x.InlineValueEvaluatableExpression,EventEmitter:A.Emitter,ExtensionKind:x.ExtensionKind,ExtensionMode:x.ExtensionMode,ExternalUriOpenerPriority:x.ExternalUriOpenerPriority,FileChangeType:x.FileChangeType,FileDecoration:x.FileDecoration,FileSystemError:x.FileSystemError,FileType:b.FileType,FoldingRange:x.FoldingRange,FoldingRangeKind:x.FoldingRangeKind,FunctionBreakpoint:x.FunctionBreakpoint,Hover:x.Hover,IndentAction:T.IndentAction,Location:x.Location,MarkdownString:x.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:x.ParameterInformation,PortAutoForwardAction:x.PortAutoForwardAction,Position:x.Position,ProcessExecution:x.ProcessExecution,ProgressLocation:x.ProgressLocation,QuickInputButtons:x.QuickInputButtons,Range:x.Range,RelativePattern:x.RelativePattern,Selection:x.Selection,SelectionRange:x.SelectionRange,SemanticTokens:x.SemanticTokens,SemanticTokensBuilder:x.SemanticTokensBuilder,SemanticTokensEdit:x.SemanticTokensEdit,SemanticTokensEdits:x.SemanticTokensEdits,SemanticTokensLegend:x.SemanticTokensLegend,ShellExecution:x.ShellExecution,ShellQuoting:x.ShellQuoting,SignatureHelp:x.SignatureHelp,SignatureHelpTriggerKind:x.SignatureHelpTriggerKind,SignatureInformation:x.SignatureInformation,SnippetString:x.SnippetString,SourceBreakpoint:x.SourceBreakpoint,StandardTokenType:x.StandardTokenType,StatusBarAlignment:x.StatusBarAlignment,SymbolInformation:x.SymbolInformation,SymbolKind:x.SymbolKind,SymbolTag:x.SymbolTag,Task:x.Task,TaskGroup:x.TaskGroup,TaskPanelKind:x.TaskPanelKind,TaskRevealKind:x.TaskRevealKind,TaskScope:x.TaskScope,TextDocumentSaveReason:x.TextDocumentSaveReason,TextEdit:x.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:x.TextEditorLineNumbersStyle,TextEditorRevealType:x.TextEditorRevealType,TextEditorSelectionChangeKind:x.TextEditorSelectionChangeKind,ThemeColor:x.ThemeColor,ThemeIcon:x.ThemeIcon,TreeItem:x.TreeItem,TreeItemCollapsibleState:x.TreeItemCollapsibleState,UIKind:m.UIKind,Uri:I.URI,ViewColumn:x.ViewColumn,WorkspaceEdit:x.WorkspaceEdit,InlineHint:x.InlineHint,InlineHintKind:x.InlineHintKind,RemoteAuthorityResolverError:x.RemoteAuthorityResolverError,ResolvedAuthority:x.ResolvedAuthority,SourceControlInputBoxValidationType:x.SourceControlInputBoxValidationType,ExtensionRuntime:x.ExtensionRuntime,TimelineItem:x.TimelineItem,NotebookCellRange:x.NotebookCellRange,NotebookCellKind:x.NotebookCellKind,NotebookCellExecutionState:x.NotebookCellExecutionState,NotebookDocumentMetadata:x.NotebookDocumentMetadata,NotebookCellMetadata:x.NotebookCellMetadata,NotebookCellData:x.NotebookCellData,NotebookData:x.NotebookData,NotebookCellStatusBarAlignment:x.NotebookCellStatusBarAlignment,NotebookEditorRevealType:x.NotebookEditorRevealType,NotebookCellOutput:x.NotebookCellOutput,NotebookCellOutputItem:x.NotebookCellOutputItem,LinkedEditingRanges:x.LinkedEditingRanges,TestItem:x.TestItem,TestState:x.TestState,TestResult:x.TestResult,TestMessage:x.TestMessage,TestMessageSeverity:x.TestMessageSeverity,WorkspaceTrustState:x.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=fe}),define(be[221],we([0,1,61,99,31,98,35,73,40,41,101,102,103,76,75,67,72,100,74,48,71,93]),function(ae,e,E,S,R,A,D,I,y,n,T,k,b,m,r,d,_,g,w,u,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths),(0,E.registerSingleton)(_.IExtHostApiDeprecationService,_.ExtHostApiDeprecationService),(0,E.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,E.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,E.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,E.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,E.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,E.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,E.registerSingleton)(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),(0,E.registerSingleton)(S.IExtHostOutputService,S.ExtHostOutputService),(0,E.registerSingleton)(b.IExtHostSearch,b.ExtHostSearch),(0,E.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,E.registerSingleton)(T.IExtHostTask,T.WorkerExtHostTask),(0,E.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,E.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,E.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,E.registerSingleton)(R.IExtHostWorkspace,R.ExtHostWorkspace),(0,E.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,E.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry)}),define(be[222],we([0,1,220,36,216,7,13,5]),function(ae,e,E,S,R,A,D,I){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var n;(function(r){var d;const _=(d=self.trustedTypes)===null||d===void 0?void 0:d.createPolicy("TrustedFunctionWorkaround",{createScript:(w,...u)=>{u.forEach(i=>{var l;if(!((l=self.trustedTypes)===null||l===void 0?void 0:l.isScript(i)))throw new Error("TrustedScripts only, please")});const c=u.slice(0,-1).join(","),s=u.pop().toString();return`(function anonymous(${c}) {
${s}
})`}});function g(...w){return _?self.eval(_.createScript("",...w)):new Function(...w)}r.create=g})(n||(n={}));class T extends R.RequireInterceptor{_installInterceptor(){}getModule(d,_){for(let g of this._alternatives){let w=g(d);if(w){d=w;break}}if(this._factories.has(d))return this._factories.get(d).load(d,_,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class k extends S.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const d=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);m(d);const _=this._instaService.invokeFunction(E.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(T,_,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(d){return d.browser}async _loadCommonJSModule(d,_,g){var w,u,c,s,t,i,l,o;_=_.with({path:b(_.path,".js")}),d&&performance.mark(`code/extHost/willFetchExtensionCode/${d.value}`);const a=await fetch(_.toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d.value}`),a.status!==200)throw new Error(a.statusText);const f=await a.text(),v=`${_.toString(!0)}#vscode-extension`,C=`${f}
//# sourceURL=${v}`;let h;try{h=n.create((u=(w=k._ttpExtensionScripts)===null||w===void 0?void 0:w.createScript("module"))!==null&&u!==void 0?u:"module",(s=(c=k._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript("exports"))!==null&&s!==void 0?s:"exports",(i=(t=k._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&i!==void 0?i:"require",(o=(l=k._ttpExtensionScripts)===null||l===void 0?void 0:l.createScript(C))!==null&&o!==void 0?o:C)}catch(z){throw d?console.error(`Loading code for extension ${d.value} failed: ${z.message}`):console.error(`Loading code failed: ${z.message}`),console.error(`${_.toString(!0)}${typeof z.line=="number"?` line ${z.line}`:""}${typeof z.column=="number"?` column ${z.column}`:""}`),console.error(z),z}const p={},P={exports:p},F=z=>{const le=this._fakeModules.getModule(z,_);if(le===void 0)throw new Error(`Cannot load module '${z}'`);return le};try{return g.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d.value}`),h(P,p,F),P.exports!==p?P.exports:p}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d.value}`),g.codeLoadingStop()}}async $setRemoteEnvironment(d){throw new Error("Not supported")}async _waitForDebuggerAttachment(d=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const _=Date.now()+d;for(;Date.now()<_&&!("__jsDebugIsReady"in globalThis);)await(0,D.timeout)(10)}}}e.ExtHostExtensionService=k,k._ttpExtensionScripts=(y=self.trustedTypes)===null||y===void 0?void 0:y.createPolicy("ExtensionScripts",{createScript:r=>r});function b(r,d){return r.endsWith(d)?r:r+d}function m(r){d("info","log"),d("log","log"),d("warn","warn"),d("error","error");function d(w,u){console[w]=function(){r.$logExtensionHostMessage({type:"__$console",severity:u,arguments:g(arguments)})}}const _=1e5;function g(w){const u=[],c=[];if(w.length)for(let s=0;s<w.length;s++){if(typeof w[s]=="undefined")w[s]="undefined";else if(w[s]instanceof Error){const t=w[s];t.stack?w[s]=t.stack:w[s]=t.toString()}c.push(w[s])}try{const s=JSON.stringify(c,function(t,i){if(i&&typeof i=="object"){if(u.indexOf(i)!==-1)return"[Circular]";u.push(i)}return i});return s.length>_?"Output omitted for a large object that exceeds the limits":s}catch(s){return`Output omitted for an object that cannot be inspected ('${s.toString()}')`}}}}),define(be[223],we([0,1,61,19,36,222,208]),function(ae,e,E,S,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.registerSingleton)(R.IExtHostExtensionService,A.ExtHostExtensionService),(0,E.registerSingleton)(S.ILogService,D.ExtHostLogService)}),define(be[225],we([0,1,26,3,180,217,210,11,77,221,223]),function(ae,e,E,S,R,A,D,I,y){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0});const T=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const k=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const _=(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("extensionHostWorker",{createScriptURL:w=>w}),g=self.Worker;Worker=function(w,u){const c=`importScripts('${w}');`;u=u||{},u.name=u.name||I.basename(w.toString());const s=new Blob([c],{type:"application/javascript"}),t=URL.createObjectURL(s);return new g(_?_.createScriptURL(t):t,u)}}else self.Worker=class extends D.NestedWorker{constructor(_,g){super(k,_,Object.assign({name:I.basename(_.toString())},g))}};const b=new class{exit(_){T()}async exists(_){return!0}async realpath(_){return _}};class m{constructor(){const g=new MessageChannel,w=new S.Emitter;let u=!1;k(g.port2,[g.port2]),g.port1.onmessage=c=>{const{data:s}=c;if(!(s instanceof ArrayBuffer)){console.warn("UNKNOWN data received",s);return}const t=E.VSBuffer.wrap(new Uint8Array(s,0,s.byteLength));if((0,R.isMessageOfType)(t,2)){u=!0,d("received terminate message from renderer");return}w.fire(t)},this.protocol={onMessage:w.event,send:c=>{if(!u){const s=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);g.port1.postMessage(s,[s])}}}}}function r(_){return new Promise(g=>{const w=_.onMessage(u=>{w.dispose();const c=JSON.parse(u.toString());_.send((0,R.createMessageOfType)(0)),g({protocol:_,initData:c})});_.send((0,R.createMessageOfType)(1))})}let d=_=>T();(function(){const g=new m;y.mark("code/extHost/willConnectToRenderer"),r(g.protocol).then(w=>{y.mark("code/extHost/didWaitForInitData");const u=new A.ExtensionHostMain(w.protocol,w.initData,b,null);d=c=>u.terminate(c)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8437d38d364ba93b53c1e659c20b1c86f710ec28/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
